class
	PD_CS_ALIAS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create oname.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	oname: CE_POINTER [INTEGER_8] assign set_oname

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_oname (a_oname: CE_POINTER [INTEGER_8])
		do
			oname := a_oname
			update_memory_field ("oname")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			oname := a_other.oname
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				oname.is_equal (a_other.oname)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("oname")
				>>)
			init_structure_info
		end

end
