deferred class
	S_STDLIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	abs (a___x: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return abs($a___x);"
		end

	atoi (a___nptr: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_atoi (a___nptr.c_pointer)
		end

	c_atoi (a___nptr: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return atoi($a___nptr);"
		end

	calloc (a_nmemb: NATURAL_32; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared_with_count (
					default_pointer.memory_calloc (a_nmemb.to_integer_32, a_size.to_integer_32),
					(a_nmemb * a_size).to_integer_32
				)
		end

	exit (a___status: INTEGER_32)
		external
			"C inline use <less.h>"
		alias
			"exit($a___status);"
		end

	free (a___ptr: CE_POINTER [ANY])
		do
			c_free (a___ptr.c_pointer)
		end

	c_free (a___ptr: POINTER)
		external
			"C inline use <less.h>"
		alias
			"free($a___ptr);"
		end

	getenv (a___name: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_getenv (a___name.c_pointer))
		end

	c_getenv (a___name: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return getenv($a___name);"
		end

	system (a___command: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_system (a___command.c_pointer)
		end

	c_system (a___command: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return system($a___command);"
		end

end
