class
	PD_OPTIONS2

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
			create variable.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	variable: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_variable

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_variable (a_variable: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			variable := a_variable
			update_memory_field ("variable")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			variable := a_other.variable
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				variable.is_equal (a_other.variable)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("variable")
				>>)
			init_structure_info
		end

end
