class
	P_XALLOC

inherit
	WGET_DATA
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {ANY} -- routines

	x2nrealloc (a_p___0: CE_POINTER [ANY]; a_pn: CE_POINTER [NATURAL_32]; a_s: NATURAL_32): CE_POINTER [ANY]
		local
			l_n: NATURAL_32
		do
			l_n := a_pn.item
			if a_p___0.is_void then
				if not l_n.to_boolean then
					l_n := {NATURAL_32} 64 // a_s
					l_n := l_n + (not l_n.to_boolean).to_integer.to_natural_32
				end
			else
				if {NATURAL_32} 2_863_311_530 // a_s <= l_n then
					xalloc_die_inst.xalloc_die
				end
				l_n := l_n + ((l_n + {NATURAL_32} 1) // {NATURAL_32} 2)
			end
			a_pn.item := l_n
			Result := (xmalloc_inst.xrealloc (a_p___0, l_n * a_s))
		end

	xcharalloc (a_n: NATURAL_32): CE_POINTER [INTEGER_8]
		local
			l_tmp___1: CE_POINTER [ANY]
		do
			create l_tmp___1.make

			if {PLATFORM}.Integer_8_bytes.to_natural_32 = {NATURAL_32} 1 then
				l_tmp___1 := (xmalloc_inst.xmalloc (a_n))
			else
				l_tmp___1 := (xnmalloc (a_n, {PLATFORM}.Integer_8_bytes.to_natural_32))
			end
			Result := (create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___1))
		end

	xnmalloc (a_n: NATURAL_32; a_s: NATURAL_32): CE_POINTER [ANY]
		local
			l_tmp: INTEGER_32
		do
			if {PLATFORM}.Integer_32_bytes.to_natural_32 <= {PLATFORM}.Natural_32_bytes.to_natural_32 then
				l_tmp := -1
			else
				l_tmp := -2
			end
			if l_tmp.to_natural_32 // a_s < a_n then
				xalloc_die_inst.xalloc_die
			end
			Result := (xmalloc_inst.xmalloc (a_n * a_s))
		end

end
