deferred class
	S_LIBINTL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	bindtextdomain (a___domainname: CE_POINTER [INTEGER_8]; a___dirname: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_bindtextdomain (a___domainname.c_pointer, a___dirname.c_pointer))
		end

	c_bindtextdomain (a___domainname: POINTER; a___dirname: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return bindtextdomain($a___domainname, $a___dirname);"
		end

	gettext (a___msgid: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_gettext (a___msgid.c_pointer))
		end

	c_gettext (a___msgid: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return gettext($a___msgid);"
		end

	ngettext (a___msgid1: CE_POINTER [INTEGER_8]; a___msgid2: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_ngettext (a___msgid1.c_pointer, a___msgid2.c_pointer, a___n))
		end

	c_ngettext (a___msgid1: POINTER; a___msgid2: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return ngettext($a___msgid1, $a___msgid2, $a___n);"
		end

	textdomain (a___domainname: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_textdomain (a___domainname.c_pointer))
		end

	c_textdomain (a___domainname: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return textdomain($a___domainname);"
		end

end
