class
	PD_STR2NUM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create str.make
		end

feature {ANY} -- fields

	str: CE_POINTER [NATURAL_8] assign set_str

	num: INTEGER_32 assign set_num

feature {ANY} -- setters

	set_str (a_str: CE_POINTER [NATURAL_8])
		do
			str := a_str
			update_memory_field ("str")
		end

	set_num (a_num: INTEGER_32)
		do
			num := a_num
			update_memory_field ("num")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			str := a_other.str
			num := a_other.num
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				str.is_equal (a_other.str) and
				num = a_other.num
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("str"),
					create {CE_STRUCTURE_FIELD}.make ("num")
				>>)
			init_structure_info
		end

end
