class
	PD_UNICODE_7B

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create s.make
		end

feature {ANY} -- fields

	x: INTEGER_32 assign set_x

	s: CE_POINTER [NATURAL_8] assign set_s

feature {ANY} -- setters

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_s (a_s: CE_POINTER [NATURAL_8])
		do
			s := a_s
			update_memory_field ("s")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			s := a_other.s
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				s.is_equal (a_other.s)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("s")
				>>)
			init_structure_info
		end

end
