frozen class
	LINKS_INITIALIZER_SLICE43

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			language_inst.translation_croatian[128].code := 128
			language_inst.translation_croatian[128].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Prenosim"))
			language_inst.translation_croatian[129].code := 129
			language_inst.translation_croatian[129].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/200/ekam podatke o redirekciji"))
			language_inst.translation_croatian[130].code := 130
			language_inst.translation_croatian[130].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Prekinuto"))
			language_inst.translation_croatian[131].code := 131
			language_inst.translation_croatian[131].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Socket gre%/185/ka"))
			language_inst.translation_croatian[132].code := 132
			language_inst.translation_croatian[132].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Interna gre%/185/ka"))
			language_inst.translation_croatian[133].code := 133
			language_inst.translation_croatian[133].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nedovoljno memorije"))
			language_inst.translation_croatian[134].code := 134
			language_inst.translation_croatian[134].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ra%/232/unalo nije na%/240/eno"))
			language_inst.translation_croatian[135].code := 135
			language_inst.translation_croatian[135].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka pri pisanju u socket"))
			language_inst.translation_croatian[136].code := 136
			language_inst.translation_croatian[136].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka pri %/232/itanju iz socketa"))
			language_inst.translation_croatian[137].code := 137
			language_inst.translation_croatian[137].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Podaci promijenjeni"))
			language_inst.translation_croatian[138].code := 138
			language_inst.translation_croatian[138].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Neispravana URL sintaksa"))
			language_inst.translation_croatian[139].code := 139
			language_inst.translation_croatian[139].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Primi timeout"))
			language_inst.translation_croatian[140].code := 140
			language_inst.translation_croatian[140].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Zahtjev mora biti ponovljen"))
			language_inst.translation_croatian[141].code := 141
			language_inst.translation_croatian[141].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ne mogu dobiti stanje socketa "))
			language_inst.translation_croatian[142].code := 142
			language_inst.translation_croatian[142].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[143].code := 143
			language_inst.translation_croatian[143].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Neispravan HTTP odgovor"))
			language_inst.translation_croatian[144].code := 144
			language_inst.translation_croatian[144].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP 100 (???)"))
			language_inst.translation_croatian[145].code := 145
			language_inst.translation_croatian[145].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nema sadr%/190/aja"))
			language_inst.translation_croatian[146].code := 146
			language_inst.translation_croatian[146].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nepoznati tip datoteke"))
			language_inst.translation_croatian[147].code := 147
			language_inst.translation_croatian[147].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka pri otvaranju datoteke"))
			language_inst.translation_croatian[148].code := 148
			language_inst.translation_croatian[148].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Neispravan FTP odgovor"))
			language_inst.translation_croatian[149].code := 149
			language_inst.translation_croatian[149].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nemogu%/230/ pristup FTP usluzi"))
			language_inst.translation_croatian[150].code := 150
			language_inst.translation_croatian[150].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Neispravan FTP login"))
			language_inst.translation_croatian[151].code := 151
			language_inst.translation_croatian[151].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP PORT naredba nije uspjela"))
			language_inst.translation_croatian[152].code := 152
			language_inst.translation_croatian[152].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Datoteka nije prona%/240/ena"))
			language_inst.translation_croatian[153].code := 153
			language_inst.translation_croatian[153].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("gre%/185/ka u FTP datoteci"))
			language_inst.translation_croatian[154].code := 154
			language_inst.translation_croatian[154].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nepoznata gre%/185/ka"))
			language_inst.translation_croatian[155].code := 155
			language_inst.translation_croatian[155].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Primljeno"))
			language_inst.translation_croatian[156].code := 156
			language_inst.translation_croatian[156].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("od"))
			language_inst.translation_croatian[157].code := 157
			language_inst.translation_croatian[157].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("prosjek"))
			language_inst.translation_croatian[158].code := 158
			language_inst.translation_croatian[158].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("trenutno"))
			language_inst.translation_croatian[159].code := 159
			language_inst.translation_croatian[159].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Prosje%/232/na brzina"))
			language_inst.translation_croatian[160].code := 160
			language_inst.translation_croatian[160].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Brzina"))
			language_inst.translation_croatian[161].code := 161
			language_inst.translation_croatian[161].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("trenutna brzina"))
			language_inst.translation_croatian[162].code := 162
			language_inst.translation_croatian[162].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Proteklo vrijeme"))
			language_inst.translation_croatian[163].code := 163
			language_inst.translation_croatian[163].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("procijenjeno vrijeme"))
			language_inst.translation_croatian[164].code := 164
			language_inst.translation_croatian[164].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Pozadina"))
			language_inst.translation_croatian[165].code := 165
			language_inst.translation_croatian[165].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Otka%/190/i"))
			language_inst.translation_croatian[166].code := 166
			language_inst.translation_croatian[166].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Yes"))
			language_inst.translation_croatian[167].code := 167
			language_inst.translation_croatian[167].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ne"))
			language_inst.translation_croatian[168].code := 168
			language_inst.translation_croatian[168].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka pri skidanju podatka"))
			language_inst.translation_croatian[169].code := 169
			language_inst.translation_croatian[169].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nisam mogao stvoriti datoteku"))
			language_inst.translation_croatian[170].code := 170
			language_inst.translation_croatian[170].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka pri preuzimanju"))
			language_inst.translation_croatian[171].code := 171
			language_inst.translation_croatian[171].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nisam mogao stvoriti datoteku"))
			language_inst.translation_croatian[172].code := 172
			language_inst.translation_croatian[172].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[173].code := 173
			language_inst.translation_croatian[173].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nepoznati tip"))
			language_inst.translation_croatian[174].code := 174
			language_inst.translation_croatian[174].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tip sadr%/190/aja je"))
			language_inst.translation_croatian[175].code := 175
			language_inst.translation_croatian[175].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/174/elite li sa%/232/uvati ili prikazati ovu datoteku?"))
			language_inst.translation_croatian[176].code := 176
			language_inst.translation_croatian[176].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Spremi"))
			language_inst.translation_croatian[177].code := 177
			language_inst.translation_croatian[177].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Prika%/190/i"))
			language_inst.translation_croatian[178].code := 178
			language_inst.translation_croatian[178].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/169/to napraviti?"))
			language_inst.translation_croatian[179].code := 179
			language_inst.translation_croatian[179].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/174/elite li otvoriti datoteku sa"))
			language_inst.translation_croatian[180].code := 180
			language_inst.translation_croatian[180].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("spremiti ili prikazati?"))
			language_inst.translation_croatian[181].code := 181
			language_inst.translation_croatian[181].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Otvoriti"))
			language_inst.translation_croatian[182].code := 182
			language_inst.translation_croatian[182].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/190/elite li slijediti redirekciju i poslati podatke iz formulara na url"))
			language_inst.translation_croatian[183].code := 183
			language_inst.translation_croatian[183].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/174/elite li poslati podatke na url"))
			language_inst.translation_croatian[184].code := 184
			language_inst.translation_croatian[184].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/174/elite li ponovo poslati podatke na url"))
			language_inst.translation_croatian[185].code := 185
			language_inst.translation_croatian[185].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Upozorenje"))
			language_inst.translation_croatian[186].code := 186
			language_inst.translation_croatian[186].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka"))
			language_inst.translation_croatian[187].code := 187
			language_inst.translation_croatian[187].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Dobordo%/185/li"))
			language_inst.translation_croatian[188].code := 188
			language_inst.translation_croatian[188].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Dobrodo%/185/li u links!"))
			language_inst.translation_croatian[189].code := 189
			language_inst.translation_croatian[189].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Pritisni ESC za izbornik. Izaberi Pomo%/230/->Upute u izborniku za korisni%/232/ke upute."))
			language_inst.translation_croatian[190].code := 190
			language_inst.translation_croatian[190].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Oznaka"))
			language_inst.translation_croatian[191].code := 191
			language_inst.translation_croatian[191].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tip sadr%/190/aja"))
			language_inst.translation_croatian[192].code := 192
			language_inst.translation_croatian[192].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Program (%'%%%' je zamijenjeno sa imenom datoteke)"))
			language_inst.translation_croatian[193].code := 193
			language_inst.translation_croatian[193].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Blokiraj terminal dok program radi"))
			language_inst.translation_croatian[194].code := 194
			language_inst.translation_croatian[194].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Izvr%/185/i na terminalu"))
			language_inst.translation_croatian[195].code := 195
			language_inst.translation_croatian[195].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Izvr%/185/i na X-Windowsima"))
			language_inst.translation_croatian[196].code := 196
			language_inst.translation_croatian[196].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Pitaj prije otvaranja"))
			language_inst.translation_croatian[197].code := 197
			language_inst.translation_croatian[197].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Izbri%/185/i vezu"))
			language_inst.translation_croatian[198].code := 198
			language_inst.translation_croatian[198].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("veza"))
			language_inst.translation_croatian[199].code := 199
			language_inst.translation_croatian[199].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nastavak(ci)"))
			language_inst.translation_croatian[200].code := 200
			language_inst.translation_croatian[200].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tip sadr%/190/aja"))
			language_inst.translation_croatian[201].code := 201
			language_inst.translation_croatian[201].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			language_inst.translation_croatian[202].code := 202
			language_inst.translation_croatian[202].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Izbri%/185/i nastavak"))
			language_inst.translation_croatian[203].code := 203
			language_inst.translation_croatian[203].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nastavak"))
			language_inst.translation_croatian[204].code := 204
			language_inst.translation_croatian[204].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			language_inst.translation_croatian[205].code := 205
			language_inst.translation_croatian[205].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka pri slanju formulara"))
			language_inst.translation_croatian[206].code := 206
			language_inst.translation_croatian[206].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nisam mogao dobiti file"))
			language_inst.translation_croatian[207].code := 207
			language_inst.translation_croatian[207].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nije bilo prethodnog tra%/190/enja"))
			language_inst.translation_croatian[208].code := 208
			language_inst.translation_croatian[208].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nije na%/240/en tra%/190/eni niz znakova"))
			language_inst.translation_croatian[209].code := 209
			language_inst.translation_croatian[209].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka pri spremanju"))
			language_inst.translation_croatian[210].code := 210
			language_inst.translation_croatian[210].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Gre%/185/ka pri pisanju u file"))
			language_inst.translation_croatian[211].code := 211
			language_inst.translation_croatian[211].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Prika%/190/i usemapu"))
			language_inst.translation_croatian[212].code := 212
			language_inst.translation_croatian[212].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Slijedi link"))
			language_inst.translation_croatian[213].code := 213
			language_inst.translation_croatian[213].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Otvori u novom prozoru"))
			language_inst.translation_croatian[214].code := 214
			language_inst.translation_croatian[214].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Preuzmi link"))
			language_inst.translation_croatian[215].code := 215
			language_inst.translation_croatian[215].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Resetiraj formular"))
			language_inst.translation_croatian[216].code := 216
			language_inst.translation_croatian[216].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Po%/185/alji formular"))
			language_inst.translation_croatian[217].code := 217
			language_inst.translation_croatian[217].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Po%/185/alji formular i otvori u novom"))
			language_inst.translation_croatian[218].code := 218
			language_inst.translation_croatian[218].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Po%/185/alji formular i preuzmi"))
			language_inst.translation_croatian[219].code := 219
			language_inst.translation_croatian[219].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Prika%/190/i sliku"))
			language_inst.translation_croatian[220].code := 220
			language_inst.translation_croatian[220].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Skini sliku"))
			language_inst.translation_croatian[221].code := 221
			language_inst.translation_croatian[221].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nema odabranih linkova"))
			language_inst.translation_croatian[222].code := 222
			language_inst.translation_croatian[222].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Slika"))
			language_inst.translation_croatian[223].code := 223
			language_inst.translation_croatian[223].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Usemapa"))
			language_inst.translation_croatian[224].code := 224
			language_inst.translation_croatian[224].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Po%/185/ali formular na"))
			language_inst.translation_croatian[225].code := 225
			language_inst.translation_croatian[225].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Postaj formular na"))
			language_inst.translation_croatian[226].code := 226
			language_inst.translation_croatian[226].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Radio gumb"))
			language_inst.translation_croatian[227].code := 227
			language_inst.translation_croatian[227].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ozna%/232/avanje"))
			language_inst.translation_croatian[228].code := 228
			language_inst.translation_croatian[228].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Odaberi polje"))
			language_inst.translation_croatian[229].code := 229
			language_inst.translation_croatian[229].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tekstualno polje"))
			language_inst.translation_croatian[230].code := 230
			language_inst.translation_croatian[230].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tekstualno podru%/232/je"))
			language_inst.translation_croatian[231].code := 231
			language_inst.translation_croatian[231].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Po%/185/alji datoteku"))
			language_inst.translation_croatian[232].code := 232
			language_inst.translation_croatian[232].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Polje za lozinku"))
			language_inst.translation_croatian[233].code := 233
			language_inst.translation_croatian[233].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ime"))
			language_inst.translation_croatian[234].code := 234
			language_inst.translation_croatian[234].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("vrijednost"))
			language_inst.translation_croatian[235].code := 235
			language_inst.translation_croatian[235].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("udari ENTER za"))
			language_inst.translation_croatian[236].code := 236
			language_inst.translation_croatian[236].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("po%/185/alji na"))
			language_inst.translation_croatian[237].code := 237
			language_inst.translation_croatian[237].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("postaj na"))
			language_inst.translation_croatian[238].code := 238
			language_inst.translation_croatian[238].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Podaci"))
			language_inst.translation_croatian[239].code := 239
			language_inst.translation_croatian[239].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Podaci o zaglavlju"))
			language_inst.translation_croatian[240].code := 240
			language_inst.translation_croatian[240].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vi ste nigdje!"))
			language_inst.translation_croatian[241].code := 241
			language_inst.translation_croatian[241].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("URL"))
			language_inst.translation_croatian[242].code := 242
			language_inst.translation_croatian[242].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Veli%/232/ina"))
			language_inst.translation_croatian[243].code := 243
			language_inst.translation_croatian[243].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("nedovr%/185/eno"))
			language_inst.translation_croatian[244].code := 244
			language_inst.translation_croatian[244].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kodna stranica"))
			language_inst.translation_croatian[245].code := 245
			language_inst.translation_croatian[245].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("pretpostavljeno"))
			language_inst.translation_croatian[246].code := 246
			language_inst.translation_croatian[246].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("zanemarujem postavke servera"))
			language_inst.translation_croatian[247].code := 247
			language_inst.translation_croatian[247].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Server"))
			language_inst.translation_croatian[248].code := 248
			language_inst.translation_croatian[248].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Datum"))
			language_inst.translation_croatian[249].code := 249
			language_inst.translation_croatian[249].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Zadnja promjena"))
			language_inst.translation_croatian[250].code := 250
			language_inst.translation_croatian[250].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Jezik"))
			language_inst.translation_croatian[251].code := 251
			language_inst.translation_croatian[251].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Xterm"))
			language_inst.translation_croatian[252].code := 252
			language_inst.translation_croatian[252].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Twterm"))
			language_inst.translation_croatian[253].code := 253
			language_inst.translation_croatian[253].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ekran"))
			language_inst.translation_croatian[254].code := 254
			language_inst.translation_croatian[254].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Prozor"))
			language_inst.translation_croatian[255].code := 255
			language_inst.translation_croatian[255].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Cijeli prozor"))
			language_inst.translation_croatian[256].code := 256
			language_inst.translation_croatian[256].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("BeOS terminal"))
			language_inst.translation_croatian[257].code := 257
			language_inst.translation_croatian[257].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Novi prozor"))
			language_inst.translation_croatian[258].code := 258
			language_inst.translation_croatian[258].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Idi na link"))
			language_inst.translation_croatian[259].code := 259
			language_inst.translation_croatian[259].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unesi broj linka"))
			language_inst.translation_croatian[260].code := 260
			language_inst.translation_croatian[260].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Promijeni veli%/232/inu terminala"))
			language_inst.translation_croatian[261].code := 261
			language_inst.translation_croatian[261].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Stupci"))
			language_inst.translation_croatian[262].code := 262
			language_inst.translation_croatian[262].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Redci"))
			language_inst.translation_croatian[263].code := 263
			language_inst.translation_croatian[263].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bilje%/185/ke"))
			language_inst.translation_croatian[264].code := 264
			language_inst.translation_croatian[264].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Dodaj bilje%/185/ku"))
			language_inst.translation_croatian[265].code := 265
			language_inst.translation_croatian[265].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kreni"))
			language_inst.translation_croatian[266].code := 266
			language_inst.translation_croatian[266].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Uredi"))
			language_inst.translation_croatian[267].code := 267
			language_inst.translation_croatian[267].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Zatvori"))
			language_inst.translation_croatian[268].code := 268
			language_inst.translation_croatian[268].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Naslov bilje%/185/ke"))
			language_inst.translation_croatian[269].code := 269
			language_inst.translation_croatian[269].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Uredi bilje%/185/ke"))
			language_inst.translation_croatian[270].code := 270
			language_inst.translation_croatian[270].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Izbri%/185/i bilje%/185/ku"))
			language_inst.translation_croatian[271].code := 271
			language_inst.translation_croatian[271].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Upravljanje bilje%/185/kama"))
			language_inst.translation_croatian[272].code := 272
			language_inst.translation_croatian[272].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url"))
			language_inst.translation_croatian[273].code := 273
			language_inst.translation_croatian[273].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ime"))
			language_inst.translation_croatian[274].code := 274
			language_inst.translation_croatian[274].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Iza%/240/i iz Linksa"))
			language_inst.translation_croatian[275].code := 275
			language_inst.translation_croatian[275].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/174/elite li zaista iza%/230/i?"))
			language_inst.translation_croatian[276].code := 276
			language_inst.translation_croatian[276].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ho%/230/emo li zbilja van (i prekinuti svako preuzimanje)?"))
			language_inst.translation_croatian[277].code := 277
			language_inst.translation_croatian[277].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP opcije"))
			language_inst.translation_croatian[278].code := 278
			language_inst.translation_croatian[278].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP opcije"))
			language_inst.translation_croatian[279].code := 279
			language_inst.translation_croatian[279].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP bug zaobilaznica"))
			language_inst.translation_croatian[280].code := 280
			language_inst.translation_croatian[280].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Koristi HTTP/1.0"))
			language_inst.translation_croatian[281].code := 281
			language_inst.translation_croatian[281].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Dozvoli crnu listu bugovitih servera"))
			language_inst.translation_croatian[282].code := 282
			language_inst.translation_croatian[282].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Neispravna redirekcija 302 (kr%/185/i RFC, ali je kompatibilno sa Netscapeom)"))
			language_inst.translation_croatian[283].code := 283
			language_inst.translation_croatian[283].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bez odr%/190/avanja veze nakon POST zahtjeva (neke bugovite PHP baze podataka trebaju ovo)"))
			language_inst.translation_croatian[284].code := 284
			language_inst.translation_croatian[284].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[285].code := 285
			language_inst.translation_croatian[285].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Lozinka za anonimni login"))
			language_inst.translation_croatian[286].code := 286
			language_inst.translation_croatian[286].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[287].code := 287
			language_inst.translation_croatian[287].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[288].code := 288
			language_inst.translation_croatian[288].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[289].code := 289
			language_inst.translation_croatian[289].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Upute za korisnika"))
			language_inst.translation_croatian[290].code := 290
			language_inst.translation_croatian[290].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Mail program (%% %/230/e biti zamijenjeno adresom)"))
			language_inst.translation_croatian[291].code := 291
			language_inst.translation_croatian[291].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Telnet program (%% %/230/e se zamijeniti sa %"host%" ili %"host port%")"))
			language_inst.translation_croatian[292].code := 292
			language_inst.translation_croatian[292].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tn3270 program (%% %/230/e biti zamijenjeno sa %"ra%/232/unalo%" ili %"ra%/232/unalo port%")"))
			language_inst.translation_croatian[293].code := 293
			language_inst.translation_croatian[293].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[294].code := 294
			language_inst.translation_croatian[294].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Mail i telnet programi"))
			language_inst.translation_croatian[295].code := 295
			language_inst.translation_croatian[295].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nema programa"))
			language_inst.translation_croatian[296].code := 296
			language_inst.translation_croatian[296].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nema programa za"))
			language_inst.translation_croatian[297].code := 297
			language_inst.translation_croatian[297].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("email"))
			language_inst.translation_croatian[298].code := 298
			language_inst.translation_croatian[298].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("telnet"))
			language_inst.translation_croatian[299].code := 299
			language_inst.translation_croatian[299].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tn3270"))
			language_inst.translation_croatian[300].code := 300
			language_inst.translation_croatian[300].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[301].code := 301
			language_inst.translation_croatian[301].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Neispravan mailto url"))
			language_inst.translation_croatian[302].code := 302
			language_inst.translation_croatian[302].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Neispravan telnet url"))
			language_inst.translation_croatian[303].code := 303
			language_inst.translation_croatian[303].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Neispravan tn3270 url"))
			language_inst.translation_croatian[304].code := 304
			language_inst.translation_croatian[304].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[305].code := 305
			language_inst.translation_croatian[305].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Korisnikov ID"))
			language_inst.translation_croatian[306].code := 306
			language_inst.translation_croatian[306].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Lozinka"))
			language_inst.translation_croatian[307].code := 307
			language_inst.translation_croatian[307].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Unesi ime korisnika za "))
			language_inst.translation_croatian[308].code := 308
			language_inst.translation_croatian[308].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" pri "))
			language_inst.translation_croatian[309].code := 309
			language_inst.translation_croatian[309].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("SSL gre%/185/ka"))
			language_inst.translation_croatian[310].code := 310
			language_inst.translation_croatian[310].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ova ina%/232/ica Linksa nema SSL/TLS podr%/185/ku"))
			language_inst.translation_croatian[311].code := 311
			language_inst.translation_croatian[311].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[312].code := 312
			language_inst.translation_croatian[312].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[313].code := 313
			language_inst.translation_croatian[313].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_croatian[314].code := 314
			language_inst.translation_croatian[314].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G"))
			language_inst.translation_croatian[315].code := 315
			language_inst.translation_croatian[315].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_croatian[316].code := 316
			language_inst.translation_croatian[316].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_croatian[317].code := 317
			language_inst.translation_croatian[317].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R"))
			language_inst.translation_croatian[318].code := 318
			language_inst.translation_croatian[318].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_croatian[319].code := 319
			language_inst.translation_croatian[319].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("j"))
			language_inst.translation_croatian[320].code := 320
			language_inst.translation_croatian[320].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_croatian[321].code := 321
			language_inst.translation_croatian[321].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_croatian[322].code := 322
			language_inst.translation_croatian[322].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_croatian[323].code := 323
			language_inst.translation_croatian[323].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("P"))
			language_inst.translation_croatian[324].code := 324
			language_inst.translation_croatian[324].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_croatian[325].code := 325
			language_inst.translation_croatian[325].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_croatian[326].code := 326
			language_inst.translation_croatian[326].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_croatian[327].code := 327
			language_inst.translation_croatian[327].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_croatian[328].code := 328
			language_inst.translation_croatian[328].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_croatian[329].code := 329
			language_inst.translation_croatian[329].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/240/"))
			language_inst.translation_croatian[330].code := 330
			language_inst.translation_croatian[330].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_croatian[331].code := 331
			language_inst.translation_croatian[331].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_croatian[332].code := 332
			language_inst.translation_croatian[332].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_croatian[333].code := 333
			language_inst.translation_croatian[333].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("P"))
			language_inst.translation_croatian[334].code := 334
			language_inst.translation_croatian[334].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_croatian[335].code := 335
			language_inst.translation_croatian[335].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_croatian[336].code := 336
			language_inst.translation_croatian[336].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_croatian[337].code := 337
			language_inst.translation_croatian[337].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_croatian[338].code := 338
			language_inst.translation_croatian[338].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_croatian[339].code := 339
			language_inst.translation_croatian[339].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("s"))
			language_inst.translation_croatian[340].code := 340
			language_inst.translation_croatian[340].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_croatian[341].code := 341
			language_inst.translation_croatian[341].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_croatian[342].code := 342
			language_inst.translation_croatian[342].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_croatian[343].code := 343
			language_inst.translation_croatian[343].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("U"))
			language_inst.translation_croatian[344].code := 344
			language_inst.translation_croatian[344].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_croatian[345].code := 345
			language_inst.translation_croatian[345].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_croatian[346].code := 346
			language_inst.translation_croatian[346].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_croatian[347].code := 347
			language_inst.translation_croatian[347].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("J"))
			language_inst.translation_croatian[348].code := 348
			language_inst.translation_croatian[348].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_croatian[349].code := 349
			language_inst.translation_croatian[349].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_croatian[350].code := 350
			language_inst.translation_croatian[350].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_croatian[351].code := 351
			language_inst.translation_croatian[351].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("r"))
			language_inst.translation_croatian[352].code := 352
			language_inst.translation_croatian[352].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V"))
			language_inst.translation_croatian[353].code := 353
			language_inst.translation_croatian[353].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("d"))
			language_inst.translation_croatian[354].code := 354
			language_inst.translation_croatian[354].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_croatian[355].code := 355
			language_inst.translation_croatian[355].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_croatian[356].code := 356
			language_inst.translation_croatian[356].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("i"))
			language_inst.translation_croatian[357].code := 357
			language_inst.translation_croatian[357].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L"))
			language_inst.translation_croatian[358].code := 358
			language_inst.translation_croatian[358].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_croatian[359].code := 359
			language_inst.translation_croatian[359].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_croatian[360].code := 360
			language_inst.translation_croatian[360].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("P"))
			language_inst.translation_croatian[361].code := 361
			language_inst.translation_croatian[361].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("U"))
			language_inst.translation_croatian[362].code := 362
			language_inst.translation_croatian[362].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_croatian[363].code := 363
			language_inst.translation_croatian[363].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_croatian[364].code := 364
			language_inst.translation_croatian[364].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("P"))
			language_inst.translation_croatian[365].code := 365
			language_inst.translation_croatian[365].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R"))
			language_inst.translation_croatian[366].code := 366
			language_inst.translation_croatian[366].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_croatian[367].code := 367
			language_inst.translation_croatian[367].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_croatian[368].code := 368
			language_inst.translation_croatian[368].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_croatian[369].code := 369
			language_inst.translation_croatian[369].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("v"))
			language_inst.translation_croatian[370].code := 370
			language_inst.translation_croatian[370].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G"))
			language_inst.translation_croatian[371].code := 371
			language_inst.translation_croatian[371].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("X"))
			language_inst.translation_croatian[372].code := 372
			language_inst.translation_croatian[372].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_croatian[373].code := 373
			language_inst.translation_croatian[373].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_croatian[374].code := 374
			language_inst.translation_croatian[374].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_croatian[375].code := 375
			language_inst.translation_croatian[375].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_croatian[376].code := 376
			language_inst.translation_croatian[376].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_croatian[377].code := 377
			language_inst.translation_croatian[377].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
		end

end
