class
	P_SMB

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
		end

feature {ANY} -- attributes

	smb_client: INTEGER_32 assign set_smb_client

	set_smb_client (a_smb_client: INTEGER_32)
		do
			smb_client := a_smb_client
		end

feature {ANY} -- routines

	end_smb_connection (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_si: CE_POINTER [PD_SMB_CONNECTION_INFO]
			l_sdir: INTEGER_32
			l_tmp___0: INTEGER_32
			l_st: CE_POINTER [NATURAL_8]
			l_ls: CE_POINTER [NATURAL_8]
			l_le: CE_POINTER [NATURAL_8]
			l_le2: CE_POINTER [NATURAL_8]
			l_ud: CE_POINTER [NATURAL_8]
			l_t: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_type: INTEGER_32
			l_pos___0: INTEGER_32
			l_spos: CE_POINTER [NATURAL_8]
			l_gpos: CE_POINTER [NATURAL_8]
			l_p: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [NATURAL_8]
			l_ppp: CE_POINTER [NATURAL_8]
			l_tmp___14: NATURAL_32
			l_tmp___15: NATURAL_32
			l_tmp___18: NATURAL_32
			l_tmp___19: NATURAL_32
			l_tmp___22: NATURAL_32
			l_tmp___26: NATURAL_32
			l_lx: CE_POINTER [NATURAL_8]
			l_ll: CE_POINTER [NATURAL_8]
			l_lll: CE_POINTER [NATURAL_8]
			l_llll: CE_POINTER [NATURAL_8]
			l_dir: INTEGER_32
			l_pp___0: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_si.make
			create l_st.make
			create l_ls.make
			create l_le.make
			create l_le2.make
			create l_ud.make
			create l_t.make (<<1>>)
			create l_l.make (<<1>>)
			create l_spos.make
			create l_gpos.make
			create l_p.make
			create l_pp.make
			create l_ppp.make
			create l_lx.make
			create l_ll.make
			create l_lll.make
			create l_llll.make
			create l_pp___0.make
			create l_p___0.make
			create l_d.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_si := create {CE_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast (a_c.item.info)
					if (a_c.item.cache).is_void then
						if (cache_inst.get_cache_entry (a_c.item.url, create {CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))).to_boolean then
							sched_inst.setcstate (a_c, -1_004)
							sched_inst.abort_connection (a_c)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 165 -- skip if block
					end
				when 1 then -- if:
						if (a_c.item.from2).to_boolean then
							l_pos := -1 + 164 -- skip if block
						end
				when 2 then -- if:
						if (l_si.item.ntext).to_boolean then
							if (l_si.item.text[l_si.item.ntext - 1]).to_integer_32 /= 10 then
								l_tmp___0 := l_si.item.ntext
								l_si.item.ntext := (l_si.item.ntext) + 1
								l_si.item.text[l_tmp___0] := (('%N').code).to_natural_8
							end
						end
						l_si.item.text[l_si.item.ntext] := (0).to_natural_8
						if not (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_si.item.text)), ce_string ("client not found%N"))).to_boolean then
							sched_inst.setcstate (a_c, -1_500)
							l_si.item.client := (l_si.item.client) + 1
							if l_si.item.client < 2 then
								if l_si.item.client > smb_client then
									smb_client := l_si.item.client
								end
								a_c.item.tries := -1
								sched_inst.retry_connection (a_c)
							else
								smb_client := 0
								sched_inst.abort_connection (a_c)
							end
							js.return
						end
						if js.return_called then
							l_pos := -1 + 163 -- skip if block
						end
				when 3 then -- if:
						l_sdir := 0
						if l_si.item.client = 1 then
							l_st := l_si.item.text
							if not (memcmp (create {CE_POINTER [ANY]}.make_cast (l_st), create {CE_POINTER [ANY]}.make_cast (ce_string ("ServerName")), (10).to_natural_32)).to_boolean then
								if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_st), ('%N').code)).is_void) then
									l_st := create {CE_POINTER [NATURAL_8]}.make_cast (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_st), ('%N').code)) + 1))
								end
							end
							if not (memcmp (create {CE_POINTER [ANY]}.make_cast (l_st), create {CE_POINTER [ANY]}.make_cast (ce_string ("Logged")), (6).to_natural_32)).to_boolean then
								if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_st), ('%N').code)).is_void) then
									l_st := create {CE_POINTER [NATURAL_8]}.make_cast (((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_st), ('%N').code)) + 1))
								end
							end
							if (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_st), ce_string ("ERR"))).is_void then
								l_sdir := 1
							end
						end
						if (l_si.item.list).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 4 then -- if:
						if not (((a_c.item.url).item).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 5 then -- if:
						if (a_c.item.url[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.url))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 47 then
							l_pos := -1 + 23 -- skip if block
						end
				when 6 then -- if:
						if (a_c.item.url[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_c.item.url))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						if (strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_si.item.text)), ce_string ("NT_STATUS_FILE_IS_A_DIRECTORY"))).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 17 -- goto _L___9
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else:
						if (strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_si.item.text)), ce_string ("NT_STATUS_ACCESS_DENIED"))).is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 17 -- goto _L___9
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else:
						if (strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_si.item.text)), ce_string ("ERRbadfile"))).is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___9
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 16 then -- else:
						if not (l_sdir.to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___9:
						if (not ((a_c.item.cache).item.redirect).is_void) then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 453, create {CE_POINTER [ANY]}.make_cast ((a_c.item.cache).item.redirect))
						end
						(a_c.item.cache).item.redirect := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 454, a_c.item.url);
						(a_c.item.cache).item.redirect_get := 1
						links_inst.add_to_strn (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared ((a_c.item.cache).c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("redirect")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")));
						(a_c.item.cache).item.incomplete := 0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_pos := -1 + 27 -- goto _L___12
				when 20 then -- if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 27 -- goto _L___12
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 27 -- goto _L___12
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___12
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 163
				when 27 then -- else: | _L___12:
						l_t.item := (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 461))
						l_l.item := 0
						l_type := 0
						l_pos___0 := 0
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<html><head><title>")))
						l_ud := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 466, a_c.item.url)
						if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ud), 1)).is_void) then
							(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ud), 1))[0] := (0).to_integer_8
						end
						url_inst.add_conv_str (l_t, l_l, l_ud, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ud))).to_integer_32, -1)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 469, create {CE_POINTER [ANY]}.make_cast (l_ud))
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</title></head><body><pre>")))
						if l_si.item.list /= 1 then
							l_pos := -1 + 32 -- skip if block
						end
				when 28 then -- if:
						if l_si.item.client /= 1 then
							l_pos := -1 + 32 -- skip if block
						end
				when 29 then -- if:
						l_spos := create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_si.item.text)), ce_string ("Server              Comment%N------              -------%N"))))
						if (not l_spos.is_void) then
							l_tmp___14 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_spos))
							l_tmp___15 := strlen (ce_string ("Server              Comment%N------              -------%N"))
							memmove (create {CE_POINTER [ANY]}.make_cast (l_spos), create {CE_POINTER [ANY]}.make_cast ((l_spos + (strlen (ce_string ("Server              Comment%N------              -------%N"))).to_integer_32)), (l_tmp___14 - l_tmp___15) + {NATURAL_32} 1).do_nothing
						end
						l_gpos := create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast ((l_si.item.text)), ce_string ("Workgroup           Master%N---------           ------%N"))))
						if (not l_gpos.is_void) then
							l_tmp___18 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_gpos))
							l_tmp___19 := strlen (ce_string ("Workgroup           Master%N---------           ------%N"))
							memmove (create {CE_POINTER [ANY]}.make_cast (l_gpos), create {CE_POINTER [ANY]}.make_cast ((l_gpos + (strlen (ce_string ("Workgroup           Master%N---------           ------%N"))).to_integer_32)), (l_tmp___18 - l_tmp___19) + {NATURAL_32} 1).do_nothing
						end
						if l_spos.is_void then
							if l_gpos.is_void then
								l_pos := -1 + 32 -- goto sc
							end
						end
				when 30 then
						l_pp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_ppp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_p := l_si.item.text
						from
						until
							js.loop_done
						loop
							l_p := create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_p), ce_string ("%N%N"))))
							if l_p.is_void then
								js.break
							end
							if not js.loop_jumped then
								l_ppp := l_pp
								l_pp := l_p + 2
								l_p := l_p + 1
							end
						end
						if l_pp.is_void then
							l_pos := -1 + 32 -- goto sc
						end
				when 31 then
						if l_spos.is_void then
							l_ppp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						elseif l_gpos.is_void then
							l_ppp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						if (not l_spos.is_void) then
							if l_ppp.is_void then
								l_ppp := l_pp
								l_pp := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							end
							l_tmp___22 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_ppp))
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_ppp + (strlen (ce_string ("Server              Comment%N------              -------%N"))).to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_ppp), l_tmp___22 + {NATURAL_32} 1).do_nothing
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_ppp), create {CE_POINTER [ANY]}.make_cast (ce_string ("Server              Comment%N------              -------%N")), (strlen (ce_string ("Server              Comment%N------              -------%N")))).do_nothing
							if (not l_pp.is_void) then
								l_pp := l_pp + (strlen (ce_string ("Server              Comment%N------              -------%N"))).to_integer_32
							end
						end
						if (not l_gpos.is_void) then
							if (not l_pp.is_void) then
								l_tmp___26 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_pp))
								memmove (create {CE_POINTER [ANY]}.make_cast ((l_pp + (strlen (ce_string ("Workgroup           Master%N---------           ------%N"))).to_integer_32)), create {CE_POINTER [ANY]}.make_cast (l_pp), l_tmp___26 + {NATURAL_32} 1).do_nothing
								memcpy (create {CE_POINTER [ANY]}.make_cast (l_pp), create {CE_POINTER [ANY]}.make_cast (ce_string ("Workgroup           Master%N---------           ------%N")), (strlen (ce_string ("Workgroup           Master%N---------           ------%N")))).do_nothing
							end
						end
						l_pos := -1 + 32 -- goto sc
				when 32 then -- if done | sc:
						l_ls := l_si.item.text
				when 33 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 162 -- skip loop
						end
				when 34 then -- loop body:
						l_le := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ls), ('%N').code)))
						if l_le.is_void then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 161 -- skip if block
						end
				when 35 then -- if:
						l_le2 := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_ls), ('%R').code)))
						if l_le2.is_void then
							l_le2 := l_le
						elseif (l_le2.c_pointer.to_integer_32).to_natural_32 > (l_le.c_pointer.to_integer_32).to_natural_32 then
							l_le2 := l_le
						end
						l_lx := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 506, l_ls, l_le2.distance (l_ls))
						if l_si.item.list /= 1 then
							l_pos := -1 + 95 -- skip if block
						end
				when 36 then -- if:
						if not (l_lx.item).to_boolean then
							l_type := 0
						end
						if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Sharename"))).is_void) then
							if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Type"))).is_void) then
								if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Type"))).is_void) then
									l_pos___0 := (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Type"))))).distance (l_lx)
								else
									l_pos___0 := 0
								end
								l_type := 1
								l_pos := -1 + 159 -- goto af
							end
						end
				when 37 then
						if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Server"))).is_void) then
							if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Comment"))).is_void) then
								l_type := 2
								l_pos := -1 + 159 -- goto af
							end
						end
				when 38 then
						if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Workgroup"))).is_void) then
							if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Master"))).is_void) then
								l_pos___0 := (create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("Master"))))).distance (l_lx)
								l_type := 3
								l_pos := -1 + 159 -- goto af
							end
						end
				when 39 then
						if not l_type.to_boolean then
							l_pos := -1 + 159 -- goto af
						end
				when 40 then
						l_ll := l_lx
				when 41 then -- loop condition:
						if not ((l_ll.item).to_boolean) then
							l_pos := -1 + 44 -- skip loop
						end
				when 42 then -- loop body:
						if (l_ll.item).to_integer_32 /= 9 then
							if (l_ll.item).to_integer_32 /= 10 then
								if (l_ll.item).to_integer_32 /= 12 then
									if (l_ll.item).to_integer_32 /= 13 then
										if (l_ll.item).to_integer_32 /= 32 then
											if (l_ll.item).to_integer_32 /= 45 then
												l_pos := -1 + 45 -- goto np
											end
										end
									end
								end
							end
						end
				when 43 then
						l_ll := l_ll + 1
						l_pos := -1 + 41 -- back to loop condition
				when 44 then -- loop done
						l_pos := -1 + 159 -- goto af
				when 45 then -- np:
						l_ll := l_lx
						from
						until
							not (not js.loop_done and then ((l_ll.item).to_boolean))
						loop
							if (l_ll.item).to_integer_32 /= 9 then
								if (l_ll.item).to_integer_32 /= 10 then
									if (l_ll.item).to_integer_32 /= 12 then
										if (l_ll.item).to_integer_32 /= 13 then
											if (l_ll.item).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_ll := l_ll + 1
							end
						end
						l_lll := l_ll
						from
						until
							not (not js.loop_done and then ((l_lll.item).to_boolean))
						loop
							if (l_lll.item).to_integer_32 = 9 then
								js.break
							elseif (l_lll.item).to_integer_32 = 10 then
								js.break
							elseif (l_lll.item).to_integer_32 = 12 then
								js.break
							elseif (l_lll.item).to_integer_32 = 13 then
								js.break
							elseif (l_lll.item).to_integer_32 = 32 then
								js.break
							end
							if not js.loop_jumped then
								l_lll := l_lll + 1
							end
						end
						if l_type /= 1 then
							l_pos := -1 + 65 -- skip if block
						end
				when 46 then -- if:
						if (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lll), ce_string ("Disk"))).is_void then
							l_pos := -1 + 159 -- goto af
						end
				when 47 then
						if not (l_pos___0.to_boolean) then
							l_pos := -1 + 63 -- skip if block
						end
				when 48 then -- if:
						if not (l_pos___0.to_natural_32 < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx)))) then
							l_pos := -1 + 63 -- skip if block
						end
				when 49 then -- if:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 9 then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						l_pos := -1 + 62 -- goto _L
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 52 then -- else:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 10 then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						l_pos := -1 + 62 -- goto _L
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 55 then -- else:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 12 then
							l_pos := -1 + 58 -- skip if block
						end
				when 56 then -- if:
						l_pos := -1 + 62 -- goto _L
				when 57 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 58 then -- else:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 13 then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						l_pos := -1 + 62 -- goto _L
				when 60 then -- if block done, skip else block:
						l_pos := -1 + 63
				when 61 then -- else:
						l_llll := (l_lx + l_pos___0) - 1
						if (l_llll.item).to_integer_32 /= 32 then
							l_pos := -1 + 63 -- skip if block
						end
				when 62 then -- if: | _L:
						if (l_llll.c_pointer.to_integer_32).to_natural_32 > (l_ll.c_pointer.to_integer_32).to_natural_32 then
							from
							until
								js.loop_done
							loop
								if (l_llll.c_pointer.to_integer_32).to_natural_32 > (l_ll.c_pointer.to_integer_32).to_natural_32 then
									if (l_llll.item).to_integer_32 /= 9 then
										if (l_llll.item).to_integer_32 /= 10 then
											if (l_llll.item).to_integer_32 /= 12 then
												if (l_llll.item).to_integer_32 /= 13 then
													if (l_llll.item).to_integer_32 /= 32 then
														js.break
													end
												end
											end
										end
									end
								else
									js.break
								end
								if not js.loop_jumped then
									l_llll := l_llll - 1
								end
							end
							if (l_llll.item).to_integer_32 /= 9 then
								if (l_llll.item).to_integer_32 /= 10 then
									if (l_llll.item).to_integer_32 /= 12 then
										if (l_llll.item).to_integer_32 /= 13 then
											if (l_llll.item).to_integer_32 /= 32 then
												l_lll := l_llll + 1
											end
										end
									end
								end
							end
						end
				when 63 then -- if done | if done | if done | if done | if done | if done
						url_inst.add_conv_str (l_t, l_l, l_lx, l_ll.distance (l_lx), 0)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<a href=%"/")))
						url_inst.add_conv_str (l_t, l_l, l_ll, l_lll.distance (l_ll), 1)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/%">")))
						url_inst.add_conv_str (l_t, l_l, l_ll, l_lll.distance (l_ll), 0)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</a>")))
						url_inst.add_conv_str (l_t, l_l, l_lll, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lll))).to_integer_32, 0)
				when 64 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 65 then -- else:
						if l_type /= 2 then
							l_pos := -1 + 68 -- skip if block
						end
				when 66 then -- if: | sss:
						url_inst.add_conv_str (l_t, l_l, l_lx, l_ll.distance (l_lx), 0)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<a href=%"smb://")))
						url_inst.add_conv_str (l_t, l_l, l_ll, l_lll.distance (l_ll), 1)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/%">")))
						url_inst.add_conv_str (l_t, l_l, l_ll, l_lll.distance (l_ll), 0)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</a>")))
						url_inst.add_conv_str (l_t, l_l, l_lll, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lll))).to_integer_32, 0)
				when 67 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 68 then -- else:
						if l_type /= 3 then
							l_pos := -1 + 93 -- skip if block
						end
				when 69 then -- if:
						if not (l_pos___0.to_natural_32 < (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx)))) then
							l_pos := -1 + 90 -- skip if block
						end
				when 70 then -- if:
						if not (l_pos___0.to_boolean) then
							l_pos := -1 + 88 -- skip if block
						end
				when 71 then -- if:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 9 then
							l_pos := -1 + 74 -- skip if block
						end
				when 72 then -- if:
						l_pos := -1 + 84 -- goto _L___2
				when 73 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 74 then -- else:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 10 then
							l_pos := -1 + 77 -- skip if block
						end
				when 75 then -- if:
						l_pos := -1 + 84 -- goto _L___2
				when 76 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 77 then -- else:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 12 then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						l_pos := -1 + 84 -- goto _L___2
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 80 then -- else:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 13 then
							l_pos := -1 + 83 -- skip if block
						end
				when 81 then -- if:
						l_pos := -1 + 84 -- goto _L___2
				when 82 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 83 then -- else:
						if (l_lx[(l_pos___0 - 1)]).to_integer_32 /= 32 then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if: | _L___2:
						if (l_lx[l_pos___0]).to_integer_32 = 9 then
							l_pos := -1 + 90 -- goto _L___3
						elseif (l_lx[l_pos___0]).to_integer_32 = 10 then
							l_pos := -1 + 90 -- goto _L___3
						elseif (l_lx[l_pos___0]).to_integer_32 = 12 then
							l_pos := -1 + 90 -- goto _L___3
						elseif (l_lx[l_pos___0]).to_integer_32 = 13 then
							l_pos := -1 + 90 -- goto _L___3
						elseif (l_lx[l_pos___0]).to_integer_32 = 32 then
							l_pos := -1 + 90 -- goto _L___3
						else
							l_ll := l_lx + l_pos___0
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 87
				when 86 then -- else:
						l_pos := -1 + 90 -- goto _L___3
				when 87 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 89
				when 88 then -- else:
						l_pos := -1 + 90 -- goto _L___3
				when 89 then -- if done | if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else: | _L___3:
						l_ll := l_lll
						from
						until
							not (not js.loop_done and then ((l_ll.item).to_boolean))
						loop
							if (l_ll.item).to_integer_32 /= 9 then
								if (l_ll.item).to_integer_32 /= 10 then
									if (l_ll.item).to_integer_32 /= 12 then
										if (l_ll.item).to_integer_32 /= 13 then
											if (l_ll.item).to_integer_32 /= 32 then
												js.break
											end
										end
									end
								end
							end
							if not js.loop_jumped then
								l_ll := l_ll + 1
							end
						end
				when 91 then
						l_lll := l_ll
						from
						until
							not (not js.loop_done and then ((l_lll.item).to_boolean))
						loop
							if (l_lll.item).to_integer_32 = 9 then
								js.break
							elseif (l_lll.item).to_integer_32 = 10 then
								js.break
							elseif (l_lll.item).to_integer_32 = 12 then
								js.break
							elseif (l_lll.item).to_integer_32 = 13 then
								js.break
							elseif (l_lll.item).to_integer_32 = 32 then
								js.break
							end
							if not js.loop_jumped then
								l_lll := l_lll + 1
							end
						end
						l_pos := -1 + 66 -- goto sss
				when 92 then -- if block done, skip else block:
						l_pos := -1 + 94
				when 93 then -- else:
						l_pos := -1 + 159 -- goto af
				when 94 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 160
				when 95 then -- else:
						if l_si.item.list /= 2 then
							l_pos := -1 + 119 -- skip if block
						end
				when 96 then -- if:
						if l_si.item.client /= 0 then
							l_pos := -1 + 117 -- skip if block
						end
				when 97 then -- if:
						if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_lx), ce_string ("NT_STATUS"))).is_void) then
							l_le[1] := (0).to_natural_8
							l_pos := -1 + 159 -- goto af
						end
				when 98 then
						if not (l_le2.distance (l_ls) >= 5) then
							l_pos := -1 + 115 -- skip if block
						end
				when 99 then -- if:
						if (l_ls[0]).to_integer_32 /= 32 then
							l_pos := -1 + 113 -- skip if block
						end
				when 100 then -- if:
						if (l_ls[1]).to_integer_32 /= 32 then
							l_pos := -1 + 111 -- skip if block
						end
				when 101 then -- if:
						if (l_ls[2]).to_integer_32 = 32 then
							l_pos := -1 + 109 -- skip if block
						end
				when 102 then -- if:
						l_p___0 := l_ls + 3
				when 103 then -- loop condition:
						if not (((l_p___0 + 2).c_pointer.to_integer_32).to_natural_32 <= (l_le2.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 106 -- skip loop
						end
				when 104 then -- loop body:
						if (l_p___0[0]).to_integer_32 = 32 then
							if (l_p___0[1]).to_integer_32 = 32 then
								l_pos := -1 + 107 -- goto o
							end
						end
				when 105 then
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 103 -- back to loop condition
				when 106 then -- loop done
						l_pos := -1 + 159 -- goto af
				when 107 then -- o:
						l_dir := 0
						l_pp___0 := l_p___0
						from
						until
							js.loop_done
						loop
							if (l_pp___0.c_pointer.to_integer_32).to_natural_32 < (l_le2.c_pointer.to_integer_32).to_natural_32 then
								if (l_pp___0.item).to_integer_32 /= 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_pp___0 := l_pp___0 + 1
							end
						end
						from
						until
							js.loop_done
						loop
							if (l_pp___0.c_pointer.to_integer_32).to_natural_32 < (l_le2.c_pointer.to_integer_32).to_natural_32 then
								if (l_pp___0.item).to_integer_32 = 32 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped and then ((l_pp___0.item).to_integer_32 = 68) then
								l_dir := 1
								js.break
							end
							if not js.loop_jumped then
								l_pp___0 := l_pp___0 + 1
							end
						end
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("  <a href=%"./")))
						url_inst.add_conv_str (l_t, l_l, l_ls + 2, l_p___0.distance ((l_ls + 2)), 1)
						if l_dir.to_boolean then
							links_inst.add_chr_to_str (l_t, l_l, (('/').code).to_natural_8)
						end
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%">")))
						url_inst.add_conv_str (l_t, l_l, l_ls + 2, l_p___0.distance ((l_ls + 2)), 0)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</a>")))
						url_inst.add_conv_str (l_t, l_l, l_p___0, l_le.distance (l_p___0), 0)
				when 108 then -- if block done, skip else block:
						l_pos := -1 + 110
				when 109 then -- else:
						l_pos := -1 + 159 -- goto af
				when 110 then -- if done | if block done, skip else block:
						l_pos := -1 + 112
				when 111 then -- else:
						l_pos := -1 + 159 -- goto af
				when 112 then -- if done | if block done, skip else block:
						l_pos := -1 + 114
				when 113 then -- else:
						l_pos := -1 + 159 -- goto af
				when 114 then -- if done | if block done, skip else block:
						l_pos := -1 + 116
				when 115 then -- else:
						l_pos := -1 + 159 -- goto af
				when 116 then -- if done | if block done, skip else block:
						l_pos := -1 + 118
				when 117 then -- else:
						l_pos := -1 + 119 -- goto _L___7
				when 118 then -- if done | if block done, skip else block:
						l_pos := -1 + 160
				when 119 then -- else: | _L___7:
						if l_si.item.list /= 2 then
							l_pos := -1 + 159 -- skip if block
						end
				when 120 then -- if:
						if l_si.item.client /= 1 then
							l_pos := -1 + 157 -- skip if block
						end
				when 121 then -- if:
						if l_le2.distance (l_ls) <= 17 then
							l_pos := -1 + 159 -- goto af
						end
				when 122 then
						l_d := l_ls + 17
				when 123 then -- smbc_next_chr:
						if ((l_d + 9).c_pointer.to_integer_32).to_natural_32 >= (l_le2.c_pointer.to_integer_32).to_natural_32 then
							l_pos := -1 + 159 -- goto af
						end
				when 124 then
						if (l_d[0]).to_integer_32 /= 58 then
							l_pos := -1 + 154 -- skip if block
						end
				when 125 then -- if:
						if not ((l_d[1]).to_integer_32 >= 48) then
							l_pos := -1 + 152 -- skip if block
						end
				when 126 then -- if:
						if not ((l_d[1]).to_integer_32 <= 57) then
							l_pos := -1 + 150 -- skip if block
						end
				when 127 then -- if:
						if not ((l_d[2]).to_integer_32 >= 48) then
							l_pos := -1 + 148 -- skip if block
						end
				when 128 then -- if:
						if not ((l_d[2]).to_integer_32 <= 57) then
							l_pos := -1 + 146 -- skip if block
						end
				when 129 then -- if:
						if (l_d[3]).to_integer_32 /= 32 then
							l_pos := -1 + 144 -- skip if block
						end
				when 130 then -- if:
						if (l_d[4]).to_integer_32 /= 49 then
							l_pos := -1 + 133 -- skip if block
						end
				when 131 then -- if:
						if (l_d[5]).to_integer_32 = 57 then
							l_pos := -1 + 136 -- goto _L___4
						else
							l_pos := -1 + 133 -- goto _L___5
						end
				when 132 then -- if block done, skip else block:
						l_pos := -1 + 143
				when 133 then -- else: | _L___5:
						if (l_d[4]).to_integer_32 /= 50 then
							l_pos := -1 + 142 -- skip if block
						end
				when 134 then -- if:
						if not ((l_d[5]).to_integer_32 >= 48) then
							l_pos := -1 + 140 -- skip if block
						end
				when 135 then -- if:
						if not ((l_d[5]).to_integer_32 <= 57) then
							l_pos := -1 + 138 -- skip if block
						end
				when 136 then -- if: | _L___4:
						if (l_d[6]).to_integer_32 >= 48 then
							if (l_d[6]).to_integer_32 <= 57 then
								if (l_d[7]).to_integer_32 >= 48 then
									if (l_d[7]).to_integer_32 <= 57 then
										if (l_d[8]).to_integer_32 /= 32 then
											l_d := l_d + 1
											l_pos := -1 + 123 -- goto smbc_next_chr
										end
									else
										l_d := l_d + 1
										l_pos := -1 + 123 -- goto smbc_next_chr
									end
								else
									l_d := l_d + 1
									l_pos := -1 + 123 -- goto smbc_next_chr
								end
							else
								l_d := l_d + 1
								l_pos := -1 + 123 -- goto smbc_next_chr
							end
						else
							l_d := l_d + 1
							l_pos := -1 + 123 -- goto smbc_next_chr
						end
				when 137 then -- if block done, skip else block:
						l_pos := -1 + 139
				when 138 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 139 then -- if done | if block done, skip else block:
						l_pos := -1 + 141
				when 140 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 141 then -- if done | if block done, skip else block:
						l_pos := -1 + 143
				when 142 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 143 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 145
				when 144 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 145 then -- if done | if block done, skip else block:
						l_pos := -1 + 147
				when 146 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 147 then -- if done | if block done, skip else block:
						l_pos := -1 + 149
				when 148 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 149 then -- if done | if block done, skip else block:
						l_pos := -1 + 151
				when 150 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 151 then -- if done | if block done, skip else block:
						l_pos := -1 + 153
				when 152 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 153 then -- if done | if block done, skip else block:
						l_pos := -1 + 155
				when 154 then -- else:
						l_d := l_d + 1
						l_pos := -1 + 123 -- goto smbc_next_chr
				when 155 then
						l_d := l_d + (9)
						url_inst.add_conv_str (l_t, l_l, l_ls, l_d.distance (l_ls), 0)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<a href=%"./")))
						url_inst.add_conv_str (l_t, l_l, l_d, l_le2.distance (l_d), 1)
						if (l_ls[4]).to_integer_32 = 68 then
							links_inst.add_chr_to_str (l_t, l_l, (('/').code).to_natural_8)
						end
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%">")))
						url_inst.add_conv_str (l_t, l_l, l_d, l_le2.distance (l_d), 0)
						links_inst.add_to_str (l_t, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("</a>")))
				when 156 then -- if block done, skip else block:
						l_pos := -1 + 158
				when 157 then -- else:
						l_pos := -1 + 159 -- goto af
				when 158 then -- if done | if block done, skip else block:
						l_pos := -1 + 160
				when 159 then -- else: | af:
						url_inst.add_conv_str (l_t, l_l, l_ls, l_le2.distance (l_ls), 0)
				when 160 then -- if done | if done
						links_inst.add_chr_to_str (l_t, l_l, (('%N').code).to_natural_8)
						l_ls := l_le + 1
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 614, create {CE_POINTER [ANY]}.make_cast (l_lx))
				when 161 then -- if done
						l_pos := -1 + 33 -- back to loop condition
				when 162 then -- loop done
						cache_inst.add_fragment (a_c.item.cache, (0).to_integer_32, l_t.item, (l_l.item).to_integer_32).do_nothing
						a_c.item.from2 := a_c.item.from2 + (l_l.item).to_integer_32
						cache_inst.truncate_entry (a_c.item.cache, (l_l.item).to_integer_32, 1);
						(a_c.item.cache).item.incomplete := 0
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 621, create {CE_POINTER [ANY]}.make_cast (l_t.item))
						if ((a_c.item.cache).item.head).is_void then
							(a_c.item.cache).item.head := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 622, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%R%N")))
						end
						links_inst.add_to_strn (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared ((a_c.item.cache).c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("head")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Content-Type: text/html%R%N")))
				when 163 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 165
				when 164 then -- else:
						cache_inst.truncate_entry (a_c.item.cache, a_c.item.from2, 1);
						(a_c.item.cache).item.incomplete := 0
				when 165 then -- if done
						if not js.return_called then
							connect_inst.close_socket (create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock1")))
							connect_inst.close_socket (create {CE_POINTER [INTEGER_32]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("sock2")))
							sched_inst.setcstate (a_c, -1_000)
							sched_inst.abort_connection (a_c)
						end
				when 166 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	smb_func (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_i: INTEGER_32
			l_po: CE_ARRAY [INTEGER_32]
			l_pe: CE_ARRAY [INTEGER_32]
			l_host: CE_POINTER [NATURAL_8]
			l_user: CE_POINTER [NATURAL_8]
			l_pass: CE_POINTER [NATURAL_8]
			l_port: CE_POINTER [NATURAL_8]
			l_data1: CE_POINTER [NATURAL_8]
			l_data: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_share: CE_POINTER [NATURAL_8]
			l_dir: CE_POINTER [NATURAL_8]
			l_datal: CE_ARRAY [INTEGER_32]
			l_p: CE_POINTER [NATURAL_8]
			l_r: INTEGER_32
			l_si: CE_POINTER [PD_SMB_CONNECTION_INFO]
			l_n: INTEGER_32
			l_v: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_uphp: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_s___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___27: INTEGER_32
			l_ss: CE_POINTER [NATURAL_8]
			l_s___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___30: INTEGER_32
			l_tmp___31: INTEGER_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_tmp___37: INTEGER_32
			l_tmp___38: INTEGER_32
			l_tmp___39: INTEGER_32
			l_d: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_dl: CE_ARRAY [INTEGER_32]
			l_dp: CE_POINTER [NATURAL_8]
			l_tmp___41: INTEGER_32
			l_tmp___42: INTEGER_32
			l_tmp___43: INTEGER_32
			l_tmp___46: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_po.make (<<2>>)
			create l_pe.make (<<2>>)
			create l_host.make
			create l_user.make
			create l_pass.make
			create l_port.make
			create l_data1.make
			create l_data.make (<<1>>)
			create l_share.make
			create l_dir.make
			create l_datal.make (<<1>>)
			create l_p.make
			create l_si.make
			create l_v.make (<<32>>)
			create l_uphp.make (<<1>>)
			create l_s.make (<<1>>)
			create l_s___0.make (<<1>>)
			create l_ss.make
			create l_s___1.make (<<1>>)
			create l_d.make (<<1>>)
			create l_dl.make (<<1>>)
			create l_dp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_si := create {CE_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 35, (create {PD_SMB_CONNECTION_INFO}.make).structure_size.to_natural_32 + {NATURAL_32} 2)))
					memset (create {CE_POINTER [ANY]}.make_cast (l_si), 0, (create {PD_SMB_CONNECTION_INFO}.make).structure_size.to_natural_32).do_nothing
					a_c.item.info := create {CE_POINTER [ANY]}.make_cast (l_si)
					l_si.item.client := smb_client
					l_host := url_inst.get_host_name (a_c.item.url)
					if l_host.is_void then
						sched_inst.setcstate (a_c, -1_003)
						sched_inst.abort_connection (a_c)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_user := url_inst.get_user_name (a_c.item.url)
						if l_user.is_void then
							l_user := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 45, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						l_pass := url_inst.get_pass (a_c.item.url)
						if l_pass.is_void then
							l_pass := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 46, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						l_port := url_inst.get_port_str (a_c.item.url)
						if l_port.is_void then
							l_port := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 47, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						end
						l_data1 := url_inst.get_url_data (a_c.item.url)
						if l_data1.is_void then
							l_data1 := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
						end
						l_data.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 49)
						l_datal.item := 0
						url_inst.add_conv_str (l_data, l_datal, l_data1, (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_data1))).to_integer_32, -2)
						l_i := 0
				when 2 then -- loop condition:
						if not (not js.loop_done and then ((l_data.item[l_i]).to_boolean)) then
							l_pos := -1 + 13 -- skip loop
						end
				when 3 then -- loop body:
						if not ((l_data.item[l_i]).to_integer_32 < 32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 6 then -- else:
						if (l_data.item[l_i]).to_integer_32 /= 59 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 9 then -- else:
						if (l_data.item[l_i]).to_integer_32 /= 34 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if smb_client /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 55, create {CE_POINTER [ANY]}.make_cast (l_host))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 56, create {CE_POINTER [ANY]}.make_cast (l_port))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 57, create {CE_POINTER [ANY]}.make_cast (l_user))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 58, create {CE_POINTER [ANY]}.make_cast (l_pass))
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 59, create {CE_POINTER [ANY]}.make_cast (l_data.item))
						sched_inst.setcstate (a_c, -1_009)
						sched_inst.abort_connection (a_c)
						js.return
				when 12 then -- if done | if done | if done
						if not js.return_called then
							l_i := l_i + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 13 then -- loop done | if done
						if not js.return_called then
							l_p := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_data.item), ('/').code)))
							if (not l_p.is_void) then
								l_share := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 65, l_data.item, l_p.distance ((l_data.item)))
								l_dir := l_p + 1
							elseif (l_data.item.item).to_boolean then
								if (a_c.item.cache).is_void then
									if (cache_inst.get_cache_entry (a_c.item.url, create {CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))).to_boolean then
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 68, create {CE_POINTER [ANY]}.make_cast (l_host))
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 69, create {CE_POINTER [ANY]}.make_cast (l_port))
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 70, create {CE_POINTER [ANY]}.make_cast (l_user))
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 71, create {CE_POINTER [ANY]}.make_cast (l_pass))
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 72, create {CE_POINTER [ANY]}.make_cast (l_data.item))
										sched_inst.setcstate (a_c, -1_004)
										sched_inst.abort_connection (a_c)
										js.return
									end
								end
								if not js.return_called then
									if (not ((a_c.item.cache).item.redirect).is_void) then
										error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 77, create {CE_POINTER [ANY]}.make_cast ((a_c.item.cache).item.redirect))
									end
									(a_c.item.cache).item.redirect := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 78, a_c.item.url);
									(a_c.item.cache).item.redirect_get := 1
									links_inst.add_to_strn (create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared ((a_c.item.cache).c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("redirect")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")));
									(a_c.item.cache).item.incomplete := 0
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 82, create {CE_POINTER [ANY]}.make_cast (l_host))
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 83, create {CE_POINTER [ANY]}.make_cast (l_port))
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 84, create {CE_POINTER [ANY]}.make_cast (l_user))
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 85, create {CE_POINTER [ANY]}.make_cast (l_pass))
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 86, create {CE_POINTER [ANY]}.make_cast (l_data.item))
									sched_inst.setcstate (a_c, -1_000)
									sched_inst.abort_connection (a_c)
									js.return
								end
							else
								l_share := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 90, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
								l_dir := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
							end
						end
						if not js.return_called then
							if not (l_share.item).to_boolean then
								l_si.item.list := 1
							elseif not (l_dir.item).to_boolean then
								l_si.item.list := 2
							elseif (l_dir[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 47 then
								l_si.item.list := 2
							elseif (l_dir[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 92 then
								l_si.item.list := 2
							end
							if (os_dep_inst.c2_pipe (l_po)).to_boolean then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 94, create {CE_POINTER [ANY]}.make_cast (l_host))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 95, create {CE_POINTER [ANY]}.make_cast (l_port))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 96, create {CE_POINTER [ANY]}.make_cast (l_user))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 97, create {CE_POINTER [ANY]}.make_cast (l_pass))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 98, create {CE_POINTER [ANY]}.make_cast (l_share))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 99, create {CE_POINTER [ANY]}.make_cast (l_data.item))
								sched_inst.setcstate (a_c, -(errno_location).item)
								sched_inst.abort_connection (a_c)
								js.return
							end
						end
						if not js.return_called then
							if (os_dep_inst.c2_pipe (l_pe)).to_boolean then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 105, create {CE_POINTER [ANY]}.make_cast (l_host))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 106, create {CE_POINTER [ANY]}.make_cast (l_port))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 107, create {CE_POINTER [ANY]}.make_cast (l_user))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 108, create {CE_POINTER [ANY]}.make_cast (l_pass))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 109, create {CE_POINTER [ANY]}.make_cast (l_share))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 110, create {CE_POINTER [ANY]}.make_cast (l_data.item))
								close (l_po[0]).do_nothing
								close (l_po[1]).do_nothing
								sched_inst.setcstate (a_c, -(errno_location).item)
								sched_inst.abort_connection (a_c)
								js.return
							end
						end
						if not js.return_called then
							a_c.item.from2 := (0).to_integer_32
							l_r := fork
							if l_r = -1 then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 120, create {CE_POINTER [ANY]}.make_cast (l_host))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 121, create {CE_POINTER [ANY]}.make_cast (l_port))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 122, create {CE_POINTER [ANY]}.make_cast (l_user))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 123, create {CE_POINTER [ANY]}.make_cast (l_pass))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 124, create {CE_POINTER [ANY]}.make_cast (l_share))
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 125, create {CE_POINTER [ANY]}.make_cast (l_data.item))
								close (l_po[0]).do_nothing
								close (l_po[1]).do_nothing
								close (l_pe[0]).do_nothing
								close (l_pe[1]).do_nothing
								sched_inst.setcstate (a_c, -(errno_location).item)
								sched_inst.retry_connection (a_c)
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 45 -- skip if block
						end
				when 14 then -- if:
							if l_r.to_boolean then
								l_pos := -1 + 44 -- skip if block
							end
				when 15 then -- if:
							os_dep_inst.close_fork_tty
							close (1).do_nothing
							if (l_si.item.list).to_boolean then
								dup2 (l_pe[1], 1).do_nothing
							else
								dup2 (l_po[1], 1).do_nothing
							end
							close (2).do_nothing
							dup2 (l_pe[1], 2).do_nothing
							close (0).do_nothing
							open ([ce_string ("/dev/null"), 0]).do_nothing
							close (l_po[0]).do_nothing
							close (l_pe[0]).do_nothing
							close (l_po[1]).do_nothing
							close (l_pe[1]).do_nothing
							l_n := 0
							inspect l_si.item.client -- switch 1 head
							when 0 then l_pos := -1 + 16
							when 1 then l_pos := -1 + 28
							else l_pos := -1 + 42
							end
				when 16 then -- switch 1, case 0
							l_tmp___10 := l_n
							l_n := l_n + 1
							l_v[l_tmp___10] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smbclient"))
							if not (l_share.item).to_boolean then
								l_tmp___11 := l_n
								l_n := l_n + 1
								l_v[l_tmp___11] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-L"))
								l_tmp___12 := l_n
								l_n := l_n + 1
								l_v[l_tmp___12] := l_host
							else
								l_s.item := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 158, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("//"))))
								links_inst.add_to_strn (l_s, l_host)
								links_inst.add_to_strn (l_s, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
								links_inst.add_to_strn (l_s, l_share)
								l_tmp___14 := l_n
								l_n := l_n + 1
								l_v[l_tmp___14] := l_s.item
								if (l_pass.item).to_boolean then
									if not (l_user.item).to_boolean then
										l_tmp___15 := l_n
										l_n := l_n + 1
										l_v[l_tmp___15] := l_pass
									end
								end
							end
							l_tmp___16 := l_n
							l_n := l_n + 1
							l_v[l_tmp___16] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-N"))
							l_tmp___17 := l_n
							l_n := l_n + 1
							l_v[l_tmp___17] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-E"))
							if (l_port.item).to_boolean then
								l_tmp___18 := l_n
								l_n := l_n + 1
								l_v[l_tmp___18] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-p"))
								l_tmp___19 := l_n
								l_n := l_n + 1
								l_v[l_tmp___19] := l_port
							end
							if (l_user.item).to_boolean then
								l_tmp___20 := l_n
								l_n := l_n + 1
								l_v[l_tmp___20] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-U"))
								if not (l_pass.item).to_boolean then
									l_tmp___21 := l_n
									l_n := l_n + 1
									l_v[l_tmp___21] := l_user
								else
									l_s___0.item := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 178, l_user))
									links_inst.add_to_strn (l_s___0, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%")))
									links_inst.add_to_strn (l_s___0, l_pass)
									l_tmp___23 := l_n
									l_n := l_n + 1
									l_v[l_tmp___23] := l_s___0.item
								end
							end
							if not ((l_share.item).to_boolean) then
								l_pos := -1 + 27 -- skip if block
							end
				when 17 then -- if:
							if (l_dir.item).to_boolean then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							l_pos := -1 + 24 -- goto _L___0
				when 19 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 20 then -- else:
							if (l_dir[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
								l_pos := -1 + 23 -- skip if block
							end
				when 21 then -- if:
							l_pos := -1 + 24 -- goto _L___0
				when 22 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 23 then -- else:
							if (l_dir[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
								l_pos := -1 + 26 -- skip if block
							end
				when 24 then -- if: | _L___0:
							if (l_dir.item).to_boolean then
								l_tmp___24 := l_n
								l_n := l_n + 1
								l_v[l_tmp___24] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-D"))
								l_tmp___25 := l_n
								l_n := l_n + 1
								l_v[l_tmp___25] := l_dir
							end
							l_tmp___26 := l_n
							l_n := l_n + 1
							l_v[l_tmp___26] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-c"))
							l_tmp___27 := l_n
							l_n := l_n + 1
							l_v[l_tmp___27] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ls"))
				when 25 then -- if block done, skip else block:
							l_pos := -1 + 27
				when 26 then -- else:
							l_s___1.item := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 194, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("get %""))))
							links_inst.add_to_strn (l_s___1, l_dir)
							links_inst.add_to_strn (l_s___1, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%" -")))
							from
							until
								js.loop_done
							loop
								l_ss := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_s___1.item), ('/').code)))
								if l_ss.is_void then
									js.break
								end
								if not js.loop_jumped then
									l_ss.item := (('\').code).to_natural_8
								end
							end
							l_tmp___30 := l_n
							l_n := l_n + 1
							l_v[l_tmp___30] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-c"))
							l_tmp___31 := l_n
							l_n := l_n + 1
							l_v[l_tmp___31] := l_s___1.item
				when 27 then -- if done | if done | if done
							l_pos := -1 + 43 -- switch 1; break
				when 28 then -- switch 1, case 1
							l_tmp___34 := l_n
							l_n := l_n + 1
							l_v[l_tmp___34] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smbc"))
							l_uphp.item := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 205, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
							if (l_user.item).to_boolean then
								links_inst.add_to_strn (l_uphp, l_user)
								if (l_pass.item).to_boolean then
									links_inst.add_to_strn (l_uphp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")))
									links_inst.add_to_strn (l_uphp, l_pass)
								end
								links_inst.add_to_strn (l_uphp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@")))
							end
							links_inst.add_to_strn (l_uphp, l_host)
							if (l_port.item).to_boolean then
								links_inst.add_to_strn (l_uphp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")))
								links_inst.add_to_strn (l_uphp, l_port)
							end
							if (l_share.item).to_boolean then
								l_pos := -1 + 31 -- skip if block
							end
				when 29 then -- if:
							l_tmp___35 := l_n
							l_n := l_n + 1
							l_v[l_tmp___35] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-L"))
							l_tmp___36 := l_n
							l_n := l_n + 1
							l_v[l_tmp___36] := l_uphp.item
				when 30 then -- if block done, skip else block:
							l_pos := -1 + 41
				when 31 then -- else:
							links_inst.add_to_strn (l_uphp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
							links_inst.add_to_strn (l_uphp, l_share)
							if (l_dir.item).to_boolean then
								l_pos := -1 + 34 -- skip if block
							end
				when 32 then -- if:
							l_pos := -1 + 38 -- goto _L___1
				when 33 then -- if block done, skip else block:
							l_pos := -1 + 41
				when 34 then -- else:
							if (l_dir[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 47 then
								l_pos := -1 + 37 -- skip if block
							end
				when 35 then -- if:
							l_pos := -1 + 38 -- goto _L___1
				when 36 then -- if block done, skip else block:
							l_pos := -1 + 41
				when 37 then -- else:
							if (l_dir[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_dir))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 92 then
								l_pos := -1 + 40 -- skip if block
							end
				when 38 then -- if: | _L___1:
							links_inst.add_to_strn (l_uphp, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
							links_inst.add_to_strn (l_uphp, l_dir)
							l_tmp___37 := l_n
							l_n := l_n + 1
							l_v[l_tmp___37] := l_uphp.item
							l_tmp___38 := l_n
							l_n := l_n + 1
							l_v[l_tmp___38] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-c"))
							l_tmp___39 := l_n
							l_n := l_n + 1
							l_v[l_tmp___39] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ls"))
				when 39 then -- if block done, skip else block:
							l_pos := -1 + 41
				when 40 then -- else:
							l_d.item := (links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 232))
							l_dl.item := 0
							l_dp := l_dir
							l_tmp___41 := l_n
							l_n := l_n + 1
							l_v[l_tmp___41] := l_uphp.item
							l_tmp___42 := l_n
							l_n := l_n + 1
							l_v[l_tmp___42] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("-c"))
							links_inst.add_to_str (l_d, l_dl, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("pipe cat ")))
							from
							until
								not ((l_dp.item).to_boolean)
							loop
								if (l_dp.item).to_integer_32 <= 32 then
									links_inst.add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								elseif (l_dp.item).to_integer_32 = 92 then
									links_inst.add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								elseif (l_dp.item).to_integer_32 = 34 then
									links_inst.add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								elseif (l_dp.item).to_integer_32 = 39 then
									links_inst.add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								elseif (l_dp.item).to_integer_32 = 42 then
									links_inst.add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								elseif (l_dp.item).to_integer_32 = 63 then
									links_inst.add_chr_to_str (l_d, l_dl, (('\').code).to_natural_8)
								end
								links_inst.add_chr_to_str (l_d, l_dl, l_dp.item)
								l_dp := l_dp + 1
							end
							l_tmp___43 := l_n
							l_n := l_n + 1
							l_v[l_tmp___43] := l_d.item
				when 41 then -- if done | if done | if done
							l_pos := -1 + 43 -- switch 1; break
				when 42 then -- switch 1, default:
							from
							until
								False
							loop
								links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c"))
								links_inst.errline := 248
								error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("unsuported smb client"))])
							end
				when 43 then -- switch 1, done:
							l_tmp___46 := l_n
							l_n := l_n + 1
							l_v[l_tmp___46] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
							execvp (create {CE_POINTER [INTEGER_8]}.make_cast (l_v[0]), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (l_v)).do_nothing
							Io.error.put_string ("client not found")
							Io.error.flush
							exit2 (1)
				when 44 then -- if done
							a_c.item.pid := l_r
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 257, create {CE_POINTER [ANY]}.make_cast (l_host))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 258, create {CE_POINTER [ANY]}.make_cast (l_port))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 259, create {CE_POINTER [ANY]}.make_cast (l_user))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 260, create {CE_POINTER [ANY]}.make_cast (l_pass))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 261, create {CE_POINTER [ANY]}.make_cast (l_share))
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 262, create {CE_POINTER [ANY]}.make_cast (l_data.item))
							a_c.item.sock1 := l_po[0]
							a_c.item.sock2 := l_pe[0]
							close (l_po[1]).do_nothing
							close (l_pe[1]).do_nothing
							select_inst.set_handlers (l_po[0], (smb_got_data_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_c))
							select_inst.set_handlers (l_pe[0], (smb_got_text_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_c))
							sched_inst.setcstate (a_c, 2)
				when 45 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	smb_func_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smb_func)
		end

	smb_got_data (a_c: CE_POINTER [PD_CONNECTION])
		local
			l_si: CE_POINTER [PD_SMB_CONNECTION_INFO]
			l_buffer___0: CE_POINTER [INTEGER_8]
			l_r: INTEGER_32
			js: JUMP_STATE
		do
			create l_si.make
			create l_buffer___0.make

			l_si := create {CE_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast (a_c.item.info)
			l_buffer___0 := create {CE_POINTER [INTEGER_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 373, cache_inst.page_size.to_natural_32)))
			if (l_si.item.list).to_boolean then
				smb_read_text (a_c, a_c.item.sock1)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 377, create {CE_POINTER [ANY]}.make_cast (l_buffer___0))
				js.return
			end
			if not js.return_called then
				l_r := read (a_c.item.sock1, create {CE_POINTER [ANY]}.make_cast (l_buffer___0), cache_inst.page_size.to_natural_32)
				if l_r = -1 then
					sched_inst.setcstate (a_c, -(errno_location).item)
					sched_inst.retry_connection (a_c)
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 384, create {CE_POINTER [ANY]}.make_cast (l_buffer___0))
					js.return
				end
			end
			if not js.return_called and then (l_r = 0) then
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 388, create {CE_POINTER [ANY]}.make_cast (l_buffer___0))
				if not (l_si.item.cl).to_boolean then
					l_si.item.cl := 1
					select_inst.set_handlers (a_c.item.sock1, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					js.return
				end
				if not js.return_called then
					end_smb_connection (a_c)
					js.return
				end
			end
			if not js.return_called then
				sched_inst.setcstate (a_c, 8)
				if (a_c.item.cache).is_void then
					if (cache_inst.get_cache_entry (a_c.item.url, create {CE_POINTER [CE_POINTER [PD_CACHE_ENTRY]]}.make_shared (a_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("cache")))).to_boolean then
						sched_inst.setcstate (a_c, -1_004)
						sched_inst.abort_connection (a_c)
						error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 401, create {CE_POINTER [ANY]}.make_cast (l_buffer___0))
						js.return
					end
				end
			end
			if not js.return_called and then (a_c.item.from2 + l_r.to_integer_32 < 0) then
				sched_inst.setcstate (a_c, -1_014)
				sched_inst.abort_connection (a_c)
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 407, create {CE_POINTER [ANY]}.make_cast (l_buffer___0))
				js.return
			end
			if not js.return_called then
				a_c.item.received := a_c.item.received + l_r.to_integer_32
				if (cache_inst.add_fragment (a_c.item.cache, a_c.item.from2, create {CE_POINTER [NATURAL_8]}.make_cast (l_buffer___0), l_r.to_integer_32)) = 1 then
					a_c.item.tries := 0
				end
				a_c.item.from2 := a_c.item.from2 + l_r.to_integer_32
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 413, create {CE_POINTER [ANY]}.make_cast (l_buffer___0))
			end
		end

	smb_got_data_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smb_got_data)
		end

	smb_got_text (a_c: CE_POINTER [PD_CONNECTION])
		do
			smb_read_text (a_c, a_c.item.sock2)
		end

	smb_got_text_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent smb_got_text)
		end

	smb_read_text (a_c: CE_POINTER [PD_CONNECTION]; a_sock: INTEGER_32)
		local
			l_r: INTEGER_32
			l_si: CE_POINTER [PD_SMB_CONNECTION_INFO]
			l_lasti: INTEGER_32
			l_i: CE_ARRAY [INTEGER_32]
			l_position: CE_ARRAY [INTEGER_32]
			l_total: CE_ARRAY [INTEGER_32]
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_si.make
			create l_i.make (<<1>>)
			create l_position.make (<<1>>)
			create l_total.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_si := create {CE_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast (a_c.item.info)
					if (((create {PD_SMB_CONNECTION_INFO}.make).structure_size.to_natural_32 + (l_si.item.ntext).to_natural_32) + cache_inst.page_size.to_natural_32) + {NATURAL_32} 2 > {NATURAL_32} 2_147_483_647 then
						from
						until
							False
						loop
							error_inst.error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("smb.c"), 314])
							kbd_inst.fatal_tty_exit
							exit (4)
						end
					end
					l_si := create {CE_POINTER [PD_SMB_CONNECTION_INFO]}.make_cast ((error_inst.debug_mem_realloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb.c")), 315, create {CE_POINTER [ANY]}.make_cast (l_si), (((create {PD_SMB_CONNECTION_INFO}.make).structure_size.to_natural_32 + (l_si.item.ntext).to_natural_32) + cache_inst.page_size.to_natural_32) + {NATURAL_32} 2)))
					a_c.item.info := create {CE_POINTER [ANY]}.make_cast (l_si)
					l_r := read (a_sock, create {CE_POINTER [ANY]}.make_cast ((l_si.item.text + l_si.item.ntext)), cache_inst.page_size.to_natural_32)
					if l_r = -1 then
						sched_inst.setcstate (a_c, -(errno_location).item)
						sched_inst.retry_connection (a_c)
						js.return
					end
					if not js.return_called and then (l_r = 0) then
						if not (l_si.item.cl).to_boolean then
							l_si.item.cl := 1
							select_inst.set_handlers (a_sock, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							js.return
						end
						if not js.return_called then
							end_smb_connection (a_c)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 34 -- skip if block
					end
				when 1 then -- if:
						l_si.item.ntext := l_si.item.ntext + l_r
						if not (a_c.item.from2).to_boolean then
							sched_inst.setcstate (a_c, 6)
						end
						if not ((a_c.item.from2).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 2 then -- if:
						if l_si.item.client /= 1 then
							l_pos := -1 + 34 -- skip if block
						end
				when 3 then -- if:
						l_lasti := 0
						l_i.item := 0
						l_si.item.text[l_si.item.ntext] := (0).to_natural_8
						l_i.item := 0
				when 4 then -- loop condition:
						if not (not js.loop_done and then (l_i.item + 7 < l_si.item.ntext)) then
							l_pos := -1 + 33 -- skip loop
						end
				when 5 then -- loop body: | nexti:
						if (l_si.item.text[l_i.item]).to_integer_32 /= 10 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___2
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 8 then -- else:
						if (l_si.item.text[l_i.item]).to_integer_32 /= 13 then
							l_pos := -1 + 32 -- skip if block
						end
				when 9 then -- if: | _L___2:
						if (l_si.item.text[l_i.item + 1]).to_integer_32 /= 32 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 14 -- goto _L___1
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 12 then -- else:
						if not ((l_si.item.text[l_i.item + 1]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 13 then -- if:
						if not ((l_si.item.text[l_i.item + 1]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 14 then -- if: | _L___1:
						if (l_si.item.text[l_i.item + 2]).to_integer_32 /= 32 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (l_si.item.text[l_i.item + 1]).to_integer_32 = 32 then
							l_pos := -1 + 19 -- goto _L
						else
							l_pos := -1 + 17 -- goto _L___0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 17 then -- else: | _L___0:
						if not ((l_si.item.text[l_i.item + 2]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 18 then -- if:
						if not ((l_si.item.text[l_i.item + 2]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 19 then -- if: | _L:
						if not ((l_si.item.text[l_i.item + 3]).to_integer_32 >= 48) then
							l_pos := -1 + 32 -- skip if block
						end
				when 20 then -- if:
						if not ((l_si.item.text[l_i.item + 3]).to_integer_32 <= 57) then
							l_pos := -1 + 32 -- skip if block
						end
				when 21 then -- if:
						if (l_si.item.text[l_i.item + 4]).to_integer_32 /= 37 then
							l_pos := -1 + 32 -- skip if block
						end
				when 22 then -- if:
						if (l_si.item.text[l_i.item + 5]).to_integer_32 /= 32 then
							l_pos := -1 + 32 -- skip if block
						end
				when 23 then -- if:
						if (l_si.item.text[l_i.item + 6]).to_integer_32 /= 91 then
							l_pos := -1 + 32 -- skip if block
						end
				when 24 then -- if:
						l_i.item := l_i.item + (7)
				when 25 then -- loop condition:
						if (l_si.item.text[l_i.item]).to_integer_32 = 93 then
							l_pos := -1 + 28 -- skip loop
						end
				when 26 then -- loop body:
						if not (l_si.item.text[l_i.item]).to_boolean then
							l_pos := -1 + 5 -- goto nexti
						elseif (l_si.item.text[l_i.item]).to_integer_32 = 10 then
							l_pos := -1 + 5 -- goto nexti
						elseif (l_si.item.text[l_i.item]).to_integer_32 = 13 then
							l_pos := -1 + 5 -- goto nexti
						end
				when 27 then
						l_i.item := l_i.item + 1
						l_pos := -1 + 25 -- back to loop condition
				when 28 then -- loop done
						l_i.item := l_i.item + 1
						if (smbc_get_num (l_si.item.text, l_i, l_position)).to_boolean then
							l_pos := -1 + 5 -- goto nexti
						end
				when 29 then
						from
						until
							js.loop_done
						loop
							if (l_si.item.text[l_i.item]).to_integer_32 /= 32 then
								if (l_si.item.text[l_i.item]).to_integer_32 /= 9 then
									js.break
								end
							end
							if not js.loop_jumped then
								l_i.item := l_i.item + 1
							end
						end
						if (l_si.item.text[l_i.item]).to_integer_32 /= 47 then
							l_pos := -1 + 5 -- goto nexti
						end
				when 30 then
						l_i.item := l_i.item + 1
						if (smbc_get_num (l_si.item.text, l_i, l_total)).to_boolean then
							l_pos := -1 + 5 -- goto nexti
						end
				when 31 then
						if l_total.item < a_c.item.from2 then
							l_total.item := a_c.item.from2
						end
						a_c.item.est_length := l_total.item
						l_lasti := l_i.item
				when 32 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						l_i.item := l_i.item + 1
						l_pos := -1 + 4 -- back to loop condition
				when 33 then -- loop done
						if l_lasti.to_boolean then
							l_tmp___3 := l_si.item.ntext - l_lasti
							l_si.item.ntext := l_tmp___3
							memmove (create {CE_POINTER [ANY]}.make_cast ((l_si.item.text)), create {CE_POINTER [ANY]}.make_cast ((l_si.item.text + l_lasti)), l_tmp___3.to_natural_32).do_nothing
						end
				when 34 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	smbc_get_num (a_text: CE_POINTER [NATURAL_8]; a_ptr: CE_POINTER [INTEGER_32]; a_res: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_num: INTEGER_32
			l_dec: INTEGER_32
			l_dec_order: INTEGER_32
			l_unit: INTEGER_32
			l_was_digit: INTEGER_32
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := a_ptr.item
			from
			until
				js.loop_done
			loop
				if (a_text[l_i]).to_integer_32 /= 32 then
					if (a_text[l_i]).to_integer_32 /= 9 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_i := l_i + 1
				end
			end
			l_was_digit := 0
			l_num := (0).to_integer_32
			from
			until
				js.loop_done
			loop
				if (a_text[l_i]).to_integer_32 >= 48 then
					if not ((a_text[l_i]).to_integer_32 <= 57) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_num := (l_num * 10 + (a_text[l_i]).to_integer_32) - 48
					l_i := l_i + 1
					l_was_digit := 1
				end
			end
			l_dec := 0
			l_dec_order := 1
			if (a_text[l_i]).to_integer_32 = 46 then
				l_i := l_i + 1
				from
				until
					js.loop_done
				loop
					if (a_text[l_i]).to_integer_32 >= 48 then
						if not ((a_text[l_i]).to_integer_32 <= 57) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						if l_dec_order < 1_000_000 then
							l_dec := (l_dec * 10 + (a_text[l_i]).to_integer_32) - 48
							l_dec_order := l_dec_order * (10)
						end
						l_i := l_i + 1
						l_was_digit := 1
					end
				end
			end
			if not l_was_digit.to_boolean then
				Result := (-1)
				js.return
			end
			if not js.return_called then
				if (links_inst.upcase (a_text[l_i])).to_integer_32 = 66 then
					l_unit := 1
				elseif (links_inst.upcase (a_text[l_i])).to_integer_32 = 75 then
					l_unit := (1).bit_shift_left (10)
				elseif (links_inst.upcase (a_text[l_i])).to_integer_32 = 77 then
					l_unit := (1).bit_shift_left (20)
				elseif (links_inst.upcase (a_text[l_i])).to_integer_32 = 71 then
					l_unit := (1).bit_shift_left (30)
				else
					Result := (-1)
					js.return
				end
			end
			if not js.return_called then
				l_i := l_i + 1
				a_ptr.item := l_i
				a_res.item := ((l_num * l_unit.to_integer_32).to_double + l_dec.to_double * (l_unit.to_double / l_dec_order.to_double)).truncated_to_integer
				Result := 0
			end
		end

end
