class
	PD_COMPITEM_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ci_key.make (<<17>>)
		end

feature {ANY} -- fields

	ci_key: CE_ARRAY [NATURAL_8]

	ci_flag: NATURAL_32 assign set_ci_flag

	ci_newID: INTEGER_32 assign set_ci_newID

feature {ANY} -- setters

	set_ci_flag (a_ci_flag: NATURAL_32)
		do
			ci_flag := a_ci_flag
			update_memory_field ("ci_flag")
		end

	set_ci_newID (a_ci_newID: INTEGER_32)
		do
			ci_newID := a_ci_newID
			update_memory_field ("ci_newID")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ci_key := a_other.ci_key.twin
			ci_flag := a_other.ci_flag
			ci_newID := a_other.ci_newID
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ci_key.is_equal (a_other.ci_key) and
				ci_flag = a_other.ci_flag and
				ci_newID = a_other.ci_newID
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ci_key", <<17>>),
					create {CE_STRUCTURE_FIELD}.make ("ci_flag"),
					create {CE_STRUCTURE_FIELD}.make ("ci_newID")
				>>)
			init_structure_info
		end

end
