class
	PD_EVENT_NAME

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	event: NATURAL_32 assign set_event

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_event (a_event: NATURAL_32)
		do
			event := a_event
			update_memory_field ("event")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			event := a_other.event
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				event = a_other.event
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("event")
				>>)
			init_structure_info
		end

end
