class
	PD_FILE_BUFFER

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create b_ml.make
			create b_next.make
			create b_prev.make
			create b_ffname.make
			create b_sfname.make
			create b_fname.make
			create b_wininfo.make
			create b_namedm.make (<<26>>)
			create b_visual.make
			create b_last_cursor.make
			create b_last_insert.make
			create b_last_change.make
			create b_changelist.make (<<100>>)
			create b_chartab.make (<<32>>)
			create b_maphash.make (<<256>>)
			create b_first_abbr.make
			create b_ucmds.make
			create b_op_start.make
			create b_op_end.make
			create b_u_oldhead.make
			create b_u_newhead.make
			create b_u_curhead.make
			create b_u_line_ptr.make
			create b_p_scriptID.make (<<71>>)
			create b_p_bh.make
			create b_p_bt.make
			create b_p_cino.make
			create b_p_cink.make
			create b_p_cinw.make
			create b_p_com.make
			create b_p_cms.make
			create b_p_cpt.make
			create b_p_cfu.make
			create b_p_ofu.make
			create b_p_fenc.make
			create b_p_ff.make
			create b_p_ft.make
			create b_p_fo.make
			create b_p_flp.make
			create b_p_isk.make
			create b_p_def.make
			create b_p_inc.make
			create b_p_inex.make
			create b_p_inde.make
			create b_p_indk.make
			create b_p_fex.make
			create b_p_key.make
			create b_p_kp.make
			create b_p_mps.make
			create b_p_nf.make
			create b_p_qe.make
			create b_p_sua.make
			create b_p_syn.make
			create b_p_gp.make
			create b_p_mp.make
			create b_p_efm.make
			create b_p_ep.make
			create b_p_path.make
			create b_p_tags.make
			create b_p_dict.make
			create b_p_tsr.make
			create b_start_fenc.make
			create b_bufvar.make
			create b_vars.make
			create b_p_bexpr.make
			create b_p_cm.make
			create b_s.make
			create b_signlist.make
		end

feature {ANY} -- fields

	b_ml: PD_MEMLINE assign set_b_ml

	b_next: CE_POINTER [PD_FILE_BUFFER] assign set_b_next

	b_prev: CE_POINTER [PD_FILE_BUFFER] assign set_b_prev

	b_nwindows: INTEGER_32 assign set_b_nwindows

	b_flags: INTEGER_32 assign set_b_flags

	b_ffname: CE_POINTER [NATURAL_8] assign set_b_ffname

	b_sfname: CE_POINTER [NATURAL_8] assign set_b_sfname

	b_fname: CE_POINTER [NATURAL_8] assign set_b_fname

	b_dev_valid: INTEGER_32 assign set_b_dev_valid

	b_dev: NATURAL_64 assign set_b_dev

	b_ino: NATURAL_32 assign set_b_ino

	b_fnum: INTEGER_32 assign set_b_fnum

	b_changed: INTEGER_32 assign set_b_changed

	b_changedtick: INTEGER_32 assign set_b_changedtick

	b_saving: INTEGER_32 assign set_b_saving

	b_mod_set: INTEGER_32 assign set_b_mod_set

	b_mod_top: INTEGER_32 assign set_b_mod_top

	b_mod_bot: INTEGER_32 assign set_b_mod_bot

	b_mod_xlines: INTEGER_32 assign set_b_mod_xlines

	b_wininfo: CE_POINTER [PD_WININFO_S] assign set_b_wininfo

	b_mtime: INTEGER_32 assign set_b_mtime

	b_mtime_read: INTEGER_32 assign set_b_mtime_read

	b_orig_size: INTEGER_32 assign set_b_orig_size

	b_orig_mode: INTEGER_32 assign set_b_orig_mode

	b_namedm: CE_ARRAY [PD_POS_T]

	b_visual: PD_VISUALINFO_T assign set_b_visual

	b_visual_mode_eval: INTEGER_32 assign set_b_visual_mode_eval

	b_last_cursor: PD_POS_T assign set_b_last_cursor

	b_last_insert: PD_POS_T assign set_b_last_insert

	b_last_change: PD_POS_T assign set_b_last_change

	b_changelist: CE_ARRAY [PD_POS_T]

	b_changelistlen: INTEGER_32 assign set_b_changelistlen

	b_new_change: INTEGER_32 assign set_b_new_change

	b_chartab: CE_ARRAY [NATURAL_8]

	b_maphash: CE_ARRAY [CE_POINTER [PD_MAPBLOCK]]

	b_first_abbr: CE_POINTER [PD_MAPBLOCK] assign set_b_first_abbr

	b_ucmds: PD_GROWARRAY assign set_b_ucmds

	b_op_start: PD_POS_T assign set_b_op_start

	b_op_end: PD_POS_T assign set_b_op_end

	b_marks_read: INTEGER_32 assign set_b_marks_read

	b_u_oldhead: CE_POINTER [PD_U_HEADER] assign set_b_u_oldhead

	b_u_newhead: CE_POINTER [PD_U_HEADER] assign set_b_u_newhead

	b_u_curhead: CE_POINTER [PD_U_HEADER] assign set_b_u_curhead

	b_u_numhead: INTEGER_32 assign set_b_u_numhead

	b_u_synced: INTEGER_32 assign set_b_u_synced

	b_u_seq_last: INTEGER_32 assign set_b_u_seq_last

	b_u_save_nr_last: INTEGER_32 assign set_b_u_save_nr_last

	b_u_seq_cur: INTEGER_32 assign set_b_u_seq_cur

	b_u_time_cur: INTEGER_32 assign set_b_u_time_cur

	b_u_save_nr_cur: INTEGER_32 assign set_b_u_save_nr_cur

	b_u_line_ptr: CE_POINTER [NATURAL_8] assign set_b_u_line_ptr

	b_u_line_lnum: INTEGER_32 assign set_b_u_line_lnum

	b_u_line_colnr: INTEGER_32 assign set_b_u_line_colnr

	b_scanned: INTEGER_32 assign set_b_scanned

	b_p_iminsert: INTEGER_32 assign set_b_p_iminsert

	b_p_imsearch: INTEGER_32 assign set_b_p_imsearch

	b_p_initialized: INTEGER_32 assign set_b_p_initialized

	b_p_scriptID: CE_ARRAY [INTEGER_32]

	b_p_ai: INTEGER_32 assign set_b_p_ai

	b_p_ai_nopaste: INTEGER_32 assign set_b_p_ai_nopaste

	b_p_ci: INTEGER_32 assign set_b_p_ci

	b_p_bin: INTEGER_32 assign set_b_p_bin

	b_p_bomb: INTEGER_32 assign set_b_p_bomb

	b_p_bh: CE_POINTER [NATURAL_8] assign set_b_p_bh

	b_p_bt: CE_POINTER [NATURAL_8] assign set_b_p_bt

	b_p_bl: INTEGER_32 assign set_b_p_bl

	b_p_cin: INTEGER_32 assign set_b_p_cin

	b_p_cino: CE_POINTER [NATURAL_8] assign set_b_p_cino

	b_p_cink: CE_POINTER [NATURAL_8] assign set_b_p_cink

	b_p_cinw: CE_POINTER [NATURAL_8] assign set_b_p_cinw

	b_p_com: CE_POINTER [NATURAL_8] assign set_b_p_com

	b_p_cms: CE_POINTER [NATURAL_8] assign set_b_p_cms

	b_p_cpt: CE_POINTER [NATURAL_8] assign set_b_p_cpt

	b_p_cfu: CE_POINTER [NATURAL_8] assign set_b_p_cfu

	b_p_ofu: CE_POINTER [NATURAL_8] assign set_b_p_ofu

	b_p_eol: INTEGER_32 assign set_b_p_eol

	b_p_et: INTEGER_32 assign set_b_p_et

	b_p_et_nobin: INTEGER_32 assign set_b_p_et_nobin

	b_p_fenc: CE_POINTER [NATURAL_8] assign set_b_p_fenc

	b_p_ff: CE_POINTER [NATURAL_8] assign set_b_p_ff

	b_p_ft: CE_POINTER [NATURAL_8] assign set_b_p_ft

	b_p_fo: CE_POINTER [NATURAL_8] assign set_b_p_fo

	b_p_flp: CE_POINTER [NATURAL_8] assign set_b_p_flp

	b_p_inf: INTEGER_32 assign set_b_p_inf

	b_p_isk: CE_POINTER [NATURAL_8] assign set_b_p_isk

	b_p_def: CE_POINTER [NATURAL_8] assign set_b_p_def

	b_p_inc: CE_POINTER [NATURAL_8] assign set_b_p_inc

	b_p_inex: CE_POINTER [NATURAL_8] assign set_b_p_inex

	b_p_inex_flags: NATURAL_32 assign set_b_p_inex_flags

	b_p_inde: CE_POINTER [NATURAL_8] assign set_b_p_inde

	b_p_inde_flags: NATURAL_32 assign set_b_p_inde_flags

	b_p_indk: CE_POINTER [NATURAL_8] assign set_b_p_indk

	b_p_fex: CE_POINTER [NATURAL_8] assign set_b_p_fex

	b_p_fex_flags: NATURAL_32 assign set_b_p_fex_flags

	b_p_key: CE_POINTER [NATURAL_8] assign set_b_p_key

	b_p_kp: CE_POINTER [NATURAL_8] assign set_b_p_kp

	b_p_lisp: INTEGER_32 assign set_b_p_lisp

	b_p_mps: CE_POINTER [NATURAL_8] assign set_b_p_mps

	b_p_ml: INTEGER_32 assign set_b_p_ml

	b_p_ml_nobin: INTEGER_32 assign set_b_p_ml_nobin

	b_p_ma: INTEGER_32 assign set_b_p_ma

	b_p_nf: CE_POINTER [NATURAL_8] assign set_b_p_nf

	b_p_pi: INTEGER_32 assign set_b_p_pi

	b_p_qe: CE_POINTER [NATURAL_8] assign set_b_p_qe

	b_p_ro: INTEGER_32 assign set_b_p_ro

	b_p_sw: INTEGER_32 assign set_b_p_sw

	b_p_sn: INTEGER_32 assign set_b_p_sn

	b_p_si: INTEGER_32 assign set_b_p_si

	b_p_sts: INTEGER_32 assign set_b_p_sts

	b_p_sts_nopaste: INTEGER_32 assign set_b_p_sts_nopaste

	b_p_sua: CE_POINTER [NATURAL_8] assign set_b_p_sua

	b_p_swf: INTEGER_32 assign set_b_p_swf

	b_p_smc: INTEGER_32 assign set_b_p_smc

	b_p_syn: CE_POINTER [NATURAL_8] assign set_b_p_syn

	b_p_ts: INTEGER_32 assign set_b_p_ts

	b_p_tx: INTEGER_32 assign set_b_p_tx

	b_p_tw: INTEGER_32 assign set_b_p_tw

	b_p_tw_nobin: INTEGER_32 assign set_b_p_tw_nobin

	b_p_tw_nopaste: INTEGER_32 assign set_b_p_tw_nopaste

	b_p_wm: INTEGER_32 assign set_b_p_wm

	b_p_wm_nobin: INTEGER_32 assign set_b_p_wm_nobin

	b_p_wm_nopaste: INTEGER_32 assign set_b_p_wm_nopaste

	b_p_gp: CE_POINTER [NATURAL_8] assign set_b_p_gp

	b_p_mp: CE_POINTER [NATURAL_8] assign set_b_p_mp

	b_p_efm: CE_POINTER [NATURAL_8] assign set_b_p_efm

	b_p_ep: CE_POINTER [NATURAL_8] assign set_b_p_ep

	b_p_path: CE_POINTER [NATURAL_8] assign set_b_p_path

	b_p_ar: INTEGER_32 assign set_b_p_ar

	b_p_tags: CE_POINTER [NATURAL_8] assign set_b_p_tags

	b_p_dict: CE_POINTER [NATURAL_8] assign set_b_p_dict

	b_p_tsr: CE_POINTER [NATURAL_8] assign set_b_p_tsr

	b_p_udf: INTEGER_32 assign set_b_p_udf

	b_start_eol: INTEGER_32 assign set_b_start_eol

	b_start_ffc: INTEGER_32 assign set_b_start_ffc

	b_start_fenc: CE_POINTER [NATURAL_8] assign set_b_start_fenc

	b_bad_char: INTEGER_32 assign set_b_bad_char

	b_start_bomb: INTEGER_32 assign set_b_start_bomb

	b_bufvar: PD_DICTITEM_S assign set_b_bufvar

	b_vars: PD_DICTVAR_S assign set_b_vars

	b_p_bexpr: CE_POINTER [NATURAL_8] assign set_b_p_bexpr

	b_p_bexpr_flags: NATURAL_32 assign set_b_p_bexpr_flags

	b_p_cm: CE_POINTER [NATURAL_8] assign set_b_p_cm

	b_may_swap: INTEGER_32 assign set_b_may_swap

	b_did_warn: INTEGER_32 assign set_b_did_warn

	b_help: INTEGER_32 assign set_b_help

	b_spell: INTEGER_32 assign set_b_spell

	b_shortname: INTEGER_32 assign set_b_shortname

	b_s: PD_SYNBLOCK_T assign set_b_s

	b_signlist: CE_POINTER [PD_SIGNLIST] assign set_b_signlist

	b_netbeans_file: INTEGER_32 assign set_b_netbeans_file

	b_was_netbeans_file: INTEGER_32 assign set_b_was_netbeans_file

feature {ANY} -- setters

	set_b_ml (a_b_ml: PD_MEMLINE)
		do
			b_ml := a_b_ml
			update_memory_field ("b_ml")
		end

	set_b_next (a_b_next: CE_POINTER [PD_FILE_BUFFER])
		do
			b_next := a_b_next
			update_memory_field ("b_next")
		end

	set_b_prev (a_b_prev: CE_POINTER [PD_FILE_BUFFER])
		do
			b_prev := a_b_prev
			update_memory_field ("b_prev")
		end

	set_b_nwindows (a_b_nwindows: INTEGER_32)
		do
			b_nwindows := a_b_nwindows
			update_memory_field ("b_nwindows")
		end

	set_b_flags (a_b_flags: INTEGER_32)
		do
			b_flags := a_b_flags
			update_memory_field ("b_flags")
		end

	set_b_ffname (a_b_ffname: CE_POINTER [NATURAL_8])
		do
			b_ffname := a_b_ffname
			update_memory_field ("b_ffname")
		end

	set_b_sfname (a_b_sfname: CE_POINTER [NATURAL_8])
		do
			b_sfname := a_b_sfname
			update_memory_field ("b_sfname")
		end

	set_b_fname (a_b_fname: CE_POINTER [NATURAL_8])
		do
			b_fname := a_b_fname
			update_memory_field ("b_fname")
		end

	set_b_dev_valid (a_b_dev_valid: INTEGER_32)
		do
			b_dev_valid := a_b_dev_valid
			update_memory_field ("b_dev_valid")
		end

	set_b_dev (a_b_dev: NATURAL_64)
		do
			b_dev := a_b_dev
			update_memory_field ("b_dev")
		end

	set_b_ino (a_b_ino: NATURAL_32)
		do
			b_ino := a_b_ino
			update_memory_field ("b_ino")
		end

	set_b_fnum (a_b_fnum: INTEGER_32)
		do
			b_fnum := a_b_fnum
			update_memory_field ("b_fnum")
		end

	set_b_changed (a_b_changed: INTEGER_32)
		do
			b_changed := a_b_changed
			update_memory_field ("b_changed")
		end

	set_b_changedtick (a_b_changedtick: INTEGER_32)
		do
			b_changedtick := a_b_changedtick
			update_memory_field ("b_changedtick")
		end

	set_b_saving (a_b_saving: INTEGER_32)
		do
			b_saving := a_b_saving
			update_memory_field ("b_saving")
		end

	set_b_mod_set (a_b_mod_set: INTEGER_32)
		do
			b_mod_set := a_b_mod_set
			update_memory_field ("b_mod_set")
		end

	set_b_mod_top (a_b_mod_top: INTEGER_32)
		do
			b_mod_top := a_b_mod_top
			update_memory_field ("b_mod_top")
		end

	set_b_mod_bot (a_b_mod_bot: INTEGER_32)
		do
			b_mod_bot := a_b_mod_bot
			update_memory_field ("b_mod_bot")
		end

	set_b_mod_xlines (a_b_mod_xlines: INTEGER_32)
		do
			b_mod_xlines := a_b_mod_xlines
			update_memory_field ("b_mod_xlines")
		end

	set_b_wininfo (a_b_wininfo: CE_POINTER [PD_WININFO_S])
		do
			b_wininfo := a_b_wininfo
			update_memory_field ("b_wininfo")
		end

	set_b_mtime (a_b_mtime: INTEGER_32)
		do
			b_mtime := a_b_mtime
			update_memory_field ("b_mtime")
		end

	set_b_mtime_read (a_b_mtime_read: INTEGER_32)
		do
			b_mtime_read := a_b_mtime_read
			update_memory_field ("b_mtime_read")
		end

	set_b_orig_size (a_b_orig_size: INTEGER_32)
		do
			b_orig_size := a_b_orig_size
			update_memory_field ("b_orig_size")
		end

	set_b_orig_mode (a_b_orig_mode: INTEGER_32)
		do
			b_orig_mode := a_b_orig_mode
			update_memory_field ("b_orig_mode")
		end

	set_b_visual (a_b_visual: PD_VISUALINFO_T)
		do
			b_visual := a_b_visual
			update_memory_field ("b_visual")
		end

	set_b_visual_mode_eval (a_b_visual_mode_eval: INTEGER_32)
		do
			b_visual_mode_eval := a_b_visual_mode_eval
			update_memory_field ("b_visual_mode_eval")
		end

	set_b_last_cursor (a_b_last_cursor: PD_POS_T)
		do
			b_last_cursor := a_b_last_cursor
			update_memory_field ("b_last_cursor")
		end

	set_b_last_insert (a_b_last_insert: PD_POS_T)
		do
			b_last_insert := a_b_last_insert
			update_memory_field ("b_last_insert")
		end

	set_b_last_change (a_b_last_change: PD_POS_T)
		do
			b_last_change := a_b_last_change
			update_memory_field ("b_last_change")
		end

	set_b_changelistlen (a_b_changelistlen: INTEGER_32)
		do
			b_changelistlen := a_b_changelistlen
			update_memory_field ("b_changelistlen")
		end

	set_b_new_change (a_b_new_change: INTEGER_32)
		do
			b_new_change := a_b_new_change
			update_memory_field ("b_new_change")
		end

	set_b_first_abbr (a_b_first_abbr: CE_POINTER [PD_MAPBLOCK])
		do
			b_first_abbr := a_b_first_abbr
			update_memory_field ("b_first_abbr")
		end

	set_b_ucmds (a_b_ucmds: PD_GROWARRAY)
		do
			b_ucmds := a_b_ucmds
			update_memory_field ("b_ucmds")
		end

	set_b_op_start (a_b_op_start: PD_POS_T)
		do
			b_op_start := a_b_op_start
			update_memory_field ("b_op_start")
		end

	set_b_op_end (a_b_op_end: PD_POS_T)
		do
			b_op_end := a_b_op_end
			update_memory_field ("b_op_end")
		end

	set_b_marks_read (a_b_marks_read: INTEGER_32)
		do
			b_marks_read := a_b_marks_read
			update_memory_field ("b_marks_read")
		end

	set_b_u_oldhead (a_b_u_oldhead: CE_POINTER [PD_U_HEADER])
		do
			b_u_oldhead := a_b_u_oldhead
			update_memory_field ("b_u_oldhead")
		end

	set_b_u_newhead (a_b_u_newhead: CE_POINTER [PD_U_HEADER])
		do
			b_u_newhead := a_b_u_newhead
			update_memory_field ("b_u_newhead")
		end

	set_b_u_curhead (a_b_u_curhead: CE_POINTER [PD_U_HEADER])
		do
			b_u_curhead := a_b_u_curhead
			update_memory_field ("b_u_curhead")
		end

	set_b_u_numhead (a_b_u_numhead: INTEGER_32)
		do
			b_u_numhead := a_b_u_numhead
			update_memory_field ("b_u_numhead")
		end

	set_b_u_synced (a_b_u_synced: INTEGER_32)
		do
			b_u_synced := a_b_u_synced
			update_memory_field ("b_u_synced")
		end

	set_b_u_seq_last (a_b_u_seq_last: INTEGER_32)
		do
			b_u_seq_last := a_b_u_seq_last
			update_memory_field ("b_u_seq_last")
		end

	set_b_u_save_nr_last (a_b_u_save_nr_last: INTEGER_32)
		do
			b_u_save_nr_last := a_b_u_save_nr_last
			update_memory_field ("b_u_save_nr_last")
		end

	set_b_u_seq_cur (a_b_u_seq_cur: INTEGER_32)
		do
			b_u_seq_cur := a_b_u_seq_cur
			update_memory_field ("b_u_seq_cur")
		end

	set_b_u_time_cur (a_b_u_time_cur: INTEGER_32)
		do
			b_u_time_cur := a_b_u_time_cur
			update_memory_field ("b_u_time_cur")
		end

	set_b_u_save_nr_cur (a_b_u_save_nr_cur: INTEGER_32)
		do
			b_u_save_nr_cur := a_b_u_save_nr_cur
			update_memory_field ("b_u_save_nr_cur")
		end

	set_b_u_line_ptr (a_b_u_line_ptr: CE_POINTER [NATURAL_8])
		do
			b_u_line_ptr := a_b_u_line_ptr
			update_memory_field ("b_u_line_ptr")
		end

	set_b_u_line_lnum (a_b_u_line_lnum: INTEGER_32)
		do
			b_u_line_lnum := a_b_u_line_lnum
			update_memory_field ("b_u_line_lnum")
		end

	set_b_u_line_colnr (a_b_u_line_colnr: INTEGER_32)
		do
			b_u_line_colnr := a_b_u_line_colnr
			update_memory_field ("b_u_line_colnr")
		end

	set_b_scanned (a_b_scanned: INTEGER_32)
		do
			b_scanned := a_b_scanned
			update_memory_field ("b_scanned")
		end

	set_b_p_iminsert (a_b_p_iminsert: INTEGER_32)
		do
			b_p_iminsert := a_b_p_iminsert
			update_memory_field ("b_p_iminsert")
		end

	set_b_p_imsearch (a_b_p_imsearch: INTEGER_32)
		do
			b_p_imsearch := a_b_p_imsearch
			update_memory_field ("b_p_imsearch")
		end

	set_b_p_initialized (a_b_p_initialized: INTEGER_32)
		do
			b_p_initialized := a_b_p_initialized
			update_memory_field ("b_p_initialized")
		end

	set_b_p_ai (a_b_p_ai: INTEGER_32)
		do
			b_p_ai := a_b_p_ai
			update_memory_field ("b_p_ai")
		end

	set_b_p_ai_nopaste (a_b_p_ai_nopaste: INTEGER_32)
		do
			b_p_ai_nopaste := a_b_p_ai_nopaste
			update_memory_field ("b_p_ai_nopaste")
		end

	set_b_p_ci (a_b_p_ci: INTEGER_32)
		do
			b_p_ci := a_b_p_ci
			update_memory_field ("b_p_ci")
		end

	set_b_p_bin (a_b_p_bin: INTEGER_32)
		do
			b_p_bin := a_b_p_bin
			update_memory_field ("b_p_bin")
		end

	set_b_p_bomb (a_b_p_bomb: INTEGER_32)
		do
			b_p_bomb := a_b_p_bomb
			update_memory_field ("b_p_bomb")
		end

	set_b_p_bh (a_b_p_bh: CE_POINTER [NATURAL_8])
		do
			b_p_bh := a_b_p_bh
			update_memory_field ("b_p_bh")
		end

	set_b_p_bt (a_b_p_bt: CE_POINTER [NATURAL_8])
		do
			b_p_bt := a_b_p_bt
			update_memory_field ("b_p_bt")
		end

	set_b_p_bl (a_b_p_bl: INTEGER_32)
		do
			b_p_bl := a_b_p_bl
			update_memory_field ("b_p_bl")
		end

	set_b_p_cin (a_b_p_cin: INTEGER_32)
		do
			b_p_cin := a_b_p_cin
			update_memory_field ("b_p_cin")
		end

	set_b_p_cino (a_b_p_cino: CE_POINTER [NATURAL_8])
		do
			b_p_cino := a_b_p_cino
			update_memory_field ("b_p_cino")
		end

	set_b_p_cink (a_b_p_cink: CE_POINTER [NATURAL_8])
		do
			b_p_cink := a_b_p_cink
			update_memory_field ("b_p_cink")
		end

	set_b_p_cinw (a_b_p_cinw: CE_POINTER [NATURAL_8])
		do
			b_p_cinw := a_b_p_cinw
			update_memory_field ("b_p_cinw")
		end

	set_b_p_com (a_b_p_com: CE_POINTER [NATURAL_8])
		do
			b_p_com := a_b_p_com
			update_memory_field ("b_p_com")
		end

	set_b_p_cms (a_b_p_cms: CE_POINTER [NATURAL_8])
		do
			b_p_cms := a_b_p_cms
			update_memory_field ("b_p_cms")
		end

	set_b_p_cpt (a_b_p_cpt: CE_POINTER [NATURAL_8])
		do
			b_p_cpt := a_b_p_cpt
			update_memory_field ("b_p_cpt")
		end

	set_b_p_cfu (a_b_p_cfu: CE_POINTER [NATURAL_8])
		do
			b_p_cfu := a_b_p_cfu
			update_memory_field ("b_p_cfu")
		end

	set_b_p_ofu (a_b_p_ofu: CE_POINTER [NATURAL_8])
		do
			b_p_ofu := a_b_p_ofu
			update_memory_field ("b_p_ofu")
		end

	set_b_p_eol (a_b_p_eol: INTEGER_32)
		do
			b_p_eol := a_b_p_eol
			update_memory_field ("b_p_eol")
		end

	set_b_p_et (a_b_p_et: INTEGER_32)
		do
			b_p_et := a_b_p_et
			update_memory_field ("b_p_et")
		end

	set_b_p_et_nobin (a_b_p_et_nobin: INTEGER_32)
		do
			b_p_et_nobin := a_b_p_et_nobin
			update_memory_field ("b_p_et_nobin")
		end

	set_b_p_fenc (a_b_p_fenc: CE_POINTER [NATURAL_8])
		do
			b_p_fenc := a_b_p_fenc
			update_memory_field ("b_p_fenc")
		end

	set_b_p_ff (a_b_p_ff: CE_POINTER [NATURAL_8])
		do
			b_p_ff := a_b_p_ff
			update_memory_field ("b_p_ff")
		end

	set_b_p_ft (a_b_p_ft: CE_POINTER [NATURAL_8])
		do
			b_p_ft := a_b_p_ft
			update_memory_field ("b_p_ft")
		end

	set_b_p_fo (a_b_p_fo: CE_POINTER [NATURAL_8])
		do
			b_p_fo := a_b_p_fo
			update_memory_field ("b_p_fo")
		end

	set_b_p_flp (a_b_p_flp: CE_POINTER [NATURAL_8])
		do
			b_p_flp := a_b_p_flp
			update_memory_field ("b_p_flp")
		end

	set_b_p_inf (a_b_p_inf: INTEGER_32)
		do
			b_p_inf := a_b_p_inf
			update_memory_field ("b_p_inf")
		end

	set_b_p_isk (a_b_p_isk: CE_POINTER [NATURAL_8])
		do
			b_p_isk := a_b_p_isk
			update_memory_field ("b_p_isk")
		end

	set_b_p_def (a_b_p_def: CE_POINTER [NATURAL_8])
		do
			b_p_def := a_b_p_def
			update_memory_field ("b_p_def")
		end

	set_b_p_inc (a_b_p_inc: CE_POINTER [NATURAL_8])
		do
			b_p_inc := a_b_p_inc
			update_memory_field ("b_p_inc")
		end

	set_b_p_inex (a_b_p_inex: CE_POINTER [NATURAL_8])
		do
			b_p_inex := a_b_p_inex
			update_memory_field ("b_p_inex")
		end

	set_b_p_inex_flags (a_b_p_inex_flags: NATURAL_32)
		do
			b_p_inex_flags := a_b_p_inex_flags
			update_memory_field ("b_p_inex_flags")
		end

	set_b_p_inde (a_b_p_inde: CE_POINTER [NATURAL_8])
		do
			b_p_inde := a_b_p_inde
			update_memory_field ("b_p_inde")
		end

	set_b_p_inde_flags (a_b_p_inde_flags: NATURAL_32)
		do
			b_p_inde_flags := a_b_p_inde_flags
			update_memory_field ("b_p_inde_flags")
		end

	set_b_p_indk (a_b_p_indk: CE_POINTER [NATURAL_8])
		do
			b_p_indk := a_b_p_indk
			update_memory_field ("b_p_indk")
		end

	set_b_p_fex (a_b_p_fex: CE_POINTER [NATURAL_8])
		do
			b_p_fex := a_b_p_fex
			update_memory_field ("b_p_fex")
		end

	set_b_p_fex_flags (a_b_p_fex_flags: NATURAL_32)
		do
			b_p_fex_flags := a_b_p_fex_flags
			update_memory_field ("b_p_fex_flags")
		end

	set_b_p_key (a_b_p_key: CE_POINTER [NATURAL_8])
		do
			b_p_key := a_b_p_key
			update_memory_field ("b_p_key")
		end

	set_b_p_kp (a_b_p_kp: CE_POINTER [NATURAL_8])
		do
			b_p_kp := a_b_p_kp
			update_memory_field ("b_p_kp")
		end

	set_b_p_lisp (a_b_p_lisp: INTEGER_32)
		do
			b_p_lisp := a_b_p_lisp
			update_memory_field ("b_p_lisp")
		end

	set_b_p_mps (a_b_p_mps: CE_POINTER [NATURAL_8])
		do
			b_p_mps := a_b_p_mps
			update_memory_field ("b_p_mps")
		end

	set_b_p_ml (a_b_p_ml: INTEGER_32)
		do
			b_p_ml := a_b_p_ml
			update_memory_field ("b_p_ml")
		end

	set_b_p_ml_nobin (a_b_p_ml_nobin: INTEGER_32)
		do
			b_p_ml_nobin := a_b_p_ml_nobin
			update_memory_field ("b_p_ml_nobin")
		end

	set_b_p_ma (a_b_p_ma: INTEGER_32)
		do
			b_p_ma := a_b_p_ma
			update_memory_field ("b_p_ma")
		end

	set_b_p_nf (a_b_p_nf: CE_POINTER [NATURAL_8])
		do
			b_p_nf := a_b_p_nf
			update_memory_field ("b_p_nf")
		end

	set_b_p_pi (a_b_p_pi: INTEGER_32)
		do
			b_p_pi := a_b_p_pi
			update_memory_field ("b_p_pi")
		end

	set_b_p_qe (a_b_p_qe: CE_POINTER [NATURAL_8])
		do
			b_p_qe := a_b_p_qe
			update_memory_field ("b_p_qe")
		end

	set_b_p_ro (a_b_p_ro: INTEGER_32)
		do
			b_p_ro := a_b_p_ro
			update_memory_field ("b_p_ro")
		end

	set_b_p_sw (a_b_p_sw: INTEGER_32)
		do
			b_p_sw := a_b_p_sw
			update_memory_field ("b_p_sw")
		end

	set_b_p_sn (a_b_p_sn: INTEGER_32)
		do
			b_p_sn := a_b_p_sn
			update_memory_field ("b_p_sn")
		end

	set_b_p_si (a_b_p_si: INTEGER_32)
		do
			b_p_si := a_b_p_si
			update_memory_field ("b_p_si")
		end

	set_b_p_sts (a_b_p_sts: INTEGER_32)
		do
			b_p_sts := a_b_p_sts
			update_memory_field ("b_p_sts")
		end

	set_b_p_sts_nopaste (a_b_p_sts_nopaste: INTEGER_32)
		do
			b_p_sts_nopaste := a_b_p_sts_nopaste
			update_memory_field ("b_p_sts_nopaste")
		end

	set_b_p_sua (a_b_p_sua: CE_POINTER [NATURAL_8])
		do
			b_p_sua := a_b_p_sua
			update_memory_field ("b_p_sua")
		end

	set_b_p_swf (a_b_p_swf: INTEGER_32)
		do
			b_p_swf := a_b_p_swf
			update_memory_field ("b_p_swf")
		end

	set_b_p_smc (a_b_p_smc: INTEGER_32)
		do
			b_p_smc := a_b_p_smc
			update_memory_field ("b_p_smc")
		end

	set_b_p_syn (a_b_p_syn: CE_POINTER [NATURAL_8])
		do
			b_p_syn := a_b_p_syn
			update_memory_field ("b_p_syn")
		end

	set_b_p_ts (a_b_p_ts: INTEGER_32)
		do
			b_p_ts := a_b_p_ts
			update_memory_field ("b_p_ts")
		end

	set_b_p_tx (a_b_p_tx: INTEGER_32)
		do
			b_p_tx := a_b_p_tx
			update_memory_field ("b_p_tx")
		end

	set_b_p_tw (a_b_p_tw: INTEGER_32)
		do
			b_p_tw := a_b_p_tw
			update_memory_field ("b_p_tw")
		end

	set_b_p_tw_nobin (a_b_p_tw_nobin: INTEGER_32)
		do
			b_p_tw_nobin := a_b_p_tw_nobin
			update_memory_field ("b_p_tw_nobin")
		end

	set_b_p_tw_nopaste (a_b_p_tw_nopaste: INTEGER_32)
		do
			b_p_tw_nopaste := a_b_p_tw_nopaste
			update_memory_field ("b_p_tw_nopaste")
		end

	set_b_p_wm (a_b_p_wm: INTEGER_32)
		do
			b_p_wm := a_b_p_wm
			update_memory_field ("b_p_wm")
		end

	set_b_p_wm_nobin (a_b_p_wm_nobin: INTEGER_32)
		do
			b_p_wm_nobin := a_b_p_wm_nobin
			update_memory_field ("b_p_wm_nobin")
		end

	set_b_p_wm_nopaste (a_b_p_wm_nopaste: INTEGER_32)
		do
			b_p_wm_nopaste := a_b_p_wm_nopaste
			update_memory_field ("b_p_wm_nopaste")
		end

	set_b_p_gp (a_b_p_gp: CE_POINTER [NATURAL_8])
		do
			b_p_gp := a_b_p_gp
			update_memory_field ("b_p_gp")
		end

	set_b_p_mp (a_b_p_mp: CE_POINTER [NATURAL_8])
		do
			b_p_mp := a_b_p_mp
			update_memory_field ("b_p_mp")
		end

	set_b_p_efm (a_b_p_efm: CE_POINTER [NATURAL_8])
		do
			b_p_efm := a_b_p_efm
			update_memory_field ("b_p_efm")
		end

	set_b_p_ep (a_b_p_ep: CE_POINTER [NATURAL_8])
		do
			b_p_ep := a_b_p_ep
			update_memory_field ("b_p_ep")
		end

	set_b_p_path (a_b_p_path: CE_POINTER [NATURAL_8])
		do
			b_p_path := a_b_p_path
			update_memory_field ("b_p_path")
		end

	set_b_p_ar (a_b_p_ar: INTEGER_32)
		do
			b_p_ar := a_b_p_ar
			update_memory_field ("b_p_ar")
		end

	set_b_p_tags (a_b_p_tags: CE_POINTER [NATURAL_8])
		do
			b_p_tags := a_b_p_tags
			update_memory_field ("b_p_tags")
		end

	set_b_p_dict (a_b_p_dict: CE_POINTER [NATURAL_8])
		do
			b_p_dict := a_b_p_dict
			update_memory_field ("b_p_dict")
		end

	set_b_p_tsr (a_b_p_tsr: CE_POINTER [NATURAL_8])
		do
			b_p_tsr := a_b_p_tsr
			update_memory_field ("b_p_tsr")
		end

	set_b_p_udf (a_b_p_udf: INTEGER_32)
		do
			b_p_udf := a_b_p_udf
			update_memory_field ("b_p_udf")
		end

	set_b_start_eol (a_b_start_eol: INTEGER_32)
		do
			b_start_eol := a_b_start_eol
			update_memory_field ("b_start_eol")
		end

	set_b_start_ffc (a_b_start_ffc: INTEGER_32)
		do
			b_start_ffc := a_b_start_ffc
			update_memory_field ("b_start_ffc")
		end

	set_b_start_fenc (a_b_start_fenc: CE_POINTER [NATURAL_8])
		do
			b_start_fenc := a_b_start_fenc
			update_memory_field ("b_start_fenc")
		end

	set_b_bad_char (a_b_bad_char: INTEGER_32)
		do
			b_bad_char := a_b_bad_char
			update_memory_field ("b_bad_char")
		end

	set_b_start_bomb (a_b_start_bomb: INTEGER_32)
		do
			b_start_bomb := a_b_start_bomb
			update_memory_field ("b_start_bomb")
		end

	set_b_bufvar (a_b_bufvar: PD_DICTITEM_S)
		do
			b_bufvar := a_b_bufvar
			update_memory_field ("b_bufvar")
		end

	set_b_vars (a_b_vars: PD_DICTVAR_S)
		do
			b_vars := a_b_vars
			update_memory_field ("b_vars")
		end

	set_b_p_bexpr (a_b_p_bexpr: CE_POINTER [NATURAL_8])
		do
			b_p_bexpr := a_b_p_bexpr
			update_memory_field ("b_p_bexpr")
		end

	set_b_p_bexpr_flags (a_b_p_bexpr_flags: NATURAL_32)
		do
			b_p_bexpr_flags := a_b_p_bexpr_flags
			update_memory_field ("b_p_bexpr_flags")
		end

	set_b_p_cm (a_b_p_cm: CE_POINTER [NATURAL_8])
		do
			b_p_cm := a_b_p_cm
			update_memory_field ("b_p_cm")
		end

	set_b_may_swap (a_b_may_swap: INTEGER_32)
		do
			b_may_swap := a_b_may_swap
			update_memory_field ("b_may_swap")
		end

	set_b_did_warn (a_b_did_warn: INTEGER_32)
		do
			b_did_warn := a_b_did_warn
			update_memory_field ("b_did_warn")
		end

	set_b_help (a_b_help: INTEGER_32)
		do
			b_help := a_b_help
			update_memory_field ("b_help")
		end

	set_b_spell (a_b_spell: INTEGER_32)
		do
			b_spell := a_b_spell
			update_memory_field ("b_spell")
		end

	set_b_shortname (a_b_shortname: INTEGER_32)
		do
			b_shortname := a_b_shortname
			update_memory_field ("b_shortname")
		end

	set_b_s (a_b_s: PD_SYNBLOCK_T)
		do
			b_s := a_b_s
			update_memory_field ("b_s")
		end

	set_b_signlist (a_b_signlist: CE_POINTER [PD_SIGNLIST])
		do
			b_signlist := a_b_signlist
			update_memory_field ("b_signlist")
		end

	set_b_netbeans_file (a_b_netbeans_file: INTEGER_32)
		do
			b_netbeans_file := a_b_netbeans_file
			update_memory_field ("b_netbeans_file")
		end

	set_b_was_netbeans_file (a_b_was_netbeans_file: INTEGER_32)
		do
			b_was_netbeans_file := a_b_was_netbeans_file
			update_memory_field ("b_was_netbeans_file")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			b_ml := a_other.b_ml.twin
			b_next := a_other.b_next
			b_prev := a_other.b_prev
			b_nwindows := a_other.b_nwindows
			b_flags := a_other.b_flags
			b_ffname := a_other.b_ffname
			b_sfname := a_other.b_sfname
			b_fname := a_other.b_fname
			b_dev_valid := a_other.b_dev_valid
			b_dev := a_other.b_dev
			b_ino := a_other.b_ino
			b_fnum := a_other.b_fnum
			b_changed := a_other.b_changed
			b_changedtick := a_other.b_changedtick
			b_saving := a_other.b_saving
			b_mod_set := a_other.b_mod_set
			b_mod_top := a_other.b_mod_top
			b_mod_bot := a_other.b_mod_bot
			b_mod_xlines := a_other.b_mod_xlines
			b_wininfo := a_other.b_wininfo
			b_mtime := a_other.b_mtime
			b_mtime_read := a_other.b_mtime_read
			b_orig_size := a_other.b_orig_size
			b_orig_mode := a_other.b_orig_mode
			b_namedm := a_other.b_namedm.twin
			b_visual := a_other.b_visual.twin
			b_visual_mode_eval := a_other.b_visual_mode_eval
			b_last_cursor := a_other.b_last_cursor.twin
			b_last_insert := a_other.b_last_insert.twin
			b_last_change := a_other.b_last_change.twin
			b_changelist := a_other.b_changelist.twin
			b_changelistlen := a_other.b_changelistlen
			b_new_change := a_other.b_new_change
			b_chartab := a_other.b_chartab.twin
			b_maphash := a_other.b_maphash.twin
			b_first_abbr := a_other.b_first_abbr
			b_ucmds := a_other.b_ucmds.twin
			b_op_start := a_other.b_op_start.twin
			b_op_end := a_other.b_op_end.twin
			b_marks_read := a_other.b_marks_read
			b_u_oldhead := a_other.b_u_oldhead
			b_u_newhead := a_other.b_u_newhead
			b_u_curhead := a_other.b_u_curhead
			b_u_numhead := a_other.b_u_numhead
			b_u_synced := a_other.b_u_synced
			b_u_seq_last := a_other.b_u_seq_last
			b_u_save_nr_last := a_other.b_u_save_nr_last
			b_u_seq_cur := a_other.b_u_seq_cur
			b_u_time_cur := a_other.b_u_time_cur
			b_u_save_nr_cur := a_other.b_u_save_nr_cur
			b_u_line_ptr := a_other.b_u_line_ptr
			b_u_line_lnum := a_other.b_u_line_lnum
			b_u_line_colnr := a_other.b_u_line_colnr
			b_scanned := a_other.b_scanned
			b_p_iminsert := a_other.b_p_iminsert
			b_p_imsearch := a_other.b_p_imsearch
			b_p_initialized := a_other.b_p_initialized
			b_p_scriptID := a_other.b_p_scriptID.twin
			b_p_ai := a_other.b_p_ai
			b_p_ai_nopaste := a_other.b_p_ai_nopaste
			b_p_ci := a_other.b_p_ci
			b_p_bin := a_other.b_p_bin
			b_p_bomb := a_other.b_p_bomb
			b_p_bh := a_other.b_p_bh
			b_p_bt := a_other.b_p_bt
			b_p_bl := a_other.b_p_bl
			b_p_cin := a_other.b_p_cin
			b_p_cino := a_other.b_p_cino
			b_p_cink := a_other.b_p_cink
			b_p_cinw := a_other.b_p_cinw
			b_p_com := a_other.b_p_com
			b_p_cms := a_other.b_p_cms
			b_p_cpt := a_other.b_p_cpt
			b_p_cfu := a_other.b_p_cfu
			b_p_ofu := a_other.b_p_ofu
			b_p_eol := a_other.b_p_eol
			b_p_et := a_other.b_p_et
			b_p_et_nobin := a_other.b_p_et_nobin
			b_p_fenc := a_other.b_p_fenc
			b_p_ff := a_other.b_p_ff
			b_p_ft := a_other.b_p_ft
			b_p_fo := a_other.b_p_fo
			b_p_flp := a_other.b_p_flp
			b_p_inf := a_other.b_p_inf
			b_p_isk := a_other.b_p_isk
			b_p_def := a_other.b_p_def
			b_p_inc := a_other.b_p_inc
			b_p_inex := a_other.b_p_inex
			b_p_inex_flags := a_other.b_p_inex_flags
			b_p_inde := a_other.b_p_inde
			b_p_inde_flags := a_other.b_p_inde_flags
			b_p_indk := a_other.b_p_indk
			b_p_fex := a_other.b_p_fex
			b_p_fex_flags := a_other.b_p_fex_flags
			b_p_key := a_other.b_p_key
			b_p_kp := a_other.b_p_kp
			b_p_lisp := a_other.b_p_lisp
			b_p_mps := a_other.b_p_mps
			b_p_ml := a_other.b_p_ml
			b_p_ml_nobin := a_other.b_p_ml_nobin
			b_p_ma := a_other.b_p_ma
			b_p_nf := a_other.b_p_nf
			b_p_pi := a_other.b_p_pi
			b_p_qe := a_other.b_p_qe
			b_p_ro := a_other.b_p_ro
			b_p_sw := a_other.b_p_sw
			b_p_sn := a_other.b_p_sn
			b_p_si := a_other.b_p_si
			b_p_sts := a_other.b_p_sts
			b_p_sts_nopaste := a_other.b_p_sts_nopaste
			b_p_sua := a_other.b_p_sua
			b_p_swf := a_other.b_p_swf
			b_p_smc := a_other.b_p_smc
			b_p_syn := a_other.b_p_syn
			b_p_ts := a_other.b_p_ts
			b_p_tx := a_other.b_p_tx
			b_p_tw := a_other.b_p_tw
			b_p_tw_nobin := a_other.b_p_tw_nobin
			b_p_tw_nopaste := a_other.b_p_tw_nopaste
			b_p_wm := a_other.b_p_wm
			b_p_wm_nobin := a_other.b_p_wm_nobin
			b_p_wm_nopaste := a_other.b_p_wm_nopaste
			b_p_gp := a_other.b_p_gp
			b_p_mp := a_other.b_p_mp
			b_p_efm := a_other.b_p_efm
			b_p_ep := a_other.b_p_ep
			b_p_path := a_other.b_p_path
			b_p_ar := a_other.b_p_ar
			b_p_tags := a_other.b_p_tags
			b_p_dict := a_other.b_p_dict
			b_p_tsr := a_other.b_p_tsr
			b_p_udf := a_other.b_p_udf
			b_start_eol := a_other.b_start_eol
			b_start_ffc := a_other.b_start_ffc
			b_start_fenc := a_other.b_start_fenc
			b_bad_char := a_other.b_bad_char
			b_start_bomb := a_other.b_start_bomb
			b_bufvar := a_other.b_bufvar.twin
			b_vars := a_other.b_vars.twin
			b_p_bexpr := a_other.b_p_bexpr
			b_p_bexpr_flags := a_other.b_p_bexpr_flags
			b_p_cm := a_other.b_p_cm
			b_may_swap := a_other.b_may_swap
			b_did_warn := a_other.b_did_warn
			b_help := a_other.b_help
			b_spell := a_other.b_spell
			b_shortname := a_other.b_shortname
			b_s := a_other.b_s.twin
			b_signlist := a_other.b_signlist
			b_netbeans_file := a_other.b_netbeans_file
			b_was_netbeans_file := a_other.b_was_netbeans_file
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b_ml.is_equal (a_other.b_ml) and
				b_next.is_equal (a_other.b_next) and
				b_prev.is_equal (a_other.b_prev) and
				b_nwindows = a_other.b_nwindows and
				b_flags = a_other.b_flags and
				b_ffname.is_equal (a_other.b_ffname) and
				b_sfname.is_equal (a_other.b_sfname) and
				b_fname.is_equal (a_other.b_fname) and
				b_dev_valid = a_other.b_dev_valid and
				b_dev = a_other.b_dev and
				b_ino = a_other.b_ino and
				b_fnum = a_other.b_fnum and
				b_changed = a_other.b_changed and
				b_changedtick = a_other.b_changedtick and
				b_saving = a_other.b_saving and
				b_mod_set = a_other.b_mod_set and
				b_mod_top = a_other.b_mod_top and
				b_mod_bot = a_other.b_mod_bot and
				b_mod_xlines = a_other.b_mod_xlines and
				b_wininfo.is_equal (a_other.b_wininfo) and
				b_mtime = a_other.b_mtime and
				b_mtime_read = a_other.b_mtime_read and
				b_orig_size = a_other.b_orig_size and
				b_orig_mode = a_other.b_orig_mode and
				b_namedm.is_equal (a_other.b_namedm) and
				b_visual.is_equal (a_other.b_visual) and
				b_visual_mode_eval = a_other.b_visual_mode_eval and
				b_last_cursor.is_equal (a_other.b_last_cursor) and
				b_last_insert.is_equal (a_other.b_last_insert) and
				b_last_change.is_equal (a_other.b_last_change) and
				b_changelist.is_equal (a_other.b_changelist) and
				b_changelistlen = a_other.b_changelistlen and
				b_new_change = a_other.b_new_change and
				b_chartab.is_equal (a_other.b_chartab) and
				b_maphash.is_equal (a_other.b_maphash) and
				b_first_abbr.is_equal (a_other.b_first_abbr) and
				b_ucmds.is_equal (a_other.b_ucmds) and
				b_op_start.is_equal (a_other.b_op_start) and
				b_op_end.is_equal (a_other.b_op_end) and
				b_marks_read = a_other.b_marks_read and
				b_u_oldhead.is_equal (a_other.b_u_oldhead) and
				b_u_newhead.is_equal (a_other.b_u_newhead) and
				b_u_curhead.is_equal (a_other.b_u_curhead) and
				b_u_numhead = a_other.b_u_numhead and
				b_u_synced = a_other.b_u_synced and
				b_u_seq_last = a_other.b_u_seq_last and
				b_u_save_nr_last = a_other.b_u_save_nr_last and
				b_u_seq_cur = a_other.b_u_seq_cur and
				b_u_time_cur = a_other.b_u_time_cur and
				b_u_save_nr_cur = a_other.b_u_save_nr_cur and
				b_u_line_ptr.is_equal (a_other.b_u_line_ptr) and
				b_u_line_lnum = a_other.b_u_line_lnum and
				b_u_line_colnr = a_other.b_u_line_colnr and
				b_scanned = a_other.b_scanned and
				b_p_iminsert = a_other.b_p_iminsert and
				b_p_imsearch = a_other.b_p_imsearch and
				b_p_initialized = a_other.b_p_initialized and
				b_p_scriptID.is_equal (a_other.b_p_scriptID) and
				b_p_ai = a_other.b_p_ai and
				b_p_ai_nopaste = a_other.b_p_ai_nopaste and
				b_p_ci = a_other.b_p_ci and
				b_p_bin = a_other.b_p_bin and
				b_p_bomb = a_other.b_p_bomb and
				b_p_bh.is_equal (a_other.b_p_bh) and
				b_p_bt.is_equal (a_other.b_p_bt) and
				b_p_bl = a_other.b_p_bl and
				b_p_cin = a_other.b_p_cin and
				b_p_cino.is_equal (a_other.b_p_cino) and
				b_p_cink.is_equal (a_other.b_p_cink) and
				b_p_cinw.is_equal (a_other.b_p_cinw) and
				b_p_com.is_equal (a_other.b_p_com) and
				b_p_cms.is_equal (a_other.b_p_cms) and
				b_p_cpt.is_equal (a_other.b_p_cpt) and
				b_p_cfu.is_equal (a_other.b_p_cfu) and
				b_p_ofu.is_equal (a_other.b_p_ofu) and
				b_p_eol = a_other.b_p_eol and
				b_p_et = a_other.b_p_et and
				b_p_et_nobin = a_other.b_p_et_nobin and
				b_p_fenc.is_equal (a_other.b_p_fenc) and
				b_p_ff.is_equal (a_other.b_p_ff) and
				b_p_ft.is_equal (a_other.b_p_ft) and
				b_p_fo.is_equal (a_other.b_p_fo) and
				b_p_flp.is_equal (a_other.b_p_flp) and
				b_p_inf = a_other.b_p_inf and
				b_p_isk.is_equal (a_other.b_p_isk) and
				b_p_def.is_equal (a_other.b_p_def) and
				b_p_inc.is_equal (a_other.b_p_inc) and
				b_p_inex.is_equal (a_other.b_p_inex) and
				b_p_inex_flags = a_other.b_p_inex_flags and
				b_p_inde.is_equal (a_other.b_p_inde) and
				b_p_inde_flags = a_other.b_p_inde_flags and
				b_p_indk.is_equal (a_other.b_p_indk) and
				b_p_fex.is_equal (a_other.b_p_fex) and
				b_p_fex_flags = a_other.b_p_fex_flags and
				b_p_key.is_equal (a_other.b_p_key) and
				b_p_kp.is_equal (a_other.b_p_kp) and
				b_p_lisp = a_other.b_p_lisp and
				b_p_mps.is_equal (a_other.b_p_mps) and
				b_p_ml = a_other.b_p_ml and
				b_p_ml_nobin = a_other.b_p_ml_nobin and
				b_p_ma = a_other.b_p_ma and
				b_p_nf.is_equal (a_other.b_p_nf) and
				b_p_pi = a_other.b_p_pi and
				b_p_qe.is_equal (a_other.b_p_qe) and
				b_p_ro = a_other.b_p_ro and
				b_p_sw = a_other.b_p_sw and
				b_p_sn = a_other.b_p_sn and
				b_p_si = a_other.b_p_si and
				b_p_sts = a_other.b_p_sts and
				b_p_sts_nopaste = a_other.b_p_sts_nopaste and
				b_p_sua.is_equal (a_other.b_p_sua) and
				b_p_swf = a_other.b_p_swf and
				b_p_smc = a_other.b_p_smc and
				b_p_syn.is_equal (a_other.b_p_syn) and
				b_p_ts = a_other.b_p_ts and
				b_p_tx = a_other.b_p_tx and
				b_p_tw = a_other.b_p_tw and
				b_p_tw_nobin = a_other.b_p_tw_nobin and
				b_p_tw_nopaste = a_other.b_p_tw_nopaste and
				b_p_wm = a_other.b_p_wm and
				b_p_wm_nobin = a_other.b_p_wm_nobin and
				b_p_wm_nopaste = a_other.b_p_wm_nopaste and
				b_p_gp.is_equal (a_other.b_p_gp) and
				b_p_mp.is_equal (a_other.b_p_mp) and
				b_p_efm.is_equal (a_other.b_p_efm) and
				b_p_ep.is_equal (a_other.b_p_ep) and
				b_p_path.is_equal (a_other.b_p_path) and
				b_p_ar = a_other.b_p_ar and
				b_p_tags.is_equal (a_other.b_p_tags) and
				b_p_dict.is_equal (a_other.b_p_dict) and
				b_p_tsr.is_equal (a_other.b_p_tsr) and
				b_p_udf = a_other.b_p_udf and
				b_start_eol = a_other.b_start_eol and
				b_start_ffc = a_other.b_start_ffc and
				b_start_fenc.is_equal (a_other.b_start_fenc) and
				b_bad_char = a_other.b_bad_char and
				b_start_bomb = a_other.b_start_bomb and
				b_bufvar.is_equal (a_other.b_bufvar) and
				b_vars.is_equal (a_other.b_vars) and
				b_p_bexpr.is_equal (a_other.b_p_bexpr) and
				b_p_bexpr_flags = a_other.b_p_bexpr_flags and
				b_p_cm.is_equal (a_other.b_p_cm) and
				b_may_swap = a_other.b_may_swap and
				b_did_warn = a_other.b_did_warn and
				b_help = a_other.b_help and
				b_spell = a_other.b_spell and
				b_shortname = a_other.b_shortname and
				b_s.is_equal (a_other.b_s) and
				b_signlist.is_equal (a_other.b_signlist) and
				b_netbeans_file = a_other.b_netbeans_file and
				b_was_netbeans_file = a_other.b_was_netbeans_file
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("b_ml"),
					create {CE_STRUCTURE_FIELD}.make ("b_next"),
					create {CE_STRUCTURE_FIELD}.make ("b_prev"),
					create {CE_STRUCTURE_FIELD}.make ("b_nwindows"),
					create {CE_STRUCTURE_FIELD}.make ("b_flags"),
					create {CE_STRUCTURE_FIELD}.make ("b_ffname"),
					create {CE_STRUCTURE_FIELD}.make ("b_sfname"),
					create {CE_STRUCTURE_FIELD}.make ("b_fname"),
					create {CE_STRUCTURE_FIELD}.make ("b_dev_valid"),
					create {CE_STRUCTURE_FIELD}.make ("b_dev"),
					create {CE_STRUCTURE_FIELD}.make ("b_ino"),
					create {CE_STRUCTURE_FIELD}.make ("b_fnum"),
					create {CE_STRUCTURE_FIELD}.make ("b_changed"),
					create {CE_STRUCTURE_FIELD}.make ("b_changedtick"),
					create {CE_STRUCTURE_FIELD}.make ("b_saving"),
					create {CE_STRUCTURE_FIELD}.make ("b_mod_set"),
					create {CE_STRUCTURE_FIELD}.make ("b_mod_top"),
					create {CE_STRUCTURE_FIELD}.make ("b_mod_bot"),
					create {CE_STRUCTURE_FIELD}.make ("b_mod_xlines"),
					create {CE_STRUCTURE_FIELD}.make ("b_wininfo"),
					create {CE_STRUCTURE_FIELD}.make ("b_mtime"),
					create {CE_STRUCTURE_FIELD}.make ("b_mtime_read"),
					create {CE_STRUCTURE_FIELD}.make ("b_orig_size"),
					create {CE_STRUCTURE_FIELD}.make ("b_orig_mode"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b_namedm", <<26>>),
					create {CE_STRUCTURE_FIELD}.make ("b_visual"),
					create {CE_STRUCTURE_FIELD}.make ("b_visual_mode_eval"),
					create {CE_STRUCTURE_FIELD}.make ("b_last_cursor"),
					create {CE_STRUCTURE_FIELD}.make ("b_last_insert"),
					create {CE_STRUCTURE_FIELD}.make ("b_last_change"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b_changelist", <<100>>),
					create {CE_STRUCTURE_FIELD}.make ("b_changelistlen"),
					create {CE_STRUCTURE_FIELD}.make ("b_new_change"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b_chartab", <<32>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b_maphash", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("b_first_abbr"),
					create {CE_STRUCTURE_FIELD}.make ("b_ucmds"),
					create {CE_STRUCTURE_FIELD}.make ("b_op_start"),
					create {CE_STRUCTURE_FIELD}.make ("b_op_end"),
					create {CE_STRUCTURE_FIELD}.make ("b_marks_read"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_oldhead"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_newhead"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_curhead"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_numhead"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_synced"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_seq_last"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_save_nr_last"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_seq_cur"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_time_cur"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_save_nr_cur"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_line_ptr"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_line_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("b_u_line_colnr"),
					create {CE_STRUCTURE_FIELD}.make ("b_scanned"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_iminsert"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_imsearch"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_initialized"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b_p_scriptID", <<71>>),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ai"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ai_nopaste"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ci"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_bin"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_bomb"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_bh"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_bt"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_bl"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_cin"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_cino"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_cink"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_cinw"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_com"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_cms"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_cpt"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_cfu"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ofu"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_eol"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_et"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_et_nobin"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_fenc"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ff"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ft"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_fo"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_flp"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_inf"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_isk"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_def"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_inc"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_inex"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_inex_flags"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_inde"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_inde_flags"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_indk"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_fex"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_fex_flags"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_key"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_kp"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_lisp"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_mps"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ml"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ml_nobin"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ma"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_nf"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_pi"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_qe"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ro"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_sw"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_sn"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_si"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_sts"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_sts_nopaste"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_sua"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_swf"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_smc"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_syn"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ts"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_tx"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_tw"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_tw_nobin"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_tw_nopaste"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_wm"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_wm_nobin"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_wm_nopaste"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_gp"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_mp"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_efm"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ep"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_path"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_ar"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_tags"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_dict"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_tsr"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_udf"),
					create {CE_STRUCTURE_FIELD}.make ("b_start_eol"),
					create {CE_STRUCTURE_FIELD}.make ("b_start_ffc"),
					create {CE_STRUCTURE_FIELD}.make ("b_start_fenc"),
					create {CE_STRUCTURE_FIELD}.make ("b_bad_char"),
					create {CE_STRUCTURE_FIELD}.make ("b_start_bomb"),
					create {CE_STRUCTURE_FIELD}.make ("b_bufvar"),
					create {CE_STRUCTURE_FIELD}.make ("b_vars"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_bexpr"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_bexpr_flags"),
					create {CE_STRUCTURE_FIELD}.make ("b_p_cm"),
					create {CE_STRUCTURE_FIELD}.make ("b_may_swap"),
					create {CE_STRUCTURE_FIELD}.make ("b_did_warn"),
					create {CE_STRUCTURE_FIELD}.make ("b_help"),
					create {CE_STRUCTURE_FIELD}.make ("b_spell"),
					create {CE_STRUCTURE_FIELD}.make ("b_shortname"),
					create {CE_STRUCTURE_FIELD}.make ("b_s"),
					create {CE_STRUCTURE_FIELD}.make ("b_signlist"),
					create {CE_STRUCTURE_FIELD}.make ("b_netbeans_file"),
					create {CE_STRUCTURE_FIELD}.make ("b_was_netbeans_file")
				>>)
			init_structure_info
		end

end
