class
	PD_SLANG_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sl_next.make
			create sl_name.make
			create sl_fname.make
			create sl_fbyts.make
			create sl_fidxs.make
			create sl_kbyts.make
			create sl_kidxs.make
			create sl_pbyts.make
			create sl_pidxs.make
			create sl_info.make
			create sl_regions.make (<<17>>)
			create sl_midword.make
			create sl_wordcount.make
			create sl_comppat.make
			create sl_compprog.make
			create sl_comprules.make
			create sl_compstartflags.make
			create sl_compallflags.make
			create sl_syllable.make
			create sl_syl_items.make
			create sl_prefprog.make
			create sl_rep.make
			create sl_rep_first.make (<<256>>)
			create sl_sal.make
			create sl_sal_first.make (<<256>>)
			create sl_repsal.make
			create sl_repsal_first.make (<<256>>)
			create sl_sbyts.make
			create sl_sidxs.make
			create sl_sugbuf.make
			create sl_map_hash.make
			create sl_map_array.make (<<256>>)
			create sl_sounddone.make
		end

feature {ANY} -- fields

	sl_next: CE_POINTER [PD_SLANG_S] assign set_sl_next

	sl_name: CE_POINTER [NATURAL_8] assign set_sl_name

	sl_fname: CE_POINTER [NATURAL_8] assign set_sl_fname

	sl_add: INTEGER_32 assign set_sl_add

	sl_fbyts: CE_POINTER [NATURAL_8] assign set_sl_fbyts

	sl_fidxs: CE_POINTER [INTEGER_32] assign set_sl_fidxs

	sl_kbyts: CE_POINTER [NATURAL_8] assign set_sl_kbyts

	sl_kidxs: CE_POINTER [INTEGER_32] assign set_sl_kidxs

	sl_pbyts: CE_POINTER [NATURAL_8] assign set_sl_pbyts

	sl_pidxs: CE_POINTER [INTEGER_32] assign set_sl_pidxs

	sl_info: CE_POINTER [NATURAL_8] assign set_sl_info

	sl_regions: CE_ARRAY [NATURAL_8]

	sl_midword: CE_POINTER [NATURAL_8] assign set_sl_midword

	sl_wordcount: PD_HASHTABLE_S assign set_sl_wordcount

	sl_compmax: INTEGER_32 assign set_sl_compmax

	sl_compminlen: INTEGER_32 assign set_sl_compminlen

	sl_compsylmax: INTEGER_32 assign set_sl_compsylmax

	sl_compoptions: INTEGER_32 assign set_sl_compoptions

	sl_comppat: PD_GROWARRAY assign set_sl_comppat

	sl_compprog: CE_POINTER [PD_REGPROG_T] assign set_sl_compprog

	sl_comprules: CE_POINTER [NATURAL_8] assign set_sl_comprules

	sl_compstartflags: CE_POINTER [NATURAL_8] assign set_sl_compstartflags

	sl_compallflags: CE_POINTER [NATURAL_8] assign set_sl_compallflags

	sl_nobreak: NATURAL_8 assign set_sl_nobreak

	sl_syllable: CE_POINTER [NATURAL_8] assign set_sl_syllable

	sl_syl_items: PD_GROWARRAY assign set_sl_syl_items

	sl_prefixcnt: INTEGER_32 assign set_sl_prefixcnt

	sl_prefprog: CE_POINTER [CE_POINTER [PD_REGPROG_T]] assign set_sl_prefprog

	sl_rep: PD_GROWARRAY assign set_sl_rep

	sl_rep_first: CE_ARRAY [INTEGER_16]

	sl_sal: PD_GROWARRAY assign set_sl_sal

	sl_sal_first: CE_ARRAY [INTEGER_32]

	sl_followup: INTEGER_32 assign set_sl_followup

	sl_collapse: INTEGER_32 assign set_sl_collapse

	sl_rem_accents: INTEGER_32 assign set_sl_rem_accents

	sl_sofo: INTEGER_32 assign set_sl_sofo

	sl_repsal: PD_GROWARRAY assign set_sl_repsal

	sl_repsal_first: CE_ARRAY [INTEGER_16]

	sl_nosplitsugs: INTEGER_32 assign set_sl_nosplitsugs

	sl_sugtime: INTEGER_32 assign set_sl_sugtime

	sl_sbyts: CE_POINTER [NATURAL_8] assign set_sl_sbyts

	sl_sidxs: CE_POINTER [INTEGER_32] assign set_sl_sidxs

	sl_sugbuf: CE_POINTER [PD_FILE_BUFFER] assign set_sl_sugbuf

	sl_sugloaded: INTEGER_32 assign set_sl_sugloaded

	sl_has_map: INTEGER_32 assign set_sl_has_map

	sl_map_hash: PD_HASHTABLE_S assign set_sl_map_hash

	sl_map_array: CE_ARRAY [INTEGER_32]

	sl_sounddone: PD_HASHTABLE_S assign set_sl_sounddone

feature {ANY} -- setters

	set_sl_next (a_sl_next: CE_POINTER [PD_SLANG_S])
		do
			sl_next := a_sl_next
			update_memory_field ("sl_next")
		end

	set_sl_name (a_sl_name: CE_POINTER [NATURAL_8])
		do
			sl_name := a_sl_name
			update_memory_field ("sl_name")
		end

	set_sl_fname (a_sl_fname: CE_POINTER [NATURAL_8])
		do
			sl_fname := a_sl_fname
			update_memory_field ("sl_fname")
		end

	set_sl_add (a_sl_add: INTEGER_32)
		do
			sl_add := a_sl_add
			update_memory_field ("sl_add")
		end

	set_sl_fbyts (a_sl_fbyts: CE_POINTER [NATURAL_8])
		do
			sl_fbyts := a_sl_fbyts
			update_memory_field ("sl_fbyts")
		end

	set_sl_fidxs (a_sl_fidxs: CE_POINTER [INTEGER_32])
		do
			sl_fidxs := a_sl_fidxs
			update_memory_field ("sl_fidxs")
		end

	set_sl_kbyts (a_sl_kbyts: CE_POINTER [NATURAL_8])
		do
			sl_kbyts := a_sl_kbyts
			update_memory_field ("sl_kbyts")
		end

	set_sl_kidxs (a_sl_kidxs: CE_POINTER [INTEGER_32])
		do
			sl_kidxs := a_sl_kidxs
			update_memory_field ("sl_kidxs")
		end

	set_sl_pbyts (a_sl_pbyts: CE_POINTER [NATURAL_8])
		do
			sl_pbyts := a_sl_pbyts
			update_memory_field ("sl_pbyts")
		end

	set_sl_pidxs (a_sl_pidxs: CE_POINTER [INTEGER_32])
		do
			sl_pidxs := a_sl_pidxs
			update_memory_field ("sl_pidxs")
		end

	set_sl_info (a_sl_info: CE_POINTER [NATURAL_8])
		do
			sl_info := a_sl_info
			update_memory_field ("sl_info")
		end

	set_sl_midword (a_sl_midword: CE_POINTER [NATURAL_8])
		do
			sl_midword := a_sl_midword
			update_memory_field ("sl_midword")
		end

	set_sl_wordcount (a_sl_wordcount: PD_HASHTABLE_S)
		do
			sl_wordcount := a_sl_wordcount
			update_memory_field ("sl_wordcount")
		end

	set_sl_compmax (a_sl_compmax: INTEGER_32)
		do
			sl_compmax := a_sl_compmax
			update_memory_field ("sl_compmax")
		end

	set_sl_compminlen (a_sl_compminlen: INTEGER_32)
		do
			sl_compminlen := a_sl_compminlen
			update_memory_field ("sl_compminlen")
		end

	set_sl_compsylmax (a_sl_compsylmax: INTEGER_32)
		do
			sl_compsylmax := a_sl_compsylmax
			update_memory_field ("sl_compsylmax")
		end

	set_sl_compoptions (a_sl_compoptions: INTEGER_32)
		do
			sl_compoptions := a_sl_compoptions
			update_memory_field ("sl_compoptions")
		end

	set_sl_comppat (a_sl_comppat: PD_GROWARRAY)
		do
			sl_comppat := a_sl_comppat
			update_memory_field ("sl_comppat")
		end

	set_sl_compprog (a_sl_compprog: CE_POINTER [PD_REGPROG_T])
		do
			sl_compprog := a_sl_compprog
			update_memory_field ("sl_compprog")
		end

	set_sl_comprules (a_sl_comprules: CE_POINTER [NATURAL_8])
		do
			sl_comprules := a_sl_comprules
			update_memory_field ("sl_comprules")
		end

	set_sl_compstartflags (a_sl_compstartflags: CE_POINTER [NATURAL_8])
		do
			sl_compstartflags := a_sl_compstartflags
			update_memory_field ("sl_compstartflags")
		end

	set_sl_compallflags (a_sl_compallflags: CE_POINTER [NATURAL_8])
		do
			sl_compallflags := a_sl_compallflags
			update_memory_field ("sl_compallflags")
		end

	set_sl_nobreak (a_sl_nobreak: NATURAL_8)
		do
			sl_nobreak := a_sl_nobreak
			update_memory_field ("sl_nobreak")
		end

	set_sl_syllable (a_sl_syllable: CE_POINTER [NATURAL_8])
		do
			sl_syllable := a_sl_syllable
			update_memory_field ("sl_syllable")
		end

	set_sl_syl_items (a_sl_syl_items: PD_GROWARRAY)
		do
			sl_syl_items := a_sl_syl_items
			update_memory_field ("sl_syl_items")
		end

	set_sl_prefixcnt (a_sl_prefixcnt: INTEGER_32)
		do
			sl_prefixcnt := a_sl_prefixcnt
			update_memory_field ("sl_prefixcnt")
		end

	set_sl_prefprog (a_sl_prefprog: CE_POINTER [CE_POINTER [PD_REGPROG_T]])
		do
			sl_prefprog := a_sl_prefprog
			update_memory_field ("sl_prefprog")
		end

	set_sl_rep (a_sl_rep: PD_GROWARRAY)
		do
			sl_rep := a_sl_rep
			update_memory_field ("sl_rep")
		end

	set_sl_sal (a_sl_sal: PD_GROWARRAY)
		do
			sl_sal := a_sl_sal
			update_memory_field ("sl_sal")
		end

	set_sl_followup (a_sl_followup: INTEGER_32)
		do
			sl_followup := a_sl_followup
			update_memory_field ("sl_followup")
		end

	set_sl_collapse (a_sl_collapse: INTEGER_32)
		do
			sl_collapse := a_sl_collapse
			update_memory_field ("sl_collapse")
		end

	set_sl_rem_accents (a_sl_rem_accents: INTEGER_32)
		do
			sl_rem_accents := a_sl_rem_accents
			update_memory_field ("sl_rem_accents")
		end

	set_sl_sofo (a_sl_sofo: INTEGER_32)
		do
			sl_sofo := a_sl_sofo
			update_memory_field ("sl_sofo")
		end

	set_sl_repsal (a_sl_repsal: PD_GROWARRAY)
		do
			sl_repsal := a_sl_repsal
			update_memory_field ("sl_repsal")
		end

	set_sl_nosplitsugs (a_sl_nosplitsugs: INTEGER_32)
		do
			sl_nosplitsugs := a_sl_nosplitsugs
			update_memory_field ("sl_nosplitsugs")
		end

	set_sl_sugtime (a_sl_sugtime: INTEGER_32)
		do
			sl_sugtime := a_sl_sugtime
			update_memory_field ("sl_sugtime")
		end

	set_sl_sbyts (a_sl_sbyts: CE_POINTER [NATURAL_8])
		do
			sl_sbyts := a_sl_sbyts
			update_memory_field ("sl_sbyts")
		end

	set_sl_sidxs (a_sl_sidxs: CE_POINTER [INTEGER_32])
		do
			sl_sidxs := a_sl_sidxs
			update_memory_field ("sl_sidxs")
		end

	set_sl_sugbuf (a_sl_sugbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			sl_sugbuf := a_sl_sugbuf
			update_memory_field ("sl_sugbuf")
		end

	set_sl_sugloaded (a_sl_sugloaded: INTEGER_32)
		do
			sl_sugloaded := a_sl_sugloaded
			update_memory_field ("sl_sugloaded")
		end

	set_sl_has_map (a_sl_has_map: INTEGER_32)
		do
			sl_has_map := a_sl_has_map
			update_memory_field ("sl_has_map")
		end

	set_sl_map_hash (a_sl_map_hash: PD_HASHTABLE_S)
		do
			sl_map_hash := a_sl_map_hash
			update_memory_field ("sl_map_hash")
		end

	set_sl_sounddone (a_sl_sounddone: PD_HASHTABLE_S)
		do
			sl_sounddone := a_sl_sounddone
			update_memory_field ("sl_sounddone")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sl_next := a_other.sl_next
			sl_name := a_other.sl_name
			sl_fname := a_other.sl_fname
			sl_add := a_other.sl_add
			sl_fbyts := a_other.sl_fbyts
			sl_fidxs := a_other.sl_fidxs
			sl_kbyts := a_other.sl_kbyts
			sl_kidxs := a_other.sl_kidxs
			sl_pbyts := a_other.sl_pbyts
			sl_pidxs := a_other.sl_pidxs
			sl_info := a_other.sl_info
			sl_regions := a_other.sl_regions.twin
			sl_midword := a_other.sl_midword
			sl_wordcount := a_other.sl_wordcount.twin
			sl_compmax := a_other.sl_compmax
			sl_compminlen := a_other.sl_compminlen
			sl_compsylmax := a_other.sl_compsylmax
			sl_compoptions := a_other.sl_compoptions
			sl_comppat := a_other.sl_comppat.twin
			sl_compprog := a_other.sl_compprog
			sl_comprules := a_other.sl_comprules
			sl_compstartflags := a_other.sl_compstartflags
			sl_compallflags := a_other.sl_compallflags
			sl_nobreak := a_other.sl_nobreak
			sl_syllable := a_other.sl_syllable
			sl_syl_items := a_other.sl_syl_items.twin
			sl_prefixcnt := a_other.sl_prefixcnt
			sl_prefprog := a_other.sl_prefprog
			sl_rep := a_other.sl_rep.twin
			sl_rep_first := a_other.sl_rep_first.twin
			sl_sal := a_other.sl_sal.twin
			sl_sal_first := a_other.sl_sal_first.twin
			sl_followup := a_other.sl_followup
			sl_collapse := a_other.sl_collapse
			sl_rem_accents := a_other.sl_rem_accents
			sl_sofo := a_other.sl_sofo
			sl_repsal := a_other.sl_repsal.twin
			sl_repsal_first := a_other.sl_repsal_first.twin
			sl_nosplitsugs := a_other.sl_nosplitsugs
			sl_sugtime := a_other.sl_sugtime
			sl_sbyts := a_other.sl_sbyts
			sl_sidxs := a_other.sl_sidxs
			sl_sugbuf := a_other.sl_sugbuf
			sl_sugloaded := a_other.sl_sugloaded
			sl_has_map := a_other.sl_has_map
			sl_map_hash := a_other.sl_map_hash.twin
			sl_map_array := a_other.sl_map_array.twin
			sl_sounddone := a_other.sl_sounddone.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sl_next.is_equal (a_other.sl_next) and
				sl_name.is_equal (a_other.sl_name) and
				sl_fname.is_equal (a_other.sl_fname) and
				sl_add = a_other.sl_add and
				sl_fbyts.is_equal (a_other.sl_fbyts) and
				sl_fidxs.is_equal (a_other.sl_fidxs) and
				sl_kbyts.is_equal (a_other.sl_kbyts) and
				sl_kidxs.is_equal (a_other.sl_kidxs) and
				sl_pbyts.is_equal (a_other.sl_pbyts) and
				sl_pidxs.is_equal (a_other.sl_pidxs) and
				sl_info.is_equal (a_other.sl_info) and
				sl_regions.is_equal (a_other.sl_regions) and
				sl_midword.is_equal (a_other.sl_midword) and
				sl_wordcount.is_equal (a_other.sl_wordcount) and
				sl_compmax = a_other.sl_compmax and
				sl_compminlen = a_other.sl_compminlen and
				sl_compsylmax = a_other.sl_compsylmax and
				sl_compoptions = a_other.sl_compoptions and
				sl_comppat.is_equal (a_other.sl_comppat) and
				sl_compprog.is_equal (a_other.sl_compprog) and
				sl_comprules.is_equal (a_other.sl_comprules) and
				sl_compstartflags.is_equal (a_other.sl_compstartflags) and
				sl_compallflags.is_equal (a_other.sl_compallflags) and
				sl_nobreak = a_other.sl_nobreak and
				sl_syllable.is_equal (a_other.sl_syllable) and
				sl_syl_items.is_equal (a_other.sl_syl_items) and
				sl_prefixcnt = a_other.sl_prefixcnt and
				sl_prefprog.is_equal (a_other.sl_prefprog) and
				sl_rep.is_equal (a_other.sl_rep) and
				sl_rep_first.is_equal (a_other.sl_rep_first) and
				sl_sal.is_equal (a_other.sl_sal) and
				sl_sal_first.is_equal (a_other.sl_sal_first) and
				sl_followup = a_other.sl_followup and
				sl_collapse = a_other.sl_collapse and
				sl_rem_accents = a_other.sl_rem_accents and
				sl_sofo = a_other.sl_sofo and
				sl_repsal.is_equal (a_other.sl_repsal) and
				sl_repsal_first.is_equal (a_other.sl_repsal_first) and
				sl_nosplitsugs = a_other.sl_nosplitsugs and
				sl_sugtime = a_other.sl_sugtime and
				sl_sbyts.is_equal (a_other.sl_sbyts) and
				sl_sidxs.is_equal (a_other.sl_sidxs) and
				sl_sugbuf.is_equal (a_other.sl_sugbuf) and
				sl_sugloaded = a_other.sl_sugloaded and
				sl_has_map = a_other.sl_has_map and
				sl_map_hash.is_equal (a_other.sl_map_hash) and
				sl_map_array.is_equal (a_other.sl_map_array) and
				sl_sounddone.is_equal (a_other.sl_sounddone)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sl_next"),
					create {CE_STRUCTURE_FIELD}.make ("sl_name"),
					create {CE_STRUCTURE_FIELD}.make ("sl_fname"),
					create {CE_STRUCTURE_FIELD}.make ("sl_add"),
					create {CE_STRUCTURE_FIELD}.make ("sl_fbyts"),
					create {CE_STRUCTURE_FIELD}.make ("sl_fidxs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_kbyts"),
					create {CE_STRUCTURE_FIELD}.make ("sl_kidxs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_pbyts"),
					create {CE_STRUCTURE_FIELD}.make ("sl_pidxs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_info"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_regions", <<17>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_midword"),
					create {CE_STRUCTURE_FIELD}.make ("sl_wordcount"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compmax"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compminlen"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compsylmax"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compoptions"),
					create {CE_STRUCTURE_FIELD}.make ("sl_comppat"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compprog"),
					create {CE_STRUCTURE_FIELD}.make ("sl_comprules"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compstartflags"),
					create {CE_STRUCTURE_FIELD}.make ("sl_compallflags"),
					create {CE_STRUCTURE_FIELD}.make ("sl_nobreak"),
					create {CE_STRUCTURE_FIELD}.make ("sl_syllable"),
					create {CE_STRUCTURE_FIELD}.make ("sl_syl_items"),
					create {CE_STRUCTURE_FIELD}.make ("sl_prefixcnt"),
					create {CE_STRUCTURE_FIELD}.make ("sl_prefprog"),
					create {CE_STRUCTURE_FIELD}.make ("sl_rep"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_rep_first", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_sal"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_sal_first", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_followup"),
					create {CE_STRUCTURE_FIELD}.make ("sl_collapse"),
					create {CE_STRUCTURE_FIELD}.make ("sl_rem_accents"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sofo"),
					create {CE_STRUCTURE_FIELD}.make ("sl_repsal"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_repsal_first", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_nosplitsugs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sugtime"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sbyts"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sidxs"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sugbuf"),
					create {CE_STRUCTURE_FIELD}.make ("sl_sugloaded"),
					create {CE_STRUCTURE_FIELD}.make ("sl_has_map"),
					create {CE_STRUCTURE_FIELD}.make ("sl_map_hash"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sl_map_array", <<256>>),
					create {CE_STRUCTURE_FIELD}.make ("sl_sounddone")
				>>)
			init_structure_info
		end

end
