class
	PD_STL_HLREC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create start.make
		end

feature {ANY} -- fields

	start: CE_POINTER [NATURAL_8] assign set_start

	userhl: INTEGER_32 assign set_userhl

feature {ANY} -- setters

	set_start (a_start: CE_POINTER [NATURAL_8])
		do
			start := a_start
			update_memory_field ("start")
		end

	set_userhl (a_userhl: INTEGER_32)
		do
			userhl := a_userhl
			update_memory_field ("userhl")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			start := a_other.start
			userhl := a_other.userhl
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				start.is_equal (a_other.start) and
				userhl = a_other.userhl
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("start"),
					create {CE_STRUCTURE_FIELD}.make ("userhl")
				>>)
			init_structure_info
		end

end
