frozen class
	VIM_INITIALIZER_SLICE126

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			version_inst.features[15] := ce_string ("-cscope")
			version_inst.features[16] := ce_string ("+cursorbind")
			version_inst.features[17] := ce_string ("+cursorshape")
			version_inst.features[18] := ce_string ("+dialog_con_gui")
			version_inst.features[19] := ce_string ("+diff")
			version_inst.features[20] := ce_string ("+digraphs")
			version_inst.features[21] := ce_string ("+dnd")
			version_inst.features[22] := ce_string ("-ebcdic")
			version_inst.features[23] := ce_string ("-emacs_tags")
			version_inst.features[24] := ce_string ("+eval")
			version_inst.features[25] := ce_string ("+ex_extra")
			version_inst.features[26] := ce_string ("+extra_search")
			version_inst.features[27] := ce_string ("-farsi")
			version_inst.features[28] := ce_string ("+file_in_path")
			version_inst.features[29] := ce_string ("+find_in_path")
			version_inst.features[30] := ce_string ("+float")
			version_inst.features[31] := ce_string ("+folding")
			version_inst.features[32] := ce_string ("-footer")
			version_inst.features[33] := ce_string ("+fork()")
			version_inst.features[34] := ce_string ("+gettext")
			version_inst.features[35] := ce_string ("-hangul_input")
			version_inst.features[36] := ce_string ("+iconv")
			version_inst.features[37] := ce_string ("+insert_expand")
			version_inst.features[38] := ce_string ("+jumplist")
			version_inst.features[39] := ce_string ("-keymap")
			version_inst.features[40] := ce_string ("-langmap")
			version_inst.features[41] := ce_string ("+libcall")
			version_inst.features[42] := ce_string ("+linebreak")
			version_inst.features[43] := ce_string ("+lispindent")
			version_inst.features[44] := ce_string ("+listcmds")
			version_inst.features[45] := ce_string ("+localmap")
			version_inst.features[46] := ce_string ("-lua")
			version_inst.features[47] := ce_string ("+menu")
			version_inst.features[48] := ce_string ("+mksession")
			version_inst.features[49] := ce_string ("+modify_fname")
			version_inst.features[50] := ce_string ("+mouse")
			version_inst.features[51] := ce_string ("+mouseshape")
			version_inst.features[52] := ce_string ("-mouse_dec")
			version_inst.features[53] := ce_string ("-mouse_gpm")
			version_inst.features[54] := ce_string ("-mouse_jsbterm")
			version_inst.features[55] := ce_string ("-mouse_netterm")
			version_inst.features[56] := ce_string ("-mouse_sysmouse")
			version_inst.features[57] := ce_string ("+mouse_xterm")
			version_inst.features[58] := ce_string ("+multi_byte")
			version_inst.features[59] := ce_string ("+multi_lang")
			version_inst.features[60] := ce_string ("-mzscheme")
			version_inst.features[61] := ce_string ("+netbeans_intg")
			version_inst.features[62] := ce_string ("-osfiletype")
			version_inst.features[63] := ce_string ("+path_extra")
			version_inst.features[64] := ce_string ("-perl")
			version_inst.features[65] := ce_string ("+persistent_undo")
			version_inst.features[66] := ce_string ("+postscript")
			version_inst.features[67] := ce_string ("+printer")
			version_inst.features[68] := ce_string ("-profile")
			version_inst.features[69] := ce_string ("-python")
			version_inst.features[70] := ce_string ("-python3")
			version_inst.features[71] := ce_string ("+quickfix")
			version_inst.features[72] := ce_string ("+reltime")
			version_inst.features[73] := ce_string ("-rightleft")
			version_inst.features[74] := ce_string ("-ruby")
			version_inst.features[75] := ce_string ("+scrollbind")
			version_inst.features[76] := ce_string ("+signs")
			version_inst.features[77] := ce_string ("+smartindent")
			version_inst.features[78] := ce_string ("-sniff")
			version_inst.features[79] := ce_string ("+startuptime")
			version_inst.features[80] := ce_string ("+statusline")
			version_inst.features[81] := ce_string ("-sun_workshop")
			version_inst.features[82] := ce_string ("+syntax")
			version_inst.features[83] := ce_string ("+tag_binary")
			version_inst.features[84] := ce_string ("+tag_old_static")
			version_inst.features[85] := ce_string ("-tag_any_white")
			version_inst.features[86] := ce_string ("-tcl")
			version_inst.features[87] := ce_string ("+terminfo")
			version_inst.features[88] := ce_string ("+termresponse")
			version_inst.features[89] := ce_string ("+textobjects")
			version_inst.features[90] := ce_string ("+title")
			version_inst.features[91] := ce_string ("+toolbar")
			version_inst.features[92] := ce_string ("+user_commands")
			version_inst.features[93] := ce_string ("+vertsplit")
			version_inst.features[94] := ce_string ("+virtualedit")
			version_inst.features[95] := ce_string ("+visual")
			version_inst.features[96] := ce_string ("+visualextra")
			version_inst.features[97] := ce_string ("+viminfo")
			version_inst.features[98] := ce_string ("+vreplace")
			version_inst.features[99] := ce_string ("+wildignore")
			version_inst.features[100] := ce_string ("+wildmenu")
			version_inst.features[101] := ce_string ("+windows")
			version_inst.features[102] := ce_string ("+writebackup")
			version_inst.features[103] := ce_string ("+X11")
			version_inst.features[104] := ce_string ("-xfontset")
			version_inst.features[105] := ce_string ("+xim")
			version_inst.features[106] := ce_string ("+xsmp_interact")
			version_inst.features[107] := ce_string ("+xterm_clipboard")
			version_inst.features[108] := ce_string ("-xterm_save")
			version_inst.features[109] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.included_patches[0] := 0
			version_inst.extra_patches[0] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.lines[0] := ce_string ("VIM - Vi IMproved")
			version_inst.lines[1] := ce_string ("")
			version_inst.lines[2] := ce_string ("version ")
			version_inst.lines[3] := ce_string ("by Bram Moolenaar et al.")
			version_inst.lines[4] := ce_string ("Vim is open source and freely distributable")
			version_inst.lines[5] := ce_string ("")
			version_inst.lines[6] := ce_string ("Help poor children in Uganda!")
			version_inst.lines[7] := ce_string ("type  :help iccf<Enter>       for information ")
			version_inst.lines[8] := ce_string ("")
			version_inst.lines[9] := ce_string ("type  :q<Enter>               to exit         ")
			version_inst.lines[10] := ce_string ("type  :help<Enter>  or  <F1>  for on-line help")
			version_inst.lines[11] := ce_string ("type  :help version7<Enter>   for version info")
			version_inst.lines[12] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.lines[13] := ce_string ("")
			version_inst.lines[14] := ce_string ("Running in Vi compatible mode")
			version_inst.lines[15] := ce_string ("type  :set nocp<Enter>        for Vim defaults")
			version_inst.lines[16] := ce_string ("type  :help cp-default<Enter> for info on this")
			version_inst.gui_lines[0] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[1] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[3] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[4] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[5] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[6] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[7] := ce_string ("menu  Help->Orphans           for information    ")
			version_inst.gui_lines[8] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[9] := ce_string ("Running modeless, typed text is inserted")
			version_inst.gui_lines[10] := ce_string ("menu  Edit->Global Settings->Toggle Insert Mode  ")
			version_inst.gui_lines[11] := ce_string ("                              for two modes      ")
			version_inst.gui_lines[12] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[13] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[14] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			version_inst.gui_lines[15] := ce_string ("menu  Edit->Global Settings->Toggle Vi Compatible")
			version_inst.gui_lines[16] := ce_string ("                              for Vim defaults   ")
		end

end
