class
	P_AUTO_PATHDEF

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create all_cflags.make
			create all_lflags.make
			create compiled_sys.make
			create compiled_user.make
			create default_vim_dir.make
			create default_vimruntime_dir.make
		end

feature {ANY} -- attributes

	all_cflags: CE_POINTER [NATURAL_8] assign set_all_cflags

	set_all_cflags (a_all_cflags: CE_POINTER [NATURAL_8])
		do
			all_cflags := a_all_cflags
		end

	all_lflags: CE_POINTER [NATURAL_8] assign set_all_lflags

	set_all_lflags (a_all_lflags: CE_POINTER [NATURAL_8])
		do
			all_lflags := a_all_lflags
		end

	compiled_sys: CE_POINTER [NATURAL_8] assign set_compiled_sys

	set_compiled_sys (a_compiled_sys: CE_POINTER [NATURAL_8])
		do
			compiled_sys := a_compiled_sys
		end

	compiled_user: CE_POINTER [NATURAL_8] assign set_compiled_user

	set_compiled_user (a_compiled_user: CE_POINTER [NATURAL_8])
		do
			compiled_user := a_compiled_user
		end

	default_vim_dir: CE_POINTER [NATURAL_8] assign set_default_vim_dir

	set_default_vim_dir (a_default_vim_dir: CE_POINTER [NATURAL_8])
		do
			default_vim_dir := a_default_vim_dir
		end

	default_vimruntime_dir: CE_POINTER [NATURAL_8] assign set_default_vimruntime_dir

	set_default_vimruntime_dir (a_default_vimruntime_dir: CE_POINTER [NATURAL_8])
		do
			default_vimruntime_dir := a_default_vimruntime_dir
		end

end
