class
	P_NETBEANS

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create ExtEdProtocolVersion.make
			create buf___4.make
			create buf___5.make (<<128>>)
			create buf_list.make
			create globalsignmap.make
			create head.make (<<1>>)
			create keyHead.make (<<1>>)
			create mypos.make (<<1>>)
			create nbsock.make (<<1>>)
			create pos___2.make (<<1>>)
			create text___1.make
		end

feature {ANY} -- attributes

	ExtEdProtocolVersion: CE_POINTER [INTEGER_8] assign set_ExtEdProtocolVersion

	set_ExtEdProtocolVersion (a_ExtEdProtocolVersion: CE_POINTER [INTEGER_8])
		do
			ExtEdProtocolVersion := a_ExtEdProtocolVersion
		end

	buf___4: CE_POINTER [NATURAL_8] assign set_buf___4

	set_buf___4 (a_buf___4: CE_POINTER [NATURAL_8])
		do
			buf___4 := a_buf___4
		end

	buf___5: CE_ARRAY [INTEGER_8]

	buf_list: CE_POINTER [PD_NBBUF_STRUCT] assign set_buf_list

	set_buf_list (a_buf_list: CE_POINTER [PD_NBBUF_STRUCT])
		do
			buf_list := a_buf_list
		end

	buf_list_size: INTEGER_32 assign set_buf_list_size

	set_buf_list_size (a_buf_list_size: INTEGER_32)
		do
			buf_list_size := a_buf_list_size
		end

	buf_list_used: INTEGER_32 assign set_buf_list_used

	set_buf_list_used (a_buf_list_used: INTEGER_32)
		do
			buf_list_used := a_buf_list_used
		end

	curPCtype: INTEGER_32 assign set_curPCtype

	set_curPCtype (a_curPCtype: INTEGER_32)
		do
			curPCtype := a_curPCtype
		end

	did_error: INTEGER_32 assign set_did_error

	set_did_error (a_did_error: INTEGER_32)
		do
			did_error := a_did_error
		end

	did_init: INTEGER_32 assign set_did_init

	set_did_init (a_did_init: INTEGER_32)
		do
			did_init := a_did_init
		end

	dosetvisible: INTEGER_32 assign set_dosetvisible

	set_dosetvisible (a_dosetvisible: INTEGER_32)
		do
			dosetvisible := a_dosetvisible
		end

	globalsignmap: CE_POINTER [CE_POINTER [INTEGER_8]] assign set_globalsignmap

	set_globalsignmap (a_globalsignmap: CE_POINTER [CE_POINTER [INTEGER_8]])
		do
			globalsignmap := a_globalsignmap
		end

	globalsignmaplen: INTEGER_32 assign set_globalsignmaplen

	set_globalsignmaplen (a_globalsignmaplen: INTEGER_32)
		do
			globalsignmaplen := a_globalsignmaplen
		end

	globalsignmapused: INTEGER_32 assign set_globalsignmapused

	set_globalsignmapused (a_globalsignmapused: INTEGER_32)
		do
			globalsignmapused := a_globalsignmapused
		end

	guardId: INTEGER_32 assign set_guardId

	set_guardId (a_guardId: INTEGER_32)
		do
			guardId := a_guardId
		end

	head: CE_ARRAY [PD_CMDQUEUE]

	inAtomic: INTEGER_32 assign set_inAtomic

	set_inAtomic (a_inAtomic: INTEGER_32)
		do
			inAtomic := a_inAtomic
		end

	inputHandler: INTEGER_32 assign set_inputHandler

	set_inputHandler (a_inputHandler: INTEGER_32)
		do
			inputHandler := a_inputHandler
		end

	keyHead: CE_ARRAY [PD_KEYQUEUE]

	mypos: CE_ARRAY [PD_POS_T]

	nbsock: CE_ARRAY [INTEGER_32]

	needupdate: INTEGER_32 assign set_needupdate

	set_needupdate (a_needupdate: INTEGER_32)
		do
			needupdate := a_needupdate
		end

	pos___2: CE_ARRAY [PD_POS_T]

	r_cmdno: INTEGER_32 assign set_r_cmdno

	set_r_cmdno (a_r_cmdno: INTEGER_32)
		do
			r_cmdno := a_r_cmdno
		end

	skip: INTEGER_32 assign set_skip

	set_skip (a_skip: INTEGER_32)
		do
			skip := a_skip
		end

	text___1: CE_POINTER [INTEGER_8] assign set_text___1

	set_text___1 (a_text___1: CE_POINTER [INTEGER_8])
		do
			text___1 := a_text___1
		end

feature {ANY} -- routines

	addsigntype (a_buf___6: CE_POINTER [PD_NBBUF_STRUCT]; a_typeNum: INTEGER_32; a_typeName: CE_POINTER [NATURAL_8]; a_tooltip: CE_POINTER [NATURAL_8]; a_glyphFile: CE_POINTER [NATURAL_8]; a_fg: CE_POINTER [NATURAL_8]; a_bg: CE_POINTER [NATURAL_8])
		local
			l_i___0: INTEGER_32
			l_j: INTEGER_32
			l_use_fg: INTEGER_32
			l_tmp___0: INTEGER_32
			l_use_bg: INTEGER_32
			l_tmp___2: INTEGER_32
			l_fgbuf: CE_ARRAY [INTEGER_8]
			l_bgbuf: CE_ARRAY [INTEGER_8]
			l_ptr: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_value: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_incr: INTEGER_32
			l_oldlen: INTEGER_32
			l_incr___0: INTEGER_32
			l_oldlen___0: INTEGER_32
			l_tmp___14: NATURAL_16
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fgbuf.make (<<81>>)
			create l_bgbuf.make (<<81>>)
			create l_ptr.make (<<1>>)
			create l_tmp___6.make
			create l_tmp___7.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_fg.item).to_boolean then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_fg), ce_string ("none"))) /= 0 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
					else
						l_tmp___0 := 0
					end
					l_use_fg := l_tmp___0
					if (a_bg.item).to_boolean then
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_bg), ce_string ("none"))) /= 0 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
					l_use_bg := l_tmp___2
					l_i___0 := 0
					from
					until
						not (not js.loop_done and then (l_i___0 < globalsignmapused))
					loop
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_typeName), globalsignmap[l_i___0])) = 0 then
							js.break
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					if l_i___0 /= globalsignmapused then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if not (l_use_fg.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if not (l_use_bg.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						l_value := (strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_fg), l_ptr, 10)).to_integer_32
						if not (l_ptr.item).is_equal (a_fg) then
							sprintf ([l_fgbuf, ce_string ("guifg=#%%06x"), (l_value).bit_and (16_777_215)]).do_nothing
						else
							sprintf ([l_fgbuf, ce_string ("guifg=%%s ctermfg=%%s"), a_fg, a_fg]).do_nothing
						end
						l_value := (strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_bg), l_ptr, 10)).to_integer_32
						if not (l_ptr.item).is_equal (a_bg) then
							sprintf ([l_bgbuf, ce_string ("guibg=#%%06x"), (l_value).bit_and (16_777_215)]).do_nothing
						else
							sprintf ([l_bgbuf, ce_string ("guibg=%%s ctermbg=%%s"), a_bg, a_bg]).do_nothing
						end
						if l_use_bg.to_boolean then
							l_tmp___6 := l_bgbuf
						else
							l_tmp___6 := ce_string ("")
						end
						if l_use_fg.to_boolean then
							l_tmp___7 := l_fgbuf
						else
							l_tmp___7 := ce_string ("")
						end
						coloncmd ([ce_string (":highlight NB_%%s %%s %%s"), a_typeName, l_tmp___7, l_tmp___6])
						if (a_glyphFile.item).to_integer_32 = 0 then
							coloncmd ([ce_string (":sign define %%d linehl=NB_%%s"), l_i___0 + 1, a_typeName])
						elseif (charset_inst.vim_strsize (a_glyphFile)) <= 2 then
							coloncmd ([ce_string (":sign define %%d text=%%s texthl=NB_%%s"), l_i___0 + 1, a_glyphFile, a_typeName])
						else
							coloncmd ([ce_string (":sign define %%d icon=%%s linehl=NB_%%s"), l_i___0 + 1, a_glyphFile, a_typeName])
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						coloncmd ([ce_string (":sign define %%d icon=%%s"), l_i___0 + 1, a_glyphFile])
				when 8 then -- if done
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_typeName), ce_string ("CurrentPC"))) = 0 then
							curPCtype := a_typeNum
						end
						if globalsignmapused = globalsignmaplen then
							if globalsignmaplen = 0 then
								globalsignmaplen := 20
								globalsignmap := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((misc2_inst.alloc_clear (globalsignmaplen.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
							else
								l_oldlen := globalsignmaplen
								globalsignmaplen := globalsignmaplen * (2)
								l_incr := globalsignmaplen - l_oldlen
								globalsignmap := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast ((realloc (create {CE_POINTER [ANY]}.make_cast (globalsignmap), globalsignmaplen.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
								memset (create {CE_POINTER [ANY]}.make_cast ((globalsignmap + l_oldlen)), 0, l_incr.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
							end
						end
						globalsignmap[l_i___0] := create {CE_POINTER [INTEGER_8]}.make_cast (a_typeName)
						globalsignmapused := l_i___0 + 1
				when 9 then -- if done
					l_j := 0
					from
					until
						not (not js.loop_done and then (l_j < (a_buf___6.item.signmapused).to_integer_32))
					loop
						if a_buf___6.item.signmap[l_j] = l_i___0 + 1 then
							js.return
						end
						if not js.return_called then
							l_j := l_j + 1
						end
					end
					if not js.return_called then
						if (a_buf___6.item.signmapused).to_integer_32 = (a_buf___6.item.signmaplen).to_integer_32 then
							if (a_buf___6.item.signmaplen).to_integer_32 = 0 then
								a_buf___6.item.signmaplen := (5).to_natural_16
								a_buf___6.item.signmap := create {CE_POINTER [INTEGER_32]}.make_cast ((misc2_inst.alloc_clear ((a_buf___6.item.signmaplen).to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)))
							else
								l_oldlen___0 := (a_buf___6.item.signmaplen).to_integer_32
								a_buf___6.item.signmaplen := ((a_buf___6.item.signmaplen).to_integer_32 * 2).to_natural_16
								l_incr___0 := (a_buf___6.item.signmaplen).to_integer_32 - l_oldlen___0
								a_buf___6.item.signmap := create {CE_POINTER [INTEGER_32]}.make_cast ((realloc (create {CE_POINTER [ANY]}.make_cast (a_buf___6.item.signmap), (a_buf___6.item.signmaplen).to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)))
								memset (create {CE_POINTER [ANY]}.make_cast ((a_buf___6.item.signmap + l_oldlen___0)), 0, l_incr___0.to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
							end
						end
						l_tmp___14 := a_buf___6.item.signmapused
						a_buf___6.item.signmapused := ((a_buf___6.item.signmapused).to_integer_32 + 1).to_natural_16
						a_buf___6.item.signmap[l_tmp___14.to_integer_32] := l_i___0 + 1
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	coloncmd (a_args: TUPLE [a_cmd: CE_POINTER [INTEGER_8]])
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_ap___0: CE_VA_LIST
		do
			create l_buf___6.make (<<1_024>>)
			create l_ap___0.make_shared (default_pointer)

			l_ap___0 := create {CE_VA_LIST}.make (a_args, 2)
			message_inst.vim_vsnprintf (l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (1_024).to_natural_32), a_args.a_cmd, l_ap___0.twin, create {CE_POINTER [PD_TYPVAL_T]}.make_shared (default_pointer)).do_nothing
			ex_docmd_inst.do_cmdline (create {CE_POINTER [NATURAL_8]}.make_cast (l_buf___6), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), 10).do_nothing
			screen_inst.setcursor
			term_inst.out_flush
			if (gui_inst.gui.item.in_use).to_boolean then
				gui_inst.gui_update_cursor (1, 0)
				gui_gtk_x11_inst.gui_mch_flush
			end
		end

	count_changed_buffers: INTEGER_32
		local
			l_bufp: CE_POINTER [PD_FILE_BUFFER]
			l_n: INTEGER_32
		do
			create l_bufp.make

			l_n := 0
			l_bufp := globals_inst.firstbuf
			from
			until
				l_bufp.is_void
			loop
				if (l_bufp.item.b_changed).to_boolean then
					l_n := l_n + 1
				end
				l_bufp := l_bufp.item.b_next
			end
			Result := l_n
		end

	ex_nbclose (a_eap: CE_POINTER [PD_EXARG])
		do
			netbeans_close
		end

	ex_nbclose_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_nbclose)
		end

	ex_nbkey (a_eap: CE_POINTER [PD_EXARG])
		do
			netbeans_keystring (a_eap.item.arg).do_nothing
		end

	ex_nbkey_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_nbkey)
		end

	ex_nbstart (a_eap: CE_POINTER [PD_EXARG])
		do
			netbeans_open (create {CE_POINTER [INTEGER_8]}.make_cast (a_eap.item.arg), 0)
		end

	ex_nbstart_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ex_nbstart)
		end

	getConnInfo (a_file: CE_POINTER [INTEGER_8]; a_host: CE_POINTER [CE_POINTER [INTEGER_8]]; a_port: CE_POINTER [CE_POINTER [INTEGER_8]]; a_auth: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_lp: CE_POINTER [NATURAL_8]
			l_nl: CE_POINTER [NATURAL_8]
			l_st: CE_ARRAY [SD_STAT]
			js: JUMP_STATE
		do
			create l_fp.make
			create l_buf___6.make (<<8_192>>)
			create l_lp.make
			create l_nl.make
			create l_st.make (<<1>>)

			if (stat (a_file, l_st)) = 0 then
				if ((l_st.item.st_mode).bit_and ({NATURAL_32} 63)) /= {NATURAL_32} 0 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E668: Wrong access mode for NetBeans connection info file: %"%%s%"")))), create {CE_POINTER [NATURAL_8]}.make_cast (a_file)).do_nothing
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_fp := fopen (a_file, ce_string ("r"))
				if l_fp.is_void then
					misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E660: Cannot open NetBeans connection info file")), create {CE_POINTER [NATURAL_8]}.make_cast ((strerror ((errno_location).item)))).do_nothing
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_lp := create {CE_POINTER [NATURAL_8]}.make_cast ((fgets (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), 8_192, l_fp)))
					if l_lp.is_void then
						js.break
					end
					if not js.loop_jumped then
						l_nl := misc2_inst.vim_strchr (l_lp, ('%N').code)
						if not l_nl.is_void then
							l_nl.item := (0).to_natural_8
						end
						if (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lp), ce_string ("host="), (5).to_natural_32)) = 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_host.item))
							a_host.item := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strsave (l_buf___6 + 5)))
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lp), ce_string ("port="), (5).to_natural_32)) = 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_port.item))
							a_port.item := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strsave (l_buf___6 + 5)))
						elseif (strncmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_lp), ce_string ("auth="), (5).to_natural_32)) = 0 then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_auth.item))
							a_auth.item := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strsave (l_buf___6 + 5)))
						end
					end
				end
				fclose (l_fp).do_nothing
				Result := 1
			end
		end

	get_buf_size (a_bufp: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_lnum: INTEGER_32
			l_char_count: INTEGER_32
			l_eol_size: INTEGER_32
			l_last_check: INTEGER_32
			js: JUMP_STATE
		do
			l_char_count := 0
			l_last_check := 100_000
			if ((a_bufp.item.b_ml.ml_flags).bit_and (1)).to_boolean then
				Result := 0
				js.return
			else
				if (misc2_inst.get_fileformat (a_bufp)) = 1 then
					l_eol_size := 2
				else
					l_eol_size := 1
				end
				l_lnum := (1).to_integer_32
				from
				until
					not (not js.loop_done and then (l_lnum <= a_bufp.item.b_ml.ml_line_count))
				loop
					l_char_count := l_char_count + ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get_buf (a_bufp, l_lnum, 0))))).to_integer_32 + l_eol_size.to_integer_32)
					if l_char_count > l_last_check then
						ui_inst.ui_breakcheck
						if globals_inst.got_int.to_boolean then
							Result := l_char_count
							js.return
						end
						if not js.return_called then
							l_last_check := l_char_count + 100_000
						end
					end
					if not js.return_called then
						l_lnum := l_lnum + 1
					end
				end
				if not js.return_called and then (not (a_bufp.item.b_p_eol).to_boolean) then
					if (a_bufp.item.b_p_bin).to_boolean then
						l_char_count := l_char_count - l_eol_size.to_integer_32
					end
				end
			end
			if not js.return_called then
				Result := l_char_count
			end
		end

	get_off_or_lnum (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_argp: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [PD_POS_T]
		local
			l_off___0: INTEGER_32
			js: JUMP_STATE
		do
			l_off___0 := strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_argp.item), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_argp), 10)
			if ((a_argp.item).item).to_integer_32 = 47 then
				mypos.item.lnum := l_off___0
				a_argp.item := (a_argp.item) + 1
				mypos.item.col := (strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_argp.item), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_argp), 10)).to_integer_32
				mypos.item.coladd := 0
				Result := mypos
				js.return
			end
			if not js.return_called then
				Result := (off2pos (a_buf___6, l_off___0))
			end
		end

	handle_key_queue
		local
			l_postponed: INTEGER_32
			l_node: CE_POINTER [PD_KEYQUEUE]
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_node.make

			l_postponed := 0
			from
			until
				js.loop_done
			loop
				if not l_postponed.to_boolean then
					if (not (keyHead.item.next).is_void) then
						if (keyHead.item.next).is_equal (keyHead) then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_node := keyHead.item.next
					keyHead.item.next := l_node.item.next;
					(l_node.item.next).item.prev := l_node.item.prev
					if not (l_node.item.keystr).is_void then
						if (netbeans_keystring (l_node.item.keystr)).to_boolean then
							l_tmp___0 := 0
						else
							l_tmp___0 := 1
						end
						l_postponed := l_tmp___0
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_node.item.keystr))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_node))
				end
			end
		end

	isNetbeansBuffer (a_bufp: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if nbsock.item /= -1 then
				if (a_bufp.item.b_netbeans_file).to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	isNetbeansModified (a_bufp: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_bufno: INTEGER_32
		do
			if (isNetbeansBuffer (a_bufp)).to_boolean then
				l_bufno := (nb_getbufno (a_bufp))
				if l_bufno > 0 then
					Result := ((buf_list + l_bufno).item.modified).to_integer_32
				else
					Result := 0
				end
			else
				Result := 0
			end
		end

	mapsigntype (a_buf___6: CE_POINTER [PD_NBBUF_STRUCT]; a_localsigntype: INTEGER_32): INTEGER_32
		local
			l_localsigntype: INTEGER_32
			js: JUMP_STATE
		do
			l_localsigntype := a_localsigntype
			l_localsigntype := l_localsigntype - 1
			if l_localsigntype >= 0 then
				if l_localsigntype < (a_buf___6.item.signmapused).to_integer_32 then
					Result := (a_buf___6.item.signmap[l_localsigntype])
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	messageFromNetbeans (a_clientData: CE_POINTER [ANY]; a_unused1: INTEGER_32; a_unused2: NATURAL_32)
		do
			netbeans_read
		end

	messageFromNetbeans_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent messageFromNetbeans)
		end

	nb_bufp2nbbuf_fire (a_bufp: CE_POINTER [PD_FILE_BUFFER]; a_bufnop: CE_POINTER [INTEGER_32]): CE_POINTER [PD_NBBUF_STRUCT]
		local
			l_bufno: INTEGER_32
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			js: JUMP_STATE
		do
			create l_nbbuf.make

			if nbsock.item = -1 then
				Result := (create {CE_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
				js.return
			elseif not globals_inst.netbeansFireChanges.to_boolean then
				Result := (create {CE_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_bufno := nb_getbufno (a_bufp)
				if l_bufno <= 0 then
					Result := (create {CE_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_nbbuf := nb_get_buf (l_bufno)
				if not l_nbbuf.is_void then
					if not (l_nbbuf.item.fireChanges).to_boolean then
						Result := (create {CE_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
						js.return
					end
				end
			end
			if not js.return_called then
				a_bufnop.item := l_bufno
				Result := l_nbbuf
			end
		end

	nb_do_cmd (a_bufno: INTEGER_32; a_cmd: CE_POINTER [NATURAL_8]; a_func: INTEGER_32; a_cmdno: INTEGER_32; a_args: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_args: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_doupdate: INTEGER_32
			l_off___0: INTEGER_32
			l_buf___6: CE_POINTER [PD_NBBUF_STRUCT]
			l_retval: INTEGER_32
			l_cp: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_text: CE_ARRAY [NATURAL_8]
			l_tmp___4: INTEGER_32
			l_linenum: INTEGER_32
			l_serNum: INTEGER_32
			l_len: INTEGER_32
			l_len___0: INTEGER_32
			l_nlines: INTEGER_32
			l_text___0: CE_POINTER [NATURAL_8]
			l_lno: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_line: CE_POINTER [NATURAL_8]
			l_tmp___8: INTEGER_32
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___13: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_count___2: INTEGER_32
			l_first___0: PD_POS_T
			l_last: PD_POS_T
			l_pos___3: CE_POINTER [PD_POS_T]
			l_next: CE_POINTER [PD_POS_T]
			l_del_from_lnum: INTEGER_32
			l_del_to_lnum: INTEGER_32
			l_oldFire: INTEGER_32
			l_oldSuppress: INTEGER_32
			l_wasChanged: INTEGER_32
			l_i___0: INTEGER_32
			l_id: INTEGER_32
			l_to_free: CE_POINTER [NATURAL_8]
			l_ff_detected: INTEGER_32
			l_buf_was_empty: INTEGER_32
			l_len___1: NATURAL_32
			l_added: INTEGER_32
			l_oldFire___0: INTEGER_32
			l_old_b_changed: INTEGER_32
			l_nl: CE_POINTER [NATURAL_8]
			l_lnum: INTEGER_32
			l_lnum_start: INTEGER_32
			l_pos___4: CE_POINTER [PD_POS_T]
			l_oldline: CE_POINTER [NATURAL_8]
			l_newline: CE_POINTER [NATURAL_8]
			l_savedChars: INTEGER_32
			l_path: CE_POINTER [NATURAL_8]
			l_bufp: CE_POINTER [PD_FILE_BUFFER]
			l_exarg: CE_ARRAY [PD_EXARG]
			l_prev_b_changed: INTEGER_32
			l_st: CE_ARRAY [SD_STAT]
			l_pos___5: CE_POINTER [PD_POS_T]
			l_typeNum: INTEGER_32
			l_typeName: CE_POINTER [NATURAL_8]
			l_tooltip: CE_POINTER [NATURAL_8]
			l_p___1: CE_POINTER [NATURAL_8]
			l_glyphFile: CE_POINTER [NATURAL_8]
			l_parse_error: INTEGER_32
			l_fg: CE_POINTER [NATURAL_8]
			l_bg: CE_POINTER [NATURAL_8]
			l_serNum___0: INTEGER_32
			l_localTypeNum: INTEGER_32
			l_typeNum___0: INTEGER_32
			l_pos___6: CE_POINTER [PD_POS_T]
			l_serNum___1: INTEGER_32
			l_len___2: INTEGER_32
			l_first___1: PD_POS_T
			l_last___0: PD_POS_T
			l_pos___7: CE_POINTER [PD_POS_T]
			l_un: INTEGER_32
			l_lnum___0: INTEGER_32
			l_tmp___47: INTEGER_32
			l_tmp___52: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_args.make (<<1>>)
			create l_buf___6.make
			create l_cp.make (<<1>>)
			create l_text.make (<<200>>)
			create l_text___0.make
			create l_p___0.make
			create l_line.make
			create l_tmp___9.make
			create l_tmp___12.make
			create l_tmp___13.make
			create l_tmp___14.make
			create l_first___0.make
			create l_last.make
			create l_pos___3.make
			create l_next.make
			create l_to_free.make
			create l_nl.make
			create l_pos___4.make
			create l_oldline.make
			create l_newline.make
			create l_path.make
			create l_bufp.make
			create l_exarg.make (<<1>>)
			create l_st.make (<<1>>)
			create l_pos___5.make
			create l_typeName.make
			create l_tooltip.make
			create l_p___1.make
			create l_glyphFile.make
			create l_fg.make
			create l_bg.make
			create l_pos___6.make
			create l_first___1.make
			create l_last___0.make
			create l_pos___7.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_args.item := a_args
					l_doupdate := 0
					l_off___0 := 0
					l_buf___6 := (nb_get_buf (a_bufno))
					l_retval := 1
					if not (a_func.to_boolean) then
						l_pos := -1 + 77 -- skip if block
					end
				when 1 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("getModified"))) /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_buf___6.is_void then
							l_tmp___0 := count_changed_buffers
							nb_reply_nr (a_cmdno, l_tmp___0.to_integer_32)
						elseif (l_buf___6.item.bufp).is_void then
							l_tmp___0 := count_changed_buffers
							nb_reply_nr (a_cmdno, l_tmp___0.to_integer_32)
						else
							if ((l_buf___6.item.bufp).item.b_changed).to_boolean then
								l_tmp___2 := 1
							elseif (isNetbeansModified (l_buf___6.item.bufp)).to_boolean then
								l_tmp___2 := 1
							else
								l_tmp___2 := 0
							end
							nb_reply_nr (a_cmdno, l_tmp___2.to_integer_32)
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 4 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("saveAndExit"))) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						coloncmd ([ce_string (":confirm qall")])
						nb_reply_nr (a_cmdno, (count_changed_buffers).to_integer_32)
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 7 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("getCursor"))) /= 0 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_tmp___4 := pos2off (globals_inst.curbuf, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
						sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_text), ce_string ("%%d %%ld %%d %%ld"), (nb_getbufno (globals_inst.curbuf)), globals_inst.curwin.item.w_cursor.lnum, globals_inst.curwin.item.w_cursor.col, l_tmp___4]).do_nothing
						nb_reply_text (a_cmdno, l_text)
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 10 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("getAnno"))) /= 0 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_linenum := 0
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E652: Invalid buffer identifier in getAnno"))).do_nothing
							l_retval := 0
						elseif (l_buf___6.item.bufp).is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E652: Invalid buffer identifier in getAnno"))).do_nothing
							l_retval := 0
						else
							l_cp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)
							l_serNum := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_linenum := (buffer_inst.buf_findsign (l_buf___6.item.bufp, l_serNum)).to_integer_32
						end
						nb_reply_nr (a_cmdno, l_linenum)
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 13 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("getLength"))) /= 0 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_len := 0
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E632: invalid buffer identifier in getLength"))).do_nothing
							l_retval := 0
						elseif (l_buf___6.item.bufp).is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E632: invalid buffer identifier in getLength"))).do_nothing
							l_retval := 0
						else
							l_len := get_buf_size (l_buf___6.item.bufp)
						end
						nb_reply_nr (a_cmdno, l_len)
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 16 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("getText"))) /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_text___0 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_lno := (1).to_integer_32
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E633: invalid buffer identifier in getText"))).do_nothing
							l_retval := 0
						elseif (l_buf___6.item.bufp).is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E633: invalid buffer identifier in getText"))).do_nothing
							l_retval := 0
						else
							l_len___0 := get_buf_size (l_buf___6.item.bufp)
							l_nlines := (l_buf___6.item.bufp).item.b_ml.ml_line_count
							if l_len___0 > 0 then
								l_tmp___8 := (l_len___0 + l_nlines) * 2
							else
								l_tmp___8 := 4
							end
							l_text___0 := misc2_inst.alloc (l_tmp___8.to_natural_32)
							if l_text___0.is_void then
								l_retval := 0
							else
								l_p___0 := l_text___0
								l_tmp___9 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___9.item := (('%"').code).to_natural_8
								from
								until
									not (l_lno <= l_nlines)
								loop
									l_line := nb_quote ((memline_inst.ml_get_buf (l_buf___6.item.bufp, l_lno, 0)))
									if not l_line.is_void then
										strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_line)).do_nothing
										l_p___0 := l_p___0 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_line))).to_integer_32
										l_tmp___12 := l_p___0
										l_p___0 := l_p___0 + 1
										l_tmp___12.item := (('\').code).to_natural_8
										l_tmp___13 := l_p___0
										l_p___0 := l_p___0 + 1
										l_tmp___13.item := (('n').code).to_natural_8
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_line))
									end
									l_lno := l_lno + 1
								end
								l_tmp___14 := l_p___0
								l_p___0 := l_p___0 + 1
								l_tmp___14.item := (('%"').code).to_natural_8
								l_p___0.item := (('%/0/').code).to_natural_8
							end
						end
						if l_text___0.is_void then
							nb_reply_text (a_cmdno, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")))
						else
							nb_reply_text (a_cmdno, l_text___0)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text___0))
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 19 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("remove"))) /= 0 then
							l_pos := -1 + 47 -- skip if block
						end
				when 20 then -- if:
						l_oldFire := globals_inst.netbeansFireChanges
						l_oldSuppress := globals_inst.netbeansSuppressNoLines
						if skip >= 2 then
							nb_reply_nil (a_cmdno)
							Result := 1
							js.return
						end
						if js.return_called then
							l_pos := -1 + 45 -- skip if block
						end
				when 21 then -- if:
						if not (l_buf___6.is_void) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E634: invalid buffer identifier in remove"))).do_nothing
						l_retval := 0
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 24 then -- else:
						if not ((l_buf___6.item.bufp).is_void) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E634: invalid buffer identifier in remove"))).do_nothing
						l_retval := 0
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 27 then -- else:
						globals_inst.netbeansFireChanges := 0
						globals_inst.netbeansSuppressNoLines := 1
						nb_set_curbuf (l_buf___6.item.bufp)
						l_wasChanged := (l_buf___6.item.bufp).item.b_changed
						l_cp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)
						l_off___0 := strtol (l_cp.item, l_cp, 10)
						l_count___2 := strtol (l_cp.item, l_cp, 10)
						l_args.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_cp.item)
						l_pos___3 := off2pos (l_buf___6.item.bufp, l_off___0)
						if l_pos___3.is_void then
							nb_reply_text (a_cmdno, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("!bad position")))
							globals_inst.netbeansFireChanges := l_oldFire
							globals_inst.netbeansSuppressNoLines := l_oldSuppress
							Result := 0
							js.return
						end
						if not js.return_called then
							l_first___0 := (l_pos___3.item).twin
							l_pos___3 := off2pos (l_buf___6.item.bufp, (l_off___0 + l_count___2) - 1)
							if l_pos___3.is_void then
								nb_reply_text (a_cmdno, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("!bad count")))
								globals_inst.netbeansFireChanges := l_oldFire
								globals_inst.netbeansSuppressNoLines := l_oldSuppress
								Result := 0
								js.return
							end
						end
						if js.return_called then
							l_pos := -1 + 45 -- skip if block
						end
				when 28 then -- if:
						l_last := (l_pos___3.item).twin
						l_del_from_lnum := l_first___0.lnum
						l_del_to_lnum := l_last.lnum
						l_doupdate := 1
						l_next := off2pos (l_buf___6.item.bufp, l_off___0 + l_count___2)
						if l_first___0.col = 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						l_pos := -1 + 33 -- goto _L___0
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 31 then -- else:
						if l_next.is_void then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if:
						if l_first___0.lnum /= l_next.item.lnum then
							l_pos := -1 + 44 -- skip if block
						end
				when 33 then -- if: | _L___0:
						if l_first___0.lnum = l_last.lnum then
							l_pos := -1 + 36 -- skip if block
						end
				when 34 then -- if:
						l_pos := -1 + 38 -- goto _L
				when 35 then -- if block done, skip else block:
						l_pos := -1 + 43
				when 36 then -- else:
						if l_next.is_void then
							l_pos := -1 + 42 -- skip if block
						end
				when 37 then -- if:
						if l_first___0.lnum = l_next.item.lnum then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if: | _L:
						nb_partialremove (l_first___0.lnum, l_first___0.col, (2_147_483_647).to_integer_32)
						if l_first___0.lnum = l_last.lnum then
							nb_joinlines (l_first___0.lnum, l_next.item.lnum)
							l_del_to_lnum := l_next.item.lnum
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 41
				when 40 then -- else:
						nb_partialremove (l_first___0.lnum, l_first___0.col, l_last.col)
				when 41 then -- if done | if block done, skip else block:
						l_pos := -1 + 43
				when 42 then -- else:
						nb_partialremove (l_first___0.lnum, l_first___0.col, l_last.col)
				when 43 then -- if done
						l_del_from_lnum := l_del_from_lnum + 1
				when 44 then -- if done | if done
						if l_first___0.lnum /= l_last.lnum then
							if not l_next.is_void then
								if l_next.item.col /= 0 then
									if l_last.lnum = l_next.item.lnum then
										nb_partialremove (l_last.lnum, 0, l_last.col)
										if l_del_from_lnum > l_first___0.lnum then
											nb_joinlines (l_first___0.lnum, l_last.lnum)
										else
											l_del_to_lnum := l_del_to_lnum - 1
										end
									end
								end
							end
						end
						if l_first___0.lnum /= l_last.lnum then
							if l_del_from_lnum > l_first___0.lnum then
								if not l_next.is_void then
									if l_last.lnum /= l_next.item.lnum then
										nb_joinlines (l_first___0.lnum, l_next.item.lnum)
										l_del_to_lnum := l_next.item.lnum
									end
								end
							end
						end
						if l_del_to_lnum >= l_del_from_lnum then
							l_i___0 := l_del_from_lnum.to_integer_32
							from
							until
								not (l_i___0.to_integer_32 <= l_del_to_lnum)
							loop
								l_id := (buffer_inst.buf_findsign_id (l_buf___6.item.bufp, l_i___0.to_integer_32))
								if l_id > 0 then
									buffer_inst.buf_delsign (l_buf___6.item.bufp, l_id).do_nothing
								end
								l_i___0 := l_i___0 + 1
							end
							globals_inst.curwin.item.w_cursor.lnum := l_del_from_lnum
							globals_inst.curwin.item.w_cursor.col := 0
							misc1_inst.del_lines ((l_del_to_lnum - l_del_from_lnum) + 1, 0)
						end
						globals_inst.curwin.item.w_cursor := l_first___0.twin
						misc2_inst.check_cursor_lnum;
						(l_buf___6.item.bufp).item.b_changed := l_wasChanged
						globals_inst.netbeansFireChanges := l_oldFire
						globals_inst.netbeansSuppressNoLines := l_oldSuppress
						undo_inst.u_blockfree (l_buf___6.item.bufp)
						undo_inst.u_clearall (l_buf___6.item.bufp)
				when 45 then -- if done | if done | if done | if done
						if not js.return_called then
							nb_reply_nil (a_cmdno)
						end
				when 46 then -- if block done, skip else block:
						l_pos := -1 + 76
				when 47 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("insert"))) /= 0 then
							l_pos := -1 + 75 -- skip if block
						end
				when 48 then -- if:
						if skip >= 2 then
							nb_reply_nil (a_cmdno)
							Result := 1
							js.return
						end
						if js.return_called then
							l_pos := -1 + 74 -- skip if block
						end
				when 49 then -- if:
						l_cp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)
						l_off___0 := strtol (l_cp.item, l_cp, 10)
						l_args.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_cp.item)
						l_args.item := charset_inst.skipwhite (l_args.item)
						l_to_free := create {CE_POINTER [NATURAL_8]}.make_cast ((nb_unquote (l_args.item, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))))
						l_args.item := l_to_free
						if not (l_buf___6.is_void) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E635: invalid buffer identifier in insert"))).do_nothing
						l_retval := 0
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 52 then -- else:
						if not ((l_buf___6.item.bufp).is_void) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E635: invalid buffer identifier in insert"))).do_nothing
						l_retval := 0
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 73
				when 55 then -- else:
						if (l_args.item).is_void then
							l_pos := -1 + 73 -- skip if block
						end
				when 56 then -- if:
						l_ff_detected := -1
						l_buf_was_empty := ((l_buf___6.item.bufp).item.b_ml.ml_flags).bit_and (1)
						l_len___1 := (0).to_natural_32
						l_added := 0
						l_oldFire___0 := globals_inst.netbeansFireChanges
						globals_inst.netbeansFireChanges := 0
						nb_set_curbuf (l_buf___6.item.bufp)
						l_old_b_changed := globals_inst.curbuf.item.b_changed
						l_pos___4 := off2pos (globals_inst.curbuf, l_off___0)
						if not l_pos___4.is_void then
							if l_pos___4.item.lnum <= 0 then
								l_lnum_start := (1).to_integer_32
							else
								l_lnum_start := l_pos___4.item.lnum
							end
						elseif l_buf_was_empty.to_boolean then
							l_lnum_start := (1).to_integer_32
						else
							l_lnum_start := globals_inst.curbuf.item.b_ml.ml_line_count + 1
						end
						l_lnum := l_lnum_start
						l_doupdate := 1
				when 57 then -- loop condition:
						if not (not js.loop_done and then ((l_args.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 72 -- skip loop
						end
				when 58 then -- loop body:
						l_nl := misc2_inst.vim_strchr (l_args.item, ('%N').code)
						if l_nl.is_void then
							l_len___1 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item))
						else
							l_len___1 := (l_nl.distance ((l_args.item))).to_natural_32
							if (l_nl.c_pointer.to_integer_32).to_natural_32 > ((l_args.item).c_pointer.to_integer_32).to_natural_32 then
								if (l_nl[-1]).to_integer_32 = 13 then
									l_ff_detected := 1
									l_len___1 := l_len___1 - 1
								else
									l_ff_detected := 0
								end
							else
								l_ff_detected := 0
							end
						end
						l_args.item[l_len___1.to_integer_32] := (('%/0/').code).to_natural_8
						if l_lnum /= l_lnum_start then
							l_pos := -1 + 70 -- skip if block
						end
				when 59 then -- if:
						if l_pos___4.is_void then
							l_pos := -1 + 62 -- skip if block
						end
				when 60 then -- if:
						if l_pos___4.item.col > 0 then
							l_pos := -1 + 64 -- goto _L___1
						else
							l_pos := -1 + 62 -- goto _L___2
						end
				when 61 then -- if block done, skip else block:
						l_pos := -1 + 69
				when 62 then -- else: | _L___2:
						if l_lnum /= 1 then
							l_pos := -1 + 68 -- skip if block
						end
				when 63 then -- if:
						if not (l_buf_was_empty.to_boolean) then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if: | _L___1:
						l_oldline := (memline_inst.ml_get (l_lnum))
						l_newline := misc2_inst.alloc_check (((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldline))) + l_len___1) + {NATURAL_32} 1)
						if not l_newline.is_void then
							strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_newline), create {CE_POINTER [INTEGER_8]}.make_cast (l_oldline)).do_nothing
							strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_newline), create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)).do_nothing
							memline_inst.ml_replace (l_lnum, l_newline, 0).do_nothing
						end
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 67
				when 66 then -- else:
						memline_inst.ml_append (l_lnum - 1, l_args.item, (l_len___1 + {NATURAL_32} 1).to_integer_32, 0).do_nothing
						l_added := l_added + 1
				when 67 then -- if done | if block done, skip else block:
						l_pos := -1 + 69
				when 68 then -- else:
						memline_inst.ml_append (l_lnum - 1, l_args.item, (l_len___1 + {NATURAL_32} 1).to_integer_32, 0).do_nothing
						l_added := l_added + 1
				when 69 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 71
				when 70 then -- else:
						memline_inst.ml_append (l_lnum - 1, l_args.item, (l_len___1 + {NATURAL_32} 1).to_integer_32, 0).do_nothing
						l_added := l_added + 1
				when 71 then
						if l_nl.is_void then
							js.break
						end
						if not js.loop_jumped then
							l_lnum := l_lnum + 1
							l_args.item := l_nl + 1
						end
						l_pos := -1 + 57 -- back to loop condition
				when 72 then -- loop done
						misc1_inst.appended_lines_mark (l_lnum_start - 1, l_added.to_integer_32)
						if l_buf_was_empty.to_boolean then
							if l_ff_detected = -1 then
								l_ff_detected := 0
							end
							misc2_inst.set_fileformat (l_ff_detected, 4)
							globals_inst.curbuf.item.b_start_ffc := ((globals_inst.curbuf.item.b_p_ff).item).to_integer_32
						end
						globals_inst.curbuf.item.b_changed := l_old_b_changed
						globals_inst.netbeansFireChanges := l_oldFire___0
						undo_inst.u_blockfree (globals_inst.curbuf)
						undo_inst.u_clearall (globals_inst.curbuf)
				when 73 then -- if done | if done | if done
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_to_free))
						nb_reply_nil (a_cmdno)
				when 74 then -- if done | if block done, skip else block:
						l_pos := -1 + 76
				when 75 then -- else:
						nb_reply_nil (a_cmdno)
						l_retval := 0
				when 76 then -- if done | if done | if done | if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 169
				when 77 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("create"))) /= 0 then
							l_pos := -1 + 80 -- skip if block
						end
				when 78 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E636: invalid buffer identifier in create"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6.item.displayname))
							l_buf___6.item.displayname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							globals_inst.netbeansReadFile := 0
							ex_cmds_inst.do_ecmd (0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 5, globals_inst.curwin).do_nothing
							globals_inst.netbeansReadFile := 1
							l_buf___6.item.bufp := globals_inst.curbuf
							buffer_inst.maketitle
							l_buf___6.item.insertDone := {NATURAL_32} 0
							if (gui_inst.gui.item.in_use).to_boolean then
								menu_inst.gui_update_menus (0)
							end
						end
				when 79 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 80 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("insertDone"))) /= 0 then
							l_pos := -1 + 83 -- skip if block
						end
				when 81 then -- if:
						if not (l_buf___6.is_void) then
							if not ((l_buf___6.item.bufp).is_void) then
								(l_buf___6.item.bufp).item.b_start_eol := ((l_args.item.item).to_integer_32 = 84).to_integer
								l_buf___6.item.insertDone := {NATURAL_32} 1
								l_args.item := l_args.item + (2);
								(l_buf___6.item.bufp).item.b_p_ro := ((l_args.item.item).to_integer_32 = 84).to_integer
								print_read_msg (l_buf___6)
							end
						end
				when 82 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 83 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("saveDone"))) /= 0 then
							l_pos := -1 + 86 -- skip if block
						end
				when 84 then -- if:
						l_savedChars := (atol (create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)))
						if not (l_buf___6.is_void) then
							if not ((l_buf___6.item.bufp).is_void) then
								print_save_msg (l_buf___6, l_savedChars)
							end
						end
				when 85 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 86 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("startDocumentListen"))) /= 0 then
							l_pos := -1 + 89 -- skip if block
						end
				when 87 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E637: invalid buffer identifier in startDocumentListen"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_buf___6.item.fireChanges := {NATURAL_32} 1
						end
				when 88 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 89 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("stopDocumentListen"))) /= 0 then
							l_pos := -1 + 92 -- skip if block
						end
				when 90 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E638: invalid buffer identifier in stopDocumentListen"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_buf___6.item.fireChanges := {NATURAL_32} 0
							if not (l_buf___6.item.bufp).is_void then
								if ((l_buf___6.item.bufp).item.b_was_netbeans_file).to_boolean then
									if not ((l_buf___6.item.bufp).item.b_netbeans_file).to_boolean then
										misc2_inst.emsgn (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E658: NetBeans connection lost for buffer %%ld")))), ((l_buf___6.item.bufp).item.b_fnum).to_integer_32).do_nothing
									else
										buffer_inst.do_bufdel (3, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 1, (l_buf___6.item.bufp).item.b_fnum, (l_buf___6.item.bufp).item.b_fnum, 1).do_nothing
										memset (create {CE_POINTER [ANY]}.make_cast (l_buf___6), 0, (create {PD_NBBUF_STRUCT}.make).structure_size.to_natural_32).do_nothing
									end
								end
							end
						end
				when 91 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 92 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setTitle"))) /= 0 then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E639: invalid buffer identifier in setTitle"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6.item.displayname))
							l_buf___6.item.displayname := nb_unquote (l_args.item, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
						end
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 95 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("initDone"))) /= 0 then
							l_pos := -1 + 98 -- skip if block
						end
				when 96 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E640: invalid buffer identifier in initDone"))).do_nothing
							Result := 0
							js.return
						elseif (l_buf___6.item.bufp).is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E640: invalid buffer identifier in initDone"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_doupdate := 1
							l_buf___6.item.initDone := {NATURAL_32} 1
							nb_set_curbuf (l_buf___6.item.bufp)
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFREADPOST, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, l_buf___6.item.bufp).do_nothing
							handle_key_queue
						end
				when 97 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 98 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setBufferNumber"))) /= 0 then
							l_pos := -1 + 101 -- skip if block
						end
				when 99 then -- if:
						l_pos := -1 + 102 -- goto _L___7
				when 100 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 101 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("putBufferNumber"))) /= 0 then
							l_pos := -1 + 104 -- skip if block
						end
				when 102 then -- if: | _L___7:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E641: invalid buffer identifier in setBufferNumber"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_path := create {CE_POINTER [NATURAL_8]}.make_cast ((nb_unquote (l_args.item, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))))
							if l_path.is_void then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_bufp := buffer_inst.buflist_findname (l_path)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_path))
							if l_bufp.is_void then
								message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E642: File %%s not found in setBufferNumber")), l_args.item).do_nothing
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							l_buf___6.item.bufp := l_bufp
							l_buf___6.item.nbbuf_number := l_bufp.item.b_fnum
							if (a_cmd.item).to_integer_32 /= 112 then
								coloncmd ([ce_string (":buffer %%d"), l_bufp.item.b_fnum])
							else
								l_buf___6.item.initDone := {NATURAL_32} 1
								handle_key_queue
							end
						end
				when 103 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 104 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setFullName"))) /= 0 then
							l_pos := -1 + 107 -- skip if block
						end
				when 105 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E643: invalid buffer identifier in setFullName"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6.item.displayname))
							l_buf___6.item.displayname := nb_unquote (l_args.item, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
							globals_inst.netbeansReadFile := 0
							ex_cmds_inst.do_ecmd (0, create {CE_POINTER [NATURAL_8]}.make_cast (l_buf___6.item.displayname), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 5, globals_inst.curwin).do_nothing
							globals_inst.netbeansReadFile := 1
							l_buf___6.item.bufp := globals_inst.curbuf
							buffer_inst.maketitle
							if (gui_inst.gui.item.in_use).to_boolean then
								menu_inst.gui_update_menus (0)
							end
						end
				when 106 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 107 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("editFile"))) /= 0 then
							l_pos := -1 + 110 -- skip if block
						end
				when 108 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E644: invalid buffer identifier in editFile"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6.item.displayname))
							l_buf___6.item.displayname := nb_unquote (l_args.item, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
							ex_cmds_inst.do_ecmd (0, create {CE_POINTER [NATURAL_8]}.make_cast (l_buf___6.item.displayname), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (1).to_integer_32, 5, globals_inst.curwin).do_nothing
							l_buf___6.item.bufp := globals_inst.curbuf
							l_buf___6.item.initDone := {NATURAL_32} 1
							l_doupdate := 1
							buffer_inst.maketitle
							if (gui_inst.gui.item.in_use).to_boolean then
								menu_inst.gui_update_menus (0)
							end
						end
				when 109 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 110 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setVisible"))) /= 0 then
							l_pos := -1 + 118 -- skip if block
						end
				when 111 then -- if:
						if not (l_buf___6.is_void) then
							l_pos := -1 + 114 -- skip if block
						end
				when 112 then -- if:
						l_pos := -1 + 115 -- goto _L___3
				when 113 then -- if block done, skip else block:
						l_pos := -1 + 116
				when 114 then -- else:
						if not ((l_buf___6.item.bufp).is_void) then
							l_pos := -1 + 116 -- skip if block
						end
				when 115 then -- if: | _L___3:
						if option_inst.p_verbose.item > 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E645: invalid buffer identifier in setVisible"))).do_nothing
						end
						Result := 0
						js.return
				when 116 then -- if done
						if not js.return_called then
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item), ce_string ("T"))) = 0 then
								if not (l_buf___6.item.bufp).is_equal (globals_inst.curbuf) then
									l_exarg.item.cmd := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("goto"))
									l_exarg.item.forceit := 0
									dosetvisible := 1
									buffer_inst.goto_buffer (l_exarg, 1, 1, (l_buf___6.item.bufp).item.b_fnum)
									l_doupdate := 1
									dosetvisible := 0
									if (gui_inst.gui.item.in_use).to_boolean then
										gui_gtk_x11_inst.gui_mch_set_foreground
									end
								end
							end
						end
				when 117 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 118 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("raise"))) /= 0 then
							l_pos := -1 + 121 -- skip if block
						end
				when 119 then -- if:
						if (gui_inst.gui.item.in_use).to_boolean then
							gui_gtk_x11_inst.gui_mch_set_foreground
						end
				when 120 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 121 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setModified"))) /= 0 then
							l_pos := -1 + 129 -- skip if block
						end
				when 122 then -- if:
						if not (l_buf___6.is_void) then
							l_pos := -1 + 125 -- skip if block
						end
				when 123 then -- if:
						l_pos := -1 + 126 -- goto _L___4
				when 124 then -- if block done, skip else block:
						l_pos := -1 + 127
				when 125 then -- else:
						if not ((l_buf___6.item.bufp).is_void) then
							l_pos := -1 + 127 -- skip if block
						end
				when 126 then -- if: | _L___4:
						if option_inst.p_verbose.item > 0 then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E646: invalid buffer identifier in setModified"))).do_nothing
						end
						Result := 0
						js.return
				when 127 then -- if done
						if not js.return_called then
							l_prev_b_changed := (l_buf___6.item.bufp).item.b_changed
							if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item), ce_string ("T"))) = 0 then
								(l_buf___6.item.bufp).item.b_changed := 1
							else
								if not ((l_buf___6.item.bufp).item.b_ffname).is_void then
									if (stat (create {CE_POINTER [INTEGER_8]}.make_cast ((l_buf___6.item.bufp).item.b_ffname), l_st)) >= 0 then
										fileio_inst.buf_store_time (l_buf___6.item.bufp, l_st, (l_buf___6.item.bufp).item.b_ffname)
									end
								end
								(l_buf___6.item.bufp).item.b_changed := 0
							end
							l_buf___6.item.modified := ((l_buf___6.item.bufp).item.b_changed).to_natural_32
							if l_prev_b_changed /= (l_buf___6.item.bufp).item.b_changed then
								misc1_inst.check_status (l_buf___6.item.bufp)
								globals_inst.redraw_tabline := 1
								buffer_inst.maketitle
								screen_inst.update_screen (0)
							end
						end
				when 128 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 129 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setModtime"))) /= 0 then
							l_pos := -1 + 132 -- skip if block
						end
				when 130 then -- if:
						if not (l_buf___6.is_void) then
							if not ((l_buf___6.item.bufp).is_void) then
								(l_buf___6.item.bufp).item.b_mtime := (atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item))).to_integer_32
							end
						end
				when 131 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 132 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setReadOnly"))) /= 0 then
							l_pos := -1 + 135 -- skip if block
						end
				when 133 then -- if:
						if not (l_buf___6.is_void) then
							if not ((l_buf___6.item.bufp).is_void) then
								if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item), ce_string ("T"))) = 0 then
									(l_buf___6.item.bufp).item.b_p_ro := 1
								else
									(l_buf___6.item.bufp).item.b_p_ro := 0
								end
							end
						end
				when 134 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 135 then -- else:
						if ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setMark"))) = 0) then
							l_pos := -1 + 169 -- skip if block
						end
				when 136 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("showBalloon"))) /= 0 then
							l_pos := -1 + 139 -- skip if block
						end
				when 137 then -- if:
						if not globals_inst.balloonEval.is_void then
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (text___1))
							text___1 := nb_unquote (l_args.item, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))
							if not text___1.is_void then
								gui_beval_inst.gui_mch_post_balloon (globals_inst.balloonEval, create {CE_POINTER [NATURAL_8]}.make_cast (text___1))
							end
						end
				when 138 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 139 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setDot"))) /= 0 then
							l_pos := -1 + 147 -- skip if block
						end
				when 140 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E647: invalid buffer identifier in setDot"))).do_nothing
							Result := 0
							js.return
						elseif (l_buf___6.item.bufp).is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E647: invalid buffer identifier in setDot"))).do_nothing
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 146 -- skip if block
						end
				when 141 then -- if:
						nb_set_curbuf (l_buf___6.item.bufp)
						if globals_inst.VIsual_active.to_boolean then
							normal_inst.end_visual_mode
						end
						l_pos___5 := get_off_or_lnum (l_buf___6.item.bufp, l_args)
						if (not l_pos___5.is_void) then
							globals_inst.curwin.item.w_cursor := (l_pos___5.item).twin
							misc2_inst.check_cursor
							fold_inst.foldOpenCursor
						end
						move_inst.update_topline
						screen_inst.update_screen (10)
						screen_inst.setcursor
						term_inst.out_flush
						if (gui_inst.gui.item.in_use).to_boolean then
							gui_inst.gui_update_cursor (1, 0)
							gui_gtk_x11_inst.gui_mch_flush
						end
						if globals_inst.State /= 513 then
							l_pos := -1 + 144 -- skip if block
						end
				when 142 then -- if:
						l_pos := -1 + 145 -- goto _L___5
				when 143 then -- if block done, skip else block:
						l_pos := -1 + 146
				when 144 then -- else:
						if globals_inst.State /= 768 then
							l_pos := -1 + 146 -- skip if block
						end
				when 145 then -- if: | _L___5:
						if (gui_inst.gui.item.in_use).to_boolean then
							if (gtk_main_level) > {NATURAL_32} 0 then
								gtk_main_quit
							end
						end
				when 146 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 169
				when 147 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("close"))) /= 0 then
							l_pos := -1 + 150 -- skip if block
						end
				when 148 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E648: invalid buffer identifier in close"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							if (l_buf___6.item.bufp).is_void then
								if option_inst.p_verbose.item > 0 then
									message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E649: invalid buffer identifier in close"))).do_nothing
								end
							end
							globals_inst.need_mouse_correct := 1
							if not (l_buf___6.item.bufp).is_void then
								buffer_inst.do_buffer (4, 1, 1, (l_buf___6.item.bufp).item.b_fnum, 1).do_nothing
							end
							l_buf___6.item.bufp := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
							l_buf___6.item.initDone := {NATURAL_32} 0
							l_doupdate := 1
						end
				when 149 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 150 then -- else:
						if ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setStyle"))) = 0) then
							l_pos := -1 + 169 -- skip if block
						end
				when 151 then -- if:
						if ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("setExitDelay"))) = 0) then
							l_pos := -1 + 169 -- skip if block
						end
				when 152 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("defineAnnoType"))) /= 0 then
							l_pos := -1 + 155 -- skip if block
						end
				when 153 then -- if:
						l_parse_error := 0
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E650: invalid buffer identifier in defineAnnoType"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_cp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)
							l_typeNum := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_args.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_cp.item)
							l_args.item := charset_inst.skipwhite (l_args.item)
							l_typeName := create {CE_POINTER [NATURAL_8]}.make_cast ((nb_unquote (l_args.item, l_args)))
							l_args.item := charset_inst.skipwhite (l_args.item + 1)
							l_tooltip := create {CE_POINTER [NATURAL_8]}.make_cast ((nb_unquote (l_args.item, l_args)))
							l_args.item := charset_inst.skipwhite (l_args.item + 1)
							l_p___1 := create {CE_POINTER [NATURAL_8]}.make_cast ((nb_unquote (l_args.item, l_args)))
							l_glyphFile := misc2_inst.vim_strsave_escaped (l_p___1, globals_inst.escape_chars)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___1))
							l_args.item := charset_inst.skipwhite (l_args.item + 1)
							l_p___1 := charset_inst.skiptowhite (l_args.item)
							if (l_p___1.item).to_integer_32 /= 0 then
								l_p___1.item := (('%/0/').code).to_natural_8
								l_p___1 := charset_inst.skipwhite (l_p___1 + 1)
							end
							l_fg := misc2_inst.vim_strsave (l_args.item)
							l_bg := misc2_inst.vim_strsave (l_p___1)
							if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_fg))) > {NATURAL_32} 32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E532: highlighting color name too long in defineAnnoType"))).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_typeName))
								l_parse_error := 1
							elseif (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_bg))) > {NATURAL_32} 32 then
								message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E532: highlighting color name too long in defineAnnoType"))).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_typeName))
								l_parse_error := 1
							elseif not l_typeName.is_void then
								if not l_tooltip.is_void then
									if not l_glyphFile.is_void then
										addsigntype (l_buf___6, l_typeNum, l_typeName, l_tooltip, l_glyphFile, l_fg, l_bg)
									else
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_typeName))
									end
								else
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_typeName))
								end
							else
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_typeName))
							end
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_fg))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_bg))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_tooltip))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_glyphFile))
							if l_parse_error.to_boolean then
								Result := 0
								js.return
							end
						end
				when 154 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 155 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("addAnno"))) /= 0 then
							l_pos := -1 + 158 -- skip if block
						end
				when 156 then -- if:
						if l_buf___6.is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E651: invalid buffer identifier in addAnno"))).do_nothing
							Result := 0
							js.return
						elseif (l_buf___6.item.bufp).is_void then
							message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E651: invalid buffer identifier in addAnno"))).do_nothing
							Result := 0
							js.return
						end
						if not js.return_called then
							l_doupdate := 1
							l_cp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)
							l_serNum___0 := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_localTypeNum := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_args.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_cp.item)
							l_typeNum___0 := mapsigntype (l_buf___6, l_localTypeNum)
							l_pos___6 := get_off_or_lnum (l_buf___6.item.bufp, l_args)
							l_cp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)
							globals_inst.ignored := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_args.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_cp.item)
							if l_serNum___0 >= 1_000_000 then
								Result := 0
								js.return
							end
						end
						if not js.return_called and then (not l_pos___6.is_void) then
							coloncmd ([ce_string (":sign place %%d line=%%ld name=%%d buffer=%%d"), l_serNum___0, l_pos___6.item.lnum, l_typeNum___0, (l_buf___6.item.bufp).item.b_fnum])
							if l_typeNum___0 = curPCtype then
								coloncmd ([ce_string (":sign jump %%d buffer=%%d"), l_serNum___0, (l_buf___6.item.bufp).item.b_fnum])
							end
						end
				when 157 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 158 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("removeAnno"))) /= 0 then
							l_pos := -1 + 161 -- skip if block
						end
				when 159 then -- if:
						if l_buf___6.is_void then
							Result := 0
							js.return
						elseif (l_buf___6.item.bufp).is_void then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_doupdate := 1
							l_cp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)
							l_serNum___1 := (strtol (l_cp.item, l_cp, 10)).to_integer_32
							l_args.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_cp.item)
							coloncmd ([ce_string (":sign unplace %%d buffer=%%d"), l_serNum___1, (l_buf___6.item.bufp).item.b_fnum])
							screen_inst.redraw_buf_later (l_buf___6.item.bufp, 40)
						end
				when 160 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 161 then -- else:
						if ((strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("moveAnnoToFront"))) = 0) then
							l_pos := -1 + 169 -- skip if block
						end
				when 162 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("guard"))) /= 0 then
							l_pos := -1 + 165 -- skip if block
						end
				when 163 then -- if:
						l_pos := -1 + 166 -- goto _L___6
				when 164 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 165 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("unguard"))) /= 0 then
							l_pos := -1 + 168 -- skip if block
						end
				when 166 then -- if: | _L___6:
						l_un := ((a_cmd[0]).to_integer_32 = 117).to_integer
						if skip >= 2 then
							Result := 1
							js.return
						end
						if not js.return_called then
							nb_init_graphics
							if l_buf___6.is_void then
								Result := 0
								js.return
							elseif (l_buf___6.item.bufp).is_void then
								Result := 0
								js.return
							end
						end
						if not js.return_called then
							nb_set_curbuf (l_buf___6.item.bufp)
							l_cp.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_args.item)
							l_off___0 := strtol (l_cp.item, l_cp, 10)
							l_len___2 := (strtol (l_cp.item, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)).to_integer_32
							l_args.item := create {CE_POINTER [NATURAL_8]}.make_cast (l_cp.item)
							l_pos___7 := off2pos (l_buf___6.item.bufp, l_off___0)
							l_doupdate := 1
							if (not l_pos___7.is_void) then
								l_first___1 := (l_pos___7.item).twin
								l_pos___7 := off2pos (l_buf___6.item.bufp, (l_off___0 + l_len___2.to_integer_32) - 1)
								if not l_pos___7.is_void then
									if l_pos___7.item.col = 0 then
										l_pos___7 := off2pos (l_buf___6.item.bufp, (l_off___0 + l_len___2.to_integer_32) - 2)
									end
								end
								if (not l_pos___7.is_void) then
									l_last___0 := (l_pos___7.item).twin
									l_lnum___0 := l_first___1.lnum
									from
									until
										not (l_lnum___0 <= l_last___0.lnum)
									loop
										if not l_un.to_boolean then
											if (buffer_inst.buf_findsigntype_id (l_buf___6.item.bufp, l_lnum___0, 10_000)) = 0 then
												l_tmp___47 := guardId
												guardId := guardId + 1
												coloncmd ([ce_string (":sign place %%d line=%%ld name=%%d buffer=%%d"), l_tmp___47, l_lnum___0, 10_000, (l_buf___6.item.bufp).item.b_fnum])
											end
										end
										l_lnum___0 := l_lnum___0 + 1
									end
									screen_inst.redraw_buf_later (l_buf___6.item.bufp, 40)
								end
							end
						end
				when 167 then -- if block done, skip else block:
						l_pos := -1 + 169
				when 168 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("startAtomic"))) = 0 then
							inAtomic := 1
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("endAtomic"))) = 0 then
							inAtomic := 0
							if needupdate.to_boolean then
								l_doupdate := 1
								needupdate := 0
							end
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("save"))) = 0 then
							if l_buf___6.is_void then
								Result := 0
								js.return
							elseif (l_buf___6.item.bufp).is_void then
								Result := 0
								js.return
							end
							if not js.return_called then
								if (undo_inst.bufIsChanged (l_buf___6.item.bufp)).to_boolean then
									if (option_inst.p_write.item).to_boolean then
										if not ((l_buf___6.item.bufp).item.b_p_ro).to_boolean then
											if not ((l_buf___6.item.bufp).item.b_ffname).is_void then
												if not (quickfix_inst.bt_dontwrite (l_buf___6.item.bufp)).to_boolean then
													ex_cmds2_inst.buf_write_all (l_buf___6.item.bufp, 0).do_nothing
													if not (buffer_inst.buf_valid (l_buf___6.item.bufp)).to_boolean then
														l_buf___6.item.bufp := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
													end
												end
											end
										end
									end
								end
							end
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("netbeansBuffer"))) = 0 then
							if l_buf___6.is_void then
								Result := 0
								js.return
							elseif (l_buf___6.item.bufp).is_void then
								Result := 0
								js.return
							end
							if not js.return_called then
								if (l_args.item.item).to_integer_32 = 84 then
									(l_buf___6.item.bufp).item.b_netbeans_file := 1;
									(l_buf___6.item.bufp).item.b_was_netbeans_file := 1
								else
									(l_buf___6.item.bufp).item.b_netbeans_file := 0
								end
							end
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("specialKeys"))) = 0 then
							special_keys___0 (l_args.item)
						elseif (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("actionMenuItem"))) /= 0 then
							l_tmp___52 := strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("version"))
						end
				when 169 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done | if done
						if js.return_called then
							l_pos := -1 + 179 -- skip if block
						end
				when 170 then -- if:
							if inAtomic.to_boolean then
								if l_doupdate.to_boolean then
									needupdate := 1
									l_doupdate := 0
								end
							end
							if l_buf___6.is_void then
								l_pos := -1 + 178 -- skip if block
							end
				when 171 then -- if:
							if not ((l_buf___6.item.initDone).to_boolean) then
								l_pos := -1 + 178 -- skip if block
							end
				when 172 then -- if:
							if not (l_doupdate.to_boolean) then
								l_pos := -1 + 178 -- skip if block
							end
				when 173 then -- if:
							screen_inst.update_screen (40)
							screen_inst.setcursor
							term_inst.out_flush
							if (gui_inst.gui.item.in_use).to_boolean then
								gui_inst.gui_update_cursor (1, 0)
								gui_gtk_x11_inst.gui_mch_flush
							end
							if globals_inst.State /= 513 then
								l_pos := -1 + 176 -- skip if block
							end
				when 174 then -- if:
							l_pos := -1 + 177 -- goto _L___8
				when 175 then -- if block done, skip else block:
							l_pos := -1 + 178
				when 176 then -- else:
							if globals_inst.State /= 768 then
								l_pos := -1 + 178 -- skip if block
							end
				when 177 then -- if: | _L___8:
							if (gui_inst.gui.item.in_use).to_boolean then
								if (gtk_main_level) > {NATURAL_32} 0 then
									gtk_main_quit
								end
							end
				when 178 then -- if done | if done | if done | if done
							Result := l_retval
				when 179 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	nb_free
		local
			l_key_node: CE_POINTER [PD_KEYQUEUE]
			l_cmd_node: CE_POINTER [PD_CMDQUEUE]
			l_buf___6: PD_NBBUF_STRUCT
			l_bufp: CE_POINTER [PD_FILE_BUFFER]
			l_i___0: INTEGER_32
			l_next: CE_POINTER [PD_KEYQUEUE]
			l_next___0: CE_POINTER [PD_CMDQUEUE]
			js: JUMP_STATE
		do
			create l_key_node.make
			create l_cmd_node.make
			create l_buf___6.make
			create l_bufp.make
			create l_next.make
			create l_next___0.make

			l_key_node := keyHead.item.next
			l_cmd_node := head.item.next
			l_i___0 := 0
			from
			until
				not (l_i___0 < buf_list_used)
			loop
				l_buf___6 := (buf_list[l_i___0]).twin
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6.displayname))
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6.signmap))
				l_bufp := l_buf___6.bufp
				if not l_bufp.is_void then
					(l_buf___6.bufp).item.b_netbeans_file := 0;
					(l_buf___6.bufp).item.b_was_netbeans_file := 0
				end
				l_i___0 := l_i___0 + 1
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (buf_list))
			buf_list := create {CE_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer)
			buf_list_size := 0
			buf_list_used := 0
			from
			until
				js.loop_done
			loop
				if not l_key_node.is_void then
					if l_key_node.is_equal (keyHead) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_next := l_key_node.item.next
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_key_node.item.keystr))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_key_node))
					if l_next.is_equal (keyHead) then
						keyHead.item.next := keyHead
						keyHead.item.prev := keyHead
						js.break
					end
				end
				if not js.loop_jumped then
					l_key_node := l_next
				end
			end
			from
			until
				js.loop_done
			loop
				if not l_cmd_node.is_void then
					if l_cmd_node.is_equal (head) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_next___0 := l_cmd_node.item.next
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd_node.item.buffer))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_cmd_node))
					if l_next___0.is_equal (head) then
						head.item.next := head
						head.item.prev := head
						js.break
					end
				end
				if not js.loop_jumped then
					l_cmd_node := l_next___0
				end
			end
		end

	nb_get_buf (a_bufno: INTEGER_32): CE_POINTER [PD_NBBUF_STRUCT]
		local
			l_incr: INTEGER_32
			js: JUMP_STATE
		do
			if a_bufno <= 0 then
				Result := (create {CE_POINTER [PD_NBBUF_STRUCT]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if buf_list.is_void then
					buf_list := create {CE_POINTER [PD_NBBUF_STRUCT]}.make_cast ((misc2_inst.alloc_clear ({NATURAL_32} 100 * (create {PD_NBBUF_STRUCT}.make).structure_size.to_natural_32)))
					buf_list_size := 100
				end
				if a_bufno >= buf_list_used then
					if a_bufno >= buf_list_size then
						l_incr := (a_bufno - buf_list_size) + 90
						buf_list_size := buf_list_size + l_incr
						buf_list := create {CE_POINTER [PD_NBBUF_STRUCT]}.make_cast ((realloc (create {CE_POINTER [ANY]}.make_cast (buf_list), buf_list_size.to_natural_32 * (create {PD_NBBUF_STRUCT}.make).structure_size.to_natural_32)))
						memset (create {CE_POINTER [ANY]}.make_cast (((buf_list + buf_list_size) - l_incr)), 0, l_incr.to_natural_32 * (create {PD_NBBUF_STRUCT}.make).structure_size.to_natural_32).do_nothing
					end
					from
					until
						not (buf_list_used <= a_bufno)
					loop
						(buf_list + buf_list_used).item.fireChanges := {NATURAL_32} 1
						buf_list_used := buf_list_used + 1
					end
				end
				Result := (buf_list + a_bufno)
			end
		end

	nb_getbufno (a_bufp: CE_POINTER [PD_FILE_BUFFER]): INTEGER_32
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			l_i___0 := 0
			from
			until
				not (not js.loop_done and then (l_i___0 < buf_list_used))
			loop
				if ((buf_list + l_i___0).item.bufp).is_equal (a_bufp) then
					Result := l_i___0
					js.return
				end
				if not js.return_called then
					l_i___0 := l_i___0 + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	nb_init_graphics
		do
			if not did_init.to_boolean then
				coloncmd ([ce_string (":highlight NBGuarded guibg=Cyan guifg=Black ctermbg=LightCyan ctermfg=Black")])
				coloncmd ([ce_string (":sign define %%d linehl=NBGuarded"), 10_000])
				did_init := 1
			end
		end

	nb_joinlines (a_first___0: INTEGER_32; a_other: INTEGER_32)
		local
			l_len_first: INTEGER_32
			l_len_other: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_p___0.make

			l_len_first := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get (a_first___0))))).to_integer_32
			l_len_other := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((memline_inst.ml_get (a_other))))).to_integer_32
			l_p___0 := misc2_inst.alloc (((l_len_first + l_len_other) + 1).to_natural_32)
			if not l_p___0.is_void then
				memmove (create {CE_POINTER [ANY]}.make_cast (l_p___0), create {CE_POINTER [ANY]}.make_cast ((memline_inst.ml_get (a_first___0))), l_len_first.to_natural_32).do_nothing
				memmove (create {CE_POINTER [ANY]}.make_cast ((l_p___0 + l_len_first)), create {CE_POINTER [ANY]}.make_cast ((memline_inst.ml_get (a_other))), (l_len_other + 1).to_natural_32).do_nothing
				memline_inst.ml_replace (a_first___0, l_p___0, 0).do_nothing
			end
		end

	nb_parse_cmd (a_cmd: CE_POINTER [NATURAL_8])
		local
			l_verb: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_q: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_bufno: INTEGER_32
			l_isfunc: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
		do
			create l_verb.make (<<1>>)
			create l_q.make (<<1>>)
			create l_tmp___2.make
			create l_tmp___3.make

			l_isfunc := -1
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("DISCONNECT"))) = 0 then
				netbeans_close
				main_inst.getout (0)
			end
			if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), ce_string ("DETACH"))) = 0 then
				netbeans_close
				js.return
			end
			if not js.return_called then
				l_bufno := (strtol (create {CE_POINTER [INTEGER_8]}.make_cast (a_cmd), l_verb, 10)).to_integer_32
				if (l_verb.item[0]).to_integer_32 /= 58 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E627: missing colon: %%s")), a_cmd).do_nothing
					js.return
				end
			end
			if not js.return_called then
				l_verb.item := l_verb.item + 1
				l_q.item := l_verb.item
				from
				until
					not (not js.loop_done and then ((l_q.item[0]).to_boolean))
				loop
					if (l_q.item[0]).to_integer_32 = 33 then
						l_tmp___2 := l_q.item
						l_q.item := l_q.item + 1
						l_tmp___2[0] := (('%/0/').code).to_integer_8
						l_isfunc := 0
						js.break
					elseif (l_q.item[0]).to_integer_32 = 47 then
						l_tmp___3 := l_q.item
						l_q.item := l_q.item + 1
						l_tmp___3[0] := (('%/0/').code).to_integer_8
						l_isfunc := 1
						js.break
					end
					if not js.loop_jumped then
						l_q.item := l_q.item + 1
					end
				end
				if l_isfunc < 0 then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E628: missing ! or / in: %%s")), a_cmd).do_nothing
					js.return
				end
			end
			if not js.return_called then
				r_cmdno := (strtol (l_q.item, l_q, 10)).to_integer_32
				l_q.item := create {CE_POINTER [INTEGER_8]}.make_cast ((charset_inst.skipwhite (create {CE_POINTER [NATURAL_8]}.make_cast (l_q.item))))
				l_tmp___6 := nb_do_cmd (l_bufno, create {CE_POINTER [NATURAL_8]}.make_cast (l_verb.item), l_isfunc, r_cmdno, create {CE_POINTER [NATURAL_8]}.make_cast (l_q.item))
			end
		end

	nb_partialremove (a_lnum: INTEGER_32; a_first___0: INTEGER_32; a_last: INTEGER_32)
		local
			l_oldtext: CE_POINTER [NATURAL_8]
			l_newtext: CE_POINTER [NATURAL_8]
			l_oldlen: INTEGER_32
			l_lastbyte: INTEGER_32
			js: JUMP_STATE
		do
			create l_oldtext.make
			create l_newtext.make

			l_lastbyte := a_last
			l_oldtext := memline_inst.ml_get (a_lnum)
			l_oldlen := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_oldtext))).to_integer_32
			if a_first___0 >= l_oldlen then
				js.return
			elseif l_oldlen = 0 then
				js.return
			end
			if not js.return_called then
				if l_lastbyte >= l_oldlen then
					l_lastbyte := l_oldlen - 1
				end
				l_newtext := misc2_inst.alloc ((l_oldlen - (l_lastbyte - a_first___0)).to_natural_32)
				if not l_newtext.is_void then
					memmove (create {CE_POINTER [ANY]}.make_cast (l_newtext), create {CE_POINTER [ANY]}.make_cast (l_oldtext), a_first___0.to_natural_32).do_nothing
					memmove (create {CE_POINTER [ANY]}.make_cast ((l_newtext + a_first___0)), create {CE_POINTER [ANY]}.make_cast (((l_oldtext + l_lastbyte) + 1)), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (((l_oldtext + l_lastbyte) + 1)))) + {NATURAL_32} 1).do_nothing
					memline_inst.ml_replace (a_lnum, l_newtext, 0).do_nothing
				end
			end
		end

	nb_quote (a_txt: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_buf___6.make
			create l_p___0.make
			create l_q.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := (misc2_inst.alloc ({NATURAL_32} 2 * (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_txt))) + {NATURAL_32} 1))
					l_p___0 := a_txt
					l_q := l_buf___6
					if l_buf___6.is_void then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if: | loop condition:
						if not ((l_p___0.item).to_boolean) then
							l_pos := -1 + 8 -- skip loop
						end
				when 2 then -- loop body:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 34 then l_pos := -1 + 3
						when 92 then l_pos := -1 + 3
						when 10 then l_pos := -1 + 4
						when 13 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 3 then -- switch 1, case 34 | switch 1, case 92
						l_tmp___1 := l_q
						l_q := l_q + 1
						l_tmp___1.item := (('\').code).to_natural_8
						l_tmp___2 := l_q
						l_q := l_q + 1
						l_tmp___2.item := l_p___0.item
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 10
						l_tmp___3 := l_q
						l_q := l_q + 1
						l_tmp___3.item := (('\').code).to_natural_8
						l_tmp___4 := l_q
						l_q := l_q + 1
						l_tmp___4.item := (('n').code).to_natural_8
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 13
						l_tmp___5 := l_q
						l_q := l_q + 1
						l_tmp___5.item := (('\').code).to_natural_8
						l_tmp___6 := l_q
						l_q := l_q + 1
						l_tmp___6.item := (('r').code).to_natural_8
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						l_tmp___7 := l_q
						l_q := l_q + 1
						l_tmp___7.item := l_p___0.item
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
						l_q.item := (('%/0/').code).to_natural_8
						Result := l_buf___6
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nb_reply_nil (a_cmdno: INTEGER_32)
		local
			l_reply: CE_ARRAY [INTEGER_8]
		do
			create l_reply.make (<<32>>)

			sprintf ([l_reply, ce_string ("%%d%N"), a_cmdno]).do_nothing
			nb_send (l_reply, ce_string ("nb_reply_nil"))
		end

	nb_reply_nr (a_cmdno: INTEGER_32; a_result___2: INTEGER_32)
		local
			l_reply: CE_ARRAY [INTEGER_8]
		do
			create l_reply.make (<<32>>)

			sprintf ([l_reply, ce_string ("%%d %%ld%N"), a_cmdno, a_result___2]).do_nothing
			nb_send (l_reply, ce_string ("nb_reply_nr"))
		end

	nb_reply_text (a_cmdno: INTEGER_32; a_result___2: CE_POINTER [NATURAL_8])
		local
			l_reply: CE_POINTER [NATURAL_8]
		do
			create l_reply.make

			l_reply := misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_result___2))) + {NATURAL_32} 32)
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_reply), ce_string ("%%d %%s%N"), a_cmdno, create {CE_POINTER [INTEGER_8]}.make_cast (a_result___2)]).do_nothing
			nb_send (create {CE_POINTER [INTEGER_8]}.make_cast (l_reply), ce_string ("nb_reply_text"))
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_reply))
		end

	nb_send (a_buf___6: CE_POINTER [INTEGER_8]; a_fun: CE_POINTER [INTEGER_8])
		local
			l_tmp___0: INTEGER_32
		do
			if nbsock.item = -1 then
				if not did_error.to_boolean then
					message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E630: %%s(): write while not connected")), create {CE_POINTER [NATURAL_8]}.make_cast (a_fun)).do_nothing
				end
				did_error := 1
			else
				l_tmp___0 := write (nbsock.item, create {CE_POINTER [ANY]}.make_cast (a_buf___6), ((strlen (a_buf___6)).to_integer_32).to_natural_32)
				if l_tmp___0 /= (strlen (a_buf___6)).to_integer_32 then
					if not did_error.to_boolean then
						message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E631: %%s(): write failed")), create {CE_POINTER [NATURAL_8]}.make_cast (a_fun)).do_nothing
					end
					did_error := 1
				else
					did_error := 0
				end
			end
		end

	nb_set_curbuf (a_buf___6: CE_POINTER [PD_FILE_BUFFER])
		do
			if not globals_inst.curbuf.is_equal (a_buf___6) then
				if (window_inst.buf_jump_open_win (a_buf___6)).is_void then
					buffer_inst.set_curbuf (a_buf___6, 0)
				end
			end
		end

	nb_unquote (a_p___0: CE_POINTER [NATURAL_8]; a_endp: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [INTEGER_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_result___2: CE_POINTER [INTEGER_8]
			l_q: CE_POINTER [INTEGER_8]
			l_done___2: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_result___2.make
			create l_q.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
					l_result___2 := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_done___2 := 0
					l_result___2 := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.alloc_clear ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1)))
					if l_result___2.is_void then
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						if (l_tmp___1.item).to_integer_32 /= 34 then
							l_result___2[0] := (('%/0/').code).to_integer_8
							Result := l_result___2
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 17 -- skip if block
					end
				when 1 then -- if:
						l_q := l_result___2
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 16 -- skip loop
						end
				when 3 then -- loop body:
						if not l_done___2.to_boolean then
							if (l_p___0.item).to_integer_32 = 0 then
								js.break
							end
						else
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 15 -- skip if block
						end
				when 4 then -- if:
						inspect (l_p___0.item).to_integer_32 -- switch 1 head
						when 34 then l_pos := -1 + 5
						when 92 then l_pos := -1 + 6
						else l_pos := -1 + 14
						end
				when 5 then -- switch 1, case 34
						l_done___2 := 1
						l_pos := -1 + 15 -- switch 1; break
				when 6 then -- switch 1, case 92
						l_p___0 := l_p___0 + 1
						inspect (l_p___0.item).to_integer_32 -- switch 2 head
						when 92 then l_pos := -1 + 7
						when 110 then l_pos := -1 + 8
						when 116 then l_pos := -1 + 9
						when 114 then l_pos := -1 + 10
						when 34 then l_pos := -1 + 11
						when 0 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 7 then -- switch 2, case 92
						l_tmp___2 := l_q
						l_q := l_q + 1
						l_tmp___2[0] := (('\').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 8 then -- switch 2, case 110
						l_tmp___3 := l_q
						l_q := l_q + 1
						l_tmp___3[0] := (('%N').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 9 then -- switch 2, case 116
						l_tmp___4 := l_q
						l_q := l_q + 1
						l_tmp___4[0] := (('%T').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 114
						l_tmp___5 := l_q
						l_q := l_q + 1
						l_tmp___5[0] := (('%R').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 11 then -- switch 2, case 34
						l_tmp___6 := l_q
						l_q := l_q + 1
						l_tmp___6[0] := (('%"').code).to_integer_8
						l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, case 0
						l_p___0 := l_p___0 - 1
						l_pos := -1 + 13 -- switch 2; break
				when 13 then -- switch 2, done:
						l_p___0 := l_p___0 + 1
						l_pos := -1 + 15 -- switch 1; break
				when 14 then -- switch 1, default:
						l_tmp___7 := l_q
						l_q := l_q + 1
						l_tmp___8 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___7[0] := (l_tmp___8.item).to_integer_8
				when 15 then -- switch 1, done: | if done
						l_pos := -1 + 2 -- back to loop condition
				when 16 then -- loop done
						if not a_endp.is_void then
							a_endp.item := l_p___0
						end
						Result := l_result___2
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	netbeans_active: INTEGER_32
		do
			Result := (nbsock.item /= -1).to_integer
		end

	netbeans_beval_cb (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]; a_state: INTEGER_32)
		local
			l_wp___0: CE_ARRAY [CE_POINTER [PD_WINDOW_S]]
			l_text: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lnum: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_p___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_wp___0.make (<<1>>)
			create l_text.make (<<1>>)
			create l_lnum.make (<<1>>)
			create l_col.make (<<1>>)
			create l_buf___6.make (<<8_217>>)
			create l_p___0.make

			if not (option_inst.p_beval.item).to_boolean then
				js.return
			elseif globals_inst.msg_scrolled > 0 then
				js.return
			elseif nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				if (gui_beval_inst.get_beval_info (a_beval, 1, l_wp___0, l_lnum, l_text, l_col)) = 1 then
					if not (l_text.item).is_void then
						if (l_text.item[0]).to_integer_32 /= 0 then
							if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_text.item))) < {NATURAL_32} 4_096 then
								l_p___0 := nb_quote (l_text.item)
								if not l_p___0.is_void then
									message_inst.vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_217).to_natural_32), ce_string ("0:balloonText=%%d %"%%s%"%N"), r_cmdno, l_p___0]).do_nothing
									misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
								end
								nb_send (l_buf___6, ce_string ("netbeans_beval_cb"))
							end
						end
					end
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text.item))
				end
			end
		end

	netbeans_button_release (a_button: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_bufno: INTEGER_32
			l_col: INTEGER_32
			l_tmp: INTEGER_32
			l_off___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf___6.make (<<128>>)

			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_bufno := nb_getbufno (globals_inst.curbuf)
				if l_bufno >= 0 then
					if not globals_inst.curwin.is_void then
						if (globals_inst.curwin.item.w_buffer).is_equal (globals_inst.curbuf) then
							if (globals_inst.curwin.item.w_onebuf_opt.wo_nu).to_boolean then
								l_tmp := 9
							elseif (globals_inst.curwin.item.w_onebuf_opt.wo_rnu).to_boolean then
								l_tmp := 9
							else
								l_tmp := 1
							end
							l_col := (globals_inst.mouse_col - globals_inst.curwin.item.w_wincol) - l_tmp
							l_off___0 := (pos2off (globals_inst.curbuf, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))))
							sprintf ([l_buf___6, ce_string ("%%d:newDotAndMark=%%d %%ld %%ld%N"), l_bufno, r_cmdno, l_off___0, l_off___0]).do_nothing
							nb_send (l_buf___6, ce_string ("netbeans_button_release[newDotAndMark]"))
							sprintf ([l_buf___6, ce_string ("%%d:buttonRelease=%%d %%d %%ld %%d%N"), l_bufno, r_cmdno, a_button, globals_inst.curwin.item.w_cursor.lnum, l_col]).do_nothing
							nb_send (l_buf___6, ce_string ("netbeans_button_release"))
						end
					end
				end
			end
		end

	netbeans_close
		local
			js: JUMP_STATE
		do
			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				netbeans_send_disconnect
				if inputHandler /= 0 then
					gdk_input_remove (inputHandler)
					inputHandler := 0
				end
				globals_inst.bevalServers := (globals_inst.bevalServers).bit_and ((-2))
				close (nbsock.item).do_nothing
				nbsock.item := -1
				needupdate := 0
				inAtomic := 0
				nb_free
				coloncmd ([ce_string (":sign unplace *")])
				move_inst.changed_window_setting
				screen_inst.update_screen (50)
				screen_inst.setcursor
				term_inst.out_flush
				if (gui_inst.gui.item.in_use).to_boolean then
					gui_inst.gui_update_cursor (1, 0)
					gui_gtk_x11_inst.gui_mch_flush
				end
			end
		end

	netbeans_connect (a_params: CE_POINTER [INTEGER_8]; a_doabort: INTEGER_32): INTEGER_32
		local
			l_server: CE_ARRAY [SD_SOCKADDR_IN]
			l_host: CE_POINTER [SD_HOSTENT]
			l_port: INTEGER_32
			l_sd: INTEGER_32
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_hostname: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_address: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_password: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_fname: CE_POINTER [INTEGER_8]
			l_arg: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_retries: INTEGER_32
			l_success___0: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___28: CE_POINTER [INTEGER_8]
			l_tmp___32: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_server.make (<<1>>)
			create l_host.make
			create l_buf___6.make (<<32>>)
			create l_hostname.make (<<1>>)
			create l_address.make (<<1>>)
			create l_password.make (<<1>>)
			create l_fname.make
			create l_arg.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_tmp___8.make
			create l_tmp___24.make
			create l_tmp___28.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_hostname.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_address.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_password.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_arg := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					if (a_params[0]).to_integer_32 /= 61 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (getConnInfo (a_params + 1, l_hostname, l_address, l_password)) = 0 then
							Result := 0
							js.return
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if (a_params[0]).to_integer_32 = 58 then
							l_arg := a_params + 1
						end
						if not (l_arg.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_fname := getenv (ce_string ("__NETBEANS_CONINFO"))
						if not l_fname.is_void then
							if (getConnInfo (l_fname, l_hostname, l_address, l_password)) = 0 then
								Result := 0
								js.return
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if not l_arg.is_void then
							l_hostname.item := l_arg
							l_address.item := strchr (l_hostname.item, (':').code)
							if not (l_address.item).is_void then
								l_tmp___1 := l_address.item
								l_address.item := l_address.item + 1
								l_tmp___1[0] := (('%/0/').code).to_integer_8
								l_password.item := strchr (l_address.item, (':').code)
								if not (l_password.item).is_void then
									l_tmp___2 := l_password.item
									l_password.item := l_password.item + 1
									l_tmp___2[0] := (('%/0/').code).to_integer_8
								end
							end
						end
						if (l_hostname.item).is_void then
							l_hostname.item := getenv (ce_string ("__NETBEANS_HOST"))
						elseif (l_hostname.item[0]).to_integer_32 = 0 then
							l_hostname.item := getenv (ce_string ("__NETBEANS_HOST"))
						end
						if (l_address.item).is_void then
							l_address.item := getenv (ce_string ("__NETBEANS_SOCKET"))
						end
						if (l_password.item).is_void then
							l_password.item := getenv (ce_string ("__NETBEANS_VIM_PASSWORD"))
						end
						if not (l_hostname.item).is_void then
							l_hostname.item := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_hostname.item))))
						end
						if not (l_address.item).is_void then
							l_address.item := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_address.item))))
						end
						if not (l_password.item).is_void then
							l_password.item := create {CE_POINTER [INTEGER_8]}.make_cast ((misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_password.item))))
						end
				when 7 then -- if done
						if js.return_called then
							l_pos := -1 + 21 -- skip if block
						end
				when 8 then -- if:
							if (l_hostname.item).is_void then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hostname.item))
								l_tmp___6 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("localhost")))
								l_hostname.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___6)
							elseif (l_hostname.item[0]).to_integer_32 = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hostname.item))
								l_tmp___6 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("localhost")))
								l_hostname.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___6)
							end
							if (l_address.item).is_void then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_address.item))
								l_tmp___7 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("3219")))
								l_address.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___7)
							elseif (l_address.item[0]).to_integer_32 = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_address.item))
								l_tmp___7 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("3219")))
								l_address.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___7)
							end
							if (l_password.item).is_void then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_password.item))
								l_tmp___8 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("changeme")))
								l_password.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___8)
							elseif (l_password.item[0]).to_integer_32 = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_password.item))
								l_tmp___8 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("changeme")))
								l_password.item := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___8)
							end
							if (l_hostname.item).is_void then
								l_pos := -1 + 20 -- goto theend
							elseif (l_address.item).is_void then
								l_pos := -1 + 20 -- goto theend
							elseif (l_password.item).is_void then
								l_pos := -1 + 20 -- goto theend
							end
				when 9 then
							l_port := atoi (l_address.item)
							l_sd := (socket (2, 1, 0))
							if l_sd = -1 then
								misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("socket() in netbeans_connect()")), create {CE_POINTER [NATURAL_8]}.make_cast ((strerror ((errno_location).item)))).do_nothing
								l_pos := -1 + 20 -- goto theend
							end
				when 10 then
							memset (create {CE_POINTER [ANY]}.make_cast (l_server), ('%/0/').code, (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32).do_nothing
							l_server.item.sin_family := (2).to_natural_16
							l_server.item.sin_port := htons (l_port.to_natural_16)
							l_host := gethostbyname (l_hostname.item)
							if not (l_host.is_void) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
							if (access (l_hostname.item, 4)) >= 0 then
								l_sd := open ([l_hostname.item, 0, 0])
								l_pos := -1 + 20 -- goto theend
							end
				when 12 then
							misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("gethostbyname() in netbeans_connect()")), create {CE_POINTER [NATURAL_8]}.make_cast ((strerror ((errno_location).item)))).do_nothing
							l_pos := -1 + 20 -- goto theend
				when 13 then
							memcpy (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [SD_IN_ADDR]}.make_shared (l_server.item.c_pointer + (create {SD_SOCKADDR_IN}.make).offset_of ("sin_addr")))), create {CE_POINTER [ANY]}.make_cast (l_host.item.h_addr_list[0]), (l_host.item.h_length).to_natural_32).do_nothing
							if not ((connect (l_sd, create {CE_POINTER [SD_SOCKADDR]}.make_cast (l_server), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)).to_boolean) then
								l_pos := -1 + 19 -- skip if block
							end
				when 14 then -- if:
							if (errno_location).item /= 111 then
								l_pos := -1 + 18 -- skip if block
							end
				when 15 then -- if:
							close (l_sd).do_nothing
							l_sd := (socket (2, 1, 0))
							if l_sd = -1 then
								misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("socket()#2 in netbeans_connect()")), create {CE_POINTER [NATURAL_8]}.make_cast ((strerror ((errno_location).item)))).do_nothing
								l_pos := -1 + 20 -- goto theend
							end
				when 16 then
							if (connect (l_sd, create {CE_POINTER [SD_SOCKADDR]}.make_cast (l_server), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)).to_boolean then
								l_retries := 36
								l_success___0 := 0
								from
								until
									js.loop_done
								loop
									l_tmp___20 := l_retries
									l_retries := l_retries - 1
									if l_tmp___20.to_boolean then
										if (errno_location).item /= 111 then
											if (errno_location).item /= 4 then
												js.break
											end
										end
									else
										js.break
									end
									if not js.loop_jumped then
										sleep ({NATURAL_32} 5).do_nothing
										if not a_doabort.to_boolean then
											ui_inst.ui_breakcheck
											if globals_inst.got_int.to_boolean then
												(errno_location).item := 4
												js.break
											end
										end
									end
									if not js.loop_jumped then
										if (connect (l_sd, create {CE_POINTER [SD_SOCKADDR]}.make_cast (l_server), (create {SD_SOCKADDR_IN}.make).structure_size.to_natural_32)) = 0 then
											l_success___0 := 1
											js.break
										end
									end
								end
								if not l_success___0.to_boolean then
									l_tmp___24 := strerror ((errno_location).item)
									misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Cannot connect to Netbeans #2")))), create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___24)).do_nothing
									if a_doabort.to_boolean then
										main_inst.getout (1)
									end
									l_pos := -1 + 20 -- goto theend
								end
							end
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 18 then -- else:
							l_tmp___28 := strerror ((errno_location).item)
							misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("Cannot connect to Netbeans")))), create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___28)).do_nothing
							if a_doabort.to_boolean then
								main_inst.getout (1)
							end
							l_pos := -1 + 20 -- goto theend
				when 19 then -- if done
							nbsock.item := l_sd
							message_inst.vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32), ce_string ("AUTH %%s%N"), l_password.item]).do_nothing
							nb_send (l_buf___6, ce_string ("netbeans_connect"))
							sprintf ([l_buf___6, ce_string ("0:version=0 %"%%s%"%N"), ExtEdProtocolVersion]).do_nothing
							nb_send (l_buf___6, ce_string ("externaleditor_version"))
				when 20 then -- theend:
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_hostname.item))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_address.item))
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_password.item))
							if nbsock.item /= -1 then
								l_tmp___32 := 1
							else
								l_tmp___32 := 0
							end
							Result := l_tmp___32
				when 21 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	netbeans_deleted_all_lines (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_bufno: CE_ARRAY [INTEGER_32]
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<64>>)
			create l_bufno.make (<<1>>)
			create l_nbbuf.make

			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_nbbuf := nb_bufp2nbbuf_fire (a_bufp, l_bufno)
				if l_nbbuf.is_void then
					js.return
				end
			end
			if not js.return_called then
				if (l_nbbuf.item.insertDone).to_boolean then
					l_nbbuf.item.modified := {NATURAL_32} 1
				end
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("%%d:remove=%%d 0 -1%N"), l_bufno.item, r_cmdno]).do_nothing
			end
		end

	netbeans_draw_multisign_indicator (a_row: INTEGER_32)
		local
			l_i___0: INTEGER_32
			l_y: INTEGER_32
			l_x___0: INTEGER_32
			l_drawable: CE_POINTER [SD_GDKDRAWABLE]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_drawable.make

			l_drawable := (gui_inst.gui.item.drawarea).item.window
			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_x___0 := 0
				l_y := a_row * gui_inst.gui.item.char_height + 2
				l_i___0 := 0
				from
				until
					not (l_i___0 < gui_inst.gui.item.char_height - 3)
				loop
					l_tmp := l_y
					l_y := l_y + 1
					gdk_draw_point (l_drawable, gui_inst.gui.item.text_gc, l_x___0 + 2, l_tmp)
					l_i___0 := l_i___0 + 1
				end
				gdk_draw_point (l_drawable, gui_inst.gui.item.text_gc, l_x___0, l_y)
				gdk_draw_point (l_drawable, gui_inst.gui.item.text_gc, l_x___0 + 2, l_y)
				l_tmp___0 := l_y
				l_y := l_y + 1
				gdk_draw_point (l_drawable, gui_inst.gui.item.text_gc, l_x___0 + 4, l_tmp___0)
				gdk_draw_point (l_drawable, gui_inst.gui.item.text_gc, l_x___0 + 1, l_y)
				gdk_draw_point (l_drawable, gui_inst.gui.item.text_gc, l_x___0 + 2, l_y)
				l_tmp___1 := l_y
				l_y := l_y + 1
				gdk_draw_point (l_drawable, gui_inst.gui.item.text_gc, l_x___0 + 3, l_tmp___1)
				gdk_draw_point (l_drawable, gui_inst.gui.item.text_gc, l_x___0 + 2, l_y)
			end
		end

	netbeans_end
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_i___0 := 0
				from
				until
					not (l_i___0 < buf_list_used)
				loop
					if ((buf_list + l_i___0).item.bufp).is_void then
						js.continue
					end
					if not js.loop_jumped then
						if globals_inst.netbeansForcedQuit.to_boolean then
							sprintf ([buf___5, ce_string ("%%d:unmodified=%%d%N"), l_i___0, r_cmdno]).do_nothing
							nb_send (buf___5, ce_string ("netbeans_end"))
						end
						sprintf ([buf___5, ce_string ("%%d:killed=%%d%N"), l_i___0, r_cmdno]).do_nothing
						globals_inst.ignored := write (nbsock.item, create {CE_POINTER [ANY]}.make_cast (buf___5), ((strlen (buf___5)).to_integer_32).to_natural_32)
					end
					l_i___0 := l_i___0 + 1
				end
			end
		end

	netbeans_file_activated (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		local
			l_bufno: INTEGER_32
			l_bp___0: CE_POINTER [PD_NBBUF_STRUCT]
			l_buffer: CE_ARRAY [INTEGER_8]
			l_q: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_bp___0.make
			create l_buffer.make (<<8_192>>)
			create l_q.make

			l_bufno := (nb_getbufno (a_bufp))
			l_bp___0 := (nb_get_buf (l_bufno))
			if nbsock.item = -1 then
				js.return
			elseif not (a_bufp.item.b_netbeans_file).to_boolean then
				js.return
			elseif dosetvisible.to_boolean then
				js.return
			end
			if not js.return_called then
				l_q := nb_quote (a_bufp.item.b_ffname)
				if l_q.is_void then
					js.return
				elseif l_bp___0.is_void then
					js.return
				end
			end
			if not js.return_called then
				message_inst.vim_snprintf ([l_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("%%d:fileOpened=%%d %"%%s%" %%s %%s%N"), l_bufno, l_bufno, create {CE_POINTER [INTEGER_8]}.make_cast (l_q), ce_string ("T"), ce_string ("F")]).do_nothing
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_q))
				nb_send (l_buffer, ce_string ("netbeans_file_opened"))
			end
		end

	netbeans_file_killed (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		local
			l_bufno: INTEGER_32
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			l_buffer: CE_ARRAY [INTEGER_8]
			js: JUMP_STATE
		do
			create l_nbbuf.make
			create l_buffer.make (<<8_192>>)

			l_bufno := (nb_getbufno (a_bufp))
			l_nbbuf := (nb_get_buf (l_bufno))
			if nbsock.item = -1 then
				js.return
			elseif l_bufno = -1 then
				js.return
			end
			if not js.return_called then
				sprintf ([l_buffer, ce_string ("%%d:killed=%%d%N"), l_bufno, r_cmdno]).do_nothing
				nb_send (l_buffer, ce_string ("netbeans_file_killed"))
				if not l_nbbuf.is_void then
					l_nbbuf.item.bufp := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
				end
			end
		end

	netbeans_file_opened (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		local
			l_bufno: INTEGER_32
			l_buffer: CE_ARRAY [INTEGER_8]
			l_q: CE_POINTER [NATURAL_8]
			l_bp___0: CE_POINTER [PD_NBBUF_STRUCT]
			l_bnum: INTEGER_32
			js: JUMP_STATE
		do
			create l_buffer.make (<<8_192>>)
			create l_q.make
			create l_bp___0.make

			l_bufno := (nb_getbufno (a_bufp))
			l_bp___0 := (nb_get_buf ((nb_getbufno (a_bufp))))
			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_q := nb_quote (a_bufp.item.b_ffname)
				if l_q.is_void then
					js.return
				end
			end
			if not js.return_called then
				if not l_bp___0.is_void then
					l_bnum := l_bufno
				else
					l_bnum := 0
				end
				message_inst.vim_snprintf ([l_buffer, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("%%d:fileOpened=%%d %"%%s%" %%s %%s%N"), l_bnum, 0, create {CE_POINTER [INTEGER_8]}.make_cast (l_q), ce_string ("T"), ce_string ("F")]).do_nothing
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_q))
				nb_send (l_buffer, ce_string ("netbeans_file_opened"))
				if (option_inst.p_acd.item).to_boolean then
					if (misc2_inst.vim_chdirfile (a_bufp.item.b_ffname)) = 1 then
						fileio_inst.shorten_fnames (1)
					end
				end
			end
		end

	netbeans_filedesc: INTEGER_32
		do
			Result := (nbsock.item)
		end

	netbeans_gui_register
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((gui_inst.gui.item.in_use).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not ((gui_inst.gui.item.starting).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						if nbsock.item = -1 then
							js.return
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						js.return
				when 7 then -- if done
						if not js.return_called then
							if inputHandler = 0 then
								inputHandler := gdk_input_add (nbsock.item, (5).to_natural_32, messageFromNetbeans_address, create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							globals_inst.bevalServers := (globals_inst.bevalServers).bit_or ((1))
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	netbeans_gutter_click (a_lnum: INTEGER_32)
		local
			l_p___0: CE_POINTER [PD_SIGNLIST]
			l_tail: CE_POINTER [PD_SIGNLIST]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_tail.make

			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_p___0 := globals_inst.curbuf.item.b_signlist
				from
				until
					not (not js.loop_done and then (not l_p___0.is_void))
				loop
					if l_p___0.item.lnum = a_lnum then
						if (not (l_p___0.item.next).is_void) then
							if (l_p___0.item.next).item.lnum = a_lnum then
								if (not (l_p___0.item.prev).is_void) then
									(l_p___0.item.prev).item.next := l_p___0.item.next
								else
									globals_inst.curbuf.item.b_signlist := l_p___0.item.next
								end
								(l_p___0.item.next).item.prev := l_p___0.item.prev
								l_tail := l_p___0.item.next
								from
								until
									js.loop_done
								loop
									if (not (l_tail.item.next).is_void) then
										if (l_tail.item.next).item.lnum = a_lnum then
											if not ((l_tail.item.next).item.id < 1_000_000) then
												js.break
											end
										else
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_tail := l_tail.item.next
									end
								end
								l_p___0.item.next := l_tail.item.next
								if (not (l_tail.item.next).is_void) then
									(l_tail.item.next).item.prev := l_p___0
								end
								l_p___0.item.prev := l_tail
								l_tail.item.next := l_p___0
								screen_inst.update_debug_sign (globals_inst.curbuf, a_lnum)
								js.break
							end
						end
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0.item.next
					end
				end
			end
		end

	netbeans_inserted (a_bufp: CE_POINTER [PD_FILE_BUFFER]; a_linenr: INTEGER_32; a_col: INTEGER_32; a_txt: CE_POINTER [NATURAL_8]; a_newlen: INTEGER_32)
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_bufno: CE_ARRAY [INTEGER_32]
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_off___0: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_newtxt: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___6.make
			create l_bufno.make (<<1>>)
			create l_nbbuf.make
			create l_pos___3.make (<<1>>)
			create l_p___0.make
			create l_newtxt.make

			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_nbbuf := nb_bufp2nbbuf_fire (a_bufp, l_bufno)
				if l_nbbuf.is_void then
					js.return
				end
			end
			if not js.return_called then
				if (l_nbbuf.item.insertDone).to_boolean then
					l_nbbuf.item.modified := {NATURAL_32} 1
				end
				l_pos___3.item.lnum := a_linenr
				l_pos___3.item.col := a_col
				l_off___0 := pos2off (a_bufp, l_pos___3)
				l_newtxt := misc2_inst.alloc ((a_newlen + 1).to_natural_32)
				misc2_inst.vim_strncpy (l_newtxt, a_txt, a_newlen.to_natural_32)
				l_p___0 := nb_quote (l_newtxt)
				if not l_p___0.is_void then
					l_buf___6 := misc2_inst.alloc ((128 + 2 * a_newlen).to_natural_32)
					sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("%%d:insert=%%d %%ld %"%%s%"%N"), l_bufno.item, r_cmdno, l_off___0, l_p___0]).do_nothing
					nb_send (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("netbeans_inserted"))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
				end
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_newtxt))
			end
		end

	netbeans_is_guarded (a_top: INTEGER_32; a_bot: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_SIGNLIST]
			l_lnum: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			if nbsock.item = -1 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_p___0 := globals_inst.curbuf.item.b_signlist
				from
				until
					not (not js.loop_done and then (not l_p___0.is_void))
				loop
					if l_p___0.item.id >= 1_000_000 then
						l_lnum := (a_top + 1).to_integer_32
						from
						until
							not (not js.loop_done and then (l_lnum.to_integer_32 < a_bot))
						loop
							if l_lnum.to_integer_32 = l_p___0.item.lnum then
								Result := 1
								js.return
							end
							if not js.return_called then
								l_lnum := l_lnum + 1
							end
						end
					end
					if not js.return_called then
						l_p___0 := l_p___0.item.next
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	netbeans_keycommand (a_key: INTEGER_32): INTEGER_32
		local
			l_keyName: CE_ARRAY [INTEGER_8]
		do
			create l_keyName.make (<<60>>)

			netbeans_keyname (a_key, l_keyName)
			Result := (netbeans_keystring (create {CE_POINTER [NATURAL_8]}.make_cast (l_keyName)))
		end

	netbeans_keyname (a_key: INTEGER_32; a_buf___6: CE_POINTER [INTEGER_8])
		local
			l_name___1: CE_POINTER [INTEGER_8]
			l_namebuf: CE_ARRAY [INTEGER_8]
			l_ctrl: INTEGER_32
			l_shift: INTEGER_32
			l_alt: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_name___1.make
			create l_namebuf.make (<<2>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_name___1 := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_ctrl := 0
					l_shift := 0
					l_alt := 0
					if ((globals_inst.mod_mask.item).bit_and (4)).to_boolean then
						l_ctrl := 1
					end
					if ((globals_inst.mod_mask.item).bit_and (2)).to_boolean then
						l_shift := 1
					end
					if ((globals_inst.mod_mask.item).bit_and (8)).to_boolean then
						l_alt := 1
					end
					inspect a_key -- switch 1 head
					when -12651 then l_pos := -1 + 1 -- -(107 + ((49).bit_shift_left (8)))
					when -1789 then l_pos := -1 + 2 -- -(253 + ((6).bit_shift_left (8)))
					when -12907 then l_pos := -1 + 3 -- -(107 + ((50).bit_shift_left (8)))
					when -2045 then l_pos := -1 + 4 -- -(253 + ((7).bit_shift_left (8)))
					when -13163 then l_pos := -1 + 5 -- -(107 + ((51).bit_shift_left (8)))
					when -2301 then l_pos := -1 + 6 -- -(253 + ((8).bit_shift_left (8)))
					when -13419 then l_pos := -1 + 7 -- -(107 + ((52).bit_shift_left (8)))
					when -2557 then l_pos := -1 + 8 -- -(253 + ((9).bit_shift_left (8)))
					when -13675 then l_pos := -1 + 9 -- -(107 + ((53).bit_shift_left (8)))
					when -2813 then l_pos := -1 + 10 -- -(253 + ((10).bit_shift_left (8)))
					when -13931 then l_pos := -1 + 11 -- -(107 + ((54).bit_shift_left (8)))
					when -3069 then l_pos := -1 + 12 -- -(253 + ((11).bit_shift_left (8)))
					when -14187 then l_pos := -1 + 13 -- -(107 + ((55).bit_shift_left (8)))
					when -3325 then l_pos := -1 + 14 -- -(253 + ((12).bit_shift_left (8)))
					when -14443 then l_pos := -1 + 15 -- -(107 + ((56).bit_shift_left (8)))
					when -3581 then l_pos := -1 + 16 -- -(253 + ((13).bit_shift_left (8)))
					when -14699 then l_pos := -1 + 17 -- -(107 + ((57).bit_shift_left (8)))
					when -3837 then l_pos := -1 + 18 -- -(253 + ((14).bit_shift_left (8)))
					when -15211 then l_pos := -1 + 19 -- -(107 + ((59).bit_shift_left (8)))
					when -4093 then l_pos := -1 + 20 -- -(253 + ((15).bit_shift_left (8)))
					when -12614 then l_pos := -1 + 21 -- -(70 + ((49).bit_shift_left (8)))
					when -4349 then l_pos := -1 + 22 -- -(253 + ((16).bit_shift_left (8)))
					when -12870 then l_pos := -1 + 23 -- -(70 + ((50).bit_shift_left (8)))
					when -4605 then l_pos := -1 + 24 -- -(253 + ((17).bit_shift_left (8)))
					else l_pos := -1 + 25
					end
				when 1 then -- switch 1, case -(107 + (49 << 8))
					l_name___1 := ce_string ("F1")
					l_pos := -1 + 26 -- switch 1; break
				when 2 then -- switch 1, case -(253 + (6 << 8))
					l_name___1 := ce_string ("F1")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 3 then -- switch 1, case -(107 + (50 << 8))
					l_name___1 := ce_string ("F2")
					l_pos := -1 + 26 -- switch 1; break
				when 4 then -- switch 1, case -(253 + (7 << 8))
					l_name___1 := ce_string ("F2")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 5 then -- switch 1, case -(107 + (51 << 8))
					l_name___1 := ce_string ("F3")
					l_pos := -1 + 26 -- switch 1; break
				when 6 then -- switch 1, case -(253 + (8 << 8))
					l_name___1 := ce_string ("F3")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 7 then -- switch 1, case -(107 + (52 << 8))
					l_name___1 := ce_string ("F4")
					l_pos := -1 + 26 -- switch 1; break
				when 8 then -- switch 1, case -(253 + (9 << 8))
					l_name___1 := ce_string ("F4")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 9 then -- switch 1, case -(107 + (53 << 8))
					l_name___1 := ce_string ("F5")
					l_pos := -1 + 26 -- switch 1; break
				when 10 then -- switch 1, case -(253 + (10 << 8))
					l_name___1 := ce_string ("F5")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 11 then -- switch 1, case -(107 + (54 << 8))
					l_name___1 := ce_string ("F6")
					l_pos := -1 + 26 -- switch 1; break
				when 12 then -- switch 1, case -(253 + (11 << 8))
					l_name___1 := ce_string ("F6")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 13 then -- switch 1, case -(107 + (55 << 8))
					l_name___1 := ce_string ("F7")
					l_pos := -1 + 26 -- switch 1; break
				when 14 then -- switch 1, case -(253 + (12 << 8))
					l_name___1 := ce_string ("F7")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 15 then -- switch 1, case -(107 + (56 << 8))
					l_name___1 := ce_string ("F8")
					l_pos := -1 + 26 -- switch 1; break
				when 16 then -- switch 1, case -(253 + (13 << 8))
					l_name___1 := ce_string ("F8")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 17 then -- switch 1, case -(107 + (57 << 8))
					l_name___1 := ce_string ("F9")
					l_pos := -1 + 26 -- switch 1; break
				when 18 then -- switch 1, case -(253 + (14 << 8))
					l_name___1 := ce_string ("F9")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 19 then -- switch 1, case -(107 + (59 << 8))
					l_name___1 := ce_string ("F10")
					l_pos := -1 + 26 -- switch 1; break
				when 20 then -- switch 1, case -(253 + (15 << 8))
					l_name___1 := ce_string ("F10")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 21 then -- switch 1, case -(70 + (49 << 8))
					l_name___1 := ce_string ("F11")
					l_pos := -1 + 26 -- switch 1; break
				when 22 then -- switch 1, case -(253 + (16 << 8))
					l_name___1 := ce_string ("F11")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 23 then -- switch 1, case -(70 + (50 << 8))
					l_name___1 := ce_string ("F12")
					l_pos := -1 + 26 -- switch 1; break
				when 24 then -- switch 1, case -(253 + (17 << 8))
					l_name___1 := ce_string ("F12")
					l_shift := 1
					l_pos := -1 + 26 -- switch 1; break
				when 25 then -- switch 1, default:
					if a_key >= 32 then
						if a_key <= 126 then
							l_name___1 := l_namebuf
							l_namebuf[0] := a_key.to_integer_8
							l_namebuf[1] := (('%/0/').code).to_integer_8
						else
							l_name___1 := ce_string ("X")
						end
					else
						l_name___1 := ce_string ("X")
					end
					l_pos := -1 + 26 -- switch 1; break
				when 26 then -- switch 1, done:
					a_buf___6[0] := (('%/0/').code).to_integer_8
					if l_ctrl.to_boolean then
						strcat (a_buf___6, ce_string ("C")).do_nothing
					end
					if l_shift.to_boolean then
						strcat (a_buf___6, ce_string ("S")).do_nothing
					end
					if l_alt.to_boolean then
						strcat (a_buf___6, ce_string ("M")).do_nothing
					end
					if l_ctrl.to_boolean then
						strcat (a_buf___6, ce_string ("-")).do_nothing
					elseif l_shift.to_boolean then
						strcat (a_buf___6, ce_string ("-")).do_nothing
					elseif l_alt.to_boolean then
						strcat (a_buf___6, ce_string ("-")).do_nothing
					end
					strcat (a_buf___6, l_name___1).do_nothing
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	netbeans_keystring (a_keyName: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
			l_bufno: INTEGER_32
			l_off___0: INTEGER_32
			l_q: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<8_192>>)
			create l_q.make

			l_bufno := (nb_getbufno (globals_inst.curbuf))
			if nbsock.item = -1 then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_bufno = -1) then
				if (globals_inst.curbuf.item.b_ffname).is_void then
					l_q := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
				else
					l_q := (nb_quote (globals_inst.curbuf.item.b_ffname))
				end
				if l_q.is_void then
					Result := 1
					js.return
				end
				if not js.return_called then
					message_inst.vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("0:fileOpened=%%d %"%%s%" %%s %%s%N"), 0, l_q, ce_string ("T"), ce_string ("F")]).do_nothing
					if not (globals_inst.curbuf.item.b_ffname).is_void then
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_q))
					end
					nb_send (l_buf___6, ce_string ("netbeans_keycommand"))
					postpone_keycommand (a_keyName)
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_off___0 := pos2off (globals_inst.curbuf, create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
				sprintf ([l_buf___6, ce_string ("%%d:newDotAndMark=%%d %%ld %%ld%N"), l_bufno, r_cmdno, l_off___0, l_off___0]).do_nothing
				nb_send (l_buf___6, ce_string ("netbeans_keycommand"))
				message_inst.vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("%%d:keyCommand=%%d %"%%s%"%N"), l_bufno, r_cmdno, a_keyName]).do_nothing
				nb_send (l_buf___6, ce_string ("netbeans_keycommand"))
				message_inst.vim_snprintf ([l_buf___6, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (8_192).to_natural_32), ce_string ("%%d:keyAtPos=%%d %"%%s%" %%ld %%ld/%%ld%N"), l_bufno, r_cmdno, a_keyName, l_off___0, globals_inst.curwin.item.w_cursor.lnum, (globals_inst.curwin.item.w_cursor.col).to_integer_32]).do_nothing
				nb_send (l_buf___6, ce_string ("netbeans_keycommand"))
				Result := 1
			end
		end

	netbeans_open (a_params: CE_POINTER [INTEGER_8]; a_doabort: INTEGER_32)
		local
			l_cmd: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_cmd.make

			l_cmd := ce_string ("0:startupDone=0%N")
			if nbsock.item /= -1 then
				message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E511: netbeans already connected"))))).do_nothing
				js.return
			end
			if not js.return_called then
				if (netbeans_connect (a_params, a_doabort)) /= 1 then
					js.return
				end
			end
			if not js.return_called then
				netbeans_gui_register
				nb_send (l_cmd, ce_string ("netbeans_startup_done"))
				move_inst.changed_window_setting
				screen_inst.update_screen (50)
				screen_inst.setcursor
				term_inst.out_flush
				if (gui_inst.gui.item.in_use).to_boolean then
					gui_inst.gui_update_cursor (1, 0)
					gui_gtk_x11_inst.gui_mch_flush
				end
			end
		end

	netbeans_parse_messages
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_node: CE_POINTER [PD_CMDQUEUE]
			l_tmp: NATURAL_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p___0.make
			create l_node.make
			create l_tmp___1.make

			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if not (head.item.next).is_void then
						if (head.item.next).is_equal (head) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_node := head.item.next
						l_p___0 := misc2_inst.vim_strchr (l_node.item.buffer, ('%N').code)
						if l_p___0.is_void then
							if (l_node.item.next).is_equal (head) then
								js.return
							end
							if not js.return_called then
								l_tmp := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_node.item.buffer))
								l_p___0 := misc2_inst.alloc ((l_tmp + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_node.item.next).item.buffer)))) + {NATURAL_32} 1)
								if l_p___0.is_void then
									js.return
								end
							end
							if not js.return_called then
								strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast (l_node.item.buffer)).do_nothing
								strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), create {CE_POINTER [INTEGER_8]}.make_cast ((l_node.item.next).item.buffer)).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast ((l_node.item.next).item.buffer));
								(l_node.item.next).item.buffer := l_p___0
								head.item.next := l_node.item.next;
								(l_node.item.next).item.prev := l_node.item.prev
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_node.item.buffer))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_node))
							end
						else
							l_tmp___1 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___1.item := (('%/0/').code).to_natural_8
							if (l_p___0.item).to_integer_32 = 0 then
								head.item.next := l_node.item.next;
								(l_node.item.next).item.prev := l_node.item.prev
							end
							nb_parse_cmd (l_node.item.buffer)
							if (l_p___0.item).to_integer_32 = 0 then
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_node.item.buffer))
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_node))
							else
								memmove (create {CE_POINTER [ANY]}.make_cast (l_node.item.buffer), create {CE_POINTER [ANY]}.make_cast (l_p___0), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0))) + {NATURAL_32} 1).do_nothing
							end
						end
					end
				end
			end
			if not js.return_called then
			end
		end

	netbeans_read
		local
			l_len: INTEGER_32
			l_readlen: INTEGER_32
			l_tval: CE_ARRAY [SD_TIMEVAL]
			l_rfds: CE_ARRAY [SD_FD_SET]
			l___d0: CE_ARRAY [INTEGER_32]
			l___d1: CE_ARRAY [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tval.make (<<1>>)
			create l_rfds.make (<<1>>)
			create l___d0.make (<<1>>)
			create l___d1.make (<<1>>)
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := 0
					l_readlen := 0
					if nbsock.item = -1 then
						js.return
					end
					if not js.return_called and then (buf___4.is_void) then
						buf___4 := misc2_inst.alloc ({NATURAL_32} 4_096)
						if buf___4.is_void then
							js.return
						end
					end
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								asm15 (l___d0, l___d1, l_rfds)
								js.break
							end
							asm16 (l_rfds, nbsock)
							l_tval.item.tv_sec := (0).to_integer_32
							l_tval.item.tv_usec := (0).to_integer_32
							if (select2 (nbsock.item + 1, l_rfds, create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), create {CE_POINTER [SD_FD_SET]}.make_shared (default_pointer), l_tval)) <= 0 then
								js.break
							end
							if not js.loop_jumped then
								l_len := read (nbsock.item, create {CE_POINTER [ANY]}.make_cast (buf___4), (4_096).to_natural_32)
								if l_len <= 0 then
									js.break
								end
							end
							if not js.loop_jumped then
								save (buf___4, l_len)
								l_readlen := l_readlen + l_len
								if l_len < 4_096 then
									js.break
								end
							end
						end
						if l_readlen <= 0 then
							netbeans_close
							if l_len < 0 then
								l_tmp___1 := strerror ((errno_location).item)
								misc2_inst.emsg3 (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%%s: %%s")), create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("read from Netbeans socket")))), create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___1)).do_nothing
							end
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((gui_inst.gui.item.in_use).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if not ((gui_inst.gui.item.starting).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (gtk_main_level) > {NATURAL_32} 0 then
							gtk_main_quit
						end
				when 6 then -- if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	netbeans_removed (a_bufp: CE_POINTER [PD_FILE_BUFFER]; a_linenr: INTEGER_32; a_col: INTEGER_32; a_len: INTEGER_32)
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_bufno: CE_ARRAY [INTEGER_32]
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_off___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_buf___6.make (<<128>>)
			create l_bufno.make (<<1>>)
			create l_nbbuf.make
			create l_pos___3.make (<<1>>)

			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_nbbuf := nb_bufp2nbbuf_fire (a_bufp, l_bufno)
				if l_nbbuf.is_void then
					js.return
				end
			end
			if not js.return_called and then (a_len < 0) then
				js.return
			end
			if not js.return_called then
				l_nbbuf.item.modified := {NATURAL_32} 1
				l_pos___3.item.lnum := a_linenr
				l_pos___3.item.col := a_col
				l_off___0 := pos2off (a_bufp, l_pos___3)
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("%%d:remove=%%d %%ld %%ld%N"), l_bufno.item, r_cmdno, l_off___0, a_len]).do_nothing
				nb_send (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("netbeans_removed"))
			end
		end

	netbeans_save_buffer (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		local
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_bufno: CE_ARRAY [INTEGER_32]
			l_nbbuf: CE_POINTER [PD_NBBUF_STRUCT]
			js: JUMP_STATE
		do
			create l_buf___6.make (<<64>>)
			create l_bufno.make (<<1>>)
			create l_nbbuf.make

			if nbsock.item = -1 then
				js.return
			end
			if not js.return_called then
				l_nbbuf := nb_bufp2nbbuf_fire (a_bufp, l_bufno)
				if l_nbbuf.is_void then
					js.return
				end
			end
			if not js.return_called then
				l_nbbuf.item.modified := {NATURAL_32} 0
				sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("%%d:save=%%d%N"), l_bufno.item, r_cmdno]).do_nothing
				nb_send (create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6), ce_string ("netbeans_save_buffer"))
			end
		end

	netbeans_send_disconnect
		local
			l_buf___6: CE_ARRAY [INTEGER_8]
		do
			create l_buf___6.make (<<128>>)

			if nbsock.item /= -1 then
				sprintf ([l_buf___6, ce_string ("0:disconnect=%%d%N"), r_cmdno]).do_nothing
				nb_send (l_buf___6, ce_string ("netbeans_disconnect"))
			end
		end

	netbeans_unmodified (a_bufp: CE_POINTER [PD_FILE_BUFFER])
		do
		end

	off2pos (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_offset: INTEGER_32): CE_POINTER [PD_POS_T]
		local
			l_offset: CE_ARRAY [INTEGER_32]
			l_lnum: INTEGER_32
			js: JUMP_STATE
		do
			create l_offset.make (<<1>>)

			l_offset.item := a_offset
			pos___2.item.lnum := (0).to_integer_32
			pos___2.item.col := 0
			pos___2.item.coladd := 0
			if not ((a_buf___6.item.b_ml.ml_flags).bit_and (1)).to_boolean then
				l_lnum := memline_inst.ml_find_line_or_offset (a_buf___6, (0).to_integer_32, l_offset)
				if l_lnum < 0 then
					Result := (create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer))
					js.return
				end
				if not js.return_called then
					pos___2.item.lnum := l_lnum
					pos___2.item.col := (l_offset.item).to_integer_32
				end
			end
			if not js.return_called then
				Result := pos___2
			end
		end

	pos2off (a_buf___6: CE_POINTER [PD_FILE_BUFFER]; a_pos___3: CE_POINTER [PD_POS_T]): INTEGER_32
		local
			l_offset: INTEGER_32
			js: JUMP_STATE
		do
			l_offset := 0
			if not ((a_buf___6.item.b_ml.ml_flags).bit_and (1)).to_boolean then
				l_offset := memline_inst.ml_find_line_or_offset (a_buf___6, a_pos___3.item.lnum, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
				if l_offset < 0 then
					Result := 0
					js.return
				end
				if not js.return_called then
					l_offset := l_offset + (a_pos___3.item.col).to_integer_32
				end
			end
			if not js.return_called then
				Result := l_offset
			end
		end

	postpone_keycommand (a_keystr: CE_POINTER [NATURAL_8])
		local
			l_node: CE_POINTER [PD_KEYQUEUE]
			js: JUMP_STATE
		do
			create l_node.make

			l_node := create {CE_POINTER [PD_KEYQUEUE]}.make_cast ((misc2_inst.alloc ((create {PD_KEYQUEUE}.make).structure_size.to_natural_32)))
			if l_node.is_void then
				js.return
			end
			if not js.return_called then
				if (keyHead.item.next).is_void then
					keyHead.item.next := keyHead
					keyHead.item.prev := keyHead
				end
				l_node.item.next := keyHead
				l_node.item.prev := keyHead.item.prev;
				(keyHead.item.prev).item.next := l_node
				keyHead.item.prev := l_node
				l_node.item.keystr := misc2_inst.vim_strsave (a_keystr)
			end
		end

	print_read_msg (a_buf___6: CE_POINTER [PD_NBBUF_STRUCT])
		local
			l_lnum: INTEGER_32
			l_nchars: INTEGER_32
			l_c: NATURAL_8
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
		do
			create l_tmp___2.make
			create l_tmp___7.make

			l_lnum := ((a_buf___6.item.bufp).item.b_ml.ml_line_count).to_integer_32
			l_nchars := (a_buf___6.item.bufp).item.b_orig_size
			fileio_inst.msg_add_fname (a_buf___6.item.bufp, (a_buf___6.item.bufp).item.b_ffname)
			l_c := (0).to_natural_8
			if ((a_buf___6.item.bufp).item.b_p_ro).to_boolean then
				if (option_inst.shortmess (('r').code)).to_boolean then
					l_tmp___2 := (gettext (ce_string ("[RO]")))
				else
					l_tmp___2 := (gettext (ce_string ("[readonly]")))
				end
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___2).do_nothing
				l_c := (1).to_natural_8
			end
			if not ((a_buf___6.item.bufp).item.b_start_eol).to_boolean then
				if (option_inst.shortmess (('i').code)).to_boolean then
					l_tmp___7 := (gettext (ce_string ("[noeol]")))
				else
					l_tmp___7 := (gettext (ce_string ("[Incomplete last line]")))
				end
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), l_tmp___7).do_nothing
				l_c := (1).to_natural_8
			end
			fileio_inst.msg_add_lines (l_c.to_integer_32, l_lnum.to_integer_32, l_nchars)
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.keep_msg))
			globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.msg_scrolled_ign := 1
			message_inst.msg_trunc_attr (globals_inst.IObuff, 0, 0).do_nothing
			globals_inst.msg_scrolled_ign := 0
		end

	print_save_msg (a_buf___6: CE_POINTER [PD_NBBUF_STRUCT]; a_nchars: INTEGER_32)
		local
			l_c: NATURAL_8
			l_p___0: CE_POINTER [NATURAL_8]
			l_ebuf: CE_ARRAY [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make
			create l_ebuf.make (<<8_192>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_nchars >= 0) then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						fileio_inst.msg_add_fname (a_buf___6.item.bufp, (a_buf___6.item.bufp).item.b_ffname)
						l_c := (0).to_natural_8
						fileio_inst.msg_add_lines (l_c.to_integer_32, (a_buf___6.item.bufp).item.b_ml.ml_line_count, (a_buf___6.item.bufp).item.b_orig_size)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (globals_inst.keep_msg))
						globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						globals_inst.msg_scrolled_ign := 1
						l_p___0 := message_inst.msg_trunc_attr (globals_inst.IObuff, 0, 0)
						if not (globals_inst.msg_scrolled.to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if not globals_inst.need_wait_return.to_boolean then
							message_inst.set_keep_msg (l_p___0, 0)
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if not (a_buf___6.item.initDone).to_boolean then
							message_inst.set_keep_msg (l_p___0, 0)
						end
				when 5 then
						globals_inst.msg_scrolled_ign := 0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_ebuf), (gettext (ce_string ("E505: ")))).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_ebuf), create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff)).do_nothing
						strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_ebuf), (gettext (ce_string ("is read-only (add ! to override)")))).do_nothing
						strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), create {CE_POINTER [INTEGER_8]}.make_cast (l_ebuf)).do_nothing
						message_inst.emsg (globals_inst.IObuff).do_nothing
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	save (a_buf___6: CE_POINTER [NATURAL_8]; a_len: INTEGER_32)
		local
			l_node: CE_POINTER [PD_CMDQUEUE]
			js: JUMP_STATE
		do
			create l_node.make

			l_node := create {CE_POINTER [PD_CMDQUEUE]}.make_cast ((misc2_inst.alloc ((create {PD_CMDQUEUE}.make).structure_size.to_natural_32)))
			if l_node.is_void then
				js.return
			end
			if not js.return_called then
				l_node.item.buffer := misc2_inst.alloc ((a_len + 1).to_natural_32)
				if (l_node.item.buffer).is_void then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_node))
					js.return
				end
			end
			if not js.return_called then
				memmove (create {CE_POINTER [ANY]}.make_cast (l_node.item.buffer), create {CE_POINTER [ANY]}.make_cast (a_buf___6), a_len.to_natural_32).do_nothing
				l_node.item.buffer[a_len] := (('%/0/').code).to_natural_8
				if (head.item.next).is_void then
					head.item.next := head
					head.item.prev := head
				end
				l_node.item.next := head
				l_node.item.prev := head.item.prev;
				(head.item.prev).item.next := l_node
				head.item.prev := l_node
			end
		end

	special_keys___0 (a_args: CE_POINTER [NATURAL_8])
		local
			l_save_str: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_sep: CE_POINTER [INTEGER_8]
			l_keybuf: CE_ARRAY [INTEGER_8]
			l_cmdbuf: CE_ARRAY [INTEGER_8]
			l_i___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_save_str.make
			create l_tok.make
			create l_sep.make
			create l_keybuf.make (<<64>>)
			create l_cmdbuf.make (<<256>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_save_str := (nb_unquote (a_args, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)))
					l_tok := (strtok (l_save_str, ce_string (" ")))
				when 1 then -- loop condition:
					if not (not js.loop_done and then (not l_tok.is_void)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_i___0 := 0
						l_sep := strchr (l_tok, ('-').code)
						if l_sep.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						l_sep[0] := (('%/0/').code).to_integer_8
				when 4 then -- loop condition:
						if not ((l_tok[0]).to_boolean) then
							l_pos := -1 + 8 -- skip loop
						end
				when 5 then -- loop body:
						inspect (l_tok[0]).to_integer_32 -- switch 1 head
						when 65 then l_pos := -1 + 6
						when 77 then l_pos := -1 + 6
						when 67 then l_pos := -1 + 6
						when 83 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 6 then -- switch 1, case 65 | switch 1, case 77 | switch 1, case 67 | switch 1, case 83
						l_tmp___1 := l_i___0
						l_i___0 := l_i___0 + 1
						l_keybuf[l_tmp___1] := l_tok[0]
						l_tmp___2 := l_i___0
						l_i___0 := l_i___0 + 1
						l_keybuf[l_tmp___2] := (('-').code).to_integer_8
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
						l_tok := l_tok + 1
						l_pos := -1 + 4 -- back to loop condition
				when 8 then -- loop done
						l_tok := l_tok + 1
				when 9 then -- if done
						strcpy ((l_keybuf + l_i___0), l_tok).do_nothing
						message_inst.vim_snprintf ([l_cmdbuf, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32), ce_string ("<silent><%%s> :nbkey %%s<CR>"), l_keybuf, l_keybuf]).do_nothing
						getchar_inst.do_map (0, create {CE_POINTER [NATURAL_8]}.make_cast (l_cmdbuf), 1, 0).do_nothing
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" "))
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_save_str))
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
