class
	SD_GDKDEVICEKEY

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	keyval: NATURAL_32 assign set_keyval

	modifiers: NATURAL_32 assign set_modifiers

feature {ANY} -- setters

	set_keyval (a_keyval: NATURAL_32)
		do
			keyval := a_keyval
			update_memory_field ("keyval")
		end

	set_modifiers (a_modifiers: NATURAL_32)
		do
			modifiers := a_modifiers
			update_memory_field ("modifiers")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			keyval := a_other.keyval
			modifiers := a_other.modifiers
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				keyval = a_other.keyval and
				modifiers = a_other.modifiers
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("keyval"),
					create {CE_STRUCTURE_FIELD}.make ("modifiers")
				>>)
			init_structure_info
		end

end
