class
	SD_GOBJECTCONSTRUCTPARAM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pspec.make
			create value.make
		end

feature {ANY} -- fields

	pspec: CE_POINTER [SD_GPARAMSPEC] assign set_pspec

	value: CE_POINTER [SD_GVALUE] assign set_value

feature {ANY} -- setters

	set_pspec (a_pspec: CE_POINTER [SD_GPARAMSPEC])
		do
			pspec := a_pspec
			update_memory_field ("pspec")
		end

	set_value (a_value: CE_POINTER [SD_GVALUE])
		do
			value := a_value
			update_memory_field ("value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pspec := a_other.pspec
			value := a_other.value
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pspec.is_equal (a_other.pspec) and
				value.is_equal (a_other.value)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pspec"),
					create {CE_STRUCTURE_FIELD}.make ("value")
				>>)
			init_structure_info
		end

end
