class
	SD_GTKRADIOBUTTON

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create check_button.make
			create group.make
		end

feature {ANY} -- fields

	check_button: SD_GTKCHECKBUTTON assign set_check_button

	group: CE_POINTER [SD_GSLIST] assign set_group

feature {ANY} -- setters

	set_check_button (a_check_button: SD_GTKCHECKBUTTON)
		do
			check_button := a_check_button
			update_memory_field ("check_button")
		end

	set_group (a_group: CE_POINTER [SD_GSLIST])
		do
			group := a_group
			update_memory_field ("group")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			check_button := a_other.check_button.twin
			group := a_other.group
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				check_button.is_equal (a_other.check_button) and
				group.is_equal (a_other.group)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("check_button"),
					create {CE_STRUCTURE_FIELD}.make ("group")
				>>)
			init_structure_info
		end

end
