deferred class
	S_GDK_PIXBUF_GDK_PIXBUF

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	gdk_pixbuf_get_height (a_pixbuf: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_gdk_pixbuf_get_height (a_pixbuf.c_pointer)
		end

	c_gdk_pixbuf_get_height (a_pixbuf: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_pixbuf_get_height($a_pixbuf);"
		end

	gdk_pixbuf_get_width (a_pixbuf: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_gdk_pixbuf_get_width (a_pixbuf.c_pointer)
		end

	c_gdk_pixbuf_get_width (a_pixbuf: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_pixbuf_get_width($a_pixbuf);"
		end

	gdk_pixbuf_new_from_file (a_filename: CE_POINTER [INTEGER_8]; a_error: CE_POINTER [CE_POINTER [SD_GERROR]]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_gdk_pixbuf_new_from_file (a_filename.c_pointer, a_error.c_pointer))
		end

	c_gdk_pixbuf_new_from_file (a_filename: POINTER; a_error: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_pixbuf_new_from_file($a_filename, $a_error);"
		end

	gdk_pixbuf_new_from_inline (a_data_length: INTEGER_32; a_data: CE_POINTER [NATURAL_8]; a_copy_pixels: INTEGER_32; a_error: CE_POINTER [CE_POINTER [SD_GERROR]]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_gdk_pixbuf_new_from_inline (a_data_length, a_data.c_pointer, a_copy_pixels, a_error.c_pointer))
		end

	c_gdk_pixbuf_new_from_inline (a_data_length: INTEGER_32; a_data: POINTER; a_copy_pixels: INTEGER_32; a_error: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_pixbuf_new_from_inline($a_data_length, $a_data, $a_copy_pixels, $a_error);"
		end

	gdk_pixbuf_new_from_xpm_data (a_data: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_gdk_pixbuf_new_from_xpm_data (a_data.c_pointer))
		end

	c_gdk_pixbuf_new_from_xpm_data (a_data: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_pixbuf_new_from_xpm_data($a_data);"
		end

	gdk_pixbuf_scale_simple (a_src: CE_POINTER [ANY]; a_dest_width: INTEGER_32; a_dest_height: INTEGER_32; a_interp_type: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_gdk_pixbuf_scale_simple (a_src.c_pointer, a_dest_width, a_dest_height, a_interp_type))
		end

	c_gdk_pixbuf_scale_simple (a_src: POINTER; a_dest_width: INTEGER_32; a_dest_height: INTEGER_32; a_interp_type: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_pixbuf_scale_simple($a_src, $a_dest_width, $a_dest_height, $a_interp_type);"
		end

end
