class
	PD_CONTENTTYPE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create extension.make (<<6>>)
			create type.make
		end

feature {ANY} -- fields

	extension: CE_ARRAY [INTEGER_8]

	type: CE_POINTER [INTEGER_8] assign set_type

feature {ANY} -- setters

	set_type (a_type: CE_POINTER [INTEGER_8])
		do
			type := a_type
			update_memory_field ("type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			extension := a_other.extension.twin
			type := a_other.type
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				extension.is_equal (a_other.extension) and
				type.is_equal (a_other.type)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("extension", <<6>>),
					create {CE_STRUCTURE_FIELD}.make ("type")
				>>)
			init_structure_info
		end

end
