class
	PD_CURL_FORMS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create value.make
		end

feature {ANY} -- fields

	option: NATURAL_32 assign set_option

	value: CE_POINTER [INTEGER_8] assign set_value

feature {ANY} -- setters

	set_option (a_option: NATURAL_32)
		do
			option := a_option
			update_memory_field ("option")
		end

	set_value (a_value: CE_POINTER [INTEGER_8])
		do
			value := a_value
			update_memory_field ("value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			option := a_other.option
			value := a_other.value
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				option = a_other.option and
				value.is_equal (a_other.value)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("option"),
					create {CE_STRUCTURE_FIELD}.make ("value")
				>>)
			init_structure_info
		end

end
