class
	PD_CURL_MESSAGE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create extmsg.make
		end

feature {ANY} -- fields

	extmsg: PD_CURLMSG assign set_extmsg

feature {ANY} -- setters

	set_extmsg (a_extmsg: PD_CURLMSG)
		do
			extmsg := a_extmsg
			update_memory_field ("extmsg")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			extmsg := a_other.extmsg.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				extmsg.is_equal (a_other.extmsg)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("extmsg")
				>>)
			init_structure_info
		end

end
