class
	PD_CURL_SLIST

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make
			create next.make
		end

feature {ANY} -- fields

	data: CE_POINTER [INTEGER_8] assign set_data

	next: CE_POINTER [PD_CURL_SLIST] assign set_next

feature {ANY} -- setters

	set_data (a_data: CE_POINTER [INTEGER_8])
		do
			data := a_data
			update_memory_field ("data")
		end

	set_next (a_next: CE_POINTER [PD_CURL_SLIST])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data) and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
