class
	PD_MD5_CTX

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create state.make (<<4>>)
			create count.make (<<2>>)
			create buffer.make (<<64>>)
		end

feature {ANY} -- fields

	state: CE_ARRAY [NATURAL_32]

	count: CE_ARRAY [NATURAL_32]

	buffer: CE_ARRAY [NATURAL_8]

feature {ANY}

	copy (a_other: like Current)
		do
			state := a_other.state.twin
			count := a_other.count.twin
			buffer := a_other.buffer.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				state.is_equal (a_other.state) and
				count.is_equal (a_other.count) and
				buffer.is_equal (a_other.buffer)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("state", <<4>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("count", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("buffer", <<64>>)
				>>)
			init_structure_info
		end

end
