frozen class
	LIBCURL_INITIALIZER_SLICE2

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {LIBCURL_INITIALIZER}

	initialize
		do
			imap_inst.Curl_handler_imap[0].do_it := imap_inst.imap_do_address
			imap_inst.Curl_handler_imap[0].done := imap_inst.imap_done_address
			imap_inst.Curl_handler_imap[0].do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap[0].connect_it := imap_inst.imap_connect_address
			imap_inst.Curl_handler_imap[0].connecting := imap_inst.imap_multi_statemach_address
			imap_inst.Curl_handler_imap[0].doing := imap_inst.imap_doing_address
			imap_inst.Curl_handler_imap[0].proto_getsock := imap_inst.imap_getsock_address
			imap_inst.Curl_handler_imap[0].doing_getsock := imap_inst.imap_getsock_address
			imap_inst.Curl_handler_imap[0].perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap[0].disconnect := imap_inst.imap_disconnect_address
			imap_inst.Curl_handler_imap[0].defport := 143
			imap_inst.Curl_handler_imap[0].protocol := ((1).bit_shift_left (12)).to_integer_32
			imap_inst.Curl_handler_imap_proxy[0].scheme := ce_string ("IMAP")
			imap_inst.Curl_handler_imap_proxy[0].setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].do_it := http_inst.Curl_http_address
			imap_inst.Curl_handler_imap_proxy[0].done := http_inst.Curl_http_done_address
			imap_inst.Curl_handler_imap_proxy[0].do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].connect_it := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].doing := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].doing_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].disconnect := create {CE_ROUTINE}.make_shared (default_pointer)
			imap_inst.Curl_handler_imap_proxy[0].defport := 143
			imap_inst.Curl_handler_imap_proxy[0].protocol := 1
			imap_inst.ids[0] := ce_string ("A")
			imap_inst.ids[1] := ce_string ("B")
			imap_inst.ids[2] := ce_string ("C")
			imap_inst.ids[3] := ce_string ("D")
			pop3_inst.Curl_handler_pop3[0].scheme := ce_string ("POP3")
			pop3_inst.Curl_handler_pop3[0].setup_connection := pop3_inst.pop3_setup_connection_address
			pop3_inst.Curl_handler_pop3[0].do_it := pop3_inst.pop3_do_address
			pop3_inst.Curl_handler_pop3[0].done := pop3_inst.pop3_done_address
			pop3_inst.Curl_handler_pop3[0].do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3[0].connect_it := pop3_inst.pop3_connect_address
			pop3_inst.Curl_handler_pop3[0].connecting := pop3_inst.pop3_multi_statemach_address
			pop3_inst.Curl_handler_pop3[0].doing := pop3_inst.pop3_doing_address
			pop3_inst.Curl_handler_pop3[0].proto_getsock := pop3_inst.pop3_getsock_address
			pop3_inst.Curl_handler_pop3[0].doing_getsock := pop3_inst.pop3_getsock_address
			pop3_inst.Curl_handler_pop3[0].perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3[0].disconnect := pop3_inst.pop3_disconnect_address
			pop3_inst.Curl_handler_pop3[0].defport := 110
			pop3_inst.Curl_handler_pop3[0].protocol := ((1).bit_shift_left (14)).to_integer_32
			pop3_inst.Curl_handler_pop3_proxy[0].scheme := ce_string ("POP3")
			pop3_inst.Curl_handler_pop3_proxy[0].setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].do_it := http_inst.Curl_http_address
			pop3_inst.Curl_handler_pop3_proxy[0].done := http_inst.Curl_http_done_address
			pop3_inst.Curl_handler_pop3_proxy[0].do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].connect_it := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].doing := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].doing_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].disconnect := create {CE_ROUTINE}.make_shared (default_pointer)
			pop3_inst.Curl_handler_pop3_proxy[0].defport := 110
			pop3_inst.Curl_handler_pop3_proxy[0].protocol := 1
			smtp_inst.Curl_handler_smtp[0].scheme := ce_string ("SMTP")
			smtp_inst.Curl_handler_smtp[0].setup_connection := smtp_inst.smtp_setup_connection_address
			smtp_inst.Curl_handler_smtp[0].do_it := smtp_inst.smtp_do_address
			smtp_inst.Curl_handler_smtp[0].done := smtp_inst.smtp_done_address
			smtp_inst.Curl_handler_smtp[0].do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp[0].connect_it := smtp_inst.smtp_connect_address
			smtp_inst.Curl_handler_smtp[0].connecting := smtp_inst.smtp_multi_statemach_address
			smtp_inst.Curl_handler_smtp[0].doing := smtp_inst.smtp_doing_address
			smtp_inst.Curl_handler_smtp[0].proto_getsock := smtp_inst.smtp_getsock_address
			smtp_inst.Curl_handler_smtp[0].doing_getsock := smtp_inst.smtp_getsock_address
			smtp_inst.Curl_handler_smtp[0].perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp[0].disconnect := smtp_inst.smtp_disconnect_address
			smtp_inst.Curl_handler_smtp[0].defport := 25
			smtp_inst.Curl_handler_smtp[0].protocol := ((1).bit_shift_left (16)).to_integer_32
			smtp_inst.Curl_handler_smtp_proxy[0].scheme := ce_string ("SMTP")
			smtp_inst.Curl_handler_smtp_proxy[0].setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].do_it := http_inst.Curl_http_address
			smtp_inst.Curl_handler_smtp_proxy[0].done := http_inst.Curl_http_done_address
			smtp_inst.Curl_handler_smtp_proxy[0].do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].connect_it := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].doing := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].doing_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].disconnect := create {CE_ROUTINE}.make_shared (default_pointer)
			smtp_inst.Curl_handler_smtp_proxy[0].defport := 25
			smtp_inst.Curl_handler_smtp_proxy[0].protocol := 1
			rtsp_inst.Curl_handler_rtsp[0].scheme := ce_string ("RTSP")
			rtsp_inst.Curl_handler_rtsp[0].setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp[0].do_it := rtsp_inst.Curl_rtsp_address
			rtsp_inst.Curl_handler_rtsp[0].done := rtsp_inst.Curl_rtsp_done_address
			rtsp_inst.Curl_handler_rtsp[0].do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp[0].connect_it := rtsp_inst.Curl_rtsp_connect_address
			rtsp_inst.Curl_handler_rtsp[0].connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp[0].doing := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp[0].proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp[0].doing_getsock := rtsp_inst.rtsp_getsock_do_address
			rtsp_inst.Curl_handler_rtsp[0].perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			rtsp_inst.Curl_handler_rtsp[0].disconnect := rtsp_inst.Curl_rtsp_disconnect_address
			rtsp_inst.Curl_handler_rtsp[0].defport := 554
			rtsp_inst.Curl_handler_rtsp[0].protocol := ((1).bit_shift_left (18)).to_integer_32
			hmac_inst.hmac_ipad[0] := (54).to_natural_8
			hmac_inst.hmac_opad[0] := (92).to_natural_8
			gopher_inst.Curl_handler_gopher[0].scheme := ce_string ("GOPHER")
			gopher_inst.Curl_handler_gopher[0].setup_connection := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].do_it := gopher_inst.gopher_do_address
			gopher_inst.Curl_handler_gopher[0].done := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].do_more := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].connect_it := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].connecting := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].doing := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].proto_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].doing_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].perform_getsock := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].disconnect := create {CE_ROUTINE}.make_shared (default_pointer)
			gopher_inst.Curl_handler_gopher[0].defport := 70
			gopher_inst.Curl_handler_gopher[0].protocol := ((1).bit_shift_left (25)).to_integer_32
		end

end
