class
	P_HOSTSYN

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_is_resolved (a_conn: CE_POINTER [PD_CONNECTDATA]; a_dns: CE_POINTER [CE_POINTER [PD_CURL_DNS_ENTRY]]): NATURAL_32
		do
			a_dns.item := create {CE_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
			Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
		end

	Curl_resolv_getsock (a_conn: CE_POINTER [PD_CONNECTDATA]; a_sock: CE_POINTER [INTEGER_32]; a_numsocks: INTEGER_32): INTEGER_32
		do
			Result := 0
		end

	Curl_wait_for_resolv (a_conn: CE_POINTER [PD_CONNECTDATA]; a_entry: CE_POINTER [CE_POINTER [PD_CURL_DNS_ENTRY]]): NATURAL_32
		do
			a_entry.item := create {CE_POINTER [PD_CURL_DNS_ENTRY]}.make_shared (default_pointer)
			Result := ({PC_CURLCODE}.CURLE_COULDNT_RESOLVE_HOST)
		end

end
