class
	PD_MP_ALGDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	mp_lc: CE_POINTER [ANY] assign set_mp_lc

feature {ANY} -- setters

	set_mp_lc (a_mp_lc: CE_POINTER [ANY])
		do
			mp_lc := a_mp_lc
			update_memory_field ("mp_lc")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mp_lc := a_other.mp_lc
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mp_lc.is_equal (a_other.mp_lc)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("mp_lc")
				>>)
			init_structure_info
		end

end
