class
	P_AORS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpq_add (a_rop: CE_POINTER [PD_MPQ_STRUCT]; a_op1: CE_POINTER [PD_MPQ_STRUCT]; a_op2: CE_POINTER [PD_MPQ_STRUCT])
		do
			gmpq_aors (gmpz_add_address, a_rop, a_op1, a_op2)
		end

	gmpq_aors (a_fun: CE_ROUTINE; a_rop: CE_POINTER [PD_MPQ_STRUCT]; a_op1: CE_POINTER [PD_MPQ_STRUCT]; a_op2: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_gcd: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp1: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp2: CE_ARRAY [PD_MPZ_STRUCT]
			l_op1_num_size: INTEGER_32
			l_tmp: INTEGER_32
			l_op1_den_size: INTEGER_32
			l_op2_num_size: INTEGER_32
			l_tmp___0: INTEGER_32
			l_op2_den_size: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___8: INTEGER_32
			l___x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___13: CE_POINTER [ANY]
			l___x___1: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___18: CE_POINTER [ANY]
			l_t: CE_ARRAY [PD_MPZ_STRUCT]
			l___x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___26: INTEGER_32
			l_tmp___37: INTEGER_32
			l_tmp___38: INTEGER_32
			l_tmp___39: INTEGER_32
			l_tmp___40: INTEGER_32
			l_tmp___41: INTEGER_32
			l_tmp___45: INTEGER_32
			l_tmp___46: INTEGER_32
			l_tmp___47: INTEGER_32
			l_tmp___48: INTEGER_32
			l_tmp___49: INTEGER_32
			l_tmp___51: CE_POINTER [ANY]
			l_tmp___54: INTEGER_32
			l_tmp___55: INTEGER_32
			l_tmp___56: INTEGER_32
			l_tmp___57: INTEGER_32
			l_tmp___58: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_gcd.make (<<1>>)
			create l_tmp1.make (<<1>>)
			create l_tmp2.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l___x.make
			create l_tmp___7.make
			create l___x___0.make
			create l_tmp___13.make
			create l___x___1.make
			create l_tmp___18.make
			create l_t.make (<<1>>)
			create l___x___2.make
			create l_tmp___51.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_op1.item.mp_num.mp_size >= 0 then
						l_tmp := a_op1.item.mp_num.mp_size
					else
						l_tmp := -a_op1.item.mp_num.mp_size
					end
					l_op1_num_size := l_tmp.to_integer_32
					l_op1_den_size := (a_op1.item.mp_den.mp_size).to_integer_32
					if a_op2.item.mp_num.mp_size >= 0 then
						l_tmp___0 := a_op2.item.mp_num.mp_size
					else
						l_tmp___0 := -a_op2.item.mp_num.mp_size
					end
					l_op2_num_size := l_tmp___0.to_integer_32
					l_op2_den_size := (a_op2.item.mp_den.mp_size).to_integer_32
					l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					from
					until
						js.loop_done
					loop
						l___x := l_gcd
						if l_op1_den_size < l_op2_den_size then
							l___x.item.mp_alloc := l_op1_den_size.to_integer_32
						else
							l___x.item.mp_alloc := l_op2_den_size.to_integer_32
						end
						if l_op1_den_size < l_op2_den_size then
							l_tmp___8 := l_op1_den_size
						else
							l_tmp___8 := l_op2_den_size
						end
						if (builtin_expect ((l_tmp___8.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							if l_op1_den_size < l_op2_den_size then
								l_tmp___3 := l_op1_den_size
							else
								l_tmp___3 := l_op2_den_size
							end
							l_tmp___7 := (l_aaf.new ((l_tmp___3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							if l_op1_den_size < l_op2_den_size then
								l_tmp___5 := l_op1_den_size
							else
								l_tmp___5 := l_op2_den_size
							end
							l_tmp___7 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___5.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l___x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7)
						js.break
					end
					from
					until
						js.loop_done
					loop
						l___x___0 := l_tmp1
						l___x___0.item.mp_alloc := (l_op1_num_size + l_op2_den_size).to_integer_32
						if (builtin_expect (((l_op1_num_size + l_op2_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___13 := (l_aaf.new (((l_op1_num_size + l_op2_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___13 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_op1_num_size + l_op2_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l___x___0.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13)
						js.break
					end
					from
					until
						js.loop_done
					loop
						l___x___1 := l_tmp2
						l___x___1.item.mp_alloc := (l_op2_num_size + l_op1_den_size).to_integer_32
						if (builtin_expect (((l_op2_num_size + l_op1_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___18 := (l_aaf.new (((l_op2_num_size + l_op1_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___18 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_op2_num_size + l_op1_den_size).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l___x___1.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___18)
						js.break
					end
					gcd_inst.gmpz_gcd (l_gcd, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
					if l_gcd[0].mp_size /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_gcd[0].mp_d[0] = {NATURAL_32} 1 then
							mul_inst.gmpz_mul (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
							mul_inst.gmpz_mul (l_tmp2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
							a_fun.call ([create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2)])
							mul_inst.gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						divegcd_inst.gmpz_divexact_gcd (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
						mul_inst.gmpz_mul (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1))
						divegcd_inst.gmpz_divexact_gcd (l_tmp2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
						mul_inst.gmpz_mul (l_tmp2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
						from
						until
							js.loop_done
						loop
							l___x___2 := l_t
							if l_tmp1[0].mp_size >= 0 then
								l_tmp___25 := l_tmp1[0].mp_size
							else
								l_tmp___25 := -l_tmp1[0].mp_size
							end
							if l_tmp2[0].mp_size >= 0 then
								l_tmp___26 := l_tmp2[0].mp_size
							else
								l_tmp___26 := -l_tmp2[0].mp_size
							end
							if l_tmp___25 > l_tmp___26 then
								if l_tmp1[0].mp_size >= 0 then
									l_tmp___22 := l_tmp1[0].mp_size
								else
									l_tmp___22 := -l_tmp1[0].mp_size
								end
								l_tmp___24 := l_tmp___22
							else
								if l_tmp2[0].mp_size >= 0 then
									l_tmp___23 := l_tmp2[0].mp_size
								else
									l_tmp___23 := -l_tmp2[0].mp_size
								end
								l_tmp___24 := l_tmp___23
							end
							l___x___2.item.mp_alloc := l_tmp___24 + 1
							if l_tmp1[0].mp_size >= 0 then
								l_tmp___57 := l_tmp1[0].mp_size
							else
								l_tmp___57 := -l_tmp1[0].mp_size
							end
							if l_tmp2[0].mp_size >= 0 then
								l_tmp___58 := l_tmp2[0].mp_size
							else
								l_tmp___58 := -l_tmp2[0].mp_size
							end
							if l_tmp___57 > l_tmp___58 then
								if l_tmp1[0].mp_size >= 0 then
									l_tmp___54 := l_tmp1[0].mp_size
								else
									l_tmp___54 := -l_tmp1[0].mp_size
								end
								l_tmp___56 := l_tmp___54
							else
								if l_tmp2[0].mp_size >= 0 then
									l_tmp___55 := l_tmp2[0].mp_size
								else
									l_tmp___55 := -l_tmp2[0].mp_size
								end
								l_tmp___56 := l_tmp___55
							end
							if (builtin_expect (((l_tmp___56 + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								if l_tmp1[0].mp_size >= 0 then
									l_tmp___40 := l_tmp1[0].mp_size
								else
									l_tmp___40 := -l_tmp1[0].mp_size
								end
								if l_tmp2[0].mp_size >= 0 then
									l_tmp___41 := l_tmp2[0].mp_size
								else
									l_tmp___41 := -l_tmp2[0].mp_size
								end
								if l_tmp___40 > l_tmp___41 then
									if l_tmp1[0].mp_size >= 0 then
										l_tmp___37 := l_tmp1[0].mp_size
									else
										l_tmp___37 := -l_tmp1[0].mp_size
									end
									l_tmp___39 := l_tmp___37
								else
									if l_tmp2[0].mp_size >= 0 then
										l_tmp___38 := l_tmp2[0].mp_size
									else
										l_tmp___38 := -l_tmp2[0].mp_size
									end
									l_tmp___39 := l_tmp___38
								end
								l_tmp___51 := (l_aaf.new ((l_tmp___39 + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
							else
								if l_tmp1[0].mp_size >= 0 then
									l_tmp___48 := l_tmp1[0].mp_size
								else
									l_tmp___48 := -l_tmp1[0].mp_size
								end
								if l_tmp2[0].mp_size >= 0 then
									l_tmp___49 := l_tmp2[0].mp_size
								else
									l_tmp___49 := -l_tmp2[0].mp_size
								end
								if l_tmp___48 > l_tmp___49 then
									if l_tmp1[0].mp_size >= 0 then
										l_tmp___45 := l_tmp1[0].mp_size
									else
										l_tmp___45 := -l_tmp1[0].mp_size
									end
									l_tmp___47 := l_tmp___45
								else
									if l_tmp2[0].mp_size >= 0 then
										l_tmp___46 := l_tmp2[0].mp_size
									else
										l_tmp___46 := -l_tmp2[0].mp_size
									end
									l_tmp___47 := l_tmp___46
								end
								l_tmp___51 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___47 + 1).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32))
							end
							l___x___2.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___51)
							js.break
						end
						a_fun.call ([l_t, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2)])
						divegcd_inst.gmpz_divexact_gcd (l_tmp2, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op1.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
						gcd_inst.gmpz_gcd (l_gcd, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
						if l_gcd[0].mp_size = 1 then
							if l_gcd[0].mp_d[0] = {NATURAL_32} 1 then
								set_inst.gmpz_set (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t))
								mul_inst.gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
							else
								divegcd_inst.gmpz_divexact_gcd (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
								divegcd_inst.gmpz_divexact_gcd (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
								mul_inst.gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
							end
						else
							divegcd_inst.gmpz_divexact_gcd (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_t), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
							divegcd_inst.gmpz_divexact_gcd (l_tmp1, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_op2.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_gcd))
							mul_inst.gmpz_mul (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_rop.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp1), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp2))
						end
				when 4 then
					from
					until
						js.loop_done
					loop
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						js.break
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpq_sub (a_rop: CE_POINTER [PD_MPQ_STRUCT]; a_op1: CE_POINTER [PD_MPQ_STRUCT]; a_op2: CE_POINTER [PD_MPQ_STRUCT])
		do
			gmpq_aors (gmpz_sub_address, a_rop, a_op1, a_op2)
		end

	gmpz_add (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_abs_vsize: INTEGER_32
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_size_t_swap__tmp: INTEGER_32
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l_cy_limb: NATURAL_32
			js: JUMP_STATE
		do
			create l_u.make
			create l_v.make
			create l_up.make
			create l_vp.make
			create l_wp.make
			create l___mpz_srcptr_swap__tmp.make

			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (l_v.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_abs_vsize := l_vsize
			else
				l_abs_vsize := -l_vsize
			end
			if l_abs_usize < l_abs_vsize then
				from
				until
					js.loop_done
				loop
					l___mpz_srcptr_swap__tmp := l_u
					l_u := l_v
					l_v := l___mpz_srcptr_swap__tmp
					js.break
				end
				from
				until
					js.loop_done
				loop
					l___mp_size_t_swap__tmp := l_usize
					l_usize := l_vsize
					l_vsize := l___mp_size_t_swap__tmp
					js.break
				end
				from
				until
					js.loop_done
				loop
					l___mp_size_t_swap__tmp___0 := l_abs_usize
					l_abs_usize := l_abs_vsize
					l_abs_vsize := l___mp_size_t_swap__tmp___0
					js.break
				end
			end
			l_wsize := l_abs_usize + 1
			if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
				realloc_inst.gmpz_realloc (a_w, l_wsize).do_nothing
			end
			l_up := l_u.item.mp_d
			l_vp := l_v.item.mp_d
			l_wp := a_w.item.mp_d
			if ((l_usize).bit_xor (l_vsize)) < 0 then
				if l_abs_usize /= l_abs_vsize then
					gmp_inst.gmpn_sub (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_wsize > 0))
						loop
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_wsize := l_wsize - 1
							end
						end
						js.break
					end
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				elseif (gmp_inst.gmpn_cmp (l_up, l_vp, l_abs_usize)) < 0 then
					gmp_inst.gmpn_sub_n (l_wp, l_vp, l_up, l_abs_usize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_wsize > 0))
						loop
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_wsize := l_wsize - 1
							end
						end
						js.break
					end
					if l_usize >= 0 then
						l_wsize := -l_wsize
					end
				else
					gmp_inst.gmpn_sub_n (l_wp, l_up, l_vp, l_abs_usize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_wsize > 0))
						loop
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_wsize := l_wsize - 1
							end
						end
						js.break
					end
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				end
			else
				l_cy_limb := (gmp_inst.gmpn_add (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize))
				l_wp[l_abs_usize] := l_cy_limb
				l_wsize := (l_abs_usize.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize < 0 then
					l_wsize := -l_wsize
				end
			end
			a_w.item.mp_size := l_wsize.to_integer_32
		end

	gmpz_add_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmpz_add)
		end

	gmpz_sub (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_u: CE_POINTER [PD_MPZ_STRUCT]
			l_v: CE_POINTER [PD_MPZ_STRUCT]
			l_up: CE_POINTER [NATURAL_32]
			l_vp: CE_POINTER [NATURAL_32]
			l_wp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_vsize: INTEGER_32
			l_wsize: INTEGER_32
			l_abs_usize: INTEGER_32
			l_abs_vsize: INTEGER_32
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_size_t_swap__tmp: INTEGER_32
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l_cy_limb: NATURAL_32
			js: JUMP_STATE
		do
			create l_u.make
			create l_v.make
			create l_up.make
			create l_vp.make
			create l_wp.make
			create l___mpz_srcptr_swap__tmp.make

			l_u := a_u
			l_v := a_v
			l_usize := (l_u.item.mp_size).to_integer_32
			l_vsize := (-l_v.item.mp_size).to_integer_32
			if l_usize >= 0 then
				l_abs_usize := l_usize
			else
				l_abs_usize := -l_usize
			end
			if l_vsize >= 0 then
				l_abs_vsize := l_vsize
			else
				l_abs_vsize := -l_vsize
			end
			if l_abs_usize < l_abs_vsize then
				from
				until
					js.loop_done
				loop
					l___mpz_srcptr_swap__tmp := l_u
					l_u := l_v
					l_v := l___mpz_srcptr_swap__tmp
					js.break
				end
				from
				until
					js.loop_done
				loop
					l___mp_size_t_swap__tmp := l_usize
					l_usize := l_vsize
					l_vsize := l___mp_size_t_swap__tmp
					js.break
				end
				from
				until
					js.loop_done
				loop
					l___mp_size_t_swap__tmp___0 := l_abs_usize
					l_abs_usize := l_abs_vsize
					l_abs_vsize := l___mp_size_t_swap__tmp___0
					js.break
				end
			end
			l_wsize := l_abs_usize + 1
			if (a_w.item.mp_alloc).to_integer_32 < l_wsize then
				realloc_inst.gmpz_realloc (a_w, l_wsize).do_nothing
			end
			l_up := l_u.item.mp_d
			l_vp := l_v.item.mp_d
			l_wp := a_w.item.mp_d
			if ((l_usize).bit_xor (l_vsize)) < 0 then
				if l_abs_usize /= l_abs_vsize then
					gmp_inst.gmpn_sub (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_wsize > 0))
						loop
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_wsize := l_wsize - 1
							end
						end
						js.break
					end
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				elseif (gmp_inst.gmpn_cmp (l_up, l_vp, l_abs_usize)) < 0 then
					gmp_inst.gmpn_sub_n (l_wp, l_vp, l_up, l_abs_usize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_wsize > 0))
						loop
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_wsize := l_wsize - 1
							end
						end
						js.break
					end
					if l_usize >= 0 then
						l_wsize := -l_wsize
					end
				else
					gmp_inst.gmpn_sub_n (l_wp, l_up, l_vp, l_abs_usize).do_nothing
					l_wsize := l_abs_usize
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_wsize > 0))
						loop
							if l_wp[(l_wsize - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_wsize := l_wsize - 1
							end
						end
						js.break
					end
					if l_usize < 0 then
						l_wsize := -l_wsize
					end
				end
			else
				l_cy_limb := (gmp_inst.gmpn_add (l_wp, l_up, l_abs_usize, l_vp, l_abs_vsize))
				l_wp[l_abs_usize] := l_cy_limb
				l_wsize := (l_abs_usize.to_natural_32 + l_cy_limb).to_integer_32
				if l_usize < 0 then
					l_wsize := -l_wsize
				end
			end
			a_w.item.mp_size := l_wsize.to_integer_32
		end

	gmpz_sub_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmpz_sub)
		end

end
