class
	P_BDIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_bdiv_qr (a_qp: CE_POINTER [NATURAL_32]; a_rp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_di: NATURAL_32
			l_rh: NATURAL_32
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l___n___0: NATURAL_32
			l___inv___0: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if 60 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						if not (a_dn >= 60) then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						if 60 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if not (a_nn - a_dn >= 60) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if 1_442 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if a_dn >= 1_442 then
							l_rh := mu_bdiv_qr_inst.gmpn_mu_bdiv_qr (a_qp, a_rp, a_np, a_nn, a_dp, a_dn, a_tp)
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_tp, a_np, a_nn)
								js.break
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							l___n___0 := a_dp[0]
							l___inv___0 := (gmp_impl_inst.gmp_binvert_limb_table[((l___n___0 // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l_di := (l___inv___0).bit_and ({NATURAL_32} 4_294_967_295)
							js.break
						end
						l_di := (-l_di.to_integer_32).to_natural_32
						l_rh := dcpi1_bdiv_qr_inst.gmpn_dcpi1_bdiv_qr (a_qp, a_tp, a_nn, a_dp, a_dn, l_di)
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_rp, ((a_tp + a_nn) - a_dn), a_dn)
								js.break
							end
							js.break
						end
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 11 -- goto _L___1
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___1:
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_tp, a_np, a_nn)
								js.break
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							l___n := a_dp[0]
							l___inv := (gmp_impl_inst.gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l_di := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
							js.break
						end
						l_di := (-l_di.to_integer_32).to_natural_32
						l_rh := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (a_qp, a_tp, a_nn, a_dp, a_dn, l_di)
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_rp, ((a_tp + a_nn) - a_dn), a_dn)
								js.break
							end
							js.break
						end
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_pos := -1 + 11 -- goto _L___1
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 11 -- goto _L___1
				when 16 then
					Result := l_rh
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_bdiv_qr_itch (a_nn: INTEGER_32; a_dn: INTEGER_32): INTEGER_32
		do
			if 1_442 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_dn >= 1_442 then
					Result := (mu_bdiv_qr_inst.gmpn_mu_bdiv_qr_itch (a_nn, a_dn))
				else
					Result := a_nn
				end
			else
				Result := a_nn
			end
		end

end
