class
	P_DIV_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_div_ui (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_rtp: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_rsize: INTEGER_32
			l_tsize: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_prec: INTEGER_32
			l_q_limb: NATURAL_32
			l_rexp: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_up.make
			create l_rp.make
			create l_tp.make
			create l_rtp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make
			create l___dst.make
			create l_tmp___4.make

			l_usize := (a_u.item.mp_size).to_integer_32
			l_sign_quotient := l_usize
			if l_usize >= 0 then
				l_usize := l_usize
			else
				l_usize := -l_usize
			end
			l_prec := (a_r.item.mp_prec).to_integer_32
			if a_v = {NATURAL_32} 0 then
				errno_inst.gmp_divide_by_zero
			end
			if l_usize = 0 then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_rp := a_r.item.mp_d
				l_up := a_u.item.mp_d
				l_tsize := 1 + l_prec
				if (builtin_expect (((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new (((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_tsize + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
				if l_usize > l_tsize then
					l_up := l_up + (l_usize - l_tsize)
					l_usize := l_tsize
					l_rtp := l_tp
				else
					from
					until
						js.loop_done
					loop
						if l_tsize - l_usize /= 0 then
							l___dst := l_tp
							l___n := l_tsize - l_usize
							from
							until
								js.loop_done
							loop
								l_tmp___4 := l___dst
								l___dst := l___dst + 1
								l_tmp___4.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
						end
						js.break
					end
					l_rtp := l_tp + (l_tsize - l_usize)
				end
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_rtp, l_up, l_usize)
						js.break
					end
					js.break
				end
				gmp_inst.gmpn_divrem_1 (l_rp, (0).to_integer_32, l_tp, l_tsize, a_v).do_nothing
				l_q_limb := l_rp[(l_tsize - 1)]
				l_rsize := l_tsize - (l_q_limb = {NATURAL_32} 0).to_integer
				l_rexp := (a_u.item.mp_exp - (l_q_limb = {NATURAL_32} 0).to_integer)
				if l_sign_quotient >= 0 then
					a_r.item.mp_size := l_rsize.to_integer_32
				else
					a_r.item.mp_size := (-l_rsize).to_integer_32
				end
				a_r.item.mp_exp := l_rexp
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
