class
	P_DOPRNTF

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_doprnt_mpf2 (a_funs: CE_POINTER [PD_DOPRNT_FUNS_T]; a_data: CE_POINTER [ANY]; a_p: CE_POINTER [PD_DOPRNT_PARAMS_T]; a_point: CE_POINTER [INTEGER_8]; a_f: CE_POINTER [PD_MPF_STRUCT]): INTEGER_32
		local
			l_prec: INTEGER_32
			l_ndigits: INTEGER_32
			l_free_size: INTEGER_32
			l_len: INTEGER_32
			l_newlen: INTEGER_32
			l_justify: INTEGER_32
			l_justlen: INTEGER_32
			l_explen: INTEGER_32
			l_showbaselen: INTEGER_32
			l_sign: INTEGER_32
			l_signlen: INTEGER_32
			l_intlen: INTEGER_32
			l_intzeros: INTEGER_32
			l_pointlen: INTEGER_32
			l_fraczeros: INTEGER_32
			l_fraclen: INTEGER_32
			l_preczeros: INTEGER_32
			l_s: CE_POINTER [INTEGER_8]
			l_free_ptr: CE_POINTER [INTEGER_8]
			l_exp: CE_ARRAY [INTEGER_32]
			l_exponent: CE_ARRAY [INTEGER_8]
			l_showbase: CE_POINTER [INTEGER_8]
			l_retval: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_tmp___3: INTEGER_32
			l_n: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___11: INTEGER_32
			l_expval: INTEGER_32
			l_expsign: INTEGER_8
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: NATURAL_32
			l___ret: INTEGER_32
			l___ret___0: INTEGER_32
			l___ret___1: INTEGER_32
			l___ret___2: INTEGER_32
			l___ret___3: INTEGER_32
			l___ret___4: INTEGER_32
			l___ret___5: INTEGER_32
			l___ret___6: INTEGER_32
			l___ret___7: INTEGER_32
			l___ret___8: INTEGER_32
			l___ret___9: INTEGER_32
			l___ret___10: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_free_ptr.make
			create l_exp.make (<<1>>)
			create l_exponent.make (<<42>>)
			create l_showbase.make
			create l_num_to_text.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := 0
					l_prec := a_p.item.prec
					if not (l_prec <= -1) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_ndigits := 0
						if a_p.item.conv = 3 then
							from
							until
								js.loop_done
							loop
								if a_p.item.base >= 0 then
									l_tmp := a_p.item.base
								else
									l_tmp := -a_p.item.base
								end
								l_prec := ({NATURAL_32} 2 + (((l_tmp.to_natural_32 - {NATURAL_32} 1) * {NATURAL_32} 32).to_real_64 * mp_bases_inst.gmpn_bases[a_f.item.mp_prec].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32).to_integer_32
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						inspect a_p.item.conv -- switch 1 head
						when 1 then l_pos := -1 + 4
						when 2 then l_pos := -1 + 5
						when 3 then l_pos := -1 + 6
						else l_pos := -1 + 6
						end
				when 4 then -- switch 1, case 1
						if a_p.item.base >= 0 then
							l_tmp___0 := a_p.item.base
						else
							l_tmp___0 := -a_p.item.base
						end
						l_ndigits := ((l_prec + 2).to_integer_32 + a_f.item.mp_exp * (mp_bases_inst.gmpn_bases[l_tmp___0].chars_per_limb + (a_f.item.mp_exp >= 0).to_integer).to_integer_32).to_integer_32
						if l_ndigits > 1 then
							l_ndigits := l_ndigits
						else
							l_ndigits := 1
						end
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 2
						l_ndigits := l_prec + 1
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default: | switch 1, case 3
						if l_prec > 1 then
							l_ndigits := l_prec
						else
							l_ndigits := 1
						end
						l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done: | if done
						l_s := get_str_inst.gmpf_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_exp, a_p.item.base, l_ndigits.to_natural_32, a_f)
						l_len := (strlen (l_s)).to_integer_32
						l_free_ptr := l_s
						l_free_size := l_len + 1
						l_sign := (a_p.item.sign).to_integer_32
						if (l_s[0]).to_integer_32 = 45 then
							l_sign := (l_s[0]).to_integer_32
							l_s := l_s + 1
							l_len := l_len - 1
						end
						l_signlen := (l_sign /= 0).to_integer
						inspect a_p.item.conv -- switch 2 head
						when 1 then l_pos := -1 + 8
						when 2 then l_pos := -1 + 10
						when 3 then l_pos := -1 + 12
						else l_pos := -1 + 12
						end
				when 8 then -- switch 2, case 1
						if l_prec <= -1 then
							if 0 > l_len.to_integer_32 - l_exp.item then
								l_prec := 0
							else
								l_prec := (l_len.to_integer_32 - l_exp.item).to_integer_32
							end
						end
						l_newlen := (l_exp.item + l_prec.to_integer_32).to_integer_32
						if l_newlen < 0 then
							l_len := 0
							l_exp.item := (0).to_integer_32
						elseif not (l_len <= l_newlen) then
							if a_p.item.base >= 0 then
								l_tmp___2 := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
							else
								l_tmp___2 := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
							end
							l_num_to_text := l_tmp___2
							if a_p.item.base >= 0 then
								l_tmp___3 := a_p.item.base
							else
								l_tmp___3 := -a_p.item.base
							end
							l_base := l_tmp___3
							l_len := l_newlen
							if ((((ctype_b_loc).item[(l_s[l_len]).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
								l_n := (l_s[l_len]).to_integer_32 - 48
							else
								if ((((ctype_b_loc).item[(l_s[l_len]).to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
									l_tmp___6 := ((l_s[l_len]).to_integer_32 - 97) + 10
								else
									l_tmp___6 := ((l_s[l_len]).to_integer_32 - 65) + 10
								end
								l_n := l_tmp___6
							end
							if l_n >= (l_base + 1) // 2 then
								from
								until
									js.loop_done
								loop
									if l_len = 0 then
										l_s[0] := (('1').code).to_integer_8
										l_len := 1
										l_exp.item := l_exp.item + 1
										js.break
									end
									if not js.loop_jumped then
										if ((((ctype_b_loc).item[(l_s[(l_len - 1)]).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
											l_n := (l_s[(l_len - 1)]).to_integer_32 - 48
										else
											if ((((ctype_b_loc).item[(l_s[(l_len - 1)]).to_integer_32]).to_integer_32).bit_and (512)).to_boolean then
												l_tmp___11 := ((l_s[(l_len - 1)]).to_integer_32 - 97) + 10
											else
												l_tmp___11 := ((l_s[(l_len - 1)]).to_integer_32 - 65) + 10
											end
											l_n := l_tmp___11
										end
										l_n := l_n + 1
										if l_n /= l_base then
											l_s[(l_len - 1)] := l_num_to_text[l_n]
											js.break
										end
									end
									if not js.loop_jumped then
										l_len := l_len - 1
									end
								end
							else
								from
								until
									js.loop_done
								loop
									if l_len > 0 then
										if (l_s[(l_len - 1)]).to_integer_32 /= 48 then
											js.break
										end
									else
										js.break
									end
									if not js.loop_jumped then
										l_len := l_len - 1
									end
								end
							end
							if l_len = 0 then
								l_exp.item := (0).to_integer_32
							end
						end
				when 9 then -- fixed:
						
						if l_exp.item <= 0 then
							l_intlen := 0
							l_intzeros := 1
							l_fraczeros := (-l_exp.item).to_integer_32
							l_fraclen := l_len
						else
							if l_len.to_integer_32 < l_exp.item then
								l_intlen := l_len
							else
								l_intlen := (l_exp.item).to_integer_32
							end
							l_intzeros := (l_exp.item - l_intlen.to_integer_32).to_integer_32
							l_fraczeros := 0
							l_fraclen := l_len - l_intlen
						end
						l_explen := 0
						l_pos := -1 + 13 -- switch 2; break
				when 10 then -- switch 2, case 2
						if l_prec <= -1 then
							if 0 > l_len - 1 then
								l_prec := 0
							else
								l_prec := l_len - 1
							end
						end
				when 11 then -- scientific:
						
						if 1 < l_len then
							l_intlen := 1
						else
							l_intlen := l_len
						end
						if l_intlen = 0 then
							l_intzeros := 1
						else
							l_intzeros := 0
						end
						l_fraczeros := 0
						l_fraclen := l_len - l_intlen
						l_expval := l_exp.item - l_intlen.to_integer_32
						if (a_p.item.exptimes4).to_boolean then
							l_expval := (l_expval).bit_shift_left ((2))
						end
						if l_expval >= 0 then
							l_expsign := (('+').code).to_integer_8
						else
							l_expsign := (('-').code).to_integer_8
						end
						if l_expval >= 0 then
							l_expval := l_expval
						else
							l_expval := -l_expval
						end
						l_explen := snprintf ([l_exponent, ({PLATFORM}.Integer_8_bytes.to_natural_32 * (42).to_natural_32), a_p.item.expfmt, l_expsign.to_integer_32, l_expval])
						l_pos := -1 + 13 -- switch 2; break
				when 12 then -- switch 2, default: | switch 2, case 3
						if l_exp.item - 1 < -4 then
							l_pos := -1 + 11 -- goto scientific
						else
							if 1 > l_prec then
								l_tmp___14 := 1
							else
								l_tmp___14 := l_prec
							end
							if l_exp.item - 1 >= l_tmp___14.to_integer_32 then
								l_pos := -1 + 11 -- goto scientific
							else
								l_pos := -1 + 9 -- goto fixed
							end
						end
				when 13 then -- switch 2, done:
						if (a_p.item.showtrailing).to_boolean then
							if a_p.item.conv = 3 then
								l_tmp___15 := l_intlen + l_intzeros
							else
								l_tmp___15 := 0
							end
							l_preczeros := l_prec - ((l_fraczeros + l_fraclen) + l_tmp___15)
							if 0 > l_preczeros then
								l_preczeros := 0
							else
								l_preczeros := l_preczeros
							end
						else
							l_preczeros := 0
						end
						if (l_fraczeros + l_fraclen) + l_preczeros /= 0 then
							l_tmp___16 := strlen (a_point)
							l_pointlen := l_tmp___16.to_integer_32
						elseif a_p.item.showpoint /= 0 then
							l_tmp___16 := strlen (a_point)
							l_pointlen := l_tmp___16.to_integer_32
						else
							l_pointlen := 0
						end
						l_showbase := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_showbaselen := 0
						inspect a_p.item.showbase -- switch 3 head
						when 2 then l_pos := -1 + 14
						when 3 then l_pos := -1 + 15
						when 1 then l_pos := -1 + 16
						else l_pos := -1 + 14
						end
				when 14 then -- switch 3, default: | switch 3, case 2
						l_pos := -1 + 21 -- switch 3; break
				when 15 then -- switch 3, case 3
						if l_intlen = 0 then
							if l_fraclen = 0 then
								l_pos := -1 + 21 -- switch 3; break
							end
						end
				when 16 then -- switch 3, case 1
						inspect a_p.item.base -- switch 4 head
						when 16 then l_pos := -1 + 17
						when -16 then l_pos := -1 + 18 -- -16
						when 8 then l_pos := -1 + 19
						else l_pos := -1 + 20
						end
				when 17 then -- switch 4, case 16
						l_showbase := ce_string ("0x")
						l_showbaselen := 2
						l_pos := -1 + 20 -- switch 4; break
				when 18 then -- switch 4, case -16
						l_showbase := ce_string ("0X")
						l_showbaselen := 2
						l_pos := -1 + 20 -- switch 4; break
				when 19 then -- switch 4, case 8
						l_showbase := ce_string ("0")
						l_showbaselen := 1
						l_pos := -1 + 20 -- switch 4; break
				when 20 then -- switch 4, done:
						l_pos := -1 + 21 -- switch 3; break
				when 21 then -- switch 3, done:
						l_justlen := (a_p.item.width - ((((((((l_signlen + l_showbaselen) + l_intlen) + l_intzeros) + l_pointlen) + l_fraczeros) + l_fraclen) + l_preczeros) + l_explen))
						l_justify := a_p.item.justify
						if l_justlen <= 0 then
							l_justify := 0
						end
						if l_justify /= 2 then
							l_pos := -1 + 27 -- skip if block
						end
				when 22 then -- if: | loop condition:
							if js.loop_done then
								l_pos := -1 + 27 -- skip loop
							end
				when 23 then -- loop body: | loop condition:
							if js.loop_done then
								l_pos := -1 + 26 -- skip loop
							end
				when 24 then -- loop body:
							l___ret := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
							if l___ret = -1 then
								l_pos := -1 + 107 -- goto error
							end
				when 25 then
							l_retval := l_retval + l___ret
							js.break
							l_pos := -1 + 23 -- back to loop condition
				when 26 then -- loop done
							js.break
							l_pos := -1 + 22 -- back to loop condition
				when 27 then -- loop done | if done
							if not (l_signlen.to_boolean) then
								l_pos := -1 + 33 -- skip if block
							end
				when 28 then -- if: | loop condition:
								if js.loop_done then
									l_pos := -1 + 33 -- skip loop
								end
				when 29 then -- loop body: | loop condition:
								if js.loop_done then
									l_pos := -1 + 32 -- skip loop
								end
				when 30 then -- loop body:
								l___ret___0 := (a_funs.item.reps).integer_32_item ([a_data, l_sign, 1])
								if l___ret___0 = -1 then
									l_pos := -1 + 107 -- goto error
								end
				when 31 then
								l_retval := l_retval + l___ret___0
								js.break
								l_pos := -1 + 29 -- back to loop condition
				when 32 then -- loop done
								js.break
								l_pos := -1 + 28 -- back to loop condition
				when 33 then -- loop done | if done
								if js.loop_done then
									l_pos := -1 + 41 -- skip loop
								end
				when 34 then -- loop body:
									if l_showbaselen = 0 then
										l_pos := -1 + 40 -- skip if block
									end
				when 35 then -- if: | loop condition:
									if js.loop_done then
										l_pos := -1 + 40 -- skip loop
									end
				when 36 then -- loop body: | loop condition:
									if js.loop_done then
										l_pos := -1 + 39 -- skip loop
									end
				when 37 then -- loop body:
									l___ret___1 := (a_funs.item.memory).integer_32_item ([a_data, l_showbase, l_showbaselen.to_natural_32])
									if l___ret___1 = -1 then
										l_pos := -1 + 107 -- goto error
									end
				when 38 then
									l_retval := l_retval + l___ret___1
									js.break
									l_pos := -1 + 36 -- back to loop condition
				when 39 then -- loop done
									js.break
									l_pos := -1 + 35 -- back to loop condition
				when 40 then -- loop done | if done
									js.break
									l_pos := -1 + 33 -- back to loop condition
				when 41 then -- loop done
								if l_justify /= 3 then
									l_pos := -1 + 47 -- skip if block
								end
				when 42 then -- if: | loop condition:
									if js.loop_done then
										l_pos := -1 + 47 -- skip loop
									end
				when 43 then -- loop body: | loop condition:
									if js.loop_done then
										l_pos := -1 + 46 -- skip loop
									end
				when 44 then -- loop body:
									l___ret___2 := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
									if l___ret___2 = -1 then
										l_pos := -1 + 107 -- goto error
									end
				when 45 then
									l_retval := l_retval + l___ret___2
									js.break
									l_pos := -1 + 43 -- back to loop condition
				when 46 then -- loop done
									js.break
									l_pos := -1 + 42 -- back to loop condition
				when 47 then -- loop done | if done
									if js.loop_done then
										l_pos := -1 + 52 -- skip loop
									end
				when 48 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 51 -- skip loop
										end
				when 49 then -- loop body:
										l___ret___3 := (a_funs.item.memory).integer_32_item ([a_data, l_s, l_intlen.to_natural_32])
										if l___ret___3 = -1 then
											l_pos := -1 + 107 -- goto error
										end
				when 50 then
										l_retval := l_retval + l___ret___3
										js.break
										l_pos := -1 + 48 -- back to loop condition
				when 51 then -- loop done
										js.break
										l_pos := -1 + 47 -- back to loop condition
				when 52 then -- loop done
									if js.loop_done then
										l_pos := -1 + 60 -- skip loop
									end
				when 53 then -- loop body:
										if l_intzeros = 0 then
											l_pos := -1 + 59 -- skip if block
										end
				when 54 then -- if: | loop condition:
										if js.loop_done then
											l_pos := -1 + 59 -- skip loop
										end
				when 55 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 58 -- skip loop
										end
				when 56 then -- loop body:
										l___ret___4 := (a_funs.item.reps).integer_32_item ([a_data, ('0').code, l_intzeros])
										if l___ret___4 = -1 then
											l_pos := -1 + 107 -- goto error
										end
				when 57 then
										l_retval := l_retval + l___ret___4
										js.break
										l_pos := -1 + 55 -- back to loop condition
				when 58 then -- loop done
										js.break
										l_pos := -1 + 54 -- back to loop condition
				when 59 then -- loop done | if done
										js.break
										l_pos := -1 + 52 -- back to loop condition
				when 60 then -- loop done
									if js.loop_done then
										l_pos := -1 + 68 -- skip loop
									end
				when 61 then -- loop body:
										if l_pointlen = 0 then
											l_pos := -1 + 67 -- skip if block
										end
				when 62 then -- if: | loop condition:
										if js.loop_done then
											l_pos := -1 + 67 -- skip loop
										end
				when 63 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 66 -- skip loop
										end
				when 64 then -- loop body:
										l___ret___5 := (a_funs.item.memory).integer_32_item ([a_data, a_point, l_pointlen.to_natural_32])
										if l___ret___5 = -1 then
											l_pos := -1 + 107 -- goto error
										end
				when 65 then
										l_retval := l_retval + l___ret___5
										js.break
										l_pos := -1 + 63 -- back to loop condition
				when 66 then -- loop done
										js.break
										l_pos := -1 + 62 -- back to loop condition
				when 67 then -- loop done | if done
										js.break
										l_pos := -1 + 60 -- back to loop condition
				when 68 then -- loop done
									if js.loop_done then
										l_pos := -1 + 76 -- skip loop
									end
				when 69 then -- loop body:
										if l_fraczeros = 0 then
											l_pos := -1 + 75 -- skip if block
										end
				when 70 then -- if: | loop condition:
										if js.loop_done then
											l_pos := -1 + 75 -- skip loop
										end
				when 71 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 74 -- skip loop
										end
				when 72 then -- loop body:
										l___ret___6 := (a_funs.item.reps).integer_32_item ([a_data, ('0').code, l_fraczeros])
										if l___ret___6 = -1 then
											l_pos := -1 + 107 -- goto error
										end
				when 73 then
										l_retval := l_retval + l___ret___6
										js.break
										l_pos := -1 + 71 -- back to loop condition
				when 74 then -- loop done
										js.break
										l_pos := -1 + 70 -- back to loop condition
				when 75 then -- loop done | if done
										js.break
										l_pos := -1 + 68 -- back to loop condition
				when 76 then -- loop done
									if js.loop_done then
										l_pos := -1 + 84 -- skip loop
									end
				when 77 then -- loop body:
										if l_fraclen = 0 then
											l_pos := -1 + 83 -- skip if block
										end
				when 78 then -- if: | loop condition:
										if js.loop_done then
											l_pos := -1 + 83 -- skip loop
										end
				when 79 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 82 -- skip loop
										end
				when 80 then -- loop body:
										l___ret___7 := (a_funs.item.memory).integer_32_item ([a_data, (l_s + l_intlen), l_fraclen.to_natural_32])
										if l___ret___7 = -1 then
											l_pos := -1 + 107 -- goto error
										end
				when 81 then
										l_retval := l_retval + l___ret___7
										js.break
										l_pos := -1 + 79 -- back to loop condition
				when 82 then -- loop done
										js.break
										l_pos := -1 + 78 -- back to loop condition
				when 83 then -- loop done | if done
										js.break
										l_pos := -1 + 76 -- back to loop condition
				when 84 then -- loop done
									if js.loop_done then
										l_pos := -1 + 92 -- skip loop
									end
				when 85 then -- loop body:
										if l_preczeros = 0 then
											l_pos := -1 + 91 -- skip if block
										end
				when 86 then -- if: | loop condition:
										if js.loop_done then
											l_pos := -1 + 91 -- skip loop
										end
				when 87 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 90 -- skip loop
										end
				when 88 then -- loop body:
										l___ret___8 := (a_funs.item.reps).integer_32_item ([a_data, ('0').code, l_preczeros])
										if l___ret___8 = -1 then
											l_pos := -1 + 107 -- goto error
										end
				when 89 then
										l_retval := l_retval + l___ret___8
										js.break
										l_pos := -1 + 87 -- back to loop condition
				when 90 then -- loop done
										js.break
										l_pos := -1 + 86 -- back to loop condition
				when 91 then -- loop done | if done
										js.break
										l_pos := -1 + 84 -- back to loop condition
				when 92 then -- loop done
									if js.loop_done then
										l_pos := -1 + 100 -- skip loop
									end
				when 93 then -- loop body:
										if l_explen = 0 then
											l_pos := -1 + 99 -- skip if block
										end
				when 94 then -- if: | loop condition:
										if js.loop_done then
											l_pos := -1 + 99 -- skip loop
										end
				when 95 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 98 -- skip loop
										end
				when 96 then -- loop body:
										l___ret___9 := (a_funs.item.memory).integer_32_item ([a_data, l_exponent, l_explen.to_natural_32])
										if l___ret___9 = -1 then
											l_pos := -1 + 107 -- goto error
										end
				when 97 then
										l_retval := l_retval + l___ret___9
										js.break
										l_pos := -1 + 95 -- back to loop condition
				when 98 then -- loop done
										js.break
										l_pos := -1 + 94 -- back to loop condition
				when 99 then -- loop done | if done
										js.break
										l_pos := -1 + 92 -- back to loop condition
				when 100 then -- loop done
									if l_justify /= 1 then
										l_pos := -1 + 106 -- skip if block
									end
				when 101 then -- if: | loop condition:
										if js.loop_done then
											l_pos := -1 + 106 -- skip loop
										end
				when 102 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 105 -- skip loop
										end
				when 103 then -- loop body:
										l___ret___10 := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
										if l___ret___10 = -1 then
											l_pos := -1 + 107 -- goto error
										end
				when 104 then
										l_retval := l_retval + l___ret___10
										js.break
										l_pos := -1 + 102 -- back to loop condition
				when 105 then -- loop done
										js.break
										l_pos := -1 + 101 -- back to loop condition
				when 106 then -- loop done | done:
										memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_free_ptr), l_free_size.to_natural_32])
										Result := l_retval
										js.return
										if js.return_called then
											l_pos := -1 + 108 -- skip if block
										end
				when 107 then -- if: | error:
											l_retval := -1
											l_pos := -1 + 106 -- goto done
				when 108 then
										l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
							end

end
