class
	P_GCD_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_gcd_ui (a_w: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: NATURAL_32): NATURAL_32
		local
			l_un: INTEGER_32
			l_res: NATURAL_32
			l_tmp___0: NATURAL_32
			js: JUMP_STATE
		do
			if a_u.item.mp_size >= 0 then
				l_un := (a_u.item.mp_size).to_integer_32
			else
				l_un := (-a_u.item.mp_size).to_integer_32
			end
			if l_un = 0 then
				l_res := a_v
			elseif a_v = {NATURAL_32} 0 then
				if not a_w.is_void then
					if not a_u.is_equal (a_w) then
						if (builtin_expect ((l_un > (a_w.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
							realloc_inst.gmpz_realloc (a_w, l_un).do_nothing
						end
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_w.item.mp_d, a_u.item.mp_d, l_un)
								js.break
							end
							js.break
						end
					end
					a_w.item.mp_size := l_un.to_integer_32
				end
				l_res := a_u.item.mp_d[0]
				if l_un = 1 then
					if l_res <= {NATURAL_32} 4_294_967_295 then
						l_tmp___0 := l_res
					else
						l_tmp___0 := (0).to_natural_32
					end
				else
					l_tmp___0 := (0).to_natural_32
				end
				Result := l_tmp___0
				js.return
			else
				l_res := gcd_1_inst.gmpn_gcd_1 (a_u.item.mp_d, l_un, a_v)
			end
			if not js.return_called then
				if not a_w.is_void then
					a_w.item.mp_d[0] := l_res
					a_w.item.mp_size := (l_res /= {NATURAL_32} 0).to_integer
				end
				Result := l_res
			end
		end

end
