class
	P_GCDEXT_1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_gcdext_1 (a_up: CE_POINTER [INTEGER_32]; a_vp: CE_POINTER [INTEGER_32]; a_a: NATURAL_32; a_b: NATURAL_32): NATURAL_32
		local
			l_a: NATURAL_32
			l_b: NATURAL_32
			l_u0: INTEGER_32
			l_v0: INTEGER_32
			l_u1: INTEGER_32
			l_v1: INTEGER_32
			l_q: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					l_b := a_b
					l_u0 := (1).to_integer_32
					l_v0 := (0).to_integer_32
					l_u1 := (0).to_integer_32
					l_v1 := (1).to_integer_32
					if l_a < l_b then
						l_pos := -1 + 4 -- goto divide_by_b
					end
				when 1 then
					if js.loop_done then
						l_pos := -1 + 6 -- skip loop
					end
				when 2 then -- loop body:
						l_q := l_a // l_b
						l_a := l_a - (l_q * l_b)
						if l_a = {NATURAL_32} 0 then
							a_up.item := l_u1
							a_vp.item := l_v1
							Result := l_b
							js.return
						end
						if js.return_called then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_u0 := (l_u0.to_natural_32 - l_q * l_u1.to_natural_32).to_integer_32
						l_v0 := (l_v0.to_natural_32 - l_q * l_v1.to_natural_32).to_integer_32
				when 4 then -- divide_by_b:
						l_q := l_b // l_a
						l_b := l_b - (l_q * l_a)
						if l_b = {NATURAL_32} 0 then
							a_up.item := l_u0
							a_vp.item := l_v0
							Result := l_a
							js.return
						end
				when 5 then -- if done
						if not js.return_called then
							l_u1 := (l_u1.to_natural_32 - l_q * l_u0.to_natural_32).to_integer_32
							l_v1 := (l_v1.to_natural_32 - l_q * l_v0.to_natural_32).to_integer_32
						end
						l_pos := -1 + 1 -- back to loop condition
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
