class
	P_GCDEXT_SUBDIV_STEP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_gcdext_subdiv_step (a_gp: CE_POINTER [NATURAL_32]; a_gn: CE_POINTER [INTEGER_32]; a_up: CE_POINTER [NATURAL_32]; a_usizep: CE_POINTER [INTEGER_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_u0: CE_POINTER [NATURAL_32]; a_u1: CE_POINTER [NATURAL_32]; a_unp: CE_POINTER [INTEGER_32]; a_qp: CE_POINTER [NATURAL_32]; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_n: INTEGER_32
			l_u0: CE_POINTER [NATURAL_32]
			l_u1: CE_POINTER [NATURAL_32]
			l_an: INTEGER_32
			l_bn: INTEGER_32
			l_un: INTEGER_32
			l_qn: INTEGER_32
			l_u0n: INTEGER_32
			l_swapped: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l___gmp_i___0: INTEGER_32
			l___gmp_x___0: NATURAL_32
			l___gmp_y___0: NATURAL_32
			l___mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___2: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___3: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l___mp_ptr_swap__tmp___4: CE_POINTER [NATURAL_32]
			l_c___0: INTEGER_32
			l___gmp_i___1: INTEGER_32
			l___gmp_x___1: NATURAL_32
			l___gmp_y___1: NATURAL_32
			l___mp_ptr_swap__tmp___5: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___6: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ap.make
			create l_bp.make
			create l_u0.make
			create l_u1.make
			create l___mp_ptr_swap__tmp.make
			create l___mp_ptr_swap__tmp___0.make
			create l___mp_ptr_swap__tmp___1.make
			create l___mp_ptr_swap__tmp___2.make
			create l___mp_ptr_swap__tmp___3.make
			create l___mp_ptr_swap__tmp___4.make
			create l___mp_ptr_swap__tmp___5.make
			create l___mp_ptr_swap__tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap := a_ap
					l_bp := a_bp
					l_n := a_n
					l_u0 := a_u0
					l_u1 := a_u1
					l_bn := l_n
					l_an := l_bn
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_an > 0))
						loop
							if l_ap[(l_an - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_an := l_an - 1
							end
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_bn > 0))
						loop
							if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_bn := l_bn - 1
							end
						end
						js.break
					end
					l_un := a_unp.item
					l_swapped := 0
					if not ((builtin_expect ((l_an = 0).to_integer, 0)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if: | return_b:
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_gp, l_bp, l_bn)
								js.break
							end
							js.break
						end
						a_gn.item := l_bn
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_un > 0))
							loop
								if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_un := l_un - 1
								end
							end
							js.break
						end
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_up, l_u0, l_un)
								js.break
							end
							js.break
						end
						if l_swapped.to_boolean then
							a_usizep.item := l_un
						else
							a_usizep.item := -l_un
						end
						Result := (0).to_integer_32
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else:
						if (builtin_expect ((l_bn = 0).to_integer, 0)).to_boolean then
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (a_gp, l_ap, l_an)
									js.break
								end
								js.break
							end
							a_gn.item := l_an
							from
							until
								js.loop_done
							loop
								from
								until
									not (not js.loop_done and then (l_un > 0))
								loop
									if l_u1[(l_un - 1)] /= {NATURAL_32} 0 then
										js.break
									end
									if not js.loop_jumped then
										l_un := l_un - 1
									end
								end
								js.break
							end
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (a_up, l_u1, l_un)
									js.break
								end
								js.break
							end
							if l_swapped.to_boolean then
								a_usizep.item := -l_un
							else
								a_usizep.item := l_un
							end
							Result := (0).to_integer_32
							js.return
						end
				when 4 then -- if done
					if not js.return_called then
						if l_an < l_bn then
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									l___mp_ptr_swap__tmp := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp
									js.break
								end
								from
								until
									js.loop_done
								loop
									l___mp_size_t_swap__tmp := l_an
									l_an := l_bn
									l_bn := l___mp_size_t_swap__tmp
									js.break
								end
								js.break
							end
							from
							until
								js.loop_done
							loop
								l___mp_ptr_swap__tmp___0 := l_u0
								l_u0 := l_u1
								l_u1 := l___mp_ptr_swap__tmp___0
								js.break
							end
							l_swapped := (l_swapped).bit_xor ((1))
						elseif l_an = l_bn then
							from
							until
								js.loop_done
							loop
								l_c := 0
								l___gmp_i := l_an
								from
								until
									js.loop_done
								loop
									l___gmp_i := l___gmp_i - 1
									if not (l___gmp_i >= 0) then
										js.break
									end
									if not js.loop_jumped then
										l___gmp_x := l_ap[l___gmp_i]
										l___gmp_y := l_bp[l___gmp_i]
										if l___gmp_x /= l___gmp_y then
											if l___gmp_x > l___gmp_y then
												l_c := 1
											else
												l_c := -1
											end
											js.break
										end
									end
								end
								js.break
							end
							if (builtin_expect ((l_c = 0).to_integer, 0)).to_boolean then
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										gmp_inst.gmpn_copyi (a_gp, l_ap, l_an)
										js.break
									end
									js.break
								end
								a_gn.item := l_an
								from
								until
									js.loop_done
								loop
									l_c := 0
									l___gmp_i___0 := l_un
									from
									until
										js.loop_done
									loop
										l___gmp_i___0 := l___gmp_i___0 - 1
										if not (l___gmp_i___0 >= 0) then
											js.break
										end
										if not js.loop_jumped then
											l___gmp_x___0 := l_u0[l___gmp_i___0]
											l___gmp_y___0 := l_u1[l___gmp_i___0]
											if l___gmp_x___0 /= l___gmp_y___0 then
												if l___gmp_x___0 > l___gmp_y___0 then
													l_c := 1
												else
													l_c := -1
												end
												js.break
											end
										end
									end
									js.break
								end
								if l_c < 0 then
									from
									until
										js.loop_done
									loop
										from
										until
											not (not js.loop_done and then (l_un > 0))
										loop
											if l_u0[(l_un - 1)] /= {NATURAL_32} 0 then
												js.break
											end
											if not js.loop_jumped then
												l_un := l_un - 1
											end
										end
										js.break
									end
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											gmp_inst.gmpn_copyi (a_up, l_u0, l_un)
											js.break
										end
										js.break
									end
									l_swapped := (l_swapped).bit_xor ((1))
								else
									from
									until
										js.loop_done
									loop
										from
										until
											(l_u1[(l_un - 1)] /= {NATURAL_32} 0)
										loop
											l_un := l_un - 1
										end
										js.break
									end
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											gmp_inst.gmpn_copyi (a_up, l_u1, l_un)
											js.break
										end
										js.break
									end
								end
								if l_swapped.to_boolean then
									a_usizep.item := -l_un
								else
									a_usizep.item := l_un
								end
								Result := (0).to_integer_32
								js.return
							elseif l_c < 0 then
								from
								until
									js.loop_done
								loop
									l___mp_ptr_swap__tmp___1 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___1
									js.break
								end
								from
								until
									js.loop_done
								loop
									l___mp_ptr_swap__tmp___2 := l_u0
									l_u0 := l_u1
									l_u1 := l___mp_ptr_swap__tmp___2
									js.break
								end
								l_swapped := (l_swapped).bit_xor ((1))
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 5 then -- if:
						gmp_inst.gmpn_sub (l_ap, l_ap, l_an, l_bp, l_bn).do_nothing
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_an > 0))
							loop
								if l_ap[(l_an - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_an := l_an - 1
								end
							end
							js.break
						end
						l_u1[l_un] := gmp_inst.gmpn_add_n (l_u1, l_u1, l_u0, l_un)
						l_un := l_un + (l_u1[l_un] > {NATURAL_32} 0).to_integer
						if l_an < l_bn then
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									l___mp_ptr_swap__tmp___3 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___3
									js.break
								end
								from
								until
									js.loop_done
								loop
									l___mp_size_t_swap__tmp___0 := l_an
									l_an := l_bn
									l_bn := l___mp_size_t_swap__tmp___0
									js.break
								end
								js.break
							end
							from
							until
								js.loop_done
							loop
								l___mp_ptr_swap__tmp___4 := l_u0
								l_u0 := l_u1
								l_u1 := l___mp_ptr_swap__tmp___4
								js.break
							end
							l_swapped := (l_swapped).bit_xor ((1))
						elseif l_an = l_bn then
							from
							until
								js.loop_done
							loop
								l_c___0 := 0
								l___gmp_i___1 := l_an
								from
								until
									js.loop_done
								loop
									l___gmp_i___1 := l___gmp_i___1 - 1
									if not (l___gmp_i___1 >= 0) then
										js.break
									end
									if not js.loop_jumped then
										l___gmp_x___1 := l_ap[l___gmp_i___1]
										l___gmp_y___1 := l_bp[l___gmp_i___1]
										if l___gmp_x___1 /= l___gmp_y___1 then
											if l___gmp_x___1 > l___gmp_y___1 then
												l_c___0 := 1
											else
												l_c___0 := -1
											end
											js.break
										end
									end
								end
								js.break
							end
							if (builtin_expect ((l_c___0 = 0).to_integer, 0)).to_boolean then
								l_pos := -1 + 1 -- goto return_b
							elseif l_c___0 < 0 then
								from
								until
									js.loop_done
								loop
									l___mp_ptr_swap__tmp___5 := l_ap
									l_ap := l_bp
									l_bp := l___mp_ptr_swap__tmp___5
									js.break
								end
								from
								until
									js.loop_done
								loop
									l___mp_ptr_swap__tmp___6 := l_u0
									l_u0 := l_u1
									l_u1 := l___mp_ptr_swap__tmp___6
									js.break
								end
								l_swapped := (l_swapped).bit_xor ((1))
							end
						end
				when 6 then
						l_qn := (l_an - l_bn) + 1
						tdiv_qr_inst.gmpn_tdiv_qr (a_qp, l_ap, (0).to_integer_32, l_ap, l_an, l_bp, l_bn)
						if (gmp_impl_inst.mpn_zero_p (l_ap, l_bn)).to_boolean then
							l_pos := -1 + 1 -- goto return_b
						end
				when 7 then
						l_n := l_bn
						l_u0n := l_un
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_u0n > 0))
							loop
								if l_u0[(l_u0n - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_u0n := l_u0n - 1
								end
							end
							js.break
						end
						if l_u0n > 0 then
							l_qn := l_qn - (a_qp[(l_qn - 1)] = {NATURAL_32} 0).to_integer
							if l_qn > l_u0n then
								mul_inst.gmpn_mul (a_tp, a_qp, l_qn, l_u0, l_u0n).do_nothing
							else
								mul_inst.gmpn_mul (a_tp, l_u0, l_u0n, a_qp, l_qn).do_nothing
							end
							if l_qn + l_u0n > l_un then
								gmp_inst.gmpn_add (l_u1, a_tp, l_qn + l_u0n, l_u1, l_un).do_nothing
								l_un := l_qn + l_u0n
								l_un := l_un - (l_u1[(l_un - 1)] = {NATURAL_32} 0).to_integer
							else
								l_u1[l_un] := gmp_inst.gmpn_add (l_u1, l_u1, l_un, a_tp, l_qn + l_u0n)
								l_un := l_un + (l_u1[l_un] > {NATURAL_32} 0).to_integer
							end
						end
						a_unp.item := l_un
						Result := l_n
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
