class
	P_GET_NUM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpq_get_num (a_num: CE_POINTER [PD_MPZ_STRUCT]; a_src: CE_POINTER [PD_MPQ_STRUCT])
		local
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			l_size := (a_src.item.mp_num.mp_size).to_integer_32
			if l_size >= 0 then
				l_tmp := l_size
			else
				l_tmp := -l_size
			end
			l_abs_size := l_tmp
			if (a_num.item.mp_alloc).to_integer_32 < l_abs_size then
				realloc_inst.gmpz_realloc (a_num, l_abs_size).do_nothing
			end
			from
			until
				js.loop_done
			loop
				from
				until
					js.loop_done
				loop
					gmp_inst.gmpn_copyi (a_num.item.mp_d, a_src.item.mp_num.mp_d, l_abs_size)
					js.break
				end
				js.break
			end
			a_num.item.mp_size := l_size.to_integer_32
		end

end
