class
	P_HGCD2

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	div1 (a_rp: CE_POINTER [NATURAL_32]; a_n0: NATURAL_32; a_d0: NATURAL_32): NATURAL_32
		local
			l_n0: NATURAL_32
			l_d0: NATURAL_32
			l_q: NATURAL_32
			l_cnt: INTEGER_32
			l_cnt___0: INTEGER_32
		do
			l_n0 := a_n0
			l_d0 := a_d0
			l_q := (0).to_natural_32
			if l_n0.to_integer_32 < 0 then
				l_cnt := 1
				from
				until
					not (l_d0.to_integer_32 >= 0)
				loop
					l_d0 := (l_d0).bit_shift_left ((1))
					l_cnt := l_cnt + 1
				end
				l_q := (0).to_natural_32
				from
				until
					not (l_cnt.to_boolean)
				loop
					l_q := (l_q).bit_shift_left ((1))
					if l_n0 >= l_d0 then
						l_n0 := l_n0 - l_d0
						l_q := (l_q).bit_or (({NATURAL_32} 1))
					end
					l_d0 := (l_d0).bit_shift_right ((1))
					l_cnt := l_cnt - 1
				end
			else
				l_cnt___0 := 0
				from
				until
					not (l_n0 >= l_d0)
				loop
					l_d0 := (l_d0).bit_shift_left ((1))
					l_cnt___0 := l_cnt___0 + 1
				end
				l_q := (0).to_natural_32
				from
				until
					not (l_cnt___0.to_boolean)
				loop
					l_d0 := (l_d0).bit_shift_right ((1))
					l_q := (l_q).bit_shift_left ((1))
					if l_n0 >= l_d0 then
						l_n0 := l_n0 - l_d0
						l_q := (l_q).bit_or (({NATURAL_32} 1))
					end
					l_cnt___0 := l_cnt___0 - 1
				end
			end
			a_rp.item := l_n0
			Result := l_q
		end

	div2 (a_rp: CE_POINTER [NATURAL_32]; a_nh: NATURAL_32; a_nl: NATURAL_32; a_dh: NATURAL_32; a_dl: NATURAL_32): NATURAL_32
		local
			l_nl: CE_ARRAY [NATURAL_32]
			l_nh: CE_ARRAY [NATURAL_32]
			l_dh: CE_ARRAY [NATURAL_32]
			l_dl: CE_ARRAY [NATURAL_32]
			l_q: NATURAL_32
			l_cnt: INTEGER_32
			l_cnt___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_nl.make (<<1>>)
			create l_nh.make (<<1>>)
			create l_dh.make (<<1>>)
			create l_dl.make (<<1>>)

			l_nl.item := a_nl
			l_nh.item := a_nh
			l_dh.item := a_dh
			l_dl.item := a_dl
			l_q := (0).to_natural_32
			if (l_nh.item).to_integer_32 < 0 then
				l_cnt := 1
				from
				until
					not ((l_dh.item).to_integer_32 >= 0)
				loop
					l_dh.item := (((l_dh.item).bit_shift_left (1))).bit_or (((l_dl.item).bit_shift_right (31)))
					l_dl.item := (l_dl.item).bit_shift_left ((1))
					l_cnt := l_cnt + 1
				end
				from
				until
					not (l_cnt.to_boolean)
				loop
					l_q := (l_q).bit_shift_left ((1))
					if l_nh.item > l_dh.item then
						asm122 (l_nh, l_nl, l_dh, l_dl)
						l_q := (l_q).bit_or (({NATURAL_32} 1))
					elseif l_nh.item = l_dh.item then
						if l_nl.item >= l_dl.item then
							asm123 (l_nh, l_nl, l_dh, l_dl)
							l_q := (l_q).bit_or (({NATURAL_32} 1))
						end
					end
					l_dl.item := (((l_dh.item).bit_shift_left (31))).bit_or (((l_dl.item).bit_shift_right (1)))
					l_dh.item := (l_dh.item).bit_shift_right ((1))
					l_cnt := l_cnt - 1
				end
			else
				l_cnt___0 := 0
				from
				until
					js.loop_done
				loop
					if not (l_nh.item > l_dh.item) then
						if l_nh.item = l_dh.item then
							if not (l_nl.item >= l_dl.item) then
								js.break
							end
						else
							js.break
						end
					end
					if not js.loop_jumped then
						l_dh.item := (((l_dh.item).bit_shift_left (1))).bit_or (((l_dl.item).bit_shift_right (31)))
						l_dl.item := (l_dl.item).bit_shift_left ((1))
						l_cnt___0 := l_cnt___0 + 1
					end
				end
				from
				until
					not (l_cnt___0.to_boolean)
				loop
					l_dl.item := (((l_dh.item).bit_shift_left (31))).bit_or (((l_dl.item).bit_shift_right (1)))
					l_dh.item := (l_dh.item).bit_shift_right ((1))
					l_q := (l_q).bit_shift_left ((1))
					if l_nh.item > l_dh.item then
						asm124 (l_nh, l_nl, l_dh, l_dl)
						l_q := (l_q).bit_or (({NATURAL_32} 1))
					elseif l_nh.item = l_dh.item then
						if l_nl.item >= l_dl.item then
							asm125 (l_nh, l_nl, l_dh, l_dl)
							l_q := (l_q).bit_or (({NATURAL_32} 1))
						end
					end
					l_cnt___0 := l_cnt___0 - 1
				end
			end
			a_rp[0] := l_nl.item
			a_rp[1] := l_nh.item
			Result := l_q
		end

	gmpn_hgcd2 (a_ah: NATURAL_32; a_al: NATURAL_32; a_bh: NATURAL_32; a_bl: NATURAL_32; a_M: CE_POINTER [PD_HGCD_MATRIX1]): INTEGER_32
		local
			l_ah: CE_ARRAY [NATURAL_32]
			l_al: CE_ARRAY [NATURAL_32]
			l_bh: CE_ARRAY [NATURAL_32]
			l_bl: CE_ARRAY [NATURAL_32]
			l_u00: NATURAL_32
			l_u01: NATURAL_32
			l_u10: NATURAL_32
			l_u11: NATURAL_32
			l_r: CE_ARRAY [NATURAL_32]
			l_q: NATURAL_32
			l_r___0: CE_ARRAY [NATURAL_32]
			l_q___0: NATURAL_32
			l_r___1: CE_ARRAY [NATURAL_32]
			l_q___1: NATURAL_32
			l_r___2: CE_ARRAY [NATURAL_32]
			l_q___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ah.make (<<1>>)
			create l_al.make (<<1>>)
			create l_bh.make (<<1>>)
			create l_bl.make (<<1>>)
			create l_r.make (<<2>>)
			create l_r___0.make (<<2>>)
			create l_r___1.make (<<1>>)
			create l_r___2.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ah.item := a_ah
					l_al.item := a_al
					l_bh.item := a_bh
					l_bl.item := a_bl
					if l_ah.item < {NATURAL_32} 2 then
						Result := 0
						js.return
					elseif l_bh.item < {NATURAL_32} 2 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if not (l_ah.item > l_bh.item) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 4 then -- else:
						if l_ah.item /= l_bh.item then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not (l_al.item > l_bl.item) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						asm126 (l_ah, l_al, l_bh, l_bl)
						if l_ah.item < {NATURAL_32} 2 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_u11 := (1).to_natural_32
							l_u01 := l_u11
							l_u00 := l_u01
							l_u10 := (0).to_natural_32
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___0
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else: | _L___0:
						asm127 (l_bh, l_bl, l_ah, l_al)
						if l_bh.item < {NATURAL_32} 2 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_u11 := (1).to_natural_32
							l_u10 := l_u11
							l_u00 := l_u10
							l_u01 := (0).to_natural_32
						end
				when 11 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 36 -- skip if block
						end
				when 12 then -- if:
							if l_ah.item < l_bh.item then
								l_pos := -1 + 22 -- goto subtract_a
							end
				when 13 then
							if js.loop_done then
								l_pos := -1 + 31 -- skip loop
							end
				when 14 then -- loop body:
							if l_ah.item = l_bh.item then
								l_pos := -1 + 35 -- goto done
							end
				when 15 then
							if l_ah.item < ({NATURAL_32} 1).bit_shift_left (16) then
								l_ah.item := ((l_ah.item).bit_shift_left (16)) + ((l_al.item).bit_shift_right (16))
								l_bh.item := ((l_bh.item).bit_shift_left (16)) + ((l_bl.item).bit_shift_right (16))
								js.break
							end
							if js.loop_jumped then
								l_pos := -1 + 30 -- skip if block
							end
				when 16 then -- if:
							asm128 (l_ah, l_al, l_bh, l_bl)
							if l_ah.item < {NATURAL_32} 2 then
								l_pos := -1 + 35 -- goto done
							end
				when 17 then
							if not (l_ah.item <= l_bh.item) then
								l_pos := -1 + 20 -- skip if block
							end
				when 18 then -- if:
							l_u01 := l_u01 + l_u00
							l_u11 := l_u11 + l_u10
				when 19 then -- if block done, skip else block:
							l_pos := -1 + 22
				when 20 then -- else:
							l_q := (div2 (l_r, l_ah.item, l_al.item, l_bh.item, l_bl.item))
							l_al.item := l_r[0]
							l_ah.item := l_r[1]
							if l_ah.item < {NATURAL_32} 2 then
								l_u01 := l_u01 + (l_q * l_u00)
								l_u11 := l_u11 + (l_q * l_u10)
								l_pos := -1 + 35 -- goto done
							end
				when 21 then
							l_q := l_q + 1
							l_u01 := l_u01 + (l_q * l_u00)
							l_u11 := l_u11 + (l_q * l_u10)
				when 22 then -- subtract_a:
							
							if l_ah.item = l_bh.item then
								l_pos := -1 + 35 -- goto done
							end
				when 23 then
							if l_bh.item < ({NATURAL_32} 1).bit_shift_left (16) then
								l_ah.item := ((l_ah.item).bit_shift_left (16)) + ((l_al.item).bit_shift_right (16))
								l_bh.item := ((l_bh.item).bit_shift_left (16)) + ((l_bl.item).bit_shift_right (16))
								l_pos := -1 + 33 -- goto subtract_a1
							end
				when 24 then
							asm129 (l_bh, l_bl, l_ah, l_al)
							if l_bh.item < {NATURAL_32} 2 then
								l_pos := -1 + 35 -- goto done
							end
				when 25 then
							if not (l_bh.item <= l_ah.item) then
								l_pos := -1 + 28 -- skip if block
							end
				when 26 then -- if:
							l_u00 := l_u00 + l_u01
							l_u10 := l_u10 + l_u11
				when 27 then -- if block done, skip else block:
							l_pos := -1 + 30
				when 28 then -- else:
							l_q___0 := (div2 (l_r___0, l_bh.item, l_bl.item, l_ah.item, l_al.item))
							l_bl.item := l_r___0[0]
							l_bh.item := l_r___0[1]
							if l_bh.item < {NATURAL_32} 2 then
								l_u00 := l_u00 + (l_q___0 * l_u01)
								l_u10 := l_u10 + (l_q___0 * l_u11)
								l_pos := -1 + 35 -- goto done
							end
				when 29 then
							l_q___0 := l_q___0 + 1
							l_u00 := l_u00 + (l_q___0 * l_u01)
							l_u10 := l_u10 + (l_q___0 * l_u11)
				when 30 then -- if done | if done
							l_pos := -1 + 13 -- back to loop condition
				when 31 then -- loop done
							if js.loop_done then
								l_pos := -1 + 35 -- skip loop
							end
				when 32 then -- loop body:
							if l_ah.item = l_bh.item then
								js.break
							end
							if not js.loop_jumped then
								l_ah.item := l_ah.item - (l_bh.item)
								if l_ah.item < ({NATURAL_32} 1).bit_shift_left (17) then
									js.break
								end
							end
							if not js.loop_jumped then
								if l_ah.item <= l_bh.item then
									l_u01 := l_u01 + l_u00
									l_u11 := l_u11 + l_u10
								else
									l_q___1 := (div1 (l_r___1, l_ah.item, l_bh.item))
									l_ah.item := l_r___1.item
									if l_ah.item < ({NATURAL_32} 1).bit_shift_left (17) then
										l_u01 := l_u01 + (l_q___1 * l_u00)
										l_u11 := l_u11 + (l_q___1 * l_u10)
										js.break
									end
									if not js.loop_jumped then
										l_q___1 := l_q___1 + 1
										l_u01 := l_u01 + (l_q___1 * l_u00)
										l_u11 := l_u11 + (l_q___1 * l_u10)
									end
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 34 -- skip if block
							end
				when 33 then -- if: | subtract_a1:
							
							if l_ah.item = l_bh.item then
								js.break
							end
				when 34 then -- if done
							if not js.loop_jumped then
								l_bh.item := l_bh.item - (l_ah.item)
								if l_bh.item < ({NATURAL_32} 1).bit_shift_left (17) then
									js.break
								end
							end
							if not js.loop_jumped then
								if l_bh.item <= l_ah.item then
									l_u00 := l_u00 + l_u01
									l_u10 := l_u10 + l_u11
								else
									l_q___2 := (div1 (l_r___2, l_bh.item, l_ah.item))
									l_bh.item := l_r___2.item
									if l_bh.item < ({NATURAL_32} 1).bit_shift_left (17) then
										l_u00 := l_u00 + (l_q___2 * l_u01)
										l_u10 := l_u10 + (l_q___2 * l_u11)
										js.break
									end
									if not js.loop_jumped then
										l_q___2 := l_q___2 + 1
										l_u00 := l_u00 + (l_q___2 * l_u01)
										l_u10 := l_u10 + (l_q___2 * l_u11)
									end
								end
							end
							l_pos := -1 + 31 -- back to loop condition
				when 35 then; -- done:
							(a_M.item.u[0])[0] := l_u00;
							(a_M.item.u[0])[1] := l_u01;
							(a_M.item.u[1])[0] := l_u10;
							(a_M.item.u[1])[1] := l_u11
							Result := 1
				when 36 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpn_hgcd_mul_matrix1_inverse_vector (a_M: CE_POINTER [PD_HGCD_MATRIX1]; a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_h0: NATURAL_32
			l_h1: NATURAL_32
		do
			l_n := a_n
			l_h0 := gmp_inst.gmpn_mul_1 (a_rp, a_ap, l_n, (a_M.item.u[1])[1])
			l_h1 := gmp_inst.gmpn_submul_1 (a_rp, a_bp, l_n, (a_M.item.u[0])[1])
			l_h0 := gmp_inst.gmpn_mul_1 (a_bp, a_bp, l_n, (a_M.item.u[0])[0])
			l_h1 := gmp_inst.gmpn_submul_1 (a_bp, a_ap, l_n, (a_M.item.u[1])[0])
			l_n := l_n - (((a_rp[(l_n - 1)]).bit_or (a_bp[(l_n - 1)])) = {NATURAL_32} 0).to_integer
			Result := l_n
		end

	gmpn_hgcd_mul_matrix1_vector (a_M: CE_POINTER [PD_HGCD_MATRIX1]; a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_ah: NATURAL_32
			l_bh: NATURAL_32
		do
			l_n := a_n
			l_ah := gmp_inst.gmpn_mul_1 (a_rp, a_ap, l_n, (a_M.item.u[0])[0])
			l_ah := l_ah + (gmp_inst.gmpn_addmul_1 (a_rp, a_bp, l_n, (a_M.item.u[1])[0]))
			l_bh := gmp_inst.gmpn_mul_1 (a_bp, a_bp, l_n, (a_M.item.u[1])[1])
			l_bh := l_bh + (gmp_inst.gmpn_addmul_1 (a_bp, a_ap, l_n, (a_M.item.u[0])[1]))
			a_rp[l_n] := l_ah
			a_bp[l_n] := l_bh
			l_n := l_n + (((l_ah).bit_or (l_bh)) > {NATURAL_32} 0).to_integer
			Result := l_n
		end

end
