class
	P_INP_STR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_inp_str (a_rop: CE_POINTER [PD_MPF_STRUCT]; a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_str: CE_POINTER [INTEGER_8]
			l_alloc_size: NATURAL_32
			l_str_size: NATURAL_32
			l_c: INTEGER_32
			l_res: INTEGER_32
			l_nread: NATURAL_32
			l_old_alloc_size: NATURAL_32
			l_tmp___3: NATURAL_32
			l_old_alloc_size___0: NATURAL_32
			js: JUMP_STATE
		do
			create l_stream.make
			create l_str.make

			l_stream := a_stream
			if l_stream.is_void then
				l_stream := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
			end
			l_alloc_size := (100).to_natural_32
			l_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_alloc_size]))))
			l_str_size := (0).to_natural_32
			l_nread := (0).to_natural_32
			from
			until
				js.loop_done
			loop
				l_c := IO_getc (l_stream)
				l_nread := l_nread + 1
				if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8_192)).to_boolean then
					js.break
				end
			end
			from
			until
				js.loop_done
			loop
				if l_str_size >= l_alloc_size then
					l_old_alloc_size := l_alloc_size
					l_alloc_size := (l_alloc_size * {NATURAL_32} 3) // {NATURAL_32} 2
					l_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_str), l_old_alloc_size, l_alloc_size]))))
				end
				if l_c = -1 then
					js.break
				elseif ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8_192)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					l_tmp___3 := l_str_size
					l_str_size := l_str_size + 1
					l_str[l_tmp___3.to_integer_32] := l_c.to_integer_8
					l_c := IO_getc (l_stream)
				end
			end
			ungetc (l_c, l_stream).do_nothing
			l_nread := l_nread - 1
			if l_str_size >= l_alloc_size then
				l_old_alloc_size___0 := l_alloc_size
				l_alloc_size := (l_alloc_size * {NATURAL_32} 3) // {NATURAL_32} 2
				l_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_str), l_old_alloc_size___0, l_alloc_size]))))
			end
			l_str[l_str_size.to_integer_32] := (0).to_integer_8
			l_res := set_str_inst.gmpf_set_str (a_rop, l_str, a_base)
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_str), l_alloc_size])
			if l_res = -1 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				Result := (l_str_size + l_nread)
			end
		end

	gmpq_inp_str (a_q: CE_POINTER [PD_MPQ_STRUCT]; a_fp: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32): NATURAL_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_nread: NATURAL_32
			l_c: INTEGER_32
			js: JUMP_STATE
		do
			create l_fp.make

			l_fp := a_fp
			if l_fp.is_void then
				l_fp := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
			end
			a_q.item.mp_den.mp_size := 1
			a_q.item.mp_den.mp_d[0] := (1).to_natural_32
			l_nread := gmpz_inp_str (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), l_fp, a_base)
			if l_nread = {NATURAL_32} 0 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				l_c := IO_getc (l_fp)
				l_nread := l_nread + 1
				if l_c = 47 then
					l_c := IO_getc (l_fp)
					l_nread := l_nread + 1
					l_nread := gmpz_inp_str_nowhite (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), l_fp, a_base, l_c, l_nread)
					if l_nread = {NATURAL_32} 0 then
						a_q.item.mp_num.mp_size := 0
						a_q.item.mp_den.mp_size := 1
						a_q.item.mp_den.mp_d[0] := (1).to_natural_32
					end
				else
					ungetc (l_c, l_fp).do_nothing
					l_nread := l_nread - 1
				end
				Result := l_nread
			end
		end

	gmpz_inp_str (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_c: INTEGER_32
			l_nread: NATURAL_32
			js: JUMP_STATE
		do
			create l_stream.make

			l_stream := a_stream
			if l_stream.is_void then
				l_stream := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
			end
			l_nread := (0).to_natural_32
			from
			until
				js.loop_done
			loop
				l_c := IO_getc (l_stream)
				l_nread := l_nread + 1
				if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8_192)).to_boolean then
					js.break
				end
			end
			Result := (gmpz_inp_str_nowhite (a_x___2, l_stream, a_base, l_c, l_nread))
		end

	gmpz_inp_str_nowhite (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32; a_c: INTEGER_32; a_nread: NATURAL_32): NATURAL_32
		local
			l_base: INTEGER_32
			l_c: INTEGER_32
			l_nread: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_alloc_size: NATURAL_32
			l_str_size: NATURAL_32
			l_negative: INTEGER_32
			l_xsize: INTEGER_32
			l_digit_value: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_dig: INTEGER_32
			l_old_alloc_size: NATURAL_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
		do
			create l_str.make
			create l_digit_value.make

			l_base := a_base
			l_c := a_c
			l_nread := a_nread
			l_digit_value := mp_dv_tab_inst.gmp_digit_value_tab
			if l_base > 36 then
				l_digit_value := l_digit_value + (224)
				if l_base > 62 then
					Result := (0).to_natural_32
					js.return
				end
			end
			if not js.return_called then
				l_negative := 0
				if l_c = 45 then
					l_negative := 1
					l_c := IO_getc (a_stream)
					l_nread := l_nread + 1
				end
				if l_c = -1 then
					Result := (0).to_natural_32
					js.return
				else
					if l_base = 0 then
						l_tmp := 10
					else
						l_tmp := l_base
					end
					if (l_digit_value[l_c]).to_integer_32 >= l_tmp then
						Result := (0).to_natural_32
						js.return
					end
				end
			end
			if not js.return_called then
				if l_base = 0 then
					l_base := 10
					if l_c = 48 then
						l_base := 8
						l_c := IO_getc (a_stream)
						l_nread := l_nread + 1
						if l_c = 120 then
							l_base := 16
							l_c := IO_getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 88 then
							l_base := 16
							l_c := IO_getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 98 then
							l_base := 2
							l_c := IO_getc (a_stream)
							l_nread := l_nread + 1
						elseif l_c = 66 then
							l_base := 2
							l_c := IO_getc (a_stream)
							l_nread := l_nread + 1
						end
					end
				end
				from
				until
					l_c /= 48
				loop
					l_c := IO_getc (a_stream)
					l_nread := l_nread + 1
				end
				l_alloc_size := (100).to_natural_32
				l_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_alloc_size]))))
				l_str_size := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_c /= -1))
				loop
					l_dig := (l_digit_value[l_c]).to_integer_32
					if l_dig >= l_base then
						js.break
					end
					if not js.loop_jumped then
						if l_str_size >= l_alloc_size then
							l_old_alloc_size := l_alloc_size
							l_alloc_size := (l_alloc_size * {NATURAL_32} 3) // {NATURAL_32} 2
							l_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_str), l_old_alloc_size, l_alloc_size]))))
						end
						l_tmp___2 := l_str_size
						l_str_size := l_str_size + 1
						l_str[l_tmp___2.to_integer_32] := l_dig.to_integer_8
						l_c := IO_getc (a_stream)
					end
				end
				l_nread := l_nread + l_str_size
				ungetc (l_c, a_stream).do_nothing
				l_nread := l_nread - 1
				if l_str_size = {NATURAL_32} 0 then
					a_x___2.item.mp_size := 0
				else
					l_xsize := 2 + (l_str_size.to_real_64 / ((32).to_double * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly)).truncated_to_integer
					if (builtin_expect ((l_xsize > (a_x___2.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_x___2, l_xsize).do_nothing
					end
					l_xsize := set_str_inst.gmpn_set_str (a_x___2.item.mp_d, create {CE_POINTER [NATURAL_8]}.make_cast (l_str), l_str_size, l_base)
					if l_negative.to_boolean then
						a_x___2.item.mp_size := (-l_xsize).to_integer_32
					else
						a_x___2.item.mp_size := l_xsize.to_integer_32
					end
				end
				memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_str), l_alloc_size])
				Result := l_nread
			end
		end

end
