class
	P_INVERTAPPR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_invertappr (a_ip: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_scratch: CE_POINTER [NATURAL_32]
			l_res: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_scratch.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make

			l_scratch := a_scratch
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if l_scratch.is_void then
				if (builtin_expect (((3 * a_n + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new (((3 * a_n + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((3 * a_n + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_scratch := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
			end
			if 81 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_n >= 81 then
					l_res := gmpn_ni_invertappr (a_ip, a_dp, a_n, l_scratch)
				else
					l_res := mpn_bc_invertappr (a_ip, a_dp, a_n, l_scratch)
				end
			else
				l_res := mpn_bc_invertappr (a_ip, a_dp, a_n, l_scratch)
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
			Result := l_res
		end

	gmpn_ni_invertappr (a_ip: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_ip: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dp: CE_POINTER [NATURAL_32]
			l_n: CE_ARRAY [INTEGER_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_xp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rn: CE_ARRAY [INTEGER_32]
			l_mn: CE_ARRAY [INTEGER_32]
			l_sizes: CE_ARRAY [INTEGER_32]
			l_sizp: CE_POINTER [INTEGER_32]
			l_tp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___5: CE_POINTER [ANY]
			l_method: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_tmp___12: CE_POINTER [NATURAL_32]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___6: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_ip.make (<<1>>)
			create l_dp.make
			create l_n.make (<<1>>)
			create l_cy.make (<<1>>)
			create l_xp.make (<<1>>)
			create l_rn.make (<<1>>)
			create l_mn.make (<<1>>)
			create l_sizes.make (<<({NATURAL_32} 8 * {PLATFORM}.Integer_32_bytes.to_natural_32 - {NATURAL_32} 7).to_integer_32>>)
			create l_sizp.make
			create l_tp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___5.make
			create l_method.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)
			create l___ptr_dummy___0.make (<<1>>)
			create l___ptr_dummy___1.make (<<1>>)
			create l___ptr_dummy___2.make (<<1>>)
			create l___ptr_dummy___3.make (<<1>>)
			create l___d.make
			create l___s.make
			create l_tmp___11.make
			create l_tmp___12.make
			create l___ptr_dummy___4.make (<<1>>)
			create l___ptr_dummy___5.make (<<1>>)
			create l___ptr_dummy___6.make (<<1>>)

			l_ip.item := a_ip
			l_dp := a_dp
			l_n.item := a_n
			l_sizp := l_sizes
			l_rn.item := l_n.item
			from
			until
				js.loop_done
			loop
				l_sizp.item := l_rn.item
				l_rn.item := ((l_rn.item).bit_shift_right (1)) + 1
				l_sizp := l_sizp + 1
				if 81 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_rn.item >= 81) then
						js.break
					end
				else
					js.break
				end
			end
			l_dp := l_dp + (l_n.item)
			l_ip.item := l_ip.item + (l_n.item)
			mpn_bc_invertappr (l_ip.item - l_rn.item, l_dp - l_rn.item, l_rn.item, a_scratch).do_nothing
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if 117 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n.item >= 117 then
					l_mn.item := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_n.item + 1)
					if (builtin_expect (((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_mn.item, l_n.item, ((l_n.item).bit_shift_right (1)) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___5 := (l_aaf.new (((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_mn.item, l_n.item, ((l_n.item).bit_shift_right (1)) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___5 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_mn.item, l_n.item, ((l_n.item).bit_shift_right (1)) + 1)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5)
				end
			end
			l_xp.item := (a_scratch + l_n.item) + 3
			from
			until
				js.loop_done
			loop
				l_sizp := l_sizp - 1
				l_n.item := l_sizp.item
				if 117 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n.item >= 117 then
						l_mn.item := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_n.item + 1)
						if l_mn.item > l_n.item + l_rn.item then
							mul_inst.gmpn_mul (l_xp.item, l_dp - l_n.item, l_n.item, (l_ip.item - l_rn.item), l_rn.item).do_nothing
							gmp_inst.gmpn_add_n (l_xp.item + l_rn.item, (l_xp.item + l_rn.item), l_dp - l_n.item, (l_n.item - l_rn.item) + 1).do_nothing
							l_method.item := (1).to_natural_32
						else
							mulmod_bnm1_inst.gmpn_mulmod_bnm1 (l_xp.item, l_mn.item, l_dp - l_n.item, l_n.item, (l_ip.item - l_rn.item), l_rn.item, l_tp)
							l_xp.item[l_mn.item] := {NATURAL_32} 1 + (gmp_inst.gmpn_add_n (l_xp.item + l_rn.item, (l_xp.item + l_rn.item), l_dp - l_n.item, l_mn.item - l_rn.item))
							l_cy.item := gmp_inst.gmpn_add_n (l_xp.item, l_xp.item, l_dp - (l_n.item - (l_mn.item - l_rn.item)), l_n.item - (l_mn.item - l_rn.item))
							from
							until
								js.loop_done
							loop
								asm212 (l___ptr_dummy, l_xp, l_n, l_mn, l_rn, l_cy)
								js.break
							end
							from
							until
								js.loop_done
							loop
								asm213 (l___ptr_dummy___0, l_xp, l_rn, l_n, l_mn)
								js.break
							end
							if (l_xp.item[l_mn.item]).to_boolean then
								from
								until
									js.loop_done
								loop
									asm214 (l___ptr_dummy___1, l_xp, l_mn)
									js.break
								end
							else
								from
								until
									js.loop_done
								loop
									asm215 (l___ptr_dummy___2, l_xp)
									js.break
								end
							end
							l_method.item := (0).to_natural_32
						end
					else
						mul_inst.gmpn_mul (l_xp.item, l_dp - l_n.item, l_n.item, (l_ip.item - l_rn.item), l_rn.item).do_nothing
						gmp_inst.gmpn_add_n (l_xp.item + l_rn.item, (l_xp.item + l_rn.item), l_dp - l_n.item, (l_n.item - l_rn.item) + 1).do_nothing
						l_method.item := (1).to_natural_32
					end
				else
					mul_inst.gmpn_mul (l_xp.item, l_dp - l_n.item, l_n.item, (l_ip.item - l_rn.item), l_rn.item).do_nothing
					gmp_inst.gmpn_add_n (l_xp.item + l_rn.item, (l_xp.item + l_rn.item), l_dp - l_n.item, (l_n.item - l_rn.item) + 1).do_nothing
					l_method.item := (1).to_natural_32
				end
				if l_xp.item[l_n.item] < {NATURAL_32} 2 then
					l_cy.item := (1).to_natural_32
					from
					until
						js.loop_done
					loop
						if not (l_xp.item[l_n.item]).to_boolean then
							if not ((gmp_inst.gmpn_cmp (l_xp.item, l_dp - l_n.item, l_n.item)) > 0) then
								js.break
							end
						end
						if not js.loop_jumped then
							l_xp.item[l_n.item] := l_xp.item[l_n.item] - (gmp_inst.gmpn_sub_n (l_xp.item, l_xp.item, l_dp - l_n.item, l_n.item))
							l_cy.item := l_cy.item + 1
						end
					end
					from
					until
						js.loop_done
					loop
						asm216 (l___ptr_dummy___3, l_ip, l_rn, l_cy)
						js.break
					end
					gmp_inst.gmpn_sub_n (l_xp.item, l_dp - l_n.item, l_xp.item, l_n.item).do_nothing
				else
					from
					until
						js.loop_done
					loop
						l___d := l_xp.item
						l___s := l_xp.item
						l___n := l_n.item + 1
						from
						until
							js.loop_done
						loop
							l_tmp___11 := l___d
							l___d := l___d + 1
							l_tmp___12 := l___s
							l___s := l___s + 1
							l_tmp___11.item := (((l_tmp___12.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
							l___n := l___n - 1
							if not l___n.to_boolean then
								js.break
							end
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						asm217 (l___ptr_dummy___4, l_xp, l_method)
						js.break
					end
					if (l_xp.item[l_n.item]).to_boolean then
						from
						until
							js.loop_done
						loop
							asm218 (l___ptr_dummy___5, l_ip, l_rn)
							js.break
						end
						gmp_inst.gmpn_sub_n (l_xp.item, l_xp.item, l_dp - l_n.item, l_n.item).do_nothing
					end
				end
				mul_n_inst.gmpn_mul_n (a_scratch, ((l_xp.item + l_n.item) - l_rn.item), (l_ip.item - l_rn.item), l_rn.item)
				l_cy.item := gmp_inst.gmpn_add_n (a_scratch + l_rn.item, (a_scratch + l_rn.item), ((l_xp.item + l_n.item) - l_rn.item), 2 * l_rn.item - l_n.item)
				l_cy.item := gmp_impl_inst.gmpn_add_nc (l_ip.item - l_n.item, ((a_scratch + 3 * l_rn.item) - l_n.item), (l_xp.item + l_rn.item), l_n.item - l_rn.item, l_cy.item)
				from
				until
					js.loop_done
				loop
					asm219 (l___ptr_dummy___6, l_ip, l_rn, l_cy)
					js.break
				end
				if l_sizp.is_equal (l_sizes) then
					l_cy.item := (a_scratch[((3 * l_rn.item - l_n.item) - 1)] > {NATURAL_32} 4_294_967_288).to_integer.to_natural_32
					js.break
				end
				if not js.loop_jumped then
					l_rn.item := l_n.item
				end
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
			Result := (l_cy.item)
		end

	mpn_bc_invertappr (a_ip: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_dp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_ip: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_xp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			l_inv: PD_GMP_PI1_T
			l_v: CE_ARRAY [NATURAL_32]
			l_p: NATURAL_32
			l_t1: CE_ARRAY [NATURAL_32]
			l_t0: CE_ARRAY [NATURAL_32]
			l_mask: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_n.make (<<1>>)
			create l_dp.make (<<1>>)
			create l_ip.make (<<1>>)
			create l_xp.make
			create l___d.make
			create l___s.make
			create l_tmp.make
			create l_tmp___0.make
			create l_inv.make
			create l_v.make (<<1>>)
			create l_t1.make (<<1>>)
			create l_t0.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)

			l_n.item := a_n
			l_dp.item := a_dp
			l_ip.item := a_ip
			if l_n.item = 1 then
				from
				until
					js.loop_done
				loop
					l_ip.item.item := gmp_impl_inst.gmpn_invert_limb (l_dp.item.item)
					js.break
				end
			else
				l_xp := (a_tp + l_n.item) + 2
				l_i := l_n.item - 1
				from
				until
					not (l_i >= 0)
				loop
					l_xp[l_i] := {NATURAL_32} 4_294_967_295
					l_i := l_i - 1
				end
				from
				until
					js.loop_done
				loop
					l___d := l_xp + l_n.item
					l___s := l_dp.item
					l___n := l_n.item
					from
					until
						js.loop_done
					loop
						l_tmp := l___d
						l___d := l___d + 1
						l_tmp___0 := l___s
						l___s := l___s + 1
						l_tmp.item := (((l_tmp___0.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
						l___n := l___n - 1
						if not l___n.to_boolean then
							js.break
						end
					end
					js.break
				end
				if l_n.item = 2 then
					gmp_inst.gmpn_divrem_2 (l_ip.item, (0).to_integer_32, l_xp, (4).to_integer_32, l_dp.item).do_nothing
				else
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							l_v.item := gmp_impl_inst.gmpn_invert_limb (l_dp.item[(l_n.item - 1)])
							js.break
						end
						l_p := (l_dp.item[(l_n.item - 1)] * l_v.item)
						l_p := l_p + (l_dp.item[(l_n.item - 2)])
						if l_p < l_dp.item[(l_n.item - 2)] then
							l_v.item := l_v.item - 1
							l_mask := (-(l_p >= l_dp.item[(l_n.item - 1)]).to_integer).to_integer.to_natural_32
							l_p := l_p - (l_dp.item[(l_n.item - 1)])
							l_v.item := l_v.item + l_mask
							l_p := l_p - ((l_mask).bit_and (l_dp.item[(l_n.item - 1)]))
						end
						asm210 (l_t0, l_t1, l_dp, l_n, l_v)
						l_p := l_p + (l_t1.item)
						if l_p < l_t1.item then
							l_v.item := l_v.item - 1
							if (builtin_expect ((l_p >= l_dp.item[(l_n.item - 1)]).to_integer, 0)).to_boolean then
								if l_p > l_dp.item[(l_n.item - 1)] then
									l_v.item := l_v.item - 1
								elseif l_t0.item >= l_dp.item[(l_n.item - 2)] then
									l_v.item := l_v.item - 1
								end
							end
						end
						l_inv.inv32 := l_v.item
						js.break
					end
					sbpi1_divappr_q_inst.gmpn_sbpi1_divappr_q (l_ip.item, l_xp, 2 * l_n.item, l_dp.item, l_n.item, l_inv.inv32).do_nothing
					from
					until
						js.loop_done
					loop
						asm211 (l___ptr_dummy, l_ip)
						js.break
					end
					Result := (1).to_natural_32
					js.return
				end
			end
			if not js.return_called then
				Result := (0).to_natural_32
			end
		end

end
