class
	P_NUSSBAUMER_MUL

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_nussbaumer_mul (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32)
		local
			l_rn: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___5.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
					if not (a_ap.is_equal (a_bp)) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_an = a_bn then
							l_rn := sqrmod_bnm1_inst.gmpn_sqrmod_bnm1_next_size (2 * a_an)
							if (builtin_expect (((gmp_impl_inst.mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___5 := (l_aaf.new (((gmp_impl_inst.mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___5 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((gmp_impl_inst.mpn_sqrmod_bnm1_itch (l_rn, a_an)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5)
							sqrmod_bnm1_inst.gmpn_sqrmod_bnm1 (a_pp, l_rn, a_ap, a_an, l_tp)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_rn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_an + a_bn)
						if (builtin_expect (((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___14 := (l_aaf.new (((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___14 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn, a_an, a_bn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___14)
						mulmod_bnm1_inst.gmpn_mulmod_bnm1 (a_pp, l_rn, a_ap, a_an, a_bp, a_bn, l_tp)
				when 4 then
					from
					until
						js.loop_done
					loop
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						js.break
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
