class
	P_OUT_STR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_out_str (a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32; a_n_digits: NATURAL_32; a_op: CE_POINTER [PD_MPF_STRUCT]): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_base: INTEGER_32
			l_n_digits: NATURAL_32
			l_str: CE_POINTER [INTEGER_8]
			l_exp: CE_ARRAY [INTEGER_32]
			l_written: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_point: CE_POINTER [INTEGER_8]
			l_pointlen: NATURAL_32
			l_fwret: NATURAL_32
			l_fpret: INTEGER_32
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___9: NATURAL_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_stream.make
			create l_str.make
			create l_exp.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make
			create l_point.make
			create l_tmp___6.make

			l_stream := a_stream
			l_base := a_base
			l_n_digits := a_n_digits
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if l_base = 0 then
				l_base := 10
			end
			if l_n_digits = {NATURAL_32} 0 then
				from
				until
					js.loop_done
				loop
					l_n_digits := {NATURAL_32} 2 + ((((a_op.item.mp_prec).to_natural_32 - {NATURAL_32} 1) * {NATURAL_32} 32).to_real_64 * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32
					js.break
				end
			end
			if l_stream.is_void then
				l_stream := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
			end
			if (builtin_expect ((l_n_digits + {NATURAL_32} 2 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___2 := (l_aaf.new (l_n_digits + {NATURAL_32} 2))
			else
				l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, l_n_digits + {NATURAL_32} 2))
			end
			l_str := create {CE_POINTER [INTEGER_8]}.make_cast (l_tmp___2)
			get_str_inst.gmpf_get_str (l_str, l_exp, l_base, l_n_digits, a_op).do_nothing
			l_n_digits := strlen (l_str)
			l_written := (0).to_natural_32
			if (l_str[0]).to_integer_32 = 45 then
				l_str := l_str + 1
				fputc (('-').code, l_stream).do_nothing
				l_written := (1).to_natural_32
				l_n_digits := l_n_digits - 1
			end
			l_point := (nl_langinfo (65_536))
			l_pointlen := (strlen (l_point))
			IO_putc (('0').code, l_stream).do_nothing
			fwrite (create {CE_POINTER [ANY]}.make_cast (l_point), (1).to_natural_32, l_pointlen, l_stream).do_nothing
			l_written := l_written + (l_pointlen + {NATURAL_32} 1)
			l_fwret := fwrite (create {CE_POINTER [ANY]}.make_cast (l_str), (1).to_natural_32, l_n_digits, l_stream)
			l_written := l_written + l_fwret
			if l_base <= 10 then
				l_tmp___6 := ce_string ("e%%ld")
			else
				l_tmp___6 := ce_string ("@%%ld")
			end
			l_fpret := fprintf ([l_stream, l_tmp___6, l_exp.item])
			l_written := l_written + l_fpret.to_natural_32
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
			if (ferror (l_stream)).to_boolean then
				l_tmp___9 := (0).to_natural_32
			else
				l_tmp___9 := l_written
			end
			Result := l_tmp___9
		end

	gmpq_out_str (a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32; a_q: CE_POINTER [PD_MPQ_STRUCT]): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_written: NATURAL_32
			l_tmp___3: NATURAL_32
		do
			create l_stream.make

			l_stream := a_stream
			if l_stream.is_void then
				l_stream := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
			end
			l_written := gmpz_out_str (l_stream, a_base, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")))
			if (cmp_ui_inst.gmpz_cmp_ui (create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")), {NATURAL_32} 1)) /= 0 then
				IO_putc (('/').code, l_stream).do_nothing
				l_written := l_written + ({NATURAL_32} 1 + (gmpz_out_str (l_stream, a_base, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))))
			end
			if (ferror (l_stream)).to_boolean then
				l_tmp___3 := (0).to_natural_32
			else
				l_tmp___3 := l_written
			end
			Result := l_tmp___3
		end

	gmpz_out_str (a_stream: CE_POINTER [SD_IO_FILE]; a_base: INTEGER_32; a_x___2: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_stream: CE_POINTER [SD_IO_FILE]
			l_base: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_x_size: INTEGER_32
			l_str: CE_POINTER [NATURAL_8]
			l_str_size: NATURAL_32
			l_i: NATURAL_32
			l_written: NATURAL_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___0: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___10: CE_POINTER [ANY]
			l_fwret: NATURAL_32
			l_tmp___14: NATURAL_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_stream.make
			create l_xp.make
			create l_str.make
			create l_num_to_text.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___5.make
			create l_tmp___10.make

			l_stream := a_stream
			l_base := a_base
			l_x_size := (a_x___2.item.mp_size).to_integer_32
			if l_stream.is_void then
				l_stream := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))
			end
			if l_base >= 0 then
				l_num_to_text := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
				if l_base = 0 then
					l_base := 10
				elseif l_base > 36 then
					l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
					if l_base > 62 then
						Result := (0).to_natural_32
						js.return
					end
				end
			else
				l_base := -l_base
				l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
			end
			if not js.return_called and then (l_x_size = 0) then
				fputc (('0').code, l_stream).do_nothing
				if (ferror (l_stream)).to_boolean then
					l_tmp___0 := 0
				else
					l_tmp___0 := 1
				end
				Result := l_tmp___0.to_natural_32
				js.return
			end
			if not js.return_called then
				l_written := (0).to_natural_32
				if l_x_size < 0 then
					fputc (('-').code, l_stream).do_nothing
					l_x_size := -l_x_size
					l_written := (1).to_natural_32
				end
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_str_size := ((l_x_size * 32).to_double * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 3
				if (builtin_expect ((l_str_size < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___5 := (l_aaf.new (l_str_size))
				else
					l_tmp___5 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, l_str_size))
				end
				l_str := create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___5)
				if (builtin_expect (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___10 := (l_aaf.new (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___10 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_xp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___10)
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_xp, a_x___2.item.mp_d, l_x_size)
						js.break
					end
					js.break
				end
				l_str_size := get_str_inst.gmpn_get_str (l_str, l_base, l_xp, l_x_size)
				from
				until
					(l_str.item).to_integer_32 /= 0
				loop
					l_str_size := l_str_size - 1
					l_str := l_str + 1
				end
				l_i := (0).to_natural_32
				from
				until
					not (l_i < l_str_size)
				loop
					l_str[l_i.to_integer_32] := (l_num_to_text[(l_str[l_i.to_integer_32]).to_integer_32]).to_natural_8
					l_i := l_i + 1
				end
				l_str[l_str_size.to_integer_32] := (0).to_natural_8
				l_fwret := fwrite (create {CE_POINTER [ANY]}.make_cast (l_str), (1).to_natural_32, l_str_size, l_stream)
				l_written := l_written + l_fwret
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				if (ferror (l_stream)).to_boolean then
					l_tmp___14 := (0).to_natural_32
				else
					l_tmp___14 := l_written
				end
				Result := l_tmp___14
			end
		end

end
