class
	P_POW_1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_pow_1 (a_rp: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_exp: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_exp: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_x___2: NATURAL_32
			l_cnt: INTEGER_32
			l_i: INTEGER_32
			l_rn: INTEGER_32
			l_par: INTEGER_32
			l_bl: NATURAL_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___2: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___3: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_rp.make
			create l_tp.make
			create l___mp_ptr_swap__tmp.make
			create l___mp_ptr_swap__tmp___0.make
			create l___mp_ptr_swap__tmp___1.make
			create l___mp_ptr_swap__tmp___2.make
			create l___mp_ptr_swap__tmp___3.make

			l_rp := a_rp
			l_exp := a_exp
			l_tp := a_tp
			if l_exp <= {NATURAL_32} 1 then
				if l_exp = {NATURAL_32} 0 then
					l_rp[0] := (1).to_natural_32
					Result := (1).to_integer_32
					js.return
				else
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_rp, a_bp, a_bn)
							js.break
						end
						js.break
					end
					Result := a_bn
					js.return
				end
			end
			if not js.return_called then
				l_par := 0
				l_cnt := 32
				l_x___2 := l_exp
				from
				until
					l_x___2 = {NATURAL_32} 0
				loop
					l_par := ((l_par.to_natural_32).bit_xor (((l_x___2).bit_and ({NATURAL_32} 1)))).to_integer_32
					l_cnt := l_cnt - 1
					l_x___2 := (l_x___2).bit_shift_right ((1))
				end
				l_exp := (l_exp).bit_shift_left (l_cnt)
				if a_bn = 1 then
					l_bl := a_bp[0]
					if ((l_cnt).bit_and (1)) /= 0 then
						from
						until
							js.loop_done
						loop
							l___mp_ptr_swap__tmp := l_rp
							l_rp := l_tp
							l_tp := l___mp_ptr_swap__tmp
							js.break
						end
					end
					sqr_inst.gmpn_sqr (l_rp, a_bp, a_bn)
					l_rn := 2 * a_bn
					l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
					l_i := (32 - l_cnt) - 1
					from
					until
						js.loop_done
					loop
						l_exp := (l_exp).bit_shift_left ((1))
						if ((l_exp).bit_and ((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))))) /= {NATURAL_32} 0 then
							l_rp[l_rn] := gmp_inst.gmpn_mul_1 (l_rp, l_rp, l_rn, l_bl)
							l_rn := l_rn + (l_rp[l_rn] /= {NATURAL_32} 0).to_integer
						end
						l_i := l_i - 1
						if l_i = 0 then
							js.break
						end
						if not js.loop_jumped then
							sqr_inst.gmpn_sqr (l_tp, l_rp, l_rn)
							l_rn := 2 * l_rn
							l_rn := l_rn - (l_tp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
							from
							until
								js.loop_done
							loop
								l___mp_ptr_swap__tmp___0 := l_rp
								l_rp := l_tp
								l_tp := l___mp_ptr_swap__tmp___0
								js.break
							end
						end
					end
				else
					if ((((l_par).bit_xor (l_cnt))).bit_and (1)) = 0 then
						from
						until
							js.loop_done
						loop
							l___mp_ptr_swap__tmp___1 := l_rp
							l_rp := l_tp
							l_tp := l___mp_ptr_swap__tmp___1
							js.break
						end
					end
					sqr_inst.gmpn_sqr (l_rp, a_bp, a_bn)
					l_rn := 2 * a_bn
					l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
					l_i := (32 - l_cnt) - 1
					from
					until
						js.loop_done
					loop
						l_exp := (l_exp).bit_shift_left ((1))
						if ((l_exp).bit_and ((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))))) /= {NATURAL_32} 0 then
							l_rn := (l_rn + a_bn) - ((mul_inst.gmpn_mul (l_tp, l_rp, l_rn, a_bp, a_bn)) = {NATURAL_32} 0).to_integer
							from
							until
								js.loop_done
							loop
								l___mp_ptr_swap__tmp___2 := l_rp
								l_rp := l_tp
								l_tp := l___mp_ptr_swap__tmp___2
								js.break
							end
						end
						l_i := l_i - 1
						if l_i = 0 then
							js.break
						end
						if not js.loop_jumped then
							sqr_inst.gmpn_sqr (l_tp, l_rp, l_rn)
							l_rn := 2 * l_rn
							l_rn := l_rn - (l_tp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
							from
							until
								js.loop_done
							loop
								l___mp_ptr_swap__tmp___3 := l_rp
								l_rp := l_tp
								l_tp := l___mp_ptr_swap__tmp___3
								js.break
							end
						end
					end
				end
				Result := l_rn
			end
		end

end
