class
	P_PPRIME_P

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_probab_prime_p (a_n: CE_POINTER [PD_MPZ_STRUCT]; a_reps: INTEGER_32): INTEGER_32
		local
			l_n: CE_POINTER [PD_MPZ_STRUCT]
			l_r: NATURAL_32
			l_n2: CE_ARRAY [PD_MPZ_STRUCT]
			l_is_prime: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___5: NATURAL_32
			l_ln2: NATURAL_32
			l_q: CE_ARRAY [NATURAL_32]
			l_p1: CE_ARRAY [NATURAL_32]
			l_p0: CE_ARRAY [NATURAL_32]
			l_p: CE_ARRAY [NATURAL_32]
			l_primes: CE_ARRAY [NATURAL_32]
			l_nprimes: INTEGER_32
			l_tmp___8: NATURAL_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
		do
			create l_n.make
			create l_n2.make (<<1>>)
			create l_q.make (<<1>>)
			create l_p1.make (<<1>>)
			create l_p0.make (<<1>>)
			create l_p.make (<<1>>)
			create l_primes.make (<<15>>)

			l_n := a_n
			if (cmp_ui_inst.gmpz_cmp_ui (l_n, {NATURAL_32} 1_000_000)) <= 0 then
				if (cmpabs_ui_inst.gmpz_cmpabs_ui (l_n, {NATURAL_32} 1_000_000)) <= 0 then
					l_is_prime := isprime ((gmp_inst.gmpz_get_ui (l_n)))
					if l_is_prime.to_boolean then
						l_tmp___0 := 2
					else
						l_tmp___0 := 0
					end
					Result := l_tmp___0
					js.return
				end
				if not js.return_called then
					l_n2[0].mp_d := l_n.item.mp_d
					l_n2[0].mp_size := (-l_n.item.mp_size)
					l_n := create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_n2)
				end
			end
			if not js.return_called then
				if (((gmp_inst.gmpz_get_ui (l_n))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if 23 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if (l_n.item.mp_size).to_integer_32 >= 23 then
						l_r := (mod_1_inst.gmpn_mod_1 (l_n.item.mp_d, (l_n.item.mp_size).to_integer_32, {NATURAL_32} 3_234_846_615))
					else
						l_tmp___5 := pre_mod_1_inst.gmpn_preinv_mod_1 (l_n.item.mp_d, (l_n.item.mp_size).to_integer_32, {NATURAL_32} 3_234_846_615, (1_407_542_364).to_natural_32)
						l_r := l_tmp___5
					end
				else
					l_tmp___5 := pre_mod_1_inst.gmpn_preinv_mod_1 (l_n.item.mp_d, (l_n.item.mp_size).to_integer_32, {NATURAL_32} 3_234_846_615, (1_407_542_364).to_natural_32)
					l_r := l_tmp___5
				end
				if l_r \\ {NATURAL_32} 3 = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif l_r \\ {NATURAL_32} 5 = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif l_r \\ {NATURAL_32} 7 = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif l_r \\ {NATURAL_32} 11 = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif l_r \\ {NATURAL_32} 13 = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif l_r \\ {NATURAL_32} 17 = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif l_r \\ {NATURAL_32} 19 = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif l_r \\ {NATURAL_32} 23 = {NATURAL_32} 0 then
					Result := 0
					js.return
				elseif l_r \\ {NATURAL_32} 29 = {NATURAL_32} 0 then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				l_nprimes := 0
				l_p.item := (1).to_natural_32
				l_ln2 := (sizeinbase_inst.gmpz_sizeinbase (l_n, 2)).to_natural_32
				l_q.item := {NATURAL_32} 31
				from
				until
					not (not js.loop_done and then (l_q.item < l_ln2))
				loop
					if (isprime (l_q.item)).to_boolean then
						asm24 (l_p0, l_p1, l_p, l_q)
						if l_p1.item /= {NATURAL_32} 0 then
							if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if (l_n.item.mp_size).to_integer_32 >= 22 then
									l_r := (mod_1_inst.gmpn_mod_1 (l_n.item.mp_d, (l_n.item.mp_size).to_integer_32, l_p.item))
								else
									l_tmp___8 := gmp_impl_inst.gmpn_modexact_1_odd (l_n.item.mp_d, (l_n.item.mp_size).to_integer_32, l_p.item)
									l_r := l_tmp___8
								end
							else
								l_tmp___8 := gmp_impl_inst.gmpn_modexact_1_odd (l_n.item.mp_d, (l_n.item.mp_size).to_integer_32, l_p.item)
								l_r := l_tmp___8
							end
							from
							until
								js.loop_done
							loop
								l_nprimes := l_nprimes - 1
								if not (l_nprimes >= 0) then
									js.break
								end
								if not js.loop_jumped and then (l_r \\ (l_primes[l_nprimes]).to_natural_32 = {NATURAL_32} 0) then
									from
									until
										js.loop_done
									loop
										if (mod_1_inst.gmpn_mod_1 (l_n.item.mp_d, (l_n.item.mp_size).to_integer_32, (l_primes[l_nprimes]).to_natural_32)) /= {NATURAL_32} 0 then
											assert_inst.gmp_assert_fail (ce_string ("pprime_p.c"), 119, ce_string ("__gmpn_mod_1 (((n)->_mp_d), (mp_size_t) ((n)->_mp_size), (mp_limb_t) primes[nprimes]) == 0"))
										end
										js.break
									end
									Result := 0
									js.return
								end
							end
							if not js.return_called then
								l_p.item := l_q.item
								l_nprimes := 0
							end
						else
							l_p.item := l_p0.item
						end
						if not js.return_called then
							l_tmp___11 := l_nprimes
							l_nprimes := l_nprimes + 1
							l_primes[l_tmp___11] := (l_q.item).to_natural_32
						end
					end
					if not js.return_called then
						l_q.item := l_q.item + ({NATURAL_32} 2)
					end
				end
			end
			if not js.return_called then
				Result := (millerrabin_inst.gmpz_millerrabin (l_n, a_reps))
			end
		end

	isprime (a_t: NATURAL_32): INTEGER_32
		local
			l_q: NATURAL_32
			l_r: NATURAL_32
			l_d: NATURAL_32
			js: JUMP_STATE
		do
			if a_t < {NATURAL_32} 3 then
				Result := (a_t = {NATURAL_32} 2).to_integer
				js.return
			elseif ((a_t).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
				Result := (a_t = {NATURAL_32} 2).to_integer
				js.return
			end
			if not js.return_called then
				l_d := {NATURAL_32} 3
				l_r := {NATURAL_32} 1
				from
				until
					not (not js.loop_done and then (l_r /= {NATURAL_32} 0))
				loop
					l_q := a_t // l_d
					l_r := a_t - l_q * l_d
					if l_q < l_d then
						Result := 1
						js.return
					end
					if not js.return_called then
						l_d := l_d + ({NATURAL_32} 2)
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
