class
	P_SBPI1_DIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_sbpi1_div_qr (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32): NATURAL_32
		local
			l_dinv: CE_ARRAY [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dn: INTEGER_32
			l_qh: NATURAL_32
			l_i: INTEGER_32
			l_n1: CE_ARRAY [NATURAL_32]
			l_n0: CE_ARRAY [NATURAL_32]
			l_d1: CE_ARRAY [NATURAL_32]
			l_d0: CE_ARRAY [NATURAL_32]
			l_cy: NATURAL_32
			l_cy1: NATURAL_32
			l_q: CE_ARRAY [NATURAL_32]
			l__q0: CE_ARRAY [NATURAL_32]
			l__t1: CE_ARRAY [NATURAL_32]
			l__t0: CE_ARRAY [NATURAL_32]
			l__mask: CE_ARRAY [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dinv.make (<<1>>)
			create l_qp.make
			create l_np.make (<<1>>)
			create l_n1.make (<<1>>)
			create l_n0.make (<<1>>)
			create l_d1.make (<<1>>)
			create l_d0.make (<<1>>)
			create l_q.make (<<1>>)
			create l__q0.make (<<1>>)
			create l__t1.make (<<1>>)
			create l__t0.make (<<1>>)
			create l__mask.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dinv.item := a_dinv
					l_qp := a_qp
					l_np.item := a_np
					l_dn := a_dn
					l_np.item := l_np.item + a_nn
					l_qh := ((gmp_inst.gmpn_cmp ((l_np.item - l_dn), a_dp, l_dn)) >= 0).to_integer.to_natural_32
					if l_qh /= {NATURAL_32} 0 then
						gmp_inst.gmpn_sub_n (l_np.item - l_dn, (l_np.item - l_dn), a_dp, l_dn).do_nothing
					end
					l_qp := l_qp + (a_nn - l_dn)
					l_dn := l_dn - (2)
					l_d1.item := a_dp[(l_dn + 1)]
					l_d0.item := a_dp[l_dn]
					l_np.item := l_np.item - (2)
					l_n1.item := l_np.item[1]
					l_i := a_nn - (l_dn + 2)
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_i > 0)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_np.item := l_np.item - 1
						if not ((builtin_expect ((l_n1.item = l_d1.item).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if l_np.item[1] = l_d0.item then
							l_q.item := {NATURAL_32} 4_294_967_295
							gmp_inst.gmpn_submul_1 (l_np.item - l_dn, a_dp, l_dn + 2, l_q.item).do_nothing
							l_n1.item := l_np.item[1]
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							asm265 (l__q0, l_q, l_n1, l_dinv)
							asm266 (l_q, l__q0, l_n1, l_np)
							l_n1.item := l_np.item[1] - l_d1.item * l_q.item
							l_n0.item := l_np.item[0]
							asm267 (l_n1, l_n0, l_d1, l_d0)
							asm268 (l__t0, l__t1, l_d0, l_q)
							asm269 (l_n1, l_n0, l__t1, l__t0)
							l_q.item := l_q.item + 1
							l__mask.item := (-((l_n1.item >= l__q0.item).to_integer.to_natural_32).to_integer_32).to_natural_32
							l_q.item := l_q.item + (l__mask.item)
							asm270 (l_n1, l_n0, l__mask, l_d1, l_d0)
							if (builtin_expect ((l_n1.item >= l_d1.item).to_integer, 0)).to_boolean then
								if l_n1.item > l_d1.item then
									l_q.item := l_q.item + 1
									asm271 (l_n1, l_n0, l_d1, l_d0)
								elseif l_n0.item >= l_d0.item then
									l_q.item := l_q.item + 1
									asm272 (l_n1, l_n0, l_d1, l_d0)
								end
							end
							js.break
						end
						l_cy := gmp_inst.gmpn_submul_1 (l_np.item - l_dn, a_dp, l_dn, l_q.item)
						l_cy1 := (l_n0.item < l_cy).to_integer.to_natural_32
						l_n0.item := ((l_n0.item - l_cy)).bit_and ({NATURAL_32} 4_294_967_295)
						l_cy := (l_n1.item < l_cy1).to_integer.to_natural_32
						l_n1.item := ((l_n1.item - l_cy1)).bit_and ({NATURAL_32} 4_294_967_295)
						l_np.item[0] := l_n0.item
						if (builtin_expect ((l_cy /= {NATURAL_32} 0).to_integer, 0)).to_boolean then
							l_n1.item := l_n1.item + (l_d1.item + (gmp_inst.gmpn_add_n (l_np.item - l_dn, (l_np.item - l_dn), a_dp, l_dn + 1)))
							l_q.item := l_q.item - 1
						end
				when 6 then
						l_qp := l_qp - 1
						l_qp.item := l_q.item
						l_i := l_i - 1
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					l_np.item[1] := l_n1.item
					Result := l_qh
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
