class
	P_TAL_REENT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_tmp_reentrant_alloc (a_markp: CE_POINTER [CE_POINTER [PD_TMP_REENTRANT_T]]; a_size: NATURAL_32): CE_POINTER [ANY]
		local
			l_p: CE_POINTER [INTEGER_8]
			l_total_size: NATURAL_32
			l_tmp: NATURAL_32
			l_tmp___1: NATURAL_32
		do
			create l_p.make

			if (((create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32).bit_and (((create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32 - {NATURAL_32} 1))) = {NATURAL_32} 0 then
				l_tmp := (create {PD_TMP_REENTRANT_T}.make).structure_size.to_natural_32 + (-((create {PD_TMP_REENTRANT_T}.make).structure_size.to_natural_32).to_integer_32).to_natural_32 \\ (create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32
			else
				l_tmp := (((create {PD_TMP_REENTRANT_T}.make).structure_size.to_natural_32 + (create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32) - {NATURAL_32} 1) - (((create {PD_TMP_REENTRANT_T}.make).structure_size.to_natural_32 + (create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32) - {NATURAL_32} 1) \\ (create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32
			end
			l_total_size := a_size + l_tmp
			l_p := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_total_size]))));
			(create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_cast (l_p)).item.size := l_total_size;
			(create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_cast (l_p)).item.next := a_markp.item
			a_markp.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_cast (l_p)
			if (((create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32).bit_and (((create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32 - {NATURAL_32} 1))) = {NATURAL_32} 0 then
				l_tmp___1 := (create {PD_TMP_REENTRANT_T}.make).structure_size.to_natural_32 + (-((create {PD_TMP_REENTRANT_T}.make).structure_size.to_natural_32).to_integer_32).to_natural_32 \\ (create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32
			else
				l_tmp___1 := (((create {PD_TMP_REENTRANT_T}.make).structure_size.to_natural_32 + (create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32) - {NATURAL_32} 1) - (((create {PD_TMP_REENTRANT_T}.make).structure_size.to_natural_32 + (create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32) - {NATURAL_32} 1) \\ (create {PD_TMP_ALIGN_T}.make).structure_size.to_natural_32
			end
			Result := (create {CE_POINTER [ANY]}.make_cast ((l_p + l_tmp___1.to_integer_32)))
		end

	gmp_tmp_reentrant_free (a_mark: CE_POINTER [PD_TMP_REENTRANT_T])
		local
			l_mark: CE_POINTER [PD_TMP_REENTRANT_T]
			l_next: CE_POINTER [PD_TMP_REENTRANT_T]
		do
			create l_mark.make
			create l_next.make

			l_mark := a_mark
			from
			until
				l_mark.is_void
			loop
				l_next := l_mark.item.next
				memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_mark), l_mark.item.size])
				l_mark := l_next
			end
		end

end
