class
	P_TOOM_COUPLE_HANDLING

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom_couple_handling (a_pp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_np: CE_POINTER [NATURAL_32]; a_nsign: INTEGER_32; a_off: INTEGER_32; a_ps: INTEGER_32; a_ns: INTEGER_32)
		do
			if a_nsign.to_boolean then
				gmp_inst.gmpn_sub_n (a_np, a_pp, a_np, a_n).do_nothing
				gmp_inst.gmpn_rshift (a_np, a_np, a_n, {NATURAL_32} 1).do_nothing
			else
				gmp_inst.gmpn_add_n (a_np, a_pp, a_np, a_n).do_nothing
				gmp_inst.gmpn_rshift (a_np, a_np, a_n, {NATURAL_32} 1).do_nothing
			end
			gmp_inst.gmpn_sub_n (a_pp, a_pp, a_np, a_n).do_nothing
			if a_ps > 0 then
				gmp_inst.gmpn_rshift (a_pp, a_pp, a_n, a_ps.to_natural_32).do_nothing
			end
			if a_ns > 0 then
				gmp_inst.gmpn_rshift (a_np, a_np, a_n, a_ns.to_natural_32).do_nothing
			end
			a_pp[a_n] := gmp_inst.gmpn_add_n (a_pp + a_off, (a_pp + a_off), a_np, a_n - a_off)
			gmp_inst.gmpn_add_1 (a_pp + a_n, ((a_np + a_n) - a_off), a_off, a_pp[a_n]).do_nothing
		end

end
