class
	P_TRIALDIV

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_trialdiv (a_tp: CE_POINTER [NATURAL_32]; a_tn: INTEGER_32; a_nprimes: INTEGER_32; a_where: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_nprimes: INTEGER_32
			l_ppp: NATURAL_32
			l_cps: CE_POINTER [NATURAL_32]
			l_dp: CE_POINTER [PD_GMP_PRIMES_DTAB]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_idx: INTEGER_32
			l_np: INTEGER_32
			l_r: NATURAL_32
			l_q: NATURAL_32
			js: JUMP_STATE
		do
			create l_cps.make
			create l_dp.make

			l_nprimes := a_nprimes
			l_i := (a_where.item).to_integer_32
			from
			until
				not (not js.loop_done and then (l_i.to_natural_32 < (((create {PD_GMP_PRIMES_PTAB}.make).structure_size.to_natural_32 * (463).to_natural_32) // (create {PD_GMP_PRIMES_PTAB}.make).structure_size.to_natural_32).to_natural_32))
			loop
				l_ppp := trialdivtab_inst.gmp_primes_ptab[l_i].ppp
				l_cps := trialdivtab_inst.gmp_primes_ptab[l_i].cps
				l_r := gmp_impl_inst.gmpn_mod_1s_4p (a_tp, a_tn, (l_ppp).bit_shift_left ((l_cps[1]).to_integer_32), l_cps)
				l_idx := (trialdivtab_inst.gmp_primes_ptab[l_i].idx).to_integer_32
				l_np := (trialdivtab_inst.gmp_primes_ptab[l_i].np).to_integer_32
				l_dp := trialdivtab_inst.gmp_primes_dtab + l_idx + l_np
				l_j := -l_np
				from
				until
					not (not js.loop_done and then (l_j < 0))
				loop
					l_q := l_r * (l_dp + l_j).item.binv
					if l_q <= (l_dp + l_j).item.lim then
						a_where.item := l_i.to_integer_32
						Result := ((l_dp + l_j).item.binv)
						js.return
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_nprimes := l_nprimes - l_np
					if l_nprimes <= 0 then
						Result := (0).to_natural_32
						js.return
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := (0).to_natural_32
			end
		end

end
