deferred class
	S_GCC_BUILTIN

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	builtin_clzl (a_arg1: NATURAL_32): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __builtin_clzl($a_arg1);"
		end

	builtin_ctzl (a_arg1: NATURAL_32): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __builtin_ctzl($a_arg1);"
		end

	builtin_expect (a_arg1: INTEGER_32; a_arg2: INTEGER_32): INTEGER_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __builtin_expect($a_arg1, $a_arg2);"
		end

end
