class
	PD_GSL_MONTE_PLAIN_STATE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x.make
		end

feature {ANY} -- fields

	dim: NATURAL_32 assign set_dim

	x: CE_POINTER [REAL_64] assign set_x

feature {ANY} -- setters

	set_dim (a_dim: NATURAL_32)
		do
			dim := a_dim
			update_memory_field ("dim")
		end

	set_x (a_x: CE_POINTER [REAL_64])
		do
			x := a_x
			update_memory_field ("x")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dim := a_other.dim
			x := a_other.x
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dim = a_other.dim and
				x.is_equal (a_other.x)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dim"),
					create {CE_STRUCTURE_FIELD}.make ("x")
				>>)
			init_structure_info
		end

end
