class
	PD_GSL_VECTOR_FLOAT_VIEW

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create vector.make
		end

feature {ANY} -- fields

	vector: PD_GSL_VECTOR_FLOAT assign set_vector

feature {ANY} -- setters

	set_vector (a_vector: PD_GSL_VECTOR_FLOAT)
		do
			vector := a_vector
			update_memory_field ("vector")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			vector := a_other.vector.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				vector.is_equal (a_other.vector)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("vector")
				>>)
			init_structure_info
		end

end
