class
	PD_IU_PARAMS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create f.make
		end

feature {ANY} -- fields

	a: REAL_64 assign set_a

	f: CE_POINTER [PD_GSL_FUNCTION_STRUCT] assign set_f

feature {ANY} -- setters

	set_a (a_a: REAL_64)
		do
			a := a_a
			update_memory_field ("a")
		end

	set_f (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT])
		do
			f := a_f
			update_memory_field ("f")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			a := a_other.a
			f := a_other.f
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				a = a_other.a and
				f.is_equal (a_other.f)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("a"),
					create {CE_STRUCTURE_FIELD}.make ("f")
				>>)
			init_structure_info
		end

end
