class
	PD_TT_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create x.make (<<25>>)
		end

feature {ANY} -- fields

	n: INTEGER_32 assign set_n

	x: CE_ARRAY [NATURAL_32]

feature {ANY} -- setters

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			x := a_other.x.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				x.is_equal (a_other.x)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("x", <<25>>)
				>>)
			init_structure_info
		end

end
