frozen class
	LIBGSL_INITIALIZER_SLICE10

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {LIBGSL_INITIALIZER}

	initialize
		do
			rkf45_inst.rkf45_type[0].free := rkf45_inst.rkf45_free_address
			rkf45_inst.gsl_odeiv_step_rkf45 := rkf45_inst.rkf45_type
			rk4_inst.rk4_type[0].name := ce_string ("rk4")
			rk4_inst.rk4_type[0].can_use_dydt_in := 1
			rk4_inst.rk4_type[0].gives_exact_dydt_out := 1
			rk4_inst.rk4_type[0].alloc := rk4_inst.rk4_alloc_address
			rk4_inst.rk4_type[0].apply := rk4_inst.rk4_apply_address
			rk4_inst.rk4_type[0].reset := rk4_inst.rk4_reset_address
			rk4_inst.rk4_type[0].order := rk4_inst.rk4_order_address
			rk4_inst.rk4_type[0].free := rk4_inst.rk4_free_address
			rk4_inst.gsl_odeiv_step_rk4 := rk4_inst.rk4_type
			bsimp_inst.bd_sequence[0] := 2
			bsimp_inst.bd_sequence[1] := 6
			bsimp_inst.bd_sequence[2] := 10
			bsimp_inst.bd_sequence[3] := 14
			bsimp_inst.bd_sequence[4] := 22
			bsimp_inst.bd_sequence[5] := 34
			bsimp_inst.bd_sequence[6] := 50
			bsimp_inst.bd_sequence[7] := 70
			bsimp_inst.bsimp_type[0].name := ce_string ("bsimp")
			bsimp_inst.bsimp_type[0].can_use_dydt_in := 1
			bsimp_inst.bsimp_type[0].gives_exact_dydt_out := 1
			bsimp_inst.bsimp_type[0].alloc := bsimp_inst.bsimp_alloc_address
			bsimp_inst.bsimp_type[0].apply := bsimp_inst.bsimp_apply_address
			bsimp_inst.bsimp_type[0].reset := bsimp_inst.bsimp_reset_address
			bsimp_inst.bsimp_type[0].order := bsimp_inst.bsimp_order_address
			bsimp_inst.bsimp_type[0].free := bsimp_inst.bsimp_free_address
			bsimp_inst.gsl_odeiv_step_bsimp := bsimp_inst.bsimp_type
			reversehalton_inst.reversehalton_type[0].name := ce_string ("reversehalton")
			reversehalton_inst.reversehalton_type[0].max_dimension := {NATURAL_32} 1_229
			reversehalton_inst.reversehalton_type[0].state_size := reversehalton_inst.reversehalton_state_size_address
			reversehalton_inst.reversehalton_type[0].init_state := reversehalton_inst.reversehalton_init_address
			reversehalton_inst.reversehalton_type[0].get := reversehalton_inst.reversehalton_get_address
			reversehalton_inst.gsl_qrng_reversehalton := reversehalton_inst.reversehalton_type
			reversehalton_inst.prime_numbers[0] := 2
			reversehalton_inst.prime_numbers[1] := 3
			reversehalton_inst.prime_numbers[2] := 5
			reversehalton_inst.prime_numbers[3] := 7
			reversehalton_inst.prime_numbers[4] := 11
			reversehalton_inst.prime_numbers[5] := 13
			reversehalton_inst.prime_numbers[6] := 17
			reversehalton_inst.prime_numbers[7] := 19
			reversehalton_inst.prime_numbers[8] := 23
			reversehalton_inst.prime_numbers[9] := 29
			reversehalton_inst.prime_numbers[10] := 31
			reversehalton_inst.prime_numbers[11] := 37
			reversehalton_inst.prime_numbers[12] := 41
			reversehalton_inst.prime_numbers[13] := 43
			reversehalton_inst.prime_numbers[14] := 47
			reversehalton_inst.prime_numbers[15] := 53
			reversehalton_inst.prime_numbers[16] := 59
			reversehalton_inst.prime_numbers[17] := 61
			reversehalton_inst.prime_numbers[18] := 67
			reversehalton_inst.prime_numbers[19] := 71
			reversehalton_inst.prime_numbers[20] := 73
			reversehalton_inst.prime_numbers[21] := 79
			reversehalton_inst.prime_numbers[22] := 83
			reversehalton_inst.prime_numbers[23] := 89
			reversehalton_inst.prime_numbers[24] := 97
			reversehalton_inst.prime_numbers[25] := 101
			reversehalton_inst.prime_numbers[26] := 103
			reversehalton_inst.prime_numbers[27] := 107
			reversehalton_inst.prime_numbers[28] := 109
			reversehalton_inst.prime_numbers[29] := 113
			reversehalton_inst.prime_numbers[30] := 127
			reversehalton_inst.prime_numbers[31] := 131
			reversehalton_inst.prime_numbers[32] := 137
			reversehalton_inst.prime_numbers[33] := 139
			reversehalton_inst.prime_numbers[34] := 149
			reversehalton_inst.prime_numbers[35] := 151
			reversehalton_inst.prime_numbers[36] := 157
			reversehalton_inst.prime_numbers[37] := 163
			reversehalton_inst.prime_numbers[38] := 167
			reversehalton_inst.prime_numbers[39] := 173
			reversehalton_inst.prime_numbers[40] := 179
			reversehalton_inst.prime_numbers[41] := 181
			reversehalton_inst.prime_numbers[42] := 191
			reversehalton_inst.prime_numbers[43] := 193
			reversehalton_inst.prime_numbers[44] := 197
			reversehalton_inst.prime_numbers[45] := 199
			reversehalton_inst.prime_numbers[46] := 211
			reversehalton_inst.prime_numbers[47] := 223
			reversehalton_inst.prime_numbers[48] := 227
			reversehalton_inst.prime_numbers[49] := 229
			reversehalton_inst.prime_numbers[50] := 233
			reversehalton_inst.prime_numbers[51] := 239
			reversehalton_inst.prime_numbers[52] := 241
			reversehalton_inst.prime_numbers[53] := 251
			reversehalton_inst.prime_numbers[54] := 257
			reversehalton_inst.prime_numbers[55] := 263
			reversehalton_inst.prime_numbers[56] := 269
			reversehalton_inst.prime_numbers[57] := 271
			reversehalton_inst.prime_numbers[58] := 277
			reversehalton_inst.prime_numbers[59] := 281
			reversehalton_inst.prime_numbers[60] := 283
			reversehalton_inst.prime_numbers[61] := 293
			reversehalton_inst.prime_numbers[62] := 307
			reversehalton_inst.prime_numbers[63] := 311
			reversehalton_inst.prime_numbers[64] := 313
			reversehalton_inst.prime_numbers[65] := 317
			reversehalton_inst.prime_numbers[66] := 331
			reversehalton_inst.prime_numbers[67] := 337
			reversehalton_inst.prime_numbers[68] := 347
			reversehalton_inst.prime_numbers[69] := 349
			reversehalton_inst.prime_numbers[70] := 353
			reversehalton_inst.prime_numbers[71] := 359
			reversehalton_inst.prime_numbers[72] := 367
			reversehalton_inst.prime_numbers[73] := 373
			reversehalton_inst.prime_numbers[74] := 379
			reversehalton_inst.prime_numbers[75] := 383
			reversehalton_inst.prime_numbers[76] := 389
			reversehalton_inst.prime_numbers[77] := 397
			reversehalton_inst.prime_numbers[78] := 401
			reversehalton_inst.prime_numbers[79] := 409
			reversehalton_inst.prime_numbers[80] := 419
			reversehalton_inst.prime_numbers[81] := 421
			reversehalton_inst.prime_numbers[82] := 431
			reversehalton_inst.prime_numbers[83] := 433
			reversehalton_inst.prime_numbers[84] := 439
			reversehalton_inst.prime_numbers[85] := 443
			reversehalton_inst.prime_numbers[86] := 449
			reversehalton_inst.prime_numbers[87] := 457
			reversehalton_inst.prime_numbers[88] := 461
			reversehalton_inst.prime_numbers[89] := 463
			reversehalton_inst.prime_numbers[90] := 467
			reversehalton_inst.prime_numbers[91] := 479
			reversehalton_inst.prime_numbers[92] := 487
			reversehalton_inst.prime_numbers[93] := 491
			reversehalton_inst.prime_numbers[94] := 499
			reversehalton_inst.prime_numbers[95] := 503
			reversehalton_inst.prime_numbers[96] := 509
			reversehalton_inst.prime_numbers[97] := 521
			reversehalton_inst.prime_numbers[98] := 523
			reversehalton_inst.prime_numbers[99] := 541
			reversehalton_inst.prime_numbers[100] := 547
			reversehalton_inst.prime_numbers[101] := 557
			reversehalton_inst.prime_numbers[102] := 563
			reversehalton_inst.prime_numbers[103] := 569
			reversehalton_inst.prime_numbers[104] := 571
			reversehalton_inst.prime_numbers[105] := 577
			reversehalton_inst.prime_numbers[106] := 587
			reversehalton_inst.prime_numbers[107] := 593
			reversehalton_inst.prime_numbers[108] := 599
			reversehalton_inst.prime_numbers[109] := 601
			reversehalton_inst.prime_numbers[110] := 607
			reversehalton_inst.prime_numbers[111] := 613
			reversehalton_inst.prime_numbers[112] := 617
			reversehalton_inst.prime_numbers[113] := 619
			reversehalton_inst.prime_numbers[114] := 631
			reversehalton_inst.prime_numbers[115] := 641
			reversehalton_inst.prime_numbers[116] := 643
			reversehalton_inst.prime_numbers[117] := 647
			reversehalton_inst.prime_numbers[118] := 653
			reversehalton_inst.prime_numbers[119] := 659
			reversehalton_inst.prime_numbers[120] := 661
			reversehalton_inst.prime_numbers[121] := 673
			reversehalton_inst.prime_numbers[122] := 677
			reversehalton_inst.prime_numbers[123] := 683
			reversehalton_inst.prime_numbers[124] := 691
			reversehalton_inst.prime_numbers[125] := 701
			reversehalton_inst.prime_numbers[126] := 709
			reversehalton_inst.prime_numbers[127] := 719
			reversehalton_inst.prime_numbers[128] := 727
			reversehalton_inst.prime_numbers[129] := 733
			reversehalton_inst.prime_numbers[130] := 739
			reversehalton_inst.prime_numbers[131] := 743
			reversehalton_inst.prime_numbers[132] := 751
			reversehalton_inst.prime_numbers[133] := 757
			reversehalton_inst.prime_numbers[134] := 761
			reversehalton_inst.prime_numbers[135] := 769
			reversehalton_inst.prime_numbers[136] := 773
			reversehalton_inst.prime_numbers[137] := 787
			reversehalton_inst.prime_numbers[138] := 797
			reversehalton_inst.prime_numbers[139] := 809
			reversehalton_inst.prime_numbers[140] := 811
			reversehalton_inst.prime_numbers[141] := 821
			reversehalton_inst.prime_numbers[142] := 823
			reversehalton_inst.prime_numbers[143] := 827
			reversehalton_inst.prime_numbers[144] := 829
			reversehalton_inst.prime_numbers[145] := 839
			reversehalton_inst.prime_numbers[146] := 853
			reversehalton_inst.prime_numbers[147] := 857
			reversehalton_inst.prime_numbers[148] := 859
			reversehalton_inst.prime_numbers[149] := 863
			reversehalton_inst.prime_numbers[150] := 877
			reversehalton_inst.prime_numbers[151] := 881
			reversehalton_inst.prime_numbers[152] := 883
			reversehalton_inst.prime_numbers[153] := 887
			reversehalton_inst.prime_numbers[154] := 907
			reversehalton_inst.prime_numbers[155] := 911
			reversehalton_inst.prime_numbers[156] := 919
			reversehalton_inst.prime_numbers[157] := 929
			reversehalton_inst.prime_numbers[158] := 937
			reversehalton_inst.prime_numbers[159] := 941
			reversehalton_inst.prime_numbers[160] := 947
			reversehalton_inst.prime_numbers[161] := 953
			reversehalton_inst.prime_numbers[162] := 967
			reversehalton_inst.prime_numbers[163] := 971
			reversehalton_inst.prime_numbers[164] := 977
			reversehalton_inst.prime_numbers[165] := 983
			reversehalton_inst.prime_numbers[166] := 991
			reversehalton_inst.prime_numbers[167] := 997
			reversehalton_inst.prime_numbers[168] := 1_009
			reversehalton_inst.prime_numbers[169] := 1_013
			reversehalton_inst.prime_numbers[170] := 1_019
			reversehalton_inst.prime_numbers[171] := 1_021
			reversehalton_inst.prime_numbers[172] := 1_031
			reversehalton_inst.prime_numbers[173] := 1_033
			reversehalton_inst.prime_numbers[174] := 1_039
			reversehalton_inst.prime_numbers[175] := 1_049
			reversehalton_inst.prime_numbers[176] := 1_051
			reversehalton_inst.prime_numbers[177] := 1_061
			reversehalton_inst.prime_numbers[178] := 1_063
			reversehalton_inst.prime_numbers[179] := 1_069
			reversehalton_inst.prime_numbers[180] := 1_087
			reversehalton_inst.prime_numbers[181] := 1_091
			reversehalton_inst.prime_numbers[182] := 1_093
			reversehalton_inst.prime_numbers[183] := 1_097
			reversehalton_inst.prime_numbers[184] := 1_103
			reversehalton_inst.prime_numbers[185] := 1_109
			reversehalton_inst.prime_numbers[186] := 1_117
			reversehalton_inst.prime_numbers[187] := 1_123
			reversehalton_inst.prime_numbers[188] := 1_129
			reversehalton_inst.prime_numbers[189] := 1_151
			reversehalton_inst.prime_numbers[190] := 1_153
			reversehalton_inst.prime_numbers[191] := 1_163
			reversehalton_inst.prime_numbers[192] := 1_171
			reversehalton_inst.prime_numbers[193] := 1_181
			reversehalton_inst.prime_numbers[194] := 1_187
			reversehalton_inst.prime_numbers[195] := 1_193
			reversehalton_inst.prime_numbers[196] := 1_201
			reversehalton_inst.prime_numbers[197] := 1_213
			reversehalton_inst.prime_numbers[198] := 1_217
			reversehalton_inst.prime_numbers[199] := 1_223
			reversehalton_inst.prime_numbers[200] := 1_229
			reversehalton_inst.prime_numbers[201] := 1_231
			reversehalton_inst.prime_numbers[202] := 1_237
			reversehalton_inst.prime_numbers[203] := 1_249
			reversehalton_inst.prime_numbers[204] := 1_259
			reversehalton_inst.prime_numbers[205] := 1_277
			reversehalton_inst.prime_numbers[206] := 1_279
			reversehalton_inst.prime_numbers[207] := 1_283
			reversehalton_inst.prime_numbers[208] := 1_289
			reversehalton_inst.prime_numbers[209] := 1_291
			reversehalton_inst.prime_numbers[210] := 1_297
			reversehalton_inst.prime_numbers[211] := 1_301
			reversehalton_inst.prime_numbers[212] := 1_303
			reversehalton_inst.prime_numbers[213] := 1_307
			reversehalton_inst.prime_numbers[214] := 1_319
			reversehalton_inst.prime_numbers[215] := 1_321
			reversehalton_inst.prime_numbers[216] := 1_327
			reversehalton_inst.prime_numbers[217] := 1_361
			reversehalton_inst.prime_numbers[218] := 1_367
			reversehalton_inst.prime_numbers[219] := 1_373
			reversehalton_inst.prime_numbers[220] := 1_381
			reversehalton_inst.prime_numbers[221] := 1_399
			reversehalton_inst.prime_numbers[222] := 1_409
			reversehalton_inst.prime_numbers[223] := 1_423
			reversehalton_inst.prime_numbers[224] := 1_427
			reversehalton_inst.prime_numbers[225] := 1_429
			reversehalton_inst.prime_numbers[226] := 1_433
			reversehalton_inst.prime_numbers[227] := 1_439
			reversehalton_inst.prime_numbers[228] := 1_447
			reversehalton_inst.prime_numbers[229] := 1_451
			reversehalton_inst.prime_numbers[230] := 1_453
			reversehalton_inst.prime_numbers[231] := 1_459
			reversehalton_inst.prime_numbers[232] := 1_471
			reversehalton_inst.prime_numbers[233] := 1_481
			reversehalton_inst.prime_numbers[234] := 1_483
			reversehalton_inst.prime_numbers[235] := 1_487
			reversehalton_inst.prime_numbers[236] := 1_489
			reversehalton_inst.prime_numbers[237] := 1_493
			reversehalton_inst.prime_numbers[238] := 1_499
			reversehalton_inst.prime_numbers[239] := 1_511
			reversehalton_inst.prime_numbers[240] := 1_523
			reversehalton_inst.prime_numbers[241] := 1_531
			reversehalton_inst.prime_numbers[242] := 1_543
			reversehalton_inst.prime_numbers[243] := 1_549
			reversehalton_inst.prime_numbers[244] := 1_553
			reversehalton_inst.prime_numbers[245] := 1_559
			reversehalton_inst.prime_numbers[246] := 1_567
			reversehalton_inst.prime_numbers[247] := 1_571
			reversehalton_inst.prime_numbers[248] := 1_579
			reversehalton_inst.prime_numbers[249] := 1_583
			reversehalton_inst.prime_numbers[250] := 1_597
			reversehalton_inst.prime_numbers[251] := 1_601
			reversehalton_inst.prime_numbers[252] := 1_607
			reversehalton_inst.prime_numbers[253] := 1_609
			reversehalton_inst.prime_numbers[254] := 1_613
			reversehalton_inst.prime_numbers[255] := 1_619
			reversehalton_inst.prime_numbers[256] := 1_621
			reversehalton_inst.prime_numbers[257] := 1_627
			reversehalton_inst.prime_numbers[258] := 1_637
			reversehalton_inst.prime_numbers[259] := 1_657
			reversehalton_inst.prime_numbers[260] := 1_663
			reversehalton_inst.prime_numbers[261] := 1_667
			reversehalton_inst.prime_numbers[262] := 1_669
			reversehalton_inst.prime_numbers[263] := 1_693
			reversehalton_inst.prime_numbers[264] := 1_697
			reversehalton_inst.prime_numbers[265] := 1_699
			reversehalton_inst.prime_numbers[266] := 1_709
			reversehalton_inst.prime_numbers[267] := 1_721
			reversehalton_inst.prime_numbers[268] := 1_723
			reversehalton_inst.prime_numbers[269] := 1_733
			reversehalton_inst.prime_numbers[270] := 1_741
			reversehalton_inst.prime_numbers[271] := 1_747
			reversehalton_inst.prime_numbers[272] := 1_753
			reversehalton_inst.prime_numbers[273] := 1_759
			reversehalton_inst.prime_numbers[274] := 1_777
			reversehalton_inst.prime_numbers[275] := 1_783
			reversehalton_inst.prime_numbers[276] := 1_787
			reversehalton_inst.prime_numbers[277] := 1_789
			reversehalton_inst.prime_numbers[278] := 1_801
			reversehalton_inst.prime_numbers[279] := 1_811
			reversehalton_inst.prime_numbers[280] := 1_823
			reversehalton_inst.prime_numbers[281] := 1_831
			reversehalton_inst.prime_numbers[282] := 1_847
			reversehalton_inst.prime_numbers[283] := 1_861
			reversehalton_inst.prime_numbers[284] := 1_867
			reversehalton_inst.prime_numbers[285] := 1_871
			reversehalton_inst.prime_numbers[286] := 1_873
			reversehalton_inst.prime_numbers[287] := 1_877
			reversehalton_inst.prime_numbers[288] := 1_879
			reversehalton_inst.prime_numbers[289] := 1_889
			reversehalton_inst.prime_numbers[290] := 1_901
			reversehalton_inst.prime_numbers[291] := 1_907
			reversehalton_inst.prime_numbers[292] := 1_913
			reversehalton_inst.prime_numbers[293] := 1_931
			reversehalton_inst.prime_numbers[294] := 1_933
			reversehalton_inst.prime_numbers[295] := 1_949
			reversehalton_inst.prime_numbers[296] := 1_951
			reversehalton_inst.prime_numbers[297] := 1_973
			reversehalton_inst.prime_numbers[298] := 1_979
			reversehalton_inst.prime_numbers[299] := 1_987
			reversehalton_inst.prime_numbers[300] := 1_993
			reversehalton_inst.prime_numbers[301] := 1_997
			reversehalton_inst.prime_numbers[302] := 1_999
			reversehalton_inst.prime_numbers[303] := 2_003
			reversehalton_inst.prime_numbers[304] := 2_011
			reversehalton_inst.prime_numbers[305] := 2_017
			reversehalton_inst.prime_numbers[306] := 2_027
			reversehalton_inst.prime_numbers[307] := 2_029
			reversehalton_inst.prime_numbers[308] := 2_039
			reversehalton_inst.prime_numbers[309] := 2_053
			reversehalton_inst.prime_numbers[310] := 2_063
			reversehalton_inst.prime_numbers[311] := 2_069
			reversehalton_inst.prime_numbers[312] := 2_081
			reversehalton_inst.prime_numbers[313] := 2_083
			reversehalton_inst.prime_numbers[314] := 2_087
			reversehalton_inst.prime_numbers[315] := 2_089
			reversehalton_inst.prime_numbers[316] := 2_099
			reversehalton_inst.prime_numbers[317] := 2_111
			reversehalton_inst.prime_numbers[318] := 2_113
			reversehalton_inst.prime_numbers[319] := 2_129
			reversehalton_inst.prime_numbers[320] := 2_131
			reversehalton_inst.prime_numbers[321] := 2_137
			reversehalton_inst.prime_numbers[322] := 2_141
			reversehalton_inst.prime_numbers[323] := 2_143
			reversehalton_inst.prime_numbers[324] := 2_153
			reversehalton_inst.prime_numbers[325] := 2_161
			reversehalton_inst.prime_numbers[326] := 2_179
			reversehalton_inst.prime_numbers[327] := 2_203
			reversehalton_inst.prime_numbers[328] := 2_207
			reversehalton_inst.prime_numbers[329] := 2_213
			reversehalton_inst.prime_numbers[330] := 2_221
			reversehalton_inst.prime_numbers[331] := 2_237
			reversehalton_inst.prime_numbers[332] := 2_239
			reversehalton_inst.prime_numbers[333] := 2_243
			reversehalton_inst.prime_numbers[334] := 2_251
			reversehalton_inst.prime_numbers[335] := 2_267
			reversehalton_inst.prime_numbers[336] := 2_269
			reversehalton_inst.prime_numbers[337] := 2_273
			reversehalton_inst.prime_numbers[338] := 2_281
			reversehalton_inst.prime_numbers[339] := 2_287
			reversehalton_inst.prime_numbers[340] := 2_293
			reversehalton_inst.prime_numbers[341] := 2_297
			reversehalton_inst.prime_numbers[342] := 2_309
			reversehalton_inst.prime_numbers[343] := 2_311
			reversehalton_inst.prime_numbers[344] := 2_333
			reversehalton_inst.prime_numbers[345] := 2_339
			reversehalton_inst.prime_numbers[346] := 2_341
			reversehalton_inst.prime_numbers[347] := 2_347
			reversehalton_inst.prime_numbers[348] := 2_351
			reversehalton_inst.prime_numbers[349] := 2_357
			reversehalton_inst.prime_numbers[350] := 2_371
			reversehalton_inst.prime_numbers[351] := 2_377
			reversehalton_inst.prime_numbers[352] := 2_381
			reversehalton_inst.prime_numbers[353] := 2_383
			reversehalton_inst.prime_numbers[354] := 2_389
			reversehalton_inst.prime_numbers[355] := 2_393
			reversehalton_inst.prime_numbers[356] := 2_399
			reversehalton_inst.prime_numbers[357] := 2_411
			reversehalton_inst.prime_numbers[358] := 2_417
			reversehalton_inst.prime_numbers[359] := 2_423
			reversehalton_inst.prime_numbers[360] := 2_437
			reversehalton_inst.prime_numbers[361] := 2_441
			reversehalton_inst.prime_numbers[362] := 2_447
			reversehalton_inst.prime_numbers[363] := 2_459
			reversehalton_inst.prime_numbers[364] := 2_467
			reversehalton_inst.prime_numbers[365] := 2_473
			reversehalton_inst.prime_numbers[366] := 2_477
			reversehalton_inst.prime_numbers[367] := 2_503
			reversehalton_inst.prime_numbers[368] := 2_521
			reversehalton_inst.prime_numbers[369] := 2_531
			reversehalton_inst.prime_numbers[370] := 2_539
			reversehalton_inst.prime_numbers[371] := 2_543
			reversehalton_inst.prime_numbers[372] := 2_549
			reversehalton_inst.prime_numbers[373] := 2_551
			reversehalton_inst.prime_numbers[374] := 2_557
			reversehalton_inst.prime_numbers[375] := 2_579
			reversehalton_inst.prime_numbers[376] := 2_591
			reversehalton_inst.prime_numbers[377] := 2_593
			reversehalton_inst.prime_numbers[378] := 2_609
			reversehalton_inst.prime_numbers[379] := 2_617
			reversehalton_inst.prime_numbers[380] := 2_621
			reversehalton_inst.prime_numbers[381] := 2_633
			reversehalton_inst.prime_numbers[382] := 2_647
			reversehalton_inst.prime_numbers[383] := 2_657
			reversehalton_inst.prime_numbers[384] := 2_659
			reversehalton_inst.prime_numbers[385] := 2_663
			reversehalton_inst.prime_numbers[386] := 2_671
			reversehalton_inst.prime_numbers[387] := 2_677
			reversehalton_inst.prime_numbers[388] := 2_683
			reversehalton_inst.prime_numbers[389] := 2_687
			reversehalton_inst.prime_numbers[390] := 2_689
			reversehalton_inst.prime_numbers[391] := 2_693
			reversehalton_inst.prime_numbers[392] := 2_699
			reversehalton_inst.prime_numbers[393] := 2_707
			reversehalton_inst.prime_numbers[394] := 2_711
			reversehalton_inst.prime_numbers[395] := 2_713
			reversehalton_inst.prime_numbers[396] := 2_719
			reversehalton_inst.prime_numbers[397] := 2_729
			reversehalton_inst.prime_numbers[398] := 2_731
			reversehalton_inst.prime_numbers[399] := 2_741
			reversehalton_inst.prime_numbers[400] := 2_749
			reversehalton_inst.prime_numbers[401] := 2_753
			reversehalton_inst.prime_numbers[402] := 2_767
			reversehalton_inst.prime_numbers[403] := 2_777
			reversehalton_inst.prime_numbers[404] := 2_789
			reversehalton_inst.prime_numbers[405] := 2_791
			reversehalton_inst.prime_numbers[406] := 2_797
			reversehalton_inst.prime_numbers[407] := 2_801
			reversehalton_inst.prime_numbers[408] := 2_803
			reversehalton_inst.prime_numbers[409] := 2_819
			reversehalton_inst.prime_numbers[410] := 2_833
			reversehalton_inst.prime_numbers[411] := 2_837
			reversehalton_inst.prime_numbers[412] := 2_843
			reversehalton_inst.prime_numbers[413] := 2_851
			reversehalton_inst.prime_numbers[414] := 2_857
			reversehalton_inst.prime_numbers[415] := 2_861
			reversehalton_inst.prime_numbers[416] := 2_879
			reversehalton_inst.prime_numbers[417] := 2_887
			reversehalton_inst.prime_numbers[418] := 2_897
			reversehalton_inst.prime_numbers[419] := 2_903
			reversehalton_inst.prime_numbers[420] := 2_909
			reversehalton_inst.prime_numbers[421] := 2_917
			reversehalton_inst.prime_numbers[422] := 2_927
			reversehalton_inst.prime_numbers[423] := 2_939
			reversehalton_inst.prime_numbers[424] := 2_953
			reversehalton_inst.prime_numbers[425] := 2_957
			reversehalton_inst.prime_numbers[426] := 2_963
			reversehalton_inst.prime_numbers[427] := 2_969
			reversehalton_inst.prime_numbers[428] := 2_971
			reversehalton_inst.prime_numbers[429] := 2_999
			reversehalton_inst.prime_numbers[430] := 3_001
			reversehalton_inst.prime_numbers[431] := 3_011
			reversehalton_inst.prime_numbers[432] := 3_019
			reversehalton_inst.prime_numbers[433] := 3_023
			reversehalton_inst.prime_numbers[434] := 3_037
			reversehalton_inst.prime_numbers[435] := 3_041
			reversehalton_inst.prime_numbers[436] := 3_049
			reversehalton_inst.prime_numbers[437] := 3_061
			reversehalton_inst.prime_numbers[438] := 3_067
			reversehalton_inst.prime_numbers[439] := 3_079
			reversehalton_inst.prime_numbers[440] := 3_083
			reversehalton_inst.prime_numbers[441] := 3_089
			reversehalton_inst.prime_numbers[442] := 3_109
			reversehalton_inst.prime_numbers[443] := 3_119
			reversehalton_inst.prime_numbers[444] := 3_121
			reversehalton_inst.prime_numbers[445] := 3_137
			reversehalton_inst.prime_numbers[446] := 3_163
			reversehalton_inst.prime_numbers[447] := 3_167
			reversehalton_inst.prime_numbers[448] := 3_169
			reversehalton_inst.prime_numbers[449] := 3_181
			reversehalton_inst.prime_numbers[450] := 3_187
			reversehalton_inst.prime_numbers[451] := 3_191
			reversehalton_inst.prime_numbers[452] := 3_203
			reversehalton_inst.prime_numbers[453] := 3_209
			reversehalton_inst.prime_numbers[454] := 3_217
			reversehalton_inst.prime_numbers[455] := 3_221
			reversehalton_inst.prime_numbers[456] := 3_229
			reversehalton_inst.prime_numbers[457] := 3_251
			reversehalton_inst.prime_numbers[458] := 3_253
			reversehalton_inst.prime_numbers[459] := 3_257
			reversehalton_inst.prime_numbers[460] := 3_259
			reversehalton_inst.prime_numbers[461] := 3_271
			reversehalton_inst.prime_numbers[462] := 3_299
			reversehalton_inst.prime_numbers[463] := 3_301
			reversehalton_inst.prime_numbers[464] := 3_307
			reversehalton_inst.prime_numbers[465] := 3_313
		end

end
