class
	P_COERCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_coerce_double (a_x: REAL_64): REAL_64
		local
			l_y: REAL_64
		do
			l_y := a_x
			Result := l_y
		end

	gsl_coerce_float (a_x: REAL_32): REAL_32
		local
			l_y: REAL_32
		do
			l_y := a_x
			Result := l_y
		end

	gsl_coerce_long_double (a_x: REAL_96): REAL_96
		local
			l_y: REAL_96
		do
			l_y := a_x
			Result := l_y
		end

end
