class
	P_GRADIENT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_multifit_gradient (a_J: CE_POINTER [PD_GSL_MATRIX]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_g: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (blas_inst.gsl_blas_dgemv ({PC_CBLAS_TRANSPOSE}.CblasTrans, 1.0, a_J, a_f, 0.0, a_g))
			Result := l_status
		end

end
