class
	P_GSL_GSL_COMPLEX_MATH

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_complex_rect (a_x: REAL_64; a_y: REAL_64): PD_GSL_COMPLEX
		local
			l_z: PD_GSL_COMPLEX
			js: JUMP_STATE
		do
			create l_z.make

			from
			until
				js.loop_done
			loop
				l_z.dat[0] := a_x
				l_z.dat[1] := a_y
				js.break
			end
			Result := l_z.twin
		end

end
