class
	P_GSL_GSL_VECTOR_COMPLEX_DOUBLE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_vector_complex_const_ptr (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_i: NATURAL_32): CE_POINTER [PD_GSL_COMPLEX]
		do
			Result := (create {CE_POINTER [PD_GSL_COMPLEX]}.make_cast ((a_v.item.data + (({NATURAL_32} 2 * a_i) * a_v.item.stride).to_integer_32)))
		end

	gsl_vector_complex_get (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_i: NATURAL_32): PD_GSL_COMPLEX
		do
			Result := ((create {CE_POINTER [PD_GSL_COMPLEX]}.make_cast ((a_v.item.data + (({NATURAL_32} 2 * a_i) * a_v.item.stride).to_integer_32))).item).twin
		end

	gsl_vector_complex_ptr (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_i: NATURAL_32): CE_POINTER [PD_GSL_COMPLEX]
		do
			Result := (create {CE_POINTER [PD_GSL_COMPLEX]}.make_cast ((a_v.item.data + (({NATURAL_32} 2 * a_i) * a_v.item.stride).to_integer_32)))
		end

	gsl_vector_complex_set (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_i: NATURAL_32; a_z: PD_GSL_COMPLEX)
		do
			(create {CE_POINTER [PD_GSL_COMPLEX]}.make_cast ((a_v.item.data + (({NATURAL_32} 2 * a_i) * a_v.item.stride).to_integer_32))).item := a_z.twin
		end

end
