class
	P_GSL_GSL_VECTOR_USHORT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_vector_ushort_const_ptr (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_i: NATURAL_32): CE_POINTER [NATURAL_16]
		do
			Result := (a_v.item.data + (a_i * a_v.item.stride).to_integer_32)
		end

	gsl_vector_ushort_get (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_i: NATURAL_32): NATURAL_16
		do
			Result := (a_v.item.data[(a_i * a_v.item.stride).to_integer_32])
		end

	gsl_vector_ushort_ptr (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_i: NATURAL_32): CE_POINTER [NATURAL_16]
		do
			Result := (a_v.item.data + (a_i * a_v.item.stride).to_integer_32)
		end

	gsl_vector_ushort_set (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_i: NATURAL_32; a_x: NATURAL_16)
		do
			a_v.item.data[(a_i * a_v.item.stride).to_integer_32] := a_x
		end

end
