class
	P_QRNG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_qrng_alloc (a_T: CE_POINTER [PD_GSL_QRNG_TYPE]; a_dimension: NATURAL_32): CE_POINTER [PD_GSL_QRNG]
		local
			l_q___3: CE_POINTER [PD_GSL_QRNG]
			js: JUMP_STATE
		do
			create l_q___3.make

			l_q___3 := create {CE_POINTER [PD_GSL_QRNG]}.make_cast ((malloc ((create {PD_GSL_QRNG}.make).structure_size.to_natural_32)))
			if l_q___3.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("allocation failed for qrng struct"), ce_string ("qrng.c"), 19, 8)
					Result := (create {CE_POINTER [PD_GSL_QRNG]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_q___3.item.dimension := a_dimension
				l_q___3.item.state_size := (a_T.item.state_size).natural_32_item ([a_dimension])
				l_q___3.item.state := malloc (l_q___3.item.state_size)
				if (l_q___3.item.state).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_q___3))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("allocation failed for qrng state"), ce_string ("qrng.c"), 30, 8)
						Result := (create {CE_POINTER [PD_GSL_QRNG]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_q___3.item.type := a_T;
				(a_T.item.init_state).call ([l_q___3.item.state, l_q___3.item.dimension])
				Result := l_q___3
			end
		end

	gsl_qrng_clone (a_q___3: CE_POINTER [PD_GSL_QRNG]): CE_POINTER [PD_GSL_QRNG]
		local
			l_r___3: CE_POINTER [PD_GSL_QRNG]
			js: JUMP_STATE
		do
			create l_r___3.make

			l_r___3 := create {CE_POINTER [PD_GSL_QRNG]}.make_cast ((malloc ((create {PD_GSL_QRNG}.make).structure_size.to_natural_32)))
			if l_r___3.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for rng struct"), ce_string ("qrng.c"), 70, 8)
					Result := (create {CE_POINTER [PD_GSL_QRNG]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_r___3.item.dimension := a_q___3.item.dimension
				l_r___3.item.state_size := a_q___3.item.state_size
				l_r___3.item.state := malloc (l_r___3.item.state_size)
				if (l_r___3.item.state).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_r___3))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for rng state"), ce_string ("qrng.c"), 81, 8)
						Result := (create {CE_POINTER [PD_GSL_QRNG]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_r___3.item.type := a_q___3.item.type
				memcpy (l_r___3.item.state, a_q___3.item.state, a_q___3.item.state_size).do_nothing
				Result := l_r___3
			end
		end

	gsl_qrng_free (a_q___3: CE_POINTER [PD_GSL_QRNG])
		local
			js: JUMP_STATE
		do
			if a_q___3.is_void then
				js.return
			end
			if not js.return_called then
				if not (a_q___3.item.state).is_void then
					free (a_q___3.item.state)
				end
				free (create {CE_POINTER [ANY]}.make_cast (a_q___3))
			end
		end

	gsl_qrng_init (a_q___3: CE_POINTER [PD_GSL_QRNG])
		do
			((a_q___3.item.type).item.init_state).call ([a_q___3.item.state, a_q___3.item.dimension])
		end

	gsl_qrng_memcpy (a_dest: CE_POINTER [PD_GSL_QRNG]; a_src: CE_POINTER [PD_GSL_QRNG]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if not (a_dest.item.type).is_equal (a_src.item.type) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("generators must be of the same type"), ce_string ("qrng.c"), 51, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				a_dest.item.dimension := a_src.item.dimension
				a_dest.item.state_size := a_src.item.state_size
				memcpy (a_dest.item.state, a_src.item.state, a_src.item.state_size).do_nothing
				Result := 0
			end
		end

	gsl_qrng_name (a_q___3: CE_POINTER [PD_GSL_QRNG]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_q___3.item.type).item.name)
		end

	gsl_qrng_size (a_q___3: CE_POINTER [PD_GSL_QRNG]): NATURAL_32
		do
			Result := (a_q___3.item.state_size)
		end

	gsl_qrng_state (a_q___3: CE_POINTER [PD_GSL_QRNG]): CE_POINTER [ANY]
		do
			Result := (a_q___3.item.state)
		end

end
