class
	P_RESET2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_reset (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D])
		local
			l_i: NATURAL_32
			l_nx: NATURAL_32
			l_ny: NATURAL_32
		do
			l_nx := a_h.item.nx
			l_ny := a_h.item.ny
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_nx * l_ny)
			loop
				a_h.item.bin[l_i.to_integer_32] := (0).to_double
				l_i := l_i + 1
			end
		end

end
