class
	P_TYPES

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_generator_types.make (<<100>>)
		end

feature {ANY} -- attributes

	gsl_rng_generator_types: CE_ARRAY [CE_POINTER [PD_GSL_RNG_TYPE]]

feature {ANY} -- routines

	gsl_rng_types_setup: CE_POINTER [CE_POINTER [PD_GSL_RNG_TYPE]]
		local
			l_i: INTEGER_32
		do
			l_i := 0
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := borosh13_inst.gsl_rng_borosh13
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := cmrg_inst.gsl_rng_cmrg
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := coveyou_inst.gsl_rng_coveyou
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := fishman18_inst.gsl_rng_fishman18
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := fishman20_inst.gsl_rng_fishman20
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := fishman2x_inst.gsl_rng_fishman2x
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := gfsr4_inst.gsl_rng_gfsr4
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := knuthran_inst.gsl_rng_knuthran
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := knuthran2_inst.gsl_rng_knuthran2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := knuthran2002_inst.gsl_rng_knuthran2002
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := lecuyer21_inst.gsl_rng_lecuyer21
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := minstd_inst.gsl_rng_minstd
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := mrg_inst.gsl_rng_mrg
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := mt_inst.gsl_rng_mt19937
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := mt_inst.gsl_rng_mt19937_1999
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := mt_inst.gsl_rng_mt19937_1998
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := r250_inst.gsl_rng_r250
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ran0_inst.gsl_rng_ran0
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ran1_inst.gsl_rng_ran1
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ran2_inst.gsl_rng_ran2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ran3_inst.gsl_rng_ran3
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := rand_inst.gsl_rng_rand
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := rand48_inst.gsl_rng_rand48
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random128_bsd
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random128_glibc2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random128_libc5
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random256_bsd
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random256_glibc2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random256_libc5
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random32_bsd
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random32_glibc2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random32_libc5
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random64_bsd
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random64_glibc2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random64_libc5
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random8_bsd
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random8_glibc2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random8_libc5
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random_bsd
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random_glibc2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := random_inst.gsl_rng_random_libc5
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := randu_inst.gsl_rng_randu
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranf_inst.gsl_rng_ranf
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranlux_inst.gsl_rng_ranlux
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranlux_inst.gsl_rng_ranlux389
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranlxd_inst.gsl_rng_ranlxd1
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranlxd_inst.gsl_rng_ranlxd2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranlxs_inst.gsl_rng_ranlxs0
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranlxs_inst.gsl_rng_ranlxs1
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranlxs_inst.gsl_rng_ranlxs2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := ranmar_inst.gsl_rng_ranmar
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := slatec_inst.gsl_rng_slatec
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := taus_inst.gsl_rng_taus
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := taus_inst.gsl_rng_taus2
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := taus113_inst.gsl_rng_taus113
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := transputer_inst.gsl_rng_transputer
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := tt_inst.gsl_rng_tt800
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := uni_inst.gsl_rng_uni
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := uni32_inst.gsl_rng_uni32
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := vax_inst.gsl_rng_vax
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := waterman14_inst.gsl_rng_waterman14
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := zuf_inst.gsl_rng_zuf
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types[l_i] := create {CE_POINTER [PD_GSL_RNG_TYPE]}.make_shared (default_pointer)
			l_i := l_i + 1
			Result := gsl_rng_generator_types
		end

end
