class
	PD_EYESREC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create core.make
			create eyes.make
		end

feature {ANY} -- fields

	core: SD_COREPART assign set_core

	eyes: PD_EYESPART assign set_eyes

feature {ANY} -- setters

	set_core (a_core: SD_COREPART)
		do
			core := a_core
			update_memory_field ("core")
		end

	set_eyes (a_eyes: PD_EYESPART)
		do
			eyes := a_eyes
			update_memory_field ("eyes")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			core := a_other.core.twin
			eyes := a_other.eyes.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				core.is_equal (a_other.core) and
				eyes.is_equal (a_other.eyes)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("core"),
					create {CE_STRUCTURE_FIELD}.make ("eyes")
				>>)
			init_structure_info
		end

end
