deferred class
	S_X11_INTRINSIC

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	XtAddConverter (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: CE_POINTER [INTEGER_8]; a_arg3: CE_ROUTINE; a_arg4: CE_POINTER [SD_XTCONVERTARGREC]; a_arg5: NATURAL_32)
		do
			c_XtAddConverter (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5)
		end

	c_XtAddConverter (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: POINTER; a_arg5: NATURAL_32)
		external
			"C inline use <xeyes.h>"
		alias
			"XtAddConverter($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	XtAppAddActions (a_arg1: CE_POINTER [ANY]; a_arg2: CE_POINTER [SD_XTACTIONSREC]; a_arg3: NATURAL_32)
		do
			c_XtAppAddActions (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_XtAppAddActions (a_arg1: POINTER; a_arg2: POINTER; a_arg3: NATURAL_32)
		external
			"C inline use <xeyes.h>"
		alias
			"XtAppAddActions($a_arg1, $a_arg2, $a_arg3);"
		end

	XtAppAddTimeOut (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_ROUTINE; a_arg4: CE_POINTER [ANY]): NATURAL_32
		do
			Result := c_XtAppAddTimeOut (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer)
		end

	c_XtAppAddTimeOut (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER): NATURAL_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XtAppAddTimeOut($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XtAppInitialize (a_arg1: CE_POINTER [CE_POINTER [ANY]]; a_arg2: CE_POINTER [INTEGER_8]; a_arg3: CE_POINTER [SD_XRMOPTIONDESCREC]; a_arg4: NATURAL_32; a_arg5: CE_POINTER [INTEGER_32]; a_arg6: CE_POINTER [CE_POINTER [INTEGER_8]]; a_arg7: CE_POINTER [CE_POINTER [INTEGER_8]]; a_arg8: CE_POINTER [SD_ARG]; a_arg9: NATURAL_32): CE_POINTER [SD_WIDGETREC]
		do
			create Result.make_shared (c_XtAppInitialize (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4, a_arg5.c_pointer, a_arg6.c_pointer, a_arg7.c_pointer, a_arg8.c_pointer, a_arg9))
		end

	c_XtAppInitialize (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: NATURAL_32; a_arg5: POINTER; a_arg6: POINTER; a_arg7: POINTER; a_arg8: POINTER; a_arg9: NATURAL_32): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return XtAppInitialize($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

	XtAppMainLoop (a_arg1: CE_POINTER [ANY])
		do
			c_XtAppMainLoop (a_arg1.c_pointer)
		end

	c_XtAppMainLoop (a_arg1: POINTER)
		external
			"C inline use <xeyes.h>"
		alias
			"XtAppMainLoop($a_arg1);"
		end

	XtCreateManagedWidget (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: CE_POINTER [SD_WIDGETCLASSREC]; a_arg3: CE_POINTER [SD_WIDGETREC]; a_arg4: CE_POINTER [SD_ARG]; a_arg5: NATURAL_32): CE_POINTER [SD_WIDGETREC]
		do
			create Result.make_shared (c_XtCreateManagedWidget (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5))
		end

	c_XtCreateManagedWidget (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: POINTER; a_arg5: NATURAL_32): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return XtCreateManagedWidget($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	XtDestroyApplicationContext (a_arg1: CE_POINTER [ANY])
		do
			c_XtDestroyApplicationContext (a_arg1.c_pointer)
		end

	c_XtDestroyApplicationContext (a_arg1: POINTER)
		external
			"C inline use <xeyes.h>"
		alias
			"XtDestroyApplicationContext($a_arg1);"
		end

	XtDisplay (a_arg1: CE_POINTER [SD_WIDGETREC]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_XtDisplay (a_arg1.c_pointer))
		end

	c_XtDisplay (a_arg1: POINTER): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return XtDisplay($a_arg1);"
		end

	XtGetGC (a_arg1: CE_POINTER [SD_WIDGETREC]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [SD_XGCVALUES]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_XtGetGC (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer))
		end

	c_XtGetGC (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return XtGetGC($a_arg1, $a_arg2, $a_arg3);"
		end

	XtOverrideTranslations (a_arg1: CE_POINTER [SD_WIDGETREC]; a_arg2: CE_POINTER [ANY])
		do
			c_XtOverrideTranslations (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_XtOverrideTranslations (a_arg1: POINTER; a_arg2: POINTER)
		external
			"C inline use <xeyes.h>"
		alias
			"XtOverrideTranslations($a_arg1, $a_arg2);"
		end

	XtParseTranslationTable (a_arg1: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_XtParseTranslationTable (a_arg1.c_pointer))
		end

	c_XtParseTranslationTable (a_arg1: POINTER): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return XtParseTranslationTable($a_arg1);"
		end

	XtRealizeWidget (a_arg1: CE_POINTER [SD_WIDGETREC])
		do
			c_XtRealizeWidget (a_arg1.c_pointer)
		end

	c_XtRealizeWidget (a_arg1: POINTER)
		external
			"C inline use <xeyes.h>"
		alias
			"XtRealizeWidget($a_arg1);"
		end

	XtReleaseGC (a_arg1: CE_POINTER [SD_WIDGETREC]; a_arg2: CE_POINTER [ANY])
		do
			c_XtReleaseGC (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_XtReleaseGC (a_arg1: POINTER; a_arg2: POINTER)
		external
			"C inline use <xeyes.h>"
		alias
			"XtReleaseGC($a_arg1, $a_arg2);"
		end

	XtRemoveTimeOut (a_arg1: NATURAL_32)
		external
			"C inline use <xeyes.h>"
		alias
			"XtRemoveTimeOut($a_arg1);"
		end

	XtScreen (a_arg1: CE_POINTER [SD_WIDGETREC]): CE_POINTER [SD_SCREEN]
		do
			create Result.make_shared (c_XtScreen (a_arg1.c_pointer))
		end

	c_XtScreen (a_arg1: POINTER): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return XtScreen($a_arg1);"
		end

	XtSetLanguageProc (a_arg1: CE_POINTER [ANY]; a_arg2: CE_ROUTINE; a_arg3: CE_POINTER [ANY]): CE_ROUTINE
		do
			create Result.make_shared (c_XtSetLanguageProc (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer))
		end

	c_XtSetLanguageProc (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return XtSetLanguageProc($a_arg1, $a_arg2, $a_arg3);"
		end

	XtSetValues (a_arg1: CE_POINTER [SD_WIDGETREC]; a_arg2: CE_POINTER [SD_ARG]; a_arg3: NATURAL_32)
		do
			c_XtSetValues (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_XtSetValues (a_arg1: POINTER; a_arg2: POINTER; a_arg3: NATURAL_32)
		external
			"C inline use <xeyes.h>"
		alias
			"XtSetValues($a_arg1, $a_arg2, $a_arg3);"
		end

	XtWidgetToApplicationContext (a_arg1: CE_POINTER [SD_WIDGETREC]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_XtWidgetToApplicationContext (a_arg1.c_pointer))
		end

	c_XtWidgetToApplicationContext (a_arg1: POINTER): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return XtWidgetToApplicationContext($a_arg1);"
		end

	XtWindow (a_arg1: CE_POINTER [SD_WIDGETREC]): NATURAL_32
		do
			Result := c_XtWindow (a_arg1.c_pointer)
		end

	c_XtWindow (a_arg1: POINTER): NATURAL_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XtWindow($a_arg1);"
		end

	XtWindowOfObject (a_arg1: CE_POINTER [SD_WIDGETREC]): NATURAL_32
		do
			Result := c_XtWindowOfObject (a_arg1.c_pointer)
		end

	c_XtWindowOfObject (a_arg1: POINTER): NATURAL_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XtWindowOfObject($a_arg1);"
		end

end
