class
	CE_EXCEPTION

inherit
	DEVELOPER_EXCEPTION
		rename
			raise as re_raise
		end

create
	make

feature {NONE}

	make (a_routine: POINTER; a_position: INTEGER_32; a_value_var: POINTER)
		do
			routine := a_routine
			position := a_position
			value_var := a_value_var
			set_value (a_value_var, 0)
		end

feature {ANY}

	routine: POINTER

	position: INTEGER_32

	raise (a_value: INTEGER_32)
		do
			if a_value = 0 then
				set_value (value_var, 1)
			else
				set_value (value_var, a_value)
			end
			re_raise
		end

feature {NONE}

	value_var: POINTER

	set_value (a_value_var: POINTER; a_value: INTEGER_32)
		external
			"C inline"
		alias
			"*(int *)$a_value_var = $a_value;"
		end

end
