class
	PD_SCRPOS

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	pos: INTEGER_32 assign set_pos

	ln: INTEGER_32 assign set_ln

feature {ANY} -- setters

	set_pos (a_pos: INTEGER_32)
		do
			pos := a_pos
			update_memory_field ("pos")
		end

	set_ln (a_ln: INTEGER_32)
		do
			ln := a_ln
			update_memory_field ("ln")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pos := a_other.pos
			ln := a_other.ln
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pos = a_other.pos and
				ln = a_other.ln
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pos"),
					create {CE_STRUCTURE_FIELD}.make ("ln")
				>>)
			init_structure_info
		end

end
