frozen class
	LESS_INITIALIZER_SLICE1

inherit
	LESS_DATA
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {LESS_INITIALIZER}

	initialize
		do
			main_inst.every_first_cmd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			main_inst.curr_ifile := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			main_inst.old_ifile := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			main_inst.any_display := 0
			main_inst.start_attnpos := (-1).to_integer_32
			main_inst.end_attnpos := (-1).to_integer_32
			main_inst.logfile := -1
			main_inst.force_logfile := 0
			main_inst.namelogfile := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			screen_inst.init_done := 0
			screen_inst.missing_cap := 0
			screen_inst.attrmode := 0
			screen_inst.curr_on := 0
			screen_inst.saved_term := 0
			ch_inst.ch_ungotchar := -1
			ch_inst.maxbufs := -1
			ch_inst.tried := 0
			charset_inst.utf_mode[0] := 0
			charset_inst.charsets[0].name := ce_string ("ascii")
			charset_inst.charsets[0].p_flag := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			charset_inst.charsets[0].desc := ce_string ("8bcccbcc18b95.b")
			charset_inst.charsets[1].name := ce_string ("dos")
			charset_inst.charsets[1].p_flag := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			charset_inst.charsets[1].desc := ce_string ("8bcccbcc12bc5b223.b")
			charset_inst.charsets[2].name := ce_string ("ebcdic")
			charset_inst.charsets[2].p_flag := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			charset_inst.charsets[2].desc := ce_string ("5bc6bcc7bcc41b.9b7.9b5.b..8b6.10b6.b9.7b9.8b8.17b3.3b9.7b9.8b8.6b10.b.b.b.")
			charset_inst.charsets[3].name := ce_string ("IBM-1047")
			charset_inst.charsets[3].p_flag := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			charset_inst.charsets[3].desc := ce_string ("4cbcbc3b9cbccbccbb4c6bcc5b3cbbc4bc4bccbc191.b")
			charset_inst.charsets[4].name := ce_string ("iso8859")
			charset_inst.charsets[4].p_flag := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			charset_inst.charsets[4].desc := ce_string ("8bcccbcc18b95.33b.")
			charset_inst.charsets[5].name := ce_string ("koi8-r")
			charset_inst.charsets[5].p_flag := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			charset_inst.charsets[5].desc := ce_string ("8bcccbcc18b95.b128.")
			charset_inst.charsets[6].name := ce_string ("next")
			charset_inst.charsets[6].p_flag := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			charset_inst.charsets[6].desc := ce_string ("8bcccbcc18b95.bb125.bb")
			charset_inst.charsets[7].name := ce_string ("utf-8")
			charset_inst.charsets[7].p_flag := charset_inst.utf_mode
			charset_inst.charsets[7].desc := ce_string ("8bcccbcc18b.")
			charset_inst.charsets[8].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			charset_inst.charsets[8].p_flag := create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)
			charset_inst.charsets[8].desc := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			charset_inst.cs_aliases[0].name := ce_string ("latin1")
			charset_inst.cs_aliases[0].oname := ce_string ("iso8859")
			charset_inst.cs_aliases[1].name := ce_string ("latin9")
			charset_inst.cs_aliases[1].oname := ce_string ("iso8859")
			charset_inst.cs_aliases[2].name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			charset_inst.cs_aliases[2].oname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			charset_inst.binfmt := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			charset_inst.binattr := 5
			cmdbuf_inst.in_completion := 0
			cmdbuf_inst.openquote := (('%"').code).to_integer_8
			cmdbuf_inst.closequote := (('%"').code).to_integer_8
			cmdbuf_inst.mlist_search[0].next := cmdbuf_inst.mlist_search
			cmdbuf_inst.mlist_search[0].prev := cmdbuf_inst.mlist_search
			cmdbuf_inst.mlist_search[0].curr_mp := cmdbuf_inst.mlist_search
			cmdbuf_inst.mlist_search[0].string := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			cmdbuf_inst.ml_search := create {CE_POINTER [ANY]}.make_cast (cmdbuf_inst.mlist_search)
			cmdbuf_inst.mlist_examine[0].next := cmdbuf_inst.mlist_examine
			cmdbuf_inst.mlist_examine[0].prev := cmdbuf_inst.mlist_examine
			cmdbuf_inst.mlist_examine[0].curr_mp := cmdbuf_inst.mlist_examine
			cmdbuf_inst.mlist_examine[0].string := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			cmdbuf_inst.ml_examine := create {CE_POINTER [ANY]}.make_cast (cmdbuf_inst.mlist_examine)
			cmdbuf_inst.mlist_shell[0].next := cmdbuf_inst.mlist_shell
			cmdbuf_inst.mlist_shell[0].prev := cmdbuf_inst.mlist_shell
			cmdbuf_inst.mlist_shell[0].curr_mp := cmdbuf_inst.mlist_shell
			cmdbuf_inst.mlist_shell[0].string := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			cmdbuf_inst.ml_shell := create {CE_POINTER [ANY]}.make_cast (cmdbuf_inst.mlist_shell)
			cmdbuf_inst.curr_mlist := create {CE_POINTER [PD_MLIST]}.make_shared (default_pointer)
			command_inst.ungotp := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			command_inst.shellcmd := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			decode_inst.cmdtable[0] := (('%R').code).to_natural_8
			decode_inst.cmdtable[1] := (0).to_natural_8
			decode_inst.cmdtable[2] := (12).to_natural_8
			decode_inst.cmdtable[3] := (('%N').code).to_natural_8
			decode_inst.cmdtable[4] := (0).to_natural_8
			decode_inst.cmdtable[5] := (12).to_natural_8
			decode_inst.cmdtable[6] := (('e').code).to_natural_8
			decode_inst.cmdtable[7] := (0).to_natural_8
			decode_inst.cmdtable[8] := (12).to_natural_8
			decode_inst.cmdtable[9] := (('j').code).to_natural_8
			decode_inst.cmdtable[10] := (0).to_natural_8
			decode_inst.cmdtable[11] := (12).to_natural_8
			decode_inst.cmdtable[12] := (11).to_natural_8
			decode_inst.cmdtable[13] := (4).to_natural_8
			decode_inst.cmdtable[14] := (6).to_natural_8
			decode_inst.cmdtable[15] := (1).to_natural_8
			decode_inst.cmdtable[16] := (1).to_natural_8
			decode_inst.cmdtable[17] := (1).to_natural_8
			decode_inst.cmdtable[18] := (0).to_natural_8
			decode_inst.cmdtable[19] := (12).to_natural_8
			decode_inst.cmdtable[20] := (5).to_natural_8
			decode_inst.cmdtable[21] := (0).to_natural_8
			decode_inst.cmdtable[22] := (12).to_natural_8
			decode_inst.cmdtable[23] := (14).to_natural_8
			decode_inst.cmdtable[24] := (0).to_natural_8
			decode_inst.cmdtable[25] := (12).to_natural_8
			decode_inst.cmdtable[26] := (('k').code).to_natural_8
			decode_inst.cmdtable[27] := (0).to_natural_8
			decode_inst.cmdtable[28] := (2).to_natural_8
			decode_inst.cmdtable[29] := (('y').code).to_natural_8
			decode_inst.cmdtable[30] := (0).to_natural_8
			decode_inst.cmdtable[31] := (2).to_natural_8
			decode_inst.cmdtable[32] := (25).to_natural_8
			decode_inst.cmdtable[33] := (0).to_natural_8
			decode_inst.cmdtable[34] := (2).to_natural_8
			decode_inst.cmdtable[35] := (11).to_natural_8
			decode_inst.cmdtable[36] := (40).to_natural_8
			decode_inst.cmdtable[37] := (6).to_natural_8
			decode_inst.cmdtable[38] := (1).to_natural_8
			decode_inst.cmdtable[39] := (1).to_natural_8
			decode_inst.cmdtable[40] := (1).to_natural_8
			decode_inst.cmdtable[41] := (0).to_natural_8
			decode_inst.cmdtable[42] := (2).to_natural_8
			decode_inst.cmdtable[43] := (16).to_natural_8
			decode_inst.cmdtable[44] := (0).to_natural_8
			decode_inst.cmdtable[45] := (2).to_natural_8
			decode_inst.cmdtable[46] := (11).to_natural_8
			decode_inst.cmdtable[47] := (3).to_natural_8
			decode_inst.cmdtable[48] := (6).to_natural_8
			decode_inst.cmdtable[49] := (1).to_natural_8
			decode_inst.cmdtable[50] := (1).to_natural_8
			decode_inst.cmdtable[51] := (1).to_natural_8
			decode_inst.cmdtable[52] := (0).to_natural_8
			decode_inst.cmdtable[53] := (2).to_natural_8
			decode_inst.cmdtable[54] := (('J').code).to_natural_8
			decode_inst.cmdtable[55] := (0).to_natural_8
			decode_inst.cmdtable[56] := (29).to_natural_8
			decode_inst.cmdtable[57] := (('K').code).to_natural_8
			decode_inst.cmdtable[58] := (0).to_natural_8
			decode_inst.cmdtable[59] := (30).to_natural_8
			decode_inst.cmdtable[60] := (('Y').code).to_natural_8
			decode_inst.cmdtable[61] := (0).to_natural_8
			decode_inst.cmdtable[62] := (30).to_natural_8
			decode_inst.cmdtable[63] := (('d').code).to_natural_8
			decode_inst.cmdtable[64] := (0).to_natural_8
			decode_inst.cmdtable[65] := (14).to_natural_8
			decode_inst.cmdtable[66] := (4).to_natural_8
			decode_inst.cmdtable[67] := (0).to_natural_8
			decode_inst.cmdtable[68] := (14).to_natural_8
			decode_inst.cmdtable[69] := (('u').code).to_natural_8
			decode_inst.cmdtable[70] := (0).to_natural_8
			decode_inst.cmdtable[71] := (4).to_natural_8
			decode_inst.cmdtable[72] := (21).to_natural_8
			decode_inst.cmdtable[73] := (0).to_natural_8
			decode_inst.cmdtable[74] := (4).to_natural_8
			decode_inst.cmdtable[75] := ((' ').code).to_natural_8
			decode_inst.cmdtable[76] := (0).to_natural_8
			decode_inst.cmdtable[77] := (13).to_natural_8
			decode_inst.cmdtable[78] := (('f').code).to_natural_8
			decode_inst.cmdtable[79] := (0).to_natural_8
			decode_inst.cmdtable[80] := (13).to_natural_8
			decode_inst.cmdtable[81] := (6).to_natural_8
			decode_inst.cmdtable[82] := (0).to_natural_8
			decode_inst.cmdtable[83] := (13).to_natural_8
			decode_inst.cmdtable[84] := (22).to_natural_8
			decode_inst.cmdtable[85] := (0).to_natural_8
			decode_inst.cmdtable[86] := (13).to_natural_8
			decode_inst.cmdtable[87] := (11).to_natural_8
			decode_inst.cmdtable[88] := (6).to_natural_8
			decode_inst.cmdtable[89] := (6).to_natural_8
			decode_inst.cmdtable[90] := (1).to_natural_8
			decode_inst.cmdtable[91] := (1).to_natural_8
			decode_inst.cmdtable[92] := (1).to_natural_8
			decode_inst.cmdtable[93] := (0).to_natural_8
			decode_inst.cmdtable[94] := (13).to_natural_8
			decode_inst.cmdtable[95] := (('b').code).to_natural_8
			decode_inst.cmdtable[96] := (0).to_natural_8
			decode_inst.cmdtable[97] := (3).to_natural_8
			decode_inst.cmdtable[98] := (2).to_natural_8
			decode_inst.cmdtable[99] := (0).to_natural_8
			decode_inst.cmdtable[100] := (3).to_natural_8
			decode_inst.cmdtable[101] := (27).to_natural_8
			decode_inst.cmdtable[102] := (('v').code).to_natural_8
			decode_inst.cmdtable[103] := (0).to_natural_8
			decode_inst.cmdtable[104] := (3).to_natural_8
			decode_inst.cmdtable[105] := (11).to_natural_8
			decode_inst.cmdtable[106] := (5).to_natural_8
			decode_inst.cmdtable[107] := (6).to_natural_8
			decode_inst.cmdtable[108] := (1).to_natural_8
			decode_inst.cmdtable[109] := (1).to_natural_8
			decode_inst.cmdtable[110] := (1).to_natural_8
			decode_inst.cmdtable[111] := (0).to_natural_8
			decode_inst.cmdtable[112] := (3).to_natural_8
			decode_inst.cmdtable[113] := (('z').code).to_natural_8
			decode_inst.cmdtable[114] := (0).to_natural_8
			decode_inst.cmdtable[115] := (33).to_natural_8
			decode_inst.cmdtable[116] := (('w').code).to_natural_8
			decode_inst.cmdtable[117] := (0).to_natural_8
			decode_inst.cmdtable[118] := (34).to_natural_8
			decode_inst.cmdtable[119] := (27).to_natural_8
			decode_inst.cmdtable[120] := ((' ').code).to_natural_8
			decode_inst.cmdtable[121] := (0).to_natural_8
			decode_inst.cmdtable[122] := (40).to_natural_8
			decode_inst.cmdtable[123] := (('F').code).to_natural_8
			decode_inst.cmdtable[124] := (0).to_natural_8
			decode_inst.cmdtable[125] := (50).to_natural_8
			decode_inst.cmdtable[126] := (('R').code).to_natural_8
			decode_inst.cmdtable[127] := (0).to_natural_8
			decode_inst.cmdtable[128] := (11).to_natural_8
			decode_inst.cmdtable[129] := (('r').code).to_natural_8
			decode_inst.cmdtable[130] := (0).to_natural_8
			decode_inst.cmdtable[131] := (25).to_natural_8
			decode_inst.cmdtable[132] := (18).to_natural_8
			decode_inst.cmdtable[133] := (0).to_natural_8
			decode_inst.cmdtable[134] := (25).to_natural_8
			decode_inst.cmdtable[135] := (12).to_natural_8
			decode_inst.cmdtable[136] := (0).to_natural_8
			decode_inst.cmdtable[137] := (25).to_natural_8
			decode_inst.cmdtable[138] := (27).to_natural_8
			decode_inst.cmdtable[139] := (('u').code).to_natural_8
			decode_inst.cmdtable[140] := (0).to_natural_8
			decode_inst.cmdtable[141] := (39).to_natural_8
			decode_inst.cmdtable[142] := (('g').code).to_natural_8
			decode_inst.cmdtable[143] := (0).to_natural_8
			decode_inst.cmdtable[144] := (17).to_natural_8
			decode_inst.cmdtable[145] := (11).to_natural_8
			decode_inst.cmdtable[146] := (7).to_natural_8
			decode_inst.cmdtable[147] := (6).to_natural_8
			decode_inst.cmdtable[148] := (1).to_natural_8
			decode_inst.cmdtable[149] := (1).to_natural_8
			decode_inst.cmdtable[150] := (1).to_natural_8
			decode_inst.cmdtable[151] := (0).to_natural_8
			decode_inst.cmdtable[152] := (17).to_natural_8
			decode_inst.cmdtable[153] := (('<').code).to_natural_8
			decode_inst.cmdtable[154] := (0).to_natural_8
			decode_inst.cmdtable[155] := (17).to_natural_8
			decode_inst.cmdtable[156] := (27).to_natural_8
			decode_inst.cmdtable[157] := (('<').code).to_natural_8
			decode_inst.cmdtable[158] := (0).to_natural_8
			decode_inst.cmdtable[159] := (17).to_natural_8
			decode_inst.cmdtable[160] := (('p').code).to_natural_8
			decode_inst.cmdtable[161] := (0).to_natural_8
			decode_inst.cmdtable[162] := (21).to_natural_8
			decode_inst.cmdtable[163] := (('%%').code).to_natural_8
			decode_inst.cmdtable[164] := (0).to_natural_8
			decode_inst.cmdtable[165] := (21).to_natural_8
			decode_inst.cmdtable[166] := (27).to_natural_8
			decode_inst.cmdtable[167] := (('[').code).to_natural_8
			decode_inst.cmdtable[168] := (0).to_natural_8
			decode_inst.cmdtable[169] := (41).to_natural_8
			decode_inst.cmdtable[170] := (27).to_natural_8
			decode_inst.cmdtable[171] := ((']').code).to_natural_8
			decode_inst.cmdtable[172] := (0).to_natural_8
			decode_inst.cmdtable[173] := (42).to_natural_8
			decode_inst.cmdtable[174] := (27).to_natural_8
			decode_inst.cmdtable[175] := (('(').code).to_natural_8
			decode_inst.cmdtable[176] := (0).to_natural_8
			decode_inst.cmdtable[177] := (41).to_natural_8
			decode_inst.cmdtable[178] := (27).to_natural_8
			decode_inst.cmdtable[179] := ((')').code).to_natural_8
			decode_inst.cmdtable[180] := (0).to_natural_8
			decode_inst.cmdtable[181] := (42).to_natural_8
			decode_inst.cmdtable[182] := (11).to_natural_8
			decode_inst.cmdtable[183] := (1).to_natural_8
			decode_inst.cmdtable[184] := (6).to_natural_8
			decode_inst.cmdtable[185] := (1).to_natural_8
			decode_inst.cmdtable[186] := (1).to_natural_8
			decode_inst.cmdtable[187] := (1).to_natural_8
			decode_inst.cmdtable[188] := (0).to_natural_8
			decode_inst.cmdtable[189] := (42).to_natural_8
			decode_inst.cmdtable[190] := (11).to_natural_8
			decode_inst.cmdtable[191] := (2).to_natural_8
			decode_inst.cmdtable[192] := (6).to_natural_8
			decode_inst.cmdtable[193] := (1).to_natural_8
			decode_inst.cmdtable[194] := (1).to_natural_8
			decode_inst.cmdtable[195] := (1).to_natural_8
			decode_inst.cmdtable[196] := (0).to_natural_8
			decode_inst.cmdtable[197] := (41).to_natural_8
			decode_inst.cmdtable[198] := (('{').code).to_natural_8
			decode_inst.cmdtable[199] := (0).to_natural_8
			decode_inst.cmdtable[200] := (163).to_natural_8
			decode_inst.cmdtable[201] := (('{').code).to_natural_8
			decode_inst.cmdtable[202] := (('}').code).to_natural_8
			decode_inst.cmdtable[203] := (0).to_natural_8
			decode_inst.cmdtable[204] := (('}').code).to_natural_8
			decode_inst.cmdtable[205] := (0).to_natural_8
			decode_inst.cmdtable[206] := (164).to_natural_8
			decode_inst.cmdtable[207] := (('{').code).to_natural_8
			decode_inst.cmdtable[208] := (('}').code).to_natural_8
			decode_inst.cmdtable[209] := (0).to_natural_8
			decode_inst.cmdtable[210] := (('(').code).to_natural_8
			decode_inst.cmdtable[211] := (0).to_natural_8
			decode_inst.cmdtable[212] := (163).to_natural_8
			decode_inst.cmdtable[213] := (('(').code).to_natural_8
			decode_inst.cmdtable[214] := ((')').code).to_natural_8
			decode_inst.cmdtable[215] := (0).to_natural_8
			decode_inst.cmdtable[216] := ((')').code).to_natural_8
			decode_inst.cmdtable[217] := (0).to_natural_8
			decode_inst.cmdtable[218] := (164).to_natural_8
			decode_inst.cmdtable[219] := (('(').code).to_natural_8
			decode_inst.cmdtable[220] := ((')').code).to_natural_8
			decode_inst.cmdtable[221] := (0).to_natural_8
			decode_inst.cmdtable[222] := (('[').code).to_natural_8
			decode_inst.cmdtable[223] := (0).to_natural_8
			decode_inst.cmdtable[224] := (163).to_natural_8
			decode_inst.cmdtable[225] := (('[').code).to_natural_8
			decode_inst.cmdtable[226] := ((']').code).to_natural_8
			decode_inst.cmdtable[227] := (0).to_natural_8
			decode_inst.cmdtable[228] := ((']').code).to_natural_8
			decode_inst.cmdtable[229] := (0).to_natural_8
			decode_inst.cmdtable[230] := (164).to_natural_8
			decode_inst.cmdtable[231] := (('[').code).to_natural_8
			decode_inst.cmdtable[232] := ((']').code).to_natural_8
			decode_inst.cmdtable[233] := (0).to_natural_8
			decode_inst.cmdtable[234] := (27).to_natural_8
			decode_inst.cmdtable[235] := (6).to_natural_8
			decode_inst.cmdtable[236] := (0).to_natural_8
			decode_inst.cmdtable[237] := (35).to_natural_8
			decode_inst.cmdtable[238] := (27).to_natural_8
			decode_inst.cmdtable[239] := (2).to_natural_8
			decode_inst.cmdtable[240] := (0).to_natural_8
			decode_inst.cmdtable[241] := (36).to_natural_8
			decode_inst.cmdtable[242] := (('G').code).to_natural_8
			decode_inst.cmdtable[243] := (0).to_natural_8
			decode_inst.cmdtable[244] := (16).to_natural_8
			decode_inst.cmdtable[245] := (27).to_natural_8
			decode_inst.cmdtable[246] := (('>').code).to_natural_8
			decode_inst.cmdtable[247] := (0).to_natural_8
			decode_inst.cmdtable[248] := (16).to_natural_8
			decode_inst.cmdtable[249] := (('>').code).to_natural_8
			decode_inst.cmdtable[250] := (0).to_natural_8
			decode_inst.cmdtable[251] := (16).to_natural_8
			decode_inst.cmdtable[252] := (11).to_natural_8
			decode_inst.cmdtable[253] := (8).to_natural_8
			decode_inst.cmdtable[254] := (6).to_natural_8
			decode_inst.cmdtable[255] := (1).to_natural_8
			decode_inst.cmdtable[256] := (1).to_natural_8
			decode_inst.cmdtable[257] := (1).to_natural_8
			decode_inst.cmdtable[258] := (0).to_natural_8
			decode_inst.cmdtable[259] := (16).to_natural_8
			decode_inst.cmdtable[260] := (('P').code).to_natural_8
			decode_inst.cmdtable[261] := (0).to_natural_8
			decode_inst.cmdtable[262] := (51).to_natural_8
			decode_inst.cmdtable[263] := (('0').code).to_natural_8
			decode_inst.cmdtable[264] := (0).to_natural_8
			decode_inst.cmdtable[265] := (6).to_natural_8
			decode_inst.cmdtable[266] := (('1').code).to_natural_8
			decode_inst.cmdtable[267] := (0).to_natural_8
			decode_inst.cmdtable[268] := (6).to_natural_8
			decode_inst.cmdtable[269] := (('2').code).to_natural_8
			decode_inst.cmdtable[270] := (0).to_natural_8
			decode_inst.cmdtable[271] := (6).to_natural_8
			decode_inst.cmdtable[272] := (('3').code).to_natural_8
			decode_inst.cmdtable[273] := (0).to_natural_8
			decode_inst.cmdtable[274] := (6).to_natural_8
			decode_inst.cmdtable[275] := (('4').code).to_natural_8
			decode_inst.cmdtable[276] := (0).to_natural_8
			decode_inst.cmdtable[277] := (6).to_natural_8
			decode_inst.cmdtable[278] := (('5').code).to_natural_8
			decode_inst.cmdtable[279] := (0).to_natural_8
			decode_inst.cmdtable[280] := (6).to_natural_8
			decode_inst.cmdtable[281] := (('6').code).to_natural_8
			decode_inst.cmdtable[282] := (0).to_natural_8
			decode_inst.cmdtable[283] := (6).to_natural_8
			decode_inst.cmdtable[284] := (('7').code).to_natural_8
			decode_inst.cmdtable[285] := (0).to_natural_8
			decode_inst.cmdtable[286] := (6).to_natural_8
			decode_inst.cmdtable[287] := (('8').code).to_natural_8
			decode_inst.cmdtable[288] := (0).to_natural_8
			decode_inst.cmdtable[289] := (6).to_natural_8
			decode_inst.cmdtable[290] := (('9').code).to_natural_8
			decode_inst.cmdtable[291] := (0).to_natural_8
			decode_inst.cmdtable[292] := (6).to_natural_8
			decode_inst.cmdtable[293] := (('=').code).to_natural_8
			decode_inst.cmdtable[294] := (0).to_natural_8
			decode_inst.cmdtable[295] := (28).to_natural_8
			decode_inst.cmdtable[296] := (7).to_natural_8
			decode_inst.cmdtable[297] := (0).to_natural_8
			decode_inst.cmdtable[298] := (28).to_natural_8
			decode_inst.cmdtable[299] := ((':').code).to_natural_8
			decode_inst.cmdtable[300] := (('f').code).to_natural_8
			decode_inst.cmdtable[301] := (0).to_natural_8
			decode_inst.cmdtable[302] := (28).to_natural_8
			decode_inst.cmdtable[303] := (('/').code).to_natural_8
			decode_inst.cmdtable[304] := (0).to_natural_8
			decode_inst.cmdtable[305] := (15).to_natural_8
			decode_inst.cmdtable[306] := (('?').code).to_natural_8
			decode_inst.cmdtable[307] := (0).to_natural_8
			decode_inst.cmdtable[308] := (5).to_natural_8
			decode_inst.cmdtable[309] := (27).to_natural_8
			decode_inst.cmdtable[310] := (('/').code).to_natural_8
			decode_inst.cmdtable[311] := (0).to_natural_8
			decode_inst.cmdtable[312] := (143).to_natural_8
			decode_inst.cmdtable[313] := (('*').code).to_natural_8
			decode_inst.cmdtable[314] := (0).to_natural_8
			decode_inst.cmdtable[315] := (27).to_natural_8
			decode_inst.cmdtable[316] := (('?').code).to_natural_8
			decode_inst.cmdtable[317] := (0).to_natural_8
			decode_inst.cmdtable[318] := (133).to_natural_8
			decode_inst.cmdtable[319] := (('*').code).to_natural_8
			decode_inst.cmdtable[320] := (0).to_natural_8
			decode_inst.cmdtable[321] := (('n').code).to_natural_8
			decode_inst.cmdtable[322] := (0).to_natural_8
			decode_inst.cmdtable[323] := (43).to_natural_8
			decode_inst.cmdtable[324] := (27).to_natural_8
			decode_inst.cmdtable[325] := (('n').code).to_natural_8
			decode_inst.cmdtable[326] := (0).to_natural_8
			decode_inst.cmdtable[327] := (44).to_natural_8
			decode_inst.cmdtable[328] := (('N').code).to_natural_8
			decode_inst.cmdtable[329] := (0).to_natural_8
			decode_inst.cmdtable[330] := (45).to_natural_8
			decode_inst.cmdtable[331] := (27).to_natural_8
			decode_inst.cmdtable[332] := (('N').code).to_natural_8
			decode_inst.cmdtable[333] := (0).to_natural_8
			decode_inst.cmdtable[334] := (46).to_natural_8
			decode_inst.cmdtable[335] := (('m').code).to_natural_8
			decode_inst.cmdtable[336] := (0).to_natural_8
			decode_inst.cmdtable[337] := (26).to_natural_8
			decode_inst.cmdtable[338] := (('%'').code).to_natural_8
			decode_inst.cmdtable[339] := (0).to_natural_8
			decode_inst.cmdtable[340] := (18).to_natural_8
			decode_inst.cmdtable[341] := (24).to_natural_8
			decode_inst.cmdtable[342] := (24).to_natural_8
			decode_inst.cmdtable[343] := (0).to_natural_8
			decode_inst.cmdtable[344] := (18).to_natural_8
			decode_inst.cmdtable[345] := (('E').code).to_natural_8
			decode_inst.cmdtable[346] := (0).to_natural_8
			decode_inst.cmdtable[347] := (9).to_natural_8
			decode_inst.cmdtable[348] := ((':').code).to_natural_8
			decode_inst.cmdtable[349] := (('e').code).to_natural_8
			decode_inst.cmdtable[350] := (0).to_natural_8
			decode_inst.cmdtable[351] := (9).to_natural_8
			decode_inst.cmdtable[352] := (24).to_natural_8
			decode_inst.cmdtable[353] := (22).to_natural_8
			decode_inst.cmdtable[354] := (0).to_natural_8
			decode_inst.cmdtable[355] := (9).to_natural_8
			decode_inst.cmdtable[356] := ((':').code).to_natural_8
			decode_inst.cmdtable[357] := (('n').code).to_natural_8
			decode_inst.cmdtable[358] := (0).to_natural_8
			decode_inst.cmdtable[359] := (20).to_natural_8
			decode_inst.cmdtable[360] := ((':').code).to_natural_8
			decode_inst.cmdtable[361] := (('p').code).to_natural_8
			decode_inst.cmdtable[362] := (0).to_natural_8
			decode_inst.cmdtable[363] := (23).to_natural_8
			decode_inst.cmdtable[364] := (('t').code).to_natural_8
			decode_inst.cmdtable[365] := (0).to_natural_8
			decode_inst.cmdtable[366] := (53).to_natural_8
			decode_inst.cmdtable[367] := (('T').code).to_natural_8
			decode_inst.cmdtable[368] := (0).to_natural_8
			decode_inst.cmdtable[369] := (54).to_natural_8
			decode_inst.cmdtable[370] := ((':').code).to_natural_8
			decode_inst.cmdtable[371] := (('x').code).to_natural_8
			decode_inst.cmdtable[372] := (0).to_natural_8
			decode_inst.cmdtable[373] := (38).to_natural_8
			decode_inst.cmdtable[374] := ((':').code).to_natural_8
			decode_inst.cmdtable[375] := (('d').code).to_natural_8
			decode_inst.cmdtable[376] := (0).to_natural_8
			decode_inst.cmdtable[377] := (52).to_natural_8
			decode_inst.cmdtable[378] := (('-').code).to_natural_8
			decode_inst.cmdtable[379] := (0).to_natural_8
			decode_inst.cmdtable[380] := (47).to_natural_8
			decode_inst.cmdtable[381] := ((':').code).to_natural_8
			decode_inst.cmdtable[382] := (('t').code).to_natural_8
			decode_inst.cmdtable[383] := (0).to_natural_8
			decode_inst.cmdtable[384] := (175).to_natural_8
			decode_inst.cmdtable[385] := (('t').code).to_natural_8
			decode_inst.cmdtable[386] := (0).to_natural_8
			decode_inst.cmdtable[387] := (('s').code).to_natural_8
			decode_inst.cmdtable[388] := (0).to_natural_8
			decode_inst.cmdtable[389] := (175).to_natural_8
			decode_inst.cmdtable[390] := (('o').code).to_natural_8
			decode_inst.cmdtable[391] := (0).to_natural_8
			decode_inst.cmdtable[392] := (('_').code).to_natural_8
			decode_inst.cmdtable[393] := (0).to_natural_8
			decode_inst.cmdtable[394] := (7).to_natural_8
			decode_inst.cmdtable[395] := (('|').code).to_natural_8
			decode_inst.cmdtable[396] := (0).to_natural_8
			decode_inst.cmdtable[397] := (37).to_natural_8
			decode_inst.cmdtable[398] := (('v').code).to_natural_8
			decode_inst.cmdtable[399] := (0).to_natural_8
			decode_inst.cmdtable[400] := (32).to_natural_8
			decode_inst.cmdtable[401] := (('!').code).to_natural_8
			decode_inst.cmdtable[402] := (0).to_natural_8
			decode_inst.cmdtable[403] := (27).to_natural_8
			decode_inst.cmdtable[404] := (('+').code).to_natural_8
			decode_inst.cmdtable[405] := (0).to_natural_8
			decode_inst.cmdtable[406] := (10).to_natural_8
			decode_inst.cmdtable[407] := (('H').code).to_natural_8
			decode_inst.cmdtable[408] := (0).to_natural_8
			decode_inst.cmdtable[409] := (19).to_natural_8
			decode_inst.cmdtable[410] := (('h').code).to_natural_8
			decode_inst.cmdtable[411] := (0).to_natural_8
			decode_inst.cmdtable[412] := (19).to_natural_8
			decode_inst.cmdtable[413] := (11).to_natural_8
			decode_inst.cmdtable[414] := (14).to_natural_8
			decode_inst.cmdtable[415] := (6).to_natural_8
			decode_inst.cmdtable[416] := (1).to_natural_8
			decode_inst.cmdtable[417] := (1).to_natural_8
			decode_inst.cmdtable[418] := (1).to_natural_8
			decode_inst.cmdtable[419] := (0).to_natural_8
			decode_inst.cmdtable[420] := (19).to_natural_8
			decode_inst.cmdtable[421] := (('V').code).to_natural_8
			decode_inst.cmdtable[422] := (0).to_natural_8
			decode_inst.cmdtable[423] := (31).to_natural_8
			decode_inst.cmdtable[424] := (('q').code).to_natural_8
			decode_inst.cmdtable[425] := (0).to_natural_8
		end

end
