class
	P_BRAC

inherit
	LESS_DATA
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {ANY} -- routines

	match_brac (a_obrac: INTEGER_32; a_cbrac: INTEGER_32; a_forwdir: INTEGER_32; a_n: INTEGER_32)
		local
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_nest: INTEGER_32
			l_pos2: INTEGER_32
			l_chget: CE_ROUTINE
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_chget.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					if a_forwdir.to_boolean then
						l_tmp := 0
					else
						l_tmp := -1
					end
					l_pos2 := position_inst.position (l_tmp)
					if l_pos2 /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((ch_inst.ch_seek (l_pos2)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if a_forwdir.to_boolean then
							output_inst.error (ce_string ("Nothing in top line"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						else
							output_inst.error (ce_string ("Nothing in bottom line"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
						end
						js.return
				when 5 then -- if done
						if js.return_called then
							l_pos := -1 + 13 -- skip if block
						end
				when 6 then -- if: | loop condition:
							if js.loop_done then
								l_pos := -1 + 13 -- skip loop
							end
				when 7 then -- loop body:
							l_c := ch_inst.ch_forw_get
							if l_c /= 10 then
								l_pos := -1 + 10 -- skip if block
							end
				when 8 then -- if:
							l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
							l_pos := -1 + 12
				when 10 then -- else:
							if l_c /= -1 then
								l_pos := -1 + 12 -- skip if block
							end
				when 11 then -- if: | _L___0:
							if a_forwdir.to_boolean then
								output_inst.error (ce_string ("No bracket in top line"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							else
								output_inst.error (ce_string ("No bracket in bottom line"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							end
							js.return
				when 12 then -- if done
							if not js.return_called and then (l_c = a_obrac) then
								l_n := l_n - 1
								if not (l_n > 0) then
									js.break
								end
							end
							l_pos := -1 + 6 -- back to loop condition
				when 13 then -- loop done | if done
							if not js.return_called then
								if not a_forwdir.to_boolean then
									ch_inst.ch_back_get.do_nothing
								end
								if a_forwdir.to_boolean then
									l_chget := ch_inst.ch_forw_get_address
								else
									l_chget := ch_inst.ch_back_get_address
								end
								l_nest := 0
								from
								until
									js.loop_done
								loop
									l_c := l_chget.integer_32_item ([])
									if l_c = -1 then
										js.break
									end
									if not js.loop_jumped then
										if l_c = a_obrac then
											l_nest := l_nest + 1
										elseif l_c = a_cbrac then
											l_nest := l_nest - 1
											if l_nest < 0 then
												if a_forwdir.to_boolean then
													l_tmp___1 := -1
												else
													l_tmp___1 := 1
												end
												jump_inst.jump_line_loc ((ch_inst.ch_tell), l_tmp___1)
												js.return
											end
										end
									end
								end
							end
							if not js.return_called then
								output_inst.error (ce_string ("No matching bracket"), create {CE_POINTER [PD_PARG]}.make_shared (default_pointer))
							end
				when 14 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

end
