deferred class
	S_TERMCAP

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- attributes

	PC: INTEGER_8 assign set_PC
		external
			"C inline use <less.h>"
		alias
			"return PC;"
		end

	set_PC (a_PC: INTEGER_8)
		external
			"C inline use <less.h>"
		alias
			"PC = $a_pc;"
		end

	ospeed: NATURAL_32 assign set_ospeed
		external
			"C inline use <less.h>"
		alias
			"return ospeed;"
		end

	set_ospeed (a_ospeed: NATURAL_32)
		external
			"C inline use <less.h>"
		alias
			"ospeed = $a_ospeed;"
		end

feature {ANY} -- routines

	tgetent (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_tgetent (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_tgetent (a_arg1: POINTER; a_arg2: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return tgetent($a_arg1, $a_arg2);"
		end

	tgetflag (a_arg1: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_tgetflag (a_arg1.c_pointer)
		end

	c_tgetflag (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return tgetflag($a_arg1);"
		end

	tgetnum (a_arg1: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_tgetnum (a_arg1.c_pointer)
		end

	c_tgetnum (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return tgetnum($a_arg1);"
		end

	tgetstr (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_tgetstr (a_arg1.c_pointer, a_arg2.c_pointer))
		end

	c_tgetstr (a_arg1: POINTER; a_arg2: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return tgetstr($a_arg1, $a_arg2);"
		end

	tgoto (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: INTEGER_32; a_arg3: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_tgoto (a_arg1.c_pointer, a_arg2, a_arg3))
		end

	c_tgoto (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: INTEGER_32): POINTER
		external
			"C inline use <less.h>"
		alias
			"return tgoto($a_arg1, $a_arg2, $a_arg3);"
		end

	tputs (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: INTEGER_32; a_arg3: CE_ROUTINE): INTEGER_32
		do
			Result := c_tputs (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer)
		end

	c_tputs (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return tputs($a_arg1, $a_arg2, $a_arg3);"
		end

end
