frozen class
	WGET_INITIALIZER_SLICE1

inherit
	WGET_DATA
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {WGET_INITIALIZER}

	initialize
		do
			connect_inst.last_fd := -1
			connect_inst.last_fd___0 := -1
			connect_inst.last_fd___1 := -1
			convert_inst.v1[0] := {PC_DOWNLOADED_FILE_T}.FILE_NOT_ALREADY_DOWNLOADED
			convert_inst.v2[0] := {PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_NORMALLY
			convert_inst.v3[0] := {PC_DOWNLOADED_FILE_T}.FILE_DOWNLOADED_AND_HTML_EXTENSION_ADDED
			convert_inst.v4[0] := {PC_DOWNLOADED_FILE_T}.CHECK_FOR_FILE
			cookies_inst.known_toplevel_domains[0] := ce_string (".com")
			cookies_inst.known_toplevel_domains[1] := ce_string (".edu")
			cookies_inst.known_toplevel_domains[2] := ce_string (".net")
			cookies_inst.known_toplevel_domains[3] := ce_string (".org")
			cookies_inst.known_toplevel_domains[4] := ce_string (".gov")
			cookies_inst.known_toplevel_domains[5] := ce_string (".mil")
			cookies_inst.known_toplevel_domains[6] := ce_string (".int")
			ftp_inst.depth := 0
			css_inst.yy_buffer_stack_top := (0).to_natural_32
			css_inst.yy_buffer_stack_max := (0).to_natural_32
			css_inst.yy_buffer_stack := create {CE_POINTER [CE_POINTER [PD_YY_BUFFER_STATE]]}.make_shared (default_pointer)
			css_inst.yy_c_buf_p := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			css_inst.yy_init := 0
			css_inst.yy_start := 0
			css_inst.yyin := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			css_inst.yyout := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			css_inst.yylineno := 1
			css_inst.yy_accept[0] := (0).to_integer_16
			css_inst.yy_accept[1] := (0).to_integer_16
			css_inst.yy_accept[2] := (0).to_integer_16
			css_inst.yy_accept[3] := (43).to_integer_16
			css_inst.yy_accept[4] := (41).to_integer_16
			css_inst.yy_accept[5] := (1).to_integer_16
			css_inst.yy_accept[6] := (1).to_integer_16
			css_inst.yy_accept[7] := (41).to_integer_16
			css_inst.yy_accept[8] := (12).to_integer_16
			css_inst.yy_accept[9] := (41).to_integer_16
			css_inst.yy_accept[10] := (12).to_integer_16
			css_inst.yy_accept[11] := (8).to_integer_16
			css_inst.yy_accept[12] := (10).to_integer_16
			css_inst.yy_accept[13] := (41).to_integer_16
			css_inst.yy_accept[14] := (41).to_integer_16
			css_inst.yy_accept[15] := (41).to_integer_16
			css_inst.yy_accept[16] := (37).to_integer_16
			css_inst.yy_accept[17] := (41).to_integer_16
			css_inst.yy_accept[18] := (9).to_integer_16
			css_inst.yy_accept[19] := (41).to_integer_16
			css_inst.yy_accept[20] := (13).to_integer_16
			css_inst.yy_accept[21] := (13).to_integer_16
			css_inst.yy_accept[22] := (41).to_integer_16
			css_inst.yy_accept[23] := (7).to_integer_16
			css_inst.yy_accept[24] := (41).to_integer_16
			css_inst.yy_accept[25] := (41).to_integer_16
			css_inst.yy_accept[26] := (0).to_integer_16
			css_inst.yy_accept[27] := (8).to_integer_16
			css_inst.yy_accept[28] := (10).to_integer_16
			css_inst.yy_accept[29] := (0).to_integer_16
			css_inst.yy_accept[30] := (9).to_integer_16
			css_inst.yy_accept[31] := (7).to_integer_16
			css_inst.yy_accept[32] := (0).to_integer_16
			css_inst.yy_accept[33] := (0).to_integer_16
			css_inst.yy_accept[34] := (0).to_integer_16
			css_inst.yy_accept[35] := (12).to_integer_16
			css_inst.yy_accept[36] := (11).to_integer_16
			css_inst.yy_accept[37] := (0).to_integer_16
			css_inst.yy_accept[38] := (14).to_integer_16
			css_inst.yy_accept[39] := (0).to_integer_16
			css_inst.yy_accept[40] := (12).to_integer_16
			css_inst.yy_accept[41] := (0).to_integer_16
			css_inst.yy_accept[42] := (0).to_integer_16
			css_inst.yy_accept[43] := (13).to_integer_16
			css_inst.yy_accept[44] := (0).to_integer_16
			css_inst.yy_accept[45] := (37).to_integer_16
			css_inst.yy_accept[46] := (0).to_integer_16
			css_inst.yy_accept[47] := (36).to_integer_16
			css_inst.yy_accept[48] := (0).to_integer_16
			css_inst.yy_accept[49] := (0).to_integer_16
			css_inst.yy_accept[50] := (37).to_integer_16
			css_inst.yy_accept[51] := (35).to_integer_16
			css_inst.yy_accept[52] := (35).to_integer_16
			css_inst.yy_accept[53] := (35).to_integer_16
			css_inst.yy_accept[54] := (35).to_integer_16
			css_inst.yy_accept[55] := (35).to_integer_16
			css_inst.yy_accept[56] := (35).to_integer_16
			css_inst.yy_accept[57] := (35).to_integer_16
			css_inst.yy_accept[58] := (35).to_integer_16
			css_inst.yy_accept[59] := (35).to_integer_16
			css_inst.yy_accept[60] := (35).to_integer_16
			css_inst.yy_accept[61] := (35).to_integer_16
			css_inst.yy_accept[62] := (32).to_integer_16
			css_inst.yy_accept[63] := (0).to_integer_16
			css_inst.yy_accept[64] := (0).to_integer_16
			css_inst.yy_accept[65] := (0).to_integer_16
			css_inst.yy_accept[66] := (0).to_integer_16
			css_inst.yy_accept[67] := (0).to_integer_16
			css_inst.yy_accept[68] := (0).to_integer_16
			css_inst.yy_accept[69] := (40).to_integer_16
			css_inst.yy_accept[70] := (13).to_integer_16
			css_inst.yy_accept[71] := (0).to_integer_16
			css_inst.yy_accept[72] := (13).to_integer_16
			css_inst.yy_accept[73] := (13).to_integer_16
			css_inst.yy_accept[74] := (13).to_integer_16
			css_inst.yy_accept[75] := (6).to_integer_16
			css_inst.yy_accept[76] := (5).to_integer_16
			css_inst.yy_accept[77] := (0).to_integer_16
			css_inst.yy_accept[78] := (0).to_integer_16
			css_inst.yy_accept[79] := (0).to_integer_16
			css_inst.yy_accept[80] := (12).to_integer_16
			css_inst.yy_accept[81] := (12).to_integer_16
			css_inst.yy_accept[82] := (12).to_integer_16
			css_inst.yy_accept[83] := (14).to_integer_16
			css_inst.yy_accept[84] := (14).to_integer_16
			css_inst.yy_accept[85] := (12).to_integer_16
			css_inst.yy_accept[86] := (12).to_integer_16
			css_inst.yy_accept[87] := (12).to_integer_16
			css_inst.yy_accept[88] := (4).to_integer_16
			css_inst.yy_accept[89] := (0).to_integer_16
			css_inst.yy_accept[90] := (0).to_integer_16
			css_inst.yy_accept[91] := (0).to_integer_16
			css_inst.yy_accept[92] := (35).to_integer_16
			css_inst.yy_accept[93] := (0).to_integer_16
			css_inst.yy_accept[94] := (23).to_integer_16
			css_inst.yy_accept[95] := (0).to_integer_16
			css_inst.yy_accept[96] := (35).to_integer_16
			css_inst.yy_accept[97] := (0).to_integer_16
			css_inst.yy_accept[98] := (20).to_integer_16
			css_inst.yy_accept[99] := (21).to_integer_16
			css_inst.yy_accept[100] := (0).to_integer_16
			css_inst.yy_accept[101] := (35).to_integer_16
			css_inst.yy_accept[102] := (0).to_integer_16
			css_inst.yy_accept[103] := (33).to_integer_16
			css_inst.yy_accept[104] := (0).to_integer_16
			css_inst.yy_accept[105] := (25).to_integer_16
			css_inst.yy_accept[106] := (0).to_integer_16
			css_inst.yy_accept[107] := (35).to_integer_16
			css_inst.yy_accept[108] := (0).to_integer_16
			css_inst.yy_accept[109] := (24).to_integer_16
			css_inst.yy_accept[110] := (31).to_integer_16
			css_inst.yy_accept[111] := (0).to_integer_16
			css_inst.yy_accept[112] := (27).to_integer_16
			css_inst.yy_accept[113] := (26).to_integer_16
			css_inst.yy_accept[114] := (22).to_integer_16
			css_inst.yy_accept[115] := (0).to_integer_16
			css_inst.yy_accept[116] := (35).to_integer_16
			css_inst.yy_accept[117] := (0).to_integer_16
			css_inst.yy_accept[118] := (35).to_integer_16
			css_inst.yy_accept[119] := (35).to_integer_16
			css_inst.yy_accept[120] := (35).to_integer_16
			css_inst.yy_accept[121] := (35).to_integer_16
			css_inst.yy_accept[122] := (35).to_integer_16
			css_inst.yy_accept[123] := (35).to_integer_16
			css_inst.yy_accept[124] := (35).to_integer_16
			css_inst.yy_accept[125] := (35).to_integer_16
			css_inst.yy_accept[126] := (35).to_integer_16
			css_inst.yy_accept[127] := (35).to_integer_16
			css_inst.yy_accept[128] := (35).to_integer_16
			css_inst.yy_accept[129] := (35).to_integer_16
			css_inst.yy_accept[130] := (35).to_integer_16
			css_inst.yy_accept[131] := (35).to_integer_16
			css_inst.yy_accept[132] := (32).to_integer_16
			css_inst.yy_accept[133] := (0).to_integer_16
			css_inst.yy_accept[134] := (0).to_integer_16
			css_inst.yy_accept[135] := (0).to_integer_16
			css_inst.yy_accept[136] := (0).to_integer_16
			css_inst.yy_accept[137] := (0).to_integer_16
			css_inst.yy_accept[138] := (13).to_integer_16
			css_inst.yy_accept[139] := (13).to_integer_16
			css_inst.yy_accept[140] := (13).to_integer_16
			css_inst.yy_accept[141] := (13).to_integer_16
			css_inst.yy_accept[142] := (13).to_integer_16
			css_inst.yy_accept[143] := (0).to_integer_16
			css_inst.yy_accept[144] := (0).to_integer_16
			css_inst.yy_accept[145] := (0).to_integer_16
			css_inst.yy_accept[146] := (0).to_integer_16
			css_inst.yy_accept[147] := (0).to_integer_16
			css_inst.yy_accept[148] := (12).to_integer_16
			css_inst.yy_accept[149] := (12).to_integer_16
			css_inst.yy_accept[150] := (12).to_integer_16
			css_inst.yy_accept[151] := (14).to_integer_16
			css_inst.yy_accept[152] := (14).to_integer_16
			css_inst.yy_accept[153] := (12).to_integer_16
			css_inst.yy_accept[154] := (12).to_integer_16
			css_inst.yy_accept[155] := (12).to_integer_16
			css_inst.yy_accept[156] := (0).to_integer_16
			css_inst.yy_accept[157] := (2).to_integer_16
			css_inst.yy_accept[158] := (35).to_integer_16
			css_inst.yy_accept[159] := (35).to_integer_16
			css_inst.yy_accept[160] := (35).to_integer_16
			css_inst.yy_accept[161] := (35).to_integer_16
			css_inst.yy_accept[162] := (35).to_integer_16
			css_inst.yy_accept[163] := (23).to_integer_16
			css_inst.yy_accept[164] := (28).to_integer_16
			css_inst.yy_accept[165] := (0).to_integer_16
			css_inst.yy_accept[166] := (35).to_integer_16
			css_inst.yy_accept[167] := (35).to_integer_16
			css_inst.yy_accept[168] := (35).to_integer_16
			css_inst.yy_accept[169] := (35).to_integer_16
			css_inst.yy_accept[170] := (35).to_integer_16
			css_inst.yy_accept[171] := (35).to_integer_16
			css_inst.yy_accept[172] := (35).to_integer_16
			css_inst.yy_accept[173] := (35).to_integer_16
			css_inst.yy_accept[174] := (20).to_integer_16
			css_inst.yy_accept[175] := (21).to_integer_16
			css_inst.yy_accept[176] := (35).to_integer_16
			css_inst.yy_accept[177] := (0).to_integer_16
			css_inst.yy_accept[178] := (35).to_integer_16
			css_inst.yy_accept[179] := (35).to_integer_16
			css_inst.yy_accept[180] := (35).to_integer_16
			css_inst.yy_accept[181] := (35).to_integer_16
			css_inst.yy_accept[182] := (35).to_integer_16
			css_inst.yy_accept[183] := (35).to_integer_16
			css_inst.yy_accept[184] := (35).to_integer_16
			css_inst.yy_accept[185] := (33).to_integer_16
			css_inst.yy_accept[186] := (35).to_integer_16
			css_inst.yy_accept[187] := (35).to_integer_16
			css_inst.yy_accept[188] := (35).to_integer_16
			css_inst.yy_accept[189] := (25).to_integer_16
			css_inst.yy_accept[190] := (34).to_integer_16
			css_inst.yy_accept[191] := (0).to_integer_16
			css_inst.yy_accept[192] := (35).to_integer_16
			css_inst.yy_accept[193] := (35).to_integer_16
			css_inst.yy_accept[194] := (35).to_integer_16
			css_inst.yy_accept[195] := (35).to_integer_16
			css_inst.yy_accept[196] := (35).to_integer_16
			css_inst.yy_accept[197] := (35).to_integer_16
			css_inst.yy_accept[198] := (35).to_integer_16
			css_inst.yy_accept[199] := (35).to_integer_16
			css_inst.yy_accept[200] := (35).to_integer_16
			css_inst.yy_accept[201] := (24).to_integer_16
			css_inst.yy_accept[202] := (31).to_integer_16
			css_inst.yy_accept[203] := (35).to_integer_16
			css_inst.yy_accept[204] := (35).to_integer_16
			css_inst.yy_accept[205] := (35).to_integer_16
			css_inst.yy_accept[206] := (35).to_integer_16
			css_inst.yy_accept[207] := (35).to_integer_16
			css_inst.yy_accept[208] := (26).to_integer_16
			css_inst.yy_accept[209] := (22).to_integer_16
			css_inst.yy_accept[210] := (29).to_integer_16
			css_inst.yy_accept[211] := (0).to_integer_16
			css_inst.yy_accept[212] := (35).to_integer_16
			css_inst.yy_accept[213] := (35).to_integer_16
			css_inst.yy_accept[214] := (35).to_integer_16
			css_inst.yy_accept[215] := (35).to_integer_16
			css_inst.yy_accept[216] := (35).to_integer_16
			css_inst.yy_accept[217] := (35).to_integer_16
			css_inst.yy_accept[218] := (35).to_integer_16
			css_inst.yy_accept[219] := (35).to_integer_16
			css_inst.yy_accept[220] := (35).to_integer_16
			css_inst.yy_accept[221] := (35).to_integer_16
			css_inst.yy_accept[222] := (35).to_integer_16
			css_inst.yy_accept[223] := (35).to_integer_16
			css_inst.yy_accept[224] := (35).to_integer_16
			css_inst.yy_accept[225] := (35).to_integer_16
			css_inst.yy_accept[226] := (35).to_integer_16
			css_inst.yy_accept[227] := (35).to_integer_16
			css_inst.yy_accept[228] := (35).to_integer_16
			css_inst.yy_accept[229] := (35).to_integer_16
			css_inst.yy_accept[230] := (35).to_integer_16
			css_inst.yy_accept[231] := (35).to_integer_16
			css_inst.yy_accept[232] := (32).to_integer_16
			css_inst.yy_accept[233] := (35).to_integer_16
			css_inst.yy_accept[234] := (35).to_integer_16
			css_inst.yy_accept[235] := (3).to_integer_16
			css_inst.yy_accept[236] := (0).to_integer_16
			css_inst.yy_accept[237] := (0).to_integer_16
			css_inst.yy_accept[238] := (0).to_integer_16
			css_inst.yy_accept[239] := (0).to_integer_16
			css_inst.yy_accept[240] := (13).to_integer_16
			css_inst.yy_accept[241] := (13).to_integer_16
			css_inst.yy_accept[242] := (40).to_integer_16
			css_inst.yy_accept[243] := (13).to_integer_16
			css_inst.yy_accept[244] := (0).to_integer_16
			css_inst.yy_accept[245] := (0).to_integer_16
			css_inst.yy_accept[246] := (0).to_integer_16
			css_inst.yy_accept[247] := (12).to_integer_16
			css_inst.yy_accept[248] := (14).to_integer_16
			css_inst.yy_accept[249] := (12).to_integer_16
			css_inst.yy_accept[250] := (0).to_integer_16
			css_inst.yy_accept[251] := (0).to_integer_16
			css_inst.yy_accept[252] := (35).to_integer_16
			css_inst.yy_accept[253] := (35).to_integer_16
			css_inst.yy_accept[254] := (35).to_integer_16
			css_inst.yy_accept[255] := (35).to_integer_16
			css_inst.yy_accept[256] := (35).to_integer_16
			css_inst.yy_accept[257] := (23).to_integer_16
			css_inst.yy_accept[258] := (23).to_integer_16
			css_inst.yy_accept[259] := (35).to_integer_16
			css_inst.yy_accept[260] := (35).to_integer_16
			css_inst.yy_accept[261] := (35).to_integer_16
			css_inst.yy_accept[262] := (28).to_integer_16
			css_inst.yy_accept[263] := (35).to_integer_16
			css_inst.yy_accept[264] := (35).to_integer_16
			css_inst.yy_accept[265] := (35).to_integer_16
			css_inst.yy_accept[266] := (35).to_integer_16
			css_inst.yy_accept[267] := (35).to_integer_16
			css_inst.yy_accept[268] := (35).to_integer_16
			css_inst.yy_accept[269] := (35).to_integer_16
			css_inst.yy_accept[270] := (35).to_integer_16
			css_inst.yy_accept[271] := (35).to_integer_16
			css_inst.yy_accept[272] := (20).to_integer_16
			css_inst.yy_accept[273] := (21).to_integer_16
			css_inst.yy_accept[274] := (20).to_integer_16
			css_inst.yy_accept[275] := (30).to_integer_16
			css_inst.yy_accept[276] := (0).to_integer_16
			css_inst.yy_accept[277] := (35).to_integer_16
			css_inst.yy_accept[278] := (35).to_integer_16
			css_inst.yy_accept[279] := (35).to_integer_16
			css_inst.yy_accept[280] := (35).to_integer_16
			css_inst.yy_accept[281] := (35).to_integer_16
			css_inst.yy_accept[282] := (35).to_integer_16
			css_inst.yy_accept[283] := (35).to_integer_16
			css_inst.yy_accept[284] := (35).to_integer_16
			css_inst.yy_accept[285] := (35).to_integer_16
			css_inst.yy_accept[286] := (35).to_integer_16
			css_inst.yy_accept[287] := (33).to_integer_16
			css_inst.yy_accept[288] := (33).to_integer_16
			css_inst.yy_accept[289] := (35).to_integer_16
			css_inst.yy_accept[290] := (35).to_integer_16
			css_inst.yy_accept[291] := (35).to_integer_16
			css_inst.yy_accept[292] := (25).to_integer_16
			css_inst.yy_accept[293] := (25).to_integer_16
			css_inst.yy_accept[294] := (35).to_integer_16
			css_inst.yy_accept[295] := (35).to_integer_16
			css_inst.yy_accept[296] := (35).to_integer_16
			css_inst.yy_accept[297] := (34).to_integer_16
			css_inst.yy_accept[298] := (35).to_integer_16
			css_inst.yy_accept[299] := (35).to_integer_16
			css_inst.yy_accept[300] := (35).to_integer_16
			css_inst.yy_accept[301] := (35).to_integer_16
			css_inst.yy_accept[302] := (35).to_integer_16
			css_inst.yy_accept[303] := (35).to_integer_16
			css_inst.yy_accept[304] := (35).to_integer_16
			css_inst.yy_accept[305] := (35).to_integer_16
			css_inst.yy_accept[306] := (35).to_integer_16
			css_inst.yy_accept[307] := (24).to_integer_16
			css_inst.yy_accept[308] := (31).to_integer_16
			css_inst.yy_accept[309] := (24).to_integer_16
			css_inst.yy_accept[310] := (35).to_integer_16
			css_inst.yy_accept[311] := (35).to_integer_16
			css_inst.yy_accept[312] := (35).to_integer_16
			css_inst.yy_accept[313] := (35).to_integer_16
			css_inst.yy_accept[314] := (35).to_integer_16
			css_inst.yy_accept[315] := (27).to_integer_16
			css_inst.yy_accept[316] := (26).to_integer_16
			css_inst.yy_accept[317] := (22).to_integer_16
			css_inst.yy_accept[318] := (35).to_integer_16
			css_inst.yy_accept[319] := (35).to_integer_16
			css_inst.yy_accept[320] := (35).to_integer_16
			css_inst.yy_accept[321] := (35).to_integer_16
			css_inst.yy_accept[322] := (35).to_integer_16
			css_inst.yy_accept[323] := (35).to_integer_16
			css_inst.yy_accept[324] := (35).to_integer_16
			css_inst.yy_accept[325] := (35).to_integer_16
			css_inst.yy_accept[326] := (35).to_integer_16
			css_inst.yy_accept[327] := (35).to_integer_16
			css_inst.yy_accept[328] := (35).to_integer_16
			css_inst.yy_accept[329] := (35).to_integer_16
			css_inst.yy_accept[330] := (35).to_integer_16
			css_inst.yy_accept[331] := (35).to_integer_16
			css_inst.yy_accept[332] := (35).to_integer_16
			css_inst.yy_accept[333] := (35).to_integer_16
			css_inst.yy_accept[334] := (35).to_integer_16
			css_inst.yy_accept[335] := (35).to_integer_16
			css_inst.yy_accept[336] := (35).to_integer_16
			css_inst.yy_accept[337] := (35).to_integer_16
			css_inst.yy_accept[338] := (35).to_integer_16
			css_inst.yy_accept[339] := (35).to_integer_16
			css_inst.yy_accept[340] := (35).to_integer_16
			css_inst.yy_accept[341] := (32).to_integer_16
			css_inst.yy_accept[342] := (35).to_integer_16
			css_inst.yy_accept[343] := (35).to_integer_16
			css_inst.yy_accept[344] := (35).to_integer_16
			css_inst.yy_accept[345] := (35).to_integer_16
			css_inst.yy_accept[346] := (35).to_integer_16
			css_inst.yy_accept[347] := (35).to_integer_16
			css_inst.yy_accept[348] := (35).to_integer_16
			css_inst.yy_accept[349] := (35).to_integer_16
			css_inst.yy_accept[350] := (35).to_integer_16
			css_inst.yy_accept[351] := (35).to_integer_16
			css_inst.yy_accept[352] := (35).to_integer_16
			css_inst.yy_accept[353] := (35).to_integer_16
			css_inst.yy_accept[354] := (35).to_integer_16
			css_inst.yy_accept[355] := (35).to_integer_16
			css_inst.yy_accept[356] := (35).to_integer_16
			css_inst.yy_accept[357] := (35).to_integer_16
			css_inst.yy_accept[358] := (35).to_integer_16
			css_inst.yy_accept[359] := (35).to_integer_16
			css_inst.yy_accept[360] := (35).to_integer_16
			css_inst.yy_accept[361] := (35).to_integer_16
			css_inst.yy_accept[362] := (35).to_integer_16
			css_inst.yy_accept[363] := (27).to_integer_16
			css_inst.yy_accept[364] := (35).to_integer_16
			css_inst.yy_accept[365] := (35).to_integer_16
			css_inst.yy_accept[366] := (35).to_integer_16
			css_inst.yy_accept[367] := (32).to_integer_16
			css_inst.yy_accept[368] := (32).to_integer_16
			css_inst.yy_accept[369] := (0).to_integer_16
			css_inst.yy_accept[370] := (0).to_integer_16
			css_inst.yy_accept[371] := (0).to_integer_16
			css_inst.yy_accept[372] := (16).to_integer_16
			css_inst.yy_accept[373] := (13).to_integer_16
			css_inst.yy_accept[374] := (0).to_integer_16
			css_inst.yy_accept[375] := (0).to_integer_16
			css_inst.yy_accept[376] := (0).to_integer_16
			css_inst.yy_accept[377] := (0).to_integer_16
			css_inst.yy_accept[378] := (39).to_integer_16
			css_inst.yy_accept[379] := (0).to_integer_16
			css_inst.yy_accept[380] := (0).to_integer_16
			css_inst.yy_accept[381] := (13).to_integer_16
			css_inst.yy_accept[382] := (0).to_integer_16
			css_inst.yy_accept[383] := (0).to_integer_16
			css_inst.yy_accept[384] := (0).to_integer_16
			css_inst.yy_accept[385] := (0).to_integer_16
			css_inst.yy_accept[386] := (0).to_integer_16
			css_inst.yy_accept[387] := (12).to_integer_16
			css_inst.yy_accept[388] := (14).to_integer_16
			css_inst.yy_accept[389] := (12).to_integer_16
			css_inst.yy_accept[390] := (35).to_integer_16
			css_inst.yy_accept[391] := (35).to_integer_16
			css_inst.yy_accept[392] := (35).to_integer_16
			css_inst.yy_accept[393] := (35).to_integer_16
			css_inst.yy_accept[394] := (23).to_integer_16
			css_inst.yy_accept[395] := (23).to_integer_16
			css_inst.yy_accept[396] := (23).to_integer_16
			css_inst.yy_accept[397] := (23).to_integer_16
			css_inst.yy_accept[398] := (35).to_integer_16
			css_inst.yy_accept[399] := (35).to_integer_16
			css_inst.yy_accept[400] := (35).to_integer_16
			css_inst.yy_accept[401] := (28).to_integer_16
			css_inst.yy_accept[402] := (35).to_integer_16
			css_inst.yy_accept[403] := (35).to_integer_16
			css_inst.yy_accept[404] := (35).to_integer_16
			css_inst.yy_accept[405] := (35).to_integer_16
			css_inst.yy_accept[406] := (35).to_integer_16
			css_inst.yy_accept[407] := (35).to_integer_16
			css_inst.yy_accept[408] := (35).to_integer_16
			css_inst.yy_accept[409] := (35).to_integer_16
			css_inst.yy_accept[410] := (35).to_integer_16
			css_inst.yy_accept[411] := (35).to_integer_16
			css_inst.yy_accept[412] := (35).to_integer_16
			css_inst.yy_accept[413] := (20).to_integer_16
			css_inst.yy_accept[414] := (21).to_integer_16
			css_inst.yy_accept[415] := (20).to_integer_16
			css_inst.yy_accept[416] := (20).to_integer_16
			css_inst.yy_accept[417] := (20).to_integer_16
			css_inst.yy_accept[418] := (21).to_integer_16
			css_inst.yy_accept[419] := (21).to_integer_16
			css_inst.yy_accept[420] := (35).to_integer_16
			css_inst.yy_accept[421] := (35).to_integer_16
			css_inst.yy_accept[422] := (35).to_integer_16
			css_inst.yy_accept[423] := (35).to_integer_16
			css_inst.yy_accept[424] := (35).to_integer_16
			css_inst.yy_accept[425] := (35).to_integer_16
			css_inst.yy_accept[426] := (35).to_integer_16
			css_inst.yy_accept[427] := (35).to_integer_16
			css_inst.yy_accept[428] := (35).to_integer_16
			css_inst.yy_accept[429] := (35).to_integer_16
			css_inst.yy_accept[430] := (35).to_integer_16
			css_inst.yy_accept[431] := (35).to_integer_16
			css_inst.yy_accept[432] := (35).to_integer_16
			css_inst.yy_accept[433] := (35).to_integer_16
			css_inst.yy_accept[434] := (35).to_integer_16
			css_inst.yy_accept[435] := (35).to_integer_16
			css_inst.yy_accept[436] := (35).to_integer_16
			css_inst.yy_accept[437] := (33).to_integer_16
			css_inst.yy_accept[438] := (33).to_integer_16
			css_inst.yy_accept[439] := (33).to_integer_16
			css_inst.yy_accept[440] := (33).to_integer_16
			css_inst.yy_accept[441] := (35).to_integer_16
			css_inst.yy_accept[442] := (35).to_integer_16
			css_inst.yy_accept[443] := (35).to_integer_16
			css_inst.yy_accept[444] := (25).to_integer_16
			css_inst.yy_accept[445] := (25).to_integer_16
			css_inst.yy_accept[446] := (25).to_integer_16
			css_inst.yy_accept[447] := (25).to_integer_16
			css_inst.yy_accept[448] := (35).to_integer_16
			css_inst.yy_accept[449] := (35).to_integer_16
			css_inst.yy_accept[450] := (35).to_integer_16
			css_inst.yy_accept[451] := (34).to_integer_16
			css_inst.yy_accept[452] := (34).to_integer_16
			css_inst.yy_accept[453] := (35).to_integer_16
			css_inst.yy_accept[454] := (35).to_integer_16
			css_inst.yy_accept[455] := (35).to_integer_16
			css_inst.yy_accept[456] := (35).to_integer_16
			css_inst.yy_accept[457] := (35).to_integer_16
			css_inst.yy_accept[458] := (35).to_integer_16
			css_inst.yy_accept[459] := (35).to_integer_16
			css_inst.yy_accept[460] := (35).to_integer_16
			css_inst.yy_accept[461] := (35).to_integer_16
			css_inst.yy_accept[462] := (35).to_integer_16
			css_inst.yy_accept[463] := (35).to_integer_16
			css_inst.yy_accept[464] := (24).to_integer_16
			css_inst.yy_accept[465] := (31).to_integer_16
			css_inst.yy_accept[466] := (24).to_integer_16
			css_inst.yy_accept[467] := (24).to_integer_16
			css_inst.yy_accept[468] := (24).to_integer_16
			css_inst.yy_accept[469] := (31).to_integer_16
			css_inst.yy_accept[470] := (31).to_integer_16
			css_inst.yy_accept[471] := (35).to_integer_16
			css_inst.yy_accept[472] := (35).to_integer_16
			css_inst.yy_accept[473] := (35).to_integer_16
			css_inst.yy_accept[474] := (35).to_integer_16
			css_inst.yy_accept[475] := (35).to_integer_16
		end

end
