class
	P_CSS_URL

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create token_names.make (<<30>>)
		end

feature {ANY} -- attributes

	token_names: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- routines

	get_uri_string (a_at: CE_POINTER [INTEGER_8]; a_pos: CE_POINTER [INTEGER_32]; a_length: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		local
			l_uri: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_uri.make

			if 0 /= (strncasecmp (a_at + a_pos.item, ce_string ("url("), (4).to_natural_32)) then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				a_pos.item := a_pos.item + (4)
				a_length.item := a_length.item - (5)
				from
				until
					js.loop_done
				loop
					if not ((((ctype_b_loc).item[(a_at[a_pos.item]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						a_pos.item := (a_pos.item) + 1
						a_length.item := (a_length.item) - 1
					end
				end
				from
				until
					js.loop_done
				loop
					if not ((((ctype_b_loc).item[(a_at[((a_pos.item + a_length.item) - 1)]).to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						a_length.item := (a_length.item) - 1
					end
				end
				if (a_at[a_pos.item]).to_integer_32 = 39 then
					a_pos.item := (a_pos.item) + 1
					a_length.item := a_length.item - (2)
				elseif (a_at[a_pos.item]).to_integer_32 = 34 then
					a_pos.item := (a_pos.item) + 1
					a_length.item := a_length.item - (2)
				end
				l_uri := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((a_length.item + 1).to_natural_32)))
				if (not l_uri.is_void) then
					strncpy (l_uri, (a_at + a_pos.item), (a_length.item).to_natural_32).do_nothing
					l_uri[a_length.item] := (('%/0/').code).to_integer_8
				end
				Result := l_uri
			end
		end

	get_urls_css (a_ctx: CE_POINTER [PD_MAP_CONTEXT]; a_offset: INTEGER_32; a_buf_length: INTEGER_32)
		local
			l_token: INTEGER_32
			l_buffer_pos: INTEGER_32
			l_pos2: CE_ARRAY [INTEGER_32]
			l_length: CE_ARRAY [INTEGER_32]
			l_uri: CE_POINTER [INTEGER_8]
			l_up: CE_POINTER [PD_URLPOS]
			l_up___0: CE_POINTER [PD_URLPOS]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_pos2.make (<<1>>)
			create l_length.make (<<1>>)
			create l_uri.make
			create l_up.make
			create l_up___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buffer_pos := 0
					css_inst.yy_scan_bytes ((a_ctx.item.text + a_offset), a_buf_length).do_nothing
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						l_token := css_inst.yylex
						if l_token = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 12 -- skip if block
						end
				when 3 then -- if:
						if l_token /= 14 then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if:
						from
						until
							js.loop_done
						loop
							l_buffer_pos := l_buffer_pos + css_inst.yyleng
							l_token := css_inst.yylex
							if l_token /= 1 then
								js.break
							end
						end
						if l_token /= 10 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_token /= 28 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_pos2.item := l_buffer_pos + a_offset
						l_length.item := css_inst.yyleng
						if l_token = 28 then
							l_uri := get_uri_string (a_ctx.item.text, l_pos2, l_length)
						else
							l_pos2.item := l_pos2.item + 1
							l_length.item := l_length.item - (2)
							l_uri := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_length.item + 1).to_natural_32)))
							strncpy (l_uri, (css_inst.yytext + 1), (l_length.item).to_natural_32).do_nothing
							l_uri[l_length.item] := (('%/0/').code).to_integer_8
						end
						if (not l_uri.is_void) then
							l_up := (html_url_inst.append_url (l_uri, l_pos2.item, l_length.item, a_ctx))
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Found @import: [%%s] at %%d [%%s]%N"), css_inst.yytext, l_buffer_pos, l_uri])
								end
								js.break
							end
							if (not l_up.is_void) then
								l_up.item.link_inline_p := {NATURAL_32} 1
								l_up.item.link_css_p := {NATURAL_32} 1
								l_up.item.link_expect_css := {NATURAL_32} 1
							end
							free (create {CE_POINTER [ANY]}.make_cast (l_uri))
						end
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						if l_token = 28 then
							l_pos2.item := l_buffer_pos + a_offset
							l_length.item := css_inst.yyleng
							l_uri := get_uri_string (a_ctx.item.text, l_pos2, l_length)
							if (not l_uri.is_void) then
								l_up___0 := (html_url_inst.append_url (l_uri, l_pos2.item, l_length.item, a_ctx))
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("Found URI: [%%s] at %%d [%%s]%N"), css_inst.yytext, l_buffer_pos, l_uri])
									end
									js.break
								end
								if (not l_up___0.is_void) then
									l_up___0.item.link_inline_p := {NATURAL_32} 1
									l_up___0.item.link_css_p := {NATURAL_32} 1
								end
								free (create {CE_POINTER [ANY]}.make_cast (l_uri))
							end
						end
				when 11 then
						l_buffer_pos := l_buffer_pos + css_inst.yyleng
				when 12 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 13 then -- loop done
					from
					until
						js.loop_done
					loop
						if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
							log_inst.debug_logprintf ([ce_string ("%N")])
						end
						js.break
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_urls_css_file (a_file: CE_POINTER [INTEGER_8]; a_url: CE_POINTER [INTEGER_8]): CE_POINTER [PD_URLPOS]
		local
			l_fm: CE_POINTER [PD_FILE_MEMORY]
			l_ctx: CE_ARRAY [PD_MAP_CONTEXT]
			js: JUMP_STATE
		do
			create l_fm.make
			create l_ctx.make (<<1>>)

			l_fm := utils_inst.read_file (a_file)
			if l_fm.is_void then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
				Result := (create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
						log_inst.debug_logprintf ([ce_string ("Loaded %%s (size %%s).%N"), a_file, (utils_inst.number_to_static_string ((l_fm.item.length).to_integer_64))])
					end
					js.break
				end
				l_ctx.item.text := l_fm.item.content
				l_ctx.item.tail := create {CE_POINTER [PD_URLPOS]}.make_shared (default_pointer)
				l_ctx.item.head := l_ctx.item.tail
				l_ctx.item.base := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				if (not a_url.is_void) then
					l_ctx.item.parent_base := a_url
				else
					l_ctx.item.parent_base := options_inst.opt.item.base_href
				end
				l_ctx.item.document_file := a_file
				l_ctx.item.nofollow := (0).to_boolean
				get_urls_css (l_ctx, 0, (l_fm.item.length).to_integer_32)
				utils_inst.read_file_free (l_fm)
				Result := (l_ctx.item.head)
			end
		end

end
