class
	P_INIT

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create buf___0.make (<<4_096>>)
			create choices.make (<<3>>)
			create commands.make (<<114>>)
			create home.make
		end

feature {ANY} -- attributes

	buf___0: CE_ARRAY [INTEGER_8]

	choices: CE_ARRAY [PD_DECODE_ITEM]

	commands: CE_ARRAY [PD_COMMANDS]

	home: CE_POINTER [INTEGER_8] assign set_home

	set_home (a_home: CE_POINTER [INTEGER_8])
		do
			home := a_home
		end

feature {ANY} -- routines

	check_user_specified_header (a_s: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_p___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_p___0.make

			l_p___0 := a_s
			from
			until
				js.loop_done
			loop
				if (l_p___0[0]).to_boolean then
					if (l_p___0[0]).to_integer_32 /= 58 then
						if (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0 := l_p___0 + 1
				end
			end
			if (l_p___0[0]).to_integer_32 /= 58 then
				Result := (0).to_boolean
				js.return
			elseif l_p___0.is_equal (a_s) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if (not (strchr (a_s, ('%N').code)).is_void) then
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	cleanup
		do
			if (not retr_inst.output_stream.is_void) then
				fclose (retr_inst.output_stream).do_nothing
			end
		end

	cmd_boolean (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_value: BOOLEAN
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp.make
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (c_ctype_inst.c2_tolower ((a_val[0]).to_integer_32)) /= 111 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (c_ctype_inst.c2_tolower ((a_val[1]).to_integer_32)) = 110 then
							if (a_val[2]).to_integer_32 = 0 then
								l_value := (1).to_boolean
							else
								l_pos := -1 + 3 -- goto _L___9
							end
						else
							l_pos := -1 + 3 -- goto _L___9
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else: | _L___9:
						if (c_ctype_inst.c2_tolower ((a_val[0]).to_integer_32)) /= 121 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (c_ctype_inst.c2_tolower ((a_val[1]).to_integer_32)) = 101 then
							if (c_ctype_inst.c2_tolower ((a_val[2]).to_integer_32)) = 115 then
								if (a_val[3]).to_integer_32 = 0 then
									l_value := (1).to_boolean
								else
									l_pos := -1 + 6 -- goto _L___7
								end
							else
								l_pos := -1 + 6 -- goto _L___7
							end
						else
							l_pos := -1 + 6 -- goto _L___7
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else: | _L___7:
						if (c_ctype_inst.c2_tolower ((a_val[0]).to_integer_32)) /= 49 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (a_val[1]).to_integer_32 = 0 then
							l_value := (1).to_boolean
						else
							l_pos := -1 + 9 -- goto _L___4
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 9 then -- else: | _L___4:
						if (c_ctype_inst.c2_tolower ((a_val[0]).to_integer_32)) /= 111 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (c_ctype_inst.c2_tolower ((a_val[1]).to_integer_32)) = 102 then
							if (c_ctype_inst.c2_tolower ((a_val[2]).to_integer_32)) = 102 then
								if (a_val[3]).to_integer_32 = 0 then
									l_value := (0).to_boolean
								else
									l_pos := -1 + 12 -- goto _L___3
								end
							else
								l_pos := -1 + 12 -- goto _L___3
							end
						else
							l_pos := -1 + 12 -- goto _L___3
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 12 then -- else: | _L___3:
						if (c_ctype_inst.c2_tolower ((a_val[0]).to_integer_32)) /= 110 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (c_ctype_inst.c2_tolower ((a_val[1]).to_integer_32)) = 111 then
							if (a_val[2]).to_integer_32 = 0 then
								l_value := (0).to_boolean
							else
								l_pos := -1 + 15 -- goto _L___0
							end
						else
							l_pos := -1 + 15 -- goto _L___0
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else: | _L___0:
						if (c_ctype_inst.c2_tolower ((a_val[0]).to_integer_32)) = 48 then
							if (a_val[1]).to_integer_32 = 0 then
								l_value := (0).to_boolean
							else
								l_tmp := quote_inst.quote (a_val)
								l_tmp___0 := gettext (ce_string ("%%s: %%s: Invalid boolean %%s; use `on%' or `off%'.%N"))
								fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), l_tmp___0, wget_inst.exec_name, a_com, l_tmp]).do_nothing
								Result := (0).to_boolean
								js.return
							end
						else
							l_tmp := quote_inst.quote (a_val)
							l_tmp___0 := gettext (ce_string ("%%s: %%s: Invalid boolean %%s; use `on%' or `off%'.%N"))
							fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), l_tmp___0, wget_inst.exec_name, a_com, l_tmp]).do_nothing
							Result := (0).to_boolean
							js.return
						end
				when 16 then -- if done | if done | if done | if done
						if not js.return_called then
							(create {CE_POINTER [BOOLEAN]}.make_cast (a_place)).item := l_value
							Result := (1).to_boolean
						end
				when 17 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cmd_boolean_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_boolean)
		end

	cmd_bytes (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_byte_value: CE_ARRAY [REAL_64]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_byte_value.make (<<1>>)
			create l_tmp.make

			if not (parse_bytes_helper (a_val, l_byte_value)) then
				l_tmp := quote_inst.quote (a_val)
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s: Invalid byte value %%s%N"))), wget_inst.exec_name, a_com, l_tmp]).do_nothing
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				(create {CE_POINTER [INTEGER_64]}.make_cast (a_place)).item := (l_byte_value.item).truncated_to_integer_64
				Result := (1).to_boolean
			end
		end

	cmd_bytes_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_bytes)
		end

	cmd_bytes_sum (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_byte_value: CE_ARRAY [REAL_64]
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_byte_value.make (<<1>>)
			create l_tmp.make

			if not (parse_bytes_helper (a_val, l_byte_value)) then
				l_tmp := quote_inst.quote (a_val)
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s: Invalid byte value %%s%N"))), wget_inst.exec_name, a_com, l_tmp]).do_nothing
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				(create {CE_POINTER [INTEGER_64]}.make_cast (a_place)).item := (l_byte_value.item).truncated_to_integer_64
				Result := (1).to_boolean
			end
		end

	cmd_bytes_sum_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_bytes_sum)
		end

	cmd_directory (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_s: CE_POINTER [INTEGER_8]
			l_t: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_s.make
			create l_t.make

			if not (cmd_file (a_com, a_val, a_place)) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				l_s := (create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_place)).item
				l_t := l_s + (strlen (l_s)).to_integer_32
				from
				until
					js.loop_done
				loop
					if (l_t.c_pointer.to_integer_32).to_natural_32 > (l_s.c_pointer.to_integer_32).to_natural_32 then
						l_t := l_t - 1
						if (l_t[0]).to_integer_32 /= 47 then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_t[0] := (('%/0/').code).to_integer_8
					end
				end
				Result := (1).to_boolean
			end
		end

	cmd_directory_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_directory)
		end

	cmd_directory_vector (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_pvec: CE_POINTER [CE_POINTER [CE_POINTER [INTEGER_8]]]
			l_t: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_seps___0: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_pvec.make
			create l_t.make
			create l_seps___0.make

			l_pvec := create {CE_POINTER [CE_POINTER [CE_POINTER [INTEGER_8]]]}.make_cast (a_place)
			if (a_val[0]).to_boolean then
				l_seps___0 := utils_inst.sepstring (a_val)
				l_t := l_seps___0
				from
				until
					js.loop_done
				loop
					if (not l_t.is_void) then
						if (l_t.item).is_void then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_len := (strlen (l_t.item)).to_integer_32
						if l_len > 1 then
							if (l_t.item[(l_len - 1)]).to_integer_32 = 47 then
								l_t.item[(l_len - 1)] := (('%/0/').code).to_integer_8
							end
						end
						l_t := l_t + 1
					end
				end
				l_pvec.item := utils_inst.merge_vecs (l_pvec.item, l_seps___0)
			else
				utils_inst.free_vec (l_pvec.item)
				l_pvec.item := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer)
			end
			Result := (1).to_boolean
		end

	cmd_directory_vector_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_directory_vector)
		end

	cmd_file (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_pstring: CE_POINTER [CE_POINTER [INTEGER_8]]
		do
			create l_pstring.make

			l_pstring := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_place)
			if (not (l_pstring.item).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (l_pstring.item))
			end
			l_pstring.item := xmalloc_inst.xstrdup (a_val)
			Result := (1).to_boolean
		end

	cmd_file_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_file)
		end

	cmd_number (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make
			create l_tmp___0.make

			if (simple_atoi (a_val, a_val + (strlen (a_val)).to_integer_32, create {CE_POINTER [INTEGER_32]}.make_cast (a_place))) then
				if (create {CE_POINTER [INTEGER_32]}.make_cast (a_place)).item < 0 then
					l_tmp := quote_inst.quote (a_val)
					l_tmp___0 := gettext (ce_string ("%%s: %%s: Invalid number %%s.%N"))
					fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), l_tmp___0, wget_inst.exec_name, a_com, l_tmp]).do_nothing
					Result := (0).to_boolean
					js.return
				end
			else
				l_tmp := quote_inst.quote (a_val)
				l_tmp___0 := gettext (ce_string ("%%s: %%s: Invalid number %%s.%N"))
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), l_tmp___0, wget_inst.exec_name, a_com, l_tmp]).do_nothing
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	cmd_number_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_number)
		end

	cmd_number_inf (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if not (strcasecmp (a_val, ce_string ("inf"))).to_boolean then
				(create {CE_POINTER [INTEGER_32]}.make_cast (a_place)).item := 0
				Result := (1).to_boolean
				js.return
			end
			if not js.return_called then
				Result := (cmd_number (a_com, a_val, a_place))
			end
		end

	cmd_number_inf_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_number_inf)
		end

	cmd_spec_dirstruct (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if not (cmd_boolean (a_com, a_val, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [BOOLEAN]}.make_shared (options_inst.opt.item.c_pointer + (create {PD_OPTIONS}.make).offset_of ("dirstruct")))))) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if options_inst.opt.item.dirstruct then
					options_inst.opt.item.no_dirstruct := (0).to_boolean
				else
					options_inst.opt.item.no_dirstruct := (1).to_boolean
				end
				Result := (1).to_boolean
			end
		end

	cmd_spec_dirstruct_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_dirstruct)
		end

	cmd_spec_header (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			if (a_val[0]).to_integer_32 = 0 then
				utils_inst.free_vec (options_inst.opt.item.user_headers)
				options_inst.opt.item.user_headers := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer)
				Result := (1).to_boolean
				js.return
			end
			if not js.return_called then
				if not (check_user_specified_header (a_val)) then
					l_tmp := quote_inst.quote (a_val)
					fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s: Invalid header %%s.%N"))), wget_inst.exec_name, a_com, l_tmp]).do_nothing
					Result := (0).to_boolean
					js.return
				end
			end
			if not js.return_called then
				options_inst.opt.item.user_headers := utils_inst.vec_append (options_inst.opt.item.user_headers, a_val)
				Result := (1).to_boolean
			end
		end

	cmd_spec_header_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_header)
		end

	cmd_spec_htmlify (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_flag: INTEGER_32
		do
			l_flag := (cmd_boolean (a_com, a_val, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [BOOLEAN]}.make_shared (options_inst.opt.item.c_pointer + (create {PD_OPTIONS}.make).offset_of ("htmlify")))))).to_integer
			if l_flag.to_boolean then
				if not options_inst.opt.item.htmlify then
					options_inst.opt.item.remove_listing := (0).to_boolean
				end
			end
			Result := l_flag.to_boolean
		end

	cmd_spec_htmlify_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_htmlify)
		end

	cmd_spec_mirror (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_mirror: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_mirror.make (<<1>>)

			if not (cmd_boolean (a_com, a_val, create {CE_POINTER [ANY]}.make_cast (l_mirror))) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if (l_mirror.item).to_boolean then
					options_inst.opt.item.recursive := (1).to_boolean
					if not options_inst.opt.item.no_dirstruct then
						options_inst.opt.item.dirstruct := (1).to_boolean
					end
					options_inst.opt.item.timestamping := (1).to_boolean
					options_inst.opt.item.reclevel := -1
					options_inst.opt.item.remove_listing := (0).to_boolean
				end
				Result := (1).to_boolean
			end
		end

	cmd_spec_mirror_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_mirror)
		end

	cmd_spec_prefer_family (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_prefer_family: CE_ARRAY [INTEGER_32]
			l_ok: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_prefer_family.make (<<1>>)
			create l_tmp___0.make

			l_prefer_family.item := 2
			l_ok := (decode_string (a_val, choices, (((create {PD_DECODE_ITEM}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_DECODE_ITEM}.make).structure_size.to_natural_32).to_integer_32, l_prefer_family)).to_integer
			if not l_ok.to_boolean then
				l_tmp___0 := quote_inst.quote (a_val)
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s: Invalid value %%s.%N"))), wget_inst.exec_name, a_com, l_tmp___0]).do_nothing
			end
			options_inst.opt.item.prefer_family := (l_prefer_family.item).to_natural_32
			Result := l_ok.to_boolean
		end

	cmd_spec_prefer_family_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_prefer_family)
		end

	cmd_spec_progress (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			if not (progress_inst.valid_progress_implementation_p (a_val)) then
				l_tmp := quote_inst.quote (a_val)
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s: Invalid progress type %%s.%N"))), wget_inst.exec_name, a_com, l_tmp]).do_nothing
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if (not (options_inst.opt.item.progress_type).is_void) then
					free (create {CE_POINTER [ANY]}.make_cast (options_inst.opt.item.progress_type))
				end
				options_inst.opt.item.progress_type := xmalloc_inst.xstrdup (a_val)
				Result := (1).to_boolean
			end
		end

	cmd_spec_progress_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_progress)
		end

	cmd_spec_recursive (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if (cmd_boolean (a_com, a_val, create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [BOOLEAN]}.make_shared (options_inst.opt.item.c_pointer + (create {PD_OPTIONS}.make).offset_of ("recursive")))))) then
				if options_inst.opt.item.recursive then
					if not options_inst.opt.item.no_dirstruct then
						options_inst.opt.item.dirstruct := (1).to_boolean
					end
				end
			else
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				Result := (1).to_boolean
			end
		end

	cmd_spec_recursive_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_recursive)
		end

	cmd_spec_restrict_file_names (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_val: CE_POINTER [INTEGER_8]
			l_restrict_os: INTEGER_32
			l_restrict_ctrl: INTEGER_32
			l_restrict_case: INTEGER_32
			l_restrict_nonascii: INTEGER_32
			l_end: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_val.make
			create l_end.make
			create l_tmp___1.make
			create l_tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_val := a_val
					l_restrict_os := (options_inst.opt.item.restrict_files_os).to_integer_32
					l_restrict_ctrl := (options_inst.opt.item.restrict_files_ctrl).to_integer
					l_restrict_case := (options_inst.opt.item.restrict_files_case).to_integer_32
					l_restrict_nonascii := (options_inst.opt.item.restrict_files_nonascii).to_integer
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 19 -- skip loop
					end
				when 2 then -- loop body:
						l_end := (strchr (l_val, (',').code))
						if l_end.is_void then
							l_end := l_val + (strlen (l_val)).to_integer_32
						end
						if (l_end.distance (l_val)).to_natural_32 /= (("unix").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_val), create {CE_POINTER [ANY]}.make_cast (ce_string ("unix")), (("unix").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 5 -- goto _L___3
						else
							l_restrict_os := 0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 5 then -- else: | _L___3:
						if (l_end.distance (l_val)).to_natural_32 /= (("windows").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_val), create {CE_POINTER [ANY]}.make_cast (ce_string ("windows")), (("windows").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 8 -- goto _L___2
						else
							l_restrict_os := 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 8 then -- else: | _L___2:
						if (l_end.distance (l_val)).to_natural_32 /= (("lowercase").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_val), create {CE_POINTER [ANY]}.make_cast (ce_string ("lowercase")), (("lowercase").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 11 -- goto _L___1
						else
							l_restrict_case := 1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 11 then -- else: | _L___1:
						if (l_end.distance (l_val)).to_natural_32 /= (("uppercase").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_val), create {CE_POINTER [ANY]}.make_cast (ce_string ("uppercase")), (("uppercase").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 14 -- goto _L___0
						else
							l_restrict_case := 2
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else: | _L___0:
						if (l_end.distance (l_val)).to_natural_32 /= (("nocontrol").count + 1).to_natural_32 - {NATURAL_32} 1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_val), create {CE_POINTER [ANY]}.make_cast (ce_string ("nocontrol")), (("nocontrol").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
							l_pos := -1 + 17 -- goto _L
						else
							l_restrict_ctrl := 0
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else: | _L:
						if (l_end.distance (l_val)).to_natural_32 = (("ascii").count + 1).to_natural_32 - {NATURAL_32} 1 then
							if (memcmp (create {CE_POINTER [ANY]}.make_cast (l_val), create {CE_POINTER [ANY]}.make_cast (ce_string ("ascii")), (("ascii").count + 1).to_natural_32 - {NATURAL_32} 1)).to_boolean then
								l_tmp___1 := quote_inst.quote (l_val)
								l_tmp___2 := gettext (ce_string ("%%s: %%s: Invalid restriction %%s,%N    use [unix|windows],[lowercase|uppercase],[nocontrol],[ascii].%N"))
								fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), l_tmp___2, wget_inst.exec_name, a_com, l_tmp___1]).do_nothing
								Result := (0).to_boolean
								js.return
							else
								l_restrict_nonascii := 1
							end
						else
							l_tmp___1 := quote_inst.quote (l_val)
							l_tmp___2 := gettext (ce_string ("%%s: %%s: Invalid restriction %%s,%N    use [unix|windows],[lowercase|uppercase],[nocontrol],[ascii].%N"))
							fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), l_tmp___2, wget_inst.exec_name, a_com, l_tmp___1]).do_nothing
							Result := (0).to_boolean
							js.return
						end
				when 18 then -- if done | if done | if done | if done
						if not js.return_called then
							if (l_end[0]).to_boolean then
								l_val := l_end + 1
							end
							if (l_val[0]).to_boolean then
								if not (l_end[0]).to_boolean then
									js.break
								end
							else
								js.break
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 19 then -- loop done
					if not js.return_called then
						options_inst.opt.item.restrict_files_os := l_restrict_os.to_natural_32
						options_inst.opt.item.restrict_files_ctrl := l_restrict_ctrl.to_boolean
						options_inst.opt.item.restrict_files_case := l_restrict_case.to_natural_32
						options_inst.opt.item.restrict_files_nonascii := l_restrict_nonascii.to_boolean
						Result := (1).to_boolean
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cmd_spec_restrict_file_names_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_restrict_file_names)
		end

	cmd_spec_timeout (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_value: CE_ARRAY [REAL_64]
			js: JUMP_STATE
		do
			create l_value.make (<<1>>)

			if not (cmd_time (a_com, a_val, create {CE_POINTER [ANY]}.make_cast (l_value))) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				options_inst.opt.item.read_timeout := l_value.item
				options_inst.opt.item.connect_timeout := l_value.item
				options_inst.opt.item.dns_timeout := l_value.item
				Result := (1).to_boolean
			end
		end

	cmd_spec_timeout_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_timeout)
		end

	cmd_spec_useragent (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_tmp: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_tmp.make

			if (not (strchr (a_val, ('%N').code)).is_void) then
				l_tmp := quote_inst.quote (a_val)
				fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s: Invalid value %%s.%N"))), wget_inst.exec_name, a_com, l_tmp]).do_nothing
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if (not (options_inst.opt.item.useragent).is_void) then
					free (create {CE_POINTER [ANY]}.make_cast (options_inst.opt.item.useragent))
				end
				options_inst.opt.item.useragent := xmalloc_inst.xstrdup (a_val)
				Result := (1).to_boolean
			end
		end

	cmd_spec_useragent_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_useragent)
		end

	cmd_spec_verbose (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place_ignored: CE_POINTER [ANY]): BOOLEAN
		local
			l_flag: CE_ARRAY [BOOLEAN]
			js: JUMP_STATE
		do
			create l_flag.make (<<1>>)

			if (cmd_boolean (a_com, a_val, create {CE_POINTER [ANY]}.make_cast (l_flag))) then
				options_inst.opt.item.verbose := (l_flag.item).to_integer
				Result := (1).to_boolean
				js.return
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	cmd_spec_verbose_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_spec_verbose)
		end

	cmd_string (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_pstring: CE_POINTER [CE_POINTER [INTEGER_8]]
		do
			create l_pstring.make

			l_pstring := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (a_place)
			if (not (l_pstring.item).is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (l_pstring.item))
			end
			l_pstring.item := xmalloc_inst.xstrdup (a_val)
			Result := (1).to_boolean
		end

	cmd_string_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_string)
		end

	cmd_time (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_val: CE_POINTER [INTEGER_8]
			l_number: CE_ARRAY [REAL_64]
			l_mult: REAL_64
			l_end: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_val.make
			create l_number.make (<<1>>)
			create l_end.make
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_val := a_val
					l_end := l_val + (strlen (l_val)).to_integer_32
					from
					until
						js.loop_done
					loop
						if (l_val.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
							if not (c_ctype_inst.c2_isspace ((l_end[-1]).to_integer_32)) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_end := l_end - 1
						end
					end
					if not (l_val.is_equal (l_end)) then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | err:
						l_tmp___1 := quote_inst.quote (l_val)
						fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: %%s: Invalid time period %%s%N"))), wget_inst.exec_name, a_com, l_tmp___1]).do_nothing
						Result := (0).to_boolean
						js.return
				when 2 then -- if done
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 3 then -- if:
						inspect (c_ctype_inst.c2_tolower ((l_end[-1]).to_integer_32)) -- switch 1 head
						when 115 then l_pos := -1 + 4
						when 109 then l_pos := -1 + 5
						when 104 then l_pos := -1 + 6
						when 100 then l_pos := -1 + 7
						when 119 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 4 then -- switch 1, case 115
						l_end := l_end - 1
						l_mult := (1).to_double
						l_pos := -1 + 10 -- switch 1; break
				when 5 then -- switch 1, case 109
						l_end := l_end - 1
						l_mult := (60).to_double
						l_pos := -1 + 10 -- switch 1; break
				when 6 then -- switch 1, case 104
						l_end := l_end - 1
						l_mult := (3_600).to_double
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 100
						l_end := l_end - 1
						l_mult := 86400.0
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 119
						l_end := l_end - 1
						l_mult := 604800.0
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, default:
						l_mult := (1).to_double
				when 10 then -- switch 1, done:
						from
						until
							js.loop_done
						loop
							if (l_val.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isspace ((l_val[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_val := l_val + 1
							end
						end
						from
						until
							js.loop_done
						loop
							if (l_val.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isspace ((l_end[-1]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_end := l_end - 1
							end
						end
						if l_val.is_equal (l_end) then
							l_pos := -1 + 1 -- goto err
						end
				when 11 then
						if not (simple_atof (l_val, l_end, l_number)) then
							l_pos := -1 + 1 -- goto err
						end
				when 12 then;
						(create {CE_POINTER [REAL_64]}.make_cast (a_place)).item := l_number.item * l_mult
						Result := (1).to_boolean
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	cmd_time_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_time)
		end

	cmd_vector (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_place: CE_POINTER [ANY]): BOOLEAN
		local
			l_pvec: CE_POINTER [CE_POINTER [CE_POINTER [INTEGER_8]]]
		do
			create l_pvec.make

			l_pvec := create {CE_POINTER [CE_POINTER [CE_POINTER [INTEGER_8]]]}.make_cast (a_place)
			if (a_val[0]).to_boolean then
				l_pvec.item := utils_inst.merge_vecs (l_pvec.item, (utils_inst.sepstring (a_val)))
			else
				utils_inst.free_vec (l_pvec.item)
				l_pvec.item := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer)
			end
			Result := (1).to_boolean
		end

	cmd_vector_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cmd_vector)
		end

	command_by_name (a_cmdname: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_lo: INTEGER_32
			l_hi: INTEGER_32
			l_mid: INTEGER_32
			l_cmp: INTEGER_32
			js: JUMP_STATE
		do
			l_lo := 0
			l_hi := (((create {PD_COMMANDS}.make).structure_size.to_natural_32 * (114).to_natural_32) // (create {PD_COMMANDS}.make).structure_size.to_natural_32 - {NATURAL_32} 1).to_integer_32
			from
			until
				not (not js.loop_done and then (l_lo <= l_hi))
			loop
				l_mid := ((l_lo + l_hi)).bit_shift_right (1)
				l_cmp := (strcasecmp (a_cmdname, commands[l_mid].name))
				if l_cmp < 0 then
					l_hi := l_mid - 1
				elseif l_cmp > 0 then
					l_lo := l_mid + 1
				else
					Result := l_mid
					js.return
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	decode_string (a_val: CE_POINTER [INTEGER_8]; a_items: CE_POINTER [PD_DECODE_ITEM]; a_itemcount: INTEGER_32; a_place: CE_POINTER [INTEGER_32]): BOOLEAN
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_done and then (l_i < a_itemcount))
			loop
				if 0 = (strcasecmp (a_val, (a_items + l_i).item.name)) then
					a_place.item := (a_items + l_i).item.code
					Result := (1).to_boolean
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := (0).to_boolean
			end
		end

	defaults
		local
			l_tmp: CE_POINTER [INTEGER_8]
		do
			create l_tmp.make

			memset (create {CE_POINTER [ANY]}.make_cast (options_inst.opt), ('%/0/').code, (create {PD_OPTIONS}.make).structure_size.to_natural_32).do_nothing
			options_inst.opt.item.cookies := (1).to_boolean
			options_inst.opt.item.verbose := -1
			options_inst.opt.item.ntry := 20
			options_inst.opt.item.reclevel := 5
			options_inst.opt.item.add_hostdir := (1).to_boolean
			options_inst.opt.item.netrc := (1).to_boolean
			options_inst.opt.item.ftp_glob := (1).to_boolean
			options_inst.opt.item.htmlify := (1).to_boolean
			options_inst.opt.item.http_keep_alive := (1).to_boolean
			options_inst.opt.item.use_proxy := (1).to_boolean
			l_tmp := getenv (ce_string ("no_proxy"))
			if (not l_tmp.is_void) then
				options_inst.opt.item.no_proxy := utils_inst.sepstring (l_tmp)
			end
			options_inst.opt.item.prefer_family := {PC_PREFER_FAMILY}.prefer_none
			options_inst.opt.item.allow_cache := (1).to_boolean
			options_inst.opt.item.read_timeout := (900).to_double
			options_inst.opt.item.use_robots := (1).to_boolean
			options_inst.opt.item.remove_listing := (1).to_boolean
			options_inst.opt.item.dot_bytes := (1_024).to_integer_64
			options_inst.opt.item.dot_spacing := 10
			options_inst.opt.item.dots_in_line := 50
			options_inst.opt.item.dns_cache := (1).to_boolean
			options_inst.opt.item.ftp_pasv := (1).to_boolean
			options_inst.opt.item.restrict_files_os := {PC_RESTRICT_FILES_OS}.restrict_unix
			options_inst.opt.item.restrict_files_ctrl := (1).to_boolean
			options_inst.opt.item.restrict_files_nonascii := (0).to_boolean
			options_inst.opt.item.restrict_files_case := {PC_RESTRICT_FILES_CASE}.restrict_no_case_restriction
			options_inst.opt.item.max_redirect := 20
			options_inst.opt.item.waitretry := (10).to_double
			options_inst.opt.item.enable_iri := (0).to_boolean
			options_inst.opt.item.locale := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			options_inst.opt.item.encoding_remote := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
		end

	dehyphen (a_s: CE_POINTER [INTEGER_8])
		local
			l_t: CE_POINTER [INTEGER_8]
			l_h: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			create l_t.make
			create l_h.make
			create l_tmp.make
			create l_tmp___0.make

			l_t := a_s
			l_h := a_s
			from
			until
				not ((l_h[0]).to_boolean)
			loop
				if (l_h[0]).to_integer_32 = 95 then
					l_h := l_h + 1
				elseif (l_h[0]).to_integer_32 = 45 then
					l_h := l_h + 1
				else
					l_tmp := l_t
					l_t := l_t + 1
					l_tmp___0 := l_h
					l_h := l_h + 1
					l_tmp[0] := l_tmp___0[0]
				end
			end
			l_t[0] := (('%/0/').code).to_integer_8
		end

	home_dir: CE_POINTER [INTEGER_8]
		local
			l_pwd: CE_POINTER [SD_PASSWD]
			l_tmp___2: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_pwd.make
			create l_tmp___2.make

			if home.is_void then
				home := getenv (ce_string ("HOME"))
				if home.is_void then
					l_pwd := (getpwuid ((getuid)))
					if l_pwd.is_void then
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						js.return
					elseif (l_pwd.item.pw_dir).is_void then
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						strcpy (buf___0, l_pwd.item.pw_dir).do_nothing
						home := buf___0
					end
				end
			end
			if not js.return_called then
				if (not home.is_void) then
					l_tmp___2 := (xmalloc_inst.xstrdup (home))
				else
					l_tmp___2 := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
				end
				Result := l_tmp___2
			end
		end

	initialize
		local
			l_file: CE_POINTER [INTEGER_8]
			l_env_sysrc: CE_POINTER [INTEGER_8]
			l_ok: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_file.make
			create l_env_sysrc.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ok := 1
					defaults
					l_env_sysrc := getenv (ce_string ("SYSTEM_WGETRC"))
					if l_env_sysrc.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (utils_inst.file_exists_p (l_env_sysrc)) then
							l_ok := (l_ok).bit_and ((run_wgetrc (l_env_sysrc)).to_integer)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if (utils_inst.file_exists_p (ce_string ("/usr/local/etc/wgetrc"))) then
							l_ok := (l_ok).bit_and ((run_wgetrc (ce_string ("/usr/local/etc/wgetrc"))).to_integer)
						end
				when 4 then
					l_file := wgetrc_file_name
					if l_file.is_void then
						js.return
					end
					if not js.return_called then
						if (strcmp (l_file, ce_string ("/usr/local/etc/wgetrc"))).to_boolean then
							l_ok := (l_ok).bit_and ((run_wgetrc (l_file)).to_integer)
						else
							l_tmp___3 := quote_inst.quote (l_file)
							fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: Warning: Both system and user wgetrc point to %%s.%N"))), wget_inst.exec_name, l_tmp___3]).do_nothing
						end
						if not l_ok.to_boolean then
							exit (2)
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_file))
					end
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_bytes_helper (a_val: CE_POINTER [INTEGER_8]; a_result: CE_POINTER [REAL_64]): BOOLEAN
		local
			l_val: CE_POINTER [INTEGER_8]
			l_number: CE_ARRAY [REAL_64]
			l_mult: REAL_64
			l_end: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_val.make
			create l_number.make (<<1>>)
			create l_end.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_val := a_val
					l_end := l_val + (strlen (l_val)).to_integer_32
					if 0 = (strcmp (l_val, ce_string ("inf"))) then
						a_result.item := (0).to_double
						Result := (1).to_boolean
						js.return
					end
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							if (l_val.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isspace ((l_end[-1]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_end := l_end - 1
							end
						end
						if l_val.is_equal (l_end) then
							Result := (0).to_boolean
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						inspect (c_ctype_inst.c2_tolower ((l_end[-1]).to_integer_32)) -- switch 1 head
						when 107 then l_pos := -1 + 2
						when 109 then l_pos := -1 + 3
						when 103 then l_pos := -1 + 4
						when 116 then l_pos := -1 + 5
						else l_pos := -1 + 6
						end
				when 2 then -- switch 1, case 107
						l_end := l_end - 1
						l_mult := 1024.0
						l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 109
						l_end := l_end - 1
						l_mult := 1048576.0
						l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 103
						l_end := l_end - 1
						l_mult := 1073741824.0
						l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 116
						l_end := l_end - 1
						l_mult := 1099511627776.0
						l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
						l_mult := (1).to_double
				when 7 then -- switch 1, done:
						from
						until
							js.loop_done
						loop
							if (l_val.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isspace ((l_val[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_val := l_val + 1
							end
						end
						from
						until
							js.loop_done
						loop
							if (l_val.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isspace ((l_end[-1]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_end := l_end - 1
							end
						end
						if l_val.is_equal (l_end) then
							Result := (0).to_boolean
							js.return
						end
				when 8 then -- if done
					if not js.return_called then
						if (simple_atof (l_val, l_end, l_number)) then
							if l_number.item < (0).to_double then
								Result := (0).to_boolean
								js.return
							end
						else
							Result := (0).to_boolean
							js.return
						end
					end
					if not js.return_called then
						a_result.item := l_number.item * l_mult
						Result := (1).to_boolean
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_line (a_line: CE_POINTER [INTEGER_8]; a_com: CE_POINTER [CE_POINTER [INTEGER_8]]; a_val: CE_POINTER [CE_POINTER [INTEGER_8]]; a_comind: CE_POINTER [INTEGER_32]): NATURAL_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_p___0: CE_POINTER [INTEGER_8]
			l_end: CE_POINTER [INTEGER_8]
			l_cmdstart: CE_POINTER [INTEGER_8]
			l_cmdend: CE_POINTER [INTEGER_8]
			l_valstart: CE_POINTER [INTEGER_8]
			l_valend: CE_POINTER [INTEGER_8]
			l_cmdcopy: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ind: INTEGER_32
			l_BTA_beg: CE_POINTER [INTEGER_8]
			l_BTA_len: INTEGER_32
			l_BTA_dest: CE_POINTER [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_line.make
			create l_p___0.make
			create l_end.make
			create l_cmdstart.make
			create l_cmdend.make
			create l_valstart.make
			create l_valend.make
			create l_cmdcopy.make (<<1>>)
			create l_BTA_beg.make
			create l_BTA_dest.make

			l_line := a_line
			l_end := l_line + (strlen (l_line)).to_integer_32
			from
			until
				js.loop_done
			loop
				if (l_line[0]).to_boolean then
					if not (c_ctype_inst.c2_isspace ((l_line[0]).to_integer_32)) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_line := l_line + 1
				end
			end
			from
			until
				js.loop_done
			loop
				if (l_end.c_pointer.to_integer_32).to_natural_32 > (l_line.c_pointer.to_integer_32).to_natural_32 then
					if not (c_ctype_inst.c2_isspace ((l_end[-1]).to_integer_32)) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_end := l_end - 1
				end
			end
			if not (l_line[0]).to_boolean then
				Result := ({PC_PARSE_LINE}.line_empty)
				js.return
			elseif (l_line[0]).to_integer_32 = 35 then
				Result := ({PC_PARSE_LINE}.line_empty)
				js.return
			end
			if not js.return_called then
				l_p___0 := l_line
				l_cmdstart := l_p___0
				from
				until
					js.loop_done
				loop
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
						if not (c_ctype_inst.c2_isalnum ((l_p___0[0]).to_integer_32)) then
							if (l_p___0[0]).to_integer_32 /= 95 then
								if (l_p___0[0]).to_integer_32 /= 45 then
									js.break
								end
							end
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + 1
					end
				end
				l_cmdend := l_p___0
				from
				until
					js.loop_done
				loop
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + 1
					end
				end
				if l_p___0.is_equal (l_end) then
					Result := ({PC_PARSE_LINE}.line_syntax_error)
					js.return
				elseif (l_p___0[0]).to_integer_32 /= 61 then
					Result := ({PC_PARSE_LINE}.line_syntax_error)
					js.return
				end
			end
			if not js.return_called then
				l_p___0 := l_p___0 + 1
				from
				until
					js.loop_done
				loop
					if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (l_end.c_pointer.to_integer_32).to_natural_32 then
						if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_p___0 := l_p___0 + 1
					end
				end
				l_valstart := l_p___0
				l_valend := l_end
				a_com.item := utils_inst.strdupdelim (l_cmdstart, l_cmdend)
				a_val.item := utils_inst.strdupdelim (l_valstart, l_valend)
				from
				until
					js.loop_done
				loop
					l_BTA_beg := l_cmdstart
					l_BTA_len := l_cmdend.distance (l_BTA_beg)
					l_BTA_dest := l_cmdcopy
					l_BTA_dest.item := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new ((l_BTA_len + 1).to_natural_32)))
					memcpy (create {CE_POINTER [ANY]}.make_cast (l_BTA_dest.item), create {CE_POINTER [ANY]}.make_cast (l_BTA_beg), l_BTA_len.to_natural_32).do_nothing
					l_BTA_dest.item[l_BTA_len] := (('%/0/').code).to_integer_8
					js.break
				end
				dehyphen (l_cmdcopy.item)
				l_ind := command_by_name (l_cmdcopy.item)
				if l_ind = -1 then
					Result := ({PC_PARSE_LINE}.line_unknown_command)
					js.return
				end
			end
			if not js.return_called then
				a_comind.item := l_ind
				Result := ({PC_PARSE_LINE}.line_ok)
			end
		end

	run_command (a_opt___0: CE_POINTER [INTEGER_8])
		local
			l_com: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_val: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_comind: CE_ARRAY [INTEGER_32]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			create l_com.make (<<1>>)
			create l_val.make (<<1>>)
			create l_comind.make (<<1>>)
			create l_tmp___1.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (parse_line (a_opt___0, l_com, l_val, l_comind)).to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0
					if not (setval_internal (l_comind.item, l_com.item, l_val.item)) then
						exit (2)
					end
					free (create {CE_POINTER [ANY]}.make_cast (l_com.item))
					free (create {CE_POINTER [ANY]}.make_cast (l_val.item))
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, default:
					l_tmp___1 := quote_inst.quote (a_opt___0)
					fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: Invalid --execute command %%s%N"))), wget_inst.exec_name, l_tmp___1]).do_nothing
					exit (2)
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	run_wgetrc (a_file: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_line: CE_POINTER [INTEGER_8]
			l_ln: INTEGER_32
			l_errcnt: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_com: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_val: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_comind: CE_ARRAY [INTEGER_32]
			l_tmp___6: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_line.make
			create l_tmp___0.make
			create l_com.make (<<1>>)
			create l_val.make (<<1>>)
			create l_comind.make (<<1>>)
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_errcnt := 0
					l_fp := fopen (a_file, ce_string ("r"))
					if l_fp.is_void then
						l_tmp___0 := strerror ((errno_location).item)
						fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: Cannot read %%s (%%s).%N"))), wget_inst.exec_name, a_file, l_tmp___0]).do_nothing
						Result := (1).to_boolean
						js.return
					end
					if js.return_called then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						l_ln := 1
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 12 -- skip loop
						end
				when 3 then -- loop body:
						l_line := utils_inst.read_whole_line (l_fp)
						if l_line.is_void then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_com.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_val.item := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						inspect (parse_line (l_line, l_com, l_val, l_comind)).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						when 3 then l_pos := -1 + 7
						when 1 then l_pos := -1 + 8
						else l_pos := -1 + 9
						end
				when 5 then -- switch 1, case 0
						if not (setval_internal_tilde (l_comind.item, l_com.item, l_val.item)) then
							fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: Error in %%s at line %%d.%N"))), wget_inst.exec_name, a_file, l_ln]).do_nothing
							l_errcnt := l_errcnt + 1
						end
						l_pos := -1 + 10 -- switch 1; break
				when 6 then -- switch 1, case 2
						fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: Syntax error in %%s at line %%d.%N"))), wget_inst.exec_name, a_file, l_ln]).do_nothing
						l_errcnt := l_errcnt + 1
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 3
						l_tmp___6 := quote_inst.quote (l_com.item)
						fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: Unknown command %%s in %%s at line %%d.%N"))), wget_inst.exec_name, l_tmp___6, a_file, l_ln]).do_nothing
						l_errcnt := l_errcnt + 1
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 1
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, default:
						abort
				when 10 then -- switch 1, done:
						if (not (l_com.item).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (l_com.item))
						end
						if (not (l_val.item).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (l_val.item))
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_line))
						l_ln := l_ln + 1
				when 11 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 12 then -- loop done
						fclose (l_fp).do_nothing
						Result := (l_errcnt = 0)
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	setoptval (a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]; a_optname: CE_POINTER [INTEGER_8])
		local
			l_dd_optname: CE_POINTER [INTEGER_8]
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_dd_optname.make

			l_dd_optname := create {CE_POINTER [INTEGER_8]}.make_cast ((l_aaf.new (({NATURAL_32} 2 + (strlen (a_optname))) + {NATURAL_32} 1)))
			l_dd_optname[0] := (('-').code).to_integer_8
			l_dd_optname[1] := (('-').code).to_integer_8
			strcpy ((l_dd_optname + 2), a_optname).do_nothing
			if a_val.is_void then
				assert_fail (ce_string ("val != ((void *)0)"), ce_string ("init.c"), {NATURAL_32} 754, ce_string ("setoptval"))
			end
			if not (setval_internal ((command_by_name (a_com)), l_dd_optname, a_val)) then
				exit (2)
			end
		end

	setval_internal (a_comind: INTEGER_32; a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			js: JUMP_STATE
		do
			if 0 <= a_comind then
				if not (a_comind.to_natural_32 < ((create {PD_COMMANDS}.make).structure_size.to_natural_32 * (114).to_natural_32) // (create {PD_COMMANDS}.make).structure_size.to_natural_32) then
					assert_fail (ce_string ("0 <= comind && ((size_t) comind) < (sizeof (commands) / sizeof ((commands)[0]))"), ce_string ("init.c"), {NATURAL_32} 699, ce_string ("setval_internal"))
				end
			else
				assert_fail (ce_string ("0 <= comind && ((size_t) comind) < (sizeof (commands) / sizeof ((commands)[0]))"), ce_string ("init.c"), {NATURAL_32} 699, ce_string ("setval_internal"))
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
					log_inst.debug_logprintf ([ce_string ("Setting %%s (%%s) to %%s%N"), a_com, commands[a_comind].name, a_val])
				end
				js.break
			end
			Result := ((commands[a_comind].action).boolean_item ([a_com, a_val, commands[a_comind].place]))
		end

	setval_internal_tilde (a_comind: INTEGER_32; a_com: CE_POINTER [INTEGER_8]; a_val: CE_POINTER [INTEGER_8]): BOOLEAN
		local
			l_val: CE_POINTER [INTEGER_8]
			l_ret: BOOLEAN
			l_homelen: INTEGER_32
			l_home___0: CE_POINTER [INTEGER_8]
			l_pstring: CE_POINTER [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_val.make
			create l_home___0.make
			create l_pstring.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_val := a_val
					l_ret := setval_internal (a_comind, a_com, l_val)
					if not ((commands[a_comind].action).is_equal (cmd_file_address)) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((commands[a_comind].action).is_equal (cmd_directory_address)) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if l_ret then
							if (l_val[0]).to_integer_32 = 126 then
								if (l_val[1]).to_integer_32 = 47 then
									l_pstring := create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_cast (commands[a_comind].place)
									l_home___0 := home_dir
									if (not l_home___0.is_void) then
										l_homelen := (strlen (l_home___0)).to_integer_32
										from
										until
											js.loop_done
										loop
											if l_homelen.to_boolean then
												if (l_home___0[(l_homelen - 1)]).to_integer_32 /= 47 then
													js.break
												end
											else
												js.break
											end
											if not js.loop_jumped then
												l_homelen := l_homelen - 1
												l_home___0[l_homelen] := (('%/0/').code).to_integer_8
											end
										end
										l_val := l_val + 1
										from
										until
											(l_val[0]).to_integer_32 /= 47
										loop
											l_val := l_val + 1
										end
										l_pstring.item := utils_inst.concat_strings ([l_home___0, ce_string ("/"), l_val, create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)])
									end
								end
							end
						end
				when 5 then -- if done
						Result := l_ret
				when 6 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	simple_atof (a_beg: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [REAL_64]): BOOLEAN
		local
			l_result: REAL_64
			l_negative: BOOLEAN
			l_seen_dot: BOOLEAN
			l_seen_digit: BOOLEAN
			l_divider: REAL_64
			l_p___0: CE_POINTER [INTEGER_8]
			l_ch: INTEGER_8
			js: JUMP_STATE
		do
			create l_p___0.make

			l_result := (0).to_double
			l_negative := (0).to_boolean
			l_seen_dot := (0).to_boolean
			l_seen_digit := (0).to_boolean
			l_divider := (1).to_double
			l_p___0 := a_beg
			from
			until
				js.loop_done
			loop
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
					if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0 := l_p___0 + 1
				end
			end
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
				if (l_p___0[0]).to_integer_32 = 45 then
					l_negative := ((l_p___0[0]).to_integer_32 = 45)
					l_p___0 := l_p___0 + 1
				elseif (l_p___0[0]).to_integer_32 = 43 then
					l_negative := ((l_p___0[0]).to_integer_32 = 45)
					l_p___0 := l_p___0 + 1
				end
			end
			from
			until
				not (not js.loop_done and then ((l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32))
			loop
				l_ch := l_p___0[0]
				if (c_ctype_inst.c2_isdigit (l_ch.to_integer_32)) then
					if not l_seen_dot then
						l_result := (10).to_double * l_result + (l_ch.to_integer_32 - 48).to_double
					else
						l_divider := l_divider * (10).to_double
						l_result := l_result + ((l_ch.to_integer_32 - 48).to_double / l_divider)
					end
					l_seen_digit := (1).to_boolean
				elseif l_ch.to_integer_32 = 46 then
					if not l_seen_dot then
						l_seen_dot := (1).to_boolean
					else
						Result := (0).to_boolean
						js.return
					end
				else
					Result := (0).to_boolean
					js.return
				end
				if not js.return_called then
					l_p___0 := l_p___0 + 1
				end
			end
			if not js.return_called and then (not l_seen_digit) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if l_negative then
					l_result := -l_result
				end
				a_dest.item := l_result
				Result := (1).to_boolean
			end
		end

	simple_atoi (a_beg: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [INTEGER_8]; a_dest: CE_POINTER [INTEGER_32]): BOOLEAN
		local
			l_result: INTEGER_32
			l_negative: BOOLEAN
			l_p___0: CE_POINTER [INTEGER_8]
			l_next: INTEGER_32
			l_next___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_p___0.make

			l_result := 0
			l_negative := (0).to_boolean
			l_p___0 := a_beg
			from
			until
				js.loop_done
			loop
				if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
					if not (c_ctype_inst.c2_isspace ((l_p___0[0]).to_integer_32)) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_p___0 := l_p___0 + 1
				end
			end
			if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
				if (l_p___0[0]).to_integer_32 = 45 then
					l_negative := ((l_p___0[0]).to_integer_32 = 45)
					l_p___0 := l_p___0 + 1
				elseif (l_p___0[0]).to_integer_32 = 43 then
					l_negative := ((l_p___0[0]).to_integer_32 = 45)
					l_p___0 := l_p___0 + 1
				end
			end
			if l_p___0.is_equal (a_end) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				if not l_negative then
					from
					until
						js.loop_done
					loop
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
							if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_next := 10 * l_result + ((l_p___0[0]).to_integer_32 - 48)
							if l_next < l_result then
								Result := (0).to_boolean
								js.return
							end
							if not js.return_called then
								l_result := l_next
								l_p___0 := l_p___0 + 1
							end
						end
					end
				else
					from
					until
						js.loop_done
					loop
						if (l_p___0.c_pointer.to_integer_32).to_natural_32 < (a_end.c_pointer.to_integer_32).to_natural_32 then
							if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
								js.break
							end
						else
							js.break
						end
						if not js.loop_jumped then
							l_next___0 := 10 * l_result - ((l_p___0[0]).to_integer_32 - 48)
							if l_next___0 > l_result then
								Result := (0).to_boolean
								js.return
							end
							if not js.return_called then
								l_result := l_next___0
								l_p___0 := l_p___0 + 1
							end
						end
					end
				end
			end
			if not js.return_called and then (not l_p___0.is_equal (a_end)) then
				Result := (0).to_boolean
				js.return
			end
			if not js.return_called then
				a_dest.item := l_result
				Result := (1).to_boolean
			end
		end

	wgetrc_env_file_name: CE_POINTER [INTEGER_8]
		local
			l_env: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_env.make

			l_env := (getenv (ce_string ("WGETRC")))
			if (not l_env.is_void) then
				if (l_env[0]).to_boolean then
					if not (utils_inst.file_exists_p (l_env)) then
						fprintf ([(create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), (gettext (ce_string ("%%s: WGETRC points to %%s, which doesn%'t exist.%N"))), wget_inst.exec_name, l_env]).do_nothing
						exit (1)
					end
					Result := (xmalloc_inst.xstrdup (l_env))
					js.return
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			end
		end

	wgetrc_file_name: CE_POINTER [INTEGER_8]
		local
			l_file: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_file.make

			l_file := (wgetrc_env_file_name)
			if (not l_file.is_void) then
				if (l_file[0]).to_boolean then
					Result := l_file
					js.return
				end
			end
			if not js.return_called then
				l_file := wgetrc_user_file_name
				Result := l_file
			end
		end

	wgetrc_user_file_name: CE_POINTER [INTEGER_8]
		local
			l_home___0: CE_POINTER [INTEGER_8]
			l_file: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_home___0.make
			create l_file.make

			l_home___0 := (home_dir)
			l_file := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			l_home___0 := home_dir
			if (not l_home___0.is_void) then
				l_file := utils_inst.aprintf ([ce_string ("%%s/.wgetrc"), l_home___0])
			end
			if (not l_home___0.is_void) then
				free (create {CE_POINTER [ANY]}.make_cast (l_home___0))
			end
			if l_file.is_void then
				Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if not (utils_inst.file_exists_p (l_file)) then
					free (create {CE_POINTER [ANY]}.make_cast (l_file))
					Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				Result := l_file
			end
		end

end
