deferred class
	S_STRING

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	memchr (a___s: CE_POINTER [ANY]; a___c: INTEGER_32; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memchr (a___s.c_pointer, a___c, a___n))
		end

	c_memchr (a___s: POINTER; a___c: INTEGER_32; a___n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return memchr($a___s, $a___c, $a___n);"
		end

	memcmp (a___s1: CE_POINTER [ANY]; a___s2: CE_POINTER [ANY]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_memcmp (a___s1.c_pointer, a___s2.c_pointer, a___n)
		end

	c_memcmp (a___s1: POINTER; a___s2: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return memcmp($a___s1, $a___s2, $a___n);"
		end

	memcpy (a___dest: CE_POINTER [ANY]; a___src: CE_POINTER [ANY]; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memcpy (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_memcpy (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return memcpy($a___dest, $a___src, $a___n);"
		end

	memmove (a___dest: CE_POINTER [ANY]; a___src: CE_POINTER [ANY]; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memmove (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_memmove (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return memmove($a___dest, $a___src, $a___n);"
		end

	memrchr (a___s: CE_POINTER [ANY]; a___c: INTEGER_32; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memrchr (a___s.c_pointer, a___c, a___n))
		end

	c_memrchr (a___s: POINTER; a___c: INTEGER_32; a___n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return memrchr($a___s, $a___c, $a___n);"
		end

	memset (a___s: CE_POINTER [ANY]; a___c: INTEGER_32; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memset (a___s.c_pointer, a___c, a___n))
		end

	c_memset (a___s: POINTER; a___c: INTEGER_32; a___n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return memset($a___s, $a___c, $a___n);"
		end

	strcasecmp (a___s1: CE_POINTER [INTEGER_8]; a___s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcasecmp (a___s1.c_pointer, a___s2.c_pointer)
		end

	c_strcasecmp (a___s1: POINTER; a___s2: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return strcasecmp($a___s1, $a___s2);"
		end

	strcasecmp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent strcasecmp)
		end

	strcat (a___dest: CE_POINTER [INTEGER_8]; a___src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcat (a___dest.c_pointer, a___src.c_pointer))
		end

	c_strcat (a___dest: POINTER; a___src: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strcat($a___dest, $a___src);"
		end

	strchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strchr (a___s.c_pointer, a___c))
		end

	c_strchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strchr($a___s, $a___c);"
		end

	strcmp (a___s1: CE_POINTER [INTEGER_8]; a___s2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcmp (a___s1.c_pointer, a___s2.c_pointer)
		end

	c_strcmp (a___s1: POINTER; a___s2: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return strcmp($a___s1, $a___s2);"
		end

	strcmp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent strcmp)
		end

	strcpy (a___dest: CE_POINTER [INTEGER_8]; a___src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcpy (a___dest.c_pointer, a___src.c_pointer))
		end

	c_strcpy (a___dest: POINTER; a___src: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strcpy($a___dest, $a___src);"
		end

	strcspn (a___s: CE_POINTER [INTEGER_8]; a___reject: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strcspn (a___s.c_pointer, a___reject.c_pointer)
		end

	c_strcspn (a___s: POINTER; a___reject: POINTER): NATURAL_32
		external
			"C inline use <wget.h>"
		alias
			"return strcspn($a___s, $a___reject);"
		end

	strerror (a___errnum: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strerror (a___errnum))
		end

	c_strerror (a___errnum: INTEGER_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strerror($a___errnum);"
		end

	strlen (a___s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a___s.c_pointer)
		end

	c_strlen (a___s: POINTER): NATURAL_32
		external
			"C inline use <wget.h>"
		alias
			"return strlen($a___s);"
		end

	strncasecmp (a___s1: CE_POINTER [INTEGER_8]; a___s2: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_strncasecmp (a___s1.c_pointer, a___s2.c_pointer, a___n)
		end

	c_strncasecmp (a___s1: POINTER; a___s2: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return strncasecmp($a___s1, $a___s2, $a___n);"
		end

	strncat (a___dest: CE_POINTER [INTEGER_8]; a___src: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strncat (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_strncat (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strncat($a___dest, $a___src, $a___n);"
		end

	strncmp (a___s1: CE_POINTER [INTEGER_8]; a___s2: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_strncmp (a___s1.c_pointer, a___s2.c_pointer, a___n)
		end

	c_strncmp (a___s1: POINTER; a___s2: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return strncmp($a___s1, $a___s2, $a___n);"
		end

	strncpy (a___dest: CE_POINTER [INTEGER_8]; a___src: CE_POINTER [INTEGER_8]; a___n: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strncpy (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_strncpy (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strncpy($a___dest, $a___src, $a___n);"
		end

	strpbrk (a___s: CE_POINTER [INTEGER_8]; a___accept: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strpbrk (a___s.c_pointer, a___accept.c_pointer))
		end

	c_strpbrk (a___s: POINTER; a___accept: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strpbrk($a___s, $a___accept);"
		end

	strrchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strrchr (a___s.c_pointer, a___c))
		end

	c_strrchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strrchr($a___s, $a___c);"
		end

	strspn (a___s: CE_POINTER [INTEGER_8]; a___accept: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strspn (a___s.c_pointer, a___accept.c_pointer)
		end

	c_strspn (a___s: POINTER; a___accept: POINTER): NATURAL_32
		external
			"C inline use <wget.h>"
		alias
			"return strspn($a___s, $a___accept);"
		end

	strstr (a___haystack: CE_POINTER [INTEGER_8]; a___needle: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strstr (a___haystack.c_pointer, a___needle.c_pointer))
		end

	c_strstr (a___haystack: POINTER; a___needle: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strstr($a___haystack, $a___needle);"
		end

	strtok (a___s: CE_POINTER [INTEGER_8]; a___delim: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strtok (a___s.c_pointer, a___delim.c_pointer))
		end

	c_strtok (a___s: POINTER; a___delim: POINTER): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return strtok($a___s, $a___delim);"
		end

end
