deferred class
	S_UNISTD

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	close (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return close($a___fd);"
		end

	fork: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return eiffel_fork();"
		end

	getpid: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return getpid();"
		end

	getuid: NATURAL_32
		external
			"C inline use <wget.h>"
		alias
			"return getuid();"
		end

	isatty (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return isatty($a___fd);"
		end

	read (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a___fd, a___buf.c_pointer, a___nbytes)
		end

	c_read (a___fd: INTEGER_32; a___buf: POINTER; a___nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return read($a___fd, $a___buf, $a___nbytes);"
		end

	readlink (a___path: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [INTEGER_8]; a___len: NATURAL_32): INTEGER_32
		do
			Result := c_readlink (a___path.c_pointer, a___buf.c_pointer, a___len)
		end

	c_readlink (a___path: POINTER; a___buf: POINTER; a___len: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return readlink($a___path, $a___buf, $a___len);"
		end

	setsid: INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return setsid();"
		end

	symlink (a___from: CE_POINTER [INTEGER_8]; a___to: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_symlink (a___from.c_pointer, a___to.c_pointer)
		end

	c_symlink (a___from: POINTER; a___to: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return symlink($a___from, $a___to);"
		end

	sysconf (a___name: INTEGER_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return sysconf($a___name);"
		end

	unlink (a___name: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_unlink (a___name.c_pointer)
		end

	c_unlink (a___name: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return unlink($a___name);"
		end

	write (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_write (a___fd, a___buf.c_pointer, a___n)
		end

	c_write (a___fd: INTEGER_32; a___buf: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return write($a___fd, $a___buf, $a___n);"
		end

end
