class
	PD_EVENT

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	ev: INTEGER_32 assign set_ev

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

	b: INTEGER_32 assign set_b

feature {ANY} -- setters

	set_ev (a_ev: INTEGER_32)
		do
			ev := a_ev
			update_memory_field ("ev")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_b (a_b: INTEGER_32)
		do
			b := a_b
			update_memory_field ("b")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ev := a_other.ev
			x := a_other.x
			y := a_other.y
			b := a_other.b
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ev = a_other.ev and
				x = a_other.x and
				y = a_other.y and
				b = a_other.b
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ev"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("b")
				>>)
			init_structure_info
		end

end
