class
	PD_PUSH_DEL_BUTTON_HOP_STRUCT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create dlg.make
			create box.make
		end

feature {ANY} -- fields

	dlg: CE_POINTER [PD_DIALOG] assign set_dlg

	box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX] assign set_box

	id: INTEGER_32 assign set_id

feature {ANY} -- setters

	set_dlg (a_dlg: CE_POINTER [PD_DIALOG])
		do
			dlg := a_dlg
			update_memory_field ("dlg")
		end

	set_box (a_box: CE_POINTER [PD_DLG_DATA_ITEM_DATA_BOX])
		do
			box := a_box
			update_memory_field ("box")
		end

	set_id (a_id: INTEGER_32)
		do
			id := a_id
			update_memory_field ("id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			dlg := a_other.dlg
			box := a_other.box
			id := a_other.id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dlg.is_equal (a_other.dlg) and
				box.is_equal (a_other.box) and
				id = a_other.id
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("dlg"),
					create {CE_STRUCTURE_FIELD}.make ("box"),
					create {CE_STRUCTURE_FIELD}.make ("id")
				>>)
			init_structure_info
		end

end
