deferred class
	S_NETDB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	gethostbyaddr (a___addr: CE_POINTER [ANY]; a___len: NATURAL_32; a___type: INTEGER_32): CE_POINTER [SD_HOSTENT]
		do
			create Result.make_shared (c_gethostbyaddr (a___addr.c_pointer, a___len, a___type))
		end

	c_gethostbyaddr (a___addr: POINTER; a___len: NATURAL_32; a___type: INTEGER_32): POINTER
		external
			"C inline use <links.h>"
		alias
			"return gethostbyaddr($a___addr, $a___len, $a___type);"
		end

	gethostbyname (a___name: CE_POINTER [INTEGER_8]): CE_POINTER [SD_HOSTENT]
		do
			create Result.make_shared (c_gethostbyname (a___name.c_pointer))
		end

	c_gethostbyname (a___name: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return gethostbyname($a___name);"
		end

	herror (a___str: CE_POINTER [INTEGER_8])
		do
			c_herror (a___str.c_pointer)
		end

	c_herror (a___str: POINTER)
		external
			"C inline use <links.h>"
		alias
			"herror($a___str);"
		end

end
