class
	PD_CHARSTAB

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create cp.make
			create name.make
		end

feature {ANY} -- fields

	cp: CE_POINTER [INTEGER_32] assign set_cp

	name: CE_POINTER [INTEGER_8] assign set_name

feature {ANY} -- setters

	set_cp (a_cp: CE_POINTER [INTEGER_32])
		do
			cp := a_cp
			update_memory_field ("cp")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			cp := a_other.cp
			name := a_other.name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				cp.is_equal (a_other.cp) and
				name.is_equal (a_other.name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("cp"),
					create {CE_STRUCTURE_FIELD}.make ("name")
				>>)
			init_structure_info
		end

end
