class
	PD_INTERVAL

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	first: INTEGER_32 assign set_first

	last: INTEGER_32 assign set_last

feature {ANY} -- setters

	set_first (a_first: INTEGER_32)
		do
			first := a_first
			update_memory_field ("first")
		end

	set_last (a_last: INTEGER_32)
		do
			last := a_last
			update_memory_field ("last")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			first := a_other.first
			last := a_other.last
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				first = a_other.first and
				last = a_other.last
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("first"),
					create {CE_STRUCTURE_FIELD}.make ("last")
				>>)
			init_structure_info
		end

end
