class
	PD_SFTWORD_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sft_word.make (<<1>>)
		end

feature {ANY} -- fields

	sft_score: INTEGER_16 assign set_sft_score

	sft_word: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_sft_score (a_sft_score: INTEGER_16)
		do
			sft_score := a_sft_score
			update_memory_field ("sft_score")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sft_score := a_other.sft_score
			sft_word := a_other.sft_word.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sft_score = a_other.sft_score and
				sft_word.is_equal (a_other.sft_word)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sft_score"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sft_word", <<1>>)
				>>)
			init_structure_info
		end

end
