frozen class
	VIM_INITIALIZER_SLICE42

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			option_inst.options[142].scriptID := 0
			option_inst.options[143].fullname := ce_string ("imcmdline")
			option_inst.options[143].shortname := ce_string ("imc")
			option_inst.options[143].flags := (1_025).to_natural_32
			option_inst.options[143].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_imcmdline)
			option_inst.options[143].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[143].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[143].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[143].scriptID := 0
			option_inst.options[144].fullname := ce_string ("imdisable")
			option_inst.options[144].shortname := ce_string ("imd")
			option_inst.options[144].flags := (1_025).to_natural_32
			option_inst.options[144].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_imdisable)
			option_inst.options[144].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[144].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[144].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[144].scriptID := 0
			option_inst.options[145].fullname := ce_string ("iminsert")
			option_inst.options[145].shortname := ce_string ("imi")
			option_inst.options[145].flags := (1_026).to_natural_32
			option_inst.options[145].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_iminsert)
			option_inst.options[145].indir := (16_418).to_natural_32
			option_inst.options[145].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 2)
			option_inst.options[145].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[145].scriptID := 0
			option_inst.options[146].fullname := ce_string ("imsearch")
			option_inst.options[146].shortname := ce_string ("ims")
			option_inst.options[146].flags := (1_026).to_natural_32
			option_inst.options[146].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_imsearch)
			option_inst.options[146].indir := (16_419).to_natural_32
			option_inst.options[146].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 2)
			option_inst.options[146].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[146].scriptID := 0
			option_inst.options[147].fullname := ce_string ("include")
			option_inst.options[147].shortname := ce_string ("inc")
			option_inst.options[147].flags := (1_036).to_natural_32
			option_inst.options[147].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_inc)
			option_inst.options[147].indir := (20_503).to_natural_32
			option_inst.options[147].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("^\s*#\s*include"))
			option_inst.options[147].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[147].scriptID := 0
			option_inst.options[148].fullname := ce_string ("includeexpr")
			option_inst.options[148].shortname := ce_string ("inex")
			option_inst.options[148].flags := (1_036).to_natural_32
			option_inst.options[148].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_inex)
			option_inst.options[148].indir := (16_422).to_natural_32
			option_inst.options[148].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[148].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[148].scriptID := 0
			option_inst.options[149].fullname := ce_string ("incsearch")
			option_inst.options[149].shortname := ce_string ("is")
			option_inst.options[149].flags := (3_073).to_natural_32
			option_inst.options[149].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_is)
			option_inst.options[149].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[149].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[149].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[149].scriptID := 0
			option_inst.options[150].fullname := ce_string ("indentexpr")
			option_inst.options[150].shortname := ce_string ("inde")
			option_inst.options[150].flags := (3_084).to_natural_32
			option_inst.options[150].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_inde)
			option_inst.options[150].indir := (16_420).to_natural_32
			option_inst.options[150].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[150].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[150].scriptID := 0
			option_inst.options[151].fullname := ce_string ("indentkeys")
			option_inst.options[151].shortname := ce_string ("indk")
			option_inst.options[151].flags := (99_340).to_natural_32
			option_inst.options[151].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_indk)
			option_inst.options[151].indir := (16_421).to_natural_32
			option_inst.options[151].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("0{,0},:,0#,!^F,o,O,e"))
			option_inst.options[151].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[151].scriptID := 0
			option_inst.options[152].fullname := ce_string ("infercase")
			option_inst.options[152].shortname := ce_string ("inf")
			option_inst.options[152].flags := (1_025).to_natural_32
			option_inst.options[152].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_inf)
			option_inst.options[152].indir := (16_423).to_natural_32
			option_inst.options[152].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[152].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[152].scriptID := 0
			option_inst.options[153].fullname := ce_string ("insertmode")
			option_inst.options[153].shortname := ce_string ("im")
			option_inst.options[153].flags := (3_073).to_natural_32
			option_inst.options[153].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_im)
			option_inst.options[153].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[153].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[153].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[153].scriptID := 0
			option_inst.options[154].fullname := ce_string ("isfname")
			option_inst.options[154].shortname := ce_string ("isf")
			option_inst.options[154].flags := (99_332).to_natural_32
			option_inst.options[154].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_isf)
			option_inst.options[154].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[154].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@,48-57,/,.,-,_,+,,,#,$,%%,~,="))
			option_inst.options[154].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[154].scriptID := 0
			option_inst.options[155].fullname := ce_string ("isident")
			option_inst.options[155].shortname := ce_string ("isi")
			option_inst.options[155].flags := (99_332).to_natural_32
			option_inst.options[155].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_isi)
			option_inst.options[155].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[155].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@,48-57,_,192-255"))
			option_inst.options[155].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[155].scriptID := 0
			option_inst.options[156].fullname := ce_string ("iskeyword")
			option_inst.options[156].shortname := ce_string ("isk")
			option_inst.options[156].flags := (100_364).to_natural_32
			option_inst.options[156].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_isk)
			option_inst.options[156].indir := (16_424).to_natural_32
			option_inst.options[156].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@,48-57,_"))
			option_inst.options[156].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@,48-57,_,192-255"))
			option_inst.options[156].scriptID := 0
			option_inst.options[157].fullname := ce_string ("isprint")
			option_inst.options[157].shortname := ce_string ("isp")
			option_inst.options[157].flags := (123_908).to_natural_32
			option_inst.options[157].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_isp)
			option_inst.options[157].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[157].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("@,161-255"))
			option_inst.options[157].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[157].scriptID := 0
			option_inst.options[158].fullname := ce_string ("joinspaces")
			option_inst.options[158].shortname := ce_string ("js")
			option_inst.options[158].flags := (3_073).to_natural_32
			option_inst.options[158].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_js)
			option_inst.options[158].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[158].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[158].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[158].scriptID := 0
			option_inst.options[159].fullname := ce_string ("key")
			option_inst.options[159].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[159].flags := (1_548).to_natural_32
			option_inst.options[159].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_key)
			option_inst.options[159].indir := (16_425).to_natural_32
			option_inst.options[159].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[159].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[159].scriptID := 0
			option_inst.options[160].fullname := ce_string ("keymap")
			option_inst.options[160].shortname := ce_string ("kmp")
			option_inst.options[160].flags := (10_507_276).to_natural_32
			option_inst.options[160].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[160].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[160].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[160].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[160].scriptID := 0
			option_inst.options[161].fullname := ce_string ("keymodel")
			option_inst.options[161].shortname := ce_string ("km")
			option_inst.options[161].flags := (99_332).to_natural_32
			option_inst.options[161].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_km)
			option_inst.options[161].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[161].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[161].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[161].scriptID := 0
			option_inst.options[162].fullname := ce_string ("keywordprg")
			option_inst.options[162].shortname := ce_string ("kp")
			option_inst.options[162].flags := (263_188).to_natural_32
			option_inst.options[162].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_kp)
			option_inst.options[162].indir := (20_522).to_natural_32
			option_inst.options[162].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("man -s"))
			option_inst.options[162].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[162].scriptID := 0
			option_inst.options[163].fullname := ce_string ("langmap")
			option_inst.options[163].shortname := ce_string ("lmap")
			option_inst.options[163].flags := (99_332).to_natural_32
			option_inst.options[163].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[163].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[163].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[163].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[163].scriptID := 0
			option_inst.options[164].fullname := ce_string ("langmenu")
			option_inst.options[164].shortname := ce_string ("lm")
			option_inst.options[164].flags := (2_098_180).to_natural_32
			option_inst.options[164].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_lm)
			option_inst.options[164].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[164].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[164].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[164].scriptID := 0
			option_inst.options[165].fullname := ce_string ("laststatus")
			option_inst.options[165].shortname := ce_string ("ls")
			option_inst.options[165].flags := (25_602).to_natural_32
			option_inst.options[165].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_ls)
			option_inst.options[165].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[165].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[165].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[165].scriptID := 0
			option_inst.options[166].fullname := ce_string ("lazyredraw")
			option_inst.options[166].shortname := ce_string ("lz")
			option_inst.options[166].flags := (1_025).to_natural_32
			option_inst.options[166].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_lz)
			option_inst.options[166].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[166].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[166].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[166].scriptID := 0
			option_inst.options[167].fullname := ce_string ("linebreak")
			option_inst.options[167].shortname := ce_string ("lbr")
			option_inst.options[167].flags := (9_217).to_natural_32
			option_inst.options[167].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[167].indir := (8_205).to_natural_32
			option_inst.options[167].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[167].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[167].scriptID := 0
			option_inst.options[168].fullname := ce_string ("lines")
			option_inst.options[168].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[168].flags := (30_274).to_natural_32
			option_inst.options[168].var := create {CE_POINTER [NATURAL_8]}.make_cast (globals_inst.Rows)
			option_inst.options[168].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[168].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 24)
			option_inst.options[168].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[168].scriptID := 0
			option_inst.options[169].fullname := ce_string ("linespace")
			option_inst.options[169].shortname := ce_string ("lsp")
			option_inst.options[169].flags := (29_698).to_natural_32
			option_inst.options[169].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_linespace)
			option_inst.options[169].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[169].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[169].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[169].scriptID := 0
			option_inst.options[170].fullname := ce_string ("lisp")
			option_inst.options[170].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[170].flags := (1_025).to_natural_32
			option_inst.options[170].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_lisp)
			option_inst.options[170].indir := (16_427).to_natural_32
			option_inst.options[170].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[170].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[170].scriptID := 0
			option_inst.options[171].fullname := ce_string ("lispwords")
			option_inst.options[171].shortname := ce_string ("lw")
			option_inst.options[171].flags := (99_332).to_natural_32
			option_inst.options[171].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_lispwords)
			option_inst.options[171].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[171].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("defun,define,defmacro,set!,lambda,if,case,let,flet,let*,letrec,do,do*,define-syntax,let-syntax,letrec-syntax,destructuring-bind,defpackage,defparameter,defstruct,deftype,defvar,do-all-symbols,do-external-symbols,do-symbols,dolist,dotimes,ecase,etypecase,eval-when,labels,macrolet,multiple-value-bind,multiple-value-call,multiple-value-prog1,multiple-value-setq,prog1,progv,typecase,unless,unwind-protect,when,with-input-from-string,with-open-file,with-open-stream,with-output-to-string,with-package-iterator,define-condition,handler-bind,handler-case,restart-bind,restart-case,with-simple-restart,store-value,use-value,muffle-warning,abort,continue,with-slots,with-slots*,with-accessors,with-accessors*,defclass,defmethod,print-unreadable-object"))
			option_inst.options[171].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[171].scriptID := 0
			option_inst.options[172].fullname := ce_string ("list")
			option_inst.options[172].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[172].flags := (9_217).to_natural_32
			option_inst.options[172].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[172].indir := (8_192).to_natural_32
			option_inst.options[172].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[172].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[172].scriptID := 0
			option_inst.options[173].fullname := ce_string ("listchars")
			option_inst.options[173].shortname := ce_string ("lcs")
			option_inst.options[173].flags := (123_908).to_natural_32
			option_inst.options[173].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_lcs)
			option_inst.options[173].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[173].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("eol:$"))
			option_inst.options[173].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[173].scriptID := 0
			option_inst.options[174].fullname := ce_string ("loadplugins")
			option_inst.options[174].shortname := ce_string ("lpl")
			option_inst.options[174].flags := (1_025).to_natural_32
			option_inst.options[174].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_lpl)
			option_inst.options[174].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[174].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[174].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[174].scriptID := 0
			option_inst.options[175].fullname := ce_string ("magic")
			option_inst.options[175].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[175].flags := (1_025).to_natural_32
			option_inst.options[175].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_magic)
			option_inst.options[175].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[175].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[175].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[175].scriptID := 0
			option_inst.options[176].fullname := ce_string ("makeef")
			option_inst.options[176].shortname := ce_string ("mef")
			option_inst.options[176].flags := (263_188).to_natural_32
			option_inst.options[176].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mef)
			option_inst.options[176].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[176].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[176].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[176].scriptID := 0
			option_inst.options[177].fullname := ce_string ("makeprg")
			option_inst.options[177].shortname := ce_string ("mp")
			option_inst.options[177].flags := (263_188).to_natural_32
			option_inst.options[177].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mp)
			option_inst.options[177].indir := (20_486).to_natural_32
			option_inst.options[177].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("make"))
			option_inst.options[177].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[177].scriptID := 0
			option_inst.options[178].fullname := ce_string ("matchpairs")
			option_inst.options[178].shortname := ce_string ("mps")
			option_inst.options[178].flags := (99_340).to_natural_32
			option_inst.options[178].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mps)
			option_inst.options[178].indir := (16_431).to_natural_32
			option_inst.options[178].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("(:),{:},[:]"))
			option_inst.options[178].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[178].scriptID := 0
			option_inst.options[179].fullname := ce_string ("matchtime")
			option_inst.options[179].shortname := ce_string ("mat")
			option_inst.options[179].flags := (1_026).to_natural_32
			option_inst.options[179].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mat)
			option_inst.options[179].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[179].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 5)
			option_inst.options[179].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[179].scriptID := 0
			option_inst.options[180].fullname := ce_string ("maxcombine")
			option_inst.options[180].shortname := ce_string ("mco")
			option_inst.options[180].flags := (1_026).to_natural_32
			option_inst.options[180].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mco)
			option_inst.options[180].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[180].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 2)
			option_inst.options[180].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[180].scriptID := 0
			option_inst.options[181].fullname := ce_string ("maxfuncdepth")
			option_inst.options[181].shortname := ce_string ("mfd")
			option_inst.options[181].flags := (1_026).to_natural_32
			option_inst.options[181].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mfd)
			option_inst.options[181].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[181].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 100)
			option_inst.options[181].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[181].scriptID := 0
			option_inst.options[182].fullname := ce_string ("maxmapdepth")
			option_inst.options[182].shortname := ce_string ("mmd")
			option_inst.options[182].flags := (1_026).to_natural_32
			option_inst.options[182].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mmd)
			option_inst.options[182].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[182].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1_000)
			option_inst.options[182].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[182].scriptID := 0
			option_inst.options[183].fullname := ce_string ("maxmem")
			option_inst.options[183].shortname := ce_string ("mm")
			option_inst.options[183].flags := (1_026).to_natural_32
			option_inst.options[183].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mm)
			option_inst.options[183].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[183].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 5_120)
			option_inst.options[183].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[183].scriptID := 0
			option_inst.options[184].fullname := ce_string ("maxmempattern")
			option_inst.options[184].shortname := ce_string ("mmp")
			option_inst.options[184].flags := (1_026).to_natural_32
			option_inst.options[184].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mmp)
			option_inst.options[184].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[184].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1_000)
			option_inst.options[184].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[184].scriptID := 0
			option_inst.options[185].fullname := ce_string ("maxmemtot")
			option_inst.options[185].shortname := ce_string ("mmt")
			option_inst.options[185].flags := (1_026).to_natural_32
			option_inst.options[185].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mmt)
			option_inst.options[185].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[185].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 10_240)
			option_inst.options[185].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[185].scriptID := 0
			option_inst.options[186].fullname := ce_string ("menuitems")
			option_inst.options[186].shortname := ce_string ("mis")
			option_inst.options[186].flags := (1_026).to_natural_32
			option_inst.options[186].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mis)
			option_inst.options[186].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[186].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 25)
			option_inst.options[186].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[186].scriptID := 0
			option_inst.options[187].fullname := ce_string ("mesg")
			option_inst.options[187].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[187].flags := (1_025).to_natural_32
			option_inst.options[187].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[187].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[187].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[187].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[187].scriptID := 0
			option_inst.options[188].fullname := ce_string ("mkspellmem")
			option_inst.options[188].shortname := ce_string ("msm")
			option_inst.options[188].flags := (263_188).to_natural_32
			option_inst.options[188].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_msm)
			option_inst.options[188].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[188].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("460000,2000,500"))
			option_inst.options[188].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[188].scriptID := 0
			option_inst.options[189].fullname := ce_string ("modeline")
			option_inst.options[189].shortname := ce_string ("ml")
			option_inst.options[189].flags := (2_049).to_natural_32
			option_inst.options[189].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_ml)
			option_inst.options[189].indir := (16_429).to_natural_32
			option_inst.options[189].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[189].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[189].scriptID := 0
			option_inst.options[190].fullname := ce_string ("modelines")
			option_inst.options[190].shortname := ce_string ("mls")
			option_inst.options[190].flags := (1_026).to_natural_32
			option_inst.options[190].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mls)
			option_inst.options[190].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[190].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 5)
			option_inst.options[190].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[190].scriptID := 0
			option_inst.options[191].fullname := ce_string ("modifiable")
			option_inst.options[191].shortname := ce_string ("ma")
			option_inst.options[191].flags := (1_049_601).to_natural_32
			option_inst.options[191].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_ma)
			option_inst.options[191].indir := (16_428).to_natural_32
			option_inst.options[191].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[191].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[191].scriptID := 0
			option_inst.options[192].fullname := ce_string ("modified")
			option_inst.options[192].shortname := ce_string ("mod")
			option_inst.options[192].flags := (5_633).to_natural_32
			option_inst.options[192].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mod)
			option_inst.options[192].indir := (16_430).to_natural_32
			option_inst.options[192].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[192].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[192].scriptID := 0
			option_inst.options[193].fullname := ce_string ("more")
			option_inst.options[193].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[193].flags := (2_049).to_natural_32
			option_inst.options[193].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_more)
			option_inst.options[193].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[193].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[193].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[193].scriptID := 0
			option_inst.options[194].fullname := ce_string ("mouse")
			option_inst.options[194].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[194].flags := (132_100).to_natural_32
			option_inst.options[194].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mouse)
			option_inst.options[194].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[194].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			option_inst.options[194].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[194].scriptID := 0
			option_inst.options[195].fullname := ce_string ("mousefocus")
			option_inst.options[195].shortname := ce_string ("mousef")
			option_inst.options[195].flags := (1_025).to_natural_32
			option_inst.options[195].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mousef)
			option_inst.options[195].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[195].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[195].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[195].scriptID := 0
			option_inst.options[196].fullname := ce_string ("mousehide")
			option_inst.options[196].shortname := ce_string ("mh")
			option_inst.options[196].flags := (1_025).to_natural_32
			option_inst.options[196].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mh)
			option_inst.options[196].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[196].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 1)
			option_inst.options[196].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[196].scriptID := 0
			option_inst.options[197].fullname := ce_string ("mousemodel")
			option_inst.options[197].shortname := ce_string ("mousem")
			option_inst.options[197].flags := (1_028).to_natural_32
			option_inst.options[197].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mousem)
			option_inst.options[197].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[197].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("extend"))
			option_inst.options[197].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[197].scriptID := 0
			option_inst.options[198].fullname := ce_string ("mouseshape")
			option_inst.options[198].shortname := ce_string ("mouses")
			option_inst.options[198].flags := (99_332).to_natural_32
			option_inst.options[198].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mouseshape)
			option_inst.options[198].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[198].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("i-r:beam,s:updown,sd:udsizing,vs:leftright,vd:lrsizing,m:no,ml:up-arrow,v:rightup-arrow"))
			option_inst.options[198].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[198].scriptID := 0
			option_inst.options[199].fullname := ce_string ("mousetime")
			option_inst.options[199].shortname := ce_string ("mouset")
			option_inst.options[199].flags := (1_026).to_natural_32
			option_inst.options[199].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_mouset)
			option_inst.options[199].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[199].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 500)
			option_inst.options[199].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[199].scriptID := 0
			option_inst.options[200].fullname := ce_string ("mzquantum")
			option_inst.options[200].shortname := ce_string ("mzq")
			option_inst.options[200].flags := (2).to_natural_32
			option_inst.options[200].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[200].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[200].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 100)
			option_inst.options[200].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 100)
			option_inst.options[200].scriptID := 0
			option_inst.options[201].fullname := ce_string ("novice")
			option_inst.options[201].shortname := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			option_inst.options[201].flags := (1_025).to_natural_32
			option_inst.options[201].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[201].indir := {PC_IDOPT_T}.PV_NONE
			option_inst.options[201].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[201].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[201].scriptID := 0
			option_inst.options[202].fullname := ce_string ("nrformats")
			option_inst.options[202].shortname := ce_string ("nf")
			option_inst.options[202].flags := (99_340).to_natural_32
			option_inst.options[202].var := create {CE_POINTER [NATURAL_8]}.make_cast (option_inst.p_nf)
			option_inst.options[202].indir := (16_432).to_natural_32
			option_inst.options[202].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("octal,hex"))
			option_inst.options[202].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[202].scriptID := 0
			option_inst.options[203].fullname := ce_string ("number")
			option_inst.options[203].shortname := ce_string ("nu")
			option_inst.options[203].flags := (9_217).to_natural_32
			option_inst.options[203].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[203].indir := (8_206).to_natural_32
			option_inst.options[203].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[203].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			option_inst.options[203].scriptID := 0
			option_inst.options[204].fullname := ce_string ("numberwidth")
			option_inst.options[204].shortname := ce_string ("nuw")
			option_inst.options[204].flags := (10_242).to_natural_32
			option_inst.options[204].var := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + -1)
			option_inst.options[204].indir := (8_208).to_natural_32
			option_inst.options[204].def_val[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 8)
			option_inst.options[204].def_val[1] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer + 4)
			option_inst.options[204].scriptID := 0
			option_inst.options[205].fullname := ce_string ("omnifunc")
			option_inst.options[205].shortname := ce_string ("ofu")
			option_inst.options[205].flags := (263_180).to_natural_32
		end

end
