class
	P_GUI_BEVAL

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create result___1.make
		end

feature {ANY} -- attributes

	recursive___11: INTEGER_32 assign set_recursive___11

	set_recursive___11 (a_recursive___11: INTEGER_32)
		do
			recursive___11 := a_recursive___11
		end

	result___1: CE_POINTER [NATURAL_8] assign set_result___1

	set_result___1 (a_result___1: CE_POINTER [NATURAL_8])
		do
			result___1 := a_result___1
		end

feature {ANY} -- routines

	addEventHandler (a_target: CE_POINTER [SD_GTKWIDGET]; a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast (a_target), ce_string ("event"), (target_event_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_beval), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				if not (gui_inst.gui.item.mainwin).is_void then
					if (gtk_widget_is_ancestor (a_target, gui_inst.gui.item.mainwin)).to_boolean then
						gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast (gui_inst.gui.item.mainwin), ce_string ("event"), (mainwin_event_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_cast (a_beval), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
					end
				end
			end
		end

	balloon_expose_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENTEXPOSE]; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			gtk_paint_flat_box (a_widget.item.style, a_widget.item.window, {SC_GTKSTATETYPE}.GTK_STATE_NORMAL, {SC_GTKSHADOWTYPE}.GTK_SHADOW_OUT, (create {CE_POINTER [SD_GDKRECTANGLE]}.make_shared (a_event.c_pointer + (create {SD_GDKEVENTEXPOSE}.make).offset_of ("area"))), a_widget, ce_string ("tooltip"), 0, 0, -1, -1)
			Result := 0
		end

	balloon_expose_event_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent balloon_expose_event_cb)
		end

	cancelBalloon (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			if a_beval.item.showState = {NATURAL_32} 3 then
				undrawBalloon (a_beval)
			elseif a_beval.item.showState = {NATURAL_32} 2 then
				undrawBalloon (a_beval)
			end
			if a_beval.item.timerID /= {NATURAL_32} 0 then
				gtk_timeout_remove (a_beval.item.timerID)
				a_beval.item.timerID := {NATURAL_32} 0
			end
			a_beval.item.showState := {PC_BESTATE}.ShS_NEUTRAL
		end

	createBalloonEvalWindow (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			a_beval.item.balloonShell := gtk_window_new ({SC_GTKWINDOWTYPE}.GTK_WINDOW_POPUP)
			gtk_widget_set_app_paintable (a_beval.item.balloonShell, 1)
			gtk_window_set_policy (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonShell), (gtk_window_get_type)))), 0, 0, 1)
			gtk_widget_set_name (a_beval.item.balloonShell, ce_string ("gtk-tooltips"))
			gtk_container_set_border_width (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonShell), (gtk_container_get_type)))), (4).to_natural_32)
			gtk_signal_connect_full (create {CE_POINTER [SD_GTKOBJECT]}.make_cast (a_beval.item.balloonShell), ce_string ("expose_event"), (balloon_expose_event_cb_address), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), 0, 0).do_nothing
			a_beval.item.balloonLabel := gtk_label_new (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
			gtk_label_set_line_wrap (create {CE_POINTER [SD_GTKLABEL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonLabel), (gtk_label_get_type)))), 0)
			gtk_label_set_justify (create {CE_POINTER [SD_GTKLABEL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonLabel), (gtk_label_get_type)))), {SC_GTKJUSTIFICATION}.GTK_JUSTIFY_LEFT)
			gtk_misc_set_alignment (create {CE_POINTER [SD_GTKMISC]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonLabel), (gtk_misc_get_type)))), {REAL_32} 0.5, {REAL_32} 0.5)
			gtk_widget_set_name (a_beval.item.balloonLabel, ce_string ("vim-balloon-label"))
			gtk_widget_show (a_beval.item.balloonLabel)
			gtk_container_add (create {CE_POINTER [SD_GTKCONTAINER]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonShell), (gtk_container_get_type)))), a_beval.item.balloonLabel)
		end

	drawBalloon (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		local
			l_requisition: CE_ARRAY [SD_GTKREQUISITION]
			l_screen_w: INTEGER_32
			l_screen_h: INTEGER_32
			l_x___0: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_x_offset: INTEGER_32
			l_y_offset: INTEGER_32
			l_layout: CE_POINTER [ANY]
			l_screen: CE_POINTER [SD_GDKSCREEN]
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
		do
			create l_requisition.make (<<1>>)
			create l_x___0.make (<<1>>)
			create l_y.make (<<1>>)
			create l_layout.make
			create l_screen.make

			if not (a_beval.item.msg).is_void then
				l_x_offset := 15
				l_y_offset := 10
				l_screen := gtk_widget_get_screen (a_beval.item.target)
				gtk_window_set_screen (create {CE_POINTER [SD_GTKWINDOW]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonShell), (gtk_window_get_type)))), l_screen)
				l_screen_w := gdk_screen_get_width (l_screen)
				l_screen_h := gdk_screen_get_height (l_screen)
				gtk_widget_ensure_style (a_beval.item.balloonShell)
				gtk_widget_ensure_style (a_beval.item.balloonLabel)
				set_printable_label_text (create {CE_POINTER [SD_GTKLABEL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonLabel), (gtk_label_get_type)))), a_beval.item.msg)
				l_layout := gtk_label_get_layout (create {CE_POINTER [SD_GTKLABEL]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_beval.item.balloonLabel), (gtk_label_get_type)))))
				pango_layout_set_wrap (l_layout, {SC_PANGOWRAPMODE}.PANGO_WRAP_WORD)
				if 20 > l_screen_w - 20 then
					l_tmp___9 := 20
				else
					l_tmp___9 := l_screen_w - 20
				end
				if gui_inst.gui.item.num_cols * gui_inst.gui.item.char_width > l_tmp___9 then
					if 20 > l_screen_w - 20 then
						l_tmp___6 := 20
					else
						l_tmp___6 := l_screen_w - 20
					end
					l_tmp___8 := l_tmp___6
				else
					if gui_inst.gui.item.num_cols * gui_inst.gui.item.char_width < l_screen_w // 2 then
						l_tmp___7 := l_screen_w // 2
					else
						l_tmp___7 := gui_inst.gui.item.num_cols * gui_inst.gui.item.char_width
					end
					l_tmp___8 := l_tmp___7
				end
				pango_layout_set_width (l_layout, 1_024 * l_tmp___8)
				gtk_widget_size_request (a_beval.item.balloonShell, l_requisition)
				gdk_window_get_origin ((a_beval.item.target).item.window, l_x___0, l_y).do_nothing
				l_x___0.item := l_x___0.item + (a_beval.item.x)
				l_y.item := l_y.item + (a_beval.item.y)
				if (l_x___0.item + l_x_offset) + l_requisition.item.width > l_screen_w then
					l_y_offset := l_y_offset + (15)
				end
				if (l_y.item + l_y_offset) + l_requisition.item.height > l_screen_h then
					l_y_offset := -l_requisition.item.height - 10
				end
				if 0 > l_screen_w - l_requisition.item.width then
					l_tmp___13 := 0
				else
					l_tmp___13 := l_screen_w - l_requisition.item.width
				end
				if l_x___0.item + l_x_offset > l_tmp___13 then
					if 0 > l_screen_w - l_requisition.item.width then
						l_tmp___11 := 0
					else
						l_tmp___11 := l_screen_w - l_requisition.item.width
					end
					l_x___0.item := l_tmp___11
				else
					if l_x___0.item + l_x_offset < 0 then
						l_tmp___12 := 0
					else
						l_tmp___12 := l_x___0.item + l_x_offset
					end
					l_x___0.item := l_tmp___12
				end
				if 0 > l_screen_h - l_requisition.item.height then
					l_tmp___17 := 0
				else
					l_tmp___17 := l_screen_h - l_requisition.item.height
				end
				if l_y.item + l_y_offset > l_tmp___17 then
					if 0 > l_screen_h - l_requisition.item.height then
						l_tmp___15 := 0
					else
						l_tmp___15 := l_screen_h - l_requisition.item.height
					end
					l_y.item := l_tmp___15
				else
					if l_y.item + l_y_offset < 0 then
						l_tmp___16 := 0
					else
						l_tmp___16 := l_y.item + l_y_offset
					end
					l_y.item := l_tmp___16
				end
				gtk_widget_set_uposition (a_beval.item.balloonShell, l_x___0.item, l_y.item)
				gtk_widget_show (a_beval.item.balloonShell)
				a_beval.item.showState := {PC_BESTATE}.ShS_SHOWING
			end
		end

	general_beval_cb (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]; a_state: INTEGER_32)
		local
			l_wp___0: CE_ARRAY [CE_POINTER [PD_WINDOW_S]]
			l_col: CE_ARRAY [INTEGER_32]
			l_use_sandbox: INTEGER_32
			l_lnum: CE_ARRAY [INTEGER_32]
			l_text: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_winnr: INTEGER_32
			l_bexpr: CE_POINTER [NATURAL_8]
			l_save_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_cw: CE_POINTER [PD_WINDOW_S]
			l_tmp: INTEGER_32
			js: JUMP_STATE
		do
			create l_wp___0.make (<<1>>)
			create l_col.make (<<1>>)
			create l_lnum.make (<<1>>)
			create l_text.make (<<1>>)
			create l_bexpr.make
			create l_save_curbuf.make
			create l_cw.make

			l_winnr := 0
			if not (option_inst.p_beval.item).to_boolean then
				js.return
			elseif globals_inst.balloonEval.is_void then
				js.return
			elseif globals_inst.msg_scrolled > 0 then
				js.return
			end
			if not js.return_called and then (recursive___11.to_boolean) then
				js.return
			end
			if not js.return_called then
				recursive___11 := 1
				if (get_beval_info (globals_inst.balloonEval, 1, l_wp___0, l_lnum, l_text, l_col)) = 1 then
					if (((l_wp___0.item.item.w_buffer).item.b_p_bexpr).item).to_integer_32 = 0 then
						l_bexpr := option_inst.p_bexpr.item
					else
						l_bexpr := (l_wp___0.item.item.w_buffer).item.b_p_bexpr
					end
					if (l_bexpr.item).to_integer_32 /= 0 then
						l_cw := globals_inst.firstwin
						from
						until
							l_cw.is_equal (l_wp___0.item)
						loop
							l_winnr := l_winnr + 1
							l_cw := l_cw.item.w_next
						end
						eval_inst.set_vim_var_nr (39, ((l_wp___0.item.item.w_buffer).item.b_fnum).to_integer_32)
						eval_inst.set_vim_var_nr (40, l_winnr)
						eval_inst.set_vim_var_nr (41, l_lnum.item)
						eval_inst.set_vim_var_nr (42, (l_col.item + 1).to_integer_32)
						eval_inst.set_vim_var_string (43, l_text.item, -1)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_text.item))
						l_save_curbuf := globals_inst.curbuf
						globals_inst.curbuf := l_wp___0.item.item.w_buffer
						if ((globals_inst.curbuf.item.b_p_bexpr).item).to_integer_32 = 0 then
							l_tmp := 0
						else
							l_tmp := 4
						end
						l_use_sandbox := option_inst.was_set_insecurely (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("balloonexpr")), l_tmp)
						globals_inst.curbuf := l_save_curbuf
						if l_use_sandbox.to_boolean then
							globals_inst.sandbox := globals_inst.sandbox + 1
						end
						globals_inst.textlock := globals_inst.textlock + 1
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (result___1))
						result___1 := eval_inst.eval_to_string (l_bexpr, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 1)
						if l_use_sandbox.to_boolean then
							globals_inst.sandbox := globals_inst.sandbox - 1
						end
						globals_inst.textlock := globals_inst.textlock - 1
						eval_inst.set_vim_var_string (43, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
						if not result___1.is_void then
							if (result___1[0]).to_integer_32 /= 0 then
								gui_mch_post_balloon (a_beval, result___1)
								recursive___11 := 0
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				if ((globals_inst.bevalServers).bit_and (1)).to_boolean then
					netbeans_inst.netbeans_beval_cb (a_beval, a_state)
				end
				recursive___11 := 0
			end
		end

	general_beval_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent general_beval_cb)
		end

	get_beval_info (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]; a_getword: INTEGER_32; a_winp: CE_POINTER [CE_POINTER [PD_WINDOW_S]]; a_lnump: CE_POINTER [INTEGER_32]; a_textp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_colp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_row: CE_ARRAY [INTEGER_32]
			l_col: CE_ARRAY [INTEGER_32]
			l_lbuf: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_lnum: CE_ARRAY [INTEGER_32]
			l_len: INTEGER_32
			l_spos: CE_POINTER [PD_POS_T]
			l_epos: CE_POINTER [PD_POS_T]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_wp___0.make
			create l_row.make (<<1>>)
			create l_col.make (<<1>>)
			create l_lbuf.make (<<1>>)
			create l_lnum.make (<<1>>)
			create l_spos.make
			create l_epos.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_textp.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_row.item := (a_beval.item.y - gui_inst.gui.item.border_offset) // gui_inst.gui.item.char_height
					l_col.item := (a_beval.item.x - gui_inst.gui.item.border_offset) // gui_inst.gui.item.char_width
					l_wp___0 := ui_inst.mouse_find_win (l_row, l_col)
					if l_wp___0.is_void then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						if not (l_row.item < l_wp___0.item.w_height) then
							l_pos := -1 + 11 -- skip if block
						end
				when 2 then -- if:
						if not (l_col.item < l_wp___0.item.w_width) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if (ui_inst.mouse_comp_pos (l_wp___0, l_row, l_col, l_lnum)).to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						l_lbuf.item := memline_inst.ml_get_buf (l_wp___0.item.w_buffer, l_lnum.item, 0)
						if not (l_col.item <= (charset_inst.win_linetabsize (l_wp___0, l_lbuf.item, (2_147_483_647).to_integer_32))) then
							l_pos := -1 + 11 -- skip if block
						end
				when 5 then -- if:
						if not (a_getword.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 6 then -- if:
						l_spos := create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer)
						l_epos := create {CE_POINTER [PD_POS_T]}.make_shared (default_pointer)
						if globals_inst.VIsual_active.to_boolean then
							if globals_inst.VIsual.item.lnum /= globals_inst.curwin.item.w_cursor.lnum then
								l_tmp___0 := (globals_inst.VIsual.item.lnum < globals_inst.curwin.item.w_cursor.lnum).to_integer
							else
								if globals_inst.VIsual.item.col /= globals_inst.curwin.item.w_cursor.col then
									l_tmp := (globals_inst.VIsual.item.col < globals_inst.curwin.item.w_cursor.col).to_integer
								else
									l_tmp := (globals_inst.VIsual.item.coladd < globals_inst.curwin.item.w_cursor.coladd).to_integer
								end
								l_tmp___0 := l_tmp
							end
							if l_tmp___0.to_boolean then
								l_spos := globals_inst.VIsual
								l_epos := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
							else
								l_spos := create {CE_POINTER [PD_POS_T]}.make_shared (globals_inst.curwin.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
								l_epos := globals_inst.VIsual
							end
						end
						l_col.item := (ui_inst.vcol2col (l_wp___0, l_lnum.item, l_col.item)) - 1
						if not (globals_inst.VIsual_active.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if (l_wp___0.item.w_buffer).is_equal (globals_inst.curwin.item.w_buffer) then
							if l_lnum.item = l_spos.item.lnum then
								l_tmp___2 := (l_col.item >= l_spos.item.col).to_integer
							else
								l_tmp___2 := (l_lnum.item > l_spos.item.lnum).to_integer
							end
							if l_tmp___2.to_boolean then
								if l_lnum.item = l_epos.item.lnum then
									l_tmp___3 := (l_col.item <= l_epos.item.col).to_integer
								else
									l_tmp___3 := (l_lnum.item < l_epos.item.lnum).to_integer
								end
								if l_tmp___3.to_boolean then
									if l_spos.item.lnum /= l_epos.item.lnum then
										Result := 0
										js.return
									elseif l_spos.item.col = l_epos.item.col then
										Result := 0
										js.return
									end
									if not js.return_called then
										l_lbuf.item := memline_inst.ml_get_buf (globals_inst.curwin.item.w_buffer, globals_inst.VIsual.item.lnum, 0)
										l_lbuf.item := misc2_inst.vim_strnsave (l_lbuf.item + l_spos.item.col, (l_epos.item.col - l_spos.item.col) + ((option_inst.p_sel.item.item).to_integer_32 /= 101).to_integer)
										l_lnum.item := l_spos.item.lnum
										l_col.item := l_spos.item.col
									end
								else
									l_pos := -1 + 9 -- goto _L___1
								end
							else
								l_pos := -1 + 9 -- goto _L___1
							end
						else
							l_pos := -1 + 9 -- goto _L___1
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L___1:
						globals_inst.emsg_off := globals_inst.emsg_off + 1
						l_len := normal_inst.find_ident_at_pos (l_wp___0, l_lnum.item, l_col.item, l_lbuf, 7)
						globals_inst.emsg_off := globals_inst.emsg_off - 1
						if l_len = 0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_lbuf.item := misc2_inst.vim_strnsave (l_lbuf.item, l_len)
						end
				when 10 then -- if done
						if not js.return_called then
							a_winp.item := l_wp___0
							a_lnump.item := l_lnum.item
							a_textp.item := l_lbuf.item
							a_colp.item := l_col.item
							a_beval.item.ts := ((l_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
							Result := 1
							js.return
						end
				when 11 then -- if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gui_mch_create_beval_area (a_target: CE_POINTER [ANY]; a_mesg: CE_POINTER [NATURAL_8]; a_mesgCB: CE_ROUTINE; a_clientData: CE_POINTER [ANY]): CE_POINTER [PD_BALLOONEVALSTRUCT]
		local
			l_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]
			js: JUMP_STATE
		do
			create l_beval.make

			if not a_mesg.is_void then
				if not a_mesgCB.is_void then
					message_inst.emsg (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E232: Cannot create BalloonEval with both message and callback"))))).do_nothing
					Result := (create {CE_POINTER [PD_BALLOONEVALSTRUCT]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				l_beval := create {CE_POINTER [PD_BALLOONEVALSTRUCT]}.make_cast ((misc2_inst.alloc ((create {PD_BALLOONEVALSTRUCT}.make).structure_size.to_natural_32)))
				if not l_beval.is_void then
					l_beval.item.target := create {CE_POINTER [SD_GTKWIDGET]}.make_cast ((g_type_check_instance_cast (create {CE_POINTER [SD_GTYPEINSTANCE]}.make_cast (a_target), (gtk_widget_get_type))))
					l_beval.item.balloonShell := create {CE_POINTER [SD_GTKWIDGET]}.make_shared (default_pointer)
					l_beval.item.timerID := {NATURAL_32} 0
					l_beval.item.showState := {PC_BESTATE}.ShS_NEUTRAL
					l_beval.item.x := 0
					l_beval.item.y := 0
					l_beval.item.msg := a_mesg
					l_beval.item.msgCB := a_mesgCB
					l_beval.item.clientData := a_clientData
					addEventHandler (l_beval.item.target, l_beval)
					createBalloonEvalWindow (l_beval)
				end
				Result := l_beval
			end
		end

	gui_mch_disable_beval_area (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			if not a_beval.is_void then
				removeEventHandler (a_beval)
			end
		end

	gui_mch_enable_beval_area (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			if not a_beval.is_void then
				addEventHandler (a_beval.item.target, a_beval)
			end
		end

	gui_mch_post_balloon (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]; a_mesg: CE_POINTER [NATURAL_8])
		do
			a_beval.item.msg := a_mesg
			if not a_mesg.is_void then
				drawBalloon (a_beval)
			else
				undrawBalloon (a_beval)
			end
		end

	key_event (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]; a_keyval: NATURAL_32; a_is_keypress: INTEGER_32)
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_beval.item.showState /= {NATURAL_32} 3 then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (a_beval.item.msgCB).is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						inspect a_keyval.to_integer_32 -- switch 1 head
						when 65505 then l_pos := -1 + 3
						when 65506 then l_pos := -1 + 3
						when 65507 then l_pos := -1 + 4
						when 65508 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 3 then -- switch 1, case 65505 | switch 1, case 65506
						a_beval.item.showState := {PC_BESTATE}.ShS_UPDATE_PENDING
						if a_is_keypress.to_boolean then
							l_tmp := 1
						else
							l_tmp := 0
						end
						(a_beval.item.msgCB).call ([a_beval, l_tmp])
						l_pos := -1 + 6 -- switch 1; break
				when 4 then -- switch 1, case 65507 | switch 1, case 65508
						a_beval.item.showState := {PC_BESTATE}.ShS_UPDATE_PENDING
						if a_is_keypress.to_boolean then
							l_tmp___0 := 4
						else
							l_tmp___0 := 0
						end
						(a_beval.item.msgCB).call ([a_beval, l_tmp___0])
						l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
						if a_is_keypress.to_boolean then
							cancelBalloon (a_beval)
						end
						l_pos := -1 + 6 -- switch 1; break
				when 6 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						cancelBalloon (a_beval)
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						cancelBalloon (a_beval)
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mainwin_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENT]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]
			l_pos: INTEGER_32
		do
			create l_beval.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_beval := create {CE_POINTER [PD_BALLOONEVALSTRUCT]}.make_cast (a_data)
					inspect a_event.item.type -- switch 1 head
					when 8 then l_pos := -1 + 1
					when 9 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 8
					key_event (l_beval, a_event.item.key.keyval, 1)
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 9
					key_event (l_beval, a_event.item.key.keyval, 0)
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, default:
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					Result := 0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mainwin_event_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent mainwin_event_cb)
		end

	pointer_event (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]; a_x___0: INTEGER_32; a_y: INTEGER_32; a_state: NATURAL_32)
		local
			l_distance: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			if a_x___0 - a_beval.item.x < 0 then
				l_tmp := -(a_x___0 - a_beval.item.x)
			else
				l_tmp := a_x___0 - a_beval.item.x
			end
			if a_y - a_beval.item.y < 0 then
				l_tmp___0 := -(a_y - a_beval.item.y)
			else
				l_tmp___0 := a_y - a_beval.item.y
			end
			l_distance := l_tmp + l_tmp___0
			if l_distance > 4 then
				a_beval.item.state := a_state
				cancelBalloon (a_beval)
				if not ((a_state).bit_and ({NATURAL_32} 1_792)).to_boolean then
					a_beval.item.x := a_x___0
					a_beval.item.y := a_y
					if ((a_state).bit_and ({NATURAL_32} 8)).to_boolean then
						if not (a_beval.item.msgCB).is_void then
							a_beval.item.showState := {PC_BESTATE}.ShS_PENDING;
							(a_beval.item.msgCB).call ([a_beval, a_state.to_integer_32])
						end
					else
						a_beval.item.timerID := gtk_timeout_add ((option_inst.p_bdlay.item).to_natural_32, timeout_cb_address, create {CE_POINTER [ANY]}.make_cast (a_beval))
					end
				end
			end
		end

	removeEventHandler (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			gtk_signal_compat_matched (create {CE_POINTER [SD_GTKOBJECT]}.make_cast (a_beval.item.target), (target_event_cb_address), create {CE_POINTER [ANY]}.make_cast (a_beval), (24).to_natural_32, (0).to_natural_32)
			if globals_inst.gtk_socket_id = {NATURAL_32} 0 then
				if not (gui_inst.gui.item.mainwin).is_void then
					if (gtk_widget_is_ancestor (a_beval.item.target, gui_inst.gui.item.mainwin)).to_boolean then
						gtk_signal_compat_matched (create {CE_POINTER [SD_GTKOBJECT]}.make_cast (gui_inst.gui.item.mainwin), (mainwin_event_cb_address), create {CE_POINTER [ANY]}.make_cast (a_beval), (24).to_natural_32, (0).to_natural_32)
					end
				end
			end
		end

	requestBalloon (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			if a_beval.item.showState /= {NATURAL_32} 1 then
				if not (a_beval.item.msgCB).is_void then
					a_beval.item.showState := {PC_BESTATE}.ShS_PENDING;
					(a_beval.item.msgCB).call ([a_beval, (a_beval.item.state).to_integer_32])
				elseif not (a_beval.item.msg).is_void then
					drawBalloon (a_beval)
				end
			end
		end

	set_printable_label_text (a_label: CE_POINTER [SD_GTKLABEL]; a_text: CE_POINTER [NATURAL_8])
		local
			l_text: CE_POINTER [NATURAL_8]
			l_convbuf: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_pdest: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_charlen: INTEGER_32
			l_uc: INTEGER_32
			l_attr_list: CE_POINTER [ANY]
			l_tmp: INTEGER_32
			l_aep: CE_POINTER [PD_ATTR_ENTRY]
			l_attr: CE_POINTER [SD_PANGOATTRIBUTE]
			l_pixel: INTEGER_32
			l_color: CE_ARRAY [SD_GDKCOLOR]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_outlen: INTEGER_32
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_text.make
			create l_convbuf.make
			create l_buf___6.make
			create l_p___0.make
			create l_pdest.make
			create l_attr_list.make
			create l_aep.make
			create l_attr.make
			create l_color.make (<<1>>)
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___6.make
			create l_tmp___7.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_text := a_text
					l_convbuf := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if globals_inst.output_conv.item.vc_type /= 0 then
						l_convbuf := mbyte_inst.string_convert (globals_inst.output_conv, l_text, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						if not l_convbuf.is_void then
							l_text := l_convbuf
						end
					end
					l_len := {NATURAL_32} 0
					l_p___0 := l_text
				when 1 then -- loop condition:
					if (l_p___0.item).to_integer_32 = 0 then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						if (((l_p___0.item).to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						l_charlen := 1
						if not ((l_p___0.item).to_integer_32 < 32) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0.item).to_integer_32 /= 9 then
							if (l_p___0.item).to_integer_32 /= 10 then
								l_tmp := 2
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 = 127 then
							l_tmp := 2
						else
							l_tmp := 1
						end
				when 7 then
						l_len := l_len + l_tmp.to_natural_32
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_charlen := mbyte_inst.utf_ptr2len (l_p___0)
						l_uc := mbyte_inst.utf_ptr2char (l_p___0)
						if l_charlen /= (mbyte_inst.utf_char2len (l_uc)) then
							l_charlen := 1
						end
						if l_charlen = 1 then
							l_len := l_len + ({NATURAL_32} 4)
						elseif l_uc < 160 then
							l_len := l_len + ({NATURAL_32} 4)
						elseif (mbyte_inst.utf_printable (l_uc)).to_boolean then
							l_len := l_len + l_charlen.to_natural_32
						else
							l_len := l_len + ({NATURAL_32} 6)
						end
				when 10 then -- if done
						l_p___0 := l_p___0 + l_charlen
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					l_attr_list := pango_attr_list_new
					l_buf___6 := misc2_inst.alloc (l_len + {NATURAL_32} 1)
					if l_buf___6.is_void then
						l_pos := -1 + 36 -- skip if block
					end
				when 12 then -- if:
						l_color.item.pixel := (0).to_natural_32
						l_color.item.red := (0).to_natural_16
						l_color.item.green := (0).to_natural_16
						l_color.item.blue := (0).to_natural_16
						l_aep := syntax_inst.syn_gui_attr2entry (globals_inst.highlight_attr[0])
						if not l_aep.is_void then
							l_pixel := l_aep.item.ae_u.gui.fg_color
						else
							l_pixel := (-11_111).to_integer_32
						end
						if l_pixel /= -11_111 then
							gdk_colormap_query_color ((gtk_widget_get_colormap (gui_inst.gui.item.drawarea)), l_pixel.to_natural_32, l_color)
						end
						l_pdest := l_buf___6
						l_p___0 := l_text
				when 13 then -- loop condition:
						if not (not js.loop_done and then ((l_p___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 35 -- skip loop
						end
				when 14 then -- loop body:
						if (((l_p___0.item).to_integer_32).bit_and (128)) /= 0 then
							l_pos := -1 + 20 -- skip if block
						end
				when 15 then -- if:
						if not ((l_p___0.item).to_integer_32 < 32) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (l_p___0.item).to_integer_32 /= 9 then
							if (l_p___0.item).to_integer_32 /= 10 then
								l_pos := -1 + 20 -- goto _L___3
							else
								l_pos := -1 + 18 -- goto _L___5
							end
						else
							l_pos := -1 + 18 -- goto _L___5
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else: | _L___5:
						if (l_p___0.item).to_integer_32 = 127 then
							l_pos := -1 + 20 -- goto _L___3
						else
							l_tmp___3 := l_pdest
							l_pdest := l_pdest + 1
							l_tmp___4 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___3.item := l_tmp___4.item
						end
				when 19 then -- if done | if block done, skip else block:
						l_pos := -1 + 34
				when 20 then -- else: | _L___3:
						l_charlen := mbyte_inst.utf_ptr2len (l_p___0)
						l_uc := mbyte_inst.utf_ptr2char (l_p___0)
						if l_charlen /= (mbyte_inst.utf_char2len (l_uc)) then
							l_charlen := 1
						end
						if l_charlen /= 1 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_pos := -1 + 29 -- goto _L___2
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 23 then -- else:
						if not (l_uc < 160) then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						l_pos := -1 + 29 -- goto _L___2
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 26 then -- else:
						if not ((mbyte_inst.utf_printable (l_uc)).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						from
						until
							js.loop_done
						loop
							l_tmp___6 := l_pdest
							l_pdest := l_pdest + 1
							l_tmp___7 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___6.item := l_tmp___7.item
							l_charlen := l_charlen - 1
							if l_charlen = 0 then
								js.break
							end
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 29 then -- else: | _L___2:
						if not ((((l_p___0.item).to_integer_32).bit_and (128)).to_boolean) then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						if l_charlen = 1 then
							charset_inst.transchar_hex (l_pdest, (l_p___0.item).to_integer_32)
							l_outlen := 4
						else
							l_pos := -1 + 32 -- goto _L___1
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else: | _L___1:
						if l_uc >= 128 then
							charset_inst.transchar_hex (l_pdest, l_uc)
							if l_uc < 256 then
								l_outlen := 4
							else
								l_outlen := 6
							end
						else
							charset_inst.transchar_nonprint (l_pdest, (l_p___0.item).to_integer_32)
							l_outlen := 2
						end
				when 33 then
						if l_pixel /= -11_111 then
							l_attr := pango_attr_foreground_new (l_color.item.red, l_color.item.green, l_color.item.blue)
							l_attr.item.start_index := (l_pdest.distance (l_buf___6)).to_natural_32
							l_attr.item.end_index := ((l_pdest.distance (l_buf___6)) + l_outlen).to_natural_32
							pango_attr_list_insert (l_attr_list, l_attr)
						end
						l_pdest := l_pdest + l_outlen
						l_p___0 := l_p___0 + l_charlen
				when 34 then -- if done | if done | if done
						l_pos := -1 + 13 -- back to loop condition
				when 35 then -- loop done
						l_pdest.item := (('%/0/').code).to_natural_8
				when 36 then -- if done
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_convbuf))
					gtk_label_set_text (a_label, create {CE_POINTER [INTEGER_8]}.make_cast (l_buf___6))
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_buf___6))
					gtk_label_set_attributes (a_label, l_attr_list)
					pango_attr_list_unref (l_attr_list)
				when 37 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	target_event_cb (a_widget: CE_POINTER [SD_GTKWIDGET]; a_event: CE_POINTER [SD_GDKEVENT]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]
			l_x___0: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
			l_state: CE_ARRAY [NATURAL_32]
			l_pos: INTEGER_32
		do
			create l_beval.make
			create l_x___0.make (<<1>>)
			create l_y.make (<<1>>)
			create l_state.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_beval := create {CE_POINTER [PD_BALLOONEVALSTRUCT]}.make_cast (a_data)
					inspect a_event.item.type -- switch 1 head
					when 10 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 11 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 31 then l_pos := -1 + 4
					when 8 then l_pos := -1 + 5
					when 9 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case 10
					pointer_event (l_beval, (a_event.item.crossing.x).truncated_to_integer, (a_event.item.crossing.y).truncated_to_integer, a_event.item.crossing.state)
					l_pos := -1 + 8 -- switch 1; break
				when 2 then -- switch 1, case 3
					if (a_event.item.motion.is_hint).to_boolean then
						gdk_window_get_pointer (a_widget.item.window, l_x___0, l_y, l_state).do_nothing
						pointer_event (l_beval, l_x___0.item, l_y.item, l_state.item)
					else
						pointer_event (l_beval, (a_event.item.motion.x).truncated_to_integer, (a_event.item.motion.y).truncated_to_integer, a_event.item.motion.state)
					end
					l_pos := -1 + 8 -- switch 1; break
				when 3 then -- switch 1, case 11
					if a_event.item.crossing.mode = {NATURAL_32} 0 then
						cancelBalloon (l_beval)
					end
					l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 4 | switch 1, case 31
					cancelBalloon (l_beval)
					l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 8
					key_event (l_beval, a_event.item.key.keyval, 1)
					l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 9
					key_event (l_beval, a_event.item.key.keyval, 0)
					l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
					l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
					Result := 0
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	target_event_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent target_event_cb)
		end

	timeout_cb (a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_beval: CE_POINTER [PD_BALLOONEVALSTRUCT]
		do
			create l_beval.make

			l_beval := create {CE_POINTER [PD_BALLOONEVALSTRUCT]}.make_cast (a_data)
			l_beval.item.timerID := {NATURAL_32} 0
			requestBalloon (l_beval)
			Result := 0
		end

	timeout_cb_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent timeout_cb)
		end

	undrawBalloon (a_beval: CE_POINTER [PD_BALLOONEVALSTRUCT])
		do
			if not (a_beval.item.balloonShell).is_void then
				gtk_widget_hide (a_beval.item.balloonShell)
			end
			a_beval.item.showState := {PC_BESTATE}.ShS_NEUTRAL
		end

end
