class
	SD_DATA3

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	b: CE_ARRAY [INTEGER_8]

	s: CE_ARRAY [INTEGER_16]

	l: CE_ARRAY [INTEGER_32]

feature {ANY}

	copy (a_other: like Current)
		do
			b := a_other.b.twin
			s := a_other.s.twin
			l := a_other.l.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b.is_equal (a_other.b) and
				s.is_equal (a_other.s) and
				l.is_equal (a_other.l)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b", <<20>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("s", <<10>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("l", <<5>>)
				>>)
			init_structure_info
		end

end
