class
	SD_GDKCOLOR

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	pixel: NATURAL_32 assign set_pixel

	red: NATURAL_16 assign set_red

	green: NATURAL_16 assign set_green

	blue: NATURAL_16 assign set_blue

feature {ANY} -- setters

	set_pixel (a_pixel: NATURAL_32)
		do
			pixel := a_pixel
			update_memory_field ("pixel")
		end

	set_red (a_red: NATURAL_16)
		do
			red := a_red
			update_memory_field ("red")
		end

	set_green (a_green: NATURAL_16)
		do
			green := a_green
			update_memory_field ("green")
		end

	set_blue (a_blue: NATURAL_16)
		do
			blue := a_blue
			update_memory_field ("blue")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pixel := a_other.pixel
			red := a_other.red
			green := a_other.green
			blue := a_other.blue
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pixel = a_other.pixel and
				red = a_other.red and
				green = a_other.green and
				blue = a_other.blue
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pixel"),
					create {CE_STRUCTURE_FIELD}.make ("red"),
					create {CE_STRUCTURE_FIELD}.make ("green"),
					create {CE_STRUCTURE_FIELD}.make ("blue")
				>>)
			init_structure_info
		end

end
