class
	SD_GTKIMAGEPIXMAPDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pixmap.make
		end

feature {ANY} -- fields

	pixmap: CE_POINTER [SD_GDKDRAWABLE] assign set_pixmap

feature {ANY} -- setters

	set_pixmap (a_pixmap: CE_POINTER [SD_GDKDRAWABLE])
		do
			pixmap := a_pixmap
			update_memory_field ("pixmap")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pixmap := a_other.pixmap
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pixmap.is_equal (a_other.pixmap)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pixmap")
				>>)
			init_structure_info
		end

end
