class
	SD_GTKITEM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create bin.make
		end

feature {ANY} -- fields

	bin: SD_GTKBIN assign set_bin

feature {ANY} -- setters

	set_bin (a_bin: SD_GTKBIN)
		do
			bin := a_bin
			update_memory_field ("bin")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			bin := a_other.bin.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				bin.is_equal (a_other.bin)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("bin")
				>>)
			init_structure_info
		end

end
