class
	SD_RLIMIT

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	rlim_cur: NATURAL_32 assign set_rlim_cur

	rlim_max: NATURAL_32 assign set_rlim_max

feature {ANY} -- setters

	set_rlim_cur (a_rlim_cur: NATURAL_32)
		do
			rlim_cur := a_rlim_cur
			update_memory_field ("rlim_cur")
		end

	set_rlim_max (a_rlim_max: NATURAL_32)
		do
			rlim_max := a_rlim_max
			update_memory_field ("rlim_max")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rlim_cur := a_other.rlim_cur
			rlim_max := a_other.rlim_max
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rlim_cur = a_other.rlim_cur and
				rlim_max = a_other.rlim_max
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rlim_cur"),
					create {CE_STRUCTURE_FIELD}.make ("rlim_max")
				>>)
			init_structure_info
		end

end
