deferred class
	S_SYS_STAT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	chmod (a___file: CE_POINTER [INTEGER_8]; a___mode: NATURAL_32): INTEGER_32
		do
			Result := c_chmod (a___file.c_pointer, a___mode)
		end

	c_chmod (a___file: POINTER; a___mode: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return chmod($a___file, $a___mode);"
		end

	fstat (a___fd: INTEGER_32; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_fstat (a___fd, a___buf.c_pointer)
		end

	c_fstat (a___fd: INTEGER_32; a___buf: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return fstat($a___fd, $a___buf);"
		end

	lstat (a___file: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_lstat (a___file.c_pointer, a___buf.c_pointer)
		end

	c_lstat (a___file: POINTER; a___buf: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return lstat($a___file, $a___buf);"
		end

	mkdir (a___path: CE_POINTER [INTEGER_8]; a___mode: NATURAL_32): INTEGER_32
		do
			Result := c_mkdir (a___path.c_pointer, a___mode)
		end

	c_mkdir (a___path: POINTER; a___mode: NATURAL_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return mkdir($a___path, $a___mode);"
		end

	stat (a___file: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_stat (a___file.c_pointer, a___buf.c_pointer)
		end

	c_stat (a___file: POINTER; a___buf: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return stat($a___file, $a___buf);"
		end

	umask (a___mask: NATURAL_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return umask($a___mask);"
		end

end
