deferred class
	S_X11_XUTIL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	XGetWMIconName (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [SD_XTEXTPROPERTY]): INTEGER_32
		do
			Result := c_XGetWMIconName (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer)
		end

	c_XGetWMIconName (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XGetWMIconName($a_arg1, $a_arg2, $a_arg3);"
		end

	XGetWMName (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [SD_XTEXTPROPERTY]): INTEGER_32
		do
			Result := c_XGetWMName (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer)
		end

	c_XGetWMName (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XGetWMName($a_arg1, $a_arg2, $a_arg3);"
		end

	XGetWMNormalHints (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [SD_XSIZEHINTS]; a_arg4: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_XGetWMNormalHints (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer)
		end

	c_XGetWMNormalHints (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XGetWMNormalHints($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XSetWMProperties (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [SD_XTEXTPROPERTY]; a_arg4: CE_POINTER [SD_XTEXTPROPERTY]; a_arg5: CE_POINTER [CE_POINTER [INTEGER_8]]; a_arg6: INTEGER_32; a_arg7: CE_POINTER [SD_XSIZEHINTS]; a_arg8: CE_POINTER [SD_XWMHINTS]; a_arg9: CE_POINTER [SD_XCLASSHINT])
		do
			c_XSetWMProperties (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6, a_arg7.c_pointer, a_arg8.c_pointer, a_arg9.c_pointer)
		end

	c_XSetWMProperties (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER; a_arg5: POINTER; a_arg6: INTEGER_32; a_arg7: POINTER; a_arg8: POINTER; a_arg9: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"XSetWMProperties($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

	XStringListToTextProperty (a_arg1: CE_POINTER [CE_POINTER [INTEGER_8]]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [SD_XTEXTPROPERTY]): INTEGER_32
		do
			Result := c_XStringListToTextProperty (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer)
		end

	c_XStringListToTextProperty (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XStringListToTextProperty($a_arg1, $a_arg2, $a_arg3);"
		end

	XmbTextListToTextProperty (a_display: CE_POINTER [ANY]; a_list: CE_POINTER [CE_POINTER [INTEGER_8]]; a_count: INTEGER_32; a_style: NATURAL_32; a_text_prop_return: CE_POINTER [SD_XTEXTPROPERTY]): INTEGER_32
		do
			Result := c_XmbTextListToTextProperty (a_display.c_pointer, a_list.c_pointer, a_count, a_style, a_text_prop_return.c_pointer)
		end

	c_XmbTextListToTextProperty (a_display: POINTER; a_list: POINTER; a_count: INTEGER_32; a_style: NATURAL_32; a_text_prop_return: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XmbTextListToTextProperty($a_display, $a_list, $a_count, $a_style, $a_text_prop_return);"
		end

	XmbTextPropertyToTextList (a_display: CE_POINTER [ANY]; a_text_prop: CE_POINTER [SD_XTEXTPROPERTY]; a_list_return: CE_POINTER [CE_POINTER [CE_POINTER [INTEGER_8]]]; a_count_return: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_XmbTextPropertyToTextList (a_display.c_pointer, a_text_prop.c_pointer, a_list_return.c_pointer, a_count_return.c_pointer)
		end

	c_XmbTextPropertyToTextList (a_display: POINTER; a_text_prop: POINTER; a_list_return: POINTER; a_count_return: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return XmbTextPropertyToTextList($a_display, $a_text_prop, $a_list_return, $a_count_return);"
		end

	Xutf8SetWMProperties (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [INTEGER_8]; a_arg4: CE_POINTER [INTEGER_8]; a_arg5: CE_POINTER [CE_POINTER [INTEGER_8]]; a_arg6: INTEGER_32; a_arg7: CE_POINTER [SD_XSIZEHINTS]; a_arg8: CE_POINTER [SD_XWMHINTS]; a_arg9: CE_POINTER [SD_XCLASSHINT])
		do
			c_Xutf8SetWMProperties (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6, a_arg7.c_pointer, a_arg8.c_pointer, a_arg9.c_pointer)
		end

	c_Xutf8SetWMProperties (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER; a_arg5: POINTER; a_arg6: INTEGER_32; a_arg7: POINTER; a_arg8: POINTER; a_arg9: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"Xutf8SetWMProperties($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

end
