class
	P_NONBLOCK

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	curlx_nonblock (a_sockfd: INTEGER_32; a_nonblock: INTEGER_32): INTEGER_32
		local
			l_flags: INTEGER_32
		do
			l_flags := fcntl ([a_sockfd, 3, 0])
			if 0 /= a_nonblock then
				Result := (fcntl ([a_sockfd, 4, (l_flags).bit_or (2_048)]))
			else
				Result := (fcntl ([a_sockfd, 4, (l_flags).bit_and (-2_049)]))
			end
		end

end
