class
	P_RAWSTR

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_raw_equal (a_first: CE_POINTER [INTEGER_8]; a_second: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_first: CE_POINTER [INTEGER_8]
			l_second: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_8
			l_tmp___1: INTEGER_8
			js: JUMP_STATE
		do
			create l_first.make
			create l_second.make

			l_first := a_first
			l_second := a_second
			from
			until
				js.loop_done
			loop
				if (l_first[0]).to_boolean then
					if not (l_second[0]).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_tmp := Curl_raw_toupper (l_first[0])
					if l_tmp.to_integer_32 /= (Curl_raw_toupper (l_second[0])).to_integer_32 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_first := l_first + 1
					l_second := l_second + 1
				end
			end
			l_tmp___1 := Curl_raw_toupper (l_first[0])
			Result := (l_tmp___1.to_integer_32 = (Curl_raw_toupper (l_second[0])).to_integer_32).to_integer
		end

	Curl_raw_nequal (a_first: CE_POINTER [INTEGER_8]; a_second: CE_POINTER [INTEGER_8]; a_max: NATURAL_32): INTEGER_32
		local
			l_first: CE_POINTER [INTEGER_8]
			l_second: CE_POINTER [INTEGER_8]
			l_max: NATURAL_32
			l_tmp: INTEGER_8
			l_tmp___1: INTEGER_8
			js: JUMP_STATE
		do
			create l_first.make
			create l_second.make

			l_first := a_first
			l_second := a_second
			l_max := a_max
			from
			until
				js.loop_done
			loop
				if (l_first[0]).to_boolean then
					if (l_second[0]).to_boolean then
						if not l_max.to_boolean then
							js.break
						end
					else
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_tmp := Curl_raw_toupper (l_first[0])
					if l_tmp.to_integer_32 /= (Curl_raw_toupper (l_second[0])).to_integer_32 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_max := l_max - 1
					l_first := l_first + 1
					l_second := l_second + 1
				end
			end
			if {NATURAL_32} 0 = l_max then
				Result := 1
				js.return
			end
			if not js.return_called then
				l_tmp___1 := Curl_raw_toupper (l_first[0])
				Result := (l_tmp___1.to_integer_32 = (Curl_raw_toupper (l_second[0])).to_integer_32).to_integer
			end
		end

	Curl_raw_toupper (a_in: INTEGER_8): INTEGER_8
		local
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_in.to_integer_32 -- switch 1 head
					when 97 then l_pos := -1 + 1
					when 98 then l_pos := -1 + 2
					when 99 then l_pos := -1 + 3
					when 100 then l_pos := -1 + 4
					when 101 then l_pos := -1 + 5
					when 102 then l_pos := -1 + 6
					when 103 then l_pos := -1 + 7
					when 104 then l_pos := -1 + 8
					when 105 then l_pos := -1 + 9
					when 106 then l_pos := -1 + 10
					when 107 then l_pos := -1 + 11
					when 108 then l_pos := -1 + 12
					when 109 then l_pos := -1 + 13
					when 110 then l_pos := -1 + 14
					when 111 then l_pos := -1 + 15
					when 112 then l_pos := -1 + 16
					when 113 then l_pos := -1 + 17
					when 114 then l_pos := -1 + 18
					when 115 then l_pos := -1 + 19
					when 116 then l_pos := -1 + 20
					when 117 then l_pos := -1 + 21
					when 118 then l_pos := -1 + 22
					when 119 then l_pos := -1 + 23
					when 120 then l_pos := -1 + 24
					when 121 then l_pos := -1 + 25
					when 122 then l_pos := -1 + 26
					else l_pos := -1 + 27
					end
				when 1 then -- switch 1, case 97
					Result := (('A').code).to_integer_8
					js.return
				when 2 then -- switch 1, case 98
					if not js.return_called then
						Result := (('B').code).to_integer_8
						js.return
					end
				when 3 then -- switch 1, case 99
					if not js.return_called then
						Result := (('C').code).to_integer_8
						js.return
					end
				when 4 then -- switch 1, case 100
					if not js.return_called then
						Result := (('D').code).to_integer_8
						js.return
					end
				when 5 then -- switch 1, case 101
					if not js.return_called then
						Result := (('E').code).to_integer_8
						js.return
					end
				when 6 then -- switch 1, case 102
					if not js.return_called then
						Result := (('F').code).to_integer_8
						js.return
					end
				when 7 then -- switch 1, case 103
					if not js.return_called then
						Result := (('G').code).to_integer_8
						js.return
					end
				when 8 then -- switch 1, case 104
					if not js.return_called then
						Result := (('H').code).to_integer_8
						js.return
					end
				when 9 then -- switch 1, case 105
					if not js.return_called then
						Result := (('I').code).to_integer_8
						js.return
					end
				when 10 then -- switch 1, case 106
					if not js.return_called then
						Result := (('J').code).to_integer_8
						js.return
					end
				when 11 then -- switch 1, case 107
					if not js.return_called then
						Result := (('K').code).to_integer_8
						js.return
					end
				when 12 then -- switch 1, case 108
					if not js.return_called then
						Result := (('L').code).to_integer_8
						js.return
					end
				when 13 then -- switch 1, case 109
					if not js.return_called then
						Result := (('M').code).to_integer_8
						js.return
					end
				when 14 then -- switch 1, case 110
					if not js.return_called then
						Result := (('N').code).to_integer_8
						js.return
					end
				when 15 then -- switch 1, case 111
					if not js.return_called then
						Result := (('O').code).to_integer_8
						js.return
					end
				when 16 then -- switch 1, case 112
					if not js.return_called then
						Result := (('P').code).to_integer_8
						js.return
					end
				when 17 then -- switch 1, case 113
					if not js.return_called then
						Result := (('Q').code).to_integer_8
						js.return
					end
				when 18 then -- switch 1, case 114
					if not js.return_called then
						Result := (('R').code).to_integer_8
						js.return
					end
				when 19 then -- switch 1, case 115
					if not js.return_called then
						Result := (('S').code).to_integer_8
						js.return
					end
				when 20 then -- switch 1, case 116
					if not js.return_called then
						Result := (('T').code).to_integer_8
						js.return
					end
				when 21 then -- switch 1, case 117
					if not js.return_called then
						Result := (('U').code).to_integer_8
						js.return
					end
				when 22 then -- switch 1, case 118
					if not js.return_called then
						Result := (('V').code).to_integer_8
						js.return
					end
				when 23 then -- switch 1, case 119
					if not js.return_called then
						Result := (('W').code).to_integer_8
						js.return
					end
				when 24 then -- switch 1, case 120
					if not js.return_called then
						Result := (('X').code).to_integer_8
						js.return
					end
				when 25 then -- switch 1, case 121
					if not js.return_called then
						Result := (('Y').code).to_integer_8
						js.return
					end
				when 26 then -- switch 1, case 122
					if not js.return_called then
						Result := (('Z').code).to_integer_8
						js.return
					end
				when 27 then -- switch 1, done:
					if not js.return_called then
						Result := a_in
					end
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	Curl_strntoupper (a_dest: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]; a_n: NATURAL_32)
		local
			l_dest: CE_POINTER [INTEGER_8]
			l_src: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_dest.make
			create l_src.make
			create l_tmp.make
			create l_tmp___0.make

			l_dest := a_dest
			l_src := a_src
			l_n := a_n
			if l_n < {NATURAL_32} 1 then
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					l_tmp := l_dest
					l_dest := l_dest + 1
					l_tmp[0] := Curl_raw_toupper (l_src[0])
					l_tmp___0 := l_src
					l_src := l_src + 1
					if (l_tmp___0[0]).to_boolean then
						l_n := l_n - 1
						if not l_n.to_boolean then
							js.break
						end
					else
						js.break
					end
				end
			end
		end

end
