class
	P_STREQUAL

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_strlcat (a_dst: CE_POINTER [INTEGER_8]; a_src: CE_POINTER [INTEGER_8]; a_siz: NATURAL_32): NATURAL_32
		local
			l_d: CE_POINTER [INTEGER_8]
			l_s: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_dlen: PD_DLEN
			l_tmp: NATURAL_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
		do
			create l_d.make
			create l_s.make
			create l_dlen.make
			create l_tmp___1.make

			l_d := a_dst
			l_s := a_src
			l_n := a_siz
			from
			until
				js.loop_done
			loop
				l_tmp := l_n
				l_n := l_n - 1
				if l_tmp /= {NATURAL_32} 0 then
					if (l_d[0]).to_integer_32 = 0 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_d := l_d + 1
				end
			end
			l_dlen.sig := l_d.distance (a_dst)
			l_dlen.update_class_fields -- synchronize union
			l_n := a_siz - l_dlen.uns
			if l_n = {NATURAL_32} 0 then
				Result := (l_dlen.uns + (strlen (l_s)))
				js.return
			end
			if not js.return_called then
				from
				until
					(l_s[0]).to_integer_32 = 0
				loop
					if l_n /= {NATURAL_32} 1 then
						l_tmp___1 := l_d
						l_d := l_d + 1
						l_tmp___1[0] := l_s[0]
						l_n := l_n - 1
					end
					l_s := l_s + 1
				end
				l_d[0] := (('%/0/').code).to_integer_8
				Result := (l_dlen.uns + (l_s.distance (a_src)).to_natural_32)
			end
		end

	curl_strequal (a_first: CE_POINTER [INTEGER_8]; a_second: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (strcasecmp (a_first, a_second)).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

	curl_strnequal (a_first: CE_POINTER [INTEGER_8]; a_second: CE_POINTER [INTEGER_8]; a_max: NATURAL_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
		do
			if (strncasecmp (a_first, a_second, a_max)).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			Result := l_tmp___0
		end

end
