deferred class
	S_SYS_STAT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	fstat (a___fd: INTEGER_32; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_fstat (a___fd, a___buf.c_pointer)
		end

	c_fstat (a___fd: INTEGER_32; a___buf: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return fstat($a___fd, $a___buf);"
		end

	stat (a___file: CE_POINTER [INTEGER_8]; a___buf: CE_POINTER [SD_STAT]): INTEGER_32
		do
			Result := c_stat (a___file.c_pointer, a___buf.c_pointer)
		end

	c_stat (a___file: POINTER; a___buf: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return stat($a___file, $a___buf);"
		end

end
