class
	PD_HGCD_MATRIX

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create p.make (<<2, 2>>)
		end

feature {ANY} -- fields

	alloc: INTEGER_32 assign set_alloc

	n: INTEGER_32 assign set_n

	p: CE_ARRAY [CE_ARRAY [CE_POINTER [NATURAL_32]]]

feature {ANY} -- setters

	set_alloc (a_alloc: INTEGER_32)
		do
			alloc := a_alloc
			update_memory_field ("alloc")
		end

	set_n (a_n: INTEGER_32)
		do
			n := a_n
			update_memory_field ("n")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			alloc := a_other.alloc
			n := a_other.n
			p := a_other.p.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				alloc = a_other.alloc and
				n = a_other.n and
				p.is_equal (a_other.p)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("alloc"),
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("p", <<2, 2>>)
				>>)
			init_structure_info
		end

end
