frozen class
	LIBGMP_INITIALIZER_SLICE3

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {LIBGMP_INITIALIZER}

	initialize
		do
			randmt_inst.default_state[456] := {NATURAL_32} 2_978_511_512
			randmt_inst.default_state[457] := {NATURAL_32} 3_242_676_329
			randmt_inst.default_state[458] := {NATURAL_32} 2_801_220_339
			randmt_inst.default_state[459] := (1_910_825_063).to_natural_32
			randmt_inst.default_state[460] := (1_185_245_662).to_natural_32
			randmt_inst.default_state[461] := {NATURAL_32} 3_534_611_504
			randmt_inst.default_state[462] := (1_862_755_015).to_natural_32
			randmt_inst.default_state[463] := {NATURAL_32} 4_110_972_660
			randmt_inst.default_state[464] := (1_397_818_690).to_natural_32
			randmt_inst.default_state[465] := (57_941_054).to_natural_32
			randmt_inst.default_state[466] := (1_397_760_548).to_natural_32
			randmt_inst.default_state[467] := {NATURAL_32} 3_638_906_208
			randmt_inst.default_state[468] := (1_011_133_210).to_natural_32
			randmt_inst.default_state[469] := (882_322_246).to_natural_32
			randmt_inst.default_state[470] := (1_958_717_597).to_natural_32
			randmt_inst.default_state[471] := {NATURAL_32} 3_621_218_528
			randmt_inst.default_state[472] := (937_821_660).to_natural_32
			randmt_inst.default_state[473] := {NATURAL_32} 3_778_878_431
			randmt_inst.default_state[474] := (1_347_535_905).to_natural_32
			randmt_inst.default_state[475] := {NATURAL_32} 3_118_487_486
			randmt_inst.default_state[476] := {NATURAL_32} 3_071_779_148
			randmt_inst.default_state[477] := {NATURAL_32} 2_708_671_555
			randmt_inst.default_state[478] := {NATURAL_32} 3_113_629_886
			randmt_inst.default_state[479] := {NATURAL_32} 3_050_697_581
			randmt_inst.default_state[480] := {NATURAL_32} 3_915_438_570
			randmt_inst.default_state[481] := (1_796_442_323).to_natural_32
			randmt_inst.default_state[482] := {NATURAL_32} 3_971_404_726
			randmt_inst.default_state[483] := {NATURAL_32} 3_183_381_379
			randmt_inst.default_state[484] := (774_483_909).to_natural_32
			randmt_inst.default_state[485] := (1_984_786_924).to_natural_32
			randmt_inst.default_state[486] := (1_267_683_139).to_natural_32
			randmt_inst.default_state[487] := {NATURAL_32} 3_256_736_768
			randmt_inst.default_state[488] := {NATURAL_32} 2_789_172_607
			randmt_inst.default_state[489] := {NATURAL_32} 2_187_821_360
			randmt_inst.default_state[490] := {NATURAL_32} 3_690_280_364
			randmt_inst.default_state[491] := {NATURAL_32} 2_778_004_568
			randmt_inst.default_state[492] := {NATURAL_32} 2_485_552_828
			randmt_inst.default_state[493] := {NATURAL_32} 3_181_077_883
			randmt_inst.default_state[494] := (1_242_536_801).to_natural_32
			randmt_inst.default_state[495] := (1_157_568_591).to_natural_32
			randmt_inst.default_state[496] := (954_272_303).to_natural_32
			randmt_inst.default_state[497] := (1_636_894_246).to_natural_32
			randmt_inst.default_state[498] := (1_579_447_862).to_natural_32
			randmt_inst.default_state[499] := (1_896_272_183).to_natural_32
			randmt_inst.default_state[500] := {NATURAL_32} 3_324_510_960
			randmt_inst.default_state[501] := {NATURAL_32} 3_172_802_304
			randmt_inst.default_state[502] := (2_093_014_194).to_natural_32
			randmt_inst.default_state[503] := {NATURAL_32} 3_982_706_953
			randmt_inst.default_state[504] := {NATURAL_32} 3_692_278_350
			randmt_inst.default_state[505] := {NATURAL_32} 2_543_436_953
			randmt_inst.default_state[506] := {NATURAL_32} 3_615_374_698
			randmt_inst.default_state[507] := (343_358_312).to_natural_32
			randmt_inst.default_state[508] := {NATURAL_32} 2_524_598_199
			randmt_inst.default_state[509] := (904_843_185).to_natural_32
			randmt_inst.default_state[510] := (709_955_768).to_natural_32
			randmt_inst.default_state[511] := {NATURAL_32} 3_807_424_404
			randmt_inst.default_state[512] := {NATURAL_32} 2_634_669_733
			randmt_inst.default_state[513] := (539_319_591).to_natural_32
			randmt_inst.default_state[514] := (1_467_077_451).to_natural_32
			randmt_inst.default_state[515] := {NATURAL_32} 3_775_438_564
			randmt_inst.default_state[516] := (611_267_339).to_natural_32
			randmt_inst.default_state[517] := {NATURAL_32} 2_407_313_125
			randmt_inst.default_state[518] := {NATURAL_32} 3_540_403_986
			randmt_inst.default_state[519] := (1_976_237_038).to_natural_32
			randmt_inst.default_state[520] := {NATURAL_32} 3_108_991_016
			randmt_inst.default_state[521] := {NATURAL_32} 3_985_978_982
			randmt_inst.default_state[522] := (1_561_949_620).to_natural_32
			randmt_inst.default_state[523] := (1_526_207_089).to_natural_32
			randmt_inst.default_state[524] := (331_227_173).to_natural_32
			randmt_inst.default_state[525] := {NATURAL_32} 2_233_026_137
			randmt_inst.default_state[526] := (813_716_273).to_natural_32
			randmt_inst.default_state[527] := {NATURAL_32} 3_969_730_240
			randmt_inst.default_state[528] := {NATURAL_32} 3_154_279_478
			randmt_inst.default_state[529] := (720_912_776).to_natural_32
			randmt_inst.default_state[530] := {NATURAL_32} 3_256_097_664
			randmt_inst.default_state[531] := {NATURAL_32} 3_224_051_274
			randmt_inst.default_state[532] := (80_961_911).to_natural_32
			randmt_inst.default_state[533] := {NATURAL_32} 4_233_161_175
			randmt_inst.default_state[534] := (969_832_922).to_natural_32
			randmt_inst.default_state[535] := {NATURAL_32} 2_440_956_416
			randmt_inst.default_state[536] := {NATURAL_32} 4_017_753_076
			randmt_inst.default_state[537] := {NATURAL_32} 2_844_514_513
			randmt_inst.default_state[538] := (423_775_698).to_natural_32
			randmt_inst.default_state[539] := {NATURAL_32} 2_486_820_639
			randmt_inst.default_state[540] := {NATURAL_32} 3_291_150_150
			randmt_inst.default_state[541] := {NATURAL_32} 2_916_870_206
			randmt_inst.default_state[542] := {NATURAL_32} 2_233_605_901
			randmt_inst.default_state[543] := (1_163_280_016).to_natural_32
			randmt_inst.default_state[544] := {NATURAL_32} 2_425_744_466
			randmt_inst.default_state[545] := (2_005_433_125).to_natural_32
			randmt_inst.default_state[546] := {NATURAL_32} 2_330_222_692
			randmt_inst.default_state[547] := {NATURAL_32} 3_175_331_610
			randmt_inst.default_state[548] := {NATURAL_32} 3_142_850_902
			randmt_inst.default_state[549] := (1_936_117_661).to_natural_32
			randmt_inst.default_state[550] := {NATURAL_32} 4_002_289_463
			randmt_inst.default_state[551] := {NATURAL_32} 3_047_630_793
			randmt_inst.default_state[552] := (1_349_956_583).to_natural_32
			randmt_inst.default_state[553] := {NATURAL_32} 4_235_246_282
			randmt_inst.default_state[554] := {NATURAL_32} 3_457_375_093
			randmt_inst.default_state[555] := {NATURAL_32} 3_303_611_043
			randmt_inst.default_state[556] := {NATURAL_32} 4_029_946_129
			randmt_inst.default_state[557] := (1_396_902_975).to_natural_32
			randmt_inst.default_state[558] := {NATURAL_32} 2_288_715_812
			randmt_inst.default_state[559] := (1_807_071_415).to_natural_32
			randmt_inst.default_state[560] := (870_453_844).to_natural_32
			randmt_inst.default_state[561] := {NATURAL_32} 4_052_989_014
			randmt_inst.default_state[562] := (1_527_341_439).to_natural_32
			randmt_inst.default_state[563] := (559_939_408).to_natural_32
			randmt_inst.default_state[564] := (1_222_213_361).to_natural_32
			randmt_inst.default_state[565] := (895_777_195).to_natural_32
			randmt_inst.default_state[566] := (1_856_626_116).to_natural_32
			randmt_inst.default_state[567] := (221_587_270).to_natural_32
			randmt_inst.default_state[568] := {NATURAL_32} 2_734_018_115
			randmt_inst.default_state[569] := {NATURAL_32} 2_988_876_211
			randmt_inst.default_state[570] := (321_514_044).to_natural_32
			randmt_inst.default_state[571] := (2_050_194_626).to_natural_32
			randmt_inst.default_state[572] := {NATURAL_32} 3_050_103_101
			randmt_inst.default_state[573] := (1_446_919_003).to_natural_32
			randmt_inst.default_state[574] := (1_397_657_231).to_natural_32
			randmt_inst.default_state[575] := (1_444_125_129).to_natural_32
			randmt_inst.default_state[576] := {NATURAL_32} 3_780_731_794
			randmt_inst.default_state[577] := {NATURAL_32} 2_968_531_237
			randmt_inst.default_state[578] := (1_166_435_419).to_natural_32
			randmt_inst.default_state[579] := (523_704_391).to_natural_32
			randmt_inst.default_state[580] := {NATURAL_32} 2_498_407_377
			randmt_inst.default_state[581] := (1_106_869_981).to_natural_32
			randmt_inst.default_state[582] := {NATURAL_32} 3_823_477_659
			randmt_inst.default_state[583] := (1_908_896_994).to_natural_32
			randmt_inst.default_state[584] := (1_349_687_028).to_natural_32
			randmt_inst.default_state[585] := (1_499_468_603).to_natural_32
			randmt_inst.default_state[586] := (2_018_690_196).to_natural_32
			randmt_inst.default_state[587] := (1_062_938_257).to_natural_32
			randmt_inst.default_state[588] := {NATURAL_32} 2_750_969_716
			randmt_inst.default_state[589] := (1_518_008_478).to_natural_32
			randmt_inst.default_state[590] := (400_178_984).to_natural_32
			randmt_inst.default_state[591] := {NATURAL_32} 3_923_333_485
			randmt_inst.default_state[592] := {NATURAL_32} 4_240_556_501
			randmt_inst.default_state[593] := {NATURAL_32} 3_831_596_584
			randmt_inst.default_state[594] := (67_637_319).to_natural_32
			randmt_inst.default_state[595] := {NATURAL_32} 3_638_877_023
			randmt_inst.default_state[596] := {NATURAL_32} 3_694_658_582
			randmt_inst.default_state[597] := {NATURAL_32} 2_353_607_650
			randmt_inst.default_state[598] := {NATURAL_32} 2_500_283_731
			randmt_inst.default_state[599] := {NATURAL_32} 2_981_102_381
			randmt_inst.default_state[600] := {NATURAL_32} 3_431_006_954
			randmt_inst.default_state[601] := (1_902_383_683).to_natural_32
			randmt_inst.default_state[602] := {NATURAL_32} 2_564_221_802
			randmt_inst.default_state[603] := {NATURAL_32} 2_432_616_773
			randmt_inst.default_state[604] := {NATURAL_32} 2_693_874_501
			randmt_inst.default_state[605] := (1_873_478_525).to_natural_32
			randmt_inst.default_state[606] := (1_895_078_989).to_natural_32
			randmt_inst.default_state[607] := (96_426_766).to_natural_32
			randmt_inst.default_state[608] := {NATURAL_32} 2_457_513_855
			randmt_inst.default_state[609] := {NATURAL_32} 2_710_835_041
			randmt_inst.default_state[610] := {NATURAL_32} 4_276_122_991
			randmt_inst.default_state[611] := {NATURAL_32} 4_162_139_807
			randmt_inst.default_state[612] := (1_543_513_403).to_natural_32
			randmt_inst.default_state[613] := {NATURAL_32} 4_072_240_687
			randmt_inst.default_state[614] := (1_256_930_508).to_natural_32
			randmt_inst.default_state[615] := (275_379_078).to_natural_32
			randmt_inst.default_state[616] := {NATURAL_32} 4_221_888_441
			randmt_inst.default_state[617] := (1_882_400_357).to_natural_32
			randmt_inst.default_state[618] := (1_808_433_422).to_natural_32
			randmt_inst.default_state[619] := {NATURAL_32} 2_242_609_240
			randmt_inst.default_state[620] := {NATURAL_32} 2_924_161_839
			randmt_inst.default_state[621] := {NATURAL_32} 2_635_204_370
			randmt_inst.default_state[622] := {NATURAL_32} 3_202_935_499
			randmt_inst.default_state[623] := (2_003_439_890).to_natural_32
			randmt_inst.Mersenne_Twister_Generator_Noseed[0].randseed_fn := create {CE_ROUTINE}.make_shared (default_pointer)
			randmt_inst.Mersenne_Twister_Generator_Noseed[0].randget_fn := randmt_inst.gmp_randget_mt_address
			randmt_inst.Mersenne_Twister_Generator_Noseed[0].randclear_fn := randmt_inst.gmp_randclear_mt_address
			randmt_inst.Mersenne_Twister_Generator_Noseed[0].randiset_fn := randmt_inst.gmp_randiset_mt_address
			randmts_inst.Mersenne_Twister_Generator[0].randseed_fn := randmts_inst.randseed_mt_address
			randmts_inst.Mersenne_Twister_Generator[0].randget_fn := randmt_inst.gmp_randget_mt_address
			randmts_inst.Mersenne_Twister_Generator[0].randclear_fn := randmt_inst.gmp_randclear_mt_address
			randmts_inst.Mersenne_Twister_Generator[0].randiset_fn := randmt_inst.gmp_randiset_mt_address
			rands_inst.gmp_rands_initialized := (0).to_integer_8
			version_inst.gmp_version := ce_string ("5.0.1")
			nextprime_inst.addtab[0] := (2).to_natural_8
			nextprime_inst.addtab[1] := (4).to_natural_8
			nextprime_inst.addtab[2] := (2).to_natural_8
			nextprime_inst.addtab[3] := (4).to_natural_8
			nextprime_inst.addtab[4] := (6).to_natural_8
			nextprime_inst.addtab[5] := (2).to_natural_8
			nextprime_inst.addtab[6] := (6).to_natural_8
			nextprime_inst.addtab[7] := (4).to_natural_8
			nextprime_inst.addtab[8] := (2).to_natural_8
			nextprime_inst.addtab[9] := (4).to_natural_8
			nextprime_inst.addtab[10] := (6).to_natural_8
			nextprime_inst.addtab[11] := (6).to_natural_8
			nextprime_inst.addtab[12] := (2).to_natural_8
			nextprime_inst.addtab[13] := (6).to_natural_8
			nextprime_inst.addtab[14] := (4).to_natural_8
			nextprime_inst.addtab[15] := (2).to_natural_8
			nextprime_inst.addtab[16] := (6).to_natural_8
			nextprime_inst.addtab[17] := (4).to_natural_8
			nextprime_inst.addtab[18] := (6).to_natural_8
			nextprime_inst.addtab[19] := (8).to_natural_8
			nextprime_inst.addtab[20] := (4).to_natural_8
			nextprime_inst.addtab[21] := (2).to_natural_8
			nextprime_inst.addtab[22] := (4).to_natural_8
			nextprime_inst.addtab[23] := (2).to_natural_8
			nextprime_inst.addtab[24] := (4).to_natural_8
			nextprime_inst.addtab[25] := (8).to_natural_8
			nextprime_inst.addtab[26] := (6).to_natural_8
			nextprime_inst.addtab[27] := (4).to_natural_8
			nextprime_inst.addtab[28] := (6).to_natural_8
			nextprime_inst.addtab[29] := (2).to_natural_8
			nextprime_inst.addtab[30] := (4).to_natural_8
			nextprime_inst.addtab[31] := (6).to_natural_8
			nextprime_inst.addtab[32] := (2).to_natural_8
			nextprime_inst.addtab[33] := (6).to_natural_8
			nextprime_inst.addtab[34] := (6).to_natural_8
			nextprime_inst.addtab[35] := (4).to_natural_8
			nextprime_inst.addtab[36] := (2).to_natural_8
			nextprime_inst.addtab[37] := (4).to_natural_8
			nextprime_inst.addtab[38] := (6).to_natural_8
			nextprime_inst.addtab[39] := (2).to_natural_8
			nextprime_inst.addtab[40] := (6).to_natural_8
			nextprime_inst.addtab[41] := (4).to_natural_8
			nextprime_inst.addtab[42] := (2).to_natural_8
			nextprime_inst.addtab[43] := (4).to_natural_8
			nextprime_inst.addtab[44] := (2).to_natural_8
			nextprime_inst.addtab[45] := (10).to_natural_8
			nextprime_inst.addtab[46] := (2).to_natural_8
			nextprime_inst.addtab[47] := (10).to_natural_8
			set_dfl_prec_inst.gmp_default_fp_limb_precision := (3).to_integer_32
			fac_ui_inst.table[0] := (1).to_natural_32
			fac_ui_inst.table[1] := (1).to_natural_32
			fac_ui_inst.table[2] := (2).to_natural_32
			fac_ui_inst.table[3] := (6).to_natural_32
			fac_ui_inst.table[4] := (24).to_natural_32
			fac_ui_inst.table[5] := (120).to_natural_32
			fac_ui_inst.table[6] := (720).to_natural_32
			fac_ui_inst.table[7] := (5_040).to_natural_32
			fac_ui_inst.table[8] := (40_320).to_natural_32
			fac_ui_inst.table[9] := (362_880).to_natural_32
			fac_ui_inst.table[10] := (3_628_800).to_natural_32
			fac_ui_inst.table[11] := (39_916_800).to_natural_32
			fac_ui_inst.table[12] := (479_001_600).to_natural_32
			nextprime_inst.primegap[0] := (2).to_natural_8
			nextprime_inst.primegap[1] := (2).to_natural_8
			nextprime_inst.primegap[2] := (4).to_natural_8
			nextprime_inst.primegap[3] := (2).to_natural_8
			nextprime_inst.primegap[4] := (4).to_natural_8
			nextprime_inst.primegap[5] := (2).to_natural_8
			nextprime_inst.primegap[6] := (4).to_natural_8
			nextprime_inst.primegap[7] := (6).to_natural_8
			nextprime_inst.primegap[8] := (2).to_natural_8
			nextprime_inst.primegap[9] := (6).to_natural_8
			nextprime_inst.primegap[10] := (4).to_natural_8
			nextprime_inst.primegap[11] := (2).to_natural_8
			nextprime_inst.primegap[12] := (4).to_natural_8
			nextprime_inst.primegap[13] := (6).to_natural_8
			nextprime_inst.primegap[14] := (6).to_natural_8
			nextprime_inst.primegap[15] := (2).to_natural_8
			nextprime_inst.primegap[16] := (6).to_natural_8
			nextprime_inst.primegap[17] := (4).to_natural_8
			nextprime_inst.primegap[18] := (2).to_natural_8
			nextprime_inst.primegap[19] := (6).to_natural_8
			nextprime_inst.primegap[20] := (4).to_natural_8
			nextprime_inst.primegap[21] := (6).to_natural_8
			nextprime_inst.primegap[22] := (8).to_natural_8
			nextprime_inst.primegap[23] := (4).to_natural_8
			nextprime_inst.primegap[24] := (2).to_natural_8
			nextprime_inst.primegap[25] := (4).to_natural_8
			nextprime_inst.primegap[26] := (2).to_natural_8
			nextprime_inst.primegap[27] := (4).to_natural_8
			nextprime_inst.primegap[28] := (14).to_natural_8
			nextprime_inst.primegap[29] := (4).to_natural_8
			nextprime_inst.primegap[30] := (6).to_natural_8
			nextprime_inst.primegap[31] := (2).to_natural_8
			nextprime_inst.primegap[32] := (10).to_natural_8
			nextprime_inst.primegap[33] := (2).to_natural_8
			nextprime_inst.primegap[34] := (6).to_natural_8
			nextprime_inst.primegap[35] := (6).to_natural_8
			nextprime_inst.primegap[36] := (4).to_natural_8
			nextprime_inst.primegap[37] := (6).to_natural_8
			nextprime_inst.primegap[38] := (6).to_natural_8
			nextprime_inst.primegap[39] := (2).to_natural_8
			nextprime_inst.primegap[40] := (10).to_natural_8
			nextprime_inst.primegap[41] := (2).to_natural_8
			nextprime_inst.primegap[42] := (4).to_natural_8
			nextprime_inst.primegap[43] := (2).to_natural_8
			nextprime_inst.primegap[44] := (12).to_natural_8
			nextprime_inst.primegap[45] := (12).to_natural_8
			nextprime_inst.primegap[46] := (4).to_natural_8
			nextprime_inst.primegap[47] := (2).to_natural_8
			nextprime_inst.primegap[48] := (4).to_natural_8
			nextprime_inst.primegap[49] := (6).to_natural_8
			nextprime_inst.primegap[50] := (2).to_natural_8
			nextprime_inst.primegap[51] := (10).to_natural_8
			nextprime_inst.primegap[52] := (6).to_natural_8
			nextprime_inst.primegap[53] := (6).to_natural_8
			nextprime_inst.primegap[54] := (6).to_natural_8
			nextprime_inst.primegap[55] := (2).to_natural_8
			nextprime_inst.primegap[56] := (6).to_natural_8
			nextprime_inst.primegap[57] := (4).to_natural_8
			nextprime_inst.primegap[58] := (2).to_natural_8
			nextprime_inst.primegap[59] := (10).to_natural_8
			nextprime_inst.primegap[60] := (14).to_natural_8
			nextprime_inst.primegap[61] := (4).to_natural_8
			nextprime_inst.primegap[62] := (2).to_natural_8
			nextprime_inst.primegap[63] := (4).to_natural_8
			nextprime_inst.primegap[64] := (14).to_natural_8
			nextprime_inst.primegap[65] := (6).to_natural_8
			nextprime_inst.primegap[66] := (10).to_natural_8
			nextprime_inst.primegap[67] := (2).to_natural_8
			nextprime_inst.primegap[68] := (4).to_natural_8
			nextprime_inst.primegap[69] := (6).to_natural_8
			nextprime_inst.primegap[70] := (8).to_natural_8
			nextprime_inst.primegap[71] := (6).to_natural_8
			nextprime_inst.primegap[72] := (6).to_natural_8
			nextprime_inst.primegap[73] := (4).to_natural_8
			nextprime_inst.primegap[74] := (6).to_natural_8
			nextprime_inst.primegap[75] := (8).to_natural_8
			nextprime_inst.primegap[76] := (4).to_natural_8
			nextprime_inst.primegap[77] := (8).to_natural_8
			nextprime_inst.primegap[78] := (10).to_natural_8
			nextprime_inst.primegap[79] := (2).to_natural_8
			nextprime_inst.primegap[80] := (10).to_natural_8
			nextprime_inst.primegap[81] := (2).to_natural_8
			nextprime_inst.primegap[82] := (6).to_natural_8
			nextprime_inst.primegap[83] := (4).to_natural_8
			nextprime_inst.primegap[84] := (6).to_natural_8
			nextprime_inst.primegap[85] := (8).to_natural_8
			nextprime_inst.primegap[86] := (4).to_natural_8
			nextprime_inst.primegap[87] := (2).to_natural_8
			nextprime_inst.primegap[88] := (4).to_natural_8
			nextprime_inst.primegap[89] := (12).to_natural_8
			nextprime_inst.primegap[90] := (8).to_natural_8
			nextprime_inst.primegap[91] := (4).to_natural_8
			nextprime_inst.primegap[92] := (8).to_natural_8
			nextprime_inst.primegap[93] := (4).to_natural_8
			nextprime_inst.primegap[94] := (6).to_natural_8
			nextprime_inst.primegap[95] := (12).to_natural_8
			nextprime_inst.primegap[96] := (2).to_natural_8
			nextprime_inst.primegap[97] := (18).to_natural_8
			nextprime_inst.primegap[98] := (6).to_natural_8
			nextprime_inst.primegap[99] := (10).to_natural_8
			nextprime_inst.primegap[100] := (6).to_natural_8
			nextprime_inst.primegap[101] := (6).to_natural_8
			nextprime_inst.primegap[102] := (2).to_natural_8
			nextprime_inst.primegap[103] := (6).to_natural_8
			nextprime_inst.primegap[104] := (10).to_natural_8
			nextprime_inst.primegap[105] := (6).to_natural_8
			nextprime_inst.primegap[106] := (6).to_natural_8
			nextprime_inst.primegap[107] := (2).to_natural_8
			nextprime_inst.primegap[108] := (6).to_natural_8
			nextprime_inst.primegap[109] := (6).to_natural_8
			nextprime_inst.primegap[110] := (4).to_natural_8
			nextprime_inst.primegap[111] := (2).to_natural_8
			nextprime_inst.primegap[112] := (12).to_natural_8
			nextprime_inst.primegap[113] := (10).to_natural_8
			nextprime_inst.primegap[114] := (2).to_natural_8
			nextprime_inst.primegap[115] := (4).to_natural_8
			nextprime_inst.primegap[116] := (6).to_natural_8
			nextprime_inst.primegap[117] := (6).to_natural_8
			nextprime_inst.primegap[118] := (2).to_natural_8
			nextprime_inst.primegap[119] := (12).to_natural_8
			nextprime_inst.primegap[120] := (4).to_natural_8
			nextprime_inst.primegap[121] := (6).to_natural_8
			nextprime_inst.primegap[122] := (8).to_natural_8
			nextprime_inst.primegap[123] := (10).to_natural_8
			nextprime_inst.primegap[124] := (8).to_natural_8
			nextprime_inst.primegap[125] := (10).to_natural_8
			nextprime_inst.primegap[126] := (8).to_natural_8
			nextprime_inst.primegap[127] := (6).to_natural_8
			nextprime_inst.primegap[128] := (6).to_natural_8
			nextprime_inst.primegap[129] := (4).to_natural_8
			nextprime_inst.primegap[130] := (8).to_natural_8
			nextprime_inst.primegap[131] := (6).to_natural_8
			nextprime_inst.primegap[132] := (4).to_natural_8
			nextprime_inst.primegap[133] := (8).to_natural_8
			nextprime_inst.primegap[134] := (4).to_natural_8
			nextprime_inst.primegap[135] := (14).to_natural_8
			nextprime_inst.primegap[136] := (10).to_natural_8
			nextprime_inst.primegap[137] := (12).to_natural_8
			nextprime_inst.primegap[138] := (2).to_natural_8
			nextprime_inst.primegap[139] := (10).to_natural_8
			nextprime_inst.primegap[140] := (2).to_natural_8
			nextprime_inst.primegap[141] := (4).to_natural_8
			nextprime_inst.primegap[142] := (2).to_natural_8
			nextprime_inst.primegap[143] := (10).to_natural_8
			nextprime_inst.primegap[144] := (14).to_natural_8
			nextprime_inst.primegap[145] := (4).to_natural_8
			nextprime_inst.primegap[146] := (2).to_natural_8
			nextprime_inst.primegap[147] := (4).to_natural_8
			nextprime_inst.primegap[148] := (14).to_natural_8
			nextprime_inst.primegap[149] := (4).to_natural_8
			nextprime_inst.primegap[150] := (2).to_natural_8
			nextprime_inst.primegap[151] := (4).to_natural_8
			nextprime_inst.primegap[152] := (20).to_natural_8
			nextprime_inst.primegap[153] := (4).to_natural_8
			nextprime_inst.primegap[154] := (8).to_natural_8
			nextprime_inst.primegap[155] := (10).to_natural_8
			nextprime_inst.primegap[156] := (8).to_natural_8
			nextprime_inst.primegap[157] := (4).to_natural_8
			nextprime_inst.primegap[158] := (6).to_natural_8
			nextprime_inst.primegap[159] := (6).to_natural_8
			nextprime_inst.primegap[160] := (14).to_natural_8
			nextprime_inst.primegap[161] := (4).to_natural_8
			nextprime_inst.primegap[162] := (6).to_natural_8
			nextprime_inst.primegap[163] := (6).to_natural_8
			nextprime_inst.primegap[164] := (8).to_natural_8
			nextprime_inst.primegap[165] := (6).to_natural_8
			nextprime_inst.primegap[166] := (12).to_natural_8
			fib_table_inst.gmp_fib_table[0] := (1).to_natural_32
			fib_table_inst.gmp_fib_table[1] := (0).to_natural_32
			fib_table_inst.gmp_fib_table[2] := (1).to_natural_32
			fib_table_inst.gmp_fib_table[3] := (1).to_natural_32
			fib_table_inst.gmp_fib_table[4] := (2).to_natural_32
			fib_table_inst.gmp_fib_table[5] := (3).to_natural_32
			fib_table_inst.gmp_fib_table[6] := (5).to_natural_32
			fib_table_inst.gmp_fib_table[7] := (8).to_natural_32
			fib_table_inst.gmp_fib_table[8] := (13).to_natural_32
			fib_table_inst.gmp_fib_table[9] := (21).to_natural_32
			fib_table_inst.gmp_fib_table[10] := (34).to_natural_32
			fib_table_inst.gmp_fib_table[11] := (55).to_natural_32
			fib_table_inst.gmp_fib_table[12] := (89).to_natural_32
			fib_table_inst.gmp_fib_table[13] := (144).to_natural_32
			fib_table_inst.gmp_fib_table[14] := (233).to_natural_32
			fib_table_inst.gmp_fib_table[15] := (377).to_natural_32
			fib_table_inst.gmp_fib_table[16] := (610).to_natural_32
			fib_table_inst.gmp_fib_table[17] := (987).to_natural_32
			fib_table_inst.gmp_fib_table[18] := (1_597).to_natural_32
			fib_table_inst.gmp_fib_table[19] := (2_584).to_natural_32
			fib_table_inst.gmp_fib_table[20] := (4_181).to_natural_32
			fib_table_inst.gmp_fib_table[21] := (6_765).to_natural_32
			fib_table_inst.gmp_fib_table[22] := (10_946).to_natural_32
			fib_table_inst.gmp_fib_table[23] := (17_711).to_natural_32
			fib_table_inst.gmp_fib_table[24] := (28_657).to_natural_32
			fib_table_inst.gmp_fib_table[25] := (46_368).to_natural_32
			fib_table_inst.gmp_fib_table[26] := (75_025).to_natural_32
			fib_table_inst.gmp_fib_table[27] := (121_393).to_natural_32
			fib_table_inst.gmp_fib_table[28] := (196_418).to_natural_32
			fib_table_inst.gmp_fib_table[29] := (317_811).to_natural_32
			fib_table_inst.gmp_fib_table[30] := (514_229).to_natural_32
			fib_table_inst.gmp_fib_table[31] := (832_040).to_natural_32
			fib_table_inst.gmp_fib_table[32] := (1_346_269).to_natural_32
			fib_table_inst.gmp_fib_table[33] := (2_178_309).to_natural_32
			fib_table_inst.gmp_fib_table[34] := (3_524_578).to_natural_32
			fib_table_inst.gmp_fib_table[35] := (5_702_887).to_natural_32
			fib_table_inst.gmp_fib_table[36] := (9_227_465).to_natural_32
			fib_table_inst.gmp_fib_table[37] := (14_930_352).to_natural_32
			fib_table_inst.gmp_fib_table[38] := (24_157_817).to_natural_32
			fib_table_inst.gmp_fib_table[39] := (39_088_169).to_natural_32
			fib_table_inst.gmp_fib_table[40] := (63_245_986).to_natural_32
			fib_table_inst.gmp_fib_table[41] := (102_334_155).to_natural_32
			fib_table_inst.gmp_fib_table[42] := (165_580_141).to_natural_32
			fib_table_inst.gmp_fib_table[43] := (267_914_296).to_natural_32
			fib_table_inst.gmp_fib_table[44] := (433_494_437).to_natural_32
			fib_table_inst.gmp_fib_table[45] := (701_408_733).to_natural_32
			fib_table_inst.gmp_fib_table[46] := (1_134_903_170).to_natural_32
			fib_table_inst.gmp_fib_table[47] := (1_836_311_903).to_natural_32
			fib_table_inst.gmp_fib_table[48] := {NATURAL_32} 2_971_215_073
			mp_bases_inst.gmpn_bases[0].chars_per_limb := 0
			mp_bases_inst.gmpn_bases[0].chars_per_bit_exactly := 0.0
			mp_bases_inst.gmpn_bases[0].big_base := (0).to_natural_32
			mp_bases_inst.gmpn_bases[0].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[1].chars_per_limb := 0
			mp_bases_inst.gmpn_bases[1].chars_per_bit_exactly := 1.e37
			mp_bases_inst.gmpn_bases[1].big_base := (0).to_natural_32
			mp_bases_inst.gmpn_bases[1].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[2].chars_per_limb := 32
			mp_bases_inst.gmpn_bases[2].chars_per_bit_exactly := 1.0000000000000000
			mp_bases_inst.gmpn_bases[2].big_base := (1).to_natural_32
			mp_bases_inst.gmpn_bases[2].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[3].chars_per_limb := 20
			mp_bases_inst.gmpn_bases[3].chars_per_bit_exactly := 0.6309297535714574
			mp_bases_inst.gmpn_bases[3].big_base := {NATURAL_32} 3_486_784_401
			mp_bases_inst.gmpn_bases[3].big_base_inverted := (995_507_236).to_natural_32
			mp_bases_inst.gmpn_bases[4].chars_per_limb := 16
			mp_bases_inst.gmpn_bases[4].chars_per_bit_exactly := 0.5000000000000000
			mp_bases_inst.gmpn_bases[4].big_base := (2).to_natural_32
			mp_bases_inst.gmpn_bases[4].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[5].chars_per_limb := 13
			mp_bases_inst.gmpn_bases[5].chars_per_bit_exactly := 0.4306765580733931
			mp_bases_inst.gmpn_bases[5].big_base := (1_220_703_125).to_natural_32
			mp_bases_inst.gmpn_bases[5].big_base_inverted := {NATURAL_32} 3_260_819_076
			mp_bases_inst.gmpn_bases[6].chars_per_limb := 12
			mp_bases_inst.gmpn_bases[6].chars_per_bit_exactly := 0.3868528072345416
			mp_bases_inst.gmpn_bases[6].big_base := {NATURAL_32} 2_176_782_336
			mp_bases_inst.gmpn_bases[6].big_base_inverted := {NATURAL_32} 4_179_349_942
			mp_bases_inst.gmpn_bases[7].chars_per_limb := 11
			mp_bases_inst.gmpn_bases[7].chars_per_bit_exactly := 0.3562071871080222
			mp_bases_inst.gmpn_bases[7].big_base := (1_977_326_743).to_natural_32
			mp_bases_inst.gmpn_bases[7].big_base_inverted := (369_599_179).to_natural_32
			mp_bases_inst.gmpn_bases[8].chars_per_limb := 10
			mp_bases_inst.gmpn_bases[8].chars_per_bit_exactly := 0.3333333333333334
			mp_bases_inst.gmpn_bases[8].big_base := (3).to_natural_32
			mp_bases_inst.gmpn_bases[8].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[9].chars_per_limb := 10
			mp_bases_inst.gmpn_bases[9].chars_per_bit_exactly := 0.3154648767857287
			mp_bases_inst.gmpn_bases[9].big_base := {NATURAL_32} 3_486_784_401
			mp_bases_inst.gmpn_bases[9].big_base_inverted := (995_507_236).to_natural_32
			mp_bases_inst.gmpn_bases[10].chars_per_limb := 9
			mp_bases_inst.gmpn_bases[10].chars_per_bit_exactly := 0.3010299956639811
			mp_bases_inst.gmpn_bases[10].big_base := (1_000_000_000).to_natural_32
			mp_bases_inst.gmpn_bases[10].big_base_inverted := (316_718_722).to_natural_32
		end

end
