frozen class
	LIBGMP_INITIALIZER_SLICE5

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {LIBGMP_INITIALIZER}

	initialize
		do
			mp_bases_inst.gmpn_bases[136].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[136].chars_per_bit_exactly := 0.1410942141636095
			mp_bases_inst.gmpn_bases[136].big_base := (342_102_016).to_natural_32
			mp_bases_inst.gmpn_bases[136].big_base_inverted := {NATURAL_32} 2_445_253_168
			mp_bases_inst.gmpn_bases[137].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[137].chars_per_bit_exactly := 0.1408841194731412
			mp_bases_inst.gmpn_bases[137].big_base := (352_275_361).to_natural_32
			mp_bases_inst.gmpn_bases[137].big_base_inverted := {NATURAL_32} 2_250_602_631
			mp_bases_inst.gmpn_bases[138].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[138].chars_per_bit_exactly := 0.1406761707131039
			mp_bases_inst.gmpn_bases[138].big_base := (362_673_936).to_natural_32
			mp_bases_inst.gmpn_bases[138].big_base_inverted := (2_062_928_268).to_natural_32
			mp_bases_inst.gmpn_bases[139].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[139].chars_per_bit_exactly := 0.1404703297561400
			mp_bases_inst.gmpn_bases[139].big_base := (373_301_041).to_natural_32
			mp_bases_inst.gmpn_bases[139].big_base_inverted := (1_881_932_192).to_natural_32
			mp_bases_inst.gmpn_bases[140].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[140].chars_per_bit_exactly := 0.1402665594314587
			mp_bases_inst.gmpn_bases[140].big_base := (384_160_000).to_natural_32
			mp_bases_inst.gmpn_bases[140].big_base_inverted := (1_707_331_249).to_natural_32
			mp_bases_inst.gmpn_bases[141].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[141].chars_per_bit_exactly := 0.1400648234939879
			mp_bases_inst.gmpn_bases[141].big_base := (395_254_161).to_natural_32
			mp_bases_inst.gmpn_bases[141].big_base_inverted := (1_538_856_194).to_natural_32
			mp_bases_inst.gmpn_bases[142].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[142].chars_per_bit_exactly := 0.1398650865947379
			mp_bases_inst.gmpn_bases[142].big_base := (406_586_896).to_natural_32
			mp_bases_inst.gmpn_bases[142].big_base_inverted := (1_376_250_915).to_natural_32
			mp_bases_inst.gmpn_bases[143].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[143].chars_per_bit_exactly := 0.1396673142523192
			mp_bases_inst.gmpn_bases[143].big_base := (418_161_601).to_natural_32
			mp_bases_inst.gmpn_bases[143].big_base_inverted := (1_219_271_705).to_natural_32
			mp_bases_inst.gmpn_bases[144].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[144].chars_per_bit_exactly := 0.1394714728255649
			mp_bases_inst.gmpn_bases[144].big_base := (429_981_696).to_natural_32
			mp_bases_inst.gmpn_bases[144].big_base_inverted := (1_067_686_581).to_natural_32
			mp_bases_inst.gmpn_bases[145].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[145].chars_per_bit_exactly := 0.1392775294872041
			mp_bases_inst.gmpn_bases[145].big_base := (442_050_625).to_natural_32
			mp_bases_inst.gmpn_bases[145].big_base_inverted := (921_274_642).to_natural_32
			mp_bases_inst.gmpn_bases[146].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[146].chars_per_bit_exactly := 0.1390854521985406
			mp_bases_inst.gmpn_bases[146].big_base := (454_371_856).to_natural_32
			mp_bases_inst.gmpn_bases[146].big_base_inverted := (779_825_472).to_natural_32
			mp_bases_inst.gmpn_bases[147].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[147].chars_per_bit_exactly := 0.1388952096850913
			mp_bases_inst.gmpn_bases[147].big_base := (466_948_881).to_natural_32
			mp_bases_inst.gmpn_bases[147].big_base_inverted := (643_138_571).to_natural_32
			mp_bases_inst.gmpn_bases[148].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[148].chars_per_bit_exactly := 0.1387067714131417
			mp_bases_inst.gmpn_bases[148].big_base := (479_785_216).to_natural_32
			mp_bases_inst.gmpn_bases[148].big_base_inverted := (511_022_826).to_natural_32
			mp_bases_inst.gmpn_bases[149].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[149].chars_per_bit_exactly := 0.1385201075671774
			mp_bases_inst.gmpn_bases[149].big_base := (492_884_401).to_natural_32
			mp_bases_inst.gmpn_bases[149].big_base_inverted := (383_296_013).to_natural_32
			mp_bases_inst.gmpn_bases[150].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[150].chars_per_bit_exactly := 0.1383351890281539
			mp_bases_inst.gmpn_bases[150].big_base := (506_250_000).to_natural_32
			mp_bases_inst.gmpn_bases[150].big_base_inverted := (259_784_327).to_natural_32
			mp_bases_inst.gmpn_bases[151].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[151].chars_per_bit_exactly := 0.1381519873525671
			mp_bases_inst.gmpn_bases[151].big_base := (519_885_601).to_natural_32
			mp_bases_inst.gmpn_bases[151].big_base_inverted := (140_321_938).to_natural_32
			mp_bases_inst.gmpn_bases[152].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[152].chars_per_bit_exactly := 0.1379704747522905
			mp_bases_inst.gmpn_bases[152].big_base := (533_794_816).to_natural_32
			mp_bases_inst.gmpn_bases[152].big_base_inverted := (24_750_580).to_natural_32
			mp_bases_inst.gmpn_bases[153].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[153].chars_per_bit_exactly := 0.1377906240751463
			mp_bases_inst.gmpn_bases[153].big_base := (547_981_281).to_natural_32
			mp_bases_inst.gmpn_bases[153].big_base_inverted := {NATURAL_32} 4_120_805_611
			mp_bases_inst.gmpn_bases[154].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[154].chars_per_bit_exactly := 0.1376124087861776
			mp_bases_inst.gmpn_bases[154].big_base := (562_448_656).to_natural_32
			mp_bases_inst.gmpn_bases[154].big_base_inverted := {NATURAL_32} 3_904_334_043
			mp_bases_inst.gmpn_bases[155].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[155].chars_per_bit_exactly := 0.1374358029495937
			mp_bases_inst.gmpn_bases[155].big_base := (577_200_625).to_natural_32
			mp_bases_inst.gmpn_bases[155].big_base_inverted := {NATURAL_32} 3_694_778_069
			mp_bases_inst.gmpn_bases[156].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[156].chars_per_bit_exactly := 0.1372607812113589
			mp_bases_inst.gmpn_bases[156].big_base := (592_240_896).to_natural_32
			mp_bases_inst.gmpn_bases[156].big_base_inverted := {NATURAL_32} 3_491_874_257
			mp_bases_inst.gmpn_bases[157].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[157].chars_per_bit_exactly := 0.1370873187823978
			mp_bases_inst.gmpn_bases[157].big_base := (607_573_201).to_natural_32
			mp_bases_inst.gmpn_bases[157].big_base_inverted := {NATURAL_32} 3_295_370_807
			mp_bases_inst.gmpn_bases[158].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[158].chars_per_bit_exactly := 0.1369153914223921
			mp_bases_inst.gmpn_bases[158].big_base := (623_201_296).to_natural_32
			mp_bases_inst.gmpn_bases[158].big_base_inverted := {NATURAL_32} 3_105_026_972
			mp_bases_inst.gmpn_bases[159].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[159].chars_per_bit_exactly := 0.1367449754241439
			mp_bases_inst.gmpn_bases[159].big_base := (639_128_961).to_natural_32
			mp_bases_inst.gmpn_bases[159].big_base_inverted := {NATURAL_32} 2_920_612_500
			mp_bases_inst.gmpn_bases[160].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[160].chars_per_bit_exactly := 0.1365760475984821
			mp_bases_inst.gmpn_bases[160].big_base := (655_360_000).to_natural_32
			mp_bases_inst.gmpn_bases[160].big_base_inverted := {NATURAL_32} 2_741_907_121
			mp_bases_inst.gmpn_bases[161].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[161].chars_per_bit_exactly := 0.1364085852596902
			mp_bases_inst.gmpn_bases[161].big_base := (671_898_241).to_natural_32
			mp_bases_inst.gmpn_bases[161].big_base_inverted := {NATURAL_32} 2_568_700_052
			mp_bases_inst.gmpn_bases[162].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[162].chars_per_bit_exactly := 0.1362425662114337
			mp_bases_inst.gmpn_bases[162].big_base := (688_747_536).to_natural_32
			mp_bases_inst.gmpn_bases[162].big_base_inverted := {NATURAL_32} 2_400_789_534
			mp_bases_inst.gmpn_bases[163].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[163].chars_per_bit_exactly := 0.1360779687331669
			mp_bases_inst.gmpn_bases[163].big_base := (705_911_761).to_natural_32
			mp_bases_inst.gmpn_bases[163].big_base_inverted := {NATURAL_32} 2_237_982_391
			mp_bases_inst.gmpn_bases[164].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[164].chars_per_bit_exactly := 0.1359147715670014
			mp_bases_inst.gmpn_bases[164].big_base := (723_394_816).to_natural_32
			mp_bases_inst.gmpn_bases[164].big_base_inverted := (2_080_093_620).to_natural_32
			mp_bases_inst.gmpn_bases[165].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[165].chars_per_bit_exactly := 0.1357529539050150
			mp_bases_inst.gmpn_bases[165].big_base := (741_200_625).to_natural_32
			mp_bases_inst.gmpn_bases[165].big_base_inverted := (1_926_945_992).to_natural_32
			mp_bases_inst.gmpn_bases[166].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[166].chars_per_bit_exactly := 0.1355924953769863
			mp_bases_inst.gmpn_bases[166].big_base := (759_333_136).to_natural_32
			mp_bases_inst.gmpn_bases[166].big_base_inverted := (1_778_369_688).to_natural_32
			mp_bases_inst.gmpn_bases[167].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[167].chars_per_bit_exactly := 0.1354333760385373
			mp_bases_inst.gmpn_bases[167].big_base := (777_796_321).to_natural_32
			mp_bases_inst.gmpn_bases[167].big_base_inverted := (1_634_201_940).to_natural_32
			mp_bases_inst.gmpn_bases[168].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[168].chars_per_bit_exactly := 0.1352755763596663
			mp_bases_inst.gmpn_bases[168].big_base := (796_594_176).to_natural_32
			mp_bases_inst.gmpn_bases[168].big_base_inverted := (1_494_286_702).to_natural_32
			mp_bases_inst.gmpn_bases[169].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[169].chars_per_bit_exactly := 0.1351190772136599
			mp_bases_inst.gmpn_bases[169].big_base := (815_730_721).to_natural_32
			mp_bases_inst.gmpn_bases[169].big_base_inverted := (1_358_474_335).to_natural_32
			mp_bases_inst.gmpn_bases[170].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[170].chars_per_bit_exactly := 0.1349638598663645
			mp_bases_inst.gmpn_bases[170].big_base := (835_210_000).to_natural_32
			mp_bases_inst.gmpn_bases[170].big_base_inverted := (1_226_621_308).to_natural_32
			mp_bases_inst.gmpn_bases[171].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[171].chars_per_bit_exactly := 0.1348099059658079
			mp_bases_inst.gmpn_bases[171].big_base := (855_036_081).to_natural_32
			mp_bases_inst.gmpn_bases[171].big_base_inverted := (1_098_589_912).to_natural_32
			mp_bases_inst.gmpn_bases[172].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[172].chars_per_bit_exactly := 0.1346571975321549
			mp_bases_inst.gmpn_bases[172].big_base := (875_213_056).to_natural_32
			mp_bases_inst.gmpn_bases[172].big_base_inverted := (974_247_995).to_natural_32
			mp_bases_inst.gmpn_bases[173].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[173].chars_per_bit_exactly := 0.1345057169479844
			mp_bases_inst.gmpn_bases[173].big_base := (895_745_041).to_natural_32
			mp_bases_inst.gmpn_bases[173].big_base_inverted := (853_468_706).to_natural_32
			mp_bases_inst.gmpn_bases[174].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[174].chars_per_bit_exactly := 0.1343554469488779
			mp_bases_inst.gmpn_bases[174].big_base := (916_636_176).to_natural_32
			mp_bases_inst.gmpn_bases[174].big_base_inverted := (736_130_253).to_natural_32
			mp_bases_inst.gmpn_bases[175].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[175].chars_per_bit_exactly := 0.1342063706143054
			mp_bases_inst.gmpn_bases[175].big_base := (937_890_625).to_natural_32
			mp_bases_inst.gmpn_bases[175].big_base_inverted := (622_115_672).to_natural_32
			mp_bases_inst.gmpn_bases[176].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[176].chars_per_bit_exactly := 0.1340584713587980
			mp_bases_inst.gmpn_bases[176].big_base := (959_512_576).to_natural_32
			mp_bases_inst.gmpn_bases[176].big_base_inverted := (511_312_615).to_natural_32
			mp_bases_inst.gmpn_bases[177].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[177].chars_per_bit_exactly := 0.1339117329233981
			mp_bases_inst.gmpn_bases[177].big_base := (981_506_241).to_natural_32
			mp_bases_inst.gmpn_bases[177].big_base_inverted := (403_613_136).to_natural_32
			mp_bases_inst.gmpn_bases[178].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[178].chars_per_bit_exactly := 0.1337661393673756
			mp_bases_inst.gmpn_bases[178].big_base := (1_003_875_856).to_natural_32
			mp_bases_inst.gmpn_bases[178].big_base_inverted := (298_913_501).to_natural_32
			mp_bases_inst.gmpn_bases[179].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[179].chars_per_bit_exactly := 0.1336216750601996
			mp_bases_inst.gmpn_bases[179].big_base := (1_026_625_681).to_natural_32
			mp_bases_inst.gmpn_bases[179].big_base_inverted := (197_113_998).to_natural_32
			mp_bases_inst.gmpn_bases[180].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[180].chars_per_bit_exactly := 0.1334783246737591
			mp_bases_inst.gmpn_bases[180].big_base := (1_049_760_000).to_natural_32
			mp_bases_inst.gmpn_bases[180].big_base_inverted := (98_118_760).to_natural_32
			mp_bases_inst.gmpn_bases[181].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[181].chars_per_bit_exactly := 0.1333360731748201
			mp_bases_inst.gmpn_bases[181].big_base := (1_073_283_121).to_natural_32
			mp_bases_inst.gmpn_bases[181].big_base_inverted := (1_835_596).to_natural_32
			mp_bases_inst.gmpn_bases[182].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[182].chars_per_bit_exactly := 0.1331949058177136
			mp_bases_inst.gmpn_bases[182].big_base := (1_097_199_376).to_natural_32
			mp_bases_inst.gmpn_bases[182].big_base_inverted := {NATURAL_32} 4_111_318_962
			mp_bases_inst.gmpn_bases[183].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[183].chars_per_bit_exactly := 0.1330548081372441
			mp_bases_inst.gmpn_bases[183].big_base := (1_121_513_121).to_natural_32
			mp_bases_inst.gmpn_bases[183].big_base_inverted := {NATURAL_32} 3_929_075_619
			mp_bases_inst.gmpn_bases[184].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[184].chars_per_bit_exactly := 0.1329157659418126
			mp_bases_inst.gmpn_bases[184].big_base := (1_146_228_736).to_natural_32
			mp_bases_inst.gmpn_bases[184].big_base_inverted := {NATURAL_32} 3_751_744_278
			mp_bases_inst.gmpn_bases[185].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[185].chars_per_bit_exactly := 0.1327777653067443
			mp_bases_inst.gmpn_bases[185].big_base := (1_171_350_625).to_natural_32
			mp_bases_inst.gmpn_bases[185].big_base_inverted := {NATURAL_32} 3_579_166_921
			mp_bases_inst.gmpn_bases[186].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[186].chars_per_bit_exactly := 0.1326407925678156
			mp_bases_inst.gmpn_bases[186].big_base := (1_196_883_216).to_natural_32
			mp_bases_inst.gmpn_bases[186].big_base_inverted := {NATURAL_32} 3_411_191_428
			mp_bases_inst.gmpn_bases[187].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[187].chars_per_bit_exactly := 0.1325048343149731
			mp_bases_inst.gmpn_bases[187].big_base := (1_222_830_961).to_natural_32
			mp_bases_inst.gmpn_bases[187].big_base_inverted := {NATURAL_32} 3_247_671_327
			mp_bases_inst.gmpn_bases[188].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[188].chars_per_bit_exactly := 0.1323698773862368
			mp_bases_inst.gmpn_bases[188].big_base := (1_249_198_336).to_natural_32
			mp_bases_inst.gmpn_bases[188].big_base_inverted := {NATURAL_32} 3_088_465_559
			mp_bases_inst.gmpn_bases[189].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[189].chars_per_bit_exactly := 0.1322359088617821
			mp_bases_inst.gmpn_bases[189].big_base := (1_275_989_841).to_natural_32
			mp_bases_inst.gmpn_bases[189].big_base_inverted := {NATURAL_32} 2_933_438_244
			mp_bases_inst.gmpn_bases[190].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[190].chars_per_bit_exactly := 0.1321029160581950
			mp_bases_inst.gmpn_bases[190].big_base := (1_303_210_000).to_natural_32
			mp_bases_inst.gmpn_bases[190].big_base_inverted := {NATURAL_32} 2_782_458_473
			mp_bases_inst.gmpn_bases[191].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[191].chars_per_bit_exactly := 0.1319708865228925
			mp_bases_inst.gmpn_bases[191].big_base := (1_330_863_361).to_natural_32
			mp_bases_inst.gmpn_bases[191].big_base_inverted := {NATURAL_32} 2_635_400_093
			mp_bases_inst.gmpn_bases[192].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[192].chars_per_bit_exactly := 0.1318398080287045
			mp_bases_inst.gmpn_bases[192].big_base := (1_358_954_496).to_natural_32
			mp_bases_inst.gmpn_bases[192].big_base_inverted := {NATURAL_32} 2_492_141_517
			mp_bases_inst.gmpn_bases[193].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[193].chars_per_bit_exactly := 0.1317096685686114
			mp_bases_inst.gmpn_bases[193].big_base := (1_387_488_001).to_natural_32
			mp_bases_inst.gmpn_bases[193].big_base_inverted := {NATURAL_32} 2_352_565_533
			mp_bases_inst.gmpn_bases[194].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[194].chars_per_bit_exactly := 0.1315804563506306
			mp_bases_inst.gmpn_bases[194].big_base := (1_416_468_496).to_natural_32
			mp_bases_inst.gmpn_bases[194].big_base_inverted := {NATURAL_32} 2_216_559_125
			mp_bases_inst.gmpn_bases[195].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[195].chars_per_bit_exactly := 0.1314521597928493
			mp_bases_inst.gmpn_bases[195].big_base := (1_445_900_625).to_natural_32
			mp_bases_inst.gmpn_bases[195].big_base_inverted := (2_084_013_304).to_natural_32
			mp_bases_inst.gmpn_bases[196].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[196].chars_per_bit_exactly := 0.1313247675185968
			mp_bases_inst.gmpn_bases[196].big_base := (1_475_789_056).to_natural_32
			mp_bases_inst.gmpn_bases[196].big_base_inverted := (1_954_822_942).to_natural_32
			mp_bases_inst.gmpn_bases[197].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[197].chars_per_bit_exactly := 0.1311982683517524
			mp_bases_inst.gmpn_bases[197].big_base := (1_506_138_481).to_natural_32
			mp_bases_inst.gmpn_bases[197].big_base_inverted := (1_828_886_621).to_natural_32
			mp_bases_inst.gmpn_bases[198].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[198].chars_per_bit_exactly := 0.1310726513121843
			mp_bases_inst.gmpn_bases[198].big_base := (1_536_953_616).to_natural_32
			mp_bases_inst.gmpn_bases[198].big_base_inverted := (1_706_106_478).to_natural_32
			mp_bases_inst.gmpn_bases[199].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[199].chars_per_bit_exactly := 0.1309479056113158
			mp_bases_inst.gmpn_bases[199].big_base := (1_568_239_201).to_natural_32
			mp_bases_inst.gmpn_bases[199].big_base_inverted := (1_586_388_068).to_natural_32
			mp_bases_inst.gmpn_bases[200].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[200].chars_per_bit_exactly := 0.1308240206478128
			mp_bases_inst.gmpn_bases[200].big_base := (1_600_000_000).to_natural_32
			mp_bases_inst.gmpn_bases[200].big_base_inverted := (1_469_640_227).to_natural_32
			mp_bases_inst.gmpn_bases[201].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[201].chars_per_bit_exactly := 0.1307009860033912
			mp_bases_inst.gmpn_bases[201].big_base := (1_632_240_801).to_natural_32
			mp_bases_inst.gmpn_bases[201].big_base_inverted := (1_355_774_942).to_natural_32
			mp_bases_inst.gmpn_bases[202].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[202].chars_per_bit_exactly := 0.1305787914387386
			mp_bases_inst.gmpn_bases[202].big_base := (1_664_966_416).to_natural_32
			mp_bases_inst.gmpn_bases[202].big_base_inverted := (1_244_707_227).to_natural_32
			mp_bases_inst.gmpn_bases[203].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[203].chars_per_bit_exactly := 0.1304574268895465
			mp_bases_inst.gmpn_bases[203].big_base := (1_698_181_681).to_natural_32
			mp_bases_inst.gmpn_bases[203].big_base_inverted := (1_136_355_005).to_natural_32
			mp_bases_inst.gmpn_bases[204].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[204].chars_per_bit_exactly := 0.1303368824626505
			mp_bases_inst.gmpn_bases[204].big_base := (1_731_891_456).to_natural_32
			mp_bases_inst.gmpn_bases[204].big_base_inverted := (1_030_638_996).to_natural_32
			mp_bases_inst.gmpn_bases[205].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[205].chars_per_bit_exactly := 0.1302171484322746
			mp_bases_inst.gmpn_bases[205].big_base := (1_766_100_625).to_natural_32
			mp_bases_inst.gmpn_bases[205].big_base_inverted := (927_482_606).to_natural_32
			mp_bases_inst.gmpn_bases[206].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[206].chars_per_bit_exactly := 0.1300982152363760
			mp_bases_inst.gmpn_bases[206].big_base := (1_800_814_096).to_natural_32
			mp_bases_inst.gmpn_bases[206].big_base_inverted := (826_811_824).to_natural_32
			mp_bases_inst.gmpn_bases[207].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[207].chars_per_bit_exactly := 0.1299800734730872
			mp_bases_inst.gmpn_bases[207].big_base := (1_836_036_801).to_natural_32
			mp_bases_inst.gmpn_bases[207].big_base_inverted := (728_555_125).to_natural_32
			mp_bases_inst.gmpn_bases[208].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[208].chars_per_bit_exactly := 0.1298627138972530
			mp_bases_inst.gmpn_bases[208].big_base := (1_871_773_696).to_natural_32
			mp_bases_inst.gmpn_bases[208].big_base_inverted := (632_643_374).to_natural_32
			mp_bases_inst.gmpn_bases[209].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[209].chars_per_bit_exactly := 0.1297461274170591
			mp_bases_inst.gmpn_bases[209].big_base := (1_908_029_761).to_natural_32
			mp_bases_inst.gmpn_bases[209].big_base_inverted := (539_009_733).to_natural_32
			mp_bases_inst.gmpn_bases[210].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[210].chars_per_bit_exactly := 0.1296303050907487
			mp_bases_inst.gmpn_bases[210].big_base := (1_944_810_000).to_natural_32
			mp_bases_inst.gmpn_bases[210].big_base_inverted := (447_589_579).to_natural_32
			mp_bases_inst.gmpn_bases[211].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[211].chars_per_bit_exactly := 0.1295152381234257
			mp_bases_inst.gmpn_bases[211].big_base := (1_982_119_441).to_natural_32
			mp_bases_inst.gmpn_bases[211].big_base_inverted := (358_320_415).to_natural_32
			mp_bases_inst.gmpn_bases[212].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[212].chars_per_bit_exactly := 0.1294009178639407
			mp_bases_inst.gmpn_bases[212].big_base := (2_019_963_136).to_natural_32
			mp_bases_inst.gmpn_bases[212].big_base_inverted := (271_141_794).to_natural_32
			mp_bases_inst.gmpn_bases[213].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[213].chars_per_bit_exactly := 0.1292873358018581
			mp_bases_inst.gmpn_bases[213].big_base := (2_058_346_161).to_natural_32
			mp_bases_inst.gmpn_bases[213].big_base_inverted := (185_995_241).to_natural_32
			mp_bases_inst.gmpn_bases[214].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[214].chars_per_bit_exactly := 0.1291744835645007
			mp_bases_inst.gmpn_bases[214].big_base := (2_097_273_616).to_natural_32
			mp_bases_inst.gmpn_bases[214].big_base_inverted := (102_824_182).to_natural_32
			mp_bases_inst.gmpn_bases[215].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[215].chars_per_bit_exactly := 0.1290623529140715
			mp_bases_inst.gmpn_bases[215].big_base := (2_136_750_625).to_natural_32
			mp_bases_inst.gmpn_bases[215].big_base_inverted := (21_573_871).to_natural_32
			mp_bases_inst.gmpn_bases[216].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[216].chars_per_bit_exactly := 0.1289509357448472
			mp_bases_inst.gmpn_bases[216].big_base := {NATURAL_32} 2_176_782_336
			mp_bases_inst.gmpn_bases[216].big_base_inverted := {NATURAL_32} 4_179_349_942
			mp_bases_inst.gmpn_bases[217].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[217].chars_per_bit_exactly := 0.1288402240804449
			mp_bases_inst.gmpn_bases[217].big_base := {NATURAL_32} 2_217_373_921
			mp_bases_inst.gmpn_bases[217].big_base_inverted := {NATURAL_32} 4_024_217_799
			mp_bases_inst.gmpn_bases[218].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[218].chars_per_bit_exactly := 0.1287302100711567
			mp_bases_inst.gmpn_bases[218].big_base := {NATURAL_32} 2_258_530_576
			mp_bases_inst.gmpn_bases[218].big_base_inverted := {NATURAL_32} 3_872_619_306
			mp_bases_inst.gmpn_bases[219].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[219].chars_per_bit_exactly := 0.1286208859913518
			mp_bases_inst.gmpn_bases[219].big_base := {NATURAL_32} 2_300_257_521
			mp_bases_inst.gmpn_bases[219].big_base_inverted := {NATURAL_32} 3_724_458_314
			mp_bases_inst.gmpn_bases[220].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[220].chars_per_bit_exactly := 0.1285122442369443
			mp_bases_inst.gmpn_bases[220].big_base := {NATURAL_32} 2_342_560_000
			mp_bases_inst.gmpn_bases[220].big_base_inverted := {NATURAL_32} 3_579_641_710
			mp_bases_inst.gmpn_bases[221].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[221].chars_per_bit_exactly := 0.1284042773229231
			mp_bases_inst.gmpn_bases[221].big_base := {NATURAL_32} 2_385_443_281
			mp_bases_inst.gmpn_bases[221].big_base_inverted := {NATURAL_32} 3_438_079_312
			mp_bases_inst.gmpn_bases[222].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[222].chars_per_bit_exactly := 0.1282969778809442
			mp_bases_inst.gmpn_bases[222].big_base := {NATURAL_32} 2_428_912_656
			mp_bases_inst.gmpn_bases[222].big_base_inverted := {NATURAL_32} 3_299_683_762
			mp_bases_inst.gmpn_bases[223].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[223].chars_per_bit_exactly := 0.1281903386569819
			mp_bases_inst.gmpn_bases[223].big_base := {NATURAL_32} 2_472_973_441
			mp_bases_inst.gmpn_bases[223].big_base_inverted := {NATURAL_32} 3_164_370_425
			mp_bases_inst.gmpn_bases[224].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[224].chars_per_bit_exactly := 0.1280843525090381
			mp_bases_inst.gmpn_bases[224].big_base := {NATURAL_32} 2_517_630_976
			mp_bases_inst.gmpn_bases[224].big_base_inverted := {NATURAL_32} 3_032_057_295
			mp_bases_inst.gmpn_bases[225].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[225].chars_per_bit_exactly := 0.1279790124049077
			mp_bases_inst.gmpn_bases[225].big_base := {NATURAL_32} 2_562_890_625
			mp_bases_inst.gmpn_bases[225].big_base_inverted := {NATURAL_32} 2_902_664_898
			mp_bases_inst.gmpn_bases[226].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[226].chars_per_bit_exactly := 0.1278743114199984
			mp_bases_inst.gmpn_bases[226].big_base := {NATURAL_32} 2_608_757_776
			mp_bases_inst.gmpn_bases[226].big_base_inverted := {NATURAL_32} 2_776_116_207
			mp_bases_inst.gmpn_bases[227].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[227].chars_per_bit_exactly := 0.1277702427352035
			mp_bases_inst.gmpn_bases[227].big_base := {NATURAL_32} 2_655_237_841
			mp_bases_inst.gmpn_bases[227].big_base_inverted := {NATURAL_32} 2_652_336_553
			mp_bases_inst.gmpn_bases[228].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[228].chars_per_bit_exactly := 0.1276667996348261
			mp_bases_inst.gmpn_bases[228].big_base := {NATURAL_32} 2_702_336_256
			mp_bases_inst.gmpn_bases[228].big_base_inverted := {NATURAL_32} 2_531_253_546
			mp_bases_inst.gmpn_bases[229].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[229].chars_per_bit_exactly := 0.1275639755045533
			mp_bases_inst.gmpn_bases[229].big_base := {NATURAL_32} 2_750_058_481
			mp_bases_inst.gmpn_bases[229].big_base_inverted := {NATURAL_32} 2_412_796_993
			mp_bases_inst.gmpn_bases[230].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[230].chars_per_bit_exactly := 0.1274617638294791
			mp_bases_inst.gmpn_bases[230].big_base := {NATURAL_32} 2_798_410_000
			mp_bases_inst.gmpn_bases[230].big_base_inverted := {NATURAL_32} 2_296_898_825
			mp_bases_inst.gmpn_bases[231].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[231].chars_per_bit_exactly := 0.1273601581921741
			mp_bases_inst.gmpn_bases[231].big_base := {NATURAL_32} 2_847_396_321
			mp_bases_inst.gmpn_bases[231].big_base_inverted := {NATURAL_32} 2_183_493_021
			mp_bases_inst.gmpn_bases[232].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[232].chars_per_bit_exactly := 0.1272591522708010
			mp_bases_inst.gmpn_bases[232].big_base := {NATURAL_32} 2_897_022_976
			mp_bases_inst.gmpn_bases[232].big_base_inverted := (2_072_515_539).to_natural_32
			mp_bases_inst.gmpn_bases[233].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[233].chars_per_bit_exactly := 0.1271587398372755
			mp_bases_inst.gmpn_bases[233].big_base := {NATURAL_32} 2_947_295_521
			mp_bases_inst.gmpn_bases[233].big_base_inverted := (1_963_904_249).to_natural_32
			mp_bases_inst.gmpn_bases[234].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[234].chars_per_bit_exactly := 0.1270589147554692
			mp_bases_inst.gmpn_bases[234].big_base := {NATURAL_32} 2_998_219_536
			mp_bases_inst.gmpn_bases[234].big_base_inverted := (1_857_598_869).to_natural_32
			mp_bases_inst.gmpn_bases[235].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[235].chars_per_bit_exactly := 0.1269596709794558
			mp_bases_inst.gmpn_bases[235].big_base := {NATURAL_32} 3_049_800_625
			mp_bases_inst.gmpn_bases[235].big_base_inverted := (1_753_540_899).to_natural_32
			mp_bases_inst.gmpn_bases[236].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[236].chars_per_bit_exactly := 0.1268610025517973
			mp_bases_inst.gmpn_bases[236].big_base := {NATURAL_32} 3_102_044_416
			mp_bases_inst.gmpn_bases[236].big_base_inverted := (1_651_673_563).to_natural_32
			mp_bases_inst.gmpn_bases[237].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[237].chars_per_bit_exactly := 0.1267629036018709
			mp_bases_inst.gmpn_bases[237].big_base := {NATURAL_32} 3_154_956_561
			mp_bases_inst.gmpn_bases[237].big_base_inverted := (1_551_941_755).to_natural_32
			mp_bases_inst.gmpn_bases[238].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[238].chars_per_bit_exactly := 0.1266653683442337
			mp_bases_inst.gmpn_bases[238].big_base := {NATURAL_32} 3_208_542_736
			mp_bases_inst.gmpn_bases[238].big_base_inverted := (1_454_291_975).to_natural_32
			mp_bases_inst.gmpn_bases[239].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[239].chars_per_bit_exactly := 0.1265683910770258
			mp_bases_inst.gmpn_bases[239].big_base := {NATURAL_32} 3_262_808_641
			mp_bases_inst.gmpn_bases[239].big_base_inverted := (1_358_672_283).to_natural_32
			mp_bases_inst.gmpn_bases[240].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[240].chars_per_bit_exactly := 0.1264719661804097
			mp_bases_inst.gmpn_bases[240].big_base := {NATURAL_32} 3_317_760_000
			mp_bases_inst.gmpn_bases[240].big_base_inverted := (1_265_032_243).to_natural_32
			mp_bases_inst.gmpn_bases[241].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[241].chars_per_bit_exactly := 0.1263760881150453
			mp_bases_inst.gmpn_bases[241].big_base := {NATURAL_32} 3_373_402_561
			mp_bases_inst.gmpn_bases[241].big_base_inverted := (1_173_322_876).to_natural_32
			mp_bases_inst.gmpn_bases[242].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[242].chars_per_bit_exactly := 0.1262807514205999
			mp_bases_inst.gmpn_bases[242].big_base := {NATURAL_32} 3_429_742_096
			mp_bases_inst.gmpn_bases[242].big_base_inverted := (1_083_496_611).to_natural_32
			mp_bases_inst.gmpn_bases[243].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[243].chars_per_bit_exactly := 0.1261859507142915
			mp_bases_inst.gmpn_bases[243].big_base := {NATURAL_32} 3_486_784_401
			mp_bases_inst.gmpn_bases[243].big_base_inverted := (995_507_236).to_natural_32
			mp_bases_inst.gmpn_bases[244].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[244].chars_per_bit_exactly := 0.1260916806894653
			mp_bases_inst.gmpn_bases[244].big_base := {NATURAL_32} 3_544_535_296
			mp_bases_inst.gmpn_bases[244].big_base_inverted := (909_309_861).to_natural_32
			mp_bases_inst.gmpn_bases[245].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[245].chars_per_bit_exactly := 0.1259979361142023
			mp_bases_inst.gmpn_bases[245].big_base := {NATURAL_32} 3_603_000_625
			mp_bases_inst.gmpn_bases[245].big_base_inverted := (824_860_867).to_natural_32
			mp_bases_inst.gmpn_bases[246].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[246].chars_per_bit_exactly := 0.1259047118299582
			mp_bases_inst.gmpn_bases[246].big_base := {NATURAL_32} 3_662_186_256
			mp_bases_inst.gmpn_bases[246].big_base_inverted := (742_117_872).to_natural_32
			mp_bases_inst.gmpn_bases[247].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[247].chars_per_bit_exactly := 0.1258120027502338
			mp_bases_inst.gmpn_bases[247].big_base := {NATURAL_32} 3_722_098_081
			mp_bases_inst.gmpn_bases[247].big_base_inverted := (661_039_685).to_natural_32
			mp_bases_inst.gmpn_bases[248].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[248].chars_per_bit_exactly := 0.1257198038592741
			mp_bases_inst.gmpn_bases[248].big_base := {NATURAL_32} 3_782_742_016
			mp_bases_inst.gmpn_bases[248].big_base_inverted := (581_586_271).to_natural_32
			mp_bases_inst.gmpn_bases[249].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[249].chars_per_bit_exactly := 0.1256281102107963
			mp_bases_inst.gmpn_bases[249].big_base := {NATURAL_32} 3_844_124_001
			mp_bases_inst.gmpn_bases[249].big_base_inverted := (503_718_716).to_natural_32
			mp_bases_inst.gmpn_bases[250].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[250].chars_per_bit_exactly := 0.1255369169267456
			mp_bases_inst.gmpn_bases[250].big_base := {NATURAL_32} 3_906_250_000
			mp_bases_inst.gmpn_bases[250].big_base_inverted := (427_399_186).to_natural_32
			mp_bases_inst.gmpn_bases[251].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[251].chars_per_bit_exactly := 0.1254462191960791
			mp_bases_inst.gmpn_bases[251].big_base := {NATURAL_32} 3_969_126_001
			mp_bases_inst.gmpn_bases[251].big_base_inverted := (352_590_899).to_natural_32
			mp_bases_inst.gmpn_bases[252].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[252].chars_per_bit_exactly := 0.1253560122735751
			mp_bases_inst.gmpn_bases[252].big_base := {NATURAL_32} 4_032_758_016
			mp_bases_inst.gmpn_bases[252].big_base_inverted := (279_258_085).to_natural_32
			mp_bases_inst.gmpn_bases[253].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[253].chars_per_bit_exactly := 0.1252662914786691
			mp_bases_inst.gmpn_bases[253].big_base := {NATURAL_32} 4_097_152_081
			mp_bases_inst.gmpn_bases[253].big_base_inverted := (207_365_961).to_natural_32
			mp_bases_inst.gmpn_bases[254].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[254].chars_per_bit_exactly := 0.1251770521943144
			mp_bases_inst.gmpn_bases[254].big_base := {NATURAL_32} 4_162_314_256
			mp_bases_inst.gmpn_bases[254].big_base_inverted := (136_880_695).to_natural_32
			mp_bases_inst.gmpn_bases[255].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[255].chars_per_bit_exactly := 0.1250882898658681
			mp_bases_inst.gmpn_bases[255].big_base := {NATURAL_32} 4_228_250_625
			mp_bases_inst.gmpn_bases[255].big_base_inverted := (67_769_379).to_natural_32
			mp_bases_inst.gmpn_bases[256].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[256].chars_per_bit_exactly := 0.1250000000000000
			mp_bases_inst.gmpn_bases[256].big_base := (8).to_natural_32
			mp_bases_inst.gmpn_bases[256].big_base_inverted := {NATURAL_32} 0;
			(mul_fft_inst.mpn_fft_table3[0])[0].n := {NATURAL_32} 565;
			(mul_fft_inst.mpn_fft_table3[0])[0].k := {NATURAL_32} 5;
			(mul_fft_inst.mpn_fft_table3[0])[1].n := {NATURAL_32} 25;
			(mul_fft_inst.mpn_fft_table3[0])[1].k := {NATURAL_32} 6;
			(mul_fft_inst.mpn_fft_table3[0])[2].n := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[0])[2].k := {NATURAL_32} 5;
			(mul_fft_inst.mpn_fft_table3[0])[3].n := {NATURAL_32} 27;
			(mul_fft_inst.mpn_fft_table3[0])[3].k := {NATURAL_32} 6;
			(mul_fft_inst.mpn_fft_table3[0])[4].n := {NATURAL_32} 25;
			(mul_fft_inst.mpn_fft_table3[0])[4].k := {NATURAL_32} 7;
			(mul_fft_inst.mpn_fft_table3[0])[5].n := {NATURAL_32} 13;
			(mul_fft_inst.mpn_fft_table3[0])[5].k := {NATURAL_32} 6;
			(mul_fft_inst.mpn_fft_table3[0])[6].n := {NATURAL_32} 28;
			(mul_fft_inst.mpn_fft_table3[0])[6].k := {NATURAL_32} 7;
			(mul_fft_inst.mpn_fft_table3[0])[7].n := {NATURAL_32} 15;
			(mul_fft_inst.mpn_fft_table3[0])[7].k := {NATURAL_32} 6
		end

end
