frozen class
	LIBGMP_INITIALIZER_SLICE8

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {LIBGMP_INITIALIZER}

	initialize
		do
			trialdivtab_inst.gmp_primes_dtab[0].lim := (1_431_655_765).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[1].binv := {NATURAL_32} 3_435_973_837
			trialdivtab_inst.gmp_primes_dtab[1].lim := (858_993_459).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[2].binv := {NATURAL_32} 3_067_833_783
			trialdivtab_inst.gmp_primes_dtab[2].lim := (613_566_756).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[3].binv := {NATURAL_32} 3_123_612_579
			trialdivtab_inst.gmp_primes_dtab[3].lim := (390_451_572).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[4].binv := {NATURAL_32} 3_303_820_997
			trialdivtab_inst.gmp_primes_dtab[4].lim := (330_382_099).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[5].binv := {NATURAL_32} 4_042_322_161
			trialdivtab_inst.gmp_primes_dtab[5].lim := (252_645_135).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[6].binv := (678_152_731).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[6].lim := (226_050_910).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[7].binv := {NATURAL_32} 3_921_491_879
			trialdivtab_inst.gmp_primes_dtab[7].lim := (186_737_708).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[8].binv := (1_332_920_885).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[8].lim := (148_102_320).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[9].binv := {NATURAL_32} 3_186_588_639
			trialdivtab_inst.gmp_primes_dtab[9].lim := (138_547_332).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[10].binv := {NATURAL_32} 2_437_684_141
			trialdivtab_inst.gmp_primes_dtab[10].lim := (116_080_197).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[11].binv := {NATURAL_32} 3_247_414_297
			trialdivtab_inst.gmp_primes_dtab[11].lim := (104_755_299).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[12].binv := (799_063_683).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[12].lim := (99_882_960).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[13].binv := (1_736_263_375).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[13].lim := (91_382_282).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[14].binv := {NATURAL_32} 2_350_076_445
			trialdivtab_inst.gmp_primes_dtab[14].lim := (81_037_118).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[15].binv := {NATURAL_32} 2_693_454_067
			trialdivtab_inst.gmp_primes_dtab[15].lim := (72_796_055).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[16].binv := {NATURAL_32} 3_238_827_797
			trialdivtab_inst.gmp_primes_dtab[16].lim := (70_409_299).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[17].binv := (128_207_979).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[17].lim := (64_103_989).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[18].binv := {NATURAL_32} 3_811_027_319
			trialdivtab_inst.gmp_primes_dtab[18].lim := (60_492_497).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[19].binv := {NATURAL_32} 3_353_604_601
			trialdivtab_inst.gmp_primes_dtab[19].lim := (58_835_168).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[20].binv := (1_631_000_239).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[20].lim := (54_366_674).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[21].binv := (724_452_315).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[21].lim := (51_746_593).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[22].binv := {NATURAL_32} 4_198_451_177
			trialdivtab_inst.gmp_primes_dtab[22].lim := (48_258_059).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[23].binv := (1_594_008_481).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[23].lim := (44_278_013).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[24].binv := (2_083_697_005).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[24].lim := (42_524_428).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[25].binv := {NATURAL_32} 3_544_390_487
			trialdivtab_inst.gmp_primes_dtab[25].lim := (41_698_711).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[26].binv := {NATURAL_32} 2_368_252_995
			trialdivtab_inst.gmp_primes_dtab[26].lim := (40_139_881).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[27].binv := {NATURAL_32} 3_664_513_381
			trialdivtab_inst.gmp_primes_dtab[27].lim := (39_403_369).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[28].binv := (266_059_921).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[28].lim := (38_008_560).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[29].binv := {NATURAL_32} 4_024_418_175
			trialdivtab_inst.gmp_primes_dtab[29].lim := (33_818_640).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[30].binv := {NATURAL_32} 3_376_959_019
			trialdivtab_inst.gmp_primes_dtab[30].lim := (32_786_009).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[31].binv := (125_400_505).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[31].lim := (31_350_126).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[32].binv := (1_884_841_763).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[32].lim := (30_899_045).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[33].binv := {NATURAL_32} 2_363_673_277
			trialdivtab_inst.gmp_primes_dtab[33].lim := (28_825_283).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[34].binv := {NATURAL_32} 3_214_114_599
			trialdivtab_inst.gmp_primes_dtab[34].lim := (28_443_492).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[35].binv := (738_624_949).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[35].lim := (27_356_479).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[36].binv := (1_159_377_675).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[36].lim := (26_349_492).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[37].binv := {NATURAL_32} 3_677_726_487
			trialdivtab_inst.gmp_primes_dtab[37].lim := (25_718_367).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[38].binv := (223_437_605).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[38].lim := (24_826_400).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[39].binv := {NATURAL_32} 3_647_123_067
			trialdivtab_inst.gmp_primes_dtab[39].lim := (23_994_230).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[40].binv := (284_749_213).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[40].lim := (23_729_101).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[41].binv := {NATURAL_32} 4_002_639_679
			trialdivtab_inst.gmp_primes_dtab[41].lim := (22_486_739).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[42].binv := {NATURAL_32} 2_425_655_105
			trialdivtab_inst.gmp_primes_dtab[42].lim := (22_253_716).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[43].binv := (1_024_687_629).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[43].lim := (21_801_864).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[44].binv := {NATURAL_32} 4_014_391_543
			trialdivtab_inst.gmp_primes_dtab[44].lim := (21_582_750).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[45].binv := (1_852_331_867).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[45].lim := (20_355_295).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[46].binv := {NATURAL_32} 3_678_649_119
			trialdivtab_inst.gmp_primes_dtab[46].lim := (19_259_943).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[47].binv := {NATURAL_32} 2_611_037_387
			trialdivtab_inst.gmp_primes_dtab[47].lim := (18_920_560).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[48].binv := (1_200_340_205).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[48].lim := (18_755_315).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[49].binv := (534_566_745).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[49].lim := (18_433_336).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[50].binv := (1_132_146_191).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[50].lim := (17_970_574).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[51].binv := (285_143_057).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[51].lim := (17_821_441).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[52].binv := {NATURAL_32} 2_583_824_947
			trialdivtab_inst.gmp_primes_dtab[52].lim := (17_111_423).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[53].binv := {NATURAL_32} 4_278_255_361
			trialdivtab_inst.gmp_primes_dtab[53].lim := (16_711_935).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[54].binv := (1_894_358_199).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[54].lim := (16_330_674).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[55].binv := (1_644_541_381).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[55].lim := (15_966_421).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[56].binv := {NATURAL_32} 2_725_957_103
			trialdivtab_inst.gmp_primes_dtab[56].lim := (15_848_587).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[57].binv := (635_717_181).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[57].lim := (15_505_297).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[58].binv := (122_276_649).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[58].lim := (15_284_581).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[59].binv := {NATURAL_32} 3_384_373_523
			trialdivtab_inst.gmp_primes_dtab[59].lim := (15_176_562).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[60].binv := {NATURAL_32} 2_228_105_901
			trialdivtab_inst.gmp_primes_dtab[60].lim := (14_658_591).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[61].binv := {NATURAL_32} 3_343_639_035
			trialdivtab_inst.gmp_primes_dtab[61].lim := (13_990_121).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[62].binv := {NATURAL_32} 2_803_467_399
			trialdivtab_inst.gmp_primes_dtab[62].lim := (13_810_184).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[63].binv := (960_535_817).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[63].lim := (13_721_940).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[64].binv := (1_869_733_397).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[64].lim := (13_548_792).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[65].binv := {NATURAL_32} 3_217_981_539
			trialdivtab_inst.gmp_primes_dtab[65].lim := (12_975_732).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[66].binv := {NATURAL_32} 4_129_286_065
			trialdivtab_inst.gmp_primes_dtab[66].lim := (12_744_710).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[67].binv := (1_893_746_387).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[67].lim := (12_377_427).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[68].binv := {NATURAL_32} 4_048_837_365
			trialdivtab_inst.gmp_primes_dtab[68].lim := (12_306_496).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[69].binv := {NATURAL_32} 2_591_580_833
			trialdivtab_inst.gmp_primes_dtab[69].lim := (12_167_046).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[70].binv := (705_858_135).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[70].lim := (11_963_697).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[71].binv := {NATURAL_32} 3_077_864_847
			trialdivtab_inst.gmp_primes_dtab[71].lim := (11_702_908).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[72].binv := {NATURAL_32} 3_143_501_533
			trialdivtab_inst.gmp_primes_dtab[72].lim := (11_514_657).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[73].binv := (317_306_291).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[73].lim := (11_332_367).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[74].binv := {NATURAL_32} 3_969_760_895
			trialdivtab_inst.gmp_primes_dtab[74].lim := (11_214_013).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[75].binv := {NATURAL_32} 3_963_735_885
			trialdivtab_inst.gmp_primes_dtab[75].lim := (11_041_047).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[76].binv := {NATURAL_32} 2_931_829_061
			trialdivtab_inst.gmp_primes_dtab[76].lim := (10_818_557).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[77].binv := {NATURAL_32} 2_206_392_177
			trialdivtab_inst.gmp_primes_dtab[77].lim := (10_710_641).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[78].binv := {NATURAL_32} 2_226_242_217
			trialdivtab_inst.gmp_primes_dtab[78].lim := (10_501_142).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[79].binv := (1_978_350_091).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[79].lim := (10_250_518).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[80].binv := {NATURAL_32} 4_203_150_893
			trialdivtab_inst.gmp_primes_dtab[80].lim := (10_201_822).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[81].binv := (1_066_267_983).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[81].lim := (9_965_121).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[82].binv := (158_705_489).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[82].lim := (9_919_093).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[83].binv := {NATURAL_32} 3_287_264_263
			trialdivtab_inst.gmp_primes_dtab[83].lim := (9_783_524).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[84].binv := {NATURAL_32} 2_821_299_059
			trialdivtab_inst.gmp_primes_dtab[84].lim := (9_695_185).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[85].binv := {NATURAL_32} 2_611_416_641
			trialdivtab_inst.gmp_primes_dtab[85].lim := (9_565_628).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[86].binv := (601_483_385).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[86].lim := (9_398_177).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[87].binv := {NATURAL_32} 3_298_087_685
			trialdivtab_inst.gmp_primes_dtab[87].lim := (9_316_631).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[88].binv := {NATURAL_32} 2_875_680_047
			trialdivtab_inst.gmp_primes_dtab[88].lim := (9_276_387).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[89].binv := {NATURAL_32} 4_212_194_907
			trialdivtab_inst.gmp_primes_dtab[89].lim := (9_196_932).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[90].binv := {NATURAL_32} 3_210_017_311
			trialdivtab_inst.gmp_primes_dtab[90].lim := (8_966_528).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[91].binv := {NATURAL_32} 3_113_189_847
			trialdivtab_inst.gmp_primes_dtab[91].lim := (8_819_234).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[92].binv := {NATURAL_32} 3_910_082_243
			trialdivtab_inst.gmp_primes_dtab[92].lim := (8_747_387).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[93].binv := {NATURAL_32} 3_201_859_387
			trialdivtab_inst.gmp_primes_dtab[93].lim := (8_607_148).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[94].binv := (384_241_607).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[94].lim := (8_538_702).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[95].binv := {NATURAL_32} 2_649_547_605
			trialdivtab_inst.gmp_primes_dtab[95].lim := (8_438_049).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[96].binv := (1_945_513_017).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[96].lim := (8_243_699).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[97].binv := {NATURAL_32} 2_907_109_795
			trialdivtab_inst.gmp_primes_dtab[97].lim := (8_212_174).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[98].binv := (619_237_429).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[98].lim := (7_938_941).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[99].binv := (588_889_483).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[99].lim := (7_851_859).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[100].binv := {NATURAL_32} 3_354_238_373
			trialdivtab_inst.gmp_primes_dtab[100].lim := (7_710_892).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[101].binv := {NATURAL_32} 4_272_081_147
			trialdivtab_inst.gmp_primes_dtab[101].lim := (7_628_716).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[102].binv := {NATURAL_32} 3_457_109_001
			trialdivtab_inst.gmp_primes_dtab[102].lim := (7_548_272).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[103].binv := (1_414_104_819).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[103].lim := (7_521_834).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[104].binv := (1_436_618_177).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[104].lim := (7_443_617).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[105].binv := {NATURAL_32} 2_246_260_579
			trialdivtab_inst.gmp_primes_dtab[105].lim := (7_316_809).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[106].binv := {NATURAL_32} 3_628_631_729
			trialdivtab_inst.gmp_primes_dtab[106].lim := (7_242_777).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[107].binv := (824_576_359).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[107].lim := (7_170_229).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[108].binv := {NATURAL_32} 3_523_159_529
			trialdivtab_inst.gmp_primes_dtab[108].lim := (7_146_368).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[109].binv := (1_535_433_119).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[109].lim := (7_075_728).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[110].binv := (322_297_709).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[110].lim := (7_006_471).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[111].binv := (1_976_937_945).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[111].lim := (6_961_049).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[112].binv := (1_013_029_443).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[112].lim := (6_938_557).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[113].binv := (74_872_647).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[113].lim := (6_806_604).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[114].binv := (6_700_417).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[114].lim := (6_700_416).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[115].binv := (1_730_010_155).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[115].lim := (6_679_575).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[116].binv := {NATURAL_32} 3_252_757_303
			trialdivtab_inst.gmp_primes_dtab[116].lim := (6_638_280).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[117].binv := {NATURAL_32} 2_630_914_117
			trialdivtab_inst.gmp_primes_dtab[117].lim := (6_577_285).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[118].binv := {NATURAL_32} 2_437_507_995
			trialdivtab_inst.gmp_primes_dtab[118].lim := (6_517_401).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[119].binv := {NATURAL_32} 3_352_803_517
			trialdivtab_inst.gmp_primes_dtab[119].lim := (6_497_681).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[120].binv := {NATURAL_32} 2_667_602_273
			trialdivtab_inst.gmp_primes_dtab[120].lim := (6_381_823).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[121].binv := (1_579_685_165).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[121].lim := (6_344_117).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[122].binv := (12_576_771).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[122].lim := (6_288_385).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[123].binv := {NATURAL_32} 2_660_269_179
			trialdivtab_inst.gmp_primes_dtab[123].lim := (6_215_582).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[124].binv := (1_985_120_405).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[124].lim := (6_126_914).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[125].binv := (30_288_909).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[125].lim := (6_057_781).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[126].binv := {NATURAL_32} 3_201_811_503
			trialdivtab_inst.gmp_primes_dtab[126].lim := (5_973_528).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[127].binv := {NATURAL_32} 3_568_308_455
			trialdivtab_inst.gmp_primes_dtab[127].lim := (5_907_795).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[128].binv := (515_630_453).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[128].lim := (5_859_436).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[129].binv := {NATURAL_32} 3_027_981_003
			trialdivtab_inst.gmp_primes_dtab[129].lim := (5_811_863).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[130].binv := (1_693_708_503).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[130].lim := (5_780_575).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[131].binv := (829_254_671).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[131].lim := (5_718_997).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[132].binv := {NATURAL_32} 2_445_351_261
			trialdivtab_inst.gmp_primes_dtab[132].lim := (5_673_668).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[133].binv := {NATURAL_32} 2_725_977_929
			trialdivtab_inst.gmp_primes_dtab[133].lim := (5_643_846).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[134].binv := {NATURAL_32} 3_842_571_521
			trialdivtab_inst.gmp_primes_dtab[134].lim := (5_585_133).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[135].binv := (322_261_453).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[135].lim := (5_556_231).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[136].binv := (764_034_843).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[136].lim := (5_457_391).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[137].binv := {NATURAL_32} 3_276_461_877
			trialdivtab_inst.gmp_primes_dtab[137].lim := (5_388_917).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[138].binv := (175_196_441).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[138].lim := (5_308_983).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[139].binv := (619_619_203).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[139].lim := (5_295_890).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[140].binv := (1_119_516_445).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[140].lim := (5_231_385).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[141].binv := (125_248_135).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[141].lim := (5_218_672).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[142].binv := (1_583_996_403).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[142].lim := (5_193_430).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[143].binv := (994_733_077).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[143].lim := (5_180_901).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[144].binv := {NATURAL_32} 3_322_328_695
			trialdivtab_inst.gmp_primes_dtab[144].lim := (5_119_150).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[145].binv := (1_188_291_069).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[145].lim := (5_035_131).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[146].binv := (1_212_814_569).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[146].lim := (5_011_630).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[147].binv := (484_996_307).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[147].lim := (4_999_961).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[148].binv := (74_651_807).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[148].lim := (4_976_787).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[149].binv := (925_597_285).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[149].lim := (4_897_340).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[150].binv := (1_335_778_705).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[150].lim := (4_875_104).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[151].binv := (1_147_918_779).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[151].lim := (4_864_062).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[152].binv := {NATURAL_32} 3_883_386_439
			trialdivtab_inst.gmp_primes_dtab[152].lim := (4_842_127).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[153].binv := {NATURAL_32} 4_129_229_859
			trialdivtab_inst.gmp_primes_dtab[153].lim := (4_735_355).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[154].binv := {NATURAL_32} 2_781_592_431
			trialdivtab_inst.gmp_primes_dtab[154].lim := (4_714_563).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[155].binv := (1_775_938_599).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[155].lim := (4_673_522).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[156].binv := (1_668_980_833).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[156].lim := (4_623_215).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[157].binv := (531_714_201).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[157].lim := (4_583_743).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[158].binv := (1_898_731_557).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[158].lim := (4_564_258).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[159].binv := {NATURAL_32} 4_281_361_275
			trialdivtab_inst.gmp_primes_dtab[159].lim := (4_535_340).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[160].binv := (18_027_145).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[160].lim := (4_506_786).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[161].binv := (257_609_207).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[161].lim := (4_441_538).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[162].binv := (1_296_009_699).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[162].lim := (4_423_241).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[163].binv := {NATURAL_32} 3_525_653_809
			trialdivtab_inst.gmp_primes_dtab[163].lim := (4_396_077).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[164].binv := (2_079_760_359).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[164].lim := (4_369_244).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[165].binv := {NATURAL_32} 3_484_514_335
			trialdivtab_inst.gmp_primes_dtab[165].lim := (4_333_973).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[166].binv := (831_422_957).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[166].lim := (4_307_890).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[167].binv := {NATURAL_32} 2_668_924_177
			trialdivtab_inst.gmp_primes_dtab[167].lim := (4_256_657).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[168].binv := (746_213_469).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[168].lim := (4_239_849).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[169].binv := (678_596_403).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[169].lim := (4_214_884).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[170].binv := {NATURAL_32} 3_857_477_973
			trialdivtab_inst.gmp_primes_dtab[170].lim := (4_206_628).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[171].binv := {NATURAL_32} 2_682_792_375
			trialdivtab_inst.gmp_primes_dtab[171].lim := (4_165_826).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[172].binv := (1_783_679_545).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[172].lim := (4_157_761).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[173].binv := {NATURAL_32} 3_067_243_247
			trialdivtab_inst.gmp_primes_dtab[173].lim := (4_133_751).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[174].binv := {NATURAL_32} 2_821_003_305
			trialdivtab_inst.gmp_primes_dtab[174].lim := (4_094_344).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[175].binv := (461_780_499).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[175].lim := (4_086_553).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[176].binv := (550_533_037).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[176].lim := (4_048_037).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[177].binv := (775_760_791).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[177].lim := (4_040_420).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[178].binv := (1_036_577_701).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[178].lim := (4_017_743).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[179].binv := (841_608_127).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[179].lim := (3_951_211).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[180].binv := (2_114_021_483).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[180].lim := (3_936_725).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[181].binv := (738_750_093).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[181].lim := (3_929_521).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[182].binv := {NATURAL_32} 2_674_077_177
			trialdivtab_inst.gmp_primes_dtab[182].lim := (3_915_193).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[183].binv := {NATURAL_32} 3_757_609_647
			trialdivtab_inst.gmp_primes_dtab[183].lim := (3_893_896).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[184].binv := (1_057_282_301).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[184].lim := (3_872_828).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[185].binv := {NATURAL_32} 2_633_887_733
			trialdivtab_inst.gmp_primes_dtab[185].lim := (3_845_091).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[186].binv := (198_876_491).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[186].lim := (3_824_547).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[187].binv := (620_088_281).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[187].lim := (3_804_222).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[188].binv := {NATURAL_32} 2_496_379_775
			trialdivtab_inst.gmp_primes_dtab[188].lim := (3_731_509).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[189].binv := {NATURAL_32} 3_035_904_897
			trialdivtab_inst.gmp_primes_dtab[189].lim := (3_725_036).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[190].binv := (55_395_107).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[190].lim := (3_693_007).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[191].binv := (1_962_260_891).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[191].lim := (3_667_777).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[192].binv := {NATURAL_32} 3_331_236_277
			trialdivtab_inst.gmp_primes_dtab[192].lim := (3_636_720).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[193].binv := {NATURAL_32} 2_529_218_315
			trialdivtab_inst.gmp_primes_dtab[193].lim := (3_618_338).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[194].binv := {NATURAL_32} 3_812_548_505
			trialdivtab_inst.gmp_primes_dtab[194].lim := (3_600_140).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[195].binv := {NATURAL_32} 3_096_953_937
			trialdivtab_inst.gmp_primes_dtab[195].lim := (3_576_159).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[196].binv := {NATURAL_32} 2_411_271_829
			trialdivtab_inst.gmp_primes_dtab[196].lim := (3_540_780).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[197].binv := {NATURAL_32} 3_857_353_537
			trialdivtab_inst.gmp_primes_dtab[197].lim := (3_529_143).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[198].binv := {NATURAL_32} 2_482_863_351
			trialdivtab_inst.gmp_primes_dtab[198].lim := (3_511_829).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[199].binv := (188_712_965).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[199].lim := (3_494_684).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[200].binv := {NATURAL_32} 2_836_562_479
			trialdivtab_inst.gmp_primes_dtab[200].lim := (3_489_006).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[201].binv := (329_847_933).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[201].lim := (3_472_083).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[202].binv := (206_323_489).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[202].lim := (3_438_724).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[203].binv := (2_053_669_827).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[203].lim := (3_411_411).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[204].binv := (716_388_437).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[204].lim := (3_363_325).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[205].binv := {NATURAL_32} 2_196_175_615
			trialdivtab_inst.gmp_primes_dtab[205].lim := (3_358_066).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[206].binv := (398_364_075).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[206].lim := (3_347_597).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[207].binv := (2_092_505_401).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[207].lim := (3_332_014).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[208].binv := (1_117_822_627).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[208].lim := (3_326_853).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[209].binv := (1_837_861_873).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[209].lim := (3_311_462).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[210].binv := {NATURAL_32} 3_129_614_909
			trialdivtab_inst.gmp_primes_dtab[210].lim := (3_301_281).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[211].binv := {NATURAL_32} 2_620_490_407
			trialdivtab_inst.gmp_primes_dtab[211].lim := (3_296_214).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[212].binv := (1_196_150_035).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[212].lim := (3_286_126).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[213].binv := {NATURAL_32} 3_308_329_623
			trialdivtab_inst.gmp_primes_dtab[213].lim := (3_256_229).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[214].binv := {NATURAL_32} 3_222_038_297
			trialdivtab_inst.gmp_primes_dtab[214].lim := (3_251_299).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[215].binv := (1_259_037_135).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[215].lim := (3_236_599).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[216].binv := {NATURAL_32} 2_609_800_113
			trialdivtab_inst.gmp_primes_dtab[216].lim := (3_155_743).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[217].binv := (69_121_639).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[217].lim := (3_141_892).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[218].binv := {NATURAL_32} 2_305_455_861
			trialdivtab_inst.gmp_primes_dtab[218].lim := (3_128_162).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[219].binv := (1_247_126_637).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[219].lim := (3_110_041).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[220].binv := (1_476_682_823).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[220].lim := (3_070_026).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[221].binv := (1_774_074_497).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[221].lim := (3_048_237).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[222].binv := {NATURAL_32} 3_495_131_503
			trialdivtab_inst.gmp_primes_dtab[222].lim := (3_018_248).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[223].binv := {NATURAL_32} 2_314_526_875
			trialdivtab_inst.gmp_primes_dtab[223].lim := (3_009_787).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[224].binv := {NATURAL_32} 3_077_709_245
			trialdivtab_inst.gmp_primes_dtab[224].lim := (3_005_575).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[225].binv := (905_150_121).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[225].lim := (2_997_185).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[226].binv := {NATURAL_32} 4_074_100_319
			trialdivtab_inst.gmp_primes_dtab[226].lim := (2_984_688).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[227].binv := (911_233_559).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[227].lim := (2_968_187).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[228].binv := (1_885_523_203).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[228].lim := (2_960_005).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[229].binv := {NATURAL_32} 4_256_540_197
			trialdivtab_inst.gmp_primes_dtab[229].lim := (2_955_930).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[230].binv := (2_122_461_563).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[230].lim := (2_943_774).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[231].binv := (1_623_386_687).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[231].lim := (2_919_760).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[232].binv := {NATURAL_32} 4_031_063_161
			trialdivtab_inst.gmp_primes_dtab[232].lim := (2_900_045).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[233].binv := {NATURAL_32} 2_192_373_731
			trialdivtab_inst.gmp_primes_dtab[233].lim := (2_896_134).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[234].binv := (1_943_855_407).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[234].lim := (2_888_343).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[235].binv := {NATURAL_32} 2_244_113_201
			trialdivtab_inst.gmp_primes_dtab[235].lim := (2_884_464).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[236].binv := {NATURAL_32} 4_266_199_933
			trialdivtab_inst.gmp_primes_dtab[236].lim := (2_876_736).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[237].binv := {NATURAL_32} 2_593_025_619
			trialdivtab_inst.gmp_primes_dtab[237].lim := (2_865_221).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[238].binv := {NATURAL_32} 3_564_453_335
			trialdivtab_inst.gmp_primes_dtab[238].lim := (2_842_466).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[239].binv := {NATURAL_32} 3_299_482_427
			trialdivtab_inst.gmp_primes_dtab[239].lim := (2_820_070).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[240].binv := {NATURAL_32} 2_165_718_323
			trialdivtab_inst.gmp_primes_dtab[240].lim := (2_805_334).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[241].binv := (1_497_532_343).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[241].lim := (2_783_517).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[242].binv := (329_955_525).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[242].lim := (2_772_735).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[243].binv := {NATURAL_32} 2_378_410_737
			trialdivtab_inst.gmp_primes_dtab[243].lim := (2_765_593).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[244].binv := (1_449_103_783).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[244].lim := (2_754_950).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[245].binv := {NATURAL_32} 2_348_938_719
			trialdivtab_inst.gmp_primes_dtab[245].lim := (2_740_885).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[246].binv := {NATURAL_32} 2_351_159_691
			trialdivtab_inst.gmp_primes_dtab[246].lim := (2_733_906).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[247].binv := (19_040_387).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[247].lim := (2_720_055).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[248].binv := {NATURAL_32} 4_227_137_743
			trialdivtab_inst.gmp_primes_dtab[248].lim := (2_713_182).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[249].binv := {NATURAL_32} 3_367_125_269
			trialdivtab_inst.gmp_primes_dtab[249].lim := (2_689_397).to_natural_32
			trialdivtab_inst.gmp_primes_dtab[250].binv := {NATURAL_32} 2_902_657_473
		end

end
