class
	P_CLEAR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_clear (a_m: CE_POINTER [PD_MPF_STRUCT])
		do
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (a_m.item.mp_d), ((a_m.item.mp_prec + 1) * 4).to_natural_32])
		end

	gmpq_clear (a_m: CE_POINTER [PD_MPQ_STRUCT])
		do
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (a_m.item.mp_num.mp_d), (a_m.item.mp_num.mp_alloc * 4).to_natural_32])
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (a_m.item.mp_den.mp_d), (a_m.item.mp_den.mp_alloc * 4).to_natural_32])
		end

	gmpz_clear (a_m: CE_POINTER [PD_MPZ_STRUCT])
		do
			memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (a_m.item.mp_d), (a_m.item.mp_alloc * 4).to_natural_32])
		end

end
