class
	P_DIVIS_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_divisible_ui_p (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_d: NATURAL_32): INTEGER_32
		local
			l_d: NATURAL_32
			l_asize: INTEGER_32
			l_ap: CE_POINTER [NATURAL_32]
			l_twos: NATURAL_32
			l_dlimbs: CE_ARRAY [NATURAL_32]
			l_dz: CE_ARRAY [PD_MPZ_STRUCT]
			js: JUMP_STATE
		do
			create l_ap.make
			create l_dlimbs.make (<<2>>)
			create l_dz.make (<<1>>)

			l_d := a_d
			l_asize := (a_a.item.mp_size).to_integer_32
			if (builtin_expect ((l_d = {NATURAL_32} 0).to_integer, 0)).to_boolean then
				Result := (l_asize = 0).to_integer
				js.return
			end
			if not js.return_called and then (l_asize = 0) then
				Result := 1
				js.return
			end
			if not js.return_called and then (l_d > {NATURAL_32} 4_294_967_295) then
				l_dz[0].mp_alloc := 2
				l_dz[0].mp_d := l_dlimbs
				set_ui_inst.gmpz_set_ui (l_dz, l_d)
				Result := (divis_inst.gmpz_divisible_p (a_a, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_dz)))
				js.return
			end
			if not js.return_called then
				l_ap := a_a.item.mp_d
				if l_asize >= 0 then
					l_asize := l_asize
				else
					l_asize := -l_asize
				end
				if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_asize >= 22 then
						Result := ((mod_1_inst.gmpn_mod_1 (l_ap, l_asize, l_d)) = {NATURAL_32} 0).to_integer
						js.return
					end
				end
			end
			if not js.return_called and then (not ((l_d).bit_and ({NATURAL_32} 1)).to_boolean) then
				if ((l_ap[0]).bit_and ((((l_d).bit_and ((-l_d.to_integer_32).to_natural_32)) - {NATURAL_32} 1))) /= {NATURAL_32} 0 then
					Result := 0
					js.return
				end
				if not js.return_called then
					from
					until
						js.loop_done
					loop
						l_twos := (builtin_ctzl (l_d)).to_natural_32
						js.break
					end
					l_d := (l_d).bit_shift_right (l_twos.to_integer_32)
				end
			end
			if not js.return_called then
				Result := ((gmp_impl_inst.gmpn_modexact_1_odd (l_ap, l_asize, l_d)) = {NATURAL_32} 0).to_integer
			end
		end

end
