class
	P_DOPRNT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_doprnt (a_funs: CE_POINTER [PD_DOPRNT_FUNS_T]; a_data: CE_POINTER [ANY]; a_orig_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
		local
			l_orig_ap: CE_VA_LIST
			l_ap: CE_VA_LIST
			l_this_ap: CE_VA_LIST
			l_last_ap: CE_VA_LIST
			l_alloc_fmt_size: NATURAL_32
			l_fmt: CE_POINTER [INTEGER_8]
			l_alloc_fmt: CE_POINTER [INTEGER_8]
			l_last_fmt: CE_POINTER [INTEGER_8]
			l_this_fmt: CE_POINTER [INTEGER_8]
			l_gmp_str: CE_POINTER [INTEGER_8]
			l_retval: INTEGER_32
			l_type: INTEGER_32
			l_fchar: INTEGER_32
			l_value: CE_POINTER [INTEGER_32]
			l_seen_precision: INTEGER_32
			l_param: CE_ARRAY [PD_DOPRNT_PARAMS_T]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_64
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_64
			l_xp: CE_POINTER [NATURAL_32]
			l_xsize: INTEGER_32
			l_abs_xsize: INTEGER_32
			l_z: CE_ARRAY [PD_MPZ_STRUCT]
			l___ret: INTEGER_32
			l_tmp___7: INTEGER_64
			l___ret___0: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: NATURAL_32
			l_ret: INTEGER_32
			l___ret___1: INTEGER_32
			l___ret___2: INTEGER_32
			l_tmp___13: INTEGER_32
			l___ret___3: INTEGER_32
			l___ret___4: INTEGER_32
			l_tmp___14: CE_POINTER [PD_MPF_STRUCT]
			l_tmp___16: REAL_96
			l_tmp___17: REAL_64
			l_p: CE_POINTER [ANY]
			l___ret___5: INTEGER_32
			l_n: INTEGER_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___18: CE_POINTER [NATURAL_32]
			l_tmp___19: CE_POINTER [ANY]
			l_n___0: INTEGER_32
			l_n___1: INTEGER_32
			l_tmp___21: CE_POINTER [INTEGER_8]
			l___ret___6: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_orig_ap.make_shared (default_pointer)
			create l_ap.make_shared (default_pointer)
			create l_this_ap.make_shared (default_pointer)
			create l_last_ap.make_shared (default_pointer)
			create l_fmt.make
			create l_alloc_fmt.make
			create l_last_fmt.make
			create l_this_fmt.make
			create l_gmp_str.make
			create l_value.make
			create l_param.make (<<1>>)
			create l_tmp___1.make
			create l_xp.make
			create l_z.make (<<1>>)
			create l_tmp___14.make
			create l_p.make
			create l___dst.make
			create l_tmp___18.make
			create l_tmp___19.make
			create l_tmp___21.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_orig_ap := a_orig_ap.twin
					l_retval := 0
					l_ap := l_orig_ap.twin
					l_alloc_fmt_size := (strlen (a_orig_fmt)) + {NATURAL_32} 1
					l_alloc_fmt := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_alloc_fmt_size * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
					l_fmt := l_alloc_fmt
					strcpy (l_fmt, a_orig_fmt).do_nothing
					l_last_fmt := l_fmt
					l_last_ap := l_ap.twin
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 131 -- skip loop
					end
				when 2 then -- loop body:
						l_fmt := strchr (l_fmt, ('%%').code)
						if l_fmt.is_void then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 130 -- skip if block
						end
				when 3 then -- if:
						l_this_fmt := l_fmt
						l_this_ap := l_ap.twin
						l_fmt := l_fmt + 1
						l_type := ('%/0/').code
						l_value := create {CE_POINTER [INTEGER_32]}.make_shared (l_param.item.c_pointer + (create {PD_DOPRNT_PARAMS_T}.make).offset_of ("width"))
						l_param.item.base := 10
						l_param.item.conv := 0
						l_param.item.expfmt := ce_string ("e%%c%%02ld")
						l_param.item.exptimes4 := 0
						l_param.item.fill := ((' ').code).to_integer_8
						l_param.item.justify := 2
						l_param.item.prec := 6
						l_param.item.showbase := 2
						l_param.item.showpoint := 0
						l_param.item.showtrailing := 1
						l_param.item.sign := (('%/0/').code).to_integer_8
						l_param.item.width := 0
						l_seen_precision := 0
				when 4 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 129 -- skip loop
						end
				when 5 then -- loop body:
						l_tmp___1 := l_fmt
						l_fmt := l_fmt + 1
						l_fchar := (l_tmp___1[0]).to_integer_32
						if l_fchar = 0 then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 128 -- skip if block
						end
				when 6 then -- if:
						inspect l_fchar -- switch 1 head
						when 97 then l_pos := -1 + 7
						when 65 then l_pos := -1 + 8
						when 99 then l_pos := -1 + 10
						when 100 then l_pos := -1 + 11
						when 105 then l_pos := -1 + 11
						when 117 then l_pos := -1 + 11
						when 69 then l_pos := -1 + 58
						when 101 then l_pos := -1 + 59
						when 102 then l_pos := -1 + 79
						when 70 then l_pos := -1 + 80
						when 106 then l_pos := -1 + 80
						when 76 then l_pos := -1 + 80
						when 78 then l_pos := -1 + 80
						when 113 then l_pos := -1 + 80
						when 81 then l_pos := -1 + 80
						when 116 then l_pos := -1 + 80
						when 122 then l_pos := -1 + 80
						when 90 then l_pos := -1 + 80
						when 71 then l_pos := -1 + 81
						when 103 then l_pos := -1 + 82
						when 104 then l_pos := -1 + 83
						when 108 then l_pos := -1 + 85
						when 109 then l_pos := -1 + 87
						when 77 then l_pos := -1 + 88
						when 110 then l_pos := -1 + 89
						when 111 then l_pos := -1 + 114
						when 112 then l_pos := -1 + 115
						when 115 then l_pos := -1 + 115
						when 120 then l_pos := -1 + 116
						when 88 then l_pos := -1 + 117
						when 37 then l_pos := -1 + 118
						when 35 then l_pos := -1 + 119
						when 39 then l_pos := -1 + 120
						when 43 then l_pos := -1 + 121
						when 32 then l_pos := -1 + 121
						when 45 then l_pos := -1 + 122
						when 46 then l_pos := -1 + 123
						when 42 then l_pos := -1 + 124
						when 48 then l_pos := -1 + 125
						when 49 then l_pos := -1 + 126
						when 50 then l_pos := -1 + 126
						when 51 then l_pos := -1 + 126
						when 52 then l_pos := -1 + 126
						when 53 then l_pos := -1 + 126
						when 54 then l_pos := -1 + 126
						when 55 then l_pos := -1 + 126
						when 56 then l_pos := -1 + 126
						when 57 then l_pos := -1 + 126
						else l_pos := -1 + 127
						end
				when 7 then -- switch 1, case 97
						l_param.item.base := 16
						l_param.item.expfmt := ce_string ("p%%c%%ld")
						l_pos := -1 + 9 -- goto conv_a
				when 8 then -- switch 1, case 65
						l_param.item.base := -16
						l_param.item.expfmt := ce_string ("P%%c%%ld")
				when 9 then -- conv_a:
						l_param.item.conv := 2
						l_param.item.exptimes4 := 1
						if not l_seen_precision.to_boolean then
							l_param.item.prec := -1
						end
						l_param.item.showbase := 1
						l_param.item.showtrailing := 1
						l_pos := -1 + 61 -- goto floating_a
				when 10 then -- switch 1, case 99
						l_tmp___2 := l_ap.integer_32_item
						l_pos := -1 + 129 -- goto next
				when 11 then -- integer: | switch 1, case 100 | switch 1, case 105 | switch 1, case 117
						
						if not l_seen_precision.to_boolean then
							l_param.item.prec := -1
						end
						inspect l_type -- switch 2 head
						when 106 then l_pos := -1 + 12
						when 108 then l_pos := -1 + 13
						when 76 then l_pos := -1 + 14
						when 78 then l_pos := -1 + 15
						when 113 then l_pos := -1 + 26
						when 81 then l_pos := -1 + 27
						when 116 then l_pos := -1 + 38
						when 122 then l_pos := -1 + 39
						when 90 then l_pos := -1 + 40
						else l_pos := -1 + 56
						end
				when 12 then -- switch 2, case 106
						l_tmp___3 := l_ap.integer_64_item
						l_pos := -1 + 57 -- switch 2; break
				when 13 then -- switch 2, case 108
						l_tmp___4 := l_ap.integer_32_item
						l_pos := -1 + 57 -- switch 2; break
				when 14 then -- switch 2, case 76
						l_tmp___5 := l_ap.integer_64_item
						l_pos := -1 + 57 -- switch 2; break
				when 15 then -- switch 2, case 78
						if js.loop_done then
							l_pos := -1 + 25 -- skip loop
						end
				when 16 then -- loop body:
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 18 -- skip if block
						end
				when 17 then -- if: | if block done, skip else block:
						l_pos := -1 + 24
				when 18 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 19 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 24 -- skip loop
						end
				when 20 then -- loop body: | loop condition:
						if js.loop_done then
							l_pos := -1 + 23 -- skip loop
						end
				when 21 then -- loop body:
						l___ret := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						if l___ret = -1 then
							l_pos := -1 + 139 -- goto error
						end
				when 22 then
						l_retval := l_retval + l___ret
						js.break
						l_pos := -1 + 20 -- back to loop condition
				when 23 then -- loop done
						js.break
						l_pos := -1 + 19 -- back to loop condition
				when 24 then -- loop done | if done
						js.break
						l_pos := -1 + 15 -- back to loop condition
				when 25 then -- loop done
						l_xp := (create {CE_POINTER [NATURAL_32]}.make_cast (l_ap.pointer_item))
						l_z[0].mp_d := l_xp
						l_xsize := ((l_ap.integer_32_item).to_integer_32).to_integer_32
						if l_xsize >= 0 then
							l_abs_xsize := l_xsize
						else
							l_abs_xsize := -l_xsize
						end
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_abs_xsize > 0))
							loop
								if l_xp[(l_abs_xsize - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_abs_xsize := l_abs_xsize - 1
								end
							end
							js.break
						end
						if l_xsize >= 0 then
							l_z[0].mp_size := l_abs_xsize.to_integer_32
						else
							l_z[0].mp_size := (-l_abs_xsize).to_integer_32
						end
						l_gmp_str := get_str_inst.gmpz_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_param.item.base, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_z))
						l_pos := -1 + 51 -- goto gmp_integer
				when 26 then -- switch 2, case 113
						l_tmp___7 := l_ap.integer_64_item
						l_pos := -1 + 57 -- switch 2; break
				when 27 then -- switch 2, case 81
						if js.loop_done then
							l_pos := -1 + 37 -- skip loop
						end
				when 28 then -- loop body:
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 30 -- skip if block
						end
				when 29 then -- if: | if block done, skip else block:
						l_pos := -1 + 36
				when 30 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 31 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 36 -- skip loop
						end
				when 32 then -- loop body: | loop condition:
						if js.loop_done then
							l_pos := -1 + 35 -- skip loop
						end
				when 33 then -- loop body:
						l___ret___0 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						if l___ret___0 = -1 then
							l_pos := -1 + 139 -- goto error
						end
				when 34 then
						l_retval := l_retval + l___ret___0
						js.break
						l_pos := -1 + 32 -- back to loop condition
				when 35 then -- loop done
						js.break
						l_pos := -1 + 31 -- back to loop condition
				when 36 then -- loop done | if done
						js.break
						l_pos := -1 + 27 -- back to loop condition
				when 37 then -- loop done
						l_gmp_str := get_str_inst.gmpq_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_param.item.base, (create {CE_POINTER [PD_MPQ_STRUCT]}.make_cast (l_ap.pointer_item)))
						l_pos := -1 + 51 -- goto gmp_integer
				when 38 then -- switch 2, case 116
						l_tmp___9 := l_ap.integer_32_item
						l_pos := -1 + 57 -- switch 2; break
				when 39 then -- switch 2, case 122
						l_tmp___10 := l_ap.natural_32_item
						l_pos := -1 + 57 -- switch 2; break
				when 40 then -- switch 2, case 90
						if js.loop_done then
							l_pos := -1 + 50 -- skip loop
						end
				when 41 then -- loop body:
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 43 -- skip if block
						end
				when 42 then -- if: | if block done, skip else block:
						l_pos := -1 + 49
				when 43 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 44 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 49 -- skip loop
						end
				when 45 then -- loop body: | loop condition:
						if js.loop_done then
							l_pos := -1 + 48 -- skip loop
						end
				when 46 then -- loop body:
						l___ret___1 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						if l___ret___1 = -1 then
							l_pos := -1 + 139 -- goto error
						end
				when 47 then
						l_retval := l_retval + l___ret___1
						js.break
						l_pos := -1 + 45 -- back to loop condition
				when 48 then -- loop done
						js.break
						l_pos := -1 + 44 -- back to loop condition
				when 49 then -- loop done | if done
						js.break
						l_pos := -1 + 40 -- back to loop condition
				when 50 then -- loop done
						l_gmp_str := get_str_inst.gmpz_get_str (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), l_param.item.base, (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ap.pointer_item)))
				when 51 then -- gmp_integer:
						l_ret := doprnti_inst.gmp_doprnt_integer (a_funs, a_data, l_param, l_gmp_str)
						memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_gmp_str), (strlen (l_gmp_str)) + {NATURAL_32} 1])
				when 52 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 55 -- skip loop
						end
				when 53 then -- loop body:
						l___ret___2 := l_ret
						if l___ret___2 = -1 then
							l_pos := -1 + 139 -- goto error
						end
				when 54 then
						l_retval := l_retval + l___ret___2
						js.break
						l_pos := -1 + 52 -- back to loop condition
				when 55 then -- loop done
						l_last_ap := l_ap.twin
						l_last_fmt := l_fmt
						l_pos := -1 + 57 -- switch 2; break
				when 56 then -- switch 2, default:
						l_tmp___13 := l_ap.integer_32_item
						l_pos := -1 + 57 -- switch 2; break
				when 57 then -- switch 2, done:
						l_pos := -1 + 129 -- goto next
				when 58 then -- switch 1, case 69
						l_param.item.base := -10
						l_param.item.expfmt := ce_string ("E%%c%%02ld")
				when 59 then -- switch 1, case 101
						l_param.item.conv := 2
				when 60 then -- floating:
						if l_param.item.showbase = 3 then
							l_param.item.showpoint := 1
							l_param.item.showtrailing := 1
						end
				when 61 then -- floating_a:
						inspect l_type -- switch 3 head
						when 70 then l_pos := -1 + 62
						when 76 then l_pos := -1 + 76
						else l_pos := -1 + 77
						end
				when 62 then -- switch 3, case 70
						if js.loop_done then
							l_pos := -1 + 72 -- skip loop
						end
				when 63 then -- loop body:
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 65 -- skip if block
						end
				when 64 then -- if: | if block done, skip else block:
						l_pos := -1 + 71
				when 65 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 66 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 71 -- skip loop
						end
				when 67 then -- loop body: | loop condition:
						if js.loop_done then
							l_pos := -1 + 70 -- skip loop
						end
				when 68 then -- loop body:
						l___ret___3 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						if l___ret___3 = -1 then
							l_pos := -1 + 139 -- goto error
						end
				when 69 then
						l_retval := l_retval + l___ret___3
						js.break
						l_pos := -1 + 67 -- back to loop condition
				when 70 then -- loop done
						js.break
						l_pos := -1 + 66 -- back to loop condition
				when 71 then -- loop done | if done
						js.break
						l_pos := -1 + 62 -- back to loop condition
				when 72 then -- loop done
						if js.loop_done then
							l_pos := -1 + 75 -- skip loop
						end
				when 73 then -- loop body:
						l_tmp___14 := (create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_ap.pointer_item))
						l___ret___4 := doprntf_inst.gmp_doprnt_mpf2 (a_funs, a_data, l_param, (nl_langinfo (65_536)), l_tmp___14)
						if l___ret___4 = -1 then
							l_pos := -1 + 139 -- goto error
						end
				when 74 then
						l_retval := l_retval + l___ret___4
						js.break
						l_pos := -1 + 72 -- back to loop condition
				when 75 then -- loop done
						l_last_ap := l_ap.twin
						l_last_fmt := l_fmt
						l_pos := -1 + 78 -- switch 3; break
				when 76 then -- switch 3, case 76
						l_tmp___16 := l_ap.real_96_item
						l_pos := -1 + 78 -- switch 3; break
				when 77 then -- switch 3, default:
						l_tmp___17 := l_ap.real_64_item
						l_pos := -1 + 78 -- switch 3; break
				when 78 then -- switch 3, done:
						l_pos := -1 + 129 -- goto next
				when 79 then -- switch 1, case 102
						l_param.item.conv := 1
						l_pos := -1 + 60 -- goto floating
				when 80 then -- set_type: | switch 1, case 70 | switch 1, case 106 | switch 1, case 76 | switch 1, case 78 | switch 1, case 113 | switch 1, case 81 | switch 1, case 116 | switch 1, case 122 | switch 1, case 90
						l_type := l_fchar
						l_pos := -1 + 128 -- switch 1; break
				when 81 then -- switch 1, case 71
						l_param.item.base := -10
						l_param.item.expfmt := ce_string ("E%%c%%02ld")
				when 82 then -- switch 1, case 103
						l_param.item.conv := 3
						l_param.item.showtrailing := 0
						l_pos := -1 + 60 -- goto floating
				when 83 then -- switch 1, case 104
						if l_type /= 104 then
							l_pos := -1 + 80 -- goto set_type
						end
				when 84 then
						l_type := ('H').code
						l_pos := -1 + 128 -- switch 1; break
				when 85 then -- switch 1, case 108
						if l_type /= 108 then
							l_pos := -1 + 80 -- goto set_type
						end
				when 86 then
						l_type := ('L').code
						l_pos := -1 + 128 -- switch 1; break
				when 87 then -- switch 1, case 109
						l_pos := -1 + 129 -- goto next
				when 88 then -- switch 1, case 77
						l_fmt[-1] := (('l').code).to_integer_8
						l_type := ('l').code
						l_pos := -1 + 128 -- switch 1; break
				when 89 then -- switch 1, case 110
						if js.loop_done then
							l_pos := -1 + 99 -- skip loop
						end
				when 90 then -- loop body:
						if not (l_this_fmt.is_equal (l_last_fmt)) then
							l_pos := -1 + 92 -- skip if block
						end
				when 91 then -- if: | if block done, skip else block:
						l_pos := -1 + 98
				when 92 then -- else:
						l_this_fmt[0] := (('%/0/').code).to_integer_8
				when 93 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 98 -- skip loop
						end
				when 94 then -- loop body: | loop condition:
						if js.loop_done then
							l_pos := -1 + 97 -- skip loop
						end
				when 95 then -- loop body:
						l___ret___5 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						if l___ret___5 = -1 then
							l_pos := -1 + 139 -- goto error
						end
				when 96 then
						l_retval := l_retval + l___ret___5
						js.break
						l_pos := -1 + 94 -- back to loop condition
				when 97 then -- loop done
						js.break
						l_pos := -1 + 93 -- back to loop condition
				when 98 then -- loop done | if done
						js.break
						l_pos := -1 + 89 -- back to loop condition
				when 99 then -- loop done
						l_p := (create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item))
						inspect l_type -- switch 4 head
						when 0 then l_pos := -1 + 100
						when 70 then l_pos := -1 + 101
						when 72 then l_pos := -1 + 102
						when 104 then l_pos := -1 + 103
						when 106 then l_pos := -1 + 104
						when 108 then l_pos := -1 + 105
						when 113 then l_pos := -1 + 106
						when 76 then l_pos := -1 + 107
						when 78 then l_pos := -1 + 108
						when 81 then l_pos := -1 + 109
						when 116 then l_pos := -1 + 110
						when 122 then l_pos := -1 + 111
						when 90 then l_pos := -1 + 112
						else l_pos := -1 + 113
						end
				when 100 then; -- switch 4, case 0
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_retval
						l_pos := -1 + 113 -- switch 4; break
				when 101 then -- switch 4, case 70
						set_si_inst.gmpf_set_si (create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_p), l_retval.to_integer_32)
						l_pos := -1 + 113 -- switch 4; break
				when 102 then; -- switch 4, case 72
						(create {CE_POINTER [INTEGER_8]}.make_cast (l_p)).item := l_retval.to_integer_8
						l_pos := -1 + 113 -- switch 4; break
				when 103 then; -- switch 4, case 104
						(create {CE_POINTER [INTEGER_16]}.make_cast (l_p)).item := l_retval.to_integer_16
						l_pos := -1 + 113 -- switch 4; break
				when 104 then; -- switch 4, case 106
						(create {CE_POINTER [INTEGER_64]}.make_cast (l_p)).item := l_retval.to_integer_64
						l_pos := -1 + 113 -- switch 4; break
				when 105 then; -- switch 4, case 108
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_retval.to_integer_32
						l_pos := -1 + 113 -- switch 4; break
				when 106 then -- switch 4, case 113
						from
						until
							js.loop_done
						loop
							if {PLATFORM}.Integer_64_bytes.to_natural_32 /= {PLATFORM}.Integer_64_bytes.to_natural_32 then
								assert_inst.gmp_assert_fail (ce_string ("doprnt.c"), 461, ce_string ("sizeof (quad_t) == sizeof (long long)"))
							end
							js.break
						end
				when 107 then; -- switch 4, case 76
						(create {CE_POINTER [INTEGER_64]}.make_cast (l_p)).item := l_retval.to_integer_64
						l_pos := -1 + 113 -- switch 4; break
				when 108 then -- switch 4, case 78
						l_n := l_ap.integer_32_item
						if l_n >= 0 then
							l_n := l_n
						else
							l_n := -l_n
						end
						if l_n /= 0 then
							(create {CE_POINTER [NATURAL_32]}.make_cast (l_p)).item := l_retval.to_natural_32
							from
							until
								js.loop_done
							loop
								if l_n - 1 /= 0 then
									l___dst := create {CE_POINTER [NATURAL_32]}.make_cast (l_p) + 1
									l___n := l_n - 1
									from
									until
										js.loop_done
									loop
										l_tmp___18 := l___dst
										l___dst := l___dst + 1
										l_tmp___18.item := (0).to_natural_32
										l___n := l___n - 1
										if not l___n.to_boolean then
											js.break
										end
									end
								end
								js.break
							end
						end
						l_pos := -1 + 113 -- switch 4; break
				when 109 then -- switch 4, case 81
						set_si_inst.gmpq_set_si (create {CE_POINTER [PD_MPQ_STRUCT]}.make_cast (l_p), l_retval.to_integer_32, {NATURAL_32} 1)
						l_pos := -1 + 113 -- switch 4; break
				when 110 then; -- switch 4, case 116
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_retval
						l_pos := -1 + 113 -- switch 4; break
				when 111 then; -- switch 4, case 122
						(create {CE_POINTER [NATURAL_32]}.make_cast (l_p)).item := l_retval.to_natural_32
						l_pos := -1 + 113 -- switch 4; break
				when 112 then -- switch 4, case 90
						set_si_inst.gmpz_set_si (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_p), l_retval.to_integer_32)
						l_pos := -1 + 113 -- switch 4; break
				when 113 then -- switch 4, done:
						l_last_ap := l_ap.twin
						l_last_fmt := l_fmt
						l_pos := -1 + 129 -- goto next
				when 114 then -- switch 1, case 111
						l_param.item.base := 8
						l_pos := -1 + 11 -- goto integer
				when 115 then -- switch 1, case 112 | switch 1, case 115
						l_tmp___19 := (create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item))
						l_pos := -1 + 129 -- goto next
				when 116 then -- switch 1, case 120
						l_param.item.base := 16
						l_pos := -1 + 11 -- goto integer
				when 117 then -- switch 1, case 88
						l_param.item.base := -16
						l_pos := -1 + 11 -- goto integer
				when 118 then -- switch 1, case 37
						l_pos := -1 + 129 -- goto next
				when 119 then -- switch 1, case 35
						l_param.item.showbase := 3
						l_pos := -1 + 128 -- switch 1; break
				when 120 then -- switch 1, case 39
						l_pos := -1 + 128 -- switch 1; break
				when 121 then -- switch 1, case 43 | switch 1, case 32
						l_param.item.sign := l_fchar.to_integer_8
						l_pos := -1 + 128 -- switch 1; break
				when 122 then -- switch 1, case 45
						l_param.item.justify := 1
						l_pos := -1 + 128 -- switch 1; break
				when 123 then -- switch 1, case 46
						l_seen_precision := 1
						l_param.item.prec := -1
						l_value := create {CE_POINTER [INTEGER_32]}.make_shared (l_param.item.c_pointer + (create {PD_DOPRNT_PARAMS_T}.make).offset_of ("prec"))
						l_pos := -1 + 128 -- switch 1; break
				when 124 then -- switch 1, case 42
						l_n___0 := (l_ap.integer_32_item)
						if l_value.is_equal (create {CE_POINTER [INTEGER_32]}.make_shared (l_param.item.c_pointer + (create {PD_DOPRNT_PARAMS_T}.make).offset_of ("width"))) then
							if l_n___0 < 0 then
								l_param.item.justify := 1
								l_n___0 := -l_n___0
							end
							l_param.item.width := l_n___0
						elseif 0 > l_n___0 then
							l_param.item.prec := 0
						else
							l_param.item.prec := l_n___0
						end
						l_pos := -1 + 128 -- switch 1; break
				when 125 then -- switch 1, case 48
						if l_value.is_equal (create {CE_POINTER [INTEGER_32]}.make_shared (l_param.item.c_pointer + (create {PD_DOPRNT_PARAMS_T}.make).offset_of ("width"))) then
							l_param.item.fill := (('0').code).to_integer_8
							if l_param.item.justify = 2 then
								l_param.item.justify := 3
							end
						else
							l_value.item := 0
						end
						l_pos := -1 + 128 -- switch 1; break
				when 126 then -- switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57
						l_n___1 := 0
						from
						until
							js.loop_done
						loop
							l_n___1 := l_n___1 * 10 + (l_fchar - 48)
							l_tmp___21 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := (l_tmp___21[0]).to_integer_32
							if ((l_fchar).bit_and (-128)) = 0 then
								if not ((((ctype_b_loc).item[l_fchar]).to_integer_32).bit_and (2_048)).to_boolean then
									js.break
								end
							else
								js.break
							end
						end
						l_fmt := l_fmt - 1
						l_value.item := l_n___1
						l_pos := -1 + 128 -- switch 1; break
				when 127 then -- switch 1, default:
						l_pos := -1 + 129 -- goto next
				when 128 then -- switch 1, done: | if done
						l_pos := -1 + 4 -- back to loop condition
				when 129 then -- next:
						
				when 130 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 131 then -- loop done
					if (l_last_fmt[0]).to_integer_32 = 0 then
						l_pos := -1 + 137 -- skip if block
					end
				when 132 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 137 -- skip loop
						end
				when 133 then -- loop body: | loop condition:
						if js.loop_done then
							l_pos := -1 + 136 -- skip loop
						end
				when 134 then -- loop body:
						l___ret___6 := (a_funs.item.format).integer_32_item ([a_data, l_last_fmt, l_last_ap.twin])
						if l___ret___6 = -1 then
							l_pos := -1 + 139 -- goto error
						end
				when 135 then
						l_retval := l_retval + l___ret___6
						js.break
						l_pos := -1 + 133 -- back to loop condition
				when 136 then -- loop done
						js.break
						l_pos := -1 + 132 -- back to loop condition
				when 137 then -- loop done | if done
						if not (a_funs.item.final).is_void then
							if ((a_funs.item.final).integer_32_item ([a_data])) = -1 then
								l_pos := -1 + 139 -- goto error
							end
						end
				when 138 then -- done:
						memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_alloc_fmt), l_alloc_fmt_size])
						Result := l_retval
						js.return
						if js.return_called then
							l_pos := -1 + 140 -- skip if block
						end
				when 139 then -- if: | error:
							l_retval := -1
							l_pos := -1 + 138 -- goto done
				when 140 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
