class
	P_DOPRNTI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_doprnt_integer (a_funs: CE_POINTER [PD_DOPRNT_FUNS_T]; a_data: CE_POINTER [ANY]; a_p: CE_POINTER [PD_DOPRNT_PARAMS_T]; a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_retval: INTEGER_32
			l_slen: INTEGER_32
			l_justlen: INTEGER_32
			l_showbaselen: INTEGER_32
			l_sign: INTEGER_32
			l_signlen: INTEGER_32
			l_slashlen: INTEGER_32
			l_zeros: INTEGER_32
			l_justify: INTEGER_32
			l_den_showbaselen: INTEGER_32
			l_slash: CE_POINTER [INTEGER_8]
			l_showbase: CE_POINTER [INTEGER_8]
			l___ret: INTEGER_32
			l___ret___0: INTEGER_32
			l___ret___1: INTEGER_32
			l___ret___2: INTEGER_32
			l___ret___3: INTEGER_32
			l___ret___4: INTEGER_32
			l___ret___5: INTEGER_32
			l___ret___6: INTEGER_32
			l___ret___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_slash.make
			create l_showbase.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					l_retval := 0
					l_sign := (a_p.item.sign).to_integer_32
					if (l_s[0]).to_integer_32 = 45 then
						l_sign := (l_s[0]).to_integer_32
						l_s := l_s + 1
					end
					l_signlen := (l_sign /= 0).to_integer
					if (l_s[0]).to_integer_32 = 48 then
						if a_p.item.prec = 0 then
							l_s := l_s + 1
						end
					end
					l_slen := (strlen (l_s)).to_integer_32
					l_slash := (strchr (l_s, ('/').code))
					l_showbase := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
					l_showbaselen := 0
					if a_p.item.showbase = 2 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						inspect a_p.item.base -- switch 1 head
						when 16 then l_pos := -1 + 2
						when -16 then l_pos := -1 + 3 -- -16
						when 8 then l_pos := -1 + 4
						else l_pos := -1 + 5
						end
				when 2 then -- switch 1, case 16
						l_showbase := ce_string ("0x")
						l_showbaselen := 2
						l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case -16
						l_showbase := ce_string ("0X")
						l_showbaselen := 2
						l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, case 8
						l_showbase := ce_string ("0")
						l_showbaselen := 1
						l_pos := -1 + 5 -- switch 1; break
				when 5 then -- switch 1, done: | if done
						l_den_showbaselen := l_showbaselen
						if l_slash.is_void then
							l_den_showbaselen := 0
						elseif a_p.item.showbase = 3 then
							if (l_slash[1]).to_integer_32 = 48 then
								l_den_showbaselen := 0
							end
						end
						if a_p.item.showbase = 3 then
							if (l_s[0]).to_integer_32 = 48 then
								l_showbaselen := 0
							end
						end
						if 0 > (a_p.item.prec - l_slen) then
							l_zeros := 0
						else
							l_zeros := (a_p.item.prec - l_slen)
						end
						l_justlen := ((a_p.item.width).to_natural_32 - (((((strlen (l_s)) + l_signlen.to_natural_32) + l_showbaselen.to_natural_32) + l_den_showbaselen.to_natural_32) + l_zeros.to_natural_32)).to_integer_32
						l_justify := a_p.item.justify
						if l_justlen <= 0 then
							l_justify := 0
						end
						if l_justify /= 2 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if: | loop condition:
							if js.loop_done then
								l_pos := -1 + 11 -- skip loop
							end
				when 7 then -- loop body: | loop condition:
							if js.loop_done then
								l_pos := -1 + 10 -- skip loop
							end
				when 8 then -- loop body:
							l___ret := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
							if l___ret = -1 then
								l_pos := -1 + 66 -- goto error
							end
				when 9 then
							l_retval := l_retval + l___ret
							js.break
							l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
							js.break
							l_pos := -1 + 6 -- back to loop condition
				when 11 then -- loop done | if done
							if js.loop_done then
								l_pos := -1 + 19 -- skip loop
							end
				when 12 then -- loop body:
								if l_signlen = 0 then
									l_pos := -1 + 18 -- skip if block
								end
				when 13 then -- if: | loop condition:
								if js.loop_done then
									l_pos := -1 + 18 -- skip loop
								end
				when 14 then -- loop body: | loop condition:
								if js.loop_done then
									l_pos := -1 + 17 -- skip loop
								end
				when 15 then -- loop body:
								l___ret___0 := (a_funs.item.reps).integer_32_item ([a_data, l_sign, l_signlen])
								if l___ret___0 = -1 then
									l_pos := -1 + 66 -- goto error
								end
				when 16 then
								l_retval := l_retval + l___ret___0
								js.break
								l_pos := -1 + 14 -- back to loop condition
				when 17 then -- loop done
								js.break
								l_pos := -1 + 13 -- back to loop condition
				when 18 then -- loop done | if done
								js.break
								l_pos := -1 + 11 -- back to loop condition
				when 19 then -- loop done
							if js.loop_done then
								l_pos := -1 + 27 -- skip loop
							end
				when 20 then -- loop body:
								if l_showbaselen = 0 then
									l_pos := -1 + 26 -- skip if block
								end
				when 21 then -- if: | loop condition:
								if js.loop_done then
									l_pos := -1 + 26 -- skip loop
								end
				when 22 then -- loop body: | loop condition:
								if js.loop_done then
									l_pos := -1 + 25 -- skip loop
								end
				when 23 then -- loop body:
								l___ret___1 := (a_funs.item.memory).integer_32_item ([a_data, l_showbase, l_showbaselen.to_natural_32])
								if l___ret___1 = -1 then
									l_pos := -1 + 66 -- goto error
								end
				when 24 then
								l_retval := l_retval + l___ret___1
								js.break
								l_pos := -1 + 22 -- back to loop condition
				when 25 then -- loop done
								js.break
								l_pos := -1 + 21 -- back to loop condition
				when 26 then -- loop done | if done
								js.break
								l_pos := -1 + 19 -- back to loop condition
				when 27 then -- loop done
							if js.loop_done then
								l_pos := -1 + 35 -- skip loop
							end
				when 28 then -- loop body:
								if l_zeros = 0 then
									l_pos := -1 + 34 -- skip if block
								end
				when 29 then -- if: | loop condition:
								if js.loop_done then
									l_pos := -1 + 34 -- skip loop
								end
				when 30 then -- loop body: | loop condition:
								if js.loop_done then
									l_pos := -1 + 33 -- skip loop
								end
				when 31 then -- loop body:
								l___ret___2 := (a_funs.item.reps).integer_32_item ([a_data, ('0').code, l_zeros])
								if l___ret___2 = -1 then
									l_pos := -1 + 66 -- goto error
								end
				when 32 then
								l_retval := l_retval + l___ret___2
								js.break
								l_pos := -1 + 30 -- back to loop condition
				when 33 then -- loop done
								js.break
								l_pos := -1 + 29 -- back to loop condition
				when 34 then -- loop done | if done
								js.break
								l_pos := -1 + 27 -- back to loop condition
				when 35 then -- loop done
							if l_justify /= 3 then
								l_pos := -1 + 41 -- skip if block
							end
				when 36 then -- if: | loop condition:
								if js.loop_done then
									l_pos := -1 + 41 -- skip loop
								end
				when 37 then -- loop body: | loop condition:
								if js.loop_done then
									l_pos := -1 + 40 -- skip loop
								end
				when 38 then -- loop body:
								l___ret___3 := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
								if l___ret___3 = -1 then
									l_pos := -1 + 66 -- goto error
								end
				when 39 then
								l_retval := l_retval + l___ret___3
								js.break
								l_pos := -1 + 37 -- back to loop condition
				when 40 then -- loop done
								js.break
								l_pos := -1 + 36 -- back to loop condition
				when 41 then -- loop done | if done
								if l_den_showbaselen = 0 then
									l_pos := -1 + 54 -- skip if block
								end
				when 42 then -- if:
									l_slashlen := (l_slash + 1).distance (l_s)
				when 43 then -- loop condition:
									if js.loop_done then
										l_pos := -1 + 48 -- skip loop
									end
				when 44 then -- loop body: | loop condition:
									if js.loop_done then
										l_pos := -1 + 47 -- skip loop
									end
				when 45 then -- loop body:
									l___ret___4 := (a_funs.item.memory).integer_32_item ([a_data, l_s, l_slashlen.to_natural_32])
									if l___ret___4 = -1 then
										l_pos := -1 + 66 -- goto error
									end
				when 46 then
									l_retval := l_retval + l___ret___4
									js.break
									l_pos := -1 + 44 -- back to loop condition
				when 47 then -- loop done
									js.break
									l_pos := -1 + 43 -- back to loop condition
				when 48 then -- loop done
									l_slen := l_slen - l_slashlen
									l_s := l_s + l_slashlen
				when 49 then -- loop condition:
									if js.loop_done then
										l_pos := -1 + 54 -- skip loop
									end
				when 50 then -- loop body: | loop condition:
									if js.loop_done then
										l_pos := -1 + 53 -- skip loop
									end
				when 51 then -- loop body:
									l___ret___5 := (a_funs.item.memory).integer_32_item ([a_data, l_showbase, l_den_showbaselen.to_natural_32])
									if l___ret___5 = -1 then
										l_pos := -1 + 66 -- goto error
									end
				when 52 then
									l_retval := l_retval + l___ret___5
									js.break
									l_pos := -1 + 50 -- back to loop condition
				when 53 then -- loop done
									js.break
									l_pos := -1 + 49 -- back to loop condition
				when 54 then -- loop done | if done
									if js.loop_done then
										l_pos := -1 + 59 -- skip loop
									end
				when 55 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 58 -- skip loop
										end
				when 56 then -- loop body:
										l___ret___6 := (a_funs.item.memory).integer_32_item ([a_data, l_s, l_slen.to_natural_32])
										if l___ret___6 = -1 then
											l_pos := -1 + 66 -- goto error
										end
				when 57 then
										l_retval := l_retval + l___ret___6
										js.break
										l_pos := -1 + 55 -- back to loop condition
				when 58 then -- loop done
										js.break
										l_pos := -1 + 54 -- back to loop condition
				when 59 then -- loop done
									if l_justify /= 1 then
										l_pos := -1 + 65 -- skip if block
									end
				when 60 then -- if: | loop condition:
										if js.loop_done then
											l_pos := -1 + 65 -- skip loop
										end
				when 61 then -- loop body: | loop condition:
										if js.loop_done then
											l_pos := -1 + 64 -- skip loop
										end
				when 62 then -- loop body:
										l___ret___7 := (a_funs.item.reps).integer_32_item ([a_data, (a_p.item.fill).to_integer_32, l_justlen])
										if l___ret___7 = -1 then
											l_pos := -1 + 66 -- goto error
										end
				when 63 then
										l_retval := l_retval + l___ret___7
										js.break
										l_pos := -1 + 61 -- back to loop condition
				when 64 then -- loop done
										js.break
										l_pos := -1 + 60 -- back to loop condition
				when 65 then -- loop done | done:
										Result := l_retval
										js.return
										if js.return_called then
											l_pos := -1 + 67 -- skip if block
										end
				when 66 then -- if: | error:
											l_retval := -1
											l_pos := -1 + 65 -- goto done
				when 67 then
										l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
							end

end
