class
	P_DOSCAN

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_doscan (a_funs: CE_POINTER [PD_GMP_DOSCAN_FUNS_T]; a_data: CE_POINTER [ANY]; a_orig_fmt: CE_POINTER [INTEGER_8]; a_orig_ap: CE_VA_LIST): INTEGER_32
		local
			l_orig_ap: CE_VA_LIST
			l_param: CE_ARRAY [PD_GMP_DOSCAN_PARAMS_T]
			l_ap: CE_VA_LIST
			l_alloc_fmt: CE_POINTER [INTEGER_8]
			l_fmt: CE_POINTER [INTEGER_8]
			l_this_fmt: CE_POINTER [INTEGER_8]
			l_end_fmt: CE_POINTER [INTEGER_8]
			l_orig_fmt_len: NATURAL_32
			l_alloc_fmt_size: NATURAL_32
			l_len: NATURAL_32
			l_new_fields: INTEGER_32
			l_new_chars: CE_ARRAY [INTEGER_32]
			l_fchar: INTEGER_8
			l_fields: INTEGER_32
			l_chars: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [INTEGER_8]
			l_tmp___8: NATURAL_32
			l_tmp___9: NATURAL_32
			l_arg: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l_p: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_orig_ap.make_shared (default_pointer)
			create l_param.make (<<1>>)
			create l_ap.make_shared (default_pointer)
			create l_alloc_fmt.make
			create l_fmt.make
			create l_this_fmt.make
			create l_end_fmt.make
			create l_new_chars.make (<<1>>)
			create l_tmp___0.make
			create l_tmp___3.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make
			create l_tmp___7.make
			create l_arg.make
			create l_tmp___13.make
			create l_p.make
			create l_tmp___14.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_orig_ap := a_orig_ap.twin
					l_fields := 0
					l_chars := 0
					l_ap := l_orig_ap.twin
					l_orig_fmt_len := strlen (a_orig_fmt)
					l_alloc_fmt_size := l_orig_fmt_len + {NATURAL_32} 4
					l_alloc_fmt := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_alloc_fmt_size * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
					l_fmt := a_orig_fmt
					l_end_fmt := a_orig_fmt + l_orig_fmt_len.to_integer_32
				when 1 then -- loop condition:
					if js.loop_done then
						l_pos := -1 + 62 -- skip loop
					end
				when 2 then -- loop body: | next:
						l_tmp___0 := l_fmt
						l_fmt := l_fmt + 1
						l_fchar := l_tmp___0[0]
						if l_fchar.to_integer_32 = 0 then
							js.break
						end
						if not js.loop_jumped then
							if ((((ctype_b_loc).item[l_fchar.to_integer_32]).to_integer_32).bit_and (8_192)).to_boolean then
								l_chars := l_chars + (skip_white (a_funs, a_data))
								js.continue
							end
						end
						if not (not js.loop_jumped and then (l_fchar.to_integer_32 /= 37)) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if: | literal:
						l_c := (a_funs.item.get).integer_32_item ([a_data])
						if l_c = l_fchar.to_integer_32 then
							l_pos := -1 + 7 -- skip if block
						end
				when 4 then; -- if:
						(a_funs.item.unget).call ([l_c, a_data])
						if l_c /= -1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | eof_no_match:
						if l_fields = 0 then
							l_fields := -1
						end
				when 6 then -- if done
						l_pos := -1 + 62 -- goto done
				when 7 then
						l_chars := l_chars + 1
						js.continue
				when 8 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 61 -- skip if block
						end
				when 9 then -- if:
						l_param.item.type := (('%/0/').code).to_integer_8
						l_param.item.base := 0
						l_param.item.ignore := 0
						l_param.item.width := 0
						l_this_fmt := l_fmt - 1
				when 10 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 61 -- skip loop
						end
				when 11 then -- loop body:
						l_tmp___3 := l_fmt
						l_fmt := l_fmt + 1
						l_fchar := l_tmp___3[0]
						inspect l_fchar.to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 12
						when 37 then l_pos := -1 + 13
						when 91 then l_pos := -1 + 14
						when 99 then l_pos := -1 + 18
						when 115 then l_pos := -1 + 18
						when 112 then l_pos := -1 + 18
						when 100 then l_pos := -1 + 27
						when 117 then l_pos := -1 + 27
						when 101 then l_pos := -1 + 28
						when 69 then l_pos := -1 + 28
						when 102 then l_pos := -1 + 28
						when 103 then l_pos := -1 + 28
						when 71 then l_pos := -1 + 28
						when 105 then l_pos := -1 + 28
						when 97 then l_pos := -1 + 32
						when 39 then l_pos := -1 + 32
						when 70 then l_pos := -1 + 33
						when 106 then l_pos := -1 + 33
						when 76 then l_pos := -1 + 33
						when 113 then l_pos := -1 + 33
						when 81 then l_pos := -1 + 33
						when 116 then l_pos := -1 + 33
						when 122 then l_pos := -1 + 33
						when 90 then l_pos := -1 + 33
						when 104 then l_pos := -1 + 34
						when 108 then l_pos := -1 + 37
						when 110 then l_pos := -1 + 39
						when 111 then l_pos := -1 + 55
						when 120 then l_pos := -1 + 56
						when 88 then l_pos := -1 + 56
						when 48 then l_pos := -1 + 57
						when 49 then l_pos := -1 + 57
						when 50 then l_pos := -1 + 57
						when 51 then l_pos := -1 + 57
						when 52 then l_pos := -1 + 57
						when 53 then l_pos := -1 + 57
						when 54 then l_pos := -1 + 57
						when 55 then l_pos := -1 + 57
						when 56 then l_pos := -1 + 57
						when 57 then l_pos := -1 + 57
						when 42 then l_pos := -1 + 58
						else l_pos := -1 + 59
						end
				when 12 then -- switch 1, case 0
						l_pos := -1 + 62 -- goto done
				when 13 then -- switch 1, case 37
						l_pos := -1 + 3 -- goto literal
				when 14 then -- switch 1, case 91
						l_tmp___4 := l_fmt
						l_fmt := l_fmt + 1
						l_fchar := l_tmp___4[0]
						if l_fchar.to_integer_32 = 94 then
							l_tmp___5 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := l_tmp___5[0]
						end
						if l_fchar.to_integer_32 = 93 then
							l_tmp___6 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := l_tmp___6[0]
						end
				when 15 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 18 -- skip loop
						end
				when 16 then -- loop body:
						if l_fchar.to_integer_32 = 0 then
							l_pos := -1 + 62 -- goto done
						end
				when 17 then
						if l_fchar.to_integer_32 = 93 then
							js.break
						end
						if not js.loop_jumped then
							l_tmp___7 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := l_tmp___7[0]
						end
						l_pos := -1 + 15 -- back to loop condition
				when 18 then -- libc_type: | switch 1, case 99 | switch 1, case 115 | switch 1, case 112
						l_len := (l_fmt.distance (l_this_fmt)).to_natural_32
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_alloc_fmt), create {CE_POINTER [ANY]}.make_cast (l_this_fmt), l_len).do_nothing
						l_tmp___8 := l_len
						l_len := l_len + 1
						l_alloc_fmt[l_tmp___8.to_integer_32] := (('%%').code).to_integer_8
						l_tmp___9 := l_len
						l_len := l_len + 1
						l_alloc_fmt[l_tmp___9.to_integer_32] := (('n').code).to_integer_8
						l_alloc_fmt[l_len.to_integer_32] := (('%/0/').code).to_integer_8
						l_new_chars.item := -1
						if not ((l_param.item.ignore).to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						l_new_fields := (a_funs.item.scan).integer_32_item ([a_data, l_alloc_fmt, l_new_chars, create {CE_POINTER [ANY]}.make_shared (default_pointer)])
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 21 then -- else:
						l_arg := (create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item))
						l_new_fields := (a_funs.item.scan).integer_32_item ([a_data, l_alloc_fmt, l_arg, l_new_chars])
						if l_new_fields = 0 then
							l_pos := -1 + 62 -- goto done
						end
				when 22 then
						if l_new_fields = 1 then
						end
				when 23 then -- if done
						if l_new_fields = -1 then
							l_pos := -1 + 5 -- goto eof_no_match
						end
				when 24 then
						if l_new_chars.item = -1 then
							l_pos := -1 + 62 -- goto done
						end
				when 25 then
						l_chars := l_chars + (l_new_chars.item);
						(a_funs.item.step).call ([a_data, l_new_chars.item])
				when 26 then -- increment_fields:
						if not (l_param.item.ignore).to_boolean then
							l_fields := l_fields + 1
						end
						l_pos := -1 + 2 -- goto next
				when 27 then -- switch 1, case 100 | switch 1, case 117
						l_param.item.base := 10
						l_pos := -1 + 28 -- goto numeric
				when 28 then -- numeric: | switch 1, case 101 | switch 1, case 69 | switch 1, case 102 | switch 1, case 103 | switch 1, case 71 | switch 1, case 105
						if (l_param.item.type).to_integer_32 /= 70 then
							if (l_param.item.type).to_integer_32 /= 81 then
								if (l_param.item.type).to_integer_32 /= 90 then
									l_pos := -1 + 18 -- goto libc_type
								end
							end
						end
				when 29 then
						l_chars := l_chars + (skip_white (a_funs, a_data))
						if (l_param.item.ignore).to_boolean then
							l_tmp___13 := create {CE_POINTER [ANY]}.make_shared (default_pointer)
						else
							l_tmp___13 := (create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item))
						end
						l_new_chars.item := gmpscan (a_funs, a_data, l_param, l_tmp___13)
						if l_new_chars.item = -2 then
							l_pos := -1 + 5 -- goto eof_no_match
						end
				when 30 then
						if l_new_chars.item = -1 then
							l_pos := -1 + 62 -- goto done
						end
				when 31 then
						l_chars := l_chars + (l_new_chars.item)
						l_pos := -1 + 26 -- goto increment_fields
				when 32 then -- switch 1, case 97 | switch 1, case 39
						l_pos := -1 + 60 -- switch 1; break
				when 33 then -- set_type: | switch 1, case 70 | switch 1, case 106 | switch 1, case 76 | switch 1, case 113 | switch 1, case 81 | switch 1, case 116 | switch 1, case 122 | switch 1, case 90
						l_param.item.type := l_fchar
						l_pos := -1 + 60 -- switch 1; break
				when 34 then -- switch 1, case 104
						if (l_param.item.type).to_integer_32 /= 104 then
							l_pos := -1 + 33 -- goto set_type
						end
				when 35 then
						l_param.item.type := (('H').code).to_integer_8
						l_pos := -1 + 60 -- switch 1; break
				when 36 then
						l_pos := -1 + 28 -- goto numeric
				when 37 then -- switch 1, case 108
						if (l_param.item.type).to_integer_32 /= 108 then
							l_pos := -1 + 33 -- goto set_type
						end
				when 38 then
						l_param.item.type := (('L').code).to_integer_8
						l_pos := -1 + 60 -- switch 1; break
				when 39 then -- switch 1, case 110
						if (l_param.item.ignore).to_boolean then
							l_pos := -1 + 54 -- skip if block
						end
				when 40 then -- if:
						l_p := (create {CE_POINTER [ANY]}.make_cast (l_ap.pointer_item))
						inspect (l_param.item.type).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 41
						when 70 then l_pos := -1 + 42
						when 72 then l_pos := -1 + 43
						when 104 then l_pos := -1 + 44
						when 106 then l_pos := -1 + 45
						when 108 then l_pos := -1 + 46
						when 113 then l_pos := -1 + 47
						when 76 then l_pos := -1 + 48
						when 81 then l_pos := -1 + 49
						when 116 then l_pos := -1 + 50
						when 122 then l_pos := -1 + 51
						when 90 then l_pos := -1 + 52
						else l_pos := -1 + 53
						end
				when 41 then; -- switch 2, case 0
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_chars
						l_pos := -1 + 54 -- switch 2; break
				when 42 then -- switch 2, case 70
						set_si_inst.gmpf_set_si (create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_p), l_chars.to_integer_32)
						l_pos := -1 + 54 -- switch 2; break
				when 43 then; -- switch 2, case 72
						(create {CE_POINTER [INTEGER_8]}.make_cast (l_p)).item := l_chars.to_integer_8
						l_pos := -1 + 54 -- switch 2; break
				when 44 then; -- switch 2, case 104
						(create {CE_POINTER [INTEGER_16]}.make_cast (l_p)).item := l_chars.to_integer_16
						l_pos := -1 + 54 -- switch 2; break
				when 45 then; -- switch 2, case 106
						(create {CE_POINTER [INTEGER_64]}.make_cast (l_p)).item := l_chars.to_integer_64
						l_pos := -1 + 54 -- switch 2; break
				when 46 then; -- switch 2, case 108
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_chars.to_integer_32
						l_pos := -1 + 54 -- switch 2; break
				when 47 then -- switch 2, case 113
						from
						until
							js.loop_done
						loop
							if {PLATFORM}.Integer_64_bytes.to_natural_32 /= {PLATFORM}.Integer_64_bytes.to_natural_32 then
								assert_inst.gmp_assert_fail (ce_string ("doscan.c"), 705, ce_string ("sizeof (quad_t) == sizeof (long long)"))
							end
							js.break
						end
				when 48 then; -- switch 2, case 76
						(create {CE_POINTER [INTEGER_64]}.make_cast (l_p)).item := l_chars.to_integer_64
						l_pos := -1 + 54 -- switch 2; break
				when 49 then -- switch 2, case 81
						set_si_inst.gmpq_set_si (create {CE_POINTER [PD_MPQ_STRUCT]}.make_cast (l_p), l_chars.to_integer_32, {NATURAL_32} 1)
						l_pos := -1 + 54 -- switch 2; break
				when 50 then; -- switch 2, case 116
						(create {CE_POINTER [INTEGER_32]}.make_cast (l_p)).item := l_chars
						l_pos := -1 + 54 -- switch 2; break
				when 51 then; -- switch 2, case 122
						(create {CE_POINTER [NATURAL_32]}.make_cast (l_p)).item := l_chars.to_natural_32
						l_pos := -1 + 54 -- switch 2; break
				when 52 then -- switch 2, case 90
						set_si_inst.gmpz_set_si (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_p), l_chars.to_integer_32)
						l_pos := -1 + 54 -- switch 2; break
				when 53 then -- switch 2, default:
						l_pos := -1 + 54 -- switch 2; break
				when 54 then -- switch 2, done: | if done
						l_pos := -1 + 2 -- goto next
				when 55 then -- switch 1, case 111
						l_param.item.base := 8
						l_pos := -1 + 28 -- goto numeric
				when 56 then -- switch 1, case 120 | switch 1, case 88
						l_param.item.base := 16
						l_pos := -1 + 28 -- goto numeric
				when 57 then -- switch 1, case 48 | switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57
						l_param.item.width := 0
						from
						until
							js.loop_done
						loop
							l_param.item.width := l_param.item.width * 10 + (l_fchar.to_integer_32 - 48)
							l_tmp___14 := l_fmt
							l_fmt := l_fmt + 1
							l_fchar := l_tmp___14[0]
							if not ((((ctype_b_loc).item[l_fchar.to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
								js.break
							end
						end
						l_fmt := l_fmt - 1
						l_pos := -1 + 60 -- switch 1; break
				when 58 then -- switch 1, case 42
						l_param.item.ignore := 1
						l_pos := -1 + 60 -- switch 1; break
				when 59 then -- switch 1, default:
						l_pos := -1 + 2 -- goto next
				when 60 then -- switch 1, done:
						l_pos := -1 + 10 -- back to loop condition
				when 61 then -- loop done | if done
						if js.loop_increment then
							
						end
						l_pos := -1 + 1 -- back to loop condition
				when 62 then -- done:
					memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_alloc_fmt), l_alloc_fmt_size])
					Result := l_fields
				when 63 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpscan (a_funs: CE_POINTER [PD_GMP_DOSCAN_FUNS_T]; a_data: CE_POINTER [ANY]; a_p: CE_POINTER [PD_GMP_DOSCAN_PARAMS_T]; a_dst: CE_POINTER [ANY]): INTEGER_32
		local
			l_chars: INTEGER_32
			l_c: INTEGER_32
			l_base: INTEGER_32
			l_first: INTEGER_32
			l_width: INTEGER_32
			l_seen_point: INTEGER_32
			l_seen_digit: INTEGER_32
			l_hexfloat: INTEGER_32
			l_s_upto: NATURAL_32
			l_s_alloc: NATURAL_32
			l_hexexp: NATURAL_32
			l_s: CE_POINTER [INTEGER_8]
			l_invalid: INTEGER_32
			l_s_alloc_new: NATURAL_32
			l_tmp___1: NATURAL_32
			l_s_alloc_new___0: NATURAL_32
			l_tmp___3: NATURAL_32
			l_s_alloc_new___1: NATURAL_32
			l_tmp___5: NATURAL_32
			l_s_alloc_new___2: NATURAL_32
			l_tmp___9: NATURAL_32
			l_point: CE_POINTER [INTEGER_8]
			l_pc: INTEGER_32
			l_tmp___11: CE_POINTER [INTEGER_8]
			l_s_alloc_new___3: NATURAL_32
			l_tmp___13: NATURAL_32
			l_tmp___14: CE_POINTER [INTEGER_8]
			l_s_alloc_new___4: NATURAL_32
			l_tmp___16: NATURAL_32
			l_s_alloc_new___5: NATURAL_32
			l_tmp___18: NATURAL_32
			l_f: CE_POINTER [PD_MPF_STRUCT]
			l_tmp___19: INTEGER_32
			l_dummy: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_exp: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_s.make
			create l_point.make
			create l_tmp___11.make
			create l_tmp___14.make
			create l_f.make
			create l_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_invalid := 0
					l_c := (a_funs.item.get).integer_32_item ([a_data])
					if l_c = -1 then
						Result := (-2)
						js.return
					end
					if js.return_called then
						l_pos := -1 + 70 -- skip if block
					end
				when 1 then -- if:
						l_chars := 1
						l_first := 1
						l_seen_point := 0
						if a_p.item.width = 0 then
							l_width := -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) - 1
						else
							l_width := a_p.item.width
						end
						l_base := a_p.item.base
						l_s_alloc := (512).to_natural_32
						l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
						l_s_upto := (0).to_natural_32
						l_hexfloat := 0
						l_hexexp := (0).to_natural_32
				when 2 then -- another:
						l_seen_digit := 0
						if l_c /= 45 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						from
						until
							js.loop_done
						loop
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new := l_s_alloc + {NATURAL_32} 512
								l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
								l_s_alloc := l_s_alloc_new
							end
							l_tmp___1 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___1.to_integer_32] := l_c.to_integer_8
							js.break
						end
						l_pos := -1 + 6 -- goto get_for_sign
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if l_c /= 43 then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if: | get_for_sign:
						if js.loop_done then
							l_pos := -1 + 9 -- skip loop
						end
				when 7 then -- loop body:
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 61 -- goto convert
						end
				when 8 then
						l_c := (a_funs.item.get).integer_32_item ([a_data])
						js.break
						l_pos := -1 + 6 -- back to loop condition
				when 9 then -- loop done | if done
						if l_base /= 0 then
							l_pos := -1 + 23 -- skip if block
						end
				when 10 then -- if:
						l_base := 10
						if l_c /= 48 then
							l_pos := -1 + 23 -- skip if block
						end
				when 11 then -- if:
						l_seen_digit := 1
						if (a_p.item.type).to_integer_32 /= 70 then
							l_base := 8
						end
						from
						until
							js.loop_done
						loop
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___0 := l_s_alloc + {NATURAL_32} 512
								l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___0 * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
								l_s_alloc := l_s_alloc_new___0
							end
							l_tmp___3 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___3.to_integer_32] := l_c.to_integer_8
							js.break
						end
				when 12 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 15 -- skip loop
						end
				when 13 then -- loop body:
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 61 -- goto convert
						end
				when 14 then
						l_c := (a_funs.item.get).integer_32_item ([a_data])
						js.break
						l_pos := -1 + 12 -- back to loop condition
				when 15 then -- loop done
						if l_c /= 120 then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 18 then -- else:
						if l_c /= 88 then
							l_pos := -1 + 23 -- skip if block
						end
				when 19 then -- if: | _L:
						l_base := 16
						l_seen_digit := 0
						if (a_p.item.type).to_integer_32 = 70 then
							l_hexfloat := 1
						else
							from
							until
								js.loop_done
							loop
								if l_s_upto >= l_s_alloc then
									l_s_alloc_new___1 := l_s_alloc + {NATURAL_32} 512
									l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___1 * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
									l_s_alloc := l_s_alloc_new___1
								end
								l_tmp___5 := l_s_upto
								l_s_upto := l_s_upto + 1
								l_s[l_tmp___5.to_integer_32] := l_c.to_integer_8
								js.break
							end
						end
				when 20 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 23 -- skip loop
						end
				when 21 then -- loop body:
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 61 -- goto convert
						end
				when 22 then
						l_c := (a_funs.item.get).integer_32_item ([a_data])
						js.break
						l_pos := -1 + 20 -- back to loop condition
				when 23 then -- loop done | if done | if done | if done | digits:
						if js.loop_done then
							l_pos := -1 + 30 -- skip loop
						end
				when 24 then -- loop body:
						if l_base = 16 then
							if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (4_096)).to_boolean then
								js.break
							end
						else
							if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (2_048)).to_boolean then
								js.break
							end
							if not js.loop_jumped and then (l_base = 8) then
								if l_c = 56 then
									js.break
								elseif l_c = 57 then
									js.break
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 29 -- skip if block
						end
				when 25 then -- if:
						l_seen_digit := 1
						from
						until
							js.loop_done
						loop
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___2 := l_s_alloc + {NATURAL_32} 512
								l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___2 * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
								l_s_alloc := l_s_alloc_new___2
							end
							l_tmp___9 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___9.to_integer_32] := l_c.to_integer_8
							js.break
						end
				when 26 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 29 -- skip loop
						end
				when 27 then -- loop body:
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 61 -- goto convert
						end
				when 28 then
						l_c := (a_funs.item.get).integer_32_item ([a_data])
						js.break
						l_pos := -1 + 26 -- back to loop condition
				when 29 then -- loop done | if done
						l_pos := -1 + 23 -- back to loop condition
				when 30 then -- loop done
						if not (l_first.to_boolean) then
							l_pos := -1 + 61 -- skip if block
						end
				when 31 then -- if:
						if (a_p.item.type).to_integer_32 /= 70 then
							l_pos := -1 + 42 -- skip if block
						end
				when 32 then -- if:
						if l_seen_point.to_boolean then
							l_pos := -1 + 42 -- skip if block
						end
				when 33 then -- if:
						l_point := (nl_langinfo (65_536))
						l_tmp___11 := l_point
						l_point := l_point + 1
						l_pc := ((l_tmp___11[0]).to_natural_8).to_integer_32
						if l_c /= l_pc then
							l_pos := -1 + 42 -- skip if block
						end
				when 34 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 41 -- skip loop
						end
				when 35 then -- loop body:
						from
						until
							js.loop_done
						loop
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___3 := l_s_alloc + {NATURAL_32} 512
								l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___3 * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
								l_s_alloc := l_s_alloc_new___3
							end
							l_tmp___13 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___13.to_integer_32] := l_c.to_integer_8
							js.break
						end
				when 36 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 39 -- skip loop
						end
				when 37 then -- loop body:
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 61 -- goto convert
						end
				when 38 then
						l_c := (a_funs.item.get).integer_32_item ([a_data])
						js.break
						l_pos := -1 + 36 -- back to loop condition
				when 39 then -- loop done
						l_tmp___14 := l_point
						l_point := l_point + 1
						l_pc := ((l_tmp___14[0]).to_natural_8).to_integer_32
						if l_pc = 0 then
							js.break
						end
						if not js.loop_jumped and then (l_c /= l_pc) then
							l_pos := -1 + 62 -- goto set_invalid
						end
				when 40 then
						l_pos := -1 + 34 -- back to loop condition
				when 41 then -- loop done
						l_seen_point := 1
						l_pos := -1 + 23 -- goto digits
				when 42 then -- if done | if done
						if (a_p.item.type).to_integer_32 /= 70 then
							l_pos := -1 + 57 -- skip if block
						end
				when 43 then -- if:
						if not (l_hexfloat.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						if l_c = 112 then
							l_hexexp := l_s_upto
							l_base := 10
							l_pos := -1 + 51 -- goto exponent
						elseif l_c = 80 then
							l_hexexp := l_s_upto
							l_base := 10
							l_pos := -1 + 51 -- goto exponent
						else
							l_pos := -1 + 46 -- goto _L___1
						end
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 46 then -- else: | _L___1:
						if l_hexfloat.to_boolean then
							l_pos := -1 + 57 -- skip if block
						end
				when 47 then -- if:
						if l_c /= 101 then
							l_pos := -1 + 50 -- skip if block
						end
				when 48 then -- if:
						l_pos := -1 + 51 -- goto exponent
				when 49 then -- if block done, skip else block:
						l_pos := -1 + 57
				when 50 then -- else:
						if l_c /= 69 then
							l_pos := -1 + 57 -- skip if block
						end
				when 51 then -- if: | exponent:
						if not l_seen_digit.to_boolean then
							l_pos := -1 + 62 -- goto set_invalid
						end
				when 52 then -- do_second:
						l_first := 0
						from
						until
							js.loop_done
						loop
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___4 := l_s_alloc + {NATURAL_32} 512
								l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___4 * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
								l_s_alloc := l_s_alloc_new___4
							end
							l_tmp___16 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___16.to_integer_32] := l_c.to_integer_8
							js.break
						end
				when 53 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 56 -- skip loop
						end
				when 54 then -- loop body:
						l_chars := l_chars + 1
						if l_chars > l_width then
							l_pos := -1 + 61 -- goto convert
						end
				when 55 then
						l_c := (a_funs.item.get).integer_32_item ([a_data])
						js.break
						l_pos := -1 + 53 -- back to loop condition
				when 56 then -- loop done
						l_pos := -1 + 2 -- goto another
				when 57 then -- if done | if done | if done | if done
						if (a_p.item.type).to_integer_32 /= 81 then
							l_pos := -1 + 61 -- skip if block
						end
				when 58 then -- if:
						if l_c /= 47 then
							l_pos := -1 + 61 -- skip if block
						end
				when 59 then -- if:
						if not l_seen_digit.to_boolean then
							l_pos := -1 + 62 -- goto set_invalid
						end
				when 60 then
						l_seen_digit := 0
						l_base := a_p.item.base
						l_pos := -1 + 52 -- goto do_second
				when 61 then -- if done | if done | convert:
						if l_seen_digit.to_boolean then
							l_pos := -1 + 63 -- skip if block
						end
				when 62 then -- if: | set_invalid:
						l_invalid := 1
						l_pos := -1 + 69 -- goto done
				when 63 then
						if (a_p.item.ignore).to_boolean then
							l_pos := -1 + 69 -- skip if block
						end
				when 64 then -- if:
						from
						until
							js.loop_done
						loop
							if l_s_upto >= l_s_alloc then
								l_s_alloc_new___5 := l_s_alloc + {NATURAL_32} 512
								l_s := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_s), l_s_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, l_s_alloc_new___5 * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
								l_s_alloc := l_s_alloc_new___5
							end
							l_tmp___18 := l_s_upto
							l_s_upto := l_s_upto + 1
							l_s[l_tmp___18.to_integer_32] := (('%/0/').code).to_integer_8
							js.break
						end
						inspect (a_p.item.type).to_integer_32 -- switch 1 head
						when 70 then l_pos := -1 + 65
						when 81 then l_pos := -1 + 66
						when 90 then l_pos := -1 + 67
						else l_pos := -1 + 68
						end
				when 65 then -- switch 1, case 70
						l_f := create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (a_dst)
						if l_hexexp /= {NATURAL_32} 0 then
							l_s[l_hexexp.to_integer_32] := (('%/0/').code).to_integer_8
						end
						if l_hexfloat.to_boolean then
							l_tmp___19 := 16
						else
							l_tmp___19 := 10
						end
						set_str_inst.gmpf_set_str (l_f, l_s, l_tmp___19).do_nothing
						if l_hexexp /= {NATURAL_32} 0 then
							l_exp := strtol (((l_s + l_hexexp.to_integer_32) + 1), l_dummy, 10)
							if l_exp >= 0 then
								mul_2exp_inst.gmpf_mul_2exp (l_f, l_f, l_exp.to_natural_32)
							else
								div_2exp_inst.gmpf_div_2exp (l_f, l_f, (-(l_exp.to_natural_32).to_integer_32).to_natural_32)
							end
						end
						l_pos := -1 + 69 -- switch 1; break
				when 66 then -- switch 1, case 81
						set_str_inst.gmpq_set_str (create {CE_POINTER [PD_MPQ_STRUCT]}.make_cast (a_dst), l_s, a_p.item.base).do_nothing
						l_pos := -1 + 69 -- switch 1; break
				when 67 then -- switch 1, case 90
						set_str_inst.gmpz_set_str (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (a_dst), l_s, a_p.item.base).do_nothing
						l_pos := -1 + 69 -- switch 1; break
				when 68 then -- switch 1, default:
						l_pos := -1 + 69 -- switch 1; break
				when 69 then -- switch 1, done: | done:
						
						if l_chars /= l_width + 1 then
							(a_funs.item.unget).call ([l_c, a_data])
						end
						l_chars := l_chars - 1
						memory_inst.gmp_free_func.call ([create {CE_POINTER [ANY]}.make_cast (l_s), l_s_alloc])
						if l_invalid.to_boolean then
							Result := (-1)
							js.return
						end
				when 70 then -- if done
					if not js.return_called then
						Result := l_chars
					end
				when 71 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	skip_white (a_funs: CE_POINTER [PD_GMP_DOSCAN_FUNS_T]; a_data: CE_POINTER [ANY]): INTEGER_32
		local
			l_c: INTEGER_32
			l_ret: INTEGER_32
			js: JUMP_STATE
		do
			l_ret := 0
			from
			until
				js.loop_done
			loop
				l_c := (a_funs.item.get).integer_32_item ([a_data])
				l_ret := l_ret + 1
				if not ((((ctype_b_loc).item[l_c]).to_integer_32).bit_and (8_192)).to_boolean then
					js.break
				end
			end
			(a_funs.item.unget).call ([l_c, a_data])
			l_ret := l_ret - 1
			Result := l_ret
		end

end
