class
	P_FIB_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_fib_ui (a_fn: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_fp: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_yp: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_xalloc: INTEGER_32
			l_n2: NATURAL_32
			l_c: NATURAL_32
			l_c2: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___13: CE_POINTER [ANY]
			l_xsize: INTEGER_32
			l_ysize: INTEGER_32
			l_tmp___17: NATURAL_32
			l_xsize___0: INTEGER_32
			l_ysize___0: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_fp.make
			create l_xp.make
			create l_yp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___13.make

			if a_n <= {NATURAL_32} 47 then
				a_fn.item.mp_d[0] := fib_table_inst.gmp_fib_table[(a_n + {NATURAL_32} 1).to_integer_32]
				a_fn.item.mp_size := (a_n /= {NATURAL_32} 0).to_integer
				js.return
			end
			if not js.return_called then
				l_n2 := a_n // {NATURAL_32} 2
				l_xalloc := ((((l_n2 // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4) + 1
				if (builtin_expect ((2 * l_xalloc + 1 > (a_fn.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_fn, 2 * l_xalloc + 1).do_nothing
				end
				l_fp := a_fn.item.mp_d
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				from
				until
					js.loop_done
				loop
					if (builtin_expect (((l_xalloc + l_xalloc).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___13 := (l_aaf.new (((l_xalloc + l_xalloc).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___13 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_xalloc + l_xalloc).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_xp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13)
					l_yp := l_xp + l_xalloc
					js.break
				end
				l_size := fib2_ui_inst.gmpn_fib2_ui (l_xp, l_yp, l_n2)
				if ((a_n).bit_and ({NATURAL_32} 1)).to_boolean then
					l_c2 := gmp_inst.gmpn_lshift (l_fp, l_xp, l_size, {NATURAL_32} 1)
					l_c := l_c2 + (gmp_inst.gmpn_add_n (l_xp, l_fp, l_yp, l_size))
					l_xp[l_size] := l_c
					l_xsize := l_size + (l_c /= {NATURAL_32} 0).to_integer
					l_c2 := l_c2 - (gmp_inst.gmpn_sub_n (l_yp, l_fp, l_yp, l_size))
					l_yp[l_size] := l_c2
					l_ysize := (l_size.to_natural_32 + l_c2).to_integer_32
					l_size := l_xsize + l_ysize
					l_c := mul_inst.gmpn_mul (l_fp, l_xp, l_xsize, l_yp, l_ysize)
					if ((a_n).bit_and ({NATURAL_32} 2)).to_boolean then
						l_tmp___17 := (-((2).to_natural_32).to_integer_32).to_natural_32
					else
						l_tmp___17 := (2).to_natural_32
					end
					l_fp[0] := l_fp[0] + l_tmp___17
				else
					l_c := gmp_inst.gmpn_lshift (l_yp, l_yp, l_size, {NATURAL_32} 1)
					l_c := l_c + (gmp_inst.gmpn_add_n (l_yp, l_yp, l_xp, l_size))
					l_yp[l_size] := l_c
					l_xsize___0 := l_size
					l_ysize___0 := l_size + (l_c /= {NATURAL_32} 0).to_integer
					l_size := l_size + l_ysize___0
					l_c := mul_inst.gmpn_mul (l_fp, l_yp, l_ysize___0, l_xp, l_xsize___0)
				end
				l_size := l_size - (l_c = {NATURAL_32} 0).to_integer
				l_size := l_size - (l_fp[(l_size - 1)] = {NATURAL_32} 0).to_integer
				a_fn.item.mp_size := l_size.to_integer_32
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
