class
	P_GET_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_get_ui (a_f: CE_POINTER [PD_MPF_STRUCT]): NATURAL_32
		local
			l_size: INTEGER_32
			l_exp: INTEGER_32
			l_fp: CE_POINTER [NATURAL_32]
			l_fl: NATURAL_32
		do
			create l_fp.make

			l_exp := a_f.item.mp_exp
			l_size := (a_f.item.mp_size).to_integer_32
			l_fp := a_f.item.mp_d
			l_fl := (0).to_natural_32
			if l_exp > 0 then
				if l_size >= 0 then
					l_size := l_size
				else
					l_size := -l_size
				end
				if l_size >= l_exp then
					l_fl := l_fp[(l_size - l_exp)]
				end
			end
			Result := l_fl
		end

end
