class
	P_GMP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_add (a___gmp_wp: CE_POINTER [NATURAL_32]; a___gmp_xp: CE_POINTER [NATURAL_32]; a___gmp_xsize: INTEGER_32; a___gmp_yp: CE_POINTER [NATURAL_32]; a___gmp_ysize: INTEGER_32): NATURAL_32
		local
			l___gmp_c: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: NATURAL_32
			l___gmp_j: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if js.loop_done then
						l_pos := -1 + 8 -- skip loop
					end
				when 1 then -- loop body:
						l___gmp_i := a___gmp_ysize
						if l___gmp_i = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if not ((gmpn_add_n (a___gmp_wp, a___gmp_xp, a___gmp_yp, l___gmp_i)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						if l___gmp_i >= a___gmp_xsize then
							l___gmp_c := (1).to_natural_32
							l_pos := -1 + 7 -- goto __gmp_done
						end
				when 5 then
						l___gmp_x := a___gmp_xp[l___gmp_i]
						l_tmp := l___gmp_i
						l___gmp_i := l___gmp_i + 1
						l_tmp___0 := ((l___gmp_x + {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
						a___gmp_wp[l_tmp] := l_tmp___0
						if l_tmp___0 /= {NATURAL_32} 0 then
							js.break
						end
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done | if done | if done
						if not a___gmp_wp.is_equal (a___gmp_xp) then
							from
							until
								js.loop_done
							loop
								l___gmp_j := l___gmp_i
								from
								until
									not (l___gmp_j < a___gmp_xsize)
								loop
									a___gmp_wp[l___gmp_j] := a___gmp_xp[l___gmp_j]
									l___gmp_j := l___gmp_j + 1
								end
								js.break
							end
						end
						l___gmp_c := (0).to_natural_32
				when 7 then -- __gmp_done:
						
						js.break
						l_pos := -1 + 0 -- back to loop condition
				when 8 then -- loop done
					Result := l___gmp_c
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_add_1 (a___gmp_dst: CE_POINTER [NATURAL_32]; a___gmp_src: CE_POINTER [NATURAL_32]; a___gmp_size: INTEGER_32; a___gmp_n: NATURAL_32): NATURAL_32
		local
			l___gmp_c: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_r: NATURAL_32
			l___gmp_j: INTEGER_32
			l___gmp_j___0: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				l___gmp_x := a___gmp_src[0]
				l___gmp_r := l___gmp_x + a___gmp_n
				a___gmp_dst[0] := l___gmp_r
				if l___gmp_r < a___gmp_n then
					l___gmp_c := (1).to_natural_32
					l___gmp_i := (1).to_integer_32
					from
					until
						not (not js.loop_done and then (l___gmp_i < a___gmp_size))
					loop
						l___gmp_x := a___gmp_src[l___gmp_i]
						l___gmp_r := l___gmp_x + {NATURAL_32} 1
						a___gmp_dst[l___gmp_i] := l___gmp_r
						l___gmp_i := l___gmp_i + 1
						if not (l___gmp_r < {NATURAL_32} 1) then
							if not a___gmp_src.is_equal (a___gmp_dst) then
								from
								until
									js.loop_done
								loop
									l___gmp_j := l___gmp_i
									from
									until
										not (l___gmp_j < a___gmp_size)
									loop
										a___gmp_dst[l___gmp_j] := a___gmp_src[l___gmp_j]
										l___gmp_j := l___gmp_j + 1
									end
									js.break
								end
							end
							l___gmp_c := (0).to_natural_32
							js.break
						end
					end
				else
					if not a___gmp_src.is_equal (a___gmp_dst) then
						from
						until
							js.loop_done
						loop
							l___gmp_j___0 := (1).to_integer_32
							from
							until
								not (l___gmp_j___0 < a___gmp_size)
							loop
								a___gmp_dst[l___gmp_j___0] := a___gmp_src[l___gmp_j___0]
								l___gmp_j___0 := l___gmp_j___0 + 1
							end
							js.break
						end
					end
					l___gmp_c := (0).to_natural_32
				end
				js.break
			end
			Result := l___gmp_c
		end

	gmpn_add_n (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_add_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_add_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_add_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_addmul_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_addmul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_addmul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_addmul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_cmp (a___gmp_xp: CE_POINTER [NATURAL_32]; a___gmp_yp: CE_POINTER [NATURAL_32]; a___gmp_size: INTEGER_32): INTEGER_32
		local
			l___gmp_result: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				l___gmp_result := 0
				l___gmp_i := a___gmp_size
				from
				until
					js.loop_done
				loop
					l___gmp_i := l___gmp_i - 1
					if not (l___gmp_i >= 0) then
						js.break
					end
					if not js.loop_jumped then
						l___gmp_x := a___gmp_xp[l___gmp_i]
						l___gmp_y := a___gmp_yp[l___gmp_i]
						if l___gmp_x /= l___gmp_y then
							if l___gmp_x > l___gmp_y then
								l___gmp_result := 1
							else
								l___gmp_result := -1
							end
							js.break
						end
					end
				end
				js.break
			end
			Result := l___gmp_result
		end

	gmpn_copyd (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_copyd (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_copyd (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_copyd($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_copyi (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32)
		do
			c_gmpn_copyi (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_copyi (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32)
		external
			"C inline use <libgmp.h>"
		alias
			"__gmpn_copyi($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_divrem_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_divrem_1 (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5)
		end

	c_gmpn_divrem_1 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_divrem_1($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_divrem_2 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32; a_arg5: CE_POINTER [NATURAL_32]): NATURAL_32
		do
			Result := c_gmpn_divrem_2 (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5.c_pointer)
		end

	c_gmpn_divrem_2 (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_divrem_2($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	gmpn_hamdist (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_hamdist (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_gmpn_hamdist (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_hamdist($a_arg1, $a_arg2, $a_arg3);"
		end

	gmpn_lshift (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_lshift (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_lshift (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_lshift($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_mul_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_mul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_mul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_mul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_neg (a___gmp_rp: CE_POINTER [NATURAL_32]; a___gmp_up: CE_POINTER [NATURAL_32]; a___gmp_n: INTEGER_32): NATURAL_32
		local
			l___gmp_rp: CE_POINTER [NATURAL_32]
			l___gmp_up: CE_POINTER [NATURAL_32]
			l___gmp_n: INTEGER_32
			l___gmp_ul: NATURAL_32
			l___gmp_cy: NATURAL_32
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l___gmp_rp.make
			create l___gmp_up.make
			create l_tmp.make
			create l_tmp___0.make

			l___gmp_rp := a___gmp_rp
			l___gmp_up := a___gmp_up
			l___gmp_n := a___gmp_n
			l___gmp_cy := (0).to_natural_32
			from
			until
				js.loop_done
			loop
				l_tmp := l___gmp_up
				l___gmp_up := l___gmp_up + 1
				l___gmp_ul := l_tmp.item
				l_tmp___0 := l___gmp_rp
				l___gmp_rp := l___gmp_rp + 1
				l_tmp___0.item := (-l___gmp_ul.to_integer_32).to_natural_32 - l___gmp_cy
				l___gmp_cy := (l___gmp_cy).bit_or ((l___gmp_ul /= {NATURAL_32} 0).to_integer.to_natural_32)
				l___gmp_n := l___gmp_n - 1
				if l___gmp_n = 0 then
					js.break
				end
			end
			Result := l___gmp_cy
		end

	gmpn_popcount (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_popcount (a_arg1.c_pointer, a_arg2)
		end

	c_gmpn_popcount (a_arg1: POINTER; a_arg2: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_popcount($a_arg1, $a_arg2);"
		end

	gmpn_rshift (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_rshift (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_rshift (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_rshift($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_sub (a___gmp_wp: CE_POINTER [NATURAL_32]; a___gmp_xp: CE_POINTER [NATURAL_32]; a___gmp_xsize: INTEGER_32; a___gmp_yp: CE_POINTER [NATURAL_32]; a___gmp_ysize: INTEGER_32): NATURAL_32
		local
			l___gmp_c: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l_tmp: INTEGER_32
			l___gmp_j: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if js.loop_done then
						l_pos := -1 + 8 -- skip loop
					end
				when 1 then -- loop body:
						l___gmp_i := a___gmp_ysize
						if l___gmp_i = 0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						if not ((gmpn_sub_n (a___gmp_wp, a___gmp_xp, a___gmp_yp, l___gmp_i)).to_boolean) then
							l_pos := -1 + 6 -- skip if block
						end
				when 3 then -- if: | loop condition:
						if js.loop_done then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						if l___gmp_i >= a___gmp_xsize then
							l___gmp_c := (1).to_natural_32
							l_pos := -1 + 7 -- goto __gmp_done
						end
				when 5 then
						l___gmp_x := a___gmp_xp[l___gmp_i]
						l_tmp := l___gmp_i
						l___gmp_i := l___gmp_i + 1
						a___gmp_wp[l_tmp] := ((l___gmp_x - {NATURAL_32} 1)).bit_and ({NATURAL_32} 4_294_967_295)
						if l___gmp_x /= {NATURAL_32} 0 then
							js.break
						end
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done | if done | if done
						if not a___gmp_wp.is_equal (a___gmp_xp) then
							from
							until
								js.loop_done
							loop
								l___gmp_j := l___gmp_i
								from
								until
									not (l___gmp_j < a___gmp_xsize)
								loop
									a___gmp_wp[l___gmp_j] := a___gmp_xp[l___gmp_j]
									l___gmp_j := l___gmp_j + 1
								end
								js.break
							end
						end
						l___gmp_c := (0).to_natural_32
				when 7 then -- __gmp_done:
						
						js.break
						l_pos := -1 + 0 -- back to loop condition
				when 8 then -- loop done
					Result := l___gmp_c
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_sub_1 (a___gmp_dst: CE_POINTER [NATURAL_32]; a___gmp_src: CE_POINTER [NATURAL_32]; a___gmp_size: INTEGER_32; a___gmp_n: NATURAL_32): NATURAL_32
		local
			l___gmp_c: NATURAL_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_r: NATURAL_32
			l___gmp_j: INTEGER_32
			l___gmp_j___0: INTEGER_32
			js: JUMP_STATE
		do
			from
			until
				js.loop_done
			loop
				l___gmp_x := a___gmp_src[0]
				l___gmp_r := l___gmp_x - a___gmp_n
				a___gmp_dst[0] := l___gmp_r
				if l___gmp_x < a___gmp_n then
					l___gmp_c := (1).to_natural_32
					l___gmp_i := (1).to_integer_32
					from
					until
						not (not js.loop_done and then (l___gmp_i < a___gmp_size))
					loop
						l___gmp_x := a___gmp_src[l___gmp_i]
						l___gmp_r := l___gmp_x - {NATURAL_32} 1
						a___gmp_dst[l___gmp_i] := l___gmp_r
						l___gmp_i := l___gmp_i + 1
						if not (l___gmp_x < {NATURAL_32} 1) then
							if not a___gmp_src.is_equal (a___gmp_dst) then
								from
								until
									js.loop_done
								loop
									l___gmp_j := l___gmp_i
									from
									until
										not (l___gmp_j < a___gmp_size)
									loop
										a___gmp_dst[l___gmp_j] := a___gmp_src[l___gmp_j]
										l___gmp_j := l___gmp_j + 1
									end
									js.break
								end
							end
							l___gmp_c := (0).to_natural_32
							js.break
						end
					end
				else
					if not a___gmp_src.is_equal (a___gmp_dst) then
						from
						until
							js.loop_done
						loop
							l___gmp_j___0 := (1).to_integer_32
							from
							until
								not (l___gmp_j___0 < a___gmp_size)
							loop
								a___gmp_dst[l___gmp_j___0] := a___gmp_src[l___gmp_j___0]
								l___gmp_j___0 := l___gmp_j___0 + 1
							end
							js.break
						end
					end
					l___gmp_c := (0).to_natural_32
				end
				js.break
			end
			Result := l___gmp_c
		end

	gmpn_sub_n (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): NATURAL_32
		do
			Result := c_gmpn_sub_n (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer, a_arg4)
		end

	c_gmpn_sub_n (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER; a_arg4: INTEGER_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_sub_n($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpn_submul_1 (a_arg1: CE_POINTER [NATURAL_32]; a_arg2: CE_POINTER [NATURAL_32]; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		do
			Result := c_gmpn_submul_1 (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4)
		end

	c_gmpn_submul_1 (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: NATURAL_32): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return __gmpn_submul_1($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	gmpz_fits_uint_p (a___gmp_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l___gmp_n: INTEGER_32
			l___gmp_p: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
		do
			create l___gmp_p.make

			l___gmp_n := (a___gmp_z.item.mp_size).to_integer_32
			l___gmp_p := a___gmp_z.item.mp_d
			if l___gmp_n = 0 then
				l_tmp := 1
			elseif l___gmp_n = 1 then
				if l___gmp_p[0] <= {NATURAL_32} 4_294_967_295 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	gmpz_fits_ushort_p (a___gmp_z: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l___gmp_n: INTEGER_32
			l___gmp_p: CE_POINTER [NATURAL_32]
			l_tmp: INTEGER_32
		do
			create l___gmp_p.make

			l___gmp_n := (a___gmp_z.item.mp_size).to_integer_32
			l___gmp_p := a___gmp_z.item.mp_d
			if l___gmp_n = 0 then
				l_tmp := 1
			elseif l___gmp_n = 1 then
				if l___gmp_p[0] <= {NATURAL_32} 65_535 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	gmpz_get_ui (a___gmp_z: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l___gmp_p: CE_POINTER [NATURAL_32]
			l___gmp_n: INTEGER_32
			l___gmp_l: NATURAL_32
			l_tmp: NATURAL_32
		do
			create l___gmp_p.make

			l___gmp_p := a___gmp_z.item.mp_d
			l___gmp_n := (a___gmp_z.item.mp_size).to_integer_32
			l___gmp_l := l___gmp_p[0]
			if l___gmp_n /= 0 then
				l_tmp := l___gmp_l
			else
				l_tmp := (0).to_natural_32
			end
			Result := l_tmp
		end

	gmpz_getlimbn (a___gmp_z: CE_POINTER [PD_MPZ_STRUCT]; a___gmp_n: INTEGER_32): NATURAL_32
		local
			l___gmp_result: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l___gmp_result := (0).to_natural_32
			if a___gmp_n >= 0 then
				if a___gmp_z.item.mp_size >= 0 then
					l_tmp := a___gmp_z.item.mp_size
				else
					l_tmp := -a___gmp_z.item.mp_size
				end
				if a___gmp_n < l_tmp.to_integer_32 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			if (builtin_expect ((l_tmp___0 /= 0).to_integer, 1)).to_boolean then
				l___gmp_result := a___gmp_z.item.mp_d[a___gmp_n]
			end
			Result := l___gmp_result
		end

	gmpz_perfect_square_p (a___gmp_a: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l___gmp_asize: INTEGER_32
			l___gmp_result: INTEGER_32
		do
			l___gmp_asize := (a___gmp_a.item.mp_size).to_integer_32
			l___gmp_result := (l___gmp_asize >= 0).to_integer
			if (builtin_expect ((l___gmp_asize > 0).to_integer, 1)).to_boolean then
				l___gmp_result := perfsqr_inst.gmpn_perfect_square_p (a___gmp_a.item.mp_d, l___gmp_asize)
			end
			Result := l___gmp_result
		end

	gmpz_popcount (a___gmp_u: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l___gmp_usize: INTEGER_32
			l___gmp_result: NATURAL_32
		do
			l___gmp_usize := (a___gmp_u.item.mp_size).to_integer_32
			if l___gmp_usize < 0 then
				l___gmp_result := ({NATURAL_32} 0).bit_not
			else
				l___gmp_result := (0).to_natural_32
			end
			if (builtin_expect ((l___gmp_usize > 0).to_integer, 1)).to_boolean then
				l___gmp_result := gmpn_popcount (a___gmp_u.item.mp_d, l___gmp_usize)
			end
			Result := l___gmp_result
		end

	gmpz_set_q (a___gmp_w: CE_POINTER [PD_MPZ_STRUCT]; a___gmp_u: CE_POINTER [PD_MPQ_STRUCT])
		do
			tdiv_q_inst.gmpz_tdiv_q (a___gmp_w, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a___gmp_u.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num")), create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a___gmp_u.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den")))
		end

	gmpz_size (a___gmp_z: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_tmp: INTEGER_32
		do
			if a___gmp_z.item.mp_size >= 0 then
				l_tmp := a___gmp_z.item.mp_size
			else
				l_tmp := -a___gmp_z.item.mp_size
			end
			Result := l_tmp.to_natural_32
		end

end
