class
	P_INP_RAW

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_inp_raw (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_fp: CE_POINTER [SD_IO_FILE]): NATURAL_32
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_csize_bytes: CE_ARRAY [NATURAL_8]
			l_csize: INTEGER_32
			l_abs_xsize: INTEGER_32
			l_i: INTEGER_32
			l_abs_csize: NATURAL_32
			l_cp: CE_POINTER [INTEGER_8]
			l_xp: CE_POINTER [NATURAL_32]
			l_sp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_ep: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_slimb: CE_ARRAY [NATURAL_32]
			l_elimb: CE_ARRAY [NATURAL_32]
			l_tmp___2: CE_POINTER [NATURAL_32]
			l_tmp___3: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_fp.make
			create l_csize_bytes.make (<<4>>)
			create l_cp.make
			create l_xp.make
			create l_sp.make (<<1>>)
			create l_ep.make (<<1>>)
			create l_slimb.make (<<1>>)
			create l_elimb.make (<<1>>)
			create l_tmp___2.make
			create l_tmp___3.make

			l_fp := a_fp
			if l_fp.is_void then
				l_fp := (create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))
			end
			if (fread (create {CE_POINTER [ANY]}.make_cast (l_csize_bytes), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (4).to_natural_32), (1).to_natural_32, l_fp)) /= {NATURAL_32} 1 then
				Result := (0).to_natural_32
				js.return
			end
			if not js.return_called then
				l_csize := (((((l_csize_bytes[0]).to_integer_32).bit_shift_left (24)) + (((l_csize_bytes[1]).to_integer_32).bit_shift_left (16))) + (((l_csize_bytes[2]).to_integer_32).bit_shift_left (8))) + (l_csize_bytes[3]).to_integer_32
				if {PLATFORM}.Integer_32_bytes.to_natural_32 > {NATURAL_32} 4 then
					if ((l_csize.to_natural_32).bit_and ({NATURAL_32} 2_147_483_648)).to_boolean then
						l_csize := (l_csize.to_natural_32 - (({NATURAL_32} 2_147_483_648).bit_shift_left (1))).to_integer_32
					end
				end
				if l_csize >= 0 then
					l_abs_csize := l_csize.to_natural_32
				else
					l_abs_csize := (-l_csize).to_natural_32
				end
				l_abs_xsize := (((l_abs_csize * {NATURAL_32} 8 + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
				if l_abs_xsize /= 0 then
					if (builtin_expect ((l_abs_xsize > (a_x___2.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_x___2, l_abs_xsize).do_nothing
					end
					l_xp := a_x___2.item.mp_d
					l_xp[0] := (0).to_natural_32
					l_cp := create {CE_POINTER [INTEGER_8]}.make_cast ((l_xp + l_abs_xsize)) - l_abs_csize.to_integer_32
					if (fread (create {CE_POINTER [ANY]}.make_cast (l_cp), l_abs_csize, (1).to_natural_32, l_fp)) /= {NATURAL_32} 1 then
						Result := (0).to_natural_32
						js.return
					end
					if not js.return_called then
						l_sp.item := l_xp
						l_ep.item := (l_xp + l_abs_xsize) - 1
						l_i := (0).to_integer_32
						from
						until
							not (not js.loop_done and then (l_i < (l_abs_xsize + 1) // 2))
						loop
							from
							until
								js.loop_done
							loop
								asm18 (l_elimb, l_ep)
								js.break
							end
							from
							until
								js.loop_done
							loop
								asm19 (l_slimb, l_sp)
								js.break
							end
							l_tmp___2 := l_sp.item
							l_sp.item := l_sp.item + 1
							l_tmp___2.item := l_elimb.item
							l_tmp___3 := l_ep.item
							l_ep.item := l_ep.item - 1
							l_tmp___3.item := l_slimb.item
							l_i := l_i + 1
						end
						from
						until
							js.loop_done
						loop
							from
							until
								not (not js.loop_done and then (l_abs_xsize > 0))
							loop
								if l_xp[(l_abs_xsize - 1)] /= {NATURAL_32} 0 then
									js.break
								end
								if not js.loop_jumped then
									l_abs_xsize := l_abs_xsize - 1
								end
							end
							js.break
						end
					end
				end
			end
			if not js.return_called then
				if l_csize >= 0 then
					a_x___2.item.mp_size := l_abs_xsize.to_integer_32
				else
					a_x___2.item.mp_size := (-l_abs_xsize).to_integer_32
				end
				Result := (l_abs_csize + {NATURAL_32} 4)
			end
		end

end
