class
	P_ISET_SI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_init_set_si (a_r: CE_POINTER [PD_MPF_STRUCT]; a_val: INTEGER_32)
		local
			l_prec: INTEGER_32
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp___0: INTEGER_32
		do
			l_prec := set_dfl_prec_inst.gmp_default_fp_limb_precision
			a_r.item.mp_prec := l_prec.to_integer_32
			a_r.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([((l_prec + 1) * 4).to_natural_32]))))
			if a_val >= 0 then
				l_tmp___0 := a_val
			else
				l_tmp___0 := -a_val
			end
			l_vl := l_tmp___0.to_natural_32
			a_r.item.mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			a_r.item.mp_exp := l_size
			if a_val >= 0 then
				a_r.item.mp_size := l_size.to_integer_32
			else
				a_r.item.mp_size := (-l_size).to_integer_32
			end
		end

	gmpz_init_set_si (a_dest: CE_POINTER [PD_MPZ_STRUCT]; a_val: INTEGER_32)
		local
			l_size: INTEGER_32
			l_vl: NATURAL_32
			l_tmp___0: INTEGER_32
		do
			a_dest.item.mp_alloc := 1
			a_dest.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(4).to_natural_32]))))
			if a_val >= 0 then
				l_tmp___0 := a_val
			else
				l_tmp___0 := -a_val
			end
			l_vl := l_tmp___0.to_natural_32
			a_dest.item.mp_d[0] := (l_vl).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (l_vl /= {NATURAL_32} 0).to_integer
			if a_val >= 0 then
				a_dest.item.mp_size := l_size.to_integer_32
			else
				a_dest.item.mp_size := (-l_size).to_integer_32
			end
		end

end
