class
	P_LUCNUM_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_lucnum_ui (a_ln: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_n: NATURAL_32
			l_lalloc: INTEGER_32
			l_xalloc: INTEGER_32
			l_lsize: INTEGER_32
			l_xsize: INTEGER_32
			l_lp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_xp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_c: NATURAL_32
			l_zeros: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___3: CE_POINTER [ANY]
			l_yalloc: INTEGER_32
			l_ysize: INTEGER_32
			l_yp: CE_POINTER [NATURAL_32]
			l_tmp___8: CE_POINTER [ANY]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_lp.make (<<1>>)
			create l_xp.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l_tmp___3.make
			create l_yp.make
			create l_tmp___8.make
			create l___ptr_dummy.make (<<1>>)
			create l___mp_ptr_swap__tmp.make
			create l___ptr_dummy___0.make (<<1>>)
			create l___mp_ptr_swap__tmp___0.make

			l_n := a_n
			if l_n <= {NATURAL_32} 46 then
				a_ln.item.mp_d[0] := (fib_table_inst.gmp_fib_table[(l_n + {NATURAL_32} 1).to_integer_32] + {NATURAL_32} 2 * fib_table_inst.gmp_fib_table[(l_n.to_integer_32 - 1) + 1])
				a_ln.item.mp_size := 1
				js.return
			end
			if not js.return_called then
				l_lalloc := ((((l_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4) + 2
				if (builtin_expect ((l_lalloc > (a_ln.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_ln, l_lalloc).do_nothing
				end
				l_lp.item := a_ln.item.mp_d
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_xalloc := l_lalloc
				if (builtin_expect ((l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___3 := (l_aaf.new ((l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___3 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_xalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_xp.item := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3)
				l_zeros := 0
				from
				until
					js.loop_done
				loop
					if ((l_n).bit_and ({NATURAL_32} 1)).to_boolean then
						l_yalloc := ((((l_n // {NATURAL_32} 2) // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
						if (builtin_expect ((l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___8 := (l_aaf.new ((l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___8 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_yalloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_yp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___8)
						l_xsize := fib2_ui_inst.gmpn_fib2_ui (l_xp.item, l_yp, l_n // {NATURAL_32} 2)
						l_ysize := l_xsize
						l_ysize := l_ysize - (l_yp[(l_ysize - 1)] = {NATURAL_32} 0).to_integer
						l_c := gmp_inst.gmpn_lshift (l_xp.item, l_xp.item, l_xsize, {NATURAL_32} 1)
						l_c := l_c + (gmp_inst.gmpn_add_n (l_xp.item, l_xp.item, l_yp, l_xsize))
						l_xp.item[l_xsize] := l_c
						l_xsize := l_xsize + (l_c /= {NATURAL_32} 0).to_integer
						l_c := mul_inst.gmpn_mul (l_lp.item, l_xp.item, l_xsize, l_yp, l_ysize)
						l_lsize := l_xsize + l_ysize
						l_lsize := l_lsize - (l_c = {NATURAL_32} 0).to_integer
						l_c := gmp_inst.gmpn_lshift (l_xp.item, l_lp.item, l_lsize, {NATURAL_32} 2)
						l_c := l_c + (gmp_inst.gmpn_add_n (l_lp.item, l_lp.item, l_xp.item, l_lsize))
						l_lp.item[l_lsize] := l_c
						l_lsize := l_lsize + (l_c /= {NATURAL_32} 0).to_integer
						if ((l_n).bit_and ({NATURAL_32} 2)).to_boolean then
							l_lp.item[0] := l_lp.item[0] + ({NATURAL_32} 4)
						else
							from
							until
								js.loop_done
							loop
								asm20 (l___ptr_dummy, l_lp)
								js.break
							end
						end
						js.break
					end
					if not js.loop_jumped then
						from
						until
							js.loop_done
						loop
							l___mp_ptr_swap__tmp := l_xp.item
							l_xp.item := l_lp.item
							l_lp.item := l___mp_ptr_swap__tmp
							js.break
						end
						l_zeros := l_zeros + 1
						l_n := l_n // ({NATURAL_32} 2)
						if l_n <= {NATURAL_32} 46 then
							l_lp.item[0] := (fib_table_inst.gmp_fib_table[(l_n + {NATURAL_32} 1).to_integer_32] + {NATURAL_32} 2 * fib_table_inst.gmp_fib_table[(l_n.to_integer_32 - 1) + 1])
							l_lsize := (1).to_integer_32
							js.break
						end
					end
				end
				from
				until
					not (not js.loop_done and then (l_zeros /= 0))
				loop
					sqr_inst.gmpn_sqr (l_xp.item, l_lp.item, l_lsize)
					l_lsize := l_lsize * (2)
					l_lsize := l_lsize - (l_xp.item[(l_lsize - 1)] = {NATURAL_32} 0).to_integer
					if ((l_n).bit_and ({NATURAL_32} 1)).to_boolean then
						l_xp.item[0] := l_xp.item[0] + ({NATURAL_32} 2)
						l_n := {NATURAL_32} 0
					else
						from
						until
							js.loop_done
						loop
							asm21 (l___ptr_dummy___0, l_xp)
							js.break
						end
					end
					from
					until
						js.loop_done
					loop
						l___mp_ptr_swap__tmp___0 := l_xp.item
						l_xp.item := l_lp.item
						l_lp.item := l___mp_ptr_swap__tmp___0
						js.break
					end
					l_zeros := l_zeros - 1
				end
				a_ln.item.mp_size := l_lsize.to_integer_32
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
