class
	P_MU_BDIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mu_bdiv_q (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_scratch: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_dn: CE_ARRAY [INTEGER_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l_in: CE_ARRAY [INTEGER_32]
			l_cy: INTEGER_32
			l_c0: CE_ARRAY [INTEGER_32]
			l_tn: INTEGER_32
			l_wn: CE_ARRAY [INTEGER_32]
			l_b: INTEGER_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_scratch.make (<<1>>)
			create l_dn.make (<<1>>)
			create l_qp.make
			create l_np.make
			create l_in.make (<<1>>)
			create l_c0.make (<<1>>)
			create l_wn.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)
			create l___ptr_dummy___0.make (<<1>>)
			create l___ptr_dummy___1.make (<<1>>)
			create l___ptr_dummy___2.make (<<1>>)
			create l___ptr_dummy___3.make (<<1>>)

			l_scratch.item := a_scratch
			l_dn.item := a_dn
			l_qp := a_qp
			l_np := a_np
			l_qn := a_nn
			if l_qn > l_dn.item then
				l_b := (l_qn - 1) // l_dn.item + 1
				l_in.item := (l_qn - 1) // l_b + 1
				binvert_inst.gmpn_binvert (l_scratch.item, a_dp, l_in.item, l_scratch.item + l_in.item)
				l_cy := 0
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_scratch.item + l_in.item, l_np, l_dn.item)
						js.break
					end
					js.break
				end
				l_np := l_np + (l_dn.item)
				mullo_n_inst.gmpn_mullo_n (l_qp, (l_scratch.item + l_in.item), l_scratch.item, l_in.item)
				l_qn := l_qn - (l_in.item)
				from
				until
					not (not js.loop_done and then (l_qn > l_in.item))
				loop
					if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if l_in.item >= 58 then
							l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_dn.item)
							mulmod_bnm1_inst.gmpn_mulmod_bnm1 ((l_scratch.item + l_in.item) + l_dn.item, l_tn, a_dp, l_dn.item, l_qp, l_in.item, ((l_scratch.item + l_in.item) + l_dn.item) + l_tn)
							l_wn.item := (l_dn.item + l_in.item) - l_tn
							if l_wn.item > 0 then
								l_c0.item := (gmp_inst.gmpn_sub_n (((l_scratch.item + l_in.item) + l_dn.item) + l_tn, ((l_scratch.item + l_in.item) + l_dn.item), (l_scratch.item + l_in.item), l_wn.item)).to_integer_32
								from
								until
									js.loop_done
								loop
									asm327 (l___ptr_dummy, l_scratch, l_in, l_dn, l_wn, l_c0)
									js.break
								end
							end
						else
							mul_inst.gmpn_mul ((l_scratch.item + l_in.item) + l_dn.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
						end
					else
						mul_inst.gmpn_mul ((l_scratch.item + l_in.item) + l_dn.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
					end
					l_qp := l_qp + (l_in.item)
					if l_dn.item /= l_in.item then
						l_cy := (l_cy.to_natural_32 + (gmp_inst.gmpn_sub_n (l_scratch.item + l_in.item, ((l_scratch.item + l_in.item) + l_in.item), (((l_scratch.item + l_in.item) + l_dn.item) + l_in.item), l_dn.item - l_in.item))).to_integer_32
						if l_cy = 2 then
							from
							until
								js.loop_done
							loop
								asm328 (l___ptr_dummy___0, l_scratch, l_in, l_dn)
								js.break
							end
							l_cy := 1
						end
					end
					l_cy := (gmp_impl_inst.gmpn_sub_nc (((l_scratch.item + l_in.item) + l_dn.item) - l_in.item, l_np, (((l_scratch.item + l_in.item) + l_dn.item) + l_dn.item), l_in.item, l_cy.to_natural_32)).to_integer_32
					l_np := l_np + (l_in.item)
					mullo_n_inst.gmpn_mullo_n (l_qp, (l_scratch.item + l_in.item), l_scratch.item, l_in.item)
					l_qn := l_qn - (l_in.item)
				end
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in.item >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_dn.item)
						mulmod_bnm1_inst.gmpn_mulmod_bnm1 ((l_scratch.item + l_in.item) + l_dn.item, l_tn, a_dp, l_dn.item, l_qp, l_in.item, ((l_scratch.item + l_in.item) + l_dn.item) + l_tn)
						l_wn.item := (l_dn.item + l_in.item) - l_tn
						if l_wn.item > 0 then
							l_c0.item := (gmp_inst.gmpn_sub_n (((l_scratch.item + l_in.item) + l_dn.item) + l_tn, ((l_scratch.item + l_in.item) + l_dn.item), (l_scratch.item + l_in.item), l_wn.item)).to_integer_32
							from
							until
								js.loop_done
							loop
								asm329 (l___ptr_dummy___1, l_scratch, l_in, l_dn, l_wn, l_c0)
								js.break
							end
						end
					else
						mul_inst.gmpn_mul ((l_scratch.item + l_in.item) + l_dn.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
					end
				else
					mul_inst.gmpn_mul ((l_scratch.item + l_in.item) + l_dn.item, a_dp, l_dn.item, l_qp, l_in.item).do_nothing
				end
				l_qp := l_qp + (l_in.item)
				if l_dn.item /= l_in.item then
					l_cy := (l_cy.to_natural_32 + (gmp_inst.gmpn_sub_n (l_scratch.item + l_in.item, ((l_scratch.item + l_in.item) + l_in.item), (((l_scratch.item + l_in.item) + l_dn.item) + l_in.item), l_dn.item - l_in.item))).to_integer_32
					if l_cy = 2 then
						from
						until
							js.loop_done
						loop
							asm330 (l___ptr_dummy___2, l_scratch, l_in, l_dn)
							js.break
						end
						l_cy := 1
					end
				end
				gmp_impl_inst.gmpn_sub_nc (((l_scratch.item + l_in.item) + l_dn.item) - l_in.item, l_np, (((l_scratch.item + l_in.item) + l_dn.item) + l_dn.item), l_qn - (l_dn.item - l_in.item), l_cy.to_natural_32).do_nothing
				mullo_n_inst.gmpn_mullo_n (l_qp, (l_scratch.item + l_in.item), l_scratch.item, l_qn)
			else
				l_in.item := l_qn - ((l_qn).bit_shift_right (1))
				binvert_inst.gmpn_binvert (l_scratch.item, a_dp, l_in.item, l_scratch.item + l_in.item)
				mullo_n_inst.gmpn_mullo_n (l_qp, l_np, l_scratch.item, l_in.item)
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in.item >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_qn)
						mulmod_bnm1_inst.gmpn_mulmod_bnm1 (l_scratch.item + l_in.item, l_tn, a_dp, l_qn, l_qp, l_in.item, (l_scratch.item + l_in.item) + l_tn)
						l_wn.item := (l_qn + l_in.item) - l_tn
						if l_wn.item > 0 then
							l_c0.item := ((gmp_inst.gmpn_cmp ((l_scratch.item + l_in.item), l_np, l_wn.item)) < 0).to_integer
							from
							until
								js.loop_done
							loop
								asm331 (l___ptr_dummy___3, l_scratch, l_in, l_wn, l_c0)
								js.break
							end
						end
					else
						mul_inst.gmpn_mul (l_scratch.item + l_in.item, a_dp, l_qn, l_qp, l_in.item).do_nothing
					end
				else
					mul_inst.gmpn_mul (l_scratch.item + l_in.item, a_dp, l_qn, l_qp, l_in.item).do_nothing
				end
				gmp_inst.gmpn_sub_n (l_scratch.item + l_in.item, l_np + l_in.item, ((l_scratch.item + l_in.item) + l_in.item), l_qn - l_in.item).do_nothing
				mullo_n_inst.gmpn_mullo_n (l_qp + l_in.item, (l_scratch.item + l_in.item), l_scratch.item, l_qn - l_in.item)
			end
		end

	gmpn_mu_bdiv_q_itch (a_nn: INTEGER_32; a_dn: INTEGER_32): INTEGER_32
		local
			l_qn: INTEGER_32
			l_in: INTEGER_32
			l_tn: INTEGER_32
			l_itch_binvert: INTEGER_32
			l_itch_out: INTEGER_32
			l_itches: INTEGER_32
			l_b: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_qn := a_nn
			if l_qn > a_dn then
				l_b := (l_qn - 1) // a_dn + 1
				l_in := (l_qn - 1) // l_b + 1
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_dn)
						l_itch_out := gmp_impl_inst.mpn_mulmod_bnm1_itch (l_tn, a_dn, l_in)
					else
						l_tn := a_dn + l_in
						l_itch_out := (0).to_integer_32
					end
				else
					l_tn := a_dn + l_in
					l_itch_out := (0).to_integer_32
				end
				l_itch_binvert := binvert_inst.gmpn_binvert_itch (l_in)
				l_itches := (a_dn + l_tn) + l_itch_out
				if l_itches > l_itch_binvert then
					l_tmp := l_itches
				else
					l_tmp := l_itch_binvert
				end
				Result := (l_in + l_tmp)
			else
				l_in := l_qn - ((l_qn).bit_shift_right (1))
				if 58 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_in >= 58 then
						l_tn := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_qn)
						l_itch_out := gmp_impl_inst.mpn_mulmod_bnm1_itch (l_tn, l_qn, l_in)
					else
						l_tn := l_qn + l_in
						l_itch_out := (0).to_integer_32
					end
				else
					l_tn := l_qn + l_in
					l_itch_out := (0).to_integer_32
				end
				l_itch_binvert := binvert_inst.gmpn_binvert_itch (l_in)
				l_itches := l_tn + l_itch_out
				if l_itches > l_itch_binvert then
					l_tmp___0 := l_itches
				else
					l_tmp___0 := l_itch_binvert
				end
				Result := (l_in + l_tmp___0)
			end
		end

end
