class
	P_OBPRNTFFUNS

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create gmp_obstack_printf_funs.make (<<1>>)
		end

feature {ANY} -- attributes

	gmp_obstack_printf_funs: CE_ARRAY [PD_DOPRNT_FUNS_T]

feature {ANY} -- routines

	gmp_obstack_memory (a_ob: CE_POINTER [SD_OBSTACK]; a_ptr: CE_POINTER [INTEGER_8]; a_len: NATURAL_32): INTEGER_32
		local
			l___o: CE_POINTER [SD_OBSTACK]
			l___len: INTEGER_32
		do
			create l___o.make

			l___o := a_ob
			l___len := a_len.to_integer_32
			if ((l___o.item.next_free + l___len).c_pointer.to_integer_32).to_natural_32 > ((l___o.item.chunk_limit).c_pointer.to_integer_32).to_natural_32 then
				obstack_newchunk (l___o, l___len)
			end
			memcpy (create {CE_POINTER [ANY]}.make_cast (l___o.item.next_free), create {CE_POINTER [ANY]}.make_cast (a_ptr), l___len.to_natural_32).do_nothing
			l___o.item.next_free := l___o.item.next_free + l___len
			Result := a_len.to_integer_32
		end

	gmp_obstack_memory_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_obstack_memory)
		end

	gmp_obstack_reps (a_ob: CE_POINTER [SD_OBSTACK]; a_c: INTEGER_32; a_reps: INTEGER_32): INTEGER_32
		local
			l___o: CE_POINTER [SD_OBSTACK]
			l___len: INTEGER_32
		do
			create l___o.make

			l___o := a_ob
			l___len := a_reps
			if (l___o.item.chunk_limit).distance ((l___o.item.next_free)) < l___len then
				obstack_newchunk (l___o, l___len)
			end
			l___o.item.next_free := l___o.item.next_free + l___len
			memset (create {CE_POINTER [ANY]}.make_cast ((a_ob.item.next_free - a_reps)), a_c, a_reps.to_natural_32).do_nothing
			Result := a_reps
		end

	gmp_obstack_reps_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent gmp_obstack_reps)
		end

end
