class
	P_PERFSQR

inherit
	LIBGMP_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {NONE} -- Initialization

	default_create
		do
			create sq_res_0x100.make (<<8>>)
		end

feature {ANY} -- attributes

	sq_res_0x100: CE_ARRAY [NATURAL_32]

feature {ANY} -- routines

	gmpn_perfect_square_p (a_up: CE_POINTER [NATURAL_32]; a_usize: INTEGER_32): INTEGER_32
		local
			l_idx: NATURAL_32
			l_r: NATURAL_32
			l_m: NATURAL_32
			l_idx___0: NATURAL_32
			l_q: NATURAL_32
			l_idx___1: NATURAL_32
			l_q___0: NATURAL_32
			l_idx___2: NATURAL_32
			l_q___1: NATURAL_32
			l_idx___3: NATURAL_32
			l_q___2: NATURAL_32
			l_root_ptr: CE_POINTER [NATURAL_32]
			l_res: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___5: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_root_ptr.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make

			l_idx := (a_up[0] \\ {NATURAL_32} 256).to_natural_32
			if ((((sq_res_0x100[(l_idx // {NATURAL_32} 32).to_integer_32]).bit_shift_right ((l_idx \\ {NATURAL_32} 32).to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
				Result := 0
				js.return
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						l_r := gmp_impl_inst.gmpn_mod_34lsub1 (a_up, a_usize)
						l_r := ((l_r).bit_and (((({NATURAL_32} 1).bit_shift_left (24)) - {NATURAL_32} 1))) + ((l_r).bit_shift_right (24))
						js.break
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							l_q := (l_r * {NATURAL_32} 16_404_389).bit_and (((({NATURAL_32} 1).bit_shift_left (25)) - {NATURAL_32} 1))
							l_idx___0 := ((l_q * {NATURAL_32} 45).bit_shift_right (25)).to_natural_32
							js.break
						end
						if l_idx___0.to_integer_32 - 32 < 0 then
							l_m := (440_673_409).to_natural_32
						else
							l_m := (2_336).to_natural_32
						end
						l_idx___0 := l_idx___0 \\ ({NATURAL_32} 32)
						if ((((l_m).bit_shift_right (l_idx___0.to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								l_q___0 := (l_r * {NATURAL_32} 15_790_321).bit_and (((({NATURAL_32} 1).bit_shift_left (25)) - {NATURAL_32} 1))
								l_idx___1 := ((l_q___0 * {NATURAL_32} 17).bit_shift_right (25)).to_natural_32
								js.break
							end
							if (((({NATURAL_32} 107_287).bit_shift_right (l_idx___1.to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								Result := 0
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								l_q___1 := (l_r * {NATURAL_32} 15_486_661).bit_and (((({NATURAL_32} 1).bit_shift_left (25)) - {NATURAL_32} 1))
								l_idx___2 := ((l_q___1 * {NATURAL_32} 13).bit_shift_right (25)).to_natural_32
								js.break
							end
							if (((({NATURAL_32} 2_533).bit_shift_right (l_idx___2.to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								Result := 0
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								l_q___2 := (l_r * {NATURAL_32} 14_380_471).bit_and (((({NATURAL_32} 1).bit_shift_left (25)) - {NATURAL_32} 1))
								l_idx___3 := ((l_q___2 * {NATURAL_32} 7).bit_shift_right (25)).to_natural_32
								js.break
							end
							if (((({NATURAL_32} 105).bit_shift_right (l_idx___3.to_integer_32))).bit_and ({NATURAL_32} 1)) = {NATURAL_32} 0 then
								Result := 0
								js.return
							end
							if not js.return_called then
								js.break
							end
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if (builtin_expect ((((a_usize + 1) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new ((((a_usize + 1) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (((a_usize + 1) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_root_ptr := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
				if (sqrtrem_inst.gmpn_sqrtrem (l_root_ptr, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), a_up, a_usize)).to_boolean then
					l_tmp___5 := 0
				else
					l_tmp___5 := 1
				end
				l_res := l_tmp___5
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				Result := l_res
			end
		end

end
