class
	P_RANDSDUI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_randseed_ui (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_seed: NATURAL_32)
		local
			l_zseed: CE_ARRAY [PD_MPZ_STRUCT]
			l_zlimbs: CE_ARRAY [NATURAL_32]
		do
			create l_zseed.make (<<1>>)
			create l_zlimbs.make (<<1>>)

			l_zlimbs[0] := a_seed
			l_zseed[0].mp_d := l_zlimbs
			l_zseed[0].mp_size := (l_zlimbs[0] /= {NATURAL_32} 0).to_integer
			randsd_inst.gmp_randseed (a_rstate, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_zseed))
		end

end
