class
	P_REDC_N

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_redc_n (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_ip: CE_POINTER [NATURAL_32])
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_yp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch: CE_POINTER [NATURAL_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_rn: CE_ARRAY [INTEGER_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___5: CE_POINTER [ANY]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_n.make (<<1>>)
			create l_xp.make
			create l_yp.make (<<1>>)
			create l_scratch.make
			create l_cy.make (<<1>>)
			create l_rn.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l_tmp___5.make
			create l___ptr_dummy.make (<<1>>)

			l_n.item := a_n
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_rn.item := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_n.item)
			if (builtin_expect ((((l_n.item + l_rn.item) + (gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn.item, l_n.item, l_n.item))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___5 := (l_aaf.new ((((l_n.item + l_rn.item) + (gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn.item, l_n.item, l_n.item))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___5 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (((l_n.item + l_rn.item) + (gmp_impl_inst.mpn_mulmod_bnm1_itch (l_rn.item, l_n.item, l_n.item))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_scratch := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5)
			l_xp := l_scratch
			mullo_n_inst.gmpn_mullo_n (l_xp, a_up, a_ip, l_n.item)
			l_yp.item := l_scratch + l_n.item
			mulmod_bnm1_inst.gmpn_mulmod_bnm1 (l_yp.item, l_rn.item, l_xp, l_n.item, a_mp, l_n.item, (l_scratch + l_n.item) + l_rn.item)
			from
			until
				js.loop_done
			loop
				if not (2 * l_n.item > l_rn.item) then
					assert_inst.gmp_assert_fail (ce_string ("redc_n.c"), 56, ce_string ("2 * n > rn"))
				end
				js.break
			end
			l_cy.item := gmp_inst.gmpn_sub_n (l_yp.item + l_rn.item, l_yp.item, a_up, 2 * l_n.item - l_rn.item)
			from
			until
				js.loop_done
			loop
				asm340 (l___ptr_dummy, l_yp, l_n, l_rn, l_cy)
				js.break
			end
			l_cy.item := gmp_inst.gmpn_sub_n (a_rp, (a_up + l_n.item), (l_yp.item + l_n.item), l_n.item)
			if l_cy.item /= {NATURAL_32} 0 then
				gmp_inst.gmpn_add_n (a_rp, a_rp, a_mp, l_n.item).do_nothing
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
		end

end
