class
	P_SCAN0

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_scan0 (a_up: CE_POINTER [NATURAL_32]; a_starting_bit: NATURAL_32): NATURAL_32
		local
			l_starting_word: INTEGER_32
			l_alimb: NATURAL_32
			l_cnt: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_tmp: CE_POINTER [NATURAL_32]
			l_tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_p.make
			create l_tmp.make
			create l_tmp___0.make

			l_starting_word := (a_starting_bit // {NATURAL_32} 32).to_integer_32
			l_p := a_up + l_starting_word
			l_tmp := l_p
			l_p := l_p + 1
			l_alimb := ((l_tmp.item).bit_xor ({NATURAL_32} 4_294_967_295))
			l_alimb := (l_alimb).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)))
			from
			until
				l_alimb /= {NATURAL_32} 0
			loop
				l_tmp___0 := l_p
				l_p := l_p + 1
				l_alimb := ((l_tmp___0.item).bit_xor ({NATURAL_32} 4_294_967_295))
			end
			from
			until
				js.loop_done
			loop
				l_cnt := builtin_ctzl (l_alimb)
				js.break
			end
			Result := (((l_p.distance (a_up)) - 1) * 32 + l_cnt).to_natural_32
		end

	gmpz_scan0 (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_starting_bit: NATURAL_32): NATURAL_32
		local
			l_u_ptr: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_abs_size: INTEGER_32
			l_tmp: INTEGER_32
			l_u_end: CE_POINTER [NATURAL_32]
			l_starting_limb: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_limb: NATURAL_32
			l_cnt: INTEGER_32
			l_tmp___0: NATURAL_32
			l_q: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_u_ptr.make
			create l_u_end.make
			create l_p.make
			create l_q.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_u_ptr := a_u.item.mp_d
					l_size := (a_u.item.mp_size).to_integer_32
					if l_size >= 0 then
						l_tmp := l_size
					else
						l_tmp := -l_size
					end
					l_abs_size := l_tmp
					l_u_end := l_u_ptr + l_abs_size
					l_starting_limb := (a_starting_bit // {NATURAL_32} 32).to_integer_32
					l_p := l_u_ptr + l_starting_limb
					if l_starting_limb >= l_abs_size then
						if l_size >= 0 then
							l_tmp___0 := a_starting_bit
						else
							l_tmp___0 := ({NATURAL_32} 0).bit_not
						end
						Result := l_tmp___0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						l_limb := l_p.item
						if not (l_size >= 0) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_limb := (l_limb).bit_or (((({NATURAL_32} 1).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)) - {NATURAL_32} 1))
						from
						until
							not (not js.loop_done and then (l_limb = {NATURAL_32} 4_294_967_295))
						loop
							l_p := l_p + 1
							if l_p.is_equal (l_u_end) then
								Result := (l_abs_size.to_natural_32 * {NATURAL_32} 32)
								js.return
							end
							if not js.return_called then
								l_limb := l_p.item
							end
						end
						if not js.return_called then
							l_limb := (l_limb).bit_not
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 4 then -- else:
						l_q := l_p
				when 5 then -- loop condition:
						if l_q.is_equal (l_u_ptr) then
							l_pos := -1 + 8 -- skip loop
						end
				when 6 then -- loop body:
						l_q := l_q - 1
						if l_q.item /= {NATURAL_32} 0 then
							l_pos := -1 + 9 -- goto inverted
						end
				when 7 then
						l_pos := -1 + 5 -- back to loop condition
				when 8 then -- loop done
						l_limb := l_limb - 1
				when 9 then -- inverted:
						l_limb := (l_limb).bit_and ((({NATURAL_32} 4_294_967_295).bit_shift_left ((a_starting_bit \\ {NATURAL_32} 32).to_integer_32)))
						if l_limb = {NATURAL_32} 0 then
							l_p := l_p + 1
							if l_p.is_equal (l_u_end) then
								Result := (({NATURAL_32} 0).bit_not)
								js.return
							end
							if not js.return_called then
								from
								until
									js.loop_done
								loop
									l_limb := l_p.item
									if l_limb /= {NATURAL_32} 0 then
										js.break
									end
									if not js.loop_jumped then
										l_p := l_p + 1
									end
								end
							end
						end
				when 10 then -- if done | if done
						if not js.return_called then
							from
							until
								js.loop_done
							loop
								l_cnt := builtin_ctzl (l_limb)
								js.break
							end
							Result := ((l_p.distance (l_u_ptr)).to_natural_32 * {NATURAL_32} 32 + l_cnt.to_natural_32)
						end
				when 11 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
