class
	P_SET_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_set_ui (a_f: CE_POINTER [PD_MPF_STRUCT]; a_val: NATURAL_32)
		local
			l_size: INTEGER_32
			l_tmp: INTEGER_32
		do
			a_f.item.mp_d[0] := (a_val).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (a_val /= {NATURAL_32} 0).to_integer
			l_tmp := l_size.to_integer_32
			a_f.item.mp_size := l_tmp
			a_f.item.mp_exp := l_tmp.to_integer_32
		end

	gmpq_set_ui (a_dest: CE_POINTER [PD_MPQ_STRUCT]; a_num: NATURAL_32; a_den: NATURAL_32)
		local
			l_den: NATURAL_32
		do
			l_den := a_den
			if a_num = {NATURAL_32} 0 then
				l_den := {NATURAL_32} 1
				a_dest.item.mp_num.mp_size := 0
			else
				a_dest.item.mp_num.mp_d[0] := a_num
				a_dest.item.mp_num.mp_size := 1
			end
			a_dest.item.mp_den.mp_d[0] := l_den
			a_dest.item.mp_den.mp_size := (l_den /= {NATURAL_32} 0).to_integer
		end

	gmpz_set_ui (a_dest: CE_POINTER [PD_MPZ_STRUCT]; a_val: NATURAL_32)
		local
			l_size: INTEGER_32
		do
			a_dest.item.mp_d[0] := (a_val).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (a_val /= {NATURAL_32} 0).to_integer
			a_dest.item.mp_size := l_size.to_integer_32
		end

end
