class
	P_SQRT_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_sqrt_ui (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: NATURAL_32)
		local
			l_rsize: INTEGER_32
			l_zeros: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_prec: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___3: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___5: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___3.make
			create l___dst.make
			create l_tmp___5.make

			if (builtin_expect ((a_u = {NATURAL_32} 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_prec := (a_r.item.mp_prec).to_integer_32
				l_zeros := 2 * l_prec - 2
				l_rsize := l_zeros + 1
				if (builtin_expect ((l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___3 := (l_aaf.new ((l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___3 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_rsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3)
				from
				until
					js.loop_done
				loop
					if l_zeros /= 0 then
						l___dst := l_tp
						l___n := l_zeros
						from
						until
							js.loop_done
						loop
							l_tmp___5 := l___dst
							l___dst := l___dst + 1
							l_tmp___5.item := (0).to_natural_32
							l___n := l___n - 1
							if not l___n.to_boolean then
								js.break
							end
						end
					end
					js.break
				end
				l_tp[l_zeros] := (a_u).bit_and ({NATURAL_32} 4_294_967_295)
				sqrtrem_inst.gmpn_sqrtrem (a_r.item.mp_d, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), l_tp, l_rsize).do_nothing
				a_r.item.mp_size := l_prec.to_integer_32
				a_r.item.mp_exp := (1).to_integer_32
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
