class
	P_TOOM_EVAL_PM2REXP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	DO_mpn_addlsh_n (a_dst: CE_POINTER [NATURAL_32]; a_src: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_s: NATURAL_32; a_ws: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l___cy: NATURAL_32
		do
			l___cy := gmp_inst.gmpn_lshift (a_ws, a_src, a_n, a_s)
			Result := (l___cy + (gmp_inst.gmpn_add_n (a_dst, a_dst, a_ws, a_n)))
		end

	gmpn_toom_eval_pm2rexp (a_rp: CE_POINTER [NATURAL_32]; a_rm: CE_POINTER [NATURAL_32]; a_q: NATURAL_32; a_ap: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_t: INTEGER_32; a_s: NATURAL_32; a_ws: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_i: NATURAL_32
			l_neg: INTEGER_32
		do
			a_rp[a_n] := gmp_inst.gmpn_lshift (a_rp, a_ap, a_n, a_s * a_q)
			a_ws[a_n] := gmp_inst.gmpn_lshift (a_ws, a_ap + a_n, a_n, a_s * (a_q - {NATURAL_32} 1))
			if ((a_q).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
				gmp_inst.gmpn_add (a_ws, a_ws, a_n + 1, a_ap + (a_n.to_natural_32 * a_q.to_natural_32).to_integer_32, a_t).do_nothing
				a_rp[a_n] := a_rp[a_n] + (DO_mpn_addlsh_n (a_rp, a_ap + (a_n.to_natural_32 * (a_q - {NATURAL_32} 1).to_natural_32).to_integer_32, a_n, a_s, a_rm))
			else
				gmp_inst.gmpn_add (a_rp, a_rp, a_n + 1, a_ap + (a_n.to_natural_32 * a_q.to_natural_32).to_integer_32, a_t).do_nothing
			end
			l_i := {NATURAL_32} 2
			from
			until
				not (l_i < a_q - {NATURAL_32} 1)
			loop
				a_rp[a_n] := a_rp[a_n] + (DO_mpn_addlsh_n (a_rp, a_ap + (a_n.to_natural_32 * l_i.to_natural_32).to_integer_32, a_n, a_s * (a_q - l_i), a_rm))
				l_i := l_i + 1
				a_ws[a_n] := a_ws[a_n] + (DO_mpn_addlsh_n (a_ws, a_ap + (a_n.to_natural_32 * l_i.to_natural_32).to_integer_32, a_n, a_s * (a_q - l_i), a_rm))
				l_i := l_i + 1
			end
			if (gmp_inst.gmpn_cmp (a_rp, a_ws, a_n + 1)) < 0 then
				l_neg := (0).bit_not
			else
				l_neg := 0
			end
			if l_neg.to_boolean then
				gmp_inst.gmpn_sub_n (a_rm, a_ws, a_rp, a_n + 1).do_nothing
			else
				gmp_inst.gmpn_sub_n (a_rm, a_rp, a_ws, a_n + 1).do_nothing
			end
			gmp_inst.gmpn_add_n (a_rp, a_rp, a_ws, a_n + 1).do_nothing
			Result := l_neg
		end

end
