deferred class
	S_STRING

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	memcpy (a___dest: CE_POINTER [ANY]; a___src: CE_POINTER [ANY]; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memcpy (a___dest.c_pointer, a___src.c_pointer, a___n))
		end

	c_memcpy (a___dest: POINTER; a___src: POINTER; a___n: NATURAL_32): POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return memcpy($a___dest, $a___src, $a___n);"
		end

	memset (a___s: CE_POINTER [ANY]; a___c: INTEGER_32; a___n: NATURAL_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_memset (a___s.c_pointer, a___c, a___n))
		end

	c_memset (a___s: POINTER; a___c: INTEGER_32; a___n: NATURAL_32): POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return memset($a___s, $a___c, $a___n);"
		end

	strchr (a___s: CE_POINTER [INTEGER_8]; a___c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strchr (a___s.c_pointer, a___c))
		end

	c_strchr (a___s: POINTER; a___c: INTEGER_32): POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return strchr($a___s, $a___c);"
		end

	strcpy (a___dest: CE_POINTER [INTEGER_8]; a___src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_strcpy (a___dest.c_pointer, a___src.c_pointer))
		end

	c_strcpy (a___dest: POINTER; a___src: POINTER): POINTER
		external
			"C inline use <libgmp.h>"
		alias
			"return strcpy($a___dest, $a___src);"
		end

	strlen (a___s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a___s.c_pointer)
		end

	c_strlen (a___s: POINTER): NATURAL_32
		external
			"C inline use <libgmp.h>"
		alias
			"return strlen($a___s);"
		end

end
