class
	PD_GSL_MATRIX_SHORT_VIEW

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create matrix.make
		end

feature {ANY} -- fields

	matrix: PD_GSL_MATRIX_SHORT assign set_matrix

feature {ANY} -- setters

	set_matrix (a_matrix: PD_GSL_MATRIX_SHORT)
		do
			matrix := a_matrix
			update_memory_field ("matrix")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			matrix := a_other.matrix.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				matrix.is_equal (a_other.matrix)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("matrix")
				>>)
			init_structure_info
		end

end
