class
	PD_MOLER_VANLOAN_OPTIMAL_SUGGESTION

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	k: INTEGER_32 assign set_k

	j: INTEGER_32 assign set_j

feature {ANY} -- setters

	set_k (a_k: INTEGER_32)
		do
			k := a_k
			update_memory_field ("k")
		end

	set_j (a_j: INTEGER_32)
		do
			j := a_j
			update_memory_field ("j")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			k := a_other.k
			j := a_other.j
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				k = a_other.k and
				j = a_other.j
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("k"),
					create {CE_STRUCTURE_FIELD}.make ("j")
				>>)
			init_structure_info
		end

end
