class
	PD_NEWTON_STATE_T2

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	f: REAL_64 assign set_f

	df: REAL_64 assign set_df

feature {ANY} -- setters

	set_f (a_f: REAL_64)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_df (a_df: REAL_64)
		do
			df := a_df
			update_memory_field ("df")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			df := a_other.df
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f = a_other.f and
				df = a_other.df
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("df")
				>>)
			init_structure_info
		end

end
