class
	PD_NIED2_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create cj.make (<<31, 12>>)
			create nextq.make (<<12>>)
		end

feature {ANY} -- fields

	sequence_count: NATURAL_32 assign set_sequence_count

	cj: CE_ARRAY [CE_ARRAY [INTEGER_32]]

	nextq: CE_ARRAY [INTEGER_32]

feature {ANY} -- setters

	set_sequence_count (a_sequence_count: NATURAL_32)
		do
			sequence_count := a_sequence_count
			update_memory_field ("sequence_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sequence_count := a_other.sequence_count
			cj := a_other.cj.twin
			nextq := a_other.nextq.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sequence_count = a_other.sequence_count and
				cj.is_equal (a_other.cj) and
				nextq.is_equal (a_other.nextq)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sequence_count"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("cj", <<31, 12>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("nextq", <<12>>)
				>>)
			init_structure_info
		end

end
