class
	PD_RAN_STATE_T_26__2

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	x: NATURAL_32 assign set_x

	y: NATURAL_32 assign set_y

	z: NATURAL_32 assign set_z

feature {ANY} -- setters

	set_x (a_x: NATURAL_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: NATURAL_32)
		do
			y := a_y
			update_memory_field ("y")
		end

	set_z (a_z: NATURAL_32)
		do
			z := a_z
			update_memory_field ("z")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x := a_other.x
			y := a_other.y
			z := a_other.z
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x = a_other.x and
				y = a_other.y and
				z = a_other.z
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y"),
					create {CE_STRUCTURE_FIELD}.make ("z")
				>>)
			init_structure_info
		end

end
