class
	PD_RANF_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	x0: NATURAL_16 assign set_x0

	x1: NATURAL_16 assign set_x1

	x2: NATURAL_16 assign set_x2

feature {ANY} -- setters

	set_x0 (a_x0: NATURAL_16)
		do
			x0 := a_x0
			update_memory_field ("x0")
		end

	set_x1 (a_x1: NATURAL_16)
		do
			x1 := a_x1
			update_memory_field ("x1")
		end

	set_x2 (a_x2: NATURAL_16)
		do
			x2 := a_x2
			update_memory_field ("x2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			x0 := a_other.x0
			x1 := a_other.x1
			x2 := a_other.x2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				x0 = a_other.x0 and
				x1 = a_other.x1 and
				x2 = a_other.x2
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("x0"),
					create {CE_STRUCTURE_FIELD}.make ("x1"),
					create {CE_STRUCTURE_FIELD}.make ("x2")
				>>)
			init_structure_info
		end

end
