class
	PD_REVERSEHALTON_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	sequence_count: NATURAL_32 assign set_sequence_count

feature {ANY} -- setters

	set_sequence_count (a_sequence_count: NATURAL_32)
		do
			sequence_count := a_sequence_count
			update_memory_field ("sequence_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sequence_count := a_other.sequence_count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sequence_count = a_other.sequence_count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sequence_count")
				>>)
			init_structure_info
		end

end
