frozen class
	LIBGSL_INITIALIZER_SLICE19

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {LIBGSL_INITIALIZER}

	initialize
		do
			ranlxs_inst.ranlxs1_type[0].min := {NATURAL_32} 0
			ranlxs_inst.ranlxs1_type[0].size := (create {PD_RANLXS_STATE_T}.make).structure_size.to_natural_32
			ranlxs_inst.ranlxs1_type[0].set := ranlxs_inst.ranlxs1_set_address
			ranlxs_inst.ranlxs1_type[0].get := ranlxs_inst.ranlxs_get_address
			ranlxs_inst.ranlxs1_type[0].get_double := ranlxs_inst.ranlxs_get_double_address
			ranlxs_inst.ranlxs2_type[0].name := ce_string ("ranlxs2")
			ranlxs_inst.ranlxs2_type[0].max := {NATURAL_32} 16_777_215
			ranlxs_inst.ranlxs2_type[0].min := {NATURAL_32} 0
			ranlxs_inst.ranlxs2_type[0].size := (create {PD_RANLXS_STATE_T}.make).structure_size.to_natural_32
			ranlxs_inst.ranlxs2_type[0].set := ranlxs_inst.ranlxs2_set_address
			ranlxs_inst.ranlxs2_type[0].get := ranlxs_inst.ranlxs_get_address
			ranlxs_inst.ranlxs2_type[0].get_double := ranlxs_inst.ranlxs_get_double_address
			ranlxs_inst.gsl_rng_ranlxs0 := ranlxs_inst.ranlxs0_type
			ranlxs_inst.gsl_rng_ranlxs1 := ranlxs_inst.ranlxs1_type
			ranlxs_inst.gsl_rng_ranlxs2 := ranlxs_inst.ranlxs2_type
			randu_inst.a3 := (65_539).to_integer_32
			randu_inst.randu_type[0].name := ce_string ("randu")
			randu_inst.randu_type[0].max := {NATURAL_32} 2_147_483_647
			randu_inst.randu_type[0].min := {NATURAL_32} 1
			randu_inst.randu_type[0].size := (create {PD_RANDU_STATE_T}.make).structure_size.to_natural_32
			randu_inst.randu_type[0].set := randu_inst.randu_set_address
			randu_inst.randu_type[0].get := randu_inst.randu_get_address
			randu_inst.randu_type[0].get_double := randu_inst.randu_get_double_address
			randu_inst.gsl_rng_randu := randu_inst.randu_type
			uni32_inst.m1 := (2_147_483_647).to_natural_32
			uni32_inst.m2 := (65_536).to_natural_32
			uni32_inst.uni32_type[0].name := ce_string ("uni32")
			uni32_inst.uni32_type[0].max := {NATURAL_32} 2_147_483_646
			uni32_inst.uni32_type[0].min := {NATURAL_32} 0
			uni32_inst.uni32_type[0].size := (create {PD_UNI32_STATE_T}.make).structure_size.to_natural_32
			uni32_inst.uni32_type[0].set := uni32_inst.uni32_set_address
			uni32_inst.uni32_type[0].get := uni32_inst.uni32_get_address
			uni32_inst.uni32_type[0].get_double := uni32_inst.uni32_get_double_address
			uni32_inst.gsl_rng_uni32 := uni32_inst.uni32_type
			ran1_inst.m := (2_147_483_647).to_integer_32
			ran1_inst.a___0 := (16_807).to_integer_32
			ran1_inst.q := (127_773).to_integer_32
			ran1_inst.r := (2_836).to_integer_32
			ran1_inst.ran1_type[0].name := ce_string ("ran1")
			ran1_inst.ran1_type[0].max := {NATURAL_32} 2_147_483_646
			ran1_inst.ran1_type[0].min := {NATURAL_32} 1
			ran1_inst.ran1_type[0].size := (create {PD_RAN1_STATE_T}.make).structure_size.to_natural_32
			ran1_inst.ran1_type[0].set := ran1_inst.ran1_set_address
			ran1_inst.ran1_type[0].get := ran1_inst.ran1_get_address
			ran1_inst.ran1_type[0].get_double := ran1_inst.ran1_get_double_address
			ran1_inst.gsl_rng_ran1 := ran1_inst.ran1_type
			borosh13_inst.ran_type___0[0].name := ce_string ("borosh13")
			borosh13_inst.ran_type___0[0].max := {NATURAL_32} 4_294_967_295
			borosh13_inst.ran_type___0[0].min := {NATURAL_32} 1
			borosh13_inst.ran_type___0[0].size := (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32
			borosh13_inst.ran_type___0[0].set := borosh13_inst.ran_set___0_address
			borosh13_inst.ran_type___0[0].get := borosh13_inst.ran_get___0_address
			borosh13_inst.ran_type___0[0].get_double := borosh13_inst.ran_get_double___0_address
			borosh13_inst.gsl_rng_borosh13 := borosh13_inst.ran_type___0
			ran2_inst.m1___0 := (2_147_483_563).to_integer_32
			ran2_inst.a12 := (40_014).to_integer_32
			ran2_inst.q12 := (53_668).to_integer_32
			ran2_inst.r1 := (12_211).to_integer_32
			ran2_inst.m2___0 := (2_147_483_399).to_integer_32
			ran2_inst.a22 := (40_692).to_integer_32
			ran2_inst.q22 := (52_774).to_integer_32
			ran2_inst.r2 := (3_791).to_integer_32
			ran2_inst.ran2_type[0].name := ce_string ("ran2")
			ran2_inst.ran2_type[0].max := {NATURAL_32} 2_147_483_562
			ran2_inst.ran2_type[0].min := {NATURAL_32} 1
			ran2_inst.ran2_type[0].size := (create {PD_RAN2_STATE_T}.make).structure_size.to_natural_32
			ran2_inst.ran2_type[0].set := ran2_inst.ran2_set_address
			ran2_inst.ran2_type[0].get := ran2_inst.ran2_get_address
			ran2_inst.ran2_type[0].get_double := ran2_inst.ran2_get_double_address
			ran2_inst.gsl_rng_ran2 := ran2_inst.ran2_type
			ran0_inst.m___0 := (2_147_483_647).to_integer_32
			ran0_inst.a___1 := (16_807).to_integer_32
			ran0_inst.q___0 := (127_773).to_integer_32
			ran0_inst.r___0 := (2_836).to_integer_32
			ran0_inst.mask := (123_459_876).to_natural_32
			ran0_inst.ran0_type[0].name := ce_string ("ran0")
			ran0_inst.ran0_type[0].max := {NATURAL_32} 2_147_483_646
			ran0_inst.ran0_type[0].min := {NATURAL_32} 1
			ran0_inst.ran0_type[0].size := (create {PD_RAN0_STATE_T}.make).structure_size.to_natural_32
			ran0_inst.ran0_type[0].set := ran0_inst.ran0_set_address
			ran0_inst.ran0_type[0].get := ran0_inst.ran0_get_address
			ran0_inst.ran0_type[0].get_double := ran0_inst.ran0_get_double_address
			ran0_inst.gsl_rng_ran0 := ran0_inst.ran0_type
			knuthran2_inst.ran_type___1[0].name := ce_string ("knuthran2")
			knuthran2_inst.ran_type___1[0].max := {NATURAL_32} 2_147_483_646
			knuthran2_inst.ran_type___1[0].min := {NATURAL_32} 0
			knuthran2_inst.ran_type___1[0].size := (create {PD_RAN_STATE_T_26__}.make).structure_size.to_natural_32
			knuthran2_inst.ran_type___1[0].set := knuthran2_inst.ran_set___1_address
			knuthran2_inst.ran_type___1[0].get := knuthran2_inst.ran_get___1_address
			knuthran2_inst.ran_type___1[0].get_double := knuthran2_inst.ran_get_double___1_address
			knuthran2_inst.gsl_rng_knuthran2 := knuthran2_inst.ran_type___1
			tt_inst.tt_type[0].name := ce_string ("tt800")
			tt_inst.tt_type[0].max := {NATURAL_32} 4_294_967_295
			tt_inst.tt_type[0].min := {NATURAL_32} 0
			tt_inst.tt_type[0].size := (create {PD_TT_STATE_T}.make).structure_size.to_natural_32
			tt_inst.tt_type[0].set := tt_inst.tt_set_address
			tt_inst.tt_type[0].get := tt_inst.tt_get_address
			tt_inst.tt_type[0].get_double := tt_inst.tt_get_double_address
			tt_inst.gsl_rng_tt800 := tt_inst.tt_type
			vax_inst.vax_type[0].name := ce_string ("vax")
			vax_inst.vax_type[0].max := {NATURAL_32} 4_294_967_295
			vax_inst.vax_type[0].min := {NATURAL_32} 0
			vax_inst.vax_type[0].size := (create {PD_VAX_STATE_T}.make).structure_size.to_natural_32
			vax_inst.vax_type[0].set := vax_inst.vax_set_address
			vax_inst.vax_type[0].get := vax_inst.vax_get_address
			vax_inst.vax_type[0].get_double := vax_inst.vax_get_double_address
			vax_inst.gsl_rng_vax := vax_inst.vax_type
			ranmar_inst.two24 := (16_777_216).to_natural_32
			ranmar_inst.ranmar_type[0].name := ce_string ("ranmar")
			ranmar_inst.ranmar_type[0].max := {NATURAL_32} 16_777_215
			ranmar_inst.ranmar_type[0].min := {NATURAL_32} 0
			ranmar_inst.ranmar_type[0].size := (create {PD_RANMAR_STATE_T}.make).structure_size.to_natural_32
			ranmar_inst.ranmar_type[0].set := ranmar_inst.ranmar_set_address
			ranmar_inst.ranmar_type[0].get := ranmar_inst.ranmar_get_address
			ranmar_inst.ranmar_type[0].get_double := ranmar_inst.ranmar_get_double_address
			ranmar_inst.gsl_rng_ranmar := ranmar_inst.ranmar_type
			fishman2x_inst.ran_type___2[0].name := ce_string ("fishman2x")
			fishman2x_inst.ran_type___2[0].max := {NATURAL_32} 2_147_483_646
			fishman2x_inst.ran_type___2[0].min := {NATURAL_32} 0
			fishman2x_inst.ran_type___2[0].size := (create {PD_RAN_STATE_T_26__2}.make).structure_size.to_natural_32
			fishman2x_inst.ran_type___2[0].set := fishman2x_inst.ran_set___2_address
			fishman2x_inst.ran_type___2[0].get := fishman2x_inst.ran_get___2_address
			fishman2x_inst.ran_type___2[0].get_double := fishman2x_inst.ran_get_double___2_address
			fishman2x_inst.gsl_rng_fishman2x := fishman2x_inst.ran_type___2
			ranf_inst.a0 := (45_429).to_natural_16
			ranf_inst.a1___0 := (41_703).to_natural_16
			ranf_inst.a2___0 := (10_357).to_natural_16
			ranf_inst.ranf_type[0].name := ce_string ("ranf")
			ranf_inst.ranf_type[0].max := {NATURAL_32} 4_294_967_295
			ranf_inst.ranf_type[0].min := {NATURAL_32} 0
			ranf_inst.ranf_type[0].size := (create {PD_RANF_STATE_T}.make).structure_size.to_natural_32
			ranf_inst.ranf_type[0].set := ranf_inst.ranf_set_address
			ranf_inst.ranf_type[0].get := ranf_inst.ranf_get_address
			ranf_inst.ranf_type[0].get_double := ranf_inst.ranf_get_double_address
			ranf_inst.gsl_rng_ranf := ranf_inst.ranf_type
			knuthran_inst.ran_type___3[0].name := ce_string ("knuthran")
			knuthran_inst.ran_type___3[0].max := {NATURAL_32} 1_073_741_823
			knuthran_inst.ran_type___3[0].min := {NATURAL_32} 0
			knuthran_inst.ran_type___3[0].size := (create {PD_RAN_STATE_T_26__3}.make).structure_size.to_natural_32
			knuthran_inst.ran_type___3[0].set := knuthran_inst.ran_set___3_address
			knuthran_inst.ran_type___3[0].get := knuthran_inst.ran_get___3_address
			knuthran_inst.ran_type___3[0].get_double := knuthran_inst.ran_get_double___3_address
			knuthran_inst.gsl_rng_knuthran := knuthran_inst.ran_type___3
			lecuyer21_inst.ran_type___4[0].name := ce_string ("lecuyer21")
			lecuyer21_inst.ran_type___4[0].max := {NATURAL_32} 2_147_483_398
			lecuyer21_inst.ran_type___4[0].min := {NATURAL_32} 1
			lecuyer21_inst.ran_type___4[0].size := (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32
			lecuyer21_inst.ran_type___4[0].set := lecuyer21_inst.ran_set___4_address
			lecuyer21_inst.ran_type___4[0].get := lecuyer21_inst.ran_get___4_address
			lecuyer21_inst.ran_type___4[0].get_double := lecuyer21_inst.ran_get_double___4_address
			lecuyer21_inst.gsl_rng_lecuyer21 := lecuyer21_inst.ran_type___4
			ranlxd_inst.next___0[0] := 1
			ranlxd_inst.next___0[1] := 2
			ranlxd_inst.next___0[2] := 3
			ranlxd_inst.next___0[3] := 4
			ranlxd_inst.next___0[4] := 5
			ranlxd_inst.next___0[5] := 6
			ranlxd_inst.next___0[6] := 7
			ranlxd_inst.next___0[7] := 8
			ranlxd_inst.next___0[8] := 9
			ranlxd_inst.next___0[9] := 10
			ranlxd_inst.next___0[10] := 11
			ranlxd_inst.next___0[11] := 0
			ranlxd_inst.one_bit___0 := (1.0 / 281474976710656.0)
			ranlxd_inst.ranlxd1_type[0].name := ce_string ("ranlxd1")
			ranlxd_inst.ranlxd1_type[0].max := {NATURAL_32} 4_294_967_295
			ranlxd_inst.ranlxd1_type[0].min := {NATURAL_32} 0
			ranlxd_inst.ranlxd1_type[0].size := (create {PD_RANLXD_STATE_T}.make).structure_size.to_natural_32
			ranlxd_inst.ranlxd1_type[0].set := ranlxd_inst.ranlxd1_set_address
			ranlxd_inst.ranlxd1_type[0].get := ranlxd_inst.ranlxd_get_address
			ranlxd_inst.ranlxd1_type[0].get_double := ranlxd_inst.ranlxd_get_double_address
			ranlxd_inst.ranlxd2_type[0].name := ce_string ("ranlxd2")
			ranlxd_inst.ranlxd2_type[0].max := {NATURAL_32} 4_294_967_295
			ranlxd_inst.ranlxd2_type[0].min := {NATURAL_32} 0
			ranlxd_inst.ranlxd2_type[0].size := (create {PD_RANLXD_STATE_T}.make).structure_size.to_natural_32
			ranlxd_inst.ranlxd2_type[0].set := ranlxd_inst.ranlxd2_set_address
			ranlxd_inst.ranlxd2_type[0].get := ranlxd_inst.ranlxd_get_address
			ranlxd_inst.ranlxd2_type[0].get_double := ranlxd_inst.ranlxd_get_double_address
			ranlxd_inst.gsl_rng_ranlxd1 := ranlxd_inst.ranlxd1_type
			ranlxd_inst.gsl_rng_ranlxd2 := ranlxd_inst.ranlxd2_type
			slatec_inst.P := (4_194_304).to_integer_32
			slatec_inst.a1___1 := (1_536).to_integer_32
			slatec_inst.a0___0 := (1_029).to_integer_32
			slatec_inst.a1ma0 := (507).to_integer_32
			slatec_inst.c := (1_731).to_integer_32
			slatec_inst.slatec_type[0].name := ce_string ("slatec")
			slatec_inst.slatec_type[0].max := {NATURAL_32} 4_194_303
			slatec_inst.slatec_type[0].min := {NATURAL_32} 0
			slatec_inst.slatec_type[0].size := (create {PD_SLATEC_STATE_T}.make).structure_size.to_natural_32
			slatec_inst.slatec_type[0].set := slatec_inst.slatec_set_address
			slatec_inst.slatec_type[0].get := slatec_inst.slatec_get_address
			slatec_inst.slatec_type[0].get_double := slatec_inst.slatec_get_double_address
			slatec_inst.gsl_rng_slatec := slatec_inst.slatec_type
			transputer_inst.transputer_type[0].name := ce_string ("transputer")
			transputer_inst.transputer_type[0].max := {NATURAL_32} 4_294_967_295
			transputer_inst.transputer_type[0].min := {NATURAL_32} 1
			transputer_inst.transputer_type[0].size := (create {PD_TRANSPUTER_STATE_T}.make).structure_size.to_natural_32
			transputer_inst.transputer_type[0].set := transputer_inst.transputer_set_address
			transputer_inst.transputer_type[0].get := transputer_inst.transputer_get_address
			transputer_inst.transputer_type[0].get_double := transputer_inst.transputer_get_double_address
			transputer_inst.gsl_rng_transputer := transputer_inst.transputer_type
			uni_inst.m1___1 := (32_767).to_natural_32
			uni_inst.m2___1 := (256).to_natural_32
			uni_inst.uni_type[0].name := ce_string ("uni")
			uni_inst.uni_type[0].max := {NATURAL_32} 32_766
			uni_inst.uni_type[0].min := {NATURAL_32} 0
			uni_inst.uni_type[0].size := (create {PD_UNI_STATE_T}.make).structure_size.to_natural_32
			uni_inst.uni_type[0].set := uni_inst.uni_set_address
			uni_inst.uni_type[0].get := uni_inst.uni_get_address
			uni_inst.uni_type[0].get_double := uni_inst.uni_get_double_address
			uni_inst.gsl_rng_uni := uni_inst.uni_type
			waterman14_inst.ran_type___5[0].name := ce_string ("waterman14")
			waterman14_inst.ran_type___5[0].max := {NATURAL_32} 4_294_967_295
			waterman14_inst.ran_type___5[0].min := {NATURAL_32} 1
			waterman14_inst.ran_type___5[0].size := (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32
			waterman14_inst.ran_type___5[0].set := waterman14_inst.ran_set___5_address
			waterman14_inst.ran_type___5[0].get := waterman14_inst.ran_get___5_address
			waterman14_inst.ran_type___5[0].get_double := waterman14_inst.ran_get_double___5_address
			waterman14_inst.gsl_rng_waterman14 := waterman14_inst.ran_type___5
			taus_inst.taus_type[0].name := ce_string ("taus")
			taus_inst.taus_type[0].max := {NATURAL_32} 4_294_967_295
			taus_inst.taus_type[0].min := {NATURAL_32} 0
			taus_inst.taus_type[0].size := (create {PD_TAUS_STATE_T}.make).structure_size.to_natural_32
			taus_inst.taus_type[0].set := taus_inst.taus_set_address
			taus_inst.taus_type[0].get := taus_inst.taus_get_address
			taus_inst.taus_type[0].get_double := taus_inst.taus_get_double_address
			taus_inst.gsl_rng_taus := taus_inst.taus_type
			taus_inst.taus2_type[0].name := ce_string ("taus2")
			taus_inst.taus2_type[0].max := {NATURAL_32} 4_294_967_295
			taus_inst.taus2_type[0].min := {NATURAL_32} 0
			taus_inst.taus2_type[0].size := (create {PD_TAUS_STATE_T}.make).structure_size.to_natural_32
			taus_inst.taus2_type[0].set := taus_inst.taus2_set_address
			taus_inst.taus2_type[0].get := taus_inst.taus_get_address
			taus_inst.taus2_type[0].get_double := taus_inst.taus_get_double_address
			taus_inst.gsl_rng_taus2 := taus_inst.taus2_type
			knuthran2002_inst.ran_type___6[0].name := ce_string ("knuthran2002")
			knuthran2002_inst.ran_type___6[0].max := {NATURAL_32} 1_073_741_823
			knuthran2002_inst.ran_type___6[0].min := {NATURAL_32} 0
			knuthran2002_inst.ran_type___6[0].size := (create {PD_RAN_STATE_T_26__4}.make).structure_size.to_natural_32
			knuthran2002_inst.ran_type___6[0].set := knuthran2002_inst.ran_set___6_address
			knuthran2002_inst.ran_type___6[0].get := knuthran2002_inst.ran_get___6_address
			knuthran2002_inst.ran_type___6[0].get_double := knuthran2002_inst.ran_get_double___6_address
			knuthran2002_inst.gsl_rng_knuthran2002 := knuthran2002_inst.ran_type___6
			taus113_inst.taus113_type[0].name := ce_string ("taus113")
			taus113_inst.taus113_type[0].max := {NATURAL_32} 4_294_967_295
			taus113_inst.taus113_type[0].min := {NATURAL_32} 0
			taus113_inst.taus113_type[0].size := (create {PD_TAUS113_STATE_T}.make).structure_size.to_natural_32
			taus113_inst.taus113_type[0].set := taus113_inst.taus113_set_address
			taus113_inst.taus113_type[0].get := taus113_inst.taus113_get_address
			taus113_inst.taus113_type[0].get_double := taus113_inst.taus113_get_double_address
			taus113_inst.gsl_rng_taus113 := taus113_inst.taus113_type
			rand_inst.rand_type[0].name := ce_string ("rand")
			rand_inst.rand_type[0].max := {NATURAL_32} 2_147_483_647
			rand_inst.rand_type[0].min := {NATURAL_32} 0
			rand_inst.rand_type[0].size := (create {PD_RAND_STATE_T}.make).structure_size.to_natural_32
			rand_inst.rand_type[0].set := rand_inst.rand_set_address
			rand_inst.rand_type[0].get := rand_inst.rand_get_address
			rand_inst.rand_type[0].get_double := rand_inst.rand_get_double_address
			rand_inst.gsl_rng_rand := rand_inst.rand_type
			ranlux_inst.mask_lo := {NATURAL_32} 16_777_215
			ranlux_inst.mask_hi := (({NATURAL_32} 16_777_215).bit_not)
			ranlux_inst.two24___0 := (16_777_216).to_natural_32
			ranlux_inst.ranlux_type[0].name := ce_string ("ranlux")
			ranlux_inst.ranlux_type[0].max := {NATURAL_32} 16_777_215
			ranlux_inst.ranlux_type[0].min := {NATURAL_32} 0
			ranlux_inst.ranlux_type[0].size := (create {PD_RANLUX_STATE_T}.make).structure_size.to_natural_32
			ranlux_inst.ranlux_type[0].set := ranlux_inst.ranlux_set_address
			ranlux_inst.ranlux_type[0].get := ranlux_inst.ranlux_get_address
			ranlux_inst.ranlux_type[0].get_double := ranlux_inst.ranlux_get_double_address
			ranlux_inst.ranlux389_type[0].name := ce_string ("ranlux389")
			ranlux_inst.ranlux389_type[0].max := {NATURAL_32} 16_777_215
			ranlux_inst.ranlux389_type[0].min := {NATURAL_32} 0
			ranlux_inst.ranlux389_type[0].size := (create {PD_RANLUX_STATE_T}.make).structure_size.to_natural_32
			ranlux_inst.ranlux389_type[0].set := ranlux_inst.ranlux389_set_address
			ranlux_inst.ranlux389_type[0].get := ranlux_inst.ranlux_get_address
			ranlux_inst.ranlux389_type[0].get_double := ranlux_inst.ranlux_get_double_address
			ranlux_inst.gsl_rng_ranlux := ranlux_inst.ranlux_type
			ranlux_inst.gsl_rng_ranlux389 := ranlux_inst.ranlux389_type
			fishman20_inst.m___1 := (2_147_483_647).to_integer_32
			fishman20_inst.a___2 := (48_271).to_integer_32
			fishman20_inst.q___1 := (44_488).to_integer_32
			fishman20_inst.r___1 := (3_399).to_integer_32
			fishman20_inst.ran_type___7[0].name := ce_string ("fishman20")
			fishman20_inst.ran_type___7[0].max := {NATURAL_32} 2_147_483_646
			fishman20_inst.ran_type___7[0].min := {NATURAL_32} 1
			fishman20_inst.ran_type___7[0].size := (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32
			fishman20_inst.ran_type___7[0].set := fishman20_inst.ran_set___7_address
			fishman20_inst.ran_type___7[0].get := fishman20_inst.ran_get___7_address
			fishman20_inst.ran_type___7[0].get_double := fishman20_inst.ran_get_double___7_address
			fishman20_inst.gsl_rng_fishman20 := fishman20_inst.ran_type___7
			rand48_inst.a0___1 := (58_989).to_natural_16
			rand48_inst.a1___2 := (57_068).to_natural_16
			rand48_inst.a2___1 := (5).to_natural_16
			rand48_inst.c0 := (11).to_natural_16
			rand48_inst.rand48_type[0].name := ce_string ("rand48")
			rand48_inst.rand48_type[0].max := {NATURAL_32} 4_294_967_295
			rand48_inst.rand48_type[0].min := {NATURAL_32} 0
			rand48_inst.rand48_type[0].size := (create {PD_RAND48_STATE_T}.make).structure_size.to_natural_32
			rand48_inst.rand48_type[0].set := rand48_inst.rand48_set_address
			rand48_inst.rand48_type[0].get := rand48_inst.rand48_get_address
			rand48_inst.rand48_type[0].get_double := rand48_inst.rand48_get_double_address
			rand48_inst.gsl_rng_rand48 := rand48_inst.rand48_type
			r250_inst.r250_type[0].name := ce_string ("r250")
			r250_inst.r250_type[0].max := {NATURAL_32} 4_294_967_295
			r250_inst.r250_type[0].min := {NATURAL_32} 0
			r250_inst.r250_type[0].size := (create {PD_R250_STATE_T}.make).structure_size.to_natural_32
			r250_inst.r250_type[0].set := r250_inst.r250_set_address
			r250_inst.r250_type[0].get := r250_inst.r250_get_address
			r250_inst.r250_type[0].get_double := r250_inst.r250_get_double_address
			r250_inst.gsl_rng_r250 := r250_inst.r250_type
			ran3_inst.ran3_type[0].name := ce_string ("ran3")
			ran3_inst.ran3_type[0].max := {NATURAL_32} 1_000_000_000
			ran3_inst.ran3_type[0].min := {NATURAL_32} 0
			ran3_inst.ran3_type[0].size := (create {PD_RAN3_STATE_T}.make).structure_size.to_natural_32
			ran3_inst.ran3_type[0].set := ran3_inst.ran3_set_address
			ran3_inst.ran3_type[0].get := ran3_inst.ran3_get_address
			ran3_inst.ran3_type[0].get_double := ran3_inst.ran3_get_double_address
			ran3_inst.gsl_rng_ran3 := ran3_inst.ran3_type
			minstd_inst.m___2 := (2_147_483_647).to_integer_32
			minstd_inst.a___3 := (16_807).to_integer_32
			minstd_inst.q___2 := (127_773).to_integer_32
			minstd_inst.r___2 := (2_836).to_integer_32
			minstd_inst.minstd_type[0].name := ce_string ("minstd")
			minstd_inst.minstd_type[0].max := {NATURAL_32} 2_147_483_646
			minstd_inst.minstd_type[0].min := {NATURAL_32} 1
			minstd_inst.minstd_type[0].size := (create {PD_MINSTD_STATE_T}.make).structure_size.to_natural_32
			minstd_inst.minstd_type[0].set := minstd_inst.minstd_set_address
			minstd_inst.minstd_type[0].get := minstd_inst.minstd_get_address
			minstd_inst.minstd_type[0].get_double := minstd_inst.minstd_get_double_address
			minstd_inst.gsl_rng_minstd := minstd_inst.minstd_type
			gfsr4_inst.gfsr4_type[0].name := ce_string ("gfsr4")
			gfsr4_inst.gfsr4_type[0].max := {NATURAL_32} 4_294_967_295
			gfsr4_inst.gfsr4_type[0].min := {NATURAL_32} 0
			gfsr4_inst.gfsr4_type[0].size := (create {PD_GFSR4_STATE_T}.make).structure_size.to_natural_32
			gfsr4_inst.gfsr4_type[0].set := gfsr4_inst.gfsr4_set_address
			gfsr4_inst.gfsr4_type[0].get := gfsr4_inst.gfsr4_get_address
			gfsr4_inst.gfsr4_type[0].get_double := gfsr4_inst.gfsr4_get_double_address
			gfsr4_inst.gsl_rng_gfsr4 := gfsr4_inst.gfsr4_type
			mrg_inst.m___3 := (2_147_483_647).to_integer_32
			mrg_inst.a1___3 := (107_374_182).to_integer_32
			mrg_inst.q1___0 := (20).to_integer_32
			mrg_inst.r1___0 := (7).to_integer_32
			mrg_inst.a5 := (104_480).to_integer_32
			mrg_inst.q52 := (20_554).to_integer_32
			mrg_inst.r5 := (1_727).to_integer_32
			mrg_inst.mrg_type[0].name := ce_string ("mrg")
			mrg_inst.mrg_type[0].max := {NATURAL_32} 2_147_483_646
			mrg_inst.mrg_type[0].min := {NATURAL_32} 0
			mrg_inst.mrg_type[0].size := (create {PD_MRG_STATE_T}.make).structure_size.to_natural_32
			mrg_inst.mrg_type[0].set := mrg_inst.mrg_set_address
			mrg_inst.mrg_type[0].get := mrg_inst.mrg_get_address
			mrg_inst.mrg_type[0].get_double := mrg_inst.mrg_get_double_address
			mrg_inst.gsl_rng_mrg := mrg_inst.mrg_type
			random_inst.random_glibc2_type[0].name := ce_string ("random-glibc2")
			random_inst.random_glibc2_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random_glibc2_type[0].min := {NATURAL_32} 0
			random_inst.random_glibc2_type[0].size := (create {PD_RANDOM128_STATE_T}.make).structure_size.to_natural_32
			random_inst.random_glibc2_type[0].set := random_inst.random128_glibc2_set_address
			random_inst.random_glibc2_type[0].get := random_inst.random128_get_address
			random_inst.random_glibc2_type[0].get_double := random_inst.random128_get_double_address
			random_inst.random8_glibc2_type[0].name := ce_string ("random8-glibc2")
			random_inst.random8_glibc2_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random8_glibc2_type[0].min := {NATURAL_32} 0
			random_inst.random8_glibc2_type[0].size := (create {PD_RANDOM8_STATE_T}.make).structure_size.to_natural_32
			random_inst.random8_glibc2_type[0].set := random_inst.random8_glibc2_set_address
			random_inst.random8_glibc2_type[0].get := random_inst.random8_get_address
			random_inst.random8_glibc2_type[0].get_double := random_inst.random8_get_double_address
			random_inst.random32_glibc2_type[0].name := ce_string ("random32-glibc2")
			random_inst.random32_glibc2_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random32_glibc2_type[0].min := {NATURAL_32} 0
			random_inst.random32_glibc2_type[0].size := (create {PD_RANDOM32_STATE_T}.make).structure_size.to_natural_32
			random_inst.random32_glibc2_type[0].set := random_inst.random32_glibc2_set_address
			random_inst.random32_glibc2_type[0].get := random_inst.random32_get_address
			random_inst.random32_glibc2_type[0].get_double := random_inst.random32_get_double_address
			random_inst.random64_glibc2_type[0].name := ce_string ("random64-glibc2")
			random_inst.random64_glibc2_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random64_glibc2_type[0].min := {NATURAL_32} 0
			random_inst.random64_glibc2_type[0].size := (create {PD_RANDOM64_STATE_T}.make).structure_size.to_natural_32
			random_inst.random64_glibc2_type[0].set := random_inst.random64_glibc2_set_address
			random_inst.random64_glibc2_type[0].get := random_inst.random64_get_address
			random_inst.random64_glibc2_type[0].get_double := random_inst.random64_get_double_address
			random_inst.random128_glibc2_type[0].name := ce_string ("random128-glibc2")
			random_inst.random128_glibc2_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random128_glibc2_type[0].min := {NATURAL_32} 0
			random_inst.random128_glibc2_type[0].size := (create {PD_RANDOM128_STATE_T}.make).structure_size.to_natural_32
			random_inst.random128_glibc2_type[0].set := random_inst.random128_glibc2_set_address
			random_inst.random128_glibc2_type[0].get := random_inst.random128_get_address
			random_inst.random128_glibc2_type[0].get_double := random_inst.random128_get_double_address
			random_inst.random256_glibc2_type[0].name := ce_string ("random256-glibc2")
			random_inst.random256_glibc2_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random256_glibc2_type[0].min := {NATURAL_32} 0
			random_inst.random256_glibc2_type[0].size := (create {PD_RANDOM256_STATE_T}.make).structure_size.to_natural_32
			random_inst.random256_glibc2_type[0].set := random_inst.random256_glibc2_set_address
			random_inst.random256_glibc2_type[0].get := random_inst.random256_get_address
			random_inst.random256_glibc2_type[0].get_double := random_inst.random256_get_double_address
			random_inst.random_libc5_type[0].name := ce_string ("random-libc5")
			random_inst.random_libc5_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random_libc5_type[0].min := {NATURAL_32} 0
			random_inst.random_libc5_type[0].size := (create {PD_RANDOM128_STATE_T}.make).structure_size.to_natural_32
			random_inst.random_libc5_type[0].set := random_inst.random128_libc5_set_address
			random_inst.random_libc5_type[0].get := random_inst.random128_get_address
			random_inst.random_libc5_type[0].get_double := random_inst.random128_get_double_address
			random_inst.random8_libc5_type[0].name := ce_string ("random8-libc5")
			random_inst.random8_libc5_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random8_libc5_type[0].min := {NATURAL_32} 0
			random_inst.random8_libc5_type[0].size := (create {PD_RANDOM8_STATE_T}.make).structure_size.to_natural_32
			random_inst.random8_libc5_type[0].set := random_inst.random8_libc5_set_address
			random_inst.random8_libc5_type[0].get := random_inst.random8_get_address
			random_inst.random8_libc5_type[0].get_double := random_inst.random8_get_double_address
			random_inst.random32_libc5_type[0].name := ce_string ("random32-libc5")
			random_inst.random32_libc5_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random32_libc5_type[0].min := {NATURAL_32} 0
			random_inst.random32_libc5_type[0].size := (create {PD_RANDOM32_STATE_T}.make).structure_size.to_natural_32
			random_inst.random32_libc5_type[0].set := random_inst.random32_libc5_set_address
			random_inst.random32_libc5_type[0].get := random_inst.random32_get_address
			random_inst.random32_libc5_type[0].get_double := random_inst.random32_get_double_address
			random_inst.random64_libc5_type[0].name := ce_string ("random64-libc5")
			random_inst.random64_libc5_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random64_libc5_type[0].min := {NATURAL_32} 0
			random_inst.random64_libc5_type[0].size := (create {PD_RANDOM64_STATE_T}.make).structure_size.to_natural_32
			random_inst.random64_libc5_type[0].set := random_inst.random64_libc5_set_address
			random_inst.random64_libc5_type[0].get := random_inst.random64_get_address
			random_inst.random64_libc5_type[0].get_double := random_inst.random64_get_double_address
			random_inst.random128_libc5_type[0].name := ce_string ("random128-libc5")
			random_inst.random128_libc5_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random128_libc5_type[0].min := {NATURAL_32} 0
			random_inst.random128_libc5_type[0].size := (create {PD_RANDOM128_STATE_T}.make).structure_size.to_natural_32
			random_inst.random128_libc5_type[0].set := random_inst.random128_libc5_set_address
			random_inst.random128_libc5_type[0].get := random_inst.random128_get_address
			random_inst.random128_libc5_type[0].get_double := random_inst.random128_get_double_address
			random_inst.random256_libc5_type[0].name := ce_string ("random256-libc5")
			random_inst.random256_libc5_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random256_libc5_type[0].min := {NATURAL_32} 0
			random_inst.random256_libc5_type[0].size := (create {PD_RANDOM256_STATE_T}.make).structure_size.to_natural_32
			random_inst.random256_libc5_type[0].set := random_inst.random256_libc5_set_address
			random_inst.random256_libc5_type[0].get := random_inst.random256_get_address
			random_inst.random256_libc5_type[0].get_double := random_inst.random256_get_double_address
			random_inst.random_bsd_type[0].name := ce_string ("random-bsd")
			random_inst.random_bsd_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random_bsd_type[0].min := {NATURAL_32} 0
			random_inst.random_bsd_type[0].size := (create {PD_RANDOM128_STATE_T}.make).structure_size.to_natural_32
			random_inst.random_bsd_type[0].set := random_inst.random128_bsd_set_address
			random_inst.random_bsd_type[0].get := random_inst.random128_get_address
			random_inst.random_bsd_type[0].get_double := random_inst.random128_get_double_address
			random_inst.random8_bsd_type[0].name := ce_string ("random8-bsd")
			random_inst.random8_bsd_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random8_bsd_type[0].min := {NATURAL_32} 0
			random_inst.random8_bsd_type[0].size := (create {PD_RANDOM8_STATE_T}.make).structure_size.to_natural_32
			random_inst.random8_bsd_type[0].set := random_inst.random8_bsd_set_address
			random_inst.random8_bsd_type[0].get := random_inst.random8_get_address
			random_inst.random8_bsd_type[0].get_double := random_inst.random8_get_double_address
			random_inst.random32_bsd_type[0].name := ce_string ("random32-bsd")
			random_inst.random32_bsd_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random32_bsd_type[0].min := {NATURAL_32} 0
			random_inst.random32_bsd_type[0].size := (create {PD_RANDOM32_STATE_T}.make).structure_size.to_natural_32
			random_inst.random32_bsd_type[0].set := random_inst.random32_bsd_set_address
			random_inst.random32_bsd_type[0].get := random_inst.random32_get_address
			random_inst.random32_bsd_type[0].get_double := random_inst.random32_get_double_address
			random_inst.random64_bsd_type[0].name := ce_string ("random64-bsd")
			random_inst.random64_bsd_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random64_bsd_type[0].min := {NATURAL_32} 0
			random_inst.random64_bsd_type[0].size := (create {PD_RANDOM64_STATE_T}.make).structure_size.to_natural_32
			random_inst.random64_bsd_type[0].set := random_inst.random64_bsd_set_address
			random_inst.random64_bsd_type[0].get := random_inst.random64_get_address
			random_inst.random64_bsd_type[0].get_double := random_inst.random64_get_double_address
			random_inst.random128_bsd_type[0].name := ce_string ("random128-bsd")
			random_inst.random128_bsd_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random128_bsd_type[0].min := {NATURAL_32} 0
			random_inst.random128_bsd_type[0].size := (create {PD_RANDOM128_STATE_T}.make).structure_size.to_natural_32
			random_inst.random128_bsd_type[0].set := random_inst.random128_bsd_set_address
			random_inst.random128_bsd_type[0].get := random_inst.random128_get_address
			random_inst.random128_bsd_type[0].get_double := random_inst.random128_get_double_address
			random_inst.random256_bsd_type[0].name := ce_string ("random256-bsd")
			random_inst.random256_bsd_type[0].max := {NATURAL_32} 2_147_483_647
			random_inst.random256_bsd_type[0].min := {NATURAL_32} 0
			random_inst.random256_bsd_type[0].size := (create {PD_RANDOM256_STATE_T}.make).structure_size.to_natural_32
			random_inst.random256_bsd_type[0].set := random_inst.random256_bsd_set_address
			random_inst.random256_bsd_type[0].get := random_inst.random256_get_address
			random_inst.random256_bsd_type[0].get_double := random_inst.random256_get_double_address
			random_inst.gsl_rng_random_libc5 := random_inst.random_libc5_type
			random_inst.gsl_rng_random8_libc5 := random_inst.random8_libc5_type
			random_inst.gsl_rng_random32_libc5 := random_inst.random32_libc5_type
			random_inst.gsl_rng_random64_libc5 := random_inst.random64_libc5_type
			random_inst.gsl_rng_random128_libc5 := random_inst.random128_libc5_type
			random_inst.gsl_rng_random256_libc5 := random_inst.random256_libc5_type
			random_inst.gsl_rng_random_glibc2 := random_inst.random_glibc2_type
			random_inst.gsl_rng_random8_glibc2 := random_inst.random8_glibc2_type
			random_inst.gsl_rng_random32_glibc2 := random_inst.random32_glibc2_type
			random_inst.gsl_rng_random64_glibc2 := random_inst.random64_glibc2_type
			random_inst.gsl_rng_random128_glibc2 := random_inst.random128_glibc2_type
			random_inst.gsl_rng_random256_glibc2 := random_inst.random256_glibc2_type
			random_inst.gsl_rng_random_bsd := random_inst.random_bsd_type
			random_inst.gsl_rng_random8_bsd := random_inst.random8_bsd_type
			random_inst.gsl_rng_random32_bsd := random_inst.random32_bsd_type
			random_inst.gsl_rng_random64_bsd := random_inst.random64_bsd_type
			random_inst.gsl_rng_random128_bsd := random_inst.random128_bsd_type
			random_inst.gsl_rng_random256_bsd := random_inst.random256_bsd_type
			coveyou_inst.ran_type___8[0].name := ce_string ("coveyou")
			coveyou_inst.ran_type___8[0].max := {NATURAL_32} 4_294_967_294
			coveyou_inst.ran_type___8[0].min := {NATURAL_32} 2
		end

end
