deferred class
	LIBGSL_DATA

inherit
	CE_UTILITIES
	LIBGSL_ASSEMBLER

feature {NONE}

	version_inst: P_VERSION
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	block_source_inst: P_BLOCK_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fwrite_source_inst: P_FWRITE_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fprintf_source_inst: P_FPRINTF_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	init_source_inst: P_INIT_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_pow_int_inst: P_GSL_GSL_POW_INT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_minmax_inst: P_GSL_GSL_MINMAX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_long_double_inst: P_GSL_GSL_VECTOR_LONG_DOUBLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_complex_long_double_inst: P_GSL_GSL_VECTOR_COMPLEX_LONG_DOUBLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_double_inst: P_GSL_GSL_VECTOR_DOUBLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_complex_double_inst: P_GSL_GSL_VECTOR_COMPLEX_DOUBLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_float_inst: P_GSL_GSL_VECTOR_FLOAT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_complex_float_inst: P_GSL_GSL_VECTOR_COMPLEX_FLOAT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_ulong_inst: P_GSL_GSL_VECTOR_ULONG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_long_inst: P_GSL_GSL_VECTOR_LONG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_uint_inst: P_GSL_GSL_VECTOR_UINT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_int_inst: P_GSL_GSL_VECTOR_INT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_ushort_inst: P_GSL_GSL_VECTOR_USHORT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_short_inst: P_GSL_GSL_VECTOR_SHORT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_uchar_inst: P_GSL_GSL_VECTOR_UCHAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_vector_char_inst: P_GSL_GSL_VECTOR_CHAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_complex_long_double_inst: P_GSL_GSL_MATRIX_COMPLEX_LONG_DOUBLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_complex_double_inst: P_GSL_GSL_MATRIX_COMPLEX_DOUBLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_complex_float_inst: P_GSL_GSL_MATRIX_COMPLEX_FLOAT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_long_double_inst: P_GSL_GSL_MATRIX_LONG_DOUBLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_double_inst: P_GSL_GSL_MATRIX_DOUBLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_float_inst: P_GSL_GSL_MATRIX_FLOAT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_ulong_inst: P_GSL_GSL_MATRIX_ULONG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_long_inst: P_GSL_GSL_MATRIX_LONG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_uint_inst: P_GSL_GSL_MATRIX_UINT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_int_inst: P_GSL_GSL_MATRIX_INT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_ushort_inst: P_GSL_GSL_MATRIX_USHORT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_short_inst: P_GSL_GSL_MATRIX_SHORT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_uchar_inst: P_GSL_GSL_MATRIX_UCHAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_matrix_char_inst: P_GSL_GSL_MATRIX_CHAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	blas_inst: P_BLAS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bspline_inst: P_BSPLINE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_complex_math_inst: P_GSL_GSL_COMPLEX_MATH
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	math_inst: P_MATH
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_mode_inst: P_GSL_GSL_MODE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	eval_inst: P_EVAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	integ_inst: P_INTEG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	init_inst: P_INIT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	deriv_inst: P_DERIV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dht_inst: P_DHT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	diff_inst: P_DIFF
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_permutation_inst: P_GSL_GSL_PERMUTATION
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	nonsymmv_inst: P_NONSYMMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qrstep_inst: P_QRSTEP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hermv_inst: P_HERMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	symmv_inst: P_SYMMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	jacobi_inst: P_JACOBI
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	herm_inst: P_HERM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	genherm_inst: P_GENHERM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sort_inst: P_SORT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	schur_inst: P_SCHUR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	nonsymm_inst: P_NONSYMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	francis_inst: P_FRANCIS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	genv_inst: P_GENV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gen_inst: P_GEN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	symm_inst: P_SYMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gensymmv_inst: P_GENSYMMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gensymm_inst: P_GENSYMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	genhermv_inst: P_GENHERMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	stream_inst: P_STREAM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	message_inst: P_MESSAGE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	error_inst: P_ERROR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	strerror_inst: P_STRERROR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bitreverse_inst: P_BITREVERSE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	factorize_inst: P_FACTORIZE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_init_inst: P_C_INIT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_main_inst: P_C_MAIN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_pass_2_inst: P_C_PASS_2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_pass_3_inst: P_C_PASS_3
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_pass_4_inst: P_C_PASS_4
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_pass_5_inst: P_C_PASS_5
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_pass_6_inst: P_C_PASS_6
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_pass_7_inst: P_C_PASS_7
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_pass_n_inst: P_C_PASS_N
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	c_radix2_inst: P_C_RADIX2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_init_inst: P_HC_INIT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_main_inst: P_HC_MAIN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_pass_2_inst: P_HC_PASS_2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_pass_3_inst: P_HC_PASS_3
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_pass_4_inst: P_HC_PASS_4
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_pass_5_inst: P_HC_PASS_5
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_pass_n_inst: P_HC_PASS_N
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_radix2_inst: P_HC_RADIX2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hc_unpack_inst: P_HC_UNPACK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_init_inst: P_REAL_INIT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_main_inst: P_REAL_MAIN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_pass_2_inst: P_REAL_PASS_2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_pass_3_inst: P_REAL_PASS_3
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_pass_4_inst: P_REAL_PASS_4
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_pass_5_inst: P_REAL_PASS_5
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_pass_n_inst: P_REAL_PASS_N
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_radix2_inst: P_REAL_RADIX2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	real_unpack_inst: P_REAL_UNPACK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dft_source_inst: P_DFT_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	linear_inst: P_LINEAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	params2d_inst: P_PARAMS2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	find_inst: P_FIND
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	get_inst: P_GET
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	stat_inst: P_STAT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	reset_inst: P_RESET
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	get2d_inst: P_GET2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	calloc_range2d_inst: P_CALLOC_RANGE2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	oper2d_inst: P_OPER2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	maxval2d_inst: P_MAXVAL2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	copy2d_inst: P_COPY2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	reset2d_inst: P_RESET2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	params_inst: P_PARAMS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	copy_inst: P_COPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	oper_inst: P_OPER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	init2d_inst: P_INIT2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	stat2d_inst: P_STAT2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	file2d_inst: P_FILE2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	file_inst: P_FILE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	calloc_range_inst: P_CALLOC_RANGE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	add_inst: P_ADD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	pdf_inst: P_PDF
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	pdf2d_inst: P_PDF2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	maxval_inst: P_MAXVAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	find2d_inst: P_FIND2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	add2d_inst: P_ADD2D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	read_inst: P_READ
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fp_gnux86_inst: P_FP_GNUX86
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	endian_inst: P_ENDIAN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	standardize_inst: P_STANDARDIZE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	make_rep_inst: P_MAKE_REP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	env_inst: P_ENV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	print_inst: P_PRINT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	initialise_inst: P_INITIALISE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	set_initial_inst: P_SET_INITIAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qpsrt_inst: P_QPSRT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	util_inst: P_UTIL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qpsrt2_inst: P_QPSRT2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qelg_inst: P_QELG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	positivity_inst: P_POSITIVITY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qags_inst: P_QAGS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qk31_inst: P_QK31
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qmomof_inst: P_QMOMOF
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qcheb_inst: P_QCHEB
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	err_inst: P_ERR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qng_inst: P_QNG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qk21_inst: P_QK21
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qag_inst: P_QAG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qmomo_inst: P_QMOMO
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	append_inst: P_APPEND
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qawf_inst: P_QAWF
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qk61_inst: P_QK61
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qc25f_inst: P_QC25F
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qawo_inst: P_QAWO
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qk51_inst: P_QK51
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ptsort_inst: P_PTSORT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qagp_inst: P_QAGP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qc25c_inst: P_QC25C
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qawc_inst: P_QAWC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qk41_inst: P_QK41
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	glfixed_inst: P_GLFIXED
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	workspace_inst: P_WORKSPACE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qk15_inst: P_QK15
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qk_inst: P_QK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qc25s_inst: P_QC25S
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qaws_inst: P_QAWS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	integ_eval_inst: P_INTEG_EVAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_interp_inst: P_GSL_GSL_INTERP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cspline_inst: P_CSPLINE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	interp_inst: P_INTERP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_poly_inst: P_GSL_GSL_POLY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	poly_inst: P_POLY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	spline_inst: P_SPLINE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	akima_inst: P_AKIMA
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	accel_inst: P_ACCEL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lu_inst: P_LU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bidiag_inst: P_BIDIAG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	symmtd_inst: P_SYMMTD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	balancemat_inst: P_BALANCEMAT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	exponential_inst: P_EXPONENTIAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	choleskyc_inst: P_CHOLESKYC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hessenberg_inst: P_HESSENBERG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hermtd_inst: P_HERMTD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hesstri_inst: P_HESSTRI
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	apply_givens_inst: P_APPLY_GIVENS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qr_inst: P_QR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	multiply_inst: P_MULTIPLY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	balance_inst: P_BALANCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	householder_inst: P_HOUSEHOLDER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lq_inst: P_LQ
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hh_inst: P_HH
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	luc_inst: P_LUC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qrpt_inst: P_QRPT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ptlq_inst: P_PTLQ
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	tridiag_inst: P_TRIDIAG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cholesky_inst: P_CHOLESKY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	householdercomplex_inst: P_HOUSEHOLDERCOMPLEX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	svdstep_inst: P_SVDSTEP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	svd_inst: P_SVD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	prop_source_inst: P_PROP_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	minmax_source_inst: P_MINMAX_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rowcol_source_inst: P_ROWCOL_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	swap_source_inst: P_SWAP_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	copy_source_inst: P_COPY_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	oper_complex_source_inst: P_OPER_COMPLEX_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	oper_source_inst: P_OPER_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	getset_source_inst: P_GETSET_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	view_source_inst: P_VIEW_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	file_source_inst: P_FILE_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	submatrix_source_inst: P_SUBMATRIX_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	quad_golden_inst: P_QUAD_GOLDEN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bracketing_inst: P_BRACKETING
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	convergence_inst: P_CONVERGENCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fsolver_inst: P_FSOLVER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	golden_inst: P_GOLDEN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	brent_inst: P_BRENT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_rng_inst: P_GSL_GSL_RNG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	miser_inst: P_MISER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	vegas_inst: P_VEGAS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	plain_inst: P_PLAIN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lmutil_inst: P_LMUTIL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qrsolv_inst: P_QRSOLV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lmpar_inst: P_LMPAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lmset_inst: P_LMSET
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lmiterate_inst: P_LMITERATE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lmder_inst: P_LMDER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fdfsolver_inst: P_FDFSOLVER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gradient_inst: P_GRADIENT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	work_inst: P_WORK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	multilinear_inst: P_MULTILINEAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	covar_inst: P_COVAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fdfminimizer_inst: P_FDFMINIMIZER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	simplex_inst: P_SIMPLEX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	directional_minimize_inst: P_DIRECTIONAL_MINIMIZE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	vector_bfgs_inst: P_VECTOR_BFGS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	conjugate_pr_inst: P_CONJUGATE_PR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	steepest_descent_inst: P_STEEPEST_DESCENT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	conjugate_fr_inst: P_CONJUGATE_FR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	linear_minimize_inst: P_LINEAR_MINIMIZE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	linear_wrapper_inst: P_LINEAR_WRAPPER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	vector_bfgs2_inst: P_VECTOR_BFGS2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	simplex2_inst: P_SIMPLEX2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fminimizer_inst: P_FMINIMIZER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	newton_inst: P_NEWTON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	enorm_inst: P_ENORM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gnewton_inst: P_GNEWTON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dogleg_inst: P_DOGLEG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hybridj_inst: P_HYBRIDJ
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fdjac_inst: P_FDJAC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hybrid_inst: P_HYBRID
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dnewton_inst: P_DNEWTON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	broyden_inst: P_BROYDEN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ntuple_inst: P_NTUPLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rk8pd_inst: P_RK8PD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rkck_inst: P_RKCK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	evolve_inst: P_EVOLVE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rk2imp_inst: P_RK2IMP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cstd_inst: P_CSTD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rk2_inst: P_RK2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	step_inst: P_STEP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gear1_inst: P_GEAR1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rk2simp_inst: P_RK2SIMP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cscal_inst: P_CSCAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rk4imp_inst: P_RK4IMP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gear2_inst: P_GEAR2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	control_inst: P_CONTROL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rkf45_inst: P_RKF45
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rk4_inst: P_RK4
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bsimp_inst: P_BSIMP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	permute_source_inst: P_PERMUTE_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	canonical_inst: P_CANONICAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	permutation_inst: P_PERMUTATION
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_combination_inst: P_GSL_GSL_COMBINATION
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	combination_inst: P_COMBINATION
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_multiset_inst: P_GSL_GSL_MULTISET
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	multiset_inst: P_MULTISET
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	solve_cubic_inst: P_SOLVE_CUBIC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zsolve_init_inst: P_ZSOLVE_INIT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	solve_quadratic_inst: P_SOLVE_QUADRATIC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dd_inst: P_DD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zsolve_cubic_inst: P_ZSOLVE_CUBIC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	companion_inst: P_COMPANION
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zsolve_inst: P_ZSOLVE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zsolve_quadratic_inst: P_ZSOLVE_QUADRATIC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gsl_gsl_qrng_inst: P_GSL_GSL_QRNG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	qrng_inst: P_QRNG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	reversehalton_inst: P_REVERSEHALTON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sobol_inst: P_SOBOL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	niederreiter_2_inst: P_NIEDERREITER_2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	halton_inst: P_HALTON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	levy_inst: P_LEVY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	pascal_inst: P_PASCAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cauchy_inst: P_CAUCHY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	erlang_inst: P_ERLANG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	chisq_inst: P_CHISQ
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	discrete_inst: P_DISCRETE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bernoulli_inst: P_BERNOULLI
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fdist_inst: P_FDIST
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rayleigh_inst: P_RAYLEIGH
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	laplace_inst: P_LAPLACE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gausstail_inst: P_GAUSSTAIL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	nbinomial_inst: P_NBINOMIAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	weibull_inst: P_WEIBULL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sphere_inst: P_SPHERE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hyperg_inst: P_HYPERG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	landau_inst: P_LANDAU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	binomial_inst: P_BINOMIAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gamma_inst: P_GAMMA
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	binomial_tpe_inst: P_BINOMIAL_TPE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	multinomial_inst: P_MULTINOMIAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	exppow_inst: P_EXPPOW
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	shuffle_inst: P_SHUFFLE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	geometric_inst: P_GEOMETRIC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gumbel_inst: P_GUMBEL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	flat_inst: P_FLAT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	beta_inst: P_BETA
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	tdist_inst: P_TDIST
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dirichlet_inst: P_DIRICHLET
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lognormal_inst: P_LOGNORMAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	pareto_inst: P_PARETO
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	poisson_inst: P_POISSON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	logarithmic_inst: P_LOGARITHMIC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bigauss_inst: P_BIGAUSS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	logistic_inst: P_LOGISTIC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gausszig_inst: P_GAUSSZIG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gauss_inst: P_GAUSS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	schrage_inst: P_SCHRAGE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fishman18_inst: P_FISHMAN18
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	types_inst: P_TYPES
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zuf_inst: P_ZUF
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ranlxs_inst: P_RANLXS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	randu_inst: P_RANDU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	uni32_inst: P_UNI32
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ran1_inst: P_RAN1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	borosh13_inst: P_BOROSH13
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ran2_inst: P_RAN2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ran0_inst: P_RAN0
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	knuthran2_inst: P_KNUTHRAN2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	tt_inst: P_TT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	vax_inst: P_VAX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ranmar_inst: P_RANMAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fishman2x_inst: P_FISHMAN2X
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ranf_inst: P_RANF
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	knuthran_inst: P_KNUTHRAN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lecuyer21_inst: P_LECUYER21
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ranlxd_inst: P_RANLXD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	slatec_inst: P_SLATEC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rng_inst: P_RNG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	transputer_inst: P_TRANSPUTER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	uni_inst: P_UNI
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	waterman14_inst: P_WATERMAN14
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	taus_inst: P_TAUS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	knuthran2002_inst: P_KNUTHRAN2002
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	taus113_inst: P_TAUS113
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rand_inst: P_RAND
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ranlux_inst: P_RANLUX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fishman20_inst: P_FISHMAN20
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rand48_inst: P_RAND48
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	r250_inst: P_R250
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ran3_inst: P_RAN3
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	minstd_inst: P_MINSTD
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gfsr4_inst: P_GFSR4
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	mrg_inst: P_MRG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	random_inst: P_RANDOM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	default_inst: P_DEFAULT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	coveyou_inst: P_COVEYOU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cmrg_inst: P_CMRG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	mt_inst: P_MT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	steffenson_inst: P_STEFFENSON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bisection_inst: P_BISECTION
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	secant_inst: P_SECANT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	falsepos_inst: P_FALSEPOS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	siman_inst: P_SIMAN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	subset_source_inst: P_SUBSET_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sortvec_source_inst: P_SORTVEC_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sortind_inst: P_SORTIND
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	subsetind_source_inst: P_SUBSETIND_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sortvecind_source_inst: P_SORTVECIND_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cheb_eval_inst: P_CHEB_EVAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_temme_inst: P_BESSEL_TEMME
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	trig_inst: P_TRIG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	atanint_inst: P_ATANINT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	erfc_inst: P_ERFC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fermi_dirac_inst: P_FERMI_DIRAC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	legendre_con_inst: P_LEGENDRE_CON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	airy_zero_inst: P_AIRY_ZERO
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	elljac_inst: P_ELLJAC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_j1_inst: P_BESSEL_J1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hyperg_2f0_inst: P_HYPERG_2F0
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_i_inst: P_BESSEL_I
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	expint_inst: P_EXPINT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_jnu_inst: P_BESSEL_JNU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_zero_inst: P_BESSEL_ZERO
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_j_inst: P_BESSEL_J
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hyperg_1f1_inst: P_HYPERG_1F1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_inu_inst: P_BESSEL_INU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	mathieu_charv_inst: P_MATHIEU_CHARV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_k_inst: P_BESSEL_K
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	legendre_poly_inst: P_LEGENDRE_POLY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sinint_inst: P_SININT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	mathieu_angfunc_inst: P_MATHIEU_ANGFUNC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	log_inst: P_LOG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	laguerre_inst: P_LAGUERRE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	poch_inst: P_POCH
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hyperg_2f1_inst: P_HYPERG_2F1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	exp_inst: P_EXP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	legendre_qn_inst: P_LEGENDRE_QN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_k1_inst: P_BESSEL_K1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	mathieu_workspace_inst: P_MATHIEU_WORKSPACE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_amp_phase_inst: P_BESSEL_AMP_PHASE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_sequence_inst: P_BESSEL_SEQUENCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	debye_inst: P_DEBYE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	clausen_inst: P_CLAUSEN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_i0_inst: P_BESSEL_I0
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_in_inst: P_BESSEL_IN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	transport_inst: P_TRANSPORT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	coulomb_bound_inst: P_COULOMB_BOUND
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_kn_inst: P_BESSEL_KN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	coulomb_inst: P_COULOMB
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_knu_inst: P_BESSEL_KNU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	beta_inc_inst: P_BETA_INC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	result_inst: P_RESULT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ellint_inst: P_ELLINT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	synchrotron_inst: P_SYNCHROTRON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dilog_inst: P_DILOG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	legendre_h3d_inst: P_LEGENDRE_H3D
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	mathieu_coeff_inst: P_MATHIEU_COEFF
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	shint_inst: P_SHINT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_y1_inst: P_BESSEL_Y1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cheb_eval_mode_inst: P_CHEB_EVAL_MODE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	airy_inst: P_AIRY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dawson_inst: P_DAWSON
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hyperg_0f1_inst: P_HYPERG_0F1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_jn_inst: P_BESSEL_JN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_inst: P_BESSEL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	elementary_inst: P_ELEMENTARY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	expint3_inst: P_EXPINT3
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	pow_int_inst: P_POW_INT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_yn_inst: P_BESSEL_YN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_k0_inst: P_BESSEL_K0
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_y0_inst: P_BESSEL_Y0
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hyperg_u_inst: P_HYPERG_U
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_ynu_inst: P_BESSEL_YNU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_i1_inst: P_BESSEL_I1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	mathieu_radfunc_inst: P_MATHIEU_RADFUNC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gamma_inc_inst: P_GAMMA_INC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	coupling_inst: P_COUPLING
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_j0_inst: P_BESSEL_J0
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	psi_inst: P_PSI
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zeta_inst: P_ZETA
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	airy_der_inst: P_AIRY_DER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_olver_inst: P_BESSEL_OLVER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gegenbauer_inst: P_GEGENBAUER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lambert_inst: P_LAMBERT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	bessel_y_inst: P_BESSEL_Y
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	p_variance_source_inst: P_P_VARIANCE_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	wkurtosis_source_inst: P_WKURTOSIS_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	wmean_source_inst: P_WMEAN_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	covariance_source_inst: P_COVARIANCE_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	mean_source_inst: P_MEAN_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	wabsdev_source_inst: P_WABSDEV_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	median_source_inst: P_MEDIAN_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lag1_source_inst: P_LAG1_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	skew_source_inst: P_SKEW_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	wvariance_source_inst: P_WVARIANCE_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	absdev_source_inst: P_ABSDEV_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ttest_source_inst: P_TTEST_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	quantiles_source_inst: P_QUANTILES_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	kurtosis_source_inst: P_KURTOSIS_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	wskew_source_inst: P_WSKEW_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	variance_source_inst: P_VARIANCE_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	work_utrunc_inst: P_WORK_UTRUNC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	work_u_inst: P_WORK_U
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	levin_u_inst: P_LEVIN_U
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	levin_utrunc_inst: P_LEVIN_UTRUNC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	expm1_inst: P_EXPM1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	infnan_inst: P_INFNAN
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	coerce_inst: P_COERCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	prec_inst: P_PREC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	minmax_inst: P_MINMAX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fdiv_inst: P_FDIV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fcmp_inst: P_FCMP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	log1p_inst: P_LOG1P
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hypot_inst: P_HYPOT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	invhyp_inst: P_INVHYP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ldfrexp_inst: P_LDFREXP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	results_inst: P_RESULTS
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	placeholder_inst: P_PLACEHOLDER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	vector_inst: P_VECTOR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	reim_source_inst: P_REIM_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	subvector_source_inst: P_SUBVECTOR_SOURCE
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gumbel2inv_inst: P_GUMBEL2INV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gumbel1_inst: P_GUMBEL1
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	logisticinv_inst: P_LOGISTICINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	weibullinv_inst: P_WEIBULLINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	exponentialinv_inst: P_EXPONENTIALINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	fdistinv_inst: P_FDISTINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gammainv_inst: P_GAMMAINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	hypergeometric_inst: P_HYPERGEOMETRIC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cauchyinv_inst: P_CAUCHYINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	laplaceinv_inst: P_LAPLACEINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	chisqinv_inst: P_CHISQINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	lognormalinv_inst: P_LOGNORMALINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gumbel2_inst: P_GUMBEL2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rat_eval_inst: P_RAT_EVAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gaussinv_inst: P_GAUSSINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	tdistinv_inst: P_TDISTINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	paretoinv_inst: P_PARETOINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	gumbel1inv_inst: P_GUMBEL1INV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	flatinv_inst: P_FLATINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	betainv_inst: P_BETAINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	rayleighinv_inst: P_RAYLEIGHINV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	haar_inst: P_HAAR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	wavelet_inst: P_WAVELET
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dwt_inst: P_DWT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	daubechies_inst: P_DAUBECHIES
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sasum_inst: P_SASUM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	saxpy_inst: P_SAXPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	scasum_inst: P_SCASUM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	scnrm2_inst: P_SCNRM2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	scopy_inst: P_SCOPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sdot_inst: P_SDOT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sdsdot_inst: P_SDSDOT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sgbmv_inst: P_SGBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sgemm_inst: P_SGEMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sgemv_inst: P_SGEMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sger_inst: P_SGER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	snrm2_inst: P_SNRM2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	srot_inst: P_SROT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	srotg_inst: P_SROTG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	srotm_inst: P_SROTM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	srotmg_inst: P_SROTMG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ssbmv_inst: P_SSBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sscal_inst: P_SSCAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sspmv_inst: P_SSPMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sspr_inst: P_SSPR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sspr2_inst: P_SSPR2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	sswap_inst: P_SSWAP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ssymm_inst: P_SSYMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ssymv_inst: P_SSYMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ssyr_inst: P_SSYR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ssyr2_inst: P_SSYR2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ssyr2k_inst: P_SSYR2K
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ssyrk_inst: P_SSYRK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	stbmv_inst: P_STBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	stbsv_inst: P_STBSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	stpmv_inst: P_STPMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	stpsv_inst: P_STPSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	strmm_inst: P_STRMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	strmv_inst: P_STRMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	strsm_inst: P_STRSM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	strsv_inst: P_STRSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dasum_inst: P_DASUM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	daxpy_inst: P_DAXPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dcopy_inst: P_DCOPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ddot_inst: P_DDOT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dgbmv_inst: P_DGBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dgemm_inst: P_DGEMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dgemv_inst: P_DGEMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dger_inst: P_DGER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dnrm2_inst: P_DNRM2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	drot_inst: P_DROT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	drotg_inst: P_DROTG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	drotm_inst: P_DROTM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	drotmg_inst: P_DROTMG
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dsbmv_inst: P_DSBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dscal_inst: P_DSCAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dsdot_inst: P_DSDOT
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dspmv_inst: P_DSPMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dspr_inst: P_DSPR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dspr2_inst: P_DSPR2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dswap_inst: P_DSWAP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dsymm_inst: P_DSYMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dsymv_inst: P_DSYMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dsyr_inst: P_DSYR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dsyr2_inst: P_DSYR2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dsyr2k_inst: P_DSYR2K
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dsyrk_inst: P_DSYRK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dtbmv_inst: P_DTBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dtbsv_inst: P_DTBSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dtpmv_inst: P_DTPMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dtpsv_inst: P_DTPSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dtrmm_inst: P_DTRMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dtrmv_inst: P_DTRMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dtrsm_inst: P_DTRSM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dtrsv_inst: P_DTRSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dzasum_inst: P_DZASUM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	dznrm2_inst: P_DZNRM2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	caxpy_inst: P_CAXPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ccopy_inst: P_CCOPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cdotc_sub_inst: P_CDOTC_SUB
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cdotu_sub_inst: P_CDOTU_SUB
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cgbmv_inst: P_CGBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cgemm_inst: P_CGEMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cgemv_inst: P_CGEMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cgerc_inst: P_CGERC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cgeru_inst: P_CGERU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	chbmv_inst: P_CHBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	chemm_inst: P_CHEMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	chemv_inst: P_CHEMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cher_inst: P_CHER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cher2_inst: P_CHER2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cher2k_inst: P_CHER2K
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cherk_inst: P_CHERK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	chpmv_inst: P_CHPMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	chpr_inst: P_CHPR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	chpr2_inst: P_CHPR2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	csscal_inst: P_CSSCAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	cswap_inst: P_CSWAP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	csymm_inst: P_CSYMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	csyr2k_inst: P_CSYR2K
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	csyrk_inst: P_CSYRK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ctbmv_inst: P_CTBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ctbsv_inst: P_CTBSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ctpmv_inst: P_CTPMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ctpsv_inst: P_CTPSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ctrmm_inst: P_CTRMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ctrmv_inst: P_CTRMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ctrsm_inst: P_CTRSM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ctrsv_inst: P_CTRSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zaxpy_inst: P_ZAXPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zcopy_inst: P_ZCOPY
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zdotc_sub_inst: P_ZDOTC_SUB
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zdotu_sub_inst: P_ZDOTU_SUB
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zdscal_inst: P_ZDSCAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zgbmv_inst: P_ZGBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zgemm_inst: P_ZGEMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zgemv_inst: P_ZGEMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zgerc_inst: P_ZGERC
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zgeru_inst: P_ZGERU
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zhbmv_inst: P_ZHBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zhemm_inst: P_ZHEMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zhemv_inst: P_ZHEMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zher_inst: P_ZHER
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zher2_inst: P_ZHER2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zher2k_inst: P_ZHER2K
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zherk_inst: P_ZHERK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zhpmv_inst: P_ZHPMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zhpr_inst: P_ZHPR
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zhpr2_inst: P_ZHPR2
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zscal_inst: P_ZSCAL
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zswap_inst: P_ZSWAP
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zsymm_inst: P_ZSYMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zsyr2k_inst: P_ZSYR2K
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	zsyrk_inst: P_ZSYRK
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ztbmv_inst: P_ZTBMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ztbsv_inst: P_ZTBSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ztpmv_inst: P_ZTPMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ztpsv_inst: P_ZTPSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ztrmm_inst: P_ZTRMM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ztrmv_inst: P_ZTRMV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ztrsm_inst: P_ZTRSM
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	ztrsv_inst: P_ZTRSV
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	icamax_inst: P_ICAMAX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	idamax_inst: P_IDAMAX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	isamax_inst: P_ISAMAX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	izamax_inst: P_IZAMAX
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

	xerbla_inst: P_XERBLA
		once ("PROCESS")
			create Result 
			libgsl_data_initialize
		end

feature {NONE}

	libgsl_data_initialize
		once ("PROCESS")
			version_inst.do_nothing
			block_source_inst.do_nothing
			fwrite_source_inst.do_nothing
			fprintf_source_inst.do_nothing
			init_source_inst.do_nothing
			gsl_gsl_pow_int_inst.do_nothing
			gsl_gsl_minmax_inst.do_nothing
			gsl_gsl_vector_long_double_inst.do_nothing
			gsl_gsl_vector_complex_long_double_inst.do_nothing
			gsl_gsl_vector_double_inst.do_nothing
			gsl_gsl_vector_complex_double_inst.do_nothing
			gsl_gsl_vector_float_inst.do_nothing
			gsl_gsl_vector_complex_float_inst.do_nothing
			gsl_gsl_vector_ulong_inst.do_nothing
			gsl_gsl_vector_long_inst.do_nothing
			gsl_gsl_vector_uint_inst.do_nothing
			gsl_gsl_vector_int_inst.do_nothing
			gsl_gsl_vector_ushort_inst.do_nothing
			gsl_gsl_vector_short_inst.do_nothing
			gsl_gsl_vector_uchar_inst.do_nothing
			gsl_gsl_vector_char_inst.do_nothing
			gsl_gsl_matrix_complex_long_double_inst.do_nothing
			gsl_gsl_matrix_complex_double_inst.do_nothing
			gsl_gsl_matrix_complex_float_inst.do_nothing
			gsl_gsl_matrix_long_double_inst.do_nothing
			gsl_gsl_matrix_double_inst.do_nothing
			gsl_gsl_matrix_float_inst.do_nothing
			gsl_gsl_matrix_ulong_inst.do_nothing
			gsl_gsl_matrix_long_inst.do_nothing
			gsl_gsl_matrix_uint_inst.do_nothing
			gsl_gsl_matrix_int_inst.do_nothing
			gsl_gsl_matrix_ushort_inst.do_nothing
			gsl_gsl_matrix_short_inst.do_nothing
			gsl_gsl_matrix_uchar_inst.do_nothing
			gsl_gsl_matrix_char_inst.do_nothing
			blas_inst.do_nothing
			bspline_inst.do_nothing
			gsl_gsl_complex_math_inst.do_nothing
			math_inst.do_nothing
			gsl_gsl_mode_inst.do_nothing
			eval_inst.do_nothing
			integ_inst.do_nothing
			init_inst.do_nothing
			deriv_inst.do_nothing
			dht_inst.do_nothing
			diff_inst.do_nothing
			gsl_gsl_permutation_inst.do_nothing
			nonsymmv_inst.do_nothing
			qrstep_inst.do_nothing
			hermv_inst.do_nothing
			symmv_inst.do_nothing
			jacobi_inst.do_nothing
			herm_inst.do_nothing
			genherm_inst.do_nothing
			sort_inst.do_nothing
			schur_inst.do_nothing
			nonsymm_inst.do_nothing
			francis_inst.do_nothing
			genv_inst.do_nothing
			gen_inst.do_nothing
			symm_inst.do_nothing
			gensymmv_inst.do_nothing
			gensymm_inst.do_nothing
			genhermv_inst.do_nothing
			stream_inst.do_nothing
			message_inst.do_nothing
			error_inst.do_nothing
			strerror_inst.do_nothing
			bitreverse_inst.do_nothing
			factorize_inst.do_nothing
			c_init_inst.do_nothing
			c_main_inst.do_nothing
			c_pass_2_inst.do_nothing
			c_pass_3_inst.do_nothing
			c_pass_4_inst.do_nothing
			c_pass_5_inst.do_nothing
			c_pass_6_inst.do_nothing
			c_pass_7_inst.do_nothing
			c_pass_n_inst.do_nothing
			c_radix2_inst.do_nothing
			hc_init_inst.do_nothing
			hc_main_inst.do_nothing
			hc_pass_2_inst.do_nothing
			hc_pass_3_inst.do_nothing
			hc_pass_4_inst.do_nothing
			hc_pass_5_inst.do_nothing
			hc_pass_n_inst.do_nothing
			hc_radix2_inst.do_nothing
			hc_unpack_inst.do_nothing
			real_init_inst.do_nothing
			real_main_inst.do_nothing
			real_pass_2_inst.do_nothing
			real_pass_3_inst.do_nothing
			real_pass_4_inst.do_nothing
			real_pass_5_inst.do_nothing
			real_pass_n_inst.do_nothing
			real_radix2_inst.do_nothing
			real_unpack_inst.do_nothing
			dft_source_inst.do_nothing
			linear_inst.do_nothing
			params2d_inst.do_nothing
			find_inst.do_nothing
			get_inst.do_nothing
			stat_inst.do_nothing
			reset_inst.do_nothing
			get2d_inst.do_nothing
			calloc_range2d_inst.do_nothing
			oper2d_inst.do_nothing
			maxval2d_inst.do_nothing
			copy2d_inst.do_nothing
			reset2d_inst.do_nothing
			params_inst.do_nothing
			copy_inst.do_nothing
			oper_inst.do_nothing
			init2d_inst.do_nothing
			stat2d_inst.do_nothing
			file2d_inst.do_nothing
			file_inst.do_nothing
			calloc_range_inst.do_nothing
			add_inst.do_nothing
			pdf_inst.do_nothing
			pdf2d_inst.do_nothing
			maxval_inst.do_nothing
			find2d_inst.do_nothing
			add2d_inst.do_nothing
			read_inst.do_nothing
			fp_gnux86_inst.do_nothing
			endian_inst.do_nothing
			standardize_inst.do_nothing
			make_rep_inst.do_nothing
			env_inst.do_nothing
			print_inst.do_nothing
			initialise_inst.do_nothing
			set_initial_inst.do_nothing
			qpsrt_inst.do_nothing
			util_inst.do_nothing
			qpsrt2_inst.do_nothing
			qelg_inst.do_nothing
			positivity_inst.do_nothing
			qags_inst.do_nothing
			qk31_inst.do_nothing
			qmomof_inst.do_nothing
			qcheb_inst.do_nothing
			err_inst.do_nothing
			qng_inst.do_nothing
			qk21_inst.do_nothing
			qag_inst.do_nothing
			qmomo_inst.do_nothing
			append_inst.do_nothing
			qawf_inst.do_nothing
			qk61_inst.do_nothing
			qc25f_inst.do_nothing
			qawo_inst.do_nothing
			qk51_inst.do_nothing
			ptsort_inst.do_nothing
			qagp_inst.do_nothing
			qc25c_inst.do_nothing
			qawc_inst.do_nothing
			qk41_inst.do_nothing
			glfixed_inst.do_nothing
			workspace_inst.do_nothing
			qk15_inst.do_nothing
			qk_inst.do_nothing
			qc25s_inst.do_nothing
			qaws_inst.do_nothing
			integ_eval_inst.do_nothing
			gsl_gsl_interp_inst.do_nothing
			cspline_inst.do_nothing
			interp_inst.do_nothing
			gsl_gsl_poly_inst.do_nothing
			poly_inst.do_nothing
			spline_inst.do_nothing
			akima_inst.do_nothing
			accel_inst.do_nothing
			lu_inst.do_nothing
			bidiag_inst.do_nothing
			symmtd_inst.do_nothing
			balancemat_inst.do_nothing
			exponential_inst.do_nothing
			choleskyc_inst.do_nothing
			hessenberg_inst.do_nothing
			hermtd_inst.do_nothing
			hesstri_inst.do_nothing
			apply_givens_inst.do_nothing
			qr_inst.do_nothing
			multiply_inst.do_nothing
			balance_inst.do_nothing
			householder_inst.do_nothing
			lq_inst.do_nothing
			hh_inst.do_nothing
			luc_inst.do_nothing
			qrpt_inst.do_nothing
			ptlq_inst.do_nothing
			tridiag_inst.do_nothing
			cholesky_inst.do_nothing
			householdercomplex_inst.do_nothing
			svdstep_inst.do_nothing
			svd_inst.do_nothing
			prop_source_inst.do_nothing
			minmax_source_inst.do_nothing
			rowcol_source_inst.do_nothing
			swap_source_inst.do_nothing
			copy_source_inst.do_nothing
			oper_complex_source_inst.do_nothing
			oper_source_inst.do_nothing
			getset_source_inst.do_nothing
			view_source_inst.do_nothing
			file_source_inst.do_nothing
			submatrix_source_inst.do_nothing
			quad_golden_inst.do_nothing
			bracketing_inst.do_nothing
			convergence_inst.do_nothing
			fsolver_inst.do_nothing
			golden_inst.do_nothing
			brent_inst.do_nothing
			gsl_gsl_rng_inst.do_nothing
			miser_inst.do_nothing
			vegas_inst.do_nothing
			plain_inst.do_nothing
			lmutil_inst.do_nothing
			qrsolv_inst.do_nothing
			lmpar_inst.do_nothing
			lmset_inst.do_nothing
			lmiterate_inst.do_nothing
			lmder_inst.do_nothing
			fdfsolver_inst.do_nothing
			gradient_inst.do_nothing
			work_inst.do_nothing
			multilinear_inst.do_nothing
			covar_inst.do_nothing
			fdfminimizer_inst.do_nothing
			simplex_inst.do_nothing
			directional_minimize_inst.do_nothing
			vector_bfgs_inst.do_nothing
			conjugate_pr_inst.do_nothing
			steepest_descent_inst.do_nothing
			conjugate_fr_inst.do_nothing
			linear_minimize_inst.do_nothing
			linear_wrapper_inst.do_nothing
			vector_bfgs2_inst.do_nothing
			simplex2_inst.do_nothing
			fminimizer_inst.do_nothing
			newton_inst.do_nothing
			enorm_inst.do_nothing
			gnewton_inst.do_nothing
			dogleg_inst.do_nothing
			hybridj_inst.do_nothing
			fdjac_inst.do_nothing
			hybrid_inst.do_nothing
			dnewton_inst.do_nothing
			broyden_inst.do_nothing
			ntuple_inst.do_nothing
			rk8pd_inst.do_nothing
			rkck_inst.do_nothing
			evolve_inst.do_nothing
			rk2imp_inst.do_nothing
			cstd_inst.do_nothing
			rk2_inst.do_nothing
			step_inst.do_nothing
			gear1_inst.do_nothing
			rk2simp_inst.do_nothing
			cscal_inst.do_nothing
			rk4imp_inst.do_nothing
			gear2_inst.do_nothing
			control_inst.do_nothing
			rkf45_inst.do_nothing
			rk4_inst.do_nothing
			bsimp_inst.do_nothing
			permute_source_inst.do_nothing
			canonical_inst.do_nothing
			permutation_inst.do_nothing
			gsl_gsl_combination_inst.do_nothing
			combination_inst.do_nothing
			gsl_gsl_multiset_inst.do_nothing
			multiset_inst.do_nothing
			solve_cubic_inst.do_nothing
			zsolve_init_inst.do_nothing
			solve_quadratic_inst.do_nothing
			dd_inst.do_nothing
			zsolve_cubic_inst.do_nothing
			companion_inst.do_nothing
			zsolve_inst.do_nothing
			zsolve_quadratic_inst.do_nothing
			gsl_gsl_qrng_inst.do_nothing
			qrng_inst.do_nothing
			reversehalton_inst.do_nothing
			sobol_inst.do_nothing
			niederreiter_2_inst.do_nothing
			halton_inst.do_nothing
			levy_inst.do_nothing
			pascal_inst.do_nothing
			cauchy_inst.do_nothing
			erlang_inst.do_nothing
			chisq_inst.do_nothing
			discrete_inst.do_nothing
			bernoulli_inst.do_nothing
			fdist_inst.do_nothing
			rayleigh_inst.do_nothing
			laplace_inst.do_nothing
			gausstail_inst.do_nothing
			nbinomial_inst.do_nothing
			weibull_inst.do_nothing
			sphere_inst.do_nothing
			hyperg_inst.do_nothing
			landau_inst.do_nothing
			binomial_inst.do_nothing
			gamma_inst.do_nothing
			binomial_tpe_inst.do_nothing
			multinomial_inst.do_nothing
			exppow_inst.do_nothing
			shuffle_inst.do_nothing
			geometric_inst.do_nothing
			gumbel_inst.do_nothing
			flat_inst.do_nothing
			beta_inst.do_nothing
			tdist_inst.do_nothing
			dirichlet_inst.do_nothing
			lognormal_inst.do_nothing
			pareto_inst.do_nothing
			poisson_inst.do_nothing
			logarithmic_inst.do_nothing
			bigauss_inst.do_nothing
			logistic_inst.do_nothing
			gausszig_inst.do_nothing
			gauss_inst.do_nothing
			schrage_inst.do_nothing
			fishman18_inst.do_nothing
			types_inst.do_nothing
			zuf_inst.do_nothing
			ranlxs_inst.do_nothing
			randu_inst.do_nothing
			uni32_inst.do_nothing
			ran1_inst.do_nothing
			borosh13_inst.do_nothing
			ran2_inst.do_nothing
			ran0_inst.do_nothing
			knuthran2_inst.do_nothing
			tt_inst.do_nothing
			vax_inst.do_nothing
			ranmar_inst.do_nothing
			fishman2x_inst.do_nothing
			ranf_inst.do_nothing
			knuthran_inst.do_nothing
			lecuyer21_inst.do_nothing
			ranlxd_inst.do_nothing
			slatec_inst.do_nothing
			rng_inst.do_nothing
			transputer_inst.do_nothing
			uni_inst.do_nothing
			waterman14_inst.do_nothing
			taus_inst.do_nothing
			knuthran2002_inst.do_nothing
			taus113_inst.do_nothing
			rand_inst.do_nothing
			ranlux_inst.do_nothing
			fishman20_inst.do_nothing
			rand48_inst.do_nothing
			r250_inst.do_nothing
			ran3_inst.do_nothing
			minstd_inst.do_nothing
			gfsr4_inst.do_nothing
			mrg_inst.do_nothing
			random_inst.do_nothing
			default_inst.do_nothing
			coveyou_inst.do_nothing
			cmrg_inst.do_nothing
			mt_inst.do_nothing
			steffenson_inst.do_nothing
			bisection_inst.do_nothing
			secant_inst.do_nothing
			falsepos_inst.do_nothing
			siman_inst.do_nothing
			subset_source_inst.do_nothing
			sortvec_source_inst.do_nothing
			sortind_inst.do_nothing
			subsetind_source_inst.do_nothing
			sortvecind_source_inst.do_nothing
			cheb_eval_inst.do_nothing
			bessel_temme_inst.do_nothing
			trig_inst.do_nothing
			atanint_inst.do_nothing
			erfc_inst.do_nothing
			fermi_dirac_inst.do_nothing
			legendre_con_inst.do_nothing
			airy_zero_inst.do_nothing
			elljac_inst.do_nothing
			bessel_j1_inst.do_nothing
			hyperg_2f0_inst.do_nothing
			bessel_i_inst.do_nothing
			expint_inst.do_nothing
			bessel_jnu_inst.do_nothing
			bessel_zero_inst.do_nothing
			bessel_j_inst.do_nothing
			hyperg_1f1_inst.do_nothing
			bessel_inu_inst.do_nothing
			mathieu_charv_inst.do_nothing
			bessel_k_inst.do_nothing
			legendre_poly_inst.do_nothing
			sinint_inst.do_nothing
			mathieu_angfunc_inst.do_nothing
			log_inst.do_nothing
			laguerre_inst.do_nothing
			poch_inst.do_nothing
			hyperg_2f1_inst.do_nothing
			exp_inst.do_nothing
			legendre_qn_inst.do_nothing
			bessel_k1_inst.do_nothing
			mathieu_workspace_inst.do_nothing
			bessel_amp_phase_inst.do_nothing
			bessel_sequence_inst.do_nothing
			debye_inst.do_nothing
			clausen_inst.do_nothing
			bessel_i0_inst.do_nothing
			bessel_in_inst.do_nothing
			transport_inst.do_nothing
			coulomb_bound_inst.do_nothing
			bessel_kn_inst.do_nothing
			coulomb_inst.do_nothing
			bessel_knu_inst.do_nothing
			beta_inc_inst.do_nothing
			result_inst.do_nothing
			ellint_inst.do_nothing
			synchrotron_inst.do_nothing
			dilog_inst.do_nothing
			legendre_h3d_inst.do_nothing
			mathieu_coeff_inst.do_nothing
			shint_inst.do_nothing
			bessel_y1_inst.do_nothing
			cheb_eval_mode_inst.do_nothing
			airy_inst.do_nothing
			dawson_inst.do_nothing
			hyperg_0f1_inst.do_nothing
			bessel_jn_inst.do_nothing
			bessel_inst.do_nothing
			elementary_inst.do_nothing
			expint3_inst.do_nothing
			pow_int_inst.do_nothing
			bessel_yn_inst.do_nothing
			bessel_k0_inst.do_nothing
			bessel_y0_inst.do_nothing
			hyperg_u_inst.do_nothing
			bessel_ynu_inst.do_nothing
			bessel_i1_inst.do_nothing
			mathieu_radfunc_inst.do_nothing
			gamma_inc_inst.do_nothing
			coupling_inst.do_nothing
			bessel_j0_inst.do_nothing
			psi_inst.do_nothing
			zeta_inst.do_nothing
			airy_der_inst.do_nothing
			bessel_olver_inst.do_nothing
			gegenbauer_inst.do_nothing
			lambert_inst.do_nothing
			bessel_y_inst.do_nothing
			p_variance_source_inst.do_nothing
			wkurtosis_source_inst.do_nothing
			wmean_source_inst.do_nothing
			covariance_source_inst.do_nothing
			mean_source_inst.do_nothing
			wabsdev_source_inst.do_nothing
			median_source_inst.do_nothing
			lag1_source_inst.do_nothing
			skew_source_inst.do_nothing
			wvariance_source_inst.do_nothing
			absdev_source_inst.do_nothing
			ttest_source_inst.do_nothing
			quantiles_source_inst.do_nothing
			kurtosis_source_inst.do_nothing
			wskew_source_inst.do_nothing
			variance_source_inst.do_nothing
			work_utrunc_inst.do_nothing
			work_u_inst.do_nothing
			levin_u_inst.do_nothing
			levin_utrunc_inst.do_nothing
			expm1_inst.do_nothing
			infnan_inst.do_nothing
			coerce_inst.do_nothing
			prec_inst.do_nothing
			minmax_inst.do_nothing
			fdiv_inst.do_nothing
			fcmp_inst.do_nothing
			log1p_inst.do_nothing
			hypot_inst.do_nothing
			invhyp_inst.do_nothing
			ldfrexp_inst.do_nothing
			results_inst.do_nothing
			placeholder_inst.do_nothing
			vector_inst.do_nothing
			reim_source_inst.do_nothing
			subvector_source_inst.do_nothing
			gumbel2inv_inst.do_nothing
			gumbel1_inst.do_nothing
			logisticinv_inst.do_nothing
			weibullinv_inst.do_nothing
			exponentialinv_inst.do_nothing
			fdistinv_inst.do_nothing
			gammainv_inst.do_nothing
			hypergeometric_inst.do_nothing
			cauchyinv_inst.do_nothing
			laplaceinv_inst.do_nothing
			chisqinv_inst.do_nothing
			lognormalinv_inst.do_nothing
			gumbel2_inst.do_nothing
			rat_eval_inst.do_nothing
			gaussinv_inst.do_nothing
			tdistinv_inst.do_nothing
			paretoinv_inst.do_nothing
			gumbel1inv_inst.do_nothing
			flatinv_inst.do_nothing
			betainv_inst.do_nothing
			rayleighinv_inst.do_nothing
			haar_inst.do_nothing
			wavelet_inst.do_nothing
			dwt_inst.do_nothing
			daubechies_inst.do_nothing
			sasum_inst.do_nothing
			saxpy_inst.do_nothing
			scasum_inst.do_nothing
			scnrm2_inst.do_nothing
			scopy_inst.do_nothing
			sdot_inst.do_nothing
			sdsdot_inst.do_nothing
			sgbmv_inst.do_nothing
			sgemm_inst.do_nothing
			sgemv_inst.do_nothing
			sger_inst.do_nothing
			snrm2_inst.do_nothing
			srot_inst.do_nothing
			srotg_inst.do_nothing
			srotm_inst.do_nothing
			srotmg_inst.do_nothing
			ssbmv_inst.do_nothing
			sscal_inst.do_nothing
			sspmv_inst.do_nothing
			sspr_inst.do_nothing
			sspr2_inst.do_nothing
			sswap_inst.do_nothing
			ssymm_inst.do_nothing
			ssymv_inst.do_nothing
			ssyr_inst.do_nothing
			ssyr2_inst.do_nothing
			ssyr2k_inst.do_nothing
			ssyrk_inst.do_nothing
			stbmv_inst.do_nothing
			stbsv_inst.do_nothing
			stpmv_inst.do_nothing
			stpsv_inst.do_nothing
			strmm_inst.do_nothing
			strmv_inst.do_nothing
			strsm_inst.do_nothing
			strsv_inst.do_nothing
			dasum_inst.do_nothing
			daxpy_inst.do_nothing
			dcopy_inst.do_nothing
			ddot_inst.do_nothing
			dgbmv_inst.do_nothing
			dgemm_inst.do_nothing
			dgemv_inst.do_nothing
			dger_inst.do_nothing
			dnrm2_inst.do_nothing
			drot_inst.do_nothing
			drotg_inst.do_nothing
			drotm_inst.do_nothing
			drotmg_inst.do_nothing
			dsbmv_inst.do_nothing
			dscal_inst.do_nothing
			dsdot_inst.do_nothing
			dspmv_inst.do_nothing
			dspr_inst.do_nothing
			dspr2_inst.do_nothing
			dswap_inst.do_nothing
			dsymm_inst.do_nothing
			dsymv_inst.do_nothing
			dsyr_inst.do_nothing
			dsyr2_inst.do_nothing
			dsyr2k_inst.do_nothing
			dsyrk_inst.do_nothing
			dtbmv_inst.do_nothing
			dtbsv_inst.do_nothing
			dtpmv_inst.do_nothing
			dtpsv_inst.do_nothing
			dtrmm_inst.do_nothing
			dtrmv_inst.do_nothing
			dtrsm_inst.do_nothing
			dtrsv_inst.do_nothing
			dzasum_inst.do_nothing
			dznrm2_inst.do_nothing
			caxpy_inst.do_nothing
			ccopy_inst.do_nothing
			cdotc_sub_inst.do_nothing
			cdotu_sub_inst.do_nothing
			cgbmv_inst.do_nothing
			cgemm_inst.do_nothing
			cgemv_inst.do_nothing
			cgerc_inst.do_nothing
			cgeru_inst.do_nothing
			chbmv_inst.do_nothing
			chemm_inst.do_nothing
			chemv_inst.do_nothing
			cher_inst.do_nothing
			cher2_inst.do_nothing
			cher2k_inst.do_nothing
			cherk_inst.do_nothing
			chpmv_inst.do_nothing
			chpr_inst.do_nothing
			chpr2_inst.do_nothing
			csscal_inst.do_nothing
			cswap_inst.do_nothing
			csymm_inst.do_nothing
			csyr2k_inst.do_nothing
			csyrk_inst.do_nothing
			ctbmv_inst.do_nothing
			ctbsv_inst.do_nothing
			ctpmv_inst.do_nothing
			ctpsv_inst.do_nothing
			ctrmm_inst.do_nothing
			ctrmv_inst.do_nothing
			ctrsm_inst.do_nothing
			ctrsv_inst.do_nothing
			zaxpy_inst.do_nothing
			zcopy_inst.do_nothing
			zdotc_sub_inst.do_nothing
			zdotu_sub_inst.do_nothing
			zdscal_inst.do_nothing
			zgbmv_inst.do_nothing
			zgemm_inst.do_nothing
			zgemv_inst.do_nothing
			zgerc_inst.do_nothing
			zgeru_inst.do_nothing
			zhbmv_inst.do_nothing
			zhemm_inst.do_nothing
			zhemv_inst.do_nothing
			zher_inst.do_nothing
			zher2_inst.do_nothing
			zher2k_inst.do_nothing
			zherk_inst.do_nothing
			zhpmv_inst.do_nothing
			zhpr_inst.do_nothing
			zhpr2_inst.do_nothing
			zscal_inst.do_nothing
			zswap_inst.do_nothing
			zsymm_inst.do_nothing
			zsyr2k_inst.do_nothing
			zsyrk_inst.do_nothing
			ztbmv_inst.do_nothing
			ztbsv_inst.do_nothing
			ztpmv_inst.do_nothing
			ztpsv_inst.do_nothing
			ztrmm_inst.do_nothing
			ztrmv_inst.do_nothing
			ztrsm_inst.do_nothing
			ztrsv_inst.do_nothing
			icamax_inst.do_nothing
			idamax_inst.do_nothing
			isamax_inst.do_nothing
			izamax_inst.do_nothing
			xerbla_inst.do_nothing;
			(create {LIBGSL_INITIALIZER}).initialize
		end

end
