class
	P_DGER

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_dger (a_order: NATURAL_32; a_M: INTEGER_32; a_N: INTEGER_32; a_alpha: REAL_64; a_X: CE_POINTER [REAL_64]; a_incX: INTEGER_32; a_Y: CE_POINTER [REAL_64]; a_incY: INTEGER_32; a_A___0: CE_POINTER [REAL_64]; a_lda: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: REAL_64
			l_jy: INTEGER_32
			l_tmp___1: INTEGER_32
			l_jy___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: REAL_64
			l_ix___0: INTEGER_32
			l_tmp___4: INTEGER_32
			js: JUMP_STATE
		do
			if a_order = {NATURAL_32} 101 then
				if a_incX > 0 then
					l_tmp := 0
				else
					l_tmp := (a_M - 1) * -a_incX
				end
				l_ix := l_tmp
				l_i := 0
				from
				until
					not (not js.loop_done and then (l_i < a_M))
				loop
					l_tmp___0 := a_alpha * a_X[l_ix]
					if a_incY > 0 then
						l_tmp___1 := 0
					else
						l_tmp___1 := (a_N - 1) * -a_incY
					end
					l_jy := l_tmp___1
					l_j := 0
					from
					until
						not (l_j < a_N)
					loop
						a_A___0[(a_lda * l_i + l_j)] := a_A___0[(a_lda * l_i + l_j)] + (a_Y[l_jy] * l_tmp___0)
						l_jy := l_jy + a_incY
						l_j := l_j + 1
					end
					l_ix := l_ix + a_incX
					l_i := l_i + 1
				end
			elseif a_order = {NATURAL_32} 102 then
				if a_incY > 0 then
					l_tmp___2 := 0
				else
					l_tmp___2 := (a_N - 1) * -a_incY
				end
				l_jy___0 := l_tmp___2
				l_j := 0
				from
				until
					not (not js.loop_done and then (l_j < a_N))
				loop
					l_tmp___3 := a_alpha * a_Y[l_jy___0]
					if a_incX > 0 then
						l_tmp___4 := 0
					else
						l_tmp___4 := (a_M - 1) * -a_incX
					end
					l_ix___0 := l_tmp___4
					l_i := 0
					from
					until
						not (l_i < a_M)
					loop
						a_A___0[(l_i + a_lda * l_j)] := a_A___0[(l_i + a_lda * l_j)] + (a_X[l_ix___0] * l_tmp___3)
						l_ix___0 := l_ix___0 + a_incX
						l_i := l_i + 1
					end
					l_jy___0 := l_jy___0 + a_incY
					l_j := l_j + 1
				end
			else
				xerbla_inst.cblas_xerbla ([0, ce_string ("source_ger.h"), ce_string ("unrecognized operation")])
			end
		end

end
