class
	P_ENORM

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	enorm___0 (a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				l_e2 := l_e2 + (l_fi * l_fi)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	enorm___1 (a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				l_e2 := l_e2 + (l_fi * l_fi)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	enorm___2 (a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				l_e2 := l_e2 + (l_fi * l_fi)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

	enorm___3 (a_f: CE_POINTER [PD_GSL_VECTOR]): REAL_64
		local
			l_e2: REAL_64
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_fi: REAL_64
		do
			l_e2 := (0).to_double
			l_n := a_f.item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_fi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_f, l_i))
				l_e2 := l_e2 + (l_fi * l_fi)
				l_i := l_i + 1
			end
			Result := (sqrt (l_e2))
		end

end
