class
	P_LMSET

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	set (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIFIT_FUNCTION_FDF_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]; a_scale: INTEGER_32): INTEGER_32
		local
			l_state: CE_POINTER [PD_LMDER_STATE_T]
			l_r___3: CE_POINTER [PD_GSL_MATRIX]
			l_tau: CE_POINTER [PD_GSL_VECTOR]
			l_diag: CE_POINTER [PD_GSL_VECTOR]
			l_work1: CE_POINTER [PD_GSL_VECTOR]
			l_perm: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]
			l_signum: CE_ARRAY [INTEGER_32]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_state.make
			create l_r___3.make
			create l_tau.make
			create l_diag.make
			create l_work1.make
			create l_perm.make
			create l_signum.make (<<1>>)

			l_state := create {CE_POINTER [PD_LMDER_STATE_T]}.make_cast (a_vstate)
			l_r___3 := l_state.item.r
			l_tau := l_state.item.tau
			l_diag := l_state.item.diag
			l_work1 := l_state.item.work1
			l_perm := l_state.item.perm
			l_status := ((a_fdf.item.fdf).integer_32_item ([a_x, a_fdf.item.params, a_f, a_J]))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_state.item.par := (0).to_double
				l_state.item.iter := (1).to_natural_32
				l_state.item.fnorm := lmutil_inst.enorm (a_f)
				init_source_inst.gsl_vector_set_all (a_dx, 0.0)
				if a_scale.to_boolean then
					lmutil_inst.compute_diag (a_J, l_diag)
				else
					init_source_inst.gsl_vector_set_all (l_diag, 1.0)
				end
				l_state.item.xnorm := lmutil_inst.scaled_enorm (l_diag, a_x)
				l_state.item.delta := lmutil_inst.compute_delta (l_diag, a_x)
				copy_source_inst.gsl_matrix_memcpy (l_r___3, a_J).do_nothing
				qrpt_inst.gsl_linalg_QRPT_decomp (l_r___3, l_tau, l_perm, l_signum, l_work1).do_nothing
				init_source_inst.gsl_vector_set_zero (l_state.item.rptdx)
				init_source_inst.gsl_vector_set_zero (l_state.item.w)
				init_source_inst.gsl_vector_set_zero (l_state.item.f_trial)
				Result := 0
			end
		end

end
