class
	P_PARAMS2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_histogram2d_nx (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): NATURAL_32
		do
			Result := (a_h.item.nx)
		end

	gsl_histogram2d_ny (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): NATURAL_32
		do
			Result := (a_h.item.ny)
		end

	gsl_histogram2d_xmax (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): REAL_64
		local
			l_nx: INTEGER_32
		do
			l_nx := (a_h.item.nx).to_integer_32
			Result := (a_h.item.xrange[l_nx])
		end

	gsl_histogram2d_xmin (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): REAL_64
		do
			Result := (a_h.item.xrange[0])
		end

	gsl_histogram2d_ymax (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): REAL_64
		local
			l_ny: INTEGER_32
		do
			l_ny := (a_h.item.ny).to_integer_32
			Result := (a_h.item.yrange[l_ny])
		end

	gsl_histogram2d_ymin (a_h: CE_POINTER [PD_GSL_HISTOGRAM2D]): REAL_64
		do
			Result := (a_h.item.yrange[0])
		end

end
