class
	P_PERMUTE_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_permute (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_64]
			l_r1___1: REAL_64
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_char (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [INTEGER_8]
			l_r1___1: INTEGER_8
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_char_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_8]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [INTEGER_8]
			l_r1___1: INTEGER_8
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_complex (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_64]
			l_r1___1: REAL_64
			js: JUMP_STATE
		do
			create l_t.make (<<2>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						l_t[l_a___5.to_integer_32] := a_data[((l_i * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 2)
						loop
							l_r1___1 := a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
							a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_complex_float (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_32]
			l_r1___1: REAL_32
			js: JUMP_STATE
		do
			create l_t.make (<<2>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						l_t[l_a___5.to_integer_32] := a_data[((l_i * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 2)
						loop
							l_r1___1 := a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
							a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_complex_float_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_32]
			l_r1___1: REAL_32
			js: JUMP_STATE
		do
			create l_t.make (<<2>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						l_t[l_a___5.to_integer_32] := a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 2)
						loop
							l_r1___1 := a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
							a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_complex_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_64]
			l_r1___1: REAL_64
			js: JUMP_STATE
		do
			create l_t.make (<<2>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						l_t[l_a___5.to_integer_32] := a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 2)
						loop
							l_r1___1 := a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
							a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_complex_long_double (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_96]
			l_r1___1: REAL_96
			js: JUMP_STATE
		do
			create l_t.make (<<2>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						l_t[l_a___5.to_integer_32] := a_data[((l_i * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 2)
						loop
							l_r1___1 := a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
							a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_complex_long_double_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_96]
			l_r1___1: REAL_96
			js: JUMP_STATE
		do
			create l_t.make (<<2>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						l_t[l_a___5.to_integer_32] := a_data[((l_k * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 2)
						loop
							l_r1___1 := a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32]
							a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 2)
					loop
						a_data[((l_pk * a_stride) * {NATURAL_32} 2 + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_float (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_32]
			l_r1___1: REAL_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_float_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_32]
			l_r1___1: REAL_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_int (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [INTEGER_32]
			l_r1___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_int_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [INTEGER_32]
			l_r1___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_64]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_64]
			l_r1___1: REAL_64
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_long (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [INTEGER_32]
			l_r1___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_long_double (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_96]
			l_r1___1: REAL_96
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_long_double_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [REAL_96]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [REAL_96]
			l_r1___1: REAL_96
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_long_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [INTEGER_32]
			l_r1___1: INTEGER_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_short (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [INTEGER_16]
			l_r1___1: INTEGER_16
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_short_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [INTEGER_16]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [INTEGER_16]
			l_r1___1: INTEGER_16
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_uchar (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [NATURAL_8]
			l_r1___1: NATURAL_8
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_uchar_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_8]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [NATURAL_8]
			l_r1___1: NATURAL_8
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_uint (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [NATURAL_32]
			l_r1___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_uint_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [NATURAL_32]
			l_r1___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_ulong (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [NATURAL_32]
			l_r1___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_ulong_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_32]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [NATURAL_32]
			l_r1___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_ushort (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [NATURAL_16]
			l_r1___1: NATURAL_16
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_i * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_k * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_ushort_inverse (a_p: CE_POINTER [NATURAL_32]; a_data: CE_POINTER [NATURAL_16]; a_stride: NATURAL_32; a_n: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_k: NATURAL_32
			l_pk: NATURAL_32
			l_a___5: NATURAL_32
			l_t: CE_ARRAY [NATURAL_16]
			l_r1___1: NATURAL_16
			js: JUMP_STATE
		do
			create l_t.make (<<1>>)

			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < a_n))
			loop
				l_k := a_p[l_i.to_integer_32]
				from
				until
					not (l_k > l_i)
				loop
					l_k := a_p[l_k.to_integer_32]
				end
				if l_k < l_i then
					js.continue
				end
				if not js.loop_jumped then
					l_pk := a_p[l_k.to_integer_32]
					if l_pk = l_i then
						js.continue
					end
				end
				if not js.loop_jumped then
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						l_t[l_a___5.to_integer_32] := a_data[(l_k * a_stride + l_a___5).to_integer_32]
						l_a___5 := l_a___5 + 1
					end
					from
					until
						not (not js.loop_done and then (l_pk /= l_i))
					loop
						l_a___5 := {NATURAL_32} 0
						from
						until
							not (l_a___5 < {NATURAL_32} 1)
						loop
							l_r1___1 := a_data[(l_pk * a_stride + l_a___5).to_integer_32]
							a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
							l_t[l_a___5.to_integer_32] := l_r1___1
							l_a___5 := l_a___5 + 1
						end
						l_k := l_pk
						l_pk := a_p[l_k.to_integer_32]
					end
					l_a___5 := {NATURAL_32} 0
					from
					until
						not (l_a___5 < {NATURAL_32} 1)
					loop
						a_data[(l_pk * a_stride + l_a___5).to_integer_32] := l_t[l_a___5.to_integer_32]
						l_a___5 := l_a___5 + 1
					end
				end
				if js.loop_increment then
					l_i := l_i + 1
				end
			end
			Result := 0
		end

	gsl_permute_vector (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_char (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_char (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_char_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_char_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_complex (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_complex (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_complex_float (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_complex_float (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_complex_float_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_complex_float_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_complex_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_complex_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_complex_long_double (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_complex_long_double (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_complex_long_double_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_complex_long_double_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_float (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_float (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_float_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_float_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_int (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_int (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_int_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_int_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_long (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_long (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_long_double (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_long_double (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_long_double_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_long_double_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_long_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_long_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_short (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_short (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_short_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_short_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_uchar (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_uchar (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_uchar_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_uchar_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_uint (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_uint (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_uint_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_uint_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_ulong (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_ulong (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_ulong_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_ulong_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_ushort (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 144, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_ushort (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

	gsl_permute_vector_ushort_inverse (a_p: CE_POINTER [PD_GSL_PERMUTATION_STRUCT]; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if a_v.item.size /= a_p.item.size then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("vector and permutation must be the same length"), ce_string ("permute_source.c"), 157, 19)
					Result := 19
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				gsl_permute_ushort_inverse (a_p.item.data, a_v.item.data, a_v.item.stride, a_v.item.size).do_nothing
				Result := 0
			end
		end

end
