class
	P_RNG

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_rng_alloc (a_T: CE_POINTER [PD_GSL_RNG_TYPE]): CE_POINTER [PD_GSL_RNG]
		local
			l_r___3: CE_POINTER [PD_GSL_RNG]
			js: JUMP_STATE
		do
			create l_r___3.make

			l_r___3 := create {CE_POINTER [PD_GSL_RNG]}.make_cast ((malloc ((create {PD_GSL_RNG}.make).structure_size.to_natural_32)))
			if l_r___3.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for rng struct"), ce_string ("rng.c"), 36, 8)
					Result := (create {CE_POINTER [PD_GSL_RNG]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_r___3.item.state := malloc (a_T.item.size)
				if (l_r___3.item.state).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_r___3))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for rng state"), ce_string ("rng.c"), 46, 8)
						Result := (create {CE_POINTER [PD_GSL_RNG]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_r___3.item.type := a_T
				gsl_rng_set (l_r___3, mt_inst.gsl_rng_default_seed)
				Result := l_r___3
			end
		end

	gsl_rng_clone (a_q___3: CE_POINTER [PD_GSL_RNG]): CE_POINTER [PD_GSL_RNG]
		local
			l_r___3: CE_POINTER [PD_GSL_RNG]
			js: JUMP_STATE
		do
			create l_r___3.make

			l_r___3 := create {CE_POINTER [PD_GSL_RNG]}.make_cast ((malloc ((create {PD_GSL_RNG}.make).structure_size.to_natural_32)))
			if l_r___3.is_void then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("failed to allocate space for rng struct"), ce_string ("rng.c"), 77, 8)
					Result := (create {CE_POINTER [PD_GSL_RNG]}.make_shared (default_pointer))
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_r___3.item.state := malloc ((a_q___3.item.type).item.size)
				if (l_r___3.item.state).is_void then
					free (create {CE_POINTER [ANY]}.make_cast (l_r___3))
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("failed to allocate space for rng state"), ce_string ("rng.c"), 87, 8)
						Result := (create {CE_POINTER [PD_GSL_RNG]}.make_shared (default_pointer))
						js.return
						if not js.return_called then
							js.break
						end
					end
				end
			end
			if not js.return_called then
				l_r___3.item.type := a_q___3.item.type
				memcpy (l_r___3.item.state, a_q___3.item.state, (a_q___3.item.type).item.size).do_nothing
				Result := l_r___3
			end
		end

	gsl_rng_free (a_r___3: CE_POINTER [PD_GSL_RNG])
		local
			js: JUMP_STATE
		do
			if a_r___3.is_void then
				js.return
			end
			if not js.return_called then
				free (a_r___3.item.state)
				free (create {CE_POINTER [ANY]}.make_cast (a_r___3))
			end
		end

	gsl_rng_max (a_r___3: CE_POINTER [PD_GSL_RNG]): NATURAL_32
		do
			Result := ((a_r___3.item.type).item.max)
		end

	gsl_rng_memcpy (a_dest: CE_POINTER [PD_GSL_RNG]; a_src: CE_POINTER [PD_GSL_RNG]): INTEGER_32
		local
			js: JUMP_STATE
		do
			if not (a_dest.item.type).is_equal (a_src.item.type) then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("generators must be of the same type"), ce_string ("rng.c"), 61, 4)
					Result := 4
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				memcpy (a_dest.item.state, a_src.item.state, (a_src.item.type).item.size).do_nothing
				Result := 0
			end
		end

	gsl_rng_min (a_r___3: CE_POINTER [PD_GSL_RNG]): NATURAL_32
		do
			Result := ((a_r___3.item.type).item.min)
		end

	gsl_rng_name (a_r___3: CE_POINTER [PD_GSL_RNG]): CE_POINTER [INTEGER_8]
		do
			Result := ((a_r___3.item.type).item.name)
		end

	gsl_rng_print_state (a_r___3: CE_POINTER [PD_GSL_RNG])
		local
			l_i: NATURAL_32
			l_p: CE_POINTER [NATURAL_8]
			l_n: NATURAL_32
		do
			create l_p.make

			l_p := create {CE_POINTER [NATURAL_8]}.make_cast (a_r___3.item.state)
			l_n := (a_r___3.item.type).item.size
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				printf ([ce_string ("%%.2x"), (l_p[l_i.to_integer_32]).to_integer_32]).do_nothing
				l_i := l_i + 1
			end
		end

	gsl_rng_set (a_r___3: CE_POINTER [PD_GSL_RNG]; a_seed: NATURAL_32)
		do
			((a_r___3.item.type).item.set).call ([a_r___3.item.state, a_seed])
		end

	gsl_rng_size (a_r___3: CE_POINTER [PD_GSL_RNG]): NATURAL_32
		do
			Result := ((a_r___3.item.type).item.size)
		end

	gsl_rng_state (a_r___3: CE_POINTER [PD_GSL_RNG]): CE_POINTER [ANY]
		do
			Result := (a_r___3.item.state)
		end

end
