class
	P_STANDARDIZE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	make_double_bigendian (a_x: CE_POINTER [REAL_64])
		local
			l_u: PD_U3
			l_v: PD_U3
		do
			create l_u.make
			create l_v.make

			l_u.d := a_x.item
			l_u.update_class_fields -- synchronize union
			l_v.b[0] := l_u.b[7]
			l_v.update_class_fields -- synchronize union
			l_v.b[1] := l_u.b[6]
			l_v.update_class_fields -- synchronize union
			l_v.b[2] := l_u.b[5]
			l_v.update_class_fields -- synchronize union
			l_v.b[3] := l_u.b[4]
			l_v.update_class_fields -- synchronize union
			l_v.b[4] := l_u.b[3]
			l_v.update_class_fields -- synchronize union
			l_v.b[5] := l_u.b[2]
			l_v.update_class_fields -- synchronize union
			l_v.b[6] := l_u.b[1]
			l_v.update_class_fields -- synchronize union
			l_v.b[7] := l_u.b[0]
			l_v.update_class_fields -- synchronize union
			a_x.item := l_v.d
		end

	make_float_bigendian (a_x: CE_POINTER [REAL_32])
		local
			l_u: PD_U2
			l_v: PD_U2
		do
			create l_u.make
			create l_v.make

			l_u.f := a_x.item
			l_u.update_class_fields -- synchronize union
			l_v.b[0] := l_u.b[3]
			l_v.update_class_fields -- synchronize union
			l_v.b[1] := l_u.b[2]
			l_v.update_class_fields -- synchronize union
			l_v.b[2] := l_u.b[1]
			l_v.update_class_fields -- synchronize union
			l_v.b[3] := l_u.b[0]
			l_v.update_class_fields -- synchronize union
			a_x.item := l_v.f
		end

end
