class
	P_STPSV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_stpsv (a_order: NATURAL_32; a_Uplo: NATURAL_32; a_TransA: NATURAL_32; a_Diag: NATURAL_32; a_N: INTEGER_32; a_Ap: CE_POINTER [REAL_32]; a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_nonunit: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp: NATURAL_32
			l_ix: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: REAL_32
			l_jx: INTEGER_32
			l_Aij: REAL_32
			l_tmp___2: INTEGER_32
			l_ix___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: REAL_32
			l_jx___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_Aij___0: REAL_32
			l_ix___1: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: REAL_32
			l_jx___1: INTEGER_32
			l_tmp___8: INTEGER_32
			l_Aji: REAL_32
			l_ix___2: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___10: REAL_32
			l_jx___2: INTEGER_32
			l_Aji___0: REAL_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_TransA /= {NATURAL_32} 113 then
						l_tmp := a_TransA
					else
						l_tmp := {NATURAL_32} 112
					end
					l_Trans := l_tmp.to_integer_32
					if a_N = 0 then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 50 -- skip if block
					end
				when 1 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 7 -- goto _L___12
							else
								l_pos := -1 + 4 -- goto _L___16
							end
						else
							l_pos := -1 + 4 -- goto _L___16
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 4 then -- else: | _L___16:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 13 -- skip if block
						end
				when 5 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___0 + a_incX * (a_N - 1)
						if l_nonunit.to_boolean then
							a_X[l_ix] := a_X[l_ix] / (a_Ap[((((((a_N - 1) - 1) + 1) * (2 * a_N - ((a_N - 1) - 1))) // 2 + (a_N - 1)) - (a_N - 1))])
						end
						l_ix := l_ix - a_incX
						l_i := a_N - 1
						from
						until
							js.loop_done
						loop
							if l_i > 0 then
								l_tmp___2 := l_i
								l_i := l_i - 1
								if not l_tmp___2.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tmp___1 := a_X[l_ix]
								l_jx := l_ix + a_incX
								l_j := l_i + 1
								from
								until
									not (l_j < a_N)
								loop
									l_Aij := a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)]
									l_tmp___1 := l_tmp___1 - (l_Aij * a_X[l_jx])
									l_jx := l_jx + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									a_X[l_ix] := l_tmp___1 / a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)]
								else
									a_X[l_ix] := l_tmp___1
								end
								l_ix := l_ix - a_incX
							end
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						l_pos := -1 + 13 -- goto _L___14
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 13 then -- else: | _L___14:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 19 -- goto _L___7
							else
								l_pos := -1 + 16 -- goto _L___11
							end
						else
							l_pos := -1 + 16 -- goto _L___11
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 16 then -- else: | _L___11:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 25 -- skip if block
						end
				when 17 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 23 -- skip if block
						end
				when 18 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if: | _L___7:
						if a_incX > 0 then
							l_tmp___3 := 0
						else
							l_tmp___3 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___3
						if l_nonunit.to_boolean then
							a_X[l_ix___0] := a_X[l_ix___0] / (a_Ap[0])
						end
						l_ix___0 := l_ix___0 + a_incX
						l_i := 1
						from
						until
							not (not js.loop_done and then (l_i < a_N))
						loop
							l_tmp___4 := a_X[l_ix___0]
							if a_incX > 0 then
								l_tmp___5 := 0
							else
								l_tmp___5 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___5
							l_j := 0
							from
							until
								not (l_j < l_i)
							loop
								l_Aij___0 := a_Ap[((l_i * (l_i + 1)) // 2 + l_j)]
								l_tmp___4 := l_tmp___4 - (l_Aij___0 * a_X[l_jx___0])
								l_jx___0 := l_jx___0 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								a_X[l_ix___0] := l_tmp___4 / a_Ap[((l_i * (l_i + 1)) // 2 + l_j)]
							else
								a_X[l_ix___0] := l_tmp___4
							end
							l_ix___0 := l_ix___0 + a_incX
							l_i := l_i + 1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 22 then -- if done | if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 25 -- goto _L___9
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 25 then -- else: | _L___9:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 31 -- goto _L___2
							else
								l_pos := -1 + 28 -- goto _L___6
							end
						else
							l_pos := -1 + 28 -- goto _L___6
						end
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 28 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 37 -- skip if block
						end
				when 29 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 35 -- skip if block
						end
				when 30 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___6 := 0
						else
							l_tmp___6 := (a_N - 1) * -a_incX
						end
						l_ix___1 := l_tmp___6
						if l_nonunit.to_boolean then
							a_X[l_ix___1] := a_X[l_ix___1] / (a_Ap[0])
						end
						l_ix___1 := l_ix___1 + a_incX
						l_i := 1
						from
						until
							not (not js.loop_done and then (l_i < a_N))
						loop
							l_tmp___7 := a_X[l_ix___1]
							if a_incX > 0 then
								l_tmp___8 := 0
							else
								l_tmp___8 := (a_N - 1) * -a_incX
							end
							l_jx___1 := l_tmp___8
							l_j := 0
							from
							until
								not (l_j < l_i)
							loop
								l_Aji := a_Ap[(((((l_j - 1) + 1) * (2 * a_N - (l_j - 1))) // 2 + l_i) - l_j)]
								l_tmp___7 := l_tmp___7 - (l_Aji * a_X[l_jx___1])
								l_jx___1 := l_jx___1 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								a_X[l_ix___1] := l_tmp___7 / a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_i) - l_i)]
							else
								a_X[l_ix___1] := l_tmp___7
							end
							l_ix___1 := l_ix___1 + a_incX
							l_i := l_i + 1
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 37 -- goto _L___4
				when 36 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 37 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 40 -- skip if block
						end
				when 38 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 43 -- goto _L
							else
								l_pos := -1 + 40 -- goto _L___1
							end
						else
							l_pos := -1 + 40 -- goto _L___1
						end
				when 39 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 40 then -- else: | _L___1:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 49 -- skip if block
						end
				when 41 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 47 -- skip if block
						end
				when 42 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 45 -- skip if block
						end
				when 43 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___9 := 0
						else
							l_tmp___9 := (a_N - 1) * -a_incX
						end
						l_ix___2 := l_tmp___9 + (a_N - 1) * a_incX
						if l_nonunit.to_boolean then
							a_X[l_ix___2] := a_X[l_ix___2] / (a_Ap[(((a_N - 1) * ((a_N - 1) + 1)) // 2 + (a_N - 1))])
						end
						l_ix___2 := l_ix___2 - a_incX
						l_i := a_N - 1
						from
						until
							js.loop_done
						loop
							if l_i > 0 then
								l_tmp___11 := l_i
								l_i := l_i - 1
								if not l_tmp___11.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tmp___10 := a_X[l_ix___2]
								l_jx___2 := l_ix___2 + a_incX
								l_j := l_i + 1
								from
								until
									not (l_j < a_N)
								loop
									l_Aji___0 := a_Ap[((l_j * (l_j + 1)) // 2 + l_i)]
									l_tmp___10 := l_tmp___10 - (l_Aji___0 * a_X[l_jx___2])
									l_jx___2 := l_jx___2 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									a_X[l_ix___2] := l_tmp___10 / a_Ap[((l_i * (l_i + 1)) // 2 + l_i)]
								else
									a_X[l_ix___2] := l_tmp___10
								end
								l_ix___2 := l_ix___2 - a_incX
							end
						end
				when 44 then -- if block done, skip else block:
						l_pos := -1 + 46
				when 45 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_tpsv_r.h"), ce_string ("unrecognized operation")])
				when 46 then -- if done | if block done, skip else block:
						l_pos := -1 + 48
				when 47 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_tpsv_r.h"), ce_string ("unrecognized operation")])
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_tpsv_r.h"), ce_string ("unrecognized operation")])
				when 50 then -- if done | if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
