class
	P_XERBLA

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_xerbla (a_args: TUPLE [a_p: INTEGER_32; a_rout: CE_POINTER [INTEGER_8]; a_form: CE_POINTER [INTEGER_8]])
		local
			l_ap: CE_VA_LIST
		do
			create l_ap.make_shared (default_pointer)

			l_ap := create {CE_VA_LIST}.make (a_args, 4)
			if a_args.a_p.to_boolean then
				Io.error.put_string ("Parameter " + a_args.a_p.out + " to routine " + eif_string (a_args.a_rout) + " was incorrect%N")
			end
			vfprintf ((create {CE_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer)), a_args.a_form, l_ap.twin).do_nothing
			abort
		end

end
